# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2013 ShineERP Co.,ltd (<http://www.serp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@serp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
import xlrd, base64, time, datetime, xlwt, openerp.netsvc, datetime
from StringIO import StringIO
from pychart.doc_support import val
import time
from datetime import date
from datetime import datetime

DATETIME_FORMAT = "%Y-%m-%d %H:%M:%S"
DATE_FORMAT = "%Y-%m-%d"
TIME_FORMAT = "%H:%M:%S"


class timesheet_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "timesheet.report"
    _description = "Timesheet report"
    
    _columns = {
                'start_date':fields.date('Start date',required=True),
                'end_date':fields.date('End date',required=True),
                }
    
    
    _defaults = {
        'start_date': fields.datetime.now,
        'end_date': fields.datetime.now,
    }
    
    
    
    def get_export_data(self, cr, uid, ids, context=None):        
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['model'] = 'sale.order'
        datas['form'] = self.read(cr, uid, ids)[0]     
        data = datas['form']
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Цаг бүртгэлийн тайлан')
        styles = self.get_easyxf_styles()
        report_name = u'Цаг бүртгэлийн тайлан'
        sheet.portrait=False
        ezxf = xlwt.easyxf
        sheet_style = ezxf('font: bold off; align: wrap on, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet_style2 = ezxf('font: bold off; align: wrap on, vert centre, horiz left;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet8 = ezxf('font: bold on; align: wrap on, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet9 = ezxf('font: bold on; align: wrap on, vert centre, horiz left;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')

        attendance_obj = self.pool.get('hr.attendance')
        user_obj = self.pool.get('res.users')
        user_id = user_obj.search(cr, uid, [('id','=',uid)])
        user_data = user_obj.browse(cr, uid, user_id)[0]
        
        sheet.write_merge(1, 1, 2, 6, u'%s'%report_name, ezxf('font: bold on;align:wrap on,vert centre,horiz centre;font: height 220'))
        sheet.write_merge(2, 2, 2, 6, u'Хамрагдах хугацаа: %s'%(data['start_date']+ "  " + data['end_date']), ezxf('font: bold off;align:wrap on,vert centre,horiz right;font: height 200'))
        sheet.write_merge(3, 4, 0, 0, u'Д/д', sheet8)
        sheet.write_merge(3, 4, 1, 1, u'Нэр', sheet8)
        sheet.write_merge(3, 4, 2, 2, u'Код', sheet8)
        sheet.write_merge(3, 4, 3, 3, u'Компани', sheet8)
        sheet.write_merge(3, 4, 4, 4, u'Хэлтэс', sheet8)
        sheet.write_merge(3, 4, 5, 5, u'Албан тушаал', sheet8)
        sheet.write_merge(3, 4, 6, 6, u'Өдөр', sheet8)
        sheet.write_merge(3, 4, 7, 7, u'', sheet8)
        sheet.write_merge(3, 4, 8, 8, u'Ирэх ёстой', sheet8)
        sheet.write_merge(3, 4, 9, 9, u'Явах ёстой', sheet8)
        sheet.write_merge(3, 4, 10, 10, u'Ирсэн', sheet8)
        sheet.write_merge(3, 4, 11, 11, u'Явсан', sheet8)
        sheet.write_merge(3, 4, 12, 12, u'Хоцорсон', sheet8)
        sheet.write_merge(3, 4, 13, 13, u'Эрт явсан', sheet8)
        emp_obj = self.pool.get('hr.employee')
        emp_id = emp_obj.search(cr, uid, [('id','!=',2935)])
        
        
        days = []
        idate = datetime.strptime(data['start_date'],DATE_FORMAT)
        while idate <= datetime.strptime(data['end_date'],DATE_FORMAT):
            days.append(idate)
            idate += timedelta(days = 1)
            
        number = 0
        row = 5
        for emp in emp_obj.browse(cr, uid, emp_id):
            for day in days:
                date1 = day.strftime('%Y-%m-%d')
                due_time=0
                due_day=0
                work_day = 0
                work_time = 0
                addtime = 0
                lost_time = 0.0
                
                type = ''
                signout = ''
                signin = ''
                signin1 = ''
                signout1 = ''
                last_signin = ''
                last_signin_datetime = ''
                signout_datetime = ''
                over_time = 0.0
                
                cr.execute('''select hour_from, hour_to from resource_calendar_attendance where calendar_id=%s and dayofweek='%s' order by hour_from
                '''%(1, date.weekday(datetime.strptime(date1, DATE_FORMAT))))
                fetched=cr.dictfetchall()
                
                atten_time2 = (datetime.combine(day, datetime.min.time()))
                sign = atten_time2+timedelta(hours=8)
                signin = sign.replace(hour=9, minute=00)
                atten_time3 = (datetime.combine(day, datetime.min.time()))
                signou = atten_time3+timedelta(hours=8)
                signout = signou.replace(hour=18, minute=00)
                
                
                if signin.weekday() == 0:
                    type=u'Ажлын'
                if signin.weekday() == 1:
                    type=u'Ажлын'
                if signin.weekday() == 2:
                    type=u'Ажлын'
                if signin.weekday() == 3:
                    type=u'Ажлын'
                if signin.weekday() == 4:
                    type=u'Ажлын'
                if signin.weekday() == 5:
                    type=u'Хагаc сайн'
                if signin.weekday() == 6:
                    type=u'Бүтэн сайн'
                    
                atten_time23 = (datetime.combine(day, datetime.min.time()))
                signin11 = atten_time23.replace(hour=00, minute=00)
                signin1 = datetime.strptime(str(signin11), '%Y-%m-%d %H:%M:%S') - timedelta(hours=8)
                print 'aaaaaaaa', signin1
                atten_time33 = (datetime.combine(day, datetime.min.time()))
                signout11 = atten_time33.replace(hour=23, minute=59)
                signout1 = datetime.strptime(str(signout11), '%Y-%m-%d %H:%M:%S') - timedelta(hours=8)
                print 'bbbbbbbbbbbbbbbbb', signout1
                if fetched:
                    for worktime in fetched:
                        attend_id = attendance_obj.search(cr, uid, [('name','>=',str(signin1)),('name','<=',str(signout1)),('employee_id','=',emp.id)])
                        for attd in attendance_obj.browse(cr, uid, attend_id):
                            if attd.action =='sign_in':
                                if attd.id==74733:
                                    print "asssddaa",attd.name
                                last_signin_datetime1 = datetime.strptime(attd.name, '%Y-%m-%d %H:%M:%S')
                                last_signin_datetime = last_signin_datetime1+timedelta(hours=8)
                                hour_parts2 = last_signin_datetime.hour
                                if worktime['hour_from'] <=float(hour_parts2):
                                    lost_time = (float(hour_parts2) - float(worktime['hour_from']))*60.0+last_signin_datetime.minute
                            
                                
                                
                            
                
                        attendance_id = attendance_obj.search(cr, uid, [('name','>=',str(signin1)),('name','<=',str(signout1)),('employee_id','=',emp.id)] )
                        for att in attendance_obj.browse(cr, uid, attendance_id):
                            if att.action == 'sign_out':
                                signout_datetime1 = datetime.strptime(att.name, '%Y-%m-%d %H:%M:%S')
                                signout_datetime = signout_datetime1+timedelta(hours=8) 
                                hour_parts3 = signout_datetime.hour
                                if worktime['hour_to'] >float(hour_parts3):
                                    over_time = (float(worktime['hour_to'] - float(hour_parts3)))*60.0+signout_datetime.minute
                number +=1
                last_name = ''
                sheet.write_merge(row, row, 0, 0, u'%d'%number, sheet8)
                if emp.last_name:
                    last_name = emp.last_name[0]
                sheet.write_merge(row, row, 1, 1, u'%s.%s'%(last_name,emp.name), sheet9)
                sheet.write_merge(row, row, 2, 2, u'%s'%emp.employee_code, sheet9)
                sheet.write_merge(row, row, 3, 3, u'%s'%emp.company_id.name, sheet9)
                sheet.write_merge(row, row, 4, 4, u'%s'%emp.department_id.name, sheet9)
                sheet.write_merge(row, row, 5, 5, u'%s'%emp.job_id.name, sheet9)
                sheet.write_merge(row, row, 6, 6, u'%s'%str(signin)[:10], sheet9)
                sheet.write_merge(row, row, 7, 7, u'%s'%type, sheet8)
                sheet.write_merge(row, row, 8, 8, u'%s'%str(signin)[11:], sheet8)
                sheet.write_merge(row, row, 9, 9, u'%s'%str(signout)[11:], sheet8)
                sheet.write_merge(row, row, 10, 10, u'%s'%str(last_signin_datetime)[11:], sheet8)
                sheet.write_merge(row, row, 11, 11, u'%s'%str(signout_datetime)[11:], sheet8)
                sheet.write_merge(row, row, 12, 12, u'%d'%lost_time, sheet8)
                sheet.write_merge(row, row, 13, 13, u'%d'%over_time, sheet8)
                
                row +=1

        
        sheet.write_merge(row+4, row+4, 0, 6, u'Тайлан гаргасан__________________________ /_____________________/', ezxf('font: bold off;align:wrap on,vert centre,horiz centre;font: height 200'))
        sheet.col(0).width=1400
        sheet.col(1).width=6000
        sheet.col(2).width=3000
        sheet.col(3).width=7000
        sheet.col(4).width=8000
        sheet.col(5).width=6000
        sheet.col(6).width=4000
        sheet.col(7).width=4000
        sheet.col(8).width=3000
        sheet.col(9).width=3000
        sheet.col(10).width=3000
        sheet.col(11).width=3000
        sheet.row(3).height=500
        sheet.row(4).height=800
        
        return {'data':book}
    
    
    
    