# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2013 ShineERP Co.,ltd (<http://www.serp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@serp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
import xlrd, base64, time, datetime, xlwt, openerp.netsvc, datetime
from StringIO import StringIO
from pychart.doc_support import val
import time
from datetime import date
from datetime import datetime
from dateutil.relativedelta import relativedelta
from _ast import If

DATETIME_FORMAT = "%Y-%m-%d %H:%M:%S"
DATE_FORMAT = "%Y-%m-%d"
TIME_FORMAT = "%H:%M:%S"


class timesheet_report2(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "timesheet.report2"
    _description = "Timesheet report 2"
    
    _columns = {
                'start_date':fields.date('Start date',required=True),
                'end_date':fields.date('End date',required=True),
                }
    
    
    _defaults = {
        'start_date': fields.datetime.now,
        'end_date': fields.datetime.now,
    }
    
    
    
    def get_export_data(self, cr, uid, ids, context=None):        
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['model'] = 'sale.order'
        datas['form'] = self.read(cr, uid, ids)[0]     
        data = datas['form']
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Гүйцэтгэлийн сарын баланс')
        styles = self.get_easyxf_styles()
        report_name = u'Гүйцэтгэлийн сарын баланс'
        sheet.portrait=False
        ezxf = xlwt.easyxf
        sheet_style = ezxf('font: bold off; align: wrap on, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet_style2 = ezxf('font: bold off; align: wrap on, vert centre, horiz left;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet8 = ezxf('font: bold on; align: wrap on, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet9 = ezxf('font: bold off; align: wrap on, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet10 = ezxf('font: bold on; align: wrap on, vert centre, horiz left;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet_orient = ezxf('font: bold on; align: wrap off,rotation 90, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet_orient2 = ezxf('font: bold on; align: wrap on,rotation 90, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        
        attendance_obj = self.pool.get('hr.attendance')
        user_obj = self.pool.get('res.users')
        user_id = user_obj.search(cr, uid, [('id','=',uid)])
        user_data = user_obj.browse(cr, uid, user_id)[0]
        
        sheet.write_merge(0, 0, 0, 1, u'%s'%report_name, ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 220'))
        sheet.write_merge(0, 0, 9, 13, u'', ezxf('font: bold off;align:wrap on,vert centre,horiz right;font: height 200'))
        sheet.write_merge(1, 1, 2, 9, u'%s'%report_name, ezxf('font: bold on;align:wrap on,vert centre,horiz centre;font: height 220'))
        sheet.write_merge(2, 2, 0, 1, u'Тайлант үе : ', ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(2, 2, 9, 13, u'%s'%(data['start_date']+ " - " + data['end_date']), ezxf('font: bold off;align:wrap on,vert centre,horiz right;font: height 200'))
        sheet.write_merge(3, 4, 0, 0, u'Д/д', sheet8)
        sheet.write_merge(3, 4, 1, 1, u'Овог нэр', sheet8)
        sheet.write_merge(3, 4, 2, 2, u'Албан тушаал', sheet8)
        sheet.write_merge(3, 4, 3, 3, u'Ажиллавал зохих цаг', sheet_orient)
        sheet.write_merge(3, 4, 4, 4, u'Ажилласан цаг', sheet_orient)
        sheet.write_merge(3, 3, 5, 9, u'Илүү цаг', sheet8)
        sheet.write_merge(4, 4, 5, 5, u'Бямбад ажиллах ёстой илүү цаг', sheet_orient2)
        sheet.write_merge(4, 4, 6, 6, u'Бямбад ажилласан илүү цаг', sheet_orient2)
        sheet.write_merge(4, 4, 7, 7, u'Баярын өдрийн илүү цаг', sheet_orient2)
        sheet.write_merge(4, 4, 8, 8, u'Нэмэлт илүү цаг', sheet_orient2)
        sheet.write_merge(4, 4, 9, 9, u'Нийт илүү цаг', sheet_orient2)
        sheet.write_merge(3, 3, 10, 16, u'Ажиллаагүй цаг', sheet8)
        sheet.write_merge(4, 4, 10, 10, u'Өвчтэй', sheet_orient2)
        sheet.write_merge(4, 4, 11, 11, u'Чөлөөтэй', sheet_orient2)
        sheet.write_merge(4, 4, 12, 12, u'Тасалсан', sheet_orient2)
        sheet.write_merge(4, 4, 13, 13, u'Ээлжийн амралттай', sheet_orient2)
        sheet.write_merge(4, 4, 14, 14, u'Бусад', sheet_orient2)
        sheet.write_merge(4, 4, 15, 15, u'Хоцорсон минут', sheet_orient2)
        sheet.write_merge(4, 4, 16, 16, u'Илүү цагийн хоцорсон минут', sheet_orient2)
        
        emp_obj = self.pool.get('hr.employee')
        emp_id = emp_obj.search(cr, uid, [('id','!=',2935)])
        
        overtime_obj = self.pool.get('tbab.overtime')
        holiday_obj = self.pool.get('hr.holidays')
        public_holiday_obj = self.pool.get('hr.public.holiday')
        hr_holidays_status_obj = self.pool.get('hr.holidays.status')
        
        days = []
        idate = datetime.strptime(data['start_date'],DATE_FORMAT)
        while idate <= datetime.strptime(data['end_date'],DATE_FORMAT):
            days.append(idate)
            idate += timedelta(days = 1)
        #print 'daaaaaaaaaaaaays', days
            
        number = 0
        row = 5
        for emp in emp_obj.browse(cr, uid, emp_id):
            print 'EEHHHHHHHHHHHHHHHLEEEEEEEEEEEL', emp.employee_code
            be_worked_hours = 0.0
            worked_hours = 0.0
            workday_overtime = 0.0
            saturday_overtime_must = 0.0
            saturday_overtime = 0.0
            sunday_overtime = 0.0
            tasalsan_time = 0.0
            tasalsan_time_total = 0.0
            busad_time = 0.0
            busad_time_total = 0.0
            no_log_overtime = 0.0
            no_log_overtime_total = 0.0
            line_sum = 0.0
            worked_in_work_day_and_public_holiday_total = 0.0
            total_floats = 0.0
            additional_overtimes = 0.0
            total_overtime = 0.0
            both_time = 0.0
            both_time_total = 0.0
            diff_hours2 = 0.0
            in_start_time_total = 0.0
            diff_hours3 = 0.0
            in_end_time_total = 0.0
            total_sick_this_month = 0.0
            total_legal_this_month = 0.0
            total_unpayroll_this_month = 0.0
            hotsorson_minute_workday_one_day = 0.0
            hotsorson_minute_saturday_one_day = 0.0
            hotsorson_minute_sunday_one_day = 0.0
            hotsorson_minute_workday_total = 0.0
            hotsorson_minute_saturday_total = 0.0
            hotsorson_minute_sunday_total = 0.0
            hotsorson_minute_not_saturday_total = 0.0
            #if emp.id == 2864:
            dayofhours = 0.0
            overtimeofsaturday_must = 0.0
            overtimeofworkday = 0.0
            overtimeofsaturday = 0.0
            overtimeofsunday = 0.0
            #print 'TUHAIN OGNOONUUDIIN EHNII OGNOO', days[0], days[0].date()
            
            #Tuhain sariin vzvvleltvvdiig olohiin tuld tuhain sariin ehleh bolon duusah zaagiig olj ogoh
            this_month_date = days[0].date()
            start_date_of_this_month = this_month_date.replace(day=1)
            next_month_quant = this_month_date.month + 1
            start_date_of_next_month = start_date_of_this_month.replace(month=next_month_quant)
            
            start_of_month = (datetime.combine(start_date_of_this_month, datetime.min.time()))
            start_fixed = datetime.strptime(str(start_of_month), '%Y-%m-%d %H:%M:%S') - timedelta(hours=8)
            start_of_next_month_max_time = (datetime.combine(start_date_of_next_month, datetime.max.time()))
            end_fixed = start_of_next_month_max_time - relativedelta(days=1) - timedelta(hours=8)
            
            for day in days:
                #Zowhon ajillah estoi tsag oloh
                for line44 in emp.resource_calendar_id.attendance_ids:
                    if str(line44.dayofweek) == str(day.weekday()) and day.weekday() != 5 and day.weekday() != 6:
                        dayofhours = line44.hour_to - line44.hour_from -1.0
                    else:
                        dayofhours = 0
                    be_worked_hours = be_worked_hours + dayofhours
                #Byambad ajillah estoi ilvv tsag bolon Byambad ajillasan ilvv tsag 2-iig oloh
                worked_in_work_day_and_public_holiday = 0.0
                worked_in_saturday_and_public_holiday= 0.0
                worked_in_sunday_and_public_holiday= 0.0
                diff_float = 0.0
                atten_time23 = (datetime.combine(day, datetime.min.time()))
                signin11 = atten_time23.replace(hour=00, minute=00, second=00)
                signin1 = datetime.strptime(str(signin11), '%Y-%m-%d %H:%M:%S') - timedelta(hours=8)
                atten_time33 = (datetime.combine(day, datetime.min.time()))
                signout11 = atten_time33.replace(hour=23, minute=59, second=59)
                signout1 = datetime.strptime(str(signout11), '%Y-%m-%d %H:%M:%S') - timedelta(hours=8)
                print 'Tuhain odriin zaag', signin1, signout1
                
                attend_id_in_id = attendance_obj.search(cr,uid,[('name','>=',str(signin1)),('name','<=',str(signout1)),('employee_id','=',emp.id),('action','=','sign_in')])
                attend_id_out_id = attendance_obj.search(cr,uid,[('name','>=',str(signin1)),('name','<=',str(signout1)),('employee_id','=',emp.id),('action','=','sign_out')])
                if emp.resource_calendar_id.attendance_ids:
                    if attend_id_in_id and attend_id_out_id:
                        in_browse = attendance_obj.browse(cr,uid,attend_id_in_id)
                        out_browse = attendance_obj.browse(cr,uid,attend_id_out_id)
                        if in_browse.name != out_browse.name:
                            for line55 in emp.resource_calendar_id.attendance_ids:
                                #Ajliin odrvvdiin tsag ololt
                                if str(line55.dayofweek) == str(day.weekday()) and day.weekday() != 5 and day.weekday() != 6:
                                    
                                    atten_time_in = (datetime.combine(day, datetime.min.time()))
                                    signed_in = datetime.strptime(str(in_browse.name), '%Y-%m-%d %H:%M:%S') + timedelta(hours=8)
                                    signin_must = atten_time_in.replace(hour=int(line55.hour_from), minute=int((line55.hour_from-int(line55.hour_from))*60))
                                    
                                    if signed_in >= signin_must:
                                        real_start = signed_in
                                    else:
                                        real_start = signin_must
                                    
                                    atten_time_out= (datetime.combine(day, datetime.min.time()))
                                    signed_out = datetime.strptime(str(out_browse.name), '%Y-%m-%d %H:%M:%S') + timedelta(hours=8)
                                    signout_must = atten_time_out.replace(hour=int(line55.hour_to), minute=int((line55.hour_to-int(line55.hour_to))*60))
                                    
                                    if signed_out >= signout_must:
                                        real_end= signout_must
                                    else:
                                        real_end = signed_out
                                    
                                    if signed_in > signin_must:
                                        hotsorson_minute_workday_one_day_datetime = signed_in - signin_must
                                        hotsorson_minute_workday_one_day = round((hotsorson_minute_workday_one_day_datetime.seconds)/60,1)
                                    else:
                                        hotsorson_minute_workday_one_day = 0.0
                                        
                                    work_day_if_overtime_approved = overtime_obj.search(cr,uid,[('employee_id','=',emp.id),('date_start','>=',str(signin1)),('date_end','<=',str(signout1)),('state','=','approved')])
                                    if work_day_if_overtime_approved:
                                        print 'WORKDAYYYYYYYY', signin1, signout1
                                        this_day_is_public_holiday_approved_in_both = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','>=',str(signin1)),('date_to','<=',str(signout1))])
                                        this_day_is_public_holiday_approved_in_start = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','>=',str(signin1)),('date_from','<=',str(signout1)),('date_to','>',str(signout1))])
                                        this_day_is_public_holiday_approved_in_end = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_to','>=',str(signin1)),('date_to','<=',str(signout1)),('date_from','<',str(signin1))])
                                        this_day_is_public_holiday_approved_out_both = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','<=',str(signin1)),('date_to','>=',str(signout1))])
                                        
                                        if this_day_is_public_holiday_approved_in_both or this_day_is_public_holiday_approved_in_start or this_day_is_public_holiday_approved_in_end or this_day_is_public_holiday_approved_out_both:
                                            browsed_overtime_workday0 = overtime_obj.browse(cr,uid,work_day_if_overtime_approved)
                                            worked_in_work_day_and_public_holiday_datetime = datetime.strptime(str(browsed_overtime_workday0.date_end), '%Y-%m-%d %H:%M:%S') - datetime.strptime(str(browsed_overtime_workday0.date_start), '%Y-%m-%d %H:%M:%S') - timedelta(hours=1)
                                            worked_in_work_day_and_public_holiday = round(worked_in_work_day_and_public_holiday_datetime.seconds/3600,1)
                                            overtimeofworkday = 0.0
                                            #diff_hours_per_day = 0.0
                                            #diff_float = 0.0
                                        else:
                                            worked_in_work_day_and_public_holiday = 0.0
                                            #worked_in_saturday_and_public_holiday = 0.0
                                            browsed_overtime_workday = overtime_obj.browse(cr,uid,work_day_if_overtime_approved)
                                            overtimeofworkday = round(browsed_overtime_workday.hours,1)
                                            #diff_hours_per_day =  datetime.strptime(str(real_end), '%Y-%m-%d %H:%M:%S') - datetime.strptime(str(real_start), '%Y-%m-%d %H:%M:%S') - timedelta(hours=1)
                                            #diff_float = diff_hours_per_day.seconds
                                    else:
                                        worked_in_work_day_and_public_holiday = 0.0
                                        overtimeofworkday = 0.0
                                    hotsorson_minute_workday_total = hotsorson_minute_workday_total + hotsorson_minute_workday_one_day
                                    workday_overtime = workday_overtime + overtimeofworkday
                                #Byamba garigiin tsag ololt
                                elif str(line55.dayofweek) == str(day.weekday()) and day.weekday() == 5:
                                    atten_time_in2 = (datetime.combine(day, datetime.min.time()))
                                    signed_in2 = datetime.strptime(str(in_browse.name), '%Y-%m-%d %H:%M:%S') + timedelta(hours=8)
                                    signin_must2 = atten_time_in2.replace(hour=int(line55.hour_from), minute=int((line55.hour_from-int(line55.hour_from))*60))
                                    
                                    if signed_in2 >= signin_must2:
                                        real_start2 = signed_in2
                                    else:
                                        real_start2 = signin_must2
                                    
                                    atten_time_out2 = (datetime.combine(day, datetime.min.time()))
                                    signed_out2 = datetime.strptime(str(out_browse.name), '%Y-%m-%d %H:%M:%S') + timedelta(hours=8)
                                    signout_must2 = atten_time_out2.replace(hour=int(line55.hour_to), minute=int((line55.hour_to-int(line55.hour_to))*60))
                                    
                                    if signed_out2 >= signout_must2:
                                        real_end2= signout_must2
                                    else:
                                        real_end2 = signed_out2
                                        
                                    if signed_in2 > signin_must2:
                                        hotsorson_minute_saturday_one_day_datetime = signed_in2 - signin_must2
                                        hotsorson_minute_saturday_one_day = round((hotsorson_minute_saturday_one_day_datetime.seconds)/60,1)
                                    else:
                                        hotsorson_minute_saturday_one_day = 0.0
                                
                                    saturday_if_overtime_approved = overtime_obj.search(cr,uid,[('employee_id','=',emp.id),('date_start','>=',str(signin1)),('date_end','<=',str(signout1)),('state','=','approved')])
                                    if saturday_if_overtime_approved:
                                        print 'SATURDAYYYYYYY', signin1, signout1
                                        this_day_is_public_holiday_approved_in_both_saturday = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','>=',str(signin1)),('date_to','<=',str(signout1))])
                                        this_day_is_public_holiday_approved_in_start_saturday = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','>=',str(signin1)),('date_from','<=',str(signout1)),('date_to','>',str(signout1))])
                                        this_day_is_public_holiday_approved_in_end_saturday = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_to','>=',str(signin1)),('date_to','<=',str(signout1)),('date_from','<',str(signin1))])
                                        this_day_is_public_holiday_approved_out_both_saturday = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','<=',str(signin1)),('date_to','>=',str(signout1))])
                                        
                                        if this_day_is_public_holiday_approved_in_both_saturday or this_day_is_public_holiday_approved_in_start_saturday or this_day_is_public_holiday_approved_in_end_saturday or this_day_is_public_holiday_approved_out_both_saturday:
                                            #worked_in_work_day_and_public_holiday = 0.0
                                            browsed_overtime_saturday0 = overtime_obj.browse(cr,uid,saturday_if_overtime_approved)
                                            worked_in_saturday_and_public_holiday_datetime = datetime.strptime(str(real_end2), '%Y-%m-%d %H:%M:%S') - datetime.strptime(str(real_start2), '%Y-%m-%d %H:%M:%S') - timedelta(hours=1)
                                            worked_in_saturday_and_public_holiday = round(browsed_overtime_saturday0.hours,1)
                                            #diff_hours_per_day2 = 0.0
                                            overtimeofsaturday_must = 0.0
                                            overtimeofsaturday = 0.0
                                        else:
                                            #worked_in_work_day_and_public_holiday = 0.0
                                            worked_in_saturday_and_public_holiday = 0.0
                                            browsed_overtime_saturday = overtime_obj.browse(cr,uid,saturday_if_overtime_approved)
                                            total_overtime_of_this_saturday = round(browsed_overtime_saturday.hours,1)
                                            if emp.resource_calendar_id.must_saturday_overtime == True:
                                                overtimeofsaturday_must = 4.0
                                                overtimeofsaturday = total_overtime_of_this_saturday - overtimeofsaturday_must
                                            else:
                                                overtimeofsaturday_must = 0.0
                                                overtimeofsaturday = total_overtime_of_this_saturday
                                                #diff_hours_per_day2 =  datetime.strptime(str(real_end2), '%Y-%m-%d %H:%M:%S') - datetime.strptime(str(real_start2), '%Y-%m-%d %H:%M:%S') - timedelta(hours=1)
                                    else:
                                        worked_in_saturday_and_public_holiday = 0.0
                                        overtimeofsaturday_must = 0.0
                                        overtimeofsaturday = 0.0
                                        
                                    
                                    hotsorson_minute_saturday_total = hotsorson_minute_saturday_total + hotsorson_minute_saturday_one_day
                                    saturday_overtime_must = saturday_overtime_must + overtimeofsaturday_must
                                    saturday_overtime = saturday_overtime + overtimeofsaturday
                                #Nyam garagiin tsag ololt
                                elif str(line55.dayofweek) == str(day.weekday()) and day.weekday() == 6:
                                    atten_time_in3 = (datetime.combine(day, datetime.min.time()))
                                    signed_in3 = datetime.strptime(str(in_browse.name), '%Y-%m-%d %H:%M:%S') + timedelta(hours=8)
                                    signin_must3 = atten_time_in3.replace(hour=int(line55.hour_from), minute=int((line55.hour_from-int(line55.hour_from))*60))
                                    
                                    if signed_in3 >= signin_must3:
                                        real_start3 = signed_in3
                                    else:
                                        real_start3 = signin_must3
                                    
                                    atten_time_out3 = (datetime.combine(day, datetime.min.time()))
                                    signed_out3 = datetime.strptime(str(out_browse.name), '%Y-%m-%d %H:%M:%S') + timedelta(hours=8)
                                    signout_must3 = atten_time_out3.replace(hour=int(line55.hour_to), minute=int((line55.hour_to-int(line55.hour_to))*60))
                                    
                                    if signed_out3 >= signout_must3:
                                        real_end3= signout_must3
                                    else:
                                        real_end3 = signed_out3
                                    
                                    if signed_in3 > signin_must3:
                                        hotsorson_minute_sunday_one_day_datetime = signed_in3 - signin_must3
                                        hotsorson_minute_sunday_one_day = round((hotsorson_minute_sunday_one_day_datetime.seconds)/60,1)
                                    else:
                                        hotsorson_minute_sunday_one_day = 0.0
                                    
                                    sunday_if_overtime_approved = overtime_obj.search(cr,uid,[('employee_id','=',emp.id),('date_start','>=',str(signin1)),('date_end','<=',str(signout1)),('state','=','approved')])
                                    if sunday_if_overtime_approved:
                                        print 'SUNDAYYYYYYY', signin1, signout1
                                        this_day_is_public_holiday_approved_in_both_sunday = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','>=',str(signin1)),('date_to','<=',str(signout1))])
                                        this_day_is_public_holiday_approved_in_start_sunday = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','>=',str(signin1)),('date_from','<=',str(signout1)),('date_to','>',str(signout1))])
                                        this_day_is_public_holiday_approved_in_end_sunday = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_to','>=',str(signin1)),('date_to','<=',str(signout1)),('date_from','<',str(signin1))])
                                        this_day_is_public_holiday_approved_out_both_sunday = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','<=',str(signin1)),('date_to','>=',str(signout1))])
                                        
                                        if this_day_is_public_holiday_approved_in_both_sunday or this_day_is_public_holiday_approved_in_start_sunday or this_day_is_public_holiday_approved_in_end_sunday or this_day_is_public_holiday_approved_out_both_sunday:
                                            browsed_overtime_sunday0 = overtime_obj.browse(cr,uid,sunday_if_overtime_approved)
                                            worked_in_sunday_and_public_holiday_datetime = datetime.strptime(str(real_end3), '%Y-%m-%d %H:%M:%S') - datetime.strptime(str(real_start3), '%Y-%m-%d %H:%M:%S') - timedelta(hours=1)
                                            worked_in_sunday_and_public_holiday = round(browsed_overtime_sunday0.hours,1)
                                            diff_hours_per_day3 = 0.0
                                            overtimeofsunday = 0.0
                                        else:
                                            worked_in_sunday_and_public_holiday = 0.0
                                            diff_hours_per_day3 =  datetime.strptime(str(real_end3), '%Y-%m-%d %H:%M:%S') - datetime.strptime(str(real_start3), '%Y-%m-%d %H:%M:%S') - timedelta(hours=1)
                                            browsed_overtime_sunday = overtime_obj.browse(cr,uid,sunday_if_overtime_approved)
                                            overtimeofsunday = round(browsed_overtime_sunday.hours,1)
                                    else:
                                        worked_in_sunday_and_public_holiday = 0.0
                                        sunday_overtime = 0.0
                                            
                                    hotsorson_minute_sunday_total = hotsorson_minute_sunday_total + hotsorson_minute_sunday_one_day
                                    sunday_overtime = sunday_overtime + overtimeofsunday
    
                        worked_in_work_day_and_public_holiday_total = worked_in_work_day_and_public_holiday_total + worked_in_work_day_and_public_holiday + worked_in_saturday_and_public_holiday + worked_in_sunday_and_public_holiday
                    else:
                        convert_accession = datetime.strptime(str(emp.accession_date + ' 00:00:00'),'%Y-%m-%d %H:%M:%S')
                        converted_accession = convert_accession.replace(hour=00, minute=00, second=00)
                        
                        no_log_attendance_if_overtime_approved = overtime_obj.search(cr,uid,[('employee_id','=',emp.id),('date_start','>=',str(signin1)),('date_end','<=',str(signout1)),('state','=','approved')])
                        if no_log_attendance_if_overtime_approved:
                            print 'NOLOGATTENDANCEEEEEEEEE', signin1, signout1
                            this_day_is_public_holiday_approved_in_both2 = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','>=',str(signin1)),('date_to','<=',str(signout1))])
                            this_day_is_public_holiday_approved_in_start2 = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','>=',str(signin1)),('date_from','<=',str(signout1)),('date_to','>',str(signout1))])
                            this_day_is_public_holiday_approved_in_end2 = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_to','>=',str(signin1)),('date_to','<=',str(signout1)),('date_from','<',str(signin1))])
                            this_day_is_public_holiday_approved_out_both2 = public_holiday_obj.search(cr,uid,[('state','=','validate'),('date_from','<=',str(signin1)),('date_to','>=',str(signout1))])
                            
                            if this_day_is_public_holiday_approved_in_both2 or this_day_is_public_holiday_approved_in_start2 or this_day_is_public_holiday_approved_in_end2 or this_day_is_public_holiday_approved_out_both2:
                                browsed_overtime_no_log_attendance0 = overtime_obj.browse(cr,uid,no_log_attendance_if_overtime_approved)
                                no_log_overtime_datetime = datetime.strptime(str(browsed_overtime_no_log_attendance0.date_end), '%Y-%m-%d %H:%M:%S') - datetime.strptime(str(browsed_overtime_no_log_attendance0.date_start), '%Y-%m-%d %H:%M:%S') - timedelta(hours=1)
                                no_log_overtime = round(no_log_overtime_datetime.seconds/3600,1)
                            else:
                                browsed_overtime_no_log_attendance = overtime_obj.browse(cr,uid,no_log_attendance_if_overtime_approved)
                                no_log_overtime = round(browsed_overtime_no_log_attendance.hours,1)
                        #=======================================================
                        # elif start_fixed <= converted_accession <= end_fixed:
                        #     if signin1 <= converted_accession:
                        #         tasalsan_time = 0.0
                        #         busad_time = busad_time + 8.0
                        #         no_log_overtime = 0.0
                        #     else:
                        #         tasalsan_time = 8.0
                        #         busad_time = busad_time + 0.0
                        #         no_log_overtime = 0.0
                        # elif emp.left_date:
                        #     convert_left = datetime.strptime(str(emp.left_date + ' 00:00:00'),'%Y-%m-%d %H:%M:%S')
                        #     converted_left = convert_left.replace(hour=23, minute=59, second=59)
                        #     if start_fixed <= converted_left <= end_fixed:
                        #         if signout1 >= converted_left:
                        #             tasalsan_time = 0.0
                        #             busad_time = busad_time + 8.0
                        #             no_log_overtime = 0.0
                        #         else:
                        #             tasalsan_time = 8.0
                        #             busad_time = busad_time + 0.0
                        #             no_log_overtime = 0.0
                        # 
                        # tasalsan_time_total = tasalsan_time_total + tasalsan_time
                        # busad_time_total = busad_time_total + busad_time
                        #=======================================================
                    #no_log_overtime_total = no_log_overtime_total + no_log_overtime
                    total_floats = total_floats + diff_float
                    #print '______________________', no_log_overtime_total, 'jjjjjj',no_log_overtime, '++++', workday_overtime, '++++', sunday_overtime
                    #Niilber ilvv tsag oloh
                    
                    additional_overtimes = workday_overtime + sunday_overtime + no_log_overtime
                    total_overtime = additional_overtimes + saturday_overtime_must + saturday_overtime + worked_in_work_day_and_public_holiday_total
                    
                    #Owchnii choloo oloh
                    typed_sick_leaves = hr_holidays_status_obj.search(cr,uid,[('is_sick','=',True)])
                    browsed_typed_sick_leaves = hr_holidays_status_obj.browse(cr,uid,typed_sick_leaves)
                    typed_legal_leaves = hr_holidays_status_obj.search(cr,uid,[('is_vacations','=',True)])
                    browsed_typed_legal_leaves = hr_holidays_status_obj.browse(cr,uid,typed_legal_leaves)
                    typed_unpayroll_leaves = hr_holidays_status_obj.search(cr,uid,[('unpayroll_holiday','=',True)])
                    browsed_typed_unpayroll_leaves = hr_holidays_status_obj.browse(cr,uid,typed_unpayroll_leaves)
                    #print 'TUHAIN SARIIN EHLEH BOLON DUUSAH ZAAGUUD', start_fixed, end_fixed
                    this_month_sick_leaves_approved_in_both = holiday_obj.search(cr,uid,[('employee_id','=',emp.id),('state','=','validate'),('date_from','>=',str(start_fixed)),('date_to','<=',str(end_fixed))])
                    this_month_sick_leaves_approved_in_start = holiday_obj.search(cr,uid,[('employee_id','=',emp.id),('state','=','validate'),('date_from','>=',str(start_fixed)),('date_from','<=',str(end_fixed)),('date_to','>',str(end_fixed))])
                    this_month_sick_leaves_approved_in_end = holiday_obj.search(cr,uid,[('employee_id','=',emp.id),('state','=','validate'),('date_to','>=',str(start_fixed)),('date_to','<=',str(end_fixed)),('date_from','<',str(start_fixed))])
                    this_month_sick_leaves_approved_out_both = holiday_obj.search(cr,uid,[('employee_id','=',emp.id),('state','=','validate'),('date_from','<',str(start_fixed)),('date_to','>',str(end_fixed))])
                          
                    browsed_sick_leaves_in_both = holiday_obj.browse(cr,uid,this_month_sick_leaves_approved_in_both)
                    browsed_sick_leaves_in_start = holiday_obj.browse(cr,uid,this_month_sick_leaves_approved_in_start)
                    browsed_sick_leaves_in_end = holiday_obj.browse(cr,uid,this_month_sick_leaves_approved_in_end)
                    browsed_sick_leaves_out_both = holiday_obj.browse(cr,uid,this_month_sick_leaves_approved_out_both)
                    
                    both_time_sick_total = 0.0
                    both_time_legal_total = 0.0
                    both_time_unpayroll_total = 0.0
                    in_start_time_sick_total = 0.0
                    in_start_time_legal_total = 0.0
                    in_start_time_unpayroll_total = 0.0
                    in_end_time_sick_total = 0.0
                    in_end_time_legal_total = 0.0
                    in_end_time_unpayroll_total = 0.0
                    both_time_sick = 0.0
                    both_time_legal = 0.0
                    both_time_unpayroll = 0.0
                    in_start_time_sick = 0.0
                    in_start_time_legal = 0.0
                    in_start_time_unpayroll = 0.0
                    in_end_time_sick = 0.0
                    in_end_time_legal = 0.0
                    in_end_time_unpayroll = 0.0
                    
                    if browsed_sick_leaves_in_both:
                        for line1 in  browsed_sick_leaves_in_both:
                            if line1.holiday_status_id.id == browsed_typed_sick_leaves.id:
                                if line1.number_of_days_temp == 0:
                                    both_time_sick = both_time_sick + line1.hours
                                elif line1.number_of_days_temp > 0:
                                    both_time_sick = both_time_sick + line1.number_of_days_temp * 8
                            elif line1.holiday_status_id.id == browsed_typed_legal_leaves.id:
                                if line1.number_of_days_temp == 0:
                                    both_time_legal = both_time_legal + line1.hours
                                elif line1.number_of_days_temp > 0:
                                    both_time_legal = both_time_legal + line1.number_of_days_temp * 8
                            elif line1.holiday_status_id.id == browsed_typed_unpayroll_leaves.id:
                                if line1.number_of_days_temp == 0:
                                    both_time_unpayroll = both_time_unpayroll + line1.hours
                                elif line1.number_of_days_temp > 0:
                                    both_time_unpayroll = both_time_unpayroll + line1.number_of_days_temp * 8
                        both_time_sick_total = both_time_sick_total + both_time_sick
                        both_time_legal_total = both_time_legal_total + both_time_legal
                        both_time_unpayroll_total = both_time_unpayroll_total + both_time_unpayroll
                    if browsed_sick_leaves_in_start:
                        for line2 in browsed_sick_leaves_in_start:
                            if line2.holiday_status_id.id == browsed_typed_sick_leaves.id:
                                diff_date_sick = datetime.strptime(str(end_fixed), '%Y-%m-%d %H:%M:%S.%f') - datetime.strptime(str(line2.date_from), '%Y-%m-%d %H:%M:%S') - timedelta(hours=24)
                                in_start_time_sick = in_start_time_sick + diff_date_sick.days*8
                            elif line2.holiday_status_id.id == browsed_typed_legal_leaves.id:
                                diff_date_legal = datetime.strptime(str(end_fixed), '%Y-%m-%d %H:%M:%S.%f') - datetime.strptime(str(line2.date_from), '%Y-%m-%d %H:%M:%S') - timedelta(hours=24)
                                in_start_time_legal = in_start_time_legal + diff_date_legal.days*8
                            elif line2.holiday_status_id.id == browsed_typed_unpayroll_leaves.id:
                                diff_date_unpayroll = datetime.strptime(str(end_fixed), '%Y-%m-%d %H:%M:%S.%f') - datetime.strptime(str(line2.date_from), '%Y-%m-%d %H:%M:%S') - timedelta(hours=24)
                                in_start_time_unpayroll = in_start_time_unpayroll + diff_date_unpayroll.days*8
                        in_start_time_sick_total = in_start_time_sick_total + in_start_time_sick
                        in_start_time_legal_total = in_start_time_legal_total + in_start_time_legal
                        in_start_time_unpayroll_total = in_start_time_unpayroll_total + in_start_time_unpayroll
                    if browsed_sick_leaves_in_end:
                        for line3 in browsed_sick_leaves_in_end:
                            if line3.holiday_status_id.id == browsed_typed_sick_leaves.id:
                                diff_date_sick2 = datetime.strptime(str(line3.date_to), '%Y-%m-%d %H:%M:%S') - start_fixed
                                in_end_time_sick = in_end_time_sick + diff_date_sick2.days*8
                            elif line3.holiday_status_id.id == browsed_typed_legal_leaves.id:
                                diff_date_legal2 = datetime.strptime(str(line3.date_to), '%Y-%m-%d %H:%M:%S') - start_fixed
                                in_end_time_legal = in_end_time_legal + diff_date_legal2.days*8
                            elif line3.holiday_status_id.id == browsed_typed_unpayroll_leaves.id:
                                diff_date_unpayroll2 = datetime.strptime(str(line3.date_to), '%Y-%m-%d %H:%M:%S') - start_fixed
                                in_end_time_unpayroll = in_end_time_unpayroll + diff_date_unpayroll2.days*8
                        in_end_time_sick_total = in_end_time_sick_total + in_end_time_sick
                        in_end_time_legal_total = in_end_time_legal_total + in_end_time_legal
                        in_end_time_unpayroll_total = in_end_time_unpayroll_total + in_end_time_unpayroll
                    
                    #Owchnii choloo oloh
                    total_sick_this_month = both_time_sick_total + in_start_time_sick_total + in_end_time_sick_total
                    #Eeljiin amralt oloh
                    total_legal_this_month = both_time_legal_total + in_start_time_legal_total + in_end_time_legal_total
                    #Huwiin choloo oloh
                    total_unpayroll_this_month = both_time_unpayroll_total + in_start_time_unpayroll_total + in_end_time_unpayroll_total
                    
                    if browsed_sick_leaves_out_both:
                        total_sick_this_month = 0.0
                        total_legal_this_month = 0.0
                        total_unpayroll_this_month = be_worked_hours
    
                    #Tasalsan tsag oloh
                    
                    #Busad
                    
                    #Hotsorson minut oloh
                    hotsorson_minute_not_saturday_total = hotsorson_minute_workday_total + hotsorson_minute_sunday_total
                    #Niit ajillasan tsag oloh
                    worked_hours = be_worked_hours - total_sick_this_month - total_unpayroll_this_month - tasalsan_time_total - total_legal_this_month - busad_time_total - hotsorson_minute_not_saturday_total/60
                    if worked_hours > 0:
                        worked_hours = worked_hours
                    else:
                        worked_hours = 0.0
                
            number +=1
            last_name = ''
            sheet.write_merge(row, row, 0, 0, u'%d'%number, sheet8)
            if emp.last_name:
                last_name = emp.last_name[0]
            sheet.write_merge(row, row, 1, 1, u'%s.%s'%(last_name,emp.name), sheet10)
            sheet.write_merge(row, row, 2, 2, u'%s'%emp.job_id.name, sheet10)
            sheet.write_merge(row, row, 3, 3, u'%s'%be_worked_hours, sheet9)
            sheet.write_merge(row, row, 4, 4, u'%s'%round(worked_hours,1), sheet9)
            sheet.write_merge(row, row, 5, 5, u'%s'%saturday_overtime_must, sheet9)
            sheet.write_merge(row, row, 6, 6, u'%s'%saturday_overtime, sheet9)
            sheet.write_merge(row, row, 7, 7, u'%s'%worked_in_work_day_and_public_holiday_total, sheet9)
            sheet.write_merge(row, row, 8, 8, u'%s'%round(additional_overtimes,1), sheet9)
            sheet.write_merge(row, row, 9, 9, u'%s'%total_overtime, sheet9)
            sheet.write_merge(row, row, 10, 10, u'%s'%total_sick_this_month, sheet9)
            sheet.write_merge(row, row, 11, 11, u'%s'%total_unpayroll_this_month, sheet9)
            sheet.write_merge(row, row, 12, 12, u'', sheet9)
            sheet.write_merge(row, row, 13, 13, u'%s'%total_legal_this_month, sheet9)
            sheet.write_merge(row, row, 14, 14, u'', sheet9)
            sheet.write_merge(row, row, 15, 15, u'%s'%hotsorson_minute_not_saturday_total, sheet9)
            sheet.write_merge(row, row, 16, 16, u'%s'%hotsorson_minute_saturday_total, sheet9)
            sheet.write_merge(row, row, 17, 17, u'%s'%emp.company_id.name, sheet10)
            #96+16+16
            row +=1

        
        sheet.write_merge(row+4, row+4, 0, 6, u'Цагийн баланс гаргасан..............................Г.Уугантогос', ezxf('font: bold off;align:wrap on,vert centre,horiz centre;font: height 200'))
        sheet.write_merge(row+7, row+7, 0, 6, u'Цагийн баланс Хянасан..............................Я.Нармандах', ezxf('font: bold off;align:wrap on,vert centre,horiz centre;font: height 200'))
        sheet.col(0).width=1400#Д/д
        sheet.col(1).width=6000#Овог нэр
        sheet.col(2).width=7000#Албан тушаал
        sheet.col(3).width=1400#Ажиллавал зохих цаг
        sheet.col(4).width=1400#Ажилласан цаг
        sheet.col(5).width=2000#Бямбад ажилласан илүү цаг
        sheet.col(6).width=2000#Нэмэлт илүү цаг
        sheet.col(7).width=2000#Нийт илүү цаг
        sheet.col(8).width=2000#Өвчтэй
        sheet.col(9).width=2000#Чөлөөтэй
        sheet.col(10).width=2000#Тасалсан
        sheet.col(11).width=2000#Ээлжийн амралттай
        sheet.col(12).width=2000#Бусад
        sheet.col(13).width=2000#Хоцорсон минут
        sheet.col(14).width=2000#Компани
        sheet.col(15).width=2000#Компани
        sheet.col(16).width=2000#Компани
        sheet.col(17).width=8000#Компани
        sheet.row(0).height=600#Mor 0
        sheet.row(2).height=600#Mor 2
        sheet.row(3).height=600#Mor 3
        sheet.row(4).height=1800#Mor 4
        
        return {'data':book}
    
    
    
    