# -*- coding: utf-8 -*-
##############################################################################
#    
#    Copyright (C) 2012 Agile Business Group sagl (<http://www.agilebg.com>)
#    Copyright (C) 2012 Domsense srl (<http://www.domsense.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv, fields
import openerp.addons.decimal_precision as dp
from openerp.tools.translate import _
from dateutil.relativedelta import relativedelta
import time
from datetime import timedelta, datetime
from vobject.base import readOne
from openerp.osv.fields import many2one


#===============================================================================
#     
# class account_invoice_line(osv.osv):
#     _inherit = 'account.invoice'
# 
#     def line_get_convert(self, cr, uid, line, part, date):
#         if line.get('tax_code_id'):
#             tax_id = self.pool.get('account.tax').search(cr, uid, [('id','=',line.get('tax_code_id'))])
#             tax = self.pool.get('account.tax').browse(cr, uid, tax_id)
#             if tax.partner_id.id:
#                 return {
#                     'date_maturity': line.get('date_maturity', False),
#                     'partner_id': tax.partner_id.id,
#                     'name': line['name'][:64],
#                     'date': date,
#                     'debit': line['price']>0 and line['price'],
#                     'credit': line['price']<0 and -line['price'],
#                     'account_id': line['account_id'],
#                     'analytic_lines': line.get('analytic_lines', []),
#                     'amount_currency': line['price']>0 and abs(line.get('amount_currency', False)) or -abs(line.get('amount_currency', False)),
#                     'currency_id': line.get('currency_id', False),
#                     'tax_code_id': line.get('tax_code_id', False),
#                     'tax_amount': line.get('tax_amount', False),
#                     'ref': line.get('ref', False),
#                     'quantity': line.get('quantity',1.00),
#                     'product_id': line.get('product_id', False),
#                     'product_uom_id': line.get('uos_id', False),
#                     'analytic_account_id': line.get('account_analytic_id', False),
#                 }
#             else:
#                 return {
#                 'date_maturity': line.get('date_maturity', False),
#                 'partner_id': part,
#                 'name': line['name'][:64],
#                 'date': date,
#                 'debit': line['price']>0 and line['price'],
#                 'credit': line['price']<0 and -line['price'],
#                 'account_id': line['account_id'],
#                 'analytic_lines': line.get('analytic_lines', []),
#                 'amount_currency': line['price']>0 and abs(line.get('amount_currency', False)) or -abs(line.get('amount_currency', False)),
#                 'currency_id': line.get('currency_id', False),
#                 'tax_code_id': line.get('tax_code_id', False),
#                 'tax_amount': line.get('tax_amount', False),
#                 'ref': line.get('ref', False),
#                 'quantity': line.get('quantity',1.00),
#                 'product_id': line.get('product_id', False),
#                 'product_uom_id': line.get('uos_id', False),
#                 'analytic_account_id': line.get('account_analytic_id', False),
#             }
#         else:
#             return {
#                 'date_maturity': line.get('date_maturity', False),
#                 'partner_id': part,
#                 'name': line['name'][:64],
#                 'date': date,
#                 'debit': line['price']>0 and line['price'],
#                 'credit': line['price']<0 and -line['price'],
#                 'account_id': line['account_id'],
#                 'analytic_lines': line.get('analytic_lines', []),
#                 'amount_currency': line['price']>0 and abs(line.get('amount_currency', False)) or -abs(line.get('amount_currency', False)),
#                 'currency_id': line.get('currency_id', False),
#                 'tax_code_id': line.get('tax_code_id', False),
#                 'tax_amount': line.get('tax_amount', False),
#                 'ref': line.get('ref', False),
#                 'quantity': line.get('quantity',1.00),
#                 'product_id': line.get('product_id', False),
#                 'product_uom_id': line.get('uos_id', False),
#                 'analytic_account_id': line.get('account_analytic_id', False),
#             }
#     
#===============================================================================


class asset_encoding(osv.osv):
    _name = 'asset.encoding'
    
    _columns = {
                'name':fields.char('Encoding'),
                'asset_name':fields.char('Asset name'),
                'image':fields.binary('Image',),
                'company_id':fields.many2one('res.company','Company'),
                'type':fields.selection([('tangible_assets','Tangible assets'),
                                         ('intangible_assets','Intangible assets')],'Type'),
                'measure_id':fields.many2one('product.uom','Measure'),
                'asset_encoding_line_id':fields.one2many('asset.encoding.line','asset_encoding_id','Asset encoding line'),
                }
    
    
class asset_encoding_line(osv.osv):
    _name = 'asset.encoding.line'
    _columns = {
                'country_id':fields.many2one('res.country','Country'),
                'bar_code':fields.char('Barcode'),
                'color':fields.char('Color'),
                'model':fields.char('Model'),
                'material':fields.char('Material'),
                'catapcity':fields.char('Catapcity'),
                'manual':fields.char('Manual'),
                'consumption':fields.char('Consumption'),
                'company_id':fields.many2one('res.company','Company'),
                'asset_encoding_id':many2one('asset.encoding','Asset encoding'),
                }
    

class account_invoice_line(osv.osv):
    _inherit = 'account.invoice.line'
    
    def onchange_asset_category(self, cr, uid, ids, category=False, context=None):
        if not category:
            return {'value':{}}
        category = self.pool.get('account.asset.category').browse(cr, uid, category, context=context)
        return {'value':{'account_id':category.account_asset_id.id}}

account_invoice_line()

class account_asset_asset_capitalization(osv.osv):
    _name = 'account.asset.asset.capitalization'
    _columns = {
        'date':fields.date('Date'),
        'amount':fields.float('Amount'),
        'account_move_id':fields.many2one('account.move', 'Account move'),
        'asset_id':fields.many2one('account.asset.asset', 'Asset')
    }
account_asset_asset_capitalization()

class account_asset_asset(osv.osv):
    _inherit = 'account.asset.asset'        
    
    
    
    def _amount_residualed(self, cr, uid, ids, name, args, context=None):
        cr.execute("""SELECT
                l.asset_id as id, SUM(l.debit-l.credit) AS amount
            FROM
                account_move_line l
            LEFT JOIN account_asset_asset as ass ON ass.id = l.asset_id
            LEFT JOIN account_asset_category as cat ON ass.category_id = cat.id
            WHERE  
                l.asset_id IN %s GROUP BY l.asset_id""", (tuple(ids),))
        res=dict(cr.fetchall())
        for asset in self.browse(cr, uid, ids, context):
            res[asset.id] = abs(asset.purchase_value + res.get(asset.id, 0.0)- asset.salvage_value)
        for id in ids:
            res.setdefault(id, 0.0)
        return res  

    
    def _write_amount(self, cr, uid, ids,name, args, context = None):
        
        sum_cap = 0.0
        cr.execute('select sum(amount) from account_asset_asset_capitalization where asset_id = '+str(ids[0]))
        sum_caps = cr.fetchone()
        if sum_caps and sum_caps[0]:
            sum_cap = sum_caps[0]
            
        return {ids[0]:sum_cap}
    _columns = {
        'encoding_id':fields.many2one('asset.encoding','Asset encoding'),
        'value_residual': fields.function(_amount_residualed, method=True, digits_compute=dp.get_precision('Account'), string='Residual Value'),
        'owner_id':fields.many2one('res.partner','Owner'),
        'measure_id':fields.many2one('product.uom','Measure'),
        'location_id':fields.many2one('asset.location','Asset location'),
        'type':fields.selection([('asset','Asset'),
                                 ('consumable','Consumable')],'Asset type'),
        'state': fields.selection([('draft','Draft'),('open','Running'),('close','Close'),('writeoff','WriteOff')], 'State', required=True,
                                  help="When an asset is created, the state is 'Draft'.\n" \
                                       "If the asset is confirmed, the state goes in 'Running' and the depreciation lines can be posted in the accounting.\n" \
                                       "You can manually close an asset when the depreciation is over. If the last line of depreciation is posted, the asset automatically goes in that state."),
        'history_note':     fields.text('History Notes', readonly=True),
        'default_code':fields.char('Code', size=25, readonly=True),
        'serial_number':fields.char('Serial Code', size=100),
        'write_up': fields.function(_write_amount, digits_compute=dp.get_precision('Account'), string='Write Up'),
        'capitalization_id':fields.one2many('account.asset.asset.capitalization', 'asset_id'),
        'depreciation_date':fields.date('Depreciation Date'),
        'end_date':fields.date('End date',readonly=True),
        'confirm_date':fields.date('Confirm date',readonly=True),
        'count_history_id':fields.one2many('asset.count.history','asset_id','Asset count history'),
        'move_history_id':fields.one2many('asset.move.history','asset_id','Asset move history'),
        'asset_qty':fields.float('Asset qty'),
    }
    
    _defaults = {
        'owner_id': lambda obj,cr,uid,context: context.get('owner_id', False),
        'method_number': 60,
        'method_period': 1,
        'method_progress_factor': 0.04,
        'confirm_date':time.strftime('%Y-%m-%d'),
    }
    
    def onchange_asset_name(self, cr, uid, ids, encoding_id,context=None):
            res = {}
            
            #obj = self.browse(cr, uid,ids)
            asset_obj = self.pool.get('asset.encoding')
           
            if encoding_id:
                #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
                asset = asset_obj.browse(cr, uid, encoding_id)[0]
                
                res['name']=asset.asset_name
                
            return {'value':res}
    def validate(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        return self.write(cr, uid, ids, {
            'state':'open',
            'confirm_date':time.strftime('%Y-%m-%d'),
        }, context)
        
    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid, ids)
        if 'owner_id' in vals:
            owner = self.search(cr, uid, [('owner_id','=',vals['owner_id']),('state','=','open'),('name','=',obj.name)])
            if len(owner)>=1:
                #raise osv.except_osv(_('Warning!'), _('Энэ ажилтан дээр өмнө нь хөрөнгө эсвэл хангамжийн материал олгосон байна.!!!'))
                pass
        res = super(account_asset_asset, self).write(cr, uid, ids, vals, context=context)
        
        return res
    def create(self, cr, uid, vals, context=None):
        if 'owner_id' in vals:
            owner = self.search(cr, uid, [('owner_id','=',vals['owner_id']),('state','=','open'),('name','=',vals['name'])])
            if len(owner)>=1:
                pass
                #raise osv.except_osv(_('Warning!'), _('Энэ ажилтан дээр өмнө нь хөрөнгө эсвэл хангамжийн материал олгосон байна.!!!'))
        asset_id = super(account_asset_asset, self).create(cr, uid, vals, context=context)
        self.compute_depreciation_board(cr, uid, [asset_id], context=context)
        return asset_id
#===============================================================================
#     def compute_depreciation_board(self, cr, uid, ids, context=None):
#         depreciation_lin_obj = self.pool.get('account.asset.depreciation.line')
#         currency_obj = self.pool.get('res.currency')
#         period_obj = self.pool.get('account.period')
#         last_depreciation_date = None
#         depreciation_date = None
#         for asset in self.browse(cr, uid, ids, context=context):
#             if asset.value_residual == 0.0:
#                 continue
#             posted_depreciation_line_ids = depreciation_lin_obj.search(cr, uid, [('asset_id', '=', asset.id), ('move_check', '=', True)],order='depreciation_date desc')
#             old_depreciation_line_ids = depreciation_lin_obj.search(cr, uid, [('asset_id', '=', asset.id), ('move_id', '=', False)])
#             if old_depreciation_line_ids:
#                 depreciation_lin_obj.unlink(cr, uid, old_depreciation_line_ids, context=context)
# 
#             amount_to_depr = residual_amount = asset.value_residual
#             if asset.prorata:
#                 period = period_obj.browse(cr, uid, period_obj.search(cr, uid, [('date_start','<=',asset.confirm_date),('date_stop','>=',asset.confirm_date)]))[0]
#                 depreciation_date = datetime.strptime(period.date_stop, '%Y-%m-%d')
#                 
#             else:
#                 # depreciation_date = 1st January of purchase year
#                 purchase_date = datetime.strptime(asset.confirm_date, '%Y-%m-%d')
#                 #if we already have some previous validated entries, starting date isn't 1st January but last entry + method period
#                 if (len(posted_depreciation_line_ids)>0):
#                     last_depreciation_date = datetime.strptime(depreciation_lin_obj.browse(cr,uid,posted_depreciation_line_ids[0],context=context).depreciation_date, '%Y-%m-%d')
#                     depreciation_date = (last_depreciation_date+relativedelta(months=+asset.method_period))
#                     
#                 else:
#                     purchase_date = datetime.strptime(asset.purchase_date, '%Y-%m-%d')
#                     month = purchase_date.month+1
#                     if month > 12:
#                         month = 1
#                         year = purchase_date.year+1
#                     else:
#                         month
#                         year = purchase_date.year
#                     dep_date = datetime(year, month, purchase_date.day)
#                     depreciation_date = dep_date
#             
#             
#             day = depreciation_date.day
#             month = depreciation_date.month
#             year = depreciation_date.year
#             total_days = (year % 4) and 365 or 366
#             depric_date = None
#             undone_dotation_number = self._compute_board_undone_dotation_nb(cr, uid, asset, depreciation_date, total_days, context=context)
#             for x in range(len(posted_depreciation_line_ids), undone_dotation_number):
#                 i = x + 1
#                 amount = self._compute_board_amount(cr, uid, asset, i, residual_amount, amount_to_depr, undone_dotation_number, posted_depreciation_line_ids, total_days, depreciation_date, context=context)
#                 company_currency = asset.company_id.currency_id.id
#                 current_currency = asset.currency_id.id
#                 # compute amount into company currency
#                 amount = currency_obj.compute(cr, uid, current_currency, company_currency, amount, context=context)
#                 residual_amount -= amount
#                 depric_date = depreciation_date.strftime('%Y-%m-%d')
#                 if asset.prorata:
#                     period = period_obj.browse(cr, uid, period_obj.search(cr, uid, [('date_start','<=',depreciation_date.strftime('%Y-%m-%d')),('date_stop','>=',depreciation_date.strftime('%Y-%m-%d'))]))
#                     if period !=[]:
#                         depreciation_date = datetime.strptime(period[0].date_stop, '%Y-%m-%d')
#                     else:
#                         raise osv.except_osv(_('Error!'),_(u"Та %s оны санхүүгийн мөчлөгийг үүсгэнэ үү!"%depreciation_date[:4]))
#                 vals = {
#                      'amount': amount,
#                      'asset_id': asset.id,
#                      'sequence': i,
#                      'name': str(asset.id) +'/' + str(i),
#                      'remaining_value': residual_amount,
#                      'depreciated_value': (asset.purchase_value - asset.salvage_value) - (residual_amount + amount),
#                      'depreciation_date': depreciation_date.strftime('%Y-%m-%d'),
#                 }
# 
#                 depreciation_lin_obj.create(cr, uid, vals, context=context)
#                 # Considering Depr. Period as months
#                 depreciation_date = (datetime(year, month, day) + relativedelta(months=+asset.method_period))
#                 day = depreciation_date.day
#                 month = depreciation_date.month
#                 year = depreciation_date.year
#             self.write(cr, uid, asset.id, {'end_date':depric_date}, context)
#         return True 
#===============================================================================
    
    def capitalization(self, cr, uid, ids, wizobj, context=None):
        ''' Хөрөнгө капиталжуулах визардаас шаардлагатай 
            өгөгдлүүдийг авч капиталжуулах боловсруулалт хийнэ.
            Үүнд:
             Хөрөнгийн түүх хөтлөх
             Хөрөнгийн өртөгийг капиталжуулах журналын бичилт бичих
            @param data: {
                'name': str
                'method_delay': int
                'method_period': int
                'capital': float
                'account_id': int
                'journal_id': int
                'partner_id': int
                'date': date-str
                'value_salvage':float
                'note': text
            }
        '''
        if context is None:
            context = {}
        asset = self.browse(cr, uid, ids[0], context=context)
        period_id = self.pool.get('account.period').find(cr, uid, context=context)[0]
        # Өмнөх өртөгийг түүх болгон хадгална.
        value_total_old = asset.purchase_value
        
        # Капиталжуулсан өөрчлөлтийн түүх хөтлөх, энэ нь капиталжуулахаас өмнөх
        # үеийн зарим шаардлагатай талбарын утгыг түүх болгон хадгалж байгаа юм.
        # Капиталжуулхад нэхэмжлэл үүсгэх
        move_obj = self.pool.get('account.move')
        move_line_obj = self.pool.get('account.move.line')
        
        asset_name_ref = asset.name_get()[0][1]
        move_id = move_obj.create(cr, uid, {
            'journal_id': asset.category_id.journal_id.id,
            'period_id': period_id,
            'name': '/',
            'ref': asset.code,
            'narration': wizobj.note or (u'%s хөрөнгийн капиталжуулалт.' % (asset_name_ref,))
        }, context=context)
        
        # Хөрөнгийн анхны өртөгийг капиталжуулах бичилт
        id = move_line_obj.create(cr, uid, {
            'name': asset_name_ref,
            'move_id': move_id,
            'account_id': asset.category_id.account_asset_id.id,
            'debit': wizobj.capital_amount,
            'credit': 0.0,
            'ref': asset.code,
            'period_id': period_id,
              'asset_id': asset.id,
            'journal_id': asset.category_id.journal_id.id,
            'date': wizobj.date, # Элэгдүүлж буй огноо
            'partner_id': wizobj.partner_id.id
        }, context=context)
        # Капиталжуулалтын өртөгийн эх үүсвэрийн бичилт
        id2 = move_line_obj.create(cr, uid, {
            'name': asset_name_ref,
            'move_id': move_id,
            'account_id': wizobj.account_id.id,
            'credit': wizobj.capital_amount,
            'debit': 0.0,
            'ref': asset.code,
            'asset_id': asset.id,
            'period_id': period_id,
            'journal_id': asset.category_id.journal_id.id,
            'date': wizobj.date,
            'partner_id': wizobj.partner_id.id
        }, context=context)

        move_obj.post(cr, uid, [move_id], context=context)

        self.pool.get('account.asset.asset.capitalization').create(cr,uid,{'asset_id':asset.id,
                                                                           'amount':wizobj.capital_amount,
                                                                           'date':wizobj.date,
                                                                           'account_move_id':move_id},context=context)

        vals = {}
        asset_vals = {}
        asset_obj = self.pool.get('account.asset.asset')
        purchase_value = asset.purchase_value + wizobj.capital_amount
        asset_vals.update({'purchase_value':purchase_value})
        asset_obj.write(cr, uid, asset.id, asset_vals, context=context)
        vals.update({'write_up': (asset.write_up or 0) + wizobj.capital_amount})
        
        if vals:
            self.write(cr, uid, ids, vals, context=context)
        return move_id

account_asset_asset()

class account_asset_depreciation_line(osv.osv):
    _inherit = 'account.asset.depreciation.line'

    def create_move(self, cr, uid, ids, context=None):
        can_close = False
        if context is None:
            context = {}
        asset_obj = self.pool.get('account.asset.asset')
        period_obj = self.pool.get('account.period')
        move_obj = self.pool.get('account.move')
        move_line_obj = self.pool.get('account.move.line')
        currency_obj = self.pool.get('res.currency')
        created_move_ids = []
        asset_ids = []
        for line in self.browse(cr, uid, ids, context=context):
            depreciation_date = line.depreciation_date
            period_ids = period_obj.find(cr, uid, depreciation_date, context=context)
            company_currency = line.asset_id.company_id.currency_id.id
            current_currency = line.asset_id.currency_id.id
            context.update({'date': depreciation_date})
            amount = currency_obj.compute(cr, uid, current_currency, company_currency, line.amount, context=context)
            sign = (line.asset_id.category_id.journal_id.type == 'purchase' and 1) or -1
            asset_name = line.asset_id.name
            reference = line.name
            move_vals = {
                'name': asset_name,
                'date': depreciation_date,
                'ref': reference,
                'period_id': period_ids and period_ids[0] or False,
                'journal_id': line.asset_id.category_id.journal_id.id,
                }
            move_id = move_obj.create(cr, uid, move_vals, context=context)
            journal_id = line.asset_id.category_id.journal_id.id
            partner_id = line.asset_id.partner_id.id
            move_line_obj.create(cr, uid, {
                'name': asset_name,
                'ref': reference,
                'move_id': move_id,
                'account_id': line.asset_id.category_id.account_depreciation_id.id,
                'debit': 0.0,
                'credit': amount,
                'period_id': period_ids and period_ids[0] or False,
                'journal_id': journal_id,
                'partner_id': partner_id,
                'currency_id': company_currency != current_currency and  current_currency or False,
                'amount_currency': company_currency != current_currency and - sign * line.amount or 0.0,
                'date': depreciation_date,
                'asset_id': line.asset_id.id
            })
            move_line_obj.create(cr, uid, {
                'name': asset_name,
                'ref': reference,
                'move_id': move_id,
                'account_id': line.asset_id.category_id.account_expense_depreciation_id.id,
                'credit': 0.0,
                'debit': amount,
                'period_id': period_ids and period_ids[0] or False,
                'journal_id': journal_id,
                'partner_id': partner_id,
                'currency_id': company_currency != current_currency and  current_currency or False,
                'amount_currency': company_currency != current_currency and sign * line.amount or 0.0,
                'analytic_account_id': line.asset_id.category_id.account_analytic_id.id,
                'date': depreciation_date,
                
            })
            self.write(cr, uid, line.id, {'move_id': move_id}, context=context)
            created_move_ids.append(move_id)
            asset_ids.append(line.asset_id.id)
        # we re-evaluate the assets to determine whether we can close them
        for asset in asset_obj.browse(cr, uid, list(set(asset_ids)), context=context):
            if currency_obj.is_zero(cr, uid, asset.currency_id, asset.value_residual):
                asset.write({'state': 'close'})
        return created_move_ids
    
    
class asset_count(osv.osv):
    _name = 'asset.count'
    
    _columns = {
                'company_id':fields.many2one('res.company','Company'),
                'name':fields.char('Name'),
                'date':fields.date('Start Date',required=True),
                'create_user':fields.many2one('res.users','Created user',required=True),
                'line_id':fields.one2many('asset.count.line','asset_count_id','Asset count line'),
                'state':fields.selection([('draft','Draft'),
                                          ('compute','Compute'),
                                          ('confirm','Confirm'),
                                          ],'State'),
                'type':fields.selection([('asset','Asset'),
                                         ('consumable','Consumable')],'Type',required=True),
                'move_id':fields.one2many('asset.move.line','count_id','Asset move'),
                'date_stop':fields.date('Date stop',required=True),
                'asset_location_id':fields.many2one('asset.location','Asset location'),
                'is_category':fields.boolean('Is category filter'),
                'category_id':fields.many2one('account.asset.category','Asset category'),
                'is_owner':fields.boolean('Is owner filter'),
                'owner_id':fields.many2one('hr.employee','Owner'),
                'description':fields.text('Description'),
                }
    _defaults = {
                 'state':'draft',
                 'date':fields.date.context_today,
                 'date_stop':fields.date.context_today,
                 'create_user':lambda obj, cr, uid, context: uid,
                 'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'asset.count', context=c),
                 }
    
    def action_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'draft'})
        return True
    
    def action_import(self,cr, uid, ids,context=None):
        obj = self.browse(cr, uid, ids)[0]
        asset_count_line_obj = self.pool.get('asset.count.line')
        if obj.type == 'asset':
            if obj.is_owner == True and obj.is_category == False:
                cr.execute("""select id,name,count(*),type,location_id,owner_id from account_asset_asset where 
                            location_id = %s and type = 'asset' and owner_id = %s
                            group by id,name,type,location_id,owner_id"""%obj.asset_location_id.id,obj.owner_id.id)
                asset = cr.dictfetchall()
            if obj.is_category == True and obj.is_owner == False:
                cr.execute("""select id,name,count(*),type,location_id,category_id from account_asset_asset where 
                            location_id = %s and type = 'asset' and category_id = %s
                            group by id,name,type,location_id,category_id"""%obj.asset_location_id.id,obj.category_id.id)
                asset = cr.dictfetchall()
            
            if obj.is_category == True and obj.is_owner == True:
                cr.execute("""select id,name,count(*),type,location_id, measure_id, owner_id,category_id from account_asset_asset 
                            where location_id = %s and type = 'asset' and owner_id = %s and category_id =%s 
                            group by id,name,type,measure_id,location_id,category_id,owner_id"""%obj.asset_location_id.id,obj.owner_id.id,obj.category_id.id)
                asset = cr.dictfetchall()
            elif obj.asset_location_id.id!=False:
                cr.execute("""select id,name,count(*),type,location_id, measure_id, owner_id,category_id from account_asset_asset 
                            where location_id = %s and type = 'asset' 
                            group by id,name,type,measure_id,location_id,category_id,owner_id"""%obj.asset_location_id.id)
                asset = cr.dictfetchall()
            else:
                cr.execute("""select id,name,count(*),type,location_id, measure_id, owner_id,category_id from account_asset_asset 
                            where type = 'asset' 
                            group by id,name,type,measure_id,location_id,category_id,owner_id""")
                asset = cr.dictfetchall()
                print "lllllllllllll",asset
        if obj.type == 'consumable':
            if obj.is_owner == True and obj.is_category == False:
                cr.execute("""select id,name,count(*),type,location_id,owner_id from account_asset_asset where 
                        location_id = %s and type = 'consumable' and owner_id = %s
                        group by id,name,type,location_id,owner_id"""%obj.asset_location_id.id,obj.owner_id.id)
                asset = cr.dictfetchall()
            if obj.is_category == True and obj.is_owner == False:
                cr.execute("""select id,name,count(*),type,location_id,category_id from account_asset_asset where 
                            location_id = %s and type = 'consumable' and category_id = %s
                            group by id,name,type,location_id,category_id"""%obj.asset_location_id.id,obj.category_id.id)
                asset = cr.dictfetchall()
            
            if obj.is_category == True and obj.is_owner == True:
                cr.execute("""select id,name,count(*),type,location_id, measure_id, owner_id,category_id from account_asset_asset 
                            where location_id = %s and type = 'consumable' and owner_id = %s and category_id =%s 
                            group by id,name,type,measure_id,location_id,category_id,owner_id"""%obj.asset_location_id.id,obj.owner_id.id,obj.category_id.id)
                asset = cr.dictfetchall()
            elif obj.asset_location_id.id !=False:
                cr.execute("""select id,name,count(*),type,location_id, measure_id, owner_id,category_id from account_asset_asset 
                            where location_id = %s and type = 'consumable' 
                            group by id,name,type,measure_id,location_id,category_id,owner_id"""%obj.asset_location_id.id)
                asset = cr.dictfetchall()
            else:
                cr.execute("""select id,name,count(*),type,location_id, measure_id, owner_id,category_id from account_asset_asset 
                            where type = 'consumable' 
                            group by id,name,type,measure_id,location_id,category_id,owner_id""")
                asset = cr.dictfetchall()
        for line in asset:
            if line['id'] !=[]:
                line_id = asset_count_line_obj.search(cr, uid, [('asset_id','=',line['id']),('asset_count_id','=',ids[0])])
                if line_id ==[]:
                    asset_count_line_obj.create(cr, uid, {
                                                          'asset_id':line['id'],
                                                          'now_balance':line['count'],
                                                          'asset_count_id':ids[0],
                                                          'location_id':line['location_id'],
                                                          'owner_id':line['owner_id'],
                                                          'product_uom_id':line['measure_id'],
                                                          })

        return True
    def action_compute(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('asset.count.line')
        asset_move_obj = self.pool.get('asset.move')
        asset_move_line_obj = self.pool.get('asset.move.line')
        loc_obj = self.pool.get('asset.location')
        
        loc_id = loc_obj.search(cr, uid, [('location_type','=','inventory')])
        diff = 0
        if loc_id == []:
            raise osv.except_osv(_('Warning!'),_("Та хөрөнгийн хадгалах төрөлтэй байрлалыг үүсгэнэ үү"))
        for lines in obj.line_id:
            if obj.type == 'asset':
                diff = lines.now_balance-lines.qty_balance
                line_obj.write(cr, uid, lines.id, {
                                                    'difference':diff,
                                                    }, context)
                if diff > 0:
                    move = asset_move_obj.search(cr, uid, [('count_id','=',obj.id)])
                    if move == []:
                        move_id = asset_move_obj.create(cr, uid, {
                                                        'state':'draft',
                                                        'type':'asset',
                                                        'count_id':obj.id,
                                                        })
                        
                        asset_move_line_obj.create(cr, uid, {
                                                            'asset_id':lines.asset_id.id,
                                                            'quantity':diff,
                                                            'out_of_location':lines.asset_id.location_id.id,
                                                            'in_of_location':loc_id[0],
                                                            'state':'draft',
                                                            'type':'asset',
                                                            'move_id':move_id,
                                                            'product_uom_id':lines.asset_id.measure_id.id,
                                                            'owner_id':lines.asset_id.owner_id.id,
                                                            'count_id':obj.id, 
                                                             })
                    else:
                        for line in asset_move_obj.browse(cr, uid, move):
                            asset_move_line_obj.write(cr, uid, line.id,{
                                        'asset_id':lines.asset_id.id,
                                        'quantity':diff,
                                        'out_of_location':lines.asset_id.location_id.id,
                                        'in_of_location':loc_id[0],
                                        'state':'draft',
                                        'type':'asset',
                                        'move_id':move_id,
                                        'product_uom_id':lines.asset_id.measure_id.id,
                                        'owner_id':lines.asset_id.owner_id.id,
                                        'count_id':obj.id, 
                                         })
                    
            else:
                diff = lines.now_balance-lines.qty_balance
                line_obj.write(cr, uid, lines.id, {
                                                    'difference':diff,
                                                    }, context)
                if diff > 0:
                    move_id = asset_move_obj.create(cr, uid, {
                                'state':'draft',
                                'type':'asset',
                                'count_id':obj.id,
                                })
                    
                    asset_move_obj.create(cr, uid, {
                                                    'asset_id':lines.asset_id.id,
                                                    'quantity':diff,
                                                    'out_of_location':lines.asset_id.location_id.id,
                                                    'in_of_location':loc_id[0],
                                                    'state':'draft',
                                                    'type':'consumable',
                                                    'move_id':move_id,
                                                    'product_uom_id':lines.asset_id.measure_id.id,
                                                    'owner_id':lines.asset_id.owner_id.id,
                                                    'count_id':obj.id,
                                                    })
        self.write(cr, uid, ids, {'state':'compute'}, context)
        return True
    def action_confirm(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        depreciation_date = time.strftime('%Y-%m-%d')
        period_obj = self.pool.get('account.period')
        period_ids = period_obj.find(cr, uid, depreciation_date, context=context)
        currency_obj = self.pool.get('res.currency')
        history_obj = self.pool.get('asset.count.history')
        move_obj = self.pool.get('account.move')
        move_line_obj = self.pool.get('account.move.line')
        period_id = self.pool.get('account.period').find(cr, uid, context=context)[0]
        asset_obj = self.pool.get('account.asset.asset')
        asset = asset_obj.browse(cr, uid, ids[0], context=context)
        company_currency = asset.company_id.currency_id.id
        current_currency = asset.currency_id.id
        move_id = move_obj.create(cr, uid, {
                                            'journal_id':asset.category_id.journal_id.id,
                                            'period_id':period_id,
                                            'name':'/',
                                            'ref':'asset',
                                            })
        for line in obj.move_id:
            amount = currency_obj.compute(cr, uid, current_currency, company_currency, line.asset_id.value_residual, context=context)
            move_line_obj.create(cr, uid, {
                    'name': asset.name,
                    'ref': asset.name,
                    'move_id': move_id,
                    'account_id': line.asset_id.category_id.account_asset_id.id,
                    'debit': 0.0,
                    'credit': amount,
                    'period_id': period_ids and period_ids[0] or False,
                    'journal_id': asset.category_id.journal_id.id,
                    #'partner_id': partner_id,
                    'currency_id': company_currency != current_currency and  current_currency or False,
                    'amount_currency': company_currency != current_currency and - sign * line.amount or 0.0,
                    'date': depreciation_date,
                })
            move_line_obj.create(cr, uid, {
                    'name': asset.name,
                    'ref': '/',
                    'move_id': move_id,
                    'account_id': line.in_of_location.asset_val_account_income_id.id,
                    'credit': 0.0,
                    'debit': amount,
                    'period_id': period_ids and period_ids[0] or False,
                    'journal_id': asset.category_id.journal_id.id,
                    #'partner_id': partner_id,
                    'currency_id': company_currency != current_currency and  current_currency or False,
                    'amount_currency': company_currency != current_currency and sign * line.amount or 0.0,
                    'date': depreciation_date,
                    'asset_id': line.asset_id.id
                })
        history_obj.create(cr, uid, {
                                     'asset_id':asset.id,
                                     'count_date':time.strftime('%Y-%m-%d'),
                                     'company_id':obj.company_id.id,
                                     })
        self.write(cr, uid, ids, {'state':'confirm'}, context)
        return True
class asset_count_line(osv.osv):
    _name = 'asset.count.line'
    
    _columns = {
                'company_id':fields.many2one('res.company','Company'),
                'asset_id':fields.many2one('account.asset.asset','Asset name'),
                'product_uom_id':fields.many2one('product.uom','Product uom'),
                'now_balance':fields.float('Now balance',readonly=True),
                'qty_balance':fields.float('Qty balance'),
                'difference':fields.float('Difference'),
                'asset_count_id':fields.many2one('asset.count','Asset count'),
                'reference':fields.char('Description'),
                'owner_id':fields.many2one('res.partner','Hr employee'),
                'location_id':fields.many2one('asset.location','Asset location'),
                }
    
    _defaults = {
                 'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'asset.count.line', context=c),
                 }
    def write(self, cr, uid, ids, vals, context=None):
        if 'qty_balance' in vals:
            vals.update({'qty_balance':vals['qty_balance']})
        return super(asset_count_line, self).write(cr, uid, ids, vals, context=context)
    
class asset_location(osv.osv):
    _name = 'asset.location'
    _columns = {
                'type':fields.selection([('asset','Asset'),
                                         ('consumable','Consumable')],'Type',required=True),
                'company_id':fields.many2one('res.company','Company'),
                'name':fields.char('Name'),
                'parent_id':fields.many2one('asset.location','Parent location'),
                'active':fields.boolean('Active'),
                'location_type':fields.selection([('supplier_location','Supplier location'),
                                                  ('view','View'),
                                                  ('damage','Damage'),
                                                  ('asset_type','Asset location'),
                                                  ('internal_location','Internal location'),
                                                  ('customer_location','Customer location'),
                                                  ('inventory','Inventory'),
                                                  ('procurement','Procurement'),
                                                  ('production','Production'),
                                                  ('transit_location','Transit location'),
                                                  ],'Location type'),
                'asset_val_account_income_id':fields.many2one('account.account','Asset valuation income account'),
                'asset_val_account_out_id':fields.many2one('account.account','Asset valuation out account'),
                
            } 
    _defaults = {
                 'active':True,
                 'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'asset.location', context=c),
                 }
    
class asset_move(osv.osv):
    _name = 'asset.move'
    _columns = {
                'created_date':fields.date('Created date'),
                'type':fields.selection([('asset','Asset'),
                                         ('consumable','Consumable')],'Type',required=True),
                'company_id':fields.many2one('res.company','Company'),
                'state':fields.selection([('draft','Draft'),
                                          ('confirm','Confirm'),
                                          ('return','Return')],'State'),
                'user_id':fields.many2one('res.users','Created user'),
                'move_line_id':fields.one2many('asset.move.line','move_id','Asset move line'),
                'count_id':fields.many2one('asset.count','Asset count'),
                }
    _defaults = {
                 'state':'draft',
                 'user_id':lambda self, cr, uid, c:uid,
                 'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'asset.move', context=c),
                 }
    
    

    
    def action_confirm(self, cr, uid, ids,context=None):
        obj = self.browse(cr, uid, ids)[0]
        currency_obj = self.pool.get('res.currency')
        asset_obj = self.pool.get('account.asset.asset')
        location_obj = self.pool.get('asset.location')
        account_move_obj = self.pool.get('account.move')
        move_line_obj = self.pool.get('account.move.line')
        period_ids = self.pool.get('account.period').find(cr, uid, context=context)[0]
        depreciation_date = time.strftime('%Y-%m-%d')
        company_currency = obj.company_id.currency_id.id
        for line in obj.move_line_id:
            current_currency = line.asset_id.currency_id.id
            if line.id !=False:
                location = location_obj.search(cr, uid, [('id','=',line.in_of_location.id),('location_type','=','inventory')])
                if location != []:
                    move_id = account_move_obj.create(cr, uid, {
                                                        'journal_id':line.asset_id.category_id.journal_id.id,
                                                        'period_id':period_ids,
                                                        'name':'/',
                                                        'ref':'asset',
                                                      })
                    amount = currency_obj.compute(cr, uid, current_currency, company_currency, line.asset_id.value_residual, context=context)
                    move_line_obj.create(cr, uid, {
                            'name': line.asset_id.name,
                            'ref': line.asset_id.name,
                            'move_id': move_id,
                            'account_id': line.asset_id.category_id.account_asset_id.id,
                            'debit': 0.0,
                            'credit': amount,
                            'period_id': period_ids or False,
                            'journal_id': line.asset_id.category_id.journal_id.id,
                            'partner_id': line.owner_id.id,
                            'currency_id': company_currency != current_currency and  current_currency or False,
                            'amount_currency': company_currency != current_currency and - sign * line.amount or 0.0,
                            'date': depreciation_date,
                        })
                    move_line_obj.create(cr, uid, {
                            'name': line.asset_id.name,
                            'ref': '/',
                            'move_id': move_id,
                            'account_id': line.in_of_location.asset_val_account_income_id.id,
                            'credit': 0.0,
                            'debit': amount,
                            'period_id': period_ids or False,
                            'journal_id': line.asset_id.category_id.journal_id.id,
                            'partner_id': line.owner_id.id,
                            'currency_id': company_currency != current_currency and  current_currency or False,
                            'amount_currency': company_currency != current_currency and sign * line.amount or 0.0,
                            'date': depreciation_date,
                            'asset_id': line.asset_id.id
                        })
                    
                    
                    
                
                    asset_obj.write(cr, uid, line.asset_id.id,{'location_id':line.in_of_location.id})
                else:
                    raise osv.except_osv(_('Warning!'),_("Хүрэх байршилыг тохируулна уу"))
                
            else:
                raise osv.except_osv(_('Warning!'),_("%s out of location on product don't have quantity!"%(obj.asset_id.name)))

                
        self.write(cr, uid, ids, {'state':'confirm'}, context)
        return True

class asset_move_line(osv.osv):
    _name = 'asset.move.line'
    
    _columns = {
                'company_id':fields.many2one('res.company','Company'),
                'asset_id':fields.many2one('account.asset.asset','Asset name'),
                'product_uom_id':fields.many2one('product.uom','Product uom'),
                'move_id':fields.many2one('asset.move','Asset move'),
                'owner_id':fields.many2one('res.partner','Hr employee'),
                'in_of_location':fields.many2one('asset.location','In of location',required=True),
                'out_location':fields.many2one('asset.location','Asset location'),
                'count_id':fields.many2one('asset.count','Asset count'),
                'quantity':fields.float('Quantity'),
                'reference':fields.char('Description'),
                }
    
    def asset_onchange(self, cr, uid, ids, asset, context=None):
        asset_obj = self.pool.get('account.asset.asset')
        asset = asset_obj.browse(cr, uid, asset)

        return {'value':{
                         'product_uom_id':asset.measure_id.id,
                         'owner_id':asset.owner_id.id,
                         'out_location':asset.location_id.id,
                        }}
        
class asset_count_history(osv.osv):
    _name = 'asset.count.history'
    _columns = {
                'asset_id':fields.many2one('account.asset.asset','Asset'),
                'company_id':fields.many2one('res.company','Company'),
                'count_date':fields.date('Count date'),
                }
class asset_move_history(osv.osv):
    _name = 'asset.move.history'
    _columns = {
                'asset_id':fields.many2one('account.asset.asset','Account asset'),
                'out_of_location':fields.many2one('asset.location','Out of location'),
                'in_of_location':fields.many2one('asset.location','In of location'),
                'date':fields.date('Date'),
                }
class account_asset_category(osv.osv):
    _inherit = "account.asset.category"
    
    _columns = {
                'type':fields.selection([('asset','Asset'),
                                         ('consumable','Consumable')],'Type'),
                'location_id':many2one('asset.location','Asset location'),
                }