# -*- coding: utf-8 -*-
##############################################################################
#    
#    Copyright (C) 2012 Agile Business Group sagl (<http://www.agilebg.com>)
#    Copyright (C) 2012 Domsense srl (<http://www.domsense.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv, fields
import openerp.addons.decimal_precision as dp
from openerp.tools.translate import _
from dateutil.relativedelta import relativedelta
import time
from datetime import timedelta, datetime

from lxml import etree
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula


class account_bank(osv.osv):
    _inherit = 'res.partner.bank'
    _columns = {
                'swift_code':fields.char('Swift code'),
                'iban':fields.integer('IBAN'),
                }
    
class account_bank_statement_line(osv.osv):
    _inherit = 'account.bank.statement.line'
    
    def on_change_partner_bank(self, cr, uid, ids, partner_id, context=None):
        partner_obj = self.pool.get('res.partner')
        bank_id = None
        if partner_id:
            partner = partner_obj.browse(cr, uid, partner_id)
            if len(partner.bank_ids) > 1:
                bank_id = partner.bank_ids[0].id
            elif len(partner.bank_ids) == 1:
                bank_id = partner.bank_ids.id

        return {'value':{
                            'bank_account_id':bank_id}}
    
    def get_export_print(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids[0])
        bank = self.pool.get('res.partner.bank')
        res = self.pool.get('res.partner')
        line_id = self.pool.get('account.bank.statement.line').browse(cr, uid,obj.id)
        statement = self.pool.get('account.bank.statement').browse(cr, uid,line_id.statement_id.id)
        bank_ids = bank.search(cr, uid, [('journal_id','=',statement.journal_id.id)])
        if bank_ids:
            com_bnk = bank.browse(cr, uid, bank_ids)[0]
            context['com_bank_name'] = com_bnk.bank_name
            context['com_account_number'] = com_bnk.acc_number
            context['com_partner'] = com_bnk.partner_id.name
            context['com_bnk_code'] = com_bnk.bank_bic
        else:
            raise osv.except_osv(_('Error'),_(u'Компанийн банкны дансыг тохируулаагүй байна'))
        if line_id.partner_id:
            context['partner'] = line_id.partner_id.name
            if line_id.partner_id.bank_ids:
                bank_id = bank.search(cr, uid, [('partner_id','=',line_id.partner_id.id)])
                part_bnk = bank.browse(cr, uid, bank_id)[0]
                context['partner_bnk_name'] = part_bnk.bank_name
                context['partner_account_number'] = part_bnk.acc_number
            else:
                raise osv.except_osv(_('Error'),_(u'Харилцагч данс сонгоогүй байна'))
        else:
            raise osv.except_osv(_('Error'),_(u'Харилцагч сонгоогүй байна'))
        context['amount'] = line_id.amount
        context['name'] = line_id.name
        context['date'] = statement.date
        context['company'] = statement.company_id.name
        context['move_type'] = line_id.cash_move_type.name
 
        return {
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'account.banks.statement.order',
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context,
            'nodestroy': True,
        }
    
    
class account_bank_statement_inherit(osv.osv):
    _inherit = 'account.bank.statement'
    
    def print_statement(self, cr, uid, ids, context=None):
        return {
            'name':_("Print account bank statement"),
            'view_mode': 'form',
            'view_id': False,
            'view_type': 'form',
            'res_model': 'account.bank.statement.excel',
            'type': 'ir.actions.act_window',
            'nodestroy': True,
            'target': 'new',
            'domain': '[]',
            'context': context
        }
    
    def print_payment_order(self, cr, uid, ids, context=None):
        return {
            'name':_("Print account banks statement order"),
            'view_mode': 'form',
            'view_id': False,
            'view_type': 'form',
            'res_model': 'account.banks.statement.order',
            'type': 'ir.actions.act_window',
            'nodestroy': False,
            'target': 'new',
            'domain': '[]',
            'context': context
        }
    
    #===========================================================================
    # def get_export_data(self, cr, uid, ids, context=None):
    #     if context is None:
    #         context = {}
    #     form = self.browse(cr, uid, ids[0], context=context)
    #     user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
    #     datas = {'ids': context.get('active_ids', [])}
    #     datas['form'] = self.read(cr, uid, ids)[0]
    #     
    #     data = datas['form']
    #     ezxf = xlwt.easyxf
    #     styles = self.get_easyxf_styles()
    #     
    #     styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
    #     stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
    #     styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal left;')
    #     styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
    #     stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
    #     stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
    #     styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
    #     stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
    #     style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
    #     style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
    #     style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
    #     
    #     
    #     style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
    #     style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
    #     style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
    #     book = xlwt.Workbook(encoding='utf8')
    #     sheet = book.add_sheet('Account bank statement excel')
    #     sheet.write_merge(1, 3, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
    #    
    #     sheet.write_merge(5, 5, 3, 8, u'%s' %data['id'], ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))
    #     
    #     cr.execute("""select * 
    #                     from account_bank_statement
    #                     where id = %s"""%(data['id']))
    #     statement  = cr.dictfetchall()
    #     print 'ppppppppppwppw',statement['id']
    #     if statement:
    #         for line in statement:
    #             sheet.write_merge(7, 7, 3, 8, u'%s' %line['name'], ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))
    #             sheet.write_merge(9, 9, 3, 8, u'%s' %line['user_id'], ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))
    #     else:
    #         print 'uuuuuuuuuu',statement
    #     
    #     inch = 2000
    #     inch1 = 5000
    #     sheet.col(0).width = 1*inch
    #     sheet.col(1).width = 1*inch
    #     sheet.col(2).width = 1*inch
    #     sheet.col(3).width = 1*inch
    #     sheet.col(4).width = 1*inch
    #     sheet.col(5).width = 1*inch
    #     sheet.col(6).width = 1*inch
    #     sheet.col(7).width = 1*inch
    #     sheet.col(8).width = 1*inch
    #     sheet.col(9).width = 1*inch
    #     sheet.col(10).width = 1*inch
    #     sheet.col(11).width = 1*inch
    #     
    #     #----------------------------------------------------------- inch = 1000
    #     #----------------------------------------------------------- inch1 = 900
    #     #------------------------------------------- sheet.col(0).width = 1*inch
    #     #------------------------------------------ sheet.col(1).width = 5*inch1
    #     #------------------------------------------- sheet.col(2).width = 3*inch
    #     #------------------------------------------- sheet.col(3).width = 2*inch
    #     #------------------------------------------- sheet.col(4).width = 4*inch
    #     #------------------------------------------- sheet.col(5).width = 6*inch
    #     #------------------------------------------- sheet.col(6).width = 2*inch
    #     #------------------------------------------- sheet.coшалгахl(7).width = 4*inch
    #     #------------------------------------------ sheet.col(8).width = 2*inch1
    #     #------------------------------------------- sheet.col(9).width = 4*inch
    #     
    #     return {'data':book}
    #===========================================================================
    

    #===========================================================================
    # def create(self, cr, uid, vals, context=None):
    #     if vals.get('name', '/') == '/':
    #         journal_id = vals.get('journal_id', self._default_journal_id(cr, uid, context=context))
    #         vals['name'] = self._compute_default_statement_name(cr, uid, journal_id, context=context)
    #     print 'journaliin com_id',journal_id
    #       
    #     if 'line_ids' in vals:
    #         for idx, line in enumerate(vals['line_ids']):
    #             line[2]['sequence'] = idx + 1
    #       
    #     return super(account_bank_statement, self).create(cr, uid, vals, context=context)
    #===========================================================================
    
    #===========================================================================
    # def _default_journal_id(self, cr, uid, context=None):
    #     if context is None:
    #         context = {}
    #     journal_pool = self.pool.get('account.journal')
    #     journal_type = context.get('journal_type', False)
    #     company_id = self.pool.get('res.company')._company_default_get(cr, uid, 'account.bank.statement',context=context)
    #     if journal_type:
    #         ids = journal_pool.search(cr, uid, [('type', '=', journal_type),('company_id','=',company_id)])
    #         if ids:
    #             return ids[0]
    #     return False
    #===========================================================================
#===============================================================================
#     def create(self, cr, uid, vals, context=None):
#         if vals.get('name', '/') == '/':
#             journal_id = vals.get('journal_id', self._default_journal_id(cr, uid, context=context))
#             vals['name'] = self._compute_default_statement_name(cr, uid, journal_id, context=context)
#         if 'line_ids' in vals:
#             for idx, line in enumerate(vals['line_ids']):
#                 line[2]['sequence'] = idx + 1
#         return super(account_bank_statement, self).create(cr, uid, vals, context=context)
# 
#     def write(self, cr, uid, ids, vals, context=None):
#         res = super(account_bank_statement, self).write(cr, uid, ids, vals, context=context)
#         account_bank_statement_line_obj = self.pool.get('account.bank.statement.line')
#         for statement in self.browse(cr, uid, ids, context):
#             for idx, line in enumerate(statement.line_ids):
#                 account_bank_statement_line_obj.write(cr, uid, [line.id], {'sequence': idx + 1}, context=context)
#                 if res[statement.id] < 0:
#                     print '22222222222222',res[statement.id],res
#                     res[statement.id] = '(' + res[statement.id]*(-1) + ')'
#                     print '33333333333333',res[statement.id],res
#                 else:
#                     print '44444444444444',res[statement.id],res
#                     res[statement.id] = res[statement.id]
#                     print '55555555555555',res[statement.id],res
#         return res
#     def _end_balance(self, cursor, user, ids, name, attr, context=None):
#         res = {}
#         for statement in self.browse(cursor, user, ids, context=context):
#             res[statement.id] = statement.balance_start
#             for line in statement.line_ids:
#                 res[statement.id] += line.amount
#                 print '113456781',res[statement.id],res
#                 if res[statement.id] < 0:
#                     print '22222345678922',res[statement.id],res
#                     res[statement.id] = '(' + res[statement.id]*(-1) + ')'
#                     print '333334567333',res[statement.id],res
#                 else:
#                     print '444367444',res[statement.id],res
#                     res[statement.id] = res[statement.id]
#                     print '555545678555',res[statement.id],res
#         return res
#===============================================================================
