# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class account_bank_statement_excel(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "account.bank.statement.excel"
    _description = "Account bank statement excel"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company'),
        'statement_id': fields.many2one('account.bank.statement', 'Statement id'),
        'statement_type': fields.selection([
                    ('income', 'Income'),
                    ('expense', 'Expense'),
                    ], 'Statement type', required=True)
        }
    
    #_defaults = {
    #   'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    #}
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal center;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;')
        style_orientation = ezxf('font: bold on, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        styled = ezxf('font: bold on, name Times New Roman, height 200; borders: bottom dashed, ; align: wrap on, vertical center, horizontal center;')
        style_left = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
        style_right = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal right;')
        style_amount = ezxf('font: bold on, name Times New Roman, height 200; borders: bottom dashed, ; align: wrap on, vertical center, horizontal left;')
        
        
        styleBIG = ezxf('font: bold on; align: wrap on, vertical center, horizontal center;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Account bank statement excel')
        sheet.portrait = True
        
        if data['statement_id'] == False:
            raise osv.except_osv(_('Error!'),_("Кассын утга сонгогдоогүй байна!"))
        else:
            cr.execute("""  
                select  abs.company_id, rc.name as compname, abs.date as absdate, 
                        absl.date as absldate, absl.name as abslname, absl.partner_id, 
                        amount, aj.name as ajname, curr.name as curname
                from    account_bank_statement as abs, 
                        account_bank_statement_line as absl,
                        account_journal as aj,
                        res_company as rc,
                        res_currency as curr
                where   abs.id = %s and
                        abs.id = absl.statement_id and
                        abs.journal_id = aj.id and
                        abs.company_id = rc.id and
                        absl.amount > 0 and
                        aj.currency = curr.id """%(data['statement_id'][0]))
            statement_income  = cr.dictfetchall()
            
            cr.execute("""  
                select  abs.company_id, rc.name as compname, abs.date as absdate, 
                        absl.date as absldate, absl.name as abslname, absl.partner_id, 
                        amount, aj.name as ajname, curr.name as curname
                from    account_bank_statement as abs, 
                        account_bank_statement_line as absl,
                        account_journal as aj,
                        res_company as rc,
                        res_currency as curr
                where   abs.id = %s and
                        abs.id = absl.statement_id and
                        abs.journal_id = aj.id and
                        abs.company_id = rc.id and
                        absl.amount < 0 and
                        aj.currency = curr.id """%(data['statement_id'][0]))
            statement_expense  = cr.dictfetchall()
            
            if statement_income:
                if data['statement_type'] == 'income':
                    i = 0
                    j = 1
                    n = 9
                    m = 20
                    a = 24
                    for line in statement_income:
                        sheet.write_merge(i, i, 6, 10, u'Статистикийн төв газар', style_no_border)
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        sheet.write(i, 11, u'', styler)
                        i = i + 1
                        #i=29
                        sheet.write(i, 11, u'', styler)
                        
                        
                        sheet.write_merge(j, j, 0, 6, u'%s' %line['compname'], styled)
                        sheet.write_merge(j, j, 8, 10, u'№ 188/340', style_no_border)
                        sheet.write_merge(j, j, 15, 21, u'%s' %line['compname'], styled)
                        j = j + 1
                        #j=2
                        sheet.write_merge(j, j, 0, 6, u'/Байгууллагын нэр/', style_no_border)
                        sheet.write_merge(j, j, 15, 21, u'/Байгууллагын нэр/', style_no_border)
                        j = j + 2
                        #j=4
                        sheet.write_merge(j, j, 1, 10, u'КАССЫН ОРЛОГЫН ОРДЕР №', styleBIG)
                        sheet.write_merge(j, j, 14, 21, u'КАССЫН ОРЛОГЫН ОРДЕР №', styleBIG)
                        #----------------------------------- if line['amount'] >= 0:
                            # sheet.write_merge(j, j, 1, 10, u'КАССЫН ОРЛОГЫН ОРДЕР №', styleBIG)
                            # sheet.write_merge(j, j, 14, 21, u'КАССЫН ОРЛОГЫН ОРДЕР №', styleBIG)
                        #----------------------------------------------------- else:
                            # sheet.write_merge(j, j, 1, 10, u'КАССЫН ЗАРЛАГЫН ОРДЕР №', styleBIG)
                            # sheet.write_merge(j, j, 14, 21, u'КАССЫН ЗАРЛАГЫН ОРДЕР №', styleBIG)
                        j = j + 1
                        #j=5
                        #on, sar, odor haruulah
                        year = 0
                        month = 0
                        day = 0
                        year = line['absldate'][0:4]
                        month = line['absldate'][5:7]
                        day = line['absldate'][8:10]
                        date_name = str(year) + u' оны ' + str(month) + u' сарын ' + str(day) + u' өдөр'
                        sheet.write_merge(j, j, 1, 10, date_name, styleBIG)
                        sheet.write_merge(j, j, 15, 21, date_name, styleBIG)
                        j = j + 2
                        #j=7, n=9
                        sheet.write_merge(j, n, 0, 2, u'Харилцах данс', style_table)
                        sheet.write_merge(j, n, 3, 5, u'Дэлгэрэнгүй бүртгэлийн код', style_table)
                        sheet.write_merge(j, n, 6, 7, u'Дүн', style_table)
                        sheet.write_merge(j, n, 8, 10, u'Гүйлгээний утгын код', style_table)
                        sheet.write_merge(n, n, 13, 15, u'Хаанаас :', style_right)
                        #get partner name
                        partner_name = ''
                        if line['partner_id'] == None:
                            partner_name = ''
                        else:
                            cr.execute("""  
                                select name, lastname, is_company 
                                from res_partner
                                where id =%s """%(line['partner_id']))
                            partner_info  = cr.dictfetchall()
                            for line1 in partner_info:
                                if line1['is_company'] == True:
                                    partner_name = line1['name']
                                else:
                                    if line1['lastname'] == None:
                                        partner_name = str(line1['name'])
                                    else:
                                        partner_name = str(line1['lastname']) + u' овогтой ' + str(line1['name'])
                        sheet.write_merge(j, n, 16, 21, u'%s'%partner_name, styled)
                        n = n + 1
                        #n=10
                        sheet.write_merge(n, n, 0, 2, u'', style_table)
                        sheet.write_merge(n, n, 3, 5, u'', style_table)
                        sheet.write_merge(n, n, 6, 7, u'', style_table)
                        sheet.write_merge(n, n, 8, 10, u'', style_table)
                        sheet.write_merge(n, n, 16, 21, u'/овог, нэр/', style_no_border)
                        n = n + 2
                        #n=12
                        sheet.write_merge(n, n, 0, 2, u'Хаанаас :', style_left)
                        sheet.write_merge(n, n, 3, 10, u'%s'%partner_name, styled)
                        sheet.write_merge(n, n, 12, 15, u'Гүйлгээний утга :', style_right)
                        sheet.write_merge(n, n, 16, 21, u'%s'%line['abslname'], styled)
                        n = n + 1
                        #n=13
                        sheet.write_merge(n, n, 4, 10, u'/овог, нэр/', style_no_border)
                        n = n + 2
                        #n = 15, m = 20, a=24
                        sheet.write_merge(n, n, 0, 3, u'Гүйлгээний утга :', style_left)
                        sheet.write_merge(n, n, 4, 10, u'%s'%line['abslname'], styled)
                        sheet.write_merge(n, m, 12, 14, u'ТУСЛАХ ШУГАМ', style_orientation)
                        sheet.write_merge(n, n, 15, 21, u'%s'%(str(line['amount']) + '   ' + line['curname']), styled)
                        sheet.write_merge(m, m, 0, 10, u'/үсгээр/', style_no_border)
                        sheet.write(a, 21, u'//', style_left)
                        sheet.write_merge(a, a, 0, 3, u'Нягтлан бодогч', style_left)
                        sheet.write_merge(a, a, 4, 9, u'', styled)
                        sheet.write(a,10, u'//', style_left)
                        sheet.write_merge(a, a, 12, 15, u'Нягтлан бодогч', style_no_border)
                        sheet.write_merge(a, a, 16, 20, u'', styled)
                        n = n + 2
                        #n=17
                        sheet.write_merge(n, n, 0, 3, u'%s'%line['amount'], styled)
                        sheet.write_merge(n, n, 4, 6, u'%s'%line['curname'], style_no_border)
                        sheet.write_merge(n, n, 7, 9, u'', styled)
                        sheet.write_merge(n, n, 15, 21, u'', styled)
                        n = n + 1
                        #n=18
                        sheet.write_merge(n, n, 15, 21, u'/үсгээр/', style_no_border)
                        n = n + 1
                        #n=19
                        sheet.write_merge(n, n, 0, 10, u'', styled)
                        n = n + 3
                        #n=22
                        sheet.write_merge(n, n, 0, 4, u'хавсаргасан баримт', style_left)
                        sheet.write_merge(n, n, 5, 8, u'', styled)
                        sheet.write_merge(n, n, 15, 21, u'хавсаргасан баримт', style_no_border)
                        n = n + 4
                        #n=26
                        sheet.write_merge(n, n, 0, 2, u'Кассын нярав', style_no_border)
                        sheet.write_merge(n, n, 3, 9, u'', styled)
                        sheet.write(n, 21, u'//', style_left)
                        sheet.write(n,10, u'//', style_left)
                        sheet.write_merge(n, n, 12, 15, u'Нягтлан бодогч', style_no_border)
                        sheet.write_merge(n, n, 16, 20, u'', styled)
                        n = n + 2
                        #n=28
                        sheet.write_merge(n, n, 0, 2, u'Тушаагч', style_left)
                        sheet.write_merge(n, n, 3, 10, u'', styled)
                        sheet.write_merge(n, n, 12, 14, u'Тушаагч', style_no_border)
                        sheet.write_merge(n, n, 15, 21, u'', styled)
                        
                        i = i + 1   # 30 - i(last) + i(first)
                        j = j + 24  # 30 - j(last) + j(first)
                        n = n + 11  # 30 - n(last) + n(first)
                        m = m + 30  # 30 - m(last) + m(first)
                        a = a + 30  # 30 - a(last) + a(first)
                else:
                    i = 0
                    j = 1
                    for line2 in statement_expense:
                        year = 0
                        month = 0
                        day = 0
                        year = line2['absldate'][0:4]
                        month = line2['absldate'][5:7]
                        day = line2['absldate'][8:10]
                        #date_name = str(year) + u' оны ' + str(month) + u' сарын ' + str(day) + u' өдөр'
                        
                        sheet.write_merge(i, i, 0, 5, u'НХМаягт МХ-2', style_left)
                        sheet.write_merge(i, j, 8, 21, u'Санхүү, эдийн засгийн сайд, Үндэсний статистикийн газрын даргын 2002 оны 6-р сарын 18-ны 171/111 тоот тушаалын хавсралт', style_left)
                        j = j + 2
                        #j=3
                        sheet.write_merge(j, j, 5, 15, u'Бэлэн мөнгөний зарлагын баримт', styleBIG)
                        j = j + 2
                        #j=5
                        sheet.write_merge(j, j, 0, 2, u'Дугаар', style_left)
                        sheet.write_merge(j, j, 3, 8, u'', style_table)
                        sheet.write_merge(j, j, 13, 14, year, styled)
                        sheet.write(j, 15, u'он', style_no_border)
                        sheet.write_merge(j, j, 16, 17, month, styled)
                        sheet.write(j, 18, u'сар', style_no_border)
                        sheet.write_merge(j, j, 19, 20, day, styled)
                        sheet.write_merge(j, j, 21, 22, u'өдөр', style_no_border)
                        j = j + 2
                        #j=7
                        sheet.write_merge(j, j, 0, 3, u'Байгууллагын нэр', style_left)
                        sheet.write_merge(j, j, 7, 22, u'%s' %line2['compname'], styled)
                        j = j + 2
                        #j=9
                        partner_name = ''
                        partner_lastname = ''
                        if line2['partner_id'] == None:
                            partner_name = ''
                            partner_lastname = ''
                        else:
                            cr.execute("""  
                                select name, lastname, is_company 
                                from res_partner
                                where id =%s """%(line2['partner_id']))
                            partner_info1  = cr.dictfetchall()
                            for line3 in partner_info1:
                                if line3['is_company'] == True:
                                    partner_name = line3['name']
                                    partner_lastname = ''
                                else:
                                    partner_name = line3['name']
                                    if line3['lastname'] == None:
                                        partner_lastname = ''
                                    else:
                                        partner_lastname = line3['lastname']
                        
                        sheet.write_merge(j, j, 0, 3, u'Хүлээн авсан', style_left)
                        sheet.write_merge(j, j, 5, 10, u'%s' %partner_lastname, styled)
                        sheet.write_merge(j, j, 11, 12, u'овогтой', style_no_border)
                        sheet.write_merge(j, j, 13, 22, u'%s' %partner_name, styled)
                        j = j + 2
                        #j=11
                        sheet.write_merge(j, j, 0, 6, u'Үнэмлэх /паспорт/-ийн дугаар', style_left)
                        sheet.write_merge(j, j, 8, 22, u'', styled)
                        j = j + 2
                        #j=13
                        sheet.write_merge(j, j, 0, 3, u'Гүйлгээний утга', style_left)
                        sheet.write_merge(j, j, 5, 22, u'%s' %line2['abslname'], styled)
                        j = j + 2
                        #j=15
                        sheet.write_merge(j, j, 0, 4, u'Олгосон мөнгөн дүн', style_left)
                        sheet.write_merge(j, j, 7, 20, u'%s' %line2['amount'], styled)
                        sheet.write_merge(j, j, 21, 22, u'%s' %line2['curname'], style_no_border)
                        #sheet.write_merge(j, j, 19, 20, u'', styled)
                        #sheet.write_merge(j, j, 21, 22, u'мөнгө', style_no_border)
                        j = j + 1
                        #j=16
                        sheet.write_merge(j, j, 0, 22, u'', styled)
                        j = j + 1
                        #j=17
                        sheet.write_merge(j, j, 0, 22, u'/үсгээр/', style_no_border)
                        j = j + 2
                        #j=19
                        sheet.write_merge(j, j, 0, 4, u'Хавсаргасан баримт', style_left)
                        sheet.write_merge(j, j, 7, 22, u'', styled)
                        j = j + 1
                        #j=20
                        sheet.write_merge(j, j, 0, 22, u'', styled)
                        j = j + 2
                        #j=22
                        sheet.write_merge(j, j, 7, 8, u'Дарга', style_left)
                        sheet.write_merge(j, j, 11, 15, u'', styled)
                        sheet.write_merge(j, j, 16, 19, u'/С.МӨНХБАЯР/', style_left)
                        j = j + 2
                        #j=24
                        sheet.write_merge(j, j, 7, 10, u'Нягтлан бодогч', style_left)
                        sheet.write_merge(j, j, 11, 15, u'', styled)
                        sheet.write(j, 16, u'//', style_left)
                        j = j + 1
                        #j=25
                        sheet.write_merge(j, j, 0, 3, u'Тэмдэг', style_no_border)
                        j = j + 1
                        #j=26
                        sheet.write_merge(j, j, 7, 9, u'Хүлээн авсан', style_left)
                        sheet.write_merge(j, j, 11, 15, u'', styled)
                        sheet.write_merge(j, j, 16, 17, u'/Будан/', style_left)
                        j = j + 2
                        #j=28
                        sheet.write_merge(j, j, 7, 10, u'Мөнгө тушаагч', style_left)
                        sheet.write_merge(j, j, 11, 15, u'', styled)
                        sheet.write(j, 16, u'//', style_left)
                        
                        i = i + 30  #30 - i(last) + i(first)
                        j = j + 3   #30 - j(last) + j(first)
                    
                    
            else:
                raise osv.except_osv(_('Error!'),_("Гүйлгээ үүсээгүй касс сонгосон байна, хэвлэх боломжгүй!"))
                
        inch = 1000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 1*inch
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 1*inch
        sheet.col(6).width = 1*inch
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 1*inch
        sheet.col(10).width = 1*inch
        sheet.col(11).width = 1*inch
        sheet.col(12).width = 1*inch
        sheet.col(13).width = 1*inch
        sheet.col(14).width = 1*inch
        sheet.col(15).width = 1*inch
        sheet.col(16).width = 1*inch
        sheet.col(17).width = 1*inch
        sheet.col(18).width = 1*inch
        sheet.col(19).width = 1*inch
        sheet.col(20).width = 1*inch
        sheet.col(21).width = 1*inch
        sheet.col(22).width = 1*inch
        
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

account_bank_statement_excel()