# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta
from num2words import num2words

class account_banks_statement_order(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "account.banks.statement.order"
    _description = "Account banks statement order"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company'),
        'statement_id': fields.many2one('account.bank.statement', 'Statement id')
        }
    
    def prepare_data(self, cr, uid, ids, context=None):
        fy_obj = self.pool.get('account.fiscalyear')
        period_obj = self.pool.get('account.period')
        obj = self.browse(cr, uid, ids[0], context=context)        
        data = {
            'ids': ids,
            'model': 'account.banks.statement.order',
            'report_name': 'payment.order.report'
        }        
        return data
    
    def verbose_format(self,cr, uid, ids, amount, context=None):
        '''Мөнгөн дүнг үсгээр илэрхийлэх функц
        '''
        if type(amount) not in (str, unicode) :
            amount = str(amount)
        result = u''
        BUTARHAI = True
        i = 0
        stramount = amount.replace(',','.')
        
        if '-' in stramount:
            stramount= stramount.replace('-','')        
        if '.' in amount:
            amount = stramount[:stramount.find('.')]
            subamount = stramount[stramount.find('.')+1:]
        else :
            amount = stramount
            subamount = u''
        length = len(amount)
        if length == 0 or float(amount) == 0:
            return ''
        place = 0
        try :
            while i < length :
                c = length - i
                if c % 3 == 0 :
                    c -= 3
                else :
                    while c % 3 != 0 :
                        c -= 1
                place = c / 3
                i1 = length - c
                tmp = amount[i:i1]
                j = 0
                if tmp == '000' :
                    i = i1
                    continue
                while j < len(tmp) :
                    char = int(tmp[j])
                    p = len(tmp) - j
                    if char == 1 :
                        if p == 3 :
                            result += u'нэг зуун '
                        elif p == 2 :
                            result += u'арван '
                        elif p == 1 :
                            if len(result)==0:
                                result += u'нэг '
                            else:
                                result += u'нэгэн '
                    elif char == 2 :
                        if p == 3 :
                            result += u'хоёр зуун '
                        elif p == 2 :
                            result += u'хорин '
                        elif p == 1 :
                            result += u'хоёр '
                    elif char == 3 :
                        if p == 3 :
                            result += u'гурван зуун '
                        elif p == 2 :
                            result += u'гучин '
                        elif p == 1 :
                            result += u'гурван '
                    elif char == 4 :
                        if p == 3 :
                            result += u'дөрвөн зуун '
                        elif p == 2 :
                            result += u'дөчин '
                        elif p == 1 :
                            result += u'дөрвөн '
                    elif char == 5 :
                        if p == 3 :
                            result += u'таван зуун '
                        elif p == 2 :
                            result += u'тавин '
                        elif p == 1 :
                            result += u'таван '
                    elif char == 6 :
                        if p == 3 :
                            result += u'зургаан зуун ' 
                        elif p == 2 :
                            result += u'жаран '
                        elif p == 1 :
                            result += u'зургаан '
                    elif char == 7 :
                        if p == 3 :
                            result += u'долоон зуун '
                        elif p == 2 :
                            result += u'далан '
                        elif p == 1 :
                            result += u'долоон '
                    elif char == 8 :
                        if p == 3 :
                            result += u'найман зуун '
                        elif p == 2 :
                            result += u'наян '
                        elif p == 1 :
                            result += u'найман '
                    elif char == 9 :
                        if p == 3 :
                            result += u'есөн зуун '
                        elif p == 2 :
                            result += u'ерэн '
                        elif p == 1 :
                            result += u'есөн '
                    
                    j += 1
                # -------- end while j < len(tmp)
                if place == 3 :
                    result += u'тэрбум '
                elif place == 2 :
                    result += u'сая '
                elif place == 1 :
                    result += u'мянга '
                i = i1
            # ---------- end while i < len(amount)
        except Exception, e :
            return e
        
        if len(subamount) > 0 and float(subamount) > 0 :
            result2 = verbose_format(subamount)
            BUTARHAI = False
            result2 = result2.replace(u'төгрөг', u'мөнгө')
            result += u' төгрөг %s' % result2
        if BUTARHAI:
            result += u' төгрөг'
    
        num = result
        if u"мянга  төгрөг" in num:
            result = num.replace(u"мянга  төгрөг",u"мянган  төгрөг")
        else:
            result = num
    
        return result
    
    def tbab_number2words(self,cr, uid, ids, amount, context=None):
        number_text = num2words(amount)
        oron = ''
        print 'aaaaaaaa', number_text
        return number_text
    
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = self.prepare_data(cr, uid, ids, context=context)
        
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal center;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;')
        style_no_border_small = ezxf('font: bold off, name Times New Roman, height 180; align: wrap on, vertical center, horizontal center;')
        style_no_border_small_top = ezxf('font: bold off, name Times New Roman, height 180; align: wrap on, vertical top, horizontal left;')
        style_no_border_small_bottom = ezxf('font: bold off, name Times New Roman, height 180; align: wrap on, vertical bottom, horizontal left;')
        
        style_orientation = ezxf('font: bold on, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        
        styled = ezxf('font: bold on, name Times New Roman, height 200; borders: bottom dashed, ; align: wrap on, vertical center, horizontal center;')
        style_left = ezxf('font: bold off, name Times New Roman, height 180; align: wrap on, vertical center, horizontal left;')
        style_right = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal right;')
        style_amount = ezxf('font: bold on, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;borders: top thin, left thin, bottom thin, right thin;')
        
        styleBIG = ezxf('font: bold on, name Times New Roman, height 240; align: wrap on, vertical center, horizontal center;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin;')
        #style_table_rl = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: left thin, right thin;')
        style_table_trl = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        style_table_trl_top = ezxf('font: bold off, name Times New Roman, height 170; align: wrap on, vertical top, horizontal left; borders: top thin, left thin, right thin;')
        style_table_brl_left = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical top, horizontal left; borders: left thin, bottom thin, right thin;')
        style_table_brl_center = ezxf('font: bold on, name Times New Roman, height 200; align: wrap on, vertical top, horizontal center; borders: left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        style_bold = ezxf('font: bold on, name Times New Roman; align: wrap on, vertical center, horizontal center;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Account banks statement order')
        sheet.portrait = True
        
        
        
        cre_bnk_code = None
        de_bnk_code = None
        cre_bank_name = None
        de_bank_name = None
        de_account_number = None
        cre_account_number = None
        amount = 0
        #res = None
        de_partner = None
        line_date = ''
        line_company = None
        line_name = ''
        
        if context['amount'] < 0.0:
            cre_bank_name = context['com_bank_name']#Компанийн банкны нэр
            cre_account_number = context['com_account_number']#Компанийн дансны дугаар
            cre_bnk_code = context['com_bnk_code']#Компанийн банкны код
            line_company = context['company']#Компанийн нэр
            de_bank_name = context['partner_bnk_name']#Харилцагчийн банкны нэр
            amount = context['amount'] * (-1)
            de_bnk_code = ''
            de_partner = context['partner']#Харилцагчийн нэр
            de_account_number = context['partner_account_number']#Харилцагчийн дансны дугаар
        else:
            cre_bank_name = context['partner_bnk_name']
            cre_account_number = context['partner_account_number']
            cre_bnk_code = ''
            line_company = context['partner']#Харилцагчийн нэр
            de_bank_name = context['com_bank_name']#Харилцагчийн банкны нэр
            amount = context['amount']
            de_bnk_code = context['com_bnk_code']#Компанийн банкны код
            de_partner = context['company']#Компанийн нэр
            de_account_number = context['com_account_number']#Компанийн дансны дугаар
        line_date = context['date']
        line_name = context['name']
        
        i = 0
        j = 1
        k = 1
        sheet.write_merge(i, j, 6, 12, u'Төлбөрийн даалгавар 189', styleBIG)
        sheet.write_merge(i, i, 15, 20, u'Маягт N: TC-7', style_left)
        i = i + 2 #i=2
        j = j + 2 #j=3
        sheet.write_merge(i, i, 7, 11, u'%s'%(line_date or ''), style_no_border)#LINE доторх огноо
        sheet.write_merge(k, j, 15, 22, u'Санхүү, Эдийн засгийн сайдын 2002 оны 06 дугаар сарын 28-ны өдрийн 182 тоот тушаалаар батлав.', style_left)
        i = i + 3 #i=5
        sheet.write_merge(i, i, 1, 2, u'Төлөгч', style_no_border)
        sheet.write_merge(i, i, 12, 13, u'Данс', style_bold)
        sheet.write_merge(i, i, 18, 19, u'Дүн', style_bold)
        i = i + 1 #i=6
        j = j + 7 #j=10
        sheet.write_merge(i, i, 0, 1, u'Код', style_table)
        sheet.write_merge(i, i, 2, 10, u'%s'%(line_company or ''), style_table)#LINE доторх компани эсвэл харилцагчийн нэр
        sheet.write_merge(i, i, 11, 15, u'Дебет', style_table)
        sheet.write_merge(i, j, 16, 22, u'%s'%(amount or ''), style_amount)#LINE доторх дүн
        i = i + 1 #i=7
        sheet.write_merge(i, i, 0, 10, u'%s'%(cre_bank_name or ''), style_amount)#Журналын ард байх банкны нэр
        sheet.write_merge(i, i, 11, 15, u'%s'%(cre_account_number or ''), style_amount)#Журналын ард байх дансны дугаар
        i = i + 1 #i=8
        sheet.write_merge(i, i, 0, 15, u'Хүлээн авагч', style_table_trl)
        i = i + 1 #i=9
        sheet.write_merge(i, i, 0, 1, u'Код', style_table)
        sheet.write_merge(i, i, 2, 10, u'%s'%(de_partner or ''), style_table)#Харилцагчийн нэр
        sheet.write_merge(i, i, 11, 15, u'Кредит', style_table)
        i = i + 1 #i=10
        sheet.write_merge(i, i, 0, 10, u'%s'%(de_bank_name or ''), style_table)#LINE доторх банкны дансны нэр
        sheet.write_merge(i, i, 11, 15, u'%s'%(de_account_number or ''), style_table)#LINE доторх банкны дансны дугаар
        i = i + 1 #i=11
        j = j + 3 #j=13
        text = u'Мөнгөний дүн (тоогоор) :' + u'        %s'%(amount or '')#Мөнгөний дүн (тоогоор)
        sheet.write_merge(i, i, 0, 15, text, style_table_trl)
        text1 = u'.....хоногийн.....хувийн.....торгууль'
        text2 = u'бүгд...............төг.....мөн'
        text3 = text1 + text2
        sheet.write_merge(i, j, 16, 22, text3, style_table)
        i = i + 1 #i=12
        #moneyprice = c2c_helper.verbose_numeric(abs(amount))
        text_vsgeer = u'Мөнгөний дүн (үсгээр) :' + u'        %s'%(self.verbose_format(cr, uid, ids, amount, context))#Мөнгөний дүн (үсгээр)
        sheet.write_merge(i, j, 0, 15, text_vsgeer, style_table_brl_left)#Мөнгөний дүн (үсгээр)
        i = i + 2 #i=14
        sheet.write_merge(i, i, 0, 15, u'Барааг хүлээн авсан буюу ажил үйлчилгээ гүйцэтгүүлсэн огноо', style_table_trl)
        sheet.write_merge(i, i, 16, 22, u'Дүн (торгуулийн хамт)', style_table_trl)
        i = i + 1 #i=15
        sheet.write_merge(i, i, 0, 15, u'%s'%(line_date or ''), style_table_brl_center)#Барааг хүлээн авсан буюу ажил үйлчилгээ гүйцэтгүүлсэн огноо
        sheet.write_merge(i, i, 16, 22, u'', style_table_brl_center)
        i = i + 1 #i=16
        j = j + 4 #j=17
        sheet.write_merge(i, j, 0, 15, u'Төлбөрийн зориулалт (Барааны болон ажил үйлчилгээний нэр, дагалдах баримтын дугаар)', style_table_trl_top)
        sheet.write_merge(i, j, 16, 18, u'Гүйлгээний утга', style_table)
        sheet.write_merge(i, j, 19, 22, u'', style_table)
        i = i + 2 #i=18
        j = j + 2 #j=19
        sheet.write_merge(i, j, 0, 15, u'%s'%(line_name or ''), style_table_brl_center)#Төлбөрийн зориулалт (Барааны болон ажил үйлчилгээний нэр, дагалдах баримтын дугаар)
        sheet.write_merge(i, j, 16, 18, u'Төлбөрийн зориулалт', style_table)
        sheet.write_merge(i, j, 19, 22, u'', style_table)
        i = i + 2 #i=20
        j = j + 2 #j=21
        text4 = u'Банкинд гүйлгээ хийсэн'
        text5 = u'.....оны.....сарын.....өдөр'
        sheet.write_merge(i, i, 11, 15, text4, style_no_border_small)
        sheet.write_merge(j, j, 11, 15, text5, style_no_border_small)
        sheet.write_merge(i, j, 16, 18, u'Төлөх хугацаа', style_table)
        sheet.write_merge(i, j, 19, 22, u'', style_table)
        i = i + 2 #i=22
        j = j + 2 #j=23
        text6 = u'Гүйцэтгэх захирал'
        text7 = u'.............. ' + u'Б.Хүрэлхүү'
        sheet.write_merge(i, i, 2, 5, text6, style_no_border_small_bottom)
        sheet.write_merge(i, i, 6, 10, text7, style_no_border_small_bottom)
        sheet.write_merge(i, j, 16, 18, u'Төлбөрийн ээлж', style_table)
        sheet.write_merge(i, j, 19, 22, u'', style_table)
        
        text8 = u'........ ' + u'NNNNNNNNN'#Ахлах нябо
        sheet.write_merge(i, j, 0, 1, u'Тамга', style_no_border_small)
        sheet.write_merge(j, j, 2, 5, u'Ахлах нябо', style_no_border_small_bottom)
        sheet.write_merge(j, j, 6, 10, text8, style_no_border_small_bottom)
        sheet.write_merge(j, j, 11, 15, u'.......................................', style_no_border_small_bottom)
        j = j + 1 #j=24
        sheet.write_merge(j, j, 11, 15, u'тэмдэг, гарын үсэг', style_no_border_small)
        #i=22
        #j=24
        i = i + 8   # 30 - i(last) + i(first)
        j = j + 7   # 30 - j(last) + j(first)
        k = k + 30  # 30 - k(last) + k(first)
        
        ####################
        
        
        sheet.write_merge(i, j, 6, 12, u'Төлбөрийн даалгавар 189', styleBIG)
        sheet.write_merge(i, i, 15, 20, u'Маягт N: TC-7', style_left)
        i = i + 2 #i=2
        j = j + 2 #j=3
        sheet.write_merge(i, i, 7, 11, u'%s'%(line_date or ''), style_no_border)#LINE доторх огноо
        sheet.write_merge(k, j, 15, 22, u'Санхүү, Эдийн засгийн сайдын 2002 оны 06 дугаар сарын 28-ны өдрийн 182 тоот тушаалаар батлав.', style_left)
        i = i + 3 #i=5
        sheet.write_merge(i, i, 1, 2, u'Төлөгч', style_no_border)
        sheet.write_merge(i, i, 12, 13, u'Данс', style_bold)
        sheet.write_merge(i, i, 18, 19, u'Дүн', style_bold)
        i = i + 1 #i=6
        j = j + 7 #j=10
        sheet.write_merge(i, i, 0, 1, u'Код', style_table)
        sheet.write_merge(i, i, 2, 10, u'%s'%(line_company or ''), style_table)#LINE доторх компани эсвэл харилцагчийн нэр
        sheet.write_merge(i, i, 11, 15, u'Дебет', style_table)
        sheet.write_merge(i, j, 16, 22, u'%s'%(amount or ''), style_amount)#LINE доторх дүн
        i = i + 1 #i=7
        sheet.write_merge(i, i, 0, 10, u'%s'%(cre_bank_name or ''), style_amount)#Журналын ард байх банкны нэр
        sheet.write_merge(i, i, 11, 15, u'%s'%(cre_account_number or ''), style_amount)#Журналын ард байх дансны дугаар
        i = i + 1 #i=8
        sheet.write_merge(i, i, 0, 15, u'Хүлээн авагч', style_table_trl)
        i = i + 1 #i=9
        sheet.write_merge(i, i, 0, 1, u'Код', style_table)
        sheet.write_merge(i, i, 2, 10, u'%s'%(de_partner or ''), style_table)#Харилцагчийн нэр
        sheet.write_merge(i, i, 11, 15, u'Кредит', style_table)
        i = i + 1 #i=10
        sheet.write_merge(i, i, 0, 10, u'%s'%(de_bank_name or ''), style_table)#LINE доторх банкны дансны нэр
        sheet.write_merge(i, i, 11, 15, u'%s'%(de_account_number or ''), style_table)#LINE доторх банкны дансны дугаар
        i = i + 1 #i=11
        j = j + 3 #j=13
        text = u'Мөнгөний дүн (тоогоор) :' + u'        %s'%(amount or '')#Мөнгөний дүн (тоогоор)
        sheet.write_merge(i, i, 0, 15, text, style_table_trl)
        text1 = u'.....хоногийн.....хувийн.....торгууль'
        text2 = u'бүгд...............төг.....мөн'
        text3 = text1 + text2
        sheet.write_merge(i, j, 16, 22, text3, style_table)
        i = i + 1 #i=12
        text_vsgeer = u'Мөнгөний дүн (үсгээр) :' + u'        %s'%(self.verbose_format(cr, uid, ids, amount, context))#Мөнгөний дүн (үсгээр)
        sheet.write_merge(i, j, 0, 15, text_vsgeer, style_table_brl_left)#Мөнгөний дүн (үсгээр)
        i = i + 2 #i=14
        sheet.write_merge(i, i, 0, 15, u'Барааг хүлээн авсан буюу ажил үйлчилгээ гүйцэтгүүлсэн огноо', style_table_trl)
        sheet.write_merge(i, i, 16, 22, u'Дүн (торгуулийн хамт)', style_table_trl)
        i = i + 1 #i=15
        sheet.write_merge(i, i, 0, 15, u'%s'%(line_date or ''), style_table_brl_center)#Барааг хүлээн авсан буюу ажил үйлчилгээ гүйцэтгүүлсэн огноо
        sheet.write_merge(i, i, 16, 22, u'', style_table_brl_center)
        i = i + 1 #i=16
        j = j + 4 #j=17
        sheet.write_merge(i, j, 0, 15, u'Төлбөрийн зориулалт (Барааны болон ажил үйлчилгээний нэр, дагалдах баримтын дугаар)', style_table_trl_top)
        sheet.write_merge(i, j, 16, 18, u'Гүйлгээний утга', style_table)
        sheet.write_merge(i, j, 19, 22, u'', style_table)
        i = i + 2 #i=18
        j = j + 2 #j=19
        sheet.write_merge(i, j, 0, 15, u'%s'%(line_name or ''), style_table_brl_center)#Төлбөрийн зориулалт (Барааны болон ажил үйлчилгээний нэр, дагалдах баримтын дугаар)
        sheet.write_merge(i, j, 16, 18, u'Төлбөрийн зориулалт', style_table)
        sheet.write_merge(i, j, 19, 22, u'', style_table)
        i = i + 2 #i=20
        j = j + 2 #j=21
        text4 = u'Банкинд гүйлгээ хийсэн'
        text5 = u'.....оны.....сарын.....өдөр'
        sheet.write_merge(i, i, 11, 15, text4, style_no_border_small)
        sheet.write_merge(j, j, 11, 15, text5, style_no_border_small)
        sheet.write_merge(i, j, 16, 18, u'Төлөх хугацаа', style_table)
        sheet.write_merge(i, j, 19, 22, u'', style_table)
        i = i + 2 #i=22
        j = j + 2 #j=23
        text6 = u'Гүйцэтгэх захирал'
        text7 = u'.............. ' + u'Б.Хүрэлхүү'
        sheet.write_merge(i, i, 2, 5, text6, style_no_border_small_bottom)
        sheet.write_merge(i, i, 6, 10, text7, style_no_border_small_bottom)
        sheet.write_merge(i, j, 16, 18, u'Төлбөрийн ээлж', style_table)
        sheet.write_merge(i, j, 19, 22, u'', style_table)
        
        text8 = u'........ ' + u'NNNNNNNNN'#Ахлах нябо
        sheet.write_merge(i, j, 0, 1, u'Тамга', style_no_border_small)
        sheet.write_merge(j, j, 2, 5, u'Ахлах нябо', style_no_border_small_bottom)
        sheet.write_merge(j, j, 6, 10, text8, style_no_border_small_bottom)
        sheet.write_merge(j, j, 11, 15, u'.......................................', style_no_border_small_bottom)
        j = j + 1 #j=24
        sheet.write_merge(j, j, 11, 15, u'тэмдэг, гарын үсэг', style_no_border_small)
        #i=22
        #j=24
        i = i + 8   # 30 - i(last) + i(first)
        j = j + 7   # 30 - j(last) + j(first)
        k = k + 30  # 30 - k(last) + k(first)
            
        inch = 1000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 1*inch
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 1*inch
        sheet.col(6).width = 1*inch
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 1*inch
        sheet.col(10).width = 1*inch
        sheet.col(11).width = 1*inch
        sheet.col(12).width = 1*inch
        sheet.col(13).width = 1*inch
        sheet.col(14).width = 1*inch
        sheet.col(15).width = 1*inch
        sheet.col(16).width = 1*inch
        sheet.col(17).width = 1*inch
        sheet.col(18).width = 1*inch
        sheet.col(19).width = 1*inch
        sheet.col(20).width = 1*inch
        sheet.col(21).width = 1*inch
        sheet.col(22).width = 1*inch
        
        
        return {'data':book}

account_banks_statement_order()

