# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields, osv
from openerp.tools.translate import _
import re
import time
import openerp.netsvc

class account_hoaot_invoice(osv.osv_memory):
    """
    This wizard will confirm the all the selected draft invoices
    """

    _name = "account.hoaot.invoice"
    _description = "Confirm the selected invoices"
    
    _columns = {
                'company_id':fields.many2one('res.company','Company'),
                'noat_number':fields.char('Noat number',required=True),
                'journal_id':fields.many2one('account.journal','Journal'),
                'account_id':fields.many2one('account.account','Account'),
                }
    _defaults = {
                 'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'account.hoaot.invoice"', context=c),
                 }

    
    def invoice_confirm(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        active_ids = context.get('active_ids', []) or []
        obj = self.browse(cr, uid, ids)
        
        proxy = self.pool['account.move']
        proxy_line = self.pool['account.move.line']
        tax = self.pool['account.tax']
        tax_amount = 0.0
        account =None
        date = time.strftime('%Y-%m-%d'),
        period_id = self.pool.get('account.period').find(cr, uid, context=context)[0]
        if len(obj.noat_number) > 10 or len(obj.noat_number) < 10:
            raise osv.except_osv(_(u'Warning!'), _(u'НӨАТ-ын падааны дугаар 10 оронтой байх ёстой.'))
        
        for record in proxy_line.browse(cr, uid, active_ids, context=context):
            if record.tax_amount >0.0:
                proxy_line.write(cr, uid, record.id,{
                                        
                                                 'noat_number':obj.noat_number,
                                                 })
                tax_amount += record.tax_amount
                account = record.account_id.id
            else:
                raise osv.except_osv(_(u'Warning!'), _(u'НӨАТ-ын падааны дугаар энэ гүйлгээн дээр оруулах боломжгүй'))
        if tax_amount > 0.0:
            move_id = proxy.create(cr, uid, {
                                             'name':'/',
                                             'journal_id':obj.journal_id.id,
                                             'period_id': period_id,
                                            'date':date,
                                   
                                   })
            proxy_line.create(cr, uid, {
                                        'name': '/',
                                        'debit': tax_amount,
                                        'credit':0.0,
                                        'account_id': obj.account_id.id,
                                        'noat_number':obj.noat_number,
                                        'partner_id': False,
                                        'amount_currency': 0,
                                        'company_id': obj.company_id.id,
                                        'currency_id': False,
                                        'move_id': move_id,
                                        'date': date,
                                        'journal_id': obj.journal_id.id,
                                        'period_id': period_id,
                                        })
            
            proxy_line.create(cr, uid, {
                                        'name': '/',
                                        'debit': 0.0,
                                        'credit': tax_amount,
                                        'account_id':account,
                                        'partner_id': False,
                                        'amount_currency': 0,
                                        'company_id': obj.company_id.id,
                                        'currency_id': False,
                                        'move_id': move_id,
                                        'date': date,
                                        'journal_id': obj.journal_id.id,
                                        'period_id': period_id,
                                        })
        
            
            
        return {'type': 'ir.actions.act_window_close'}
