# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields, osv
from openerp.tools.translate import _

class account_period_closed(osv.osv_memory):
    _name = 'account.period.closed'
    
    _columns = {    
                'company_id':fields.many2one('res.company','Company'),
                'start_period':fields.many2one('account.period','Start period'),
                'end_period':fields.many2one('account.period','End period'),
                'journal_id':fields.many2one('account.journal','Journal'),
                'income_down_account_id':fields.many2one('account.account','Income and down account'),
                'desc_name':fields.char('Description name'),
                }
    
    _defaults = {
                 'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'account.period.closed', context=c),
                 }
    
    def action_confirm(self, cr, uid, ids,context=None):
        obj = self.browse(cr, uid, ids)
        account_move_obj = self.pool.get('account.move')
        account_move_line_obj = self.pool.get('account.move.line')
        account_obj = self.pool.get('account.account')
        type_obj = self.pool.get('account.account.type')
        obj_acc_journal = self.pool.get('account.journal')
        currency_obj = self.pool.get('res.currency')
        obj_acc_period = self.pool.get('account.period')
        period_id = self.pool.get('account.period').find(cr, uid, context=context)[0]
        per_id = obj_acc_period.search(cr, uid, [('id','=',obj.start_period.id)])
        if per_id !=[]:
            per = obj_acc_period.browse(cr, uid, per_id)
            type_id = type_obj.search(cr, uid, [('code','in',('income','expense'))])
            account_id = account_obj.search(cr, uid, [('type','!=','view'),('user_type','=',type_id)])
            account = account_obj.browse(cr, uid, account_id)
            debit = 0.0
            credit = 0.0
            diff = 0.0
            amount = 0.0
            total = 0.0
            move_id = account_move_obj.create(cr, uid, {
                                                         'name':'/',
                                                         'period_id':obj.end_period.id,
                                                         'date':obj.end_period.date_start,
                                                         'journal_id':obj.journal_id.id,
                                                         'company_id':obj.company_id.id,
                                                        })
            for acc in account:
                if acc.debit > acc.credit:
                    amount = acc.debit - acc.credit
                    if amount > 0.0:
                        account_move_line_obj.create(cr, uid, {
                               'name':'/',
                               'move_id':move_id,
                               'account_id':acc.id,
                               'journal_id': obj.journal_id.id,
                                'period_id': period_id,
                                'date': obj.end_period.date_start,
                                'debit':0.0,
                                'credit':amount,
                               })
                else:
                    amount = acc.credit - acc.debit
                    if amount > 0.0:
                        account_move_line_obj.create(cr, uid, {
                               'name':'/',
                               'move_id':move_id,
                               'account_id':acc.id,
                               'journal_id': obj.journal_id.id,
                                'period_id': period_id,
                                'date': obj.end_period.date_start,
                                'debit':amount,
                                'credit':0.0,
                               })
                total +=amount
            diff = total
            account_move_line_obj.create(cr, uid, {
                           'name':'/',
                           'move_id':move_id,
                           'account_id':obj.income_down_account_id.id,
                           'journal_id': obj.journal_id.id,
                            'period_id': period_id,
                            'date': obj.end_period.date_start,
                            'debit':0.0,
                            'credit':diff,
                           })
            obj_acc_period.write(cr, uid, obj.end_period.id,{'state':'done'
                                                             })
                

        return True