# -*- coding: utf-8 -*-
##############################################################################
#    
#    Copyright (C) 2012 Agile Business Group sagl (<http://www.agilebg.com>)
#    Copyright (C) 2012 Domsense srl (<http://www.domsense.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import osv,fields,orm
from openerp.tools.translate import _
import time
from datetime import datetime
import openerp.addons.decimal_precision as dp

class account_asset_capitalization(osv.osv_memory):
    _name = "account.asset.capitalization"
    _description = "Capitalization asset"
    def _asset_defualt(self, cr, uid, field, context=None):
        if context is None:
            context = {}
        asset = self.pool.get('account.asset.asset').browse(cr, uid, context['active_ids'][0], context)
        if asset.state not in ('open'):
            raise osv.except_osv(_('Warning !'), _('You can do capitalization on only confirmed assets!'))
        
        if field == 'old_amount':
            return asset.purchase_value
    
    _columns = {
        'old_amount'    : fields.float('Current Amount', digits=(16,2), readonly=True),
        'capital_amount': fields.float('Capital Amount', digits=(16,2), required=True),
        'account_id'    : fields.many2one('account.account', 'Source Account', required=True, domain=[('type','not in', ('view','consolidation'))]),
        'partner_id'    : fields.many2one('res.partner', 'Associated Partner'),
        'note'          : fields.text('Notes'),
        'date':           fields.date('Date')
    }
    
    _defaults = {
        'old_amount'    : lambda obj,cr,uid,c: obj._asset_defualt(cr,uid,'old_amount',c),
    }
    
    def button_capital_asset(self, cr, uid, ids, context=None):
        ''' Хөрөнгийг капиталжуулахдаа анхны өртөгийн нэмэгдлийг хөрөнгийн дансанд бүртгэнэ.
            Мөн элэгдэх хугацааг сунгаж түүх хөтөлнө.
        '''
        if context is None:
            context = {}
        obj = self.browse(cr, uid, ids[0], context=context)
        asset_obj = self.pool.get('account.asset.asset')
        if obj.capital_amount <= 0 :
            raise osv.except_osv(_('Error'), _('The Capital Amount required !'))
        if obj.account_id.type in ('receivable','payable') and not obj.partner_id:
            raise osv.except_osv(_('Warning !'), _('You must select a partner when using receivable or payable account!'))
        
        move_id = asset_obj.capitalization(cr, uid, context['active_ids'], obj, context=context)

        data = self.read(cr, uid, ids, [])[0]
        mod_obj = self.pool.get('ir.model.data')
        if context is None:
            context = {}
        model_data_ids = mod_obj.search(cr, uid,[('model','=','ir.ui.view'),('name','=','view_move_form')], context=context)
        resource_id = mod_obj.read(cr, uid, model_data_ids, fields=['res_id'], context=context)[0]['res_id']
        
        result = {
            'domain': "[('id','in', ["+str(move_id)+"])]",
            'name': _('Entries'),
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'account.move',
            'views': [(False,'tree'),(resource_id,'form')],
            'type': 'ir.actions.act_window',
        }
        return result
    
account_asset_capitalization()
