# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################

import time
from lxml import etree
from openerp.osv import osv, fields
from openerp.tools.translate import _

class compute_asset(osv.osv):
    _name = 'compute.asset'
    
    def _get_period(self, cr, uid, context=None):
        ids = self.pool.get('account.period').find(cr, uid, context=context)
        period_id = False
        if len(ids):
            period_id = ids[0]
        return period_id
    
    _columns = {
        'move_ids' : fields.many2many('account.move','account_compute_asset','compute_id','journal_id','Entries',readonly=True),
        'period_id': fields.many2one('account.period','Period',requered=True),
        'draft'    : fields.boolean('Create as Draft',default=False, help="If this box is checked, depreciation entries will be created as draft. Then user must approve them."),
        'asset_ids': fields.many2many('account.asset.asset','asset_compute_asset_rel','compute_id','asset_id','Assets to Skip', domain=[('state','=','open')]),
    }
    _defaults={
        'period_id':_get_period,
    }
    
    def action_compute_asset(self, cr, uid, ids, context = None):
        data = self.read(cr, uid, ids[0], [])
        ass_obj = self.pool.get('account.asset.asset')
        
        asset_ids = data['asset_ids']
        search = [('state','=','open')]
        if asset_ids :
            search.append(('id','not in', asset_ids))
        asset_ids = ass_obj.search(cr, uid, search, context=context)
        if not asset_ids :
            raise osv.except_osv(_('Warning'), _('No asset available for depreciation!'))
        
        ids_create = []
        period = self.pool.get('account.period').browse(cr, uid, data['period_id'][0], context=context)
        for asset in ass_obj.browse(cr, uid, asset_ids, context=context):
            ids_create += ass_obj._compute_entries(cr, uid, [asset.id], period.id, context=context)
        move_ids = ids_create
        if not data['draft'] and ids_create :
            self.pool.get('account.move').post(cr, uid, move_ids, context=context)
        
        mod_obj = self.pool.get('ir.model.data')
        if context is None:
            context = {}
        model_data_ids = mod_obj.search(cr, uid,[('model','=','ir.ui.view'),('name','=','view_move_form')], context=context)
        resource_id = mod_obj.read(cr, uid, model_data_ids, fields=['res_id'], context=context)[0]['res_id']
       
        if not move_ids:
            move_ids = [-1]
        result = {
            'domain': "[('id','in', ["+','.join(map(str,move_ids))+"])]",
            'name': 'Entries',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'account.move',
            'views': [(False,'tree'),(resource_id,'form')],
            'type': 'ir.actions.act_window',
        }
        return result

compute_asset()