# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from lxml import etree

from openerp.osv import fields, osv
from openerp import tools
from openerp.tools.translate import _

class account_analytic_plan_instance_inherit25(osv.osv):
    _inherit = "account.analytic.plan.instance"
    _description = "Analytic Plan Instance Inherit25"
    _columns = {
        #'instance_id': fields.one2many('account.analytic.plan.instance', 'instance_real_id', 'Instances', required=True),
        'instance_real_id': fields.many2one('account.analytic.plan.instance', 'Instances', ondelete="cascade", select=True, auto_join=True),
    
    }

class aa_plan_instance_related25(osv.osv):
    _name = "aa.plan.instance.related25"
    _description = "Analytic Plan Instance Related25"
    _columns = {
        'instance_id': fields.one2many('account.analytic.plan.instance', 'instance_real_id', 'Instances'),
        'name': fields.related('instance_id', 'name',  type='char', string='Analytic Distribution'),
        'code': fields.related('instance_id', 'code',  type='char', string='Distribution Code', size=16),
        'journal_id': fields.related('instance_id', 'journal_id',  type='many2one', relation='account.analytic.journal', string='Analytic Journal'),
        'account_ids': fields.related('instance_id', 'plan_id',  type='one2many', relation='account.analytic.plan.instance.line', string='Account Id', copy=True),
        'plan_id': fields.related('instance_id', 'plan_id',  type='many2one', relation='account.analytic.plan', string="Model's Plan"),
        #'rate1': fields.related('instance_id', 'rate',  type='float', digits=(16,6), string='Rate1 (%)'),
    
        #'sourcebl': fields.related('picking_id', 'origin',  type='char', relation='stock.picking', string='Class Description', store=True, readonly=True),
        #step_ids = fields.One2many(related='template_id.step_ids', string = "Steps")
    }
    
    
#===============================================================================
# class aa_plan_instance_line_inherit25(osv.osv):
#     _inherit = "account.analytic.plan.instance.line"
#     _description = "Analytic Instance Line Inherit25"
#     #_rec_name = "analytic_account_id"
#     _columns = {
#         #'plan_id': fields.related('instance_id', 'plan_id',  type='many2one', relation='account.analytic.plan.instance', string = 'Plan Id'),
#         #'analytic_account_id': fields.related('instance_id', 'analytic_account_id',  type='many2one', relation='account.analytic.account', string = 'Analytic Account', domain=[('type','<>','view')]),
#         #'rate1': fields.related('instance_id', 'rate',  type='float', digits=(16,6), string='Rate1 (%)'),
#         'rate_rate': fields.float('Rate1 (%)', required=True, digits=(16,6)),
#         
#     }
#===============================================================================
