# -*- coding: utf-8 -*-

import logging

from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _
from openerp.tools import *
from datetime import date, timedelta, datetime
from email import _name
import time
from openerp import netsvc
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp
from openerp.models import FIELDS_TO_PGTYPES
from num2words import num2words

_logger = logging.getLogger(__name__)

class contract_amendment(osv.Model):
    #Oorchlolt, Nemelt oorchlolt
    _name = 'contract.amendment'
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    
    _columns = {
        'wpc_id': fields.many2one('work.performance.contract','WPC', track_visibility='onchange'),#Өөрчлөлт оруулах гэрээ
        'change_number': fields.integer('Change number', track_visibility='onchange'),#Өөрчлөлтийн дугаар
        
        'changing_type': fields.selection([('change','Change'),
                                  ('amendment','Amendment')],'Changing type', track_visibility='onchange'),#Өөрчлөлтийн төрөл
        
        'html_description': fields.html('HTML description', track_visibility='onchange'),#Үндсэн мэдээлэл
        'html_1': fields.html('HTML 1', track_visibility='onchange'),#Үндсэн мэдээлэл 1
        'html_2': fields.html('HTML 2', track_visibility='onchange'),#Үндсэн мэдээлэл 2
        'html_3': fields.html('HTML 3', track_visibility='onchange'),#Үндсэн мэдээлэл 3
        'html_4': fields.html('HTML 4', track_visibility='onchange'),#Үндсэн мэдээлэл 4
        'html_5': fields.html('HTML 5', track_visibility='onchange'),#Үндсэн мэдээлэл 5
        'html_6': fields.html('HTML 6', track_visibility='onchange'),#Үндсэн мэдээлэл 6
        'type': fields.selection([('work_performing','Work performing'),
                                  ('supply_goods','Supply goods'),
                                  ('design','Design'),
                                  ('other','Other'),],'Type', track_visibility='onchange'),#Гэрээний төрөл
        'name': fields.text('Name', track_visibility='onchange'),#Гэрээнийн нэр
        'company_id': fields.many2one('res.company','Company', track_visibility='onchange'),#Номин Констракшн-с гэрээлэгч
        'contract_number': fields.char('Contract number', track_visibility='onchange', copy=False),#Гэрээний дугаар
        'contract_date': fields.date('Contract date', track_visibility='onchange'),#Огноо
        'amendment_date': fields.date('Amendment date', track_visibility='onchange'),#Нэмэлт, өөрчлөлтийн огноо
        'executive_director': fields.many2one('res.users','Executive director', track_visibility='onchange'),#Гүйцэтгэх захирал
        'consumer_job': fields.many2one('hr.job','Consumer job', track_visibility='onchange'),#Захиалагчийн (хүн) албан тушаал
        'consumer_name': fields.many2one('res.users','Consumer name', track_visibility='onchange'),#Захиалагчийн нэр
        'consumer_phone': fields.char('Consumer phone', size=8, track_visibility='onchange'),#Захиалагчийн утас
        'contractor_company': fields.many2one('res.partner','Contractor company', track_visibility='onchange'),#Гэрээлэгч (компани)
        'contractor_job': fields.char('Contractor job', track_visibility='onchange'),#Гэрээлэгч хүний албан тушаал
        'contractor_name': fields.many2one('res.partner','Contractor name', track_visibility='onchange'),#Гэрээлэгч (хүн буюу хариуцагч)
        'contractor_phone': fields.char('Contractor phone', size=8, track_visibility='onchange'),#Гэрээлэгч хүний утас
        'headman_job': fields.many2one('hr.job','Headman job', track_visibility='onchange'),#Даргын албан тушаал
        'headman_name': fields.many2one('res.users','Headman name', track_visibility='onchange'),#Даргын нэр
        'headman_phone': fields.char('Headman phone', size=8, track_visibility='onchange'),#Даргын утас
        'law_headman': fields.many2one('res.users','Law headman', track_visibility='onchange', copy=False),#Хуулийн албаны дарга
        'respondent_name': fields.many2one('res.users','Respondent name', track_visibility='onchange'),#Хариуцагчийн нэр
        'respondent_job': fields.many2one('hr.job','Respondent job', track_visibility='onchange'),#Хариуцагчийн албан тушаал
        'respondent_phone': fields.char('Respondent phone', size=8, track_visibility='onchange'),#Хариуцагчийн утас
        'customer_material': fields.integer('Customer material', track_visibility='onchange'),#Захиалагч материалын дүн
        'customer_material_diff': fields.integer('Customer material diff', track_visibility='onchange'),#Захиалагч материалын дүнгийн зөрүү
        'customer_material_amendment': fields.integer('Customer material amendment', track_visibility='onchange'),#Захиалагч материалын дүнгийн нэмэлт, өөрчлөлт
        'performer_material': fields.integer('Performer material', track_visibility='onchange'),#Гүйцэтгэгч материалын дүн
        'performer_material_diff': fields.integer('Performer material diff', track_visibility='onchange'),#Гүйцэтгэгч материалын дүнгийн зөрүү
        'performer_material_amendment': fields.integer('Performer material amendment', track_visibility='onchange'),#Гүйцэтгэгч материалын дүнгийн нэмэлт, өөрчлөлт
        'contract_amount': fields.integer('Contract amount', track_visibility='onchange'),#Гэрээний дүн
        'contract_amount_diff': fields.integer('Contract amount diff', track_visibility='onchange'),#Гэрээний дүнгийн зөрүү
        'contract_amount_amendment': fields.integer('Contract amount amendment', track_visibility='onchange'),#Гэрээний дүнгийн нэмэлт, өөрчлөлт
        'contract_amount_letter': fields.char('Contract amount letter', track_visibility='onchange'),#Гэрээний дүн үсгээр
        'contract_amount_letter_amendment': fields.char('Contract amount letter amendment', track_visibility='onchange'),#Гэрээний дүн үсгээр /нэмэлт, өөрчлөлт/
        'performer_amounts_5': fields.integer('Performer amounts 5%', track_visibility='onchange'),#Гүйцэтгэгчийн нийт дүнгийн 5%
        'performer_amounts_5_amendment': fields.integer('Performer amounts 5% amendment', track_visibility='onchange'),#Гүйцэтгэгчийн нийт дүнгийн 5% /нэмэлт, өөрчлөлт/
        'state': fields.selection([('request','Request'),#Хүсэлт
                                    #('control','Control'),#Хяналт
                                    #('budget','Budget'),#Төсөв
                                    ('project','Project'),#Гэрээний төсөл
                                    ('law_headman','Law headman'),#Хуулийн албаны дарга
                                    ('project_headman','Project headman'),#Төсөл хариуцсан захирал
                                    ('building_director','Building director'),#Тэргүүн дэд захирал
                                    ('executive_director','Executive director'),#Гүйцэтгэх захирал
                                    ('approved','Approved'),#Батлагдсан
                                    ('contract_cancelled','Contract cancelled'),#Гэрээ цуцлагдсан
                                    ('cancelled','Cancelled'),#Гэрээ байгуулагдахааргүй болсон
                                    ],'State', track_visibility='onchange'),#Төлөв
        
        }
    _defaults = {
                'html_1' : '1. Гэрээний тусгай нөхцөлийн 4-т заасан Гүйцэтгэх ажил, түүний байршилд <b> “........................” </b> гэж нэмэв.',
                'html_2' : '2. Гэрээний тусгай нөхцөлийн 7-д “Захиалагчаас нийлүүлэх материал ........................ төгрөг” гэснийг ................ төгрөгөөр нэмэгдүүлж “.................................” гэж,',
                'html_3' : '3. Гэрээний тусгай нөхцөлийн 9-т “Гэрээний үнэ НӨАТ багтсан .................. /үсгээр/ төгрөг байна” гэснийг ...................... төгрөгөөр нэмэгдүүлж, “Гэрээний үнэ НӨАТ багтсан .................... /үсгээр/ төгрөг байна” гэж,',
                'html_4' : '4. Гэрээний тусгай нөхцөлийн 17-д “Гүйцэтгэгчийн ажиллах хүчний зардал болон бусад зардлын үнийн дүнгийн 5 хувь буюу .................... төгрөг” гэснийг “Гүйцэтгэгчийн ажлын хөлс болон бусад зардлын үнийн дүнгийн 5 хувь буюу .................... төгрөг” гэж тус тус өөрчлөв. /нэмэлт төсвийг хавсаргав/',
                'html_5' : '5. Энэхүү өөрчлөлт болон Төсвийг гэрээ баталсан өдрөөс мөрдөх ба ............... тоот гэрээний салшгүй хэсэг болно.',
                'html_6' : '6. Талуудын хооронд байгуулсан .................... тоот Гэрээний бусад заалт хэвээр мөрдөгдөнө.',
                'state' : 'request'
        }
    
    def create(self, cr, uid, vals, context=None):
        res ={}
        code = 0
        if vals['wpc_id'] and vals['changing_type']:
            wpc_obj = self.pool.get('contract.amendment')
            wpc_ids = wpc_obj.search(cr, uid, [('wpc_id','=',vals['wpc_id']),('changing_type','=',vals['changing_type'])],order='change_number desc',limit=1)
            change_number_info = wpc_obj.browse(cr, uid, wpc_ids)
            print 'uuuuuuu', change_number_info, change_number_info.change_number
            if change_number_info.change_number:
                code = int(change_number_info.change_number) + 1
            else:
                code = 1
        else:
            code = 0
        vals['change_number'] = code
        ca_id = super(contract_amendment, self).create(cr, uid, vals, context=context)
        
        return ca_id
    
    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid, ids)
        if 'contract_number' in vals:
            vals['contract_number'] = obj.contract_number
        if 'contract_date' in vals:
            vals['contract_date'] = obj.contract_date
        if 'customer_material' in vals:
            vals['customer_material'] = obj.customer_material
        if 'performer_material' in vals:
            vals['performer_material'] = obj.performer_material
        if 'contract_amount' in vals:
            vals['contract_amount'] = obj.contract_amount
        if 'performer_amounts_5' in vals:
            vals['performer_amounts_5'] = obj.performer_amounts_5
            
        if obj.state in ('contract_cancelled','cancelled','approved'):
            if vals:
                raise osv.except_osv(_("Буруу үйлдэл!"), _("Гэрээ байгуулагдахааргүй болсон, Гэрээ цуцлагдсан, Батлагдсан төлөвтэй байхад засч болохгүй!"))
        
        return super(contract_amendment, self).write(cr, uid, ids, vals, context=context)
        
    #===========================================================================
    # def unlink(self, cr, uid, ids, context=None):
    #     raise osv.except_osv(_("Буруу үйлдэл!"), _("Гэрээг устгах боломжгүй!!! Гэрээ байгуулагдахааргүй болсон эсвэл Гэрээ цуцлагдсан төлөвт шилжиж болно!"))
    #     return super(work_performance_contract, self).unlink(cr, uid, ids, context=context)
    #===========================================================================
    
    def verbose_format(self,cr, uid, ids, contract_amount, context=None):
        '''Мөнгөн дүнг үсгээр илэрхийлэх функц
        '''
        if type(contract_amount) not in (str, unicode) :
            contract_amount = str(contract_amount)
        result = u''
        BUTARHAI = True
        i = 0
        stramount = contract_amount.replace(',','.')
        
        if '-' in stramount:
            stramount= stramount.replace('-','')        
        if '.' in contract_amount:
            contract_amount = stramount[:stramount.find('.')]
            subamount = stramount[stramount.find('.')+1:]
        else :
            contract_amount = stramount
            subamount = u''
        length = len(contract_amount)
        if length == 0 or float(contract_amount) == 0:
            return ''
        place = 0
        try :
            while i < length :
                c = length - i
                if c % 3 == 0 :
                    c -= 3
                else :
                    while c % 3 != 0 :
                        c -= 1
                place = c / 3
                i1 = length - c
                tmp = contract_amount[i:i1]
                j = 0
                if tmp == '000' :
                    i = i1
                    continue
                while j < len(tmp) :
                    char = int(tmp[j])
                    p = len(tmp) - j
                    if char == 1 :
                        if p == 3 :
                            result += u'нэг зуун '
                        elif p == 2 :
                            result += u'арван '
                        elif p == 1 :
                            if len(result)==0:
                                result += u'нэг '
                            else:
                                result += u'нэгэн '
                    elif char == 2 :
                        if p == 3 :
                            result += u'хоёр зуун '
                        elif p == 2 :
                            result += u'хорин '
                        elif p == 1 :
                            result += u'хоёр '
                    elif char == 3 :
                        if p == 3 :
                            result += u'гурван зуун '
                        elif p == 2 :
                            result += u'гучин '
                        elif p == 1 :
                            result += u'гурван '
                    elif char == 4 :
                        if p == 3 :
                            result += u'дөрвөн зуун '
                        elif p == 2 :
                            result += u'дөчин '
                        elif p == 1 :
                            result += u'дөрвөн '
                    elif char == 5 :
                        if p == 3 :
                            result += u'таван зуун '
                        elif p == 2 :
                            result += u'тавин '
                        elif p == 1 :
                            result += u'таван '
                    elif char == 6 :
                        if p == 3 :
                            result += u'зургаан зуун ' 
                        elif p == 2 :
                            result += u'жаран '
                        elif p == 1 :
                            result += u'зургаан '
                    elif char == 7 :
                        if p == 3 :
                            result += u'долоон зуун '
                        elif p == 2 :
                            result += u'далан '
                        elif p == 1 :
                            result += u'долоон '
                    elif char == 8 :
                        if p == 3 :
                            result += u'найман зуун '
                        elif p == 2 :
                            result += u'наян '
                        elif p == 1 :
                            result += u'найман '
                    elif char == 9 :
                        if p == 3 :
                            result += u'есөн зуун '
                        elif p == 2 :
                            result += u'ерэн '
                        elif p == 1 :
                            result += u'есөн '
                    
                    j += 1
                # -------- end while j < len(tmp)
                if place == 3 :
                    result += u'тэрбум '
                elif place == 2 :
                    result += u'сая '
                elif place == 1 :
                    result += u'мянга '
                i = i1
            # ---------- end while i < len(amount)
        except Exception, e :
            return e
        
        if len(subamount) > 0 and float(subamount) > 0 :
            result2 = verbose_format(subamount)
            BUTARHAI = False
            result2 = result2.replace(u'төгрөг', u'мөнгө')
            result += u' төгрөг %s' % result2
            #result += u' %s' % result2
        if BUTARHAI:
            result += u' төгрөг'
            #result += u' '
    
        num = result
        #if u"мянга  төгрөг" in num:
        if u"тэрбум  төгрөг" in num:
            result = num.replace(u"тэрбум  төгрөг",u"тэрбум")
        elif u"сая  төгрөг" in num:
            result = num.replace(u"сая  төгрөг",u"сая")
        elif u"мянга  төгрөг" in num:
            result = num.replace(u"мянга  төгрөг",u"мянга")
        elif u"зуун  төгрөг" in num:
            result = num.replace(u"зуун  төгрөг",u"зуу")
        elif u"ерэн  төгрөг" in num:
            result = num.replace(u"ерэн  төгрөг",u"ер")
        elif u"наян  төгрөг" in num:
            result = num.replace(u"наян  төгрөг",u"ная")
        elif u"далан  төгрөг" in num:
            result = num.replace(u"далан  төгрөг",u"дал")
        elif u"жаран  төгрөг" in num:
            result = num.replace(u"жаран  төгрөг",u"жар")
        elif u"тавин  төгрөг" in num:
            result = num.replace(u"тавин  төгрөг",u"тавь")
        elif u"дөчин  төгрөг" in num:
            result = num.replace(u"дөчин  төгрөг",u"дөч")
        elif u"гучин  төгрөг" in num:
            result = num.replace(u"гучин  төгрөг",u"гуч")
        elif u"хорин  төгрөг" in num:
            result = num.replace(u"хорин  төгрөг",u"хорь")
        elif u"арван  төгрөг" in num:
            result = num.replace(u"арван  төгрөг",u"арав")
        elif u"есөн  төгрөг" in num:
            result = num.replace(u"есөн  төгрөг",u"ес")
        elif u"найман  төгрөг" in num:
            result = num.replace(u"найман  төгрөг",u"найм")
        elif u"долоон  төгрөг" in num:
            result = num.replace(u"долоон  төгрөг",u"долоо")
        elif u"зургаан  төгрөг" in num:
            result = num.replace(u"зургаан  төгрөг",u"зургаа")
        elif u"таван  төгрөг" in num:
            result = num.replace(u"таван  төгрөг",u"тав")
        elif u"дөрвөн  төгрөг" in num:
            result = num.replace(u"дөрвөн  төгрөг",u"дөрөв")
        elif u"гурван  төгрөг" in num:
            result = num.replace(u"гурван  төгрөг",u"гурав")
        elif u"хоёр  төгрөг" in num:
            result = num.replace(u"хоёр  төгрөг",u"хоёр")
        elif u"нэгэн  төгрөг" in num:
            result = num.replace(u"нэгэн  төгрөг",u"нэг")
        else:
            result = num
        #result = num
        return result
    
    def to_contract_cancelled(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'contract_cancelled'})
        return True
    
    #===========================================================================
    # def to_budget(self, cr, uid, ids, *args):
    #     self.write(cr, uid, ids, {'state': 'budget'})
    #     return True
    #===========================================================================
    
    def to_project(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        self.write(cr, uid, ids, {'state': 'project'})
        return True
    
    def to_law_headman(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        self.write(cr, uid, ids, {'state': 'law_headman'})
        return True

    def to_back_project(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        self.write(cr, uid, ids, {'state': 'project'})
        return True
    
    def to_project_headman(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        self.write(cr, uid, ids, {'state': 'project_headman'})
        return True
    
    def to_building_director(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        self.write(cr, uid, ids, {'state': 'building_director'})
        return True
    
    def to_executive_director(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        self.write(cr, uid, ids, {'state': 'executive_director'})
        return True
    
    def to_approved(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        self.write(cr, uid, ids, {'state': 'approved'})
        return True
    
    def to_cancelled(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        self.write(cr, uid, ids, {'state': 'cancelled'})
        return True

    def onchange_wpc_id(self, cr, uid, ids, wpc_id, context=None):
        res = {}
        obj = self.browse(cr, uid, ids)
        wpc_obj = self.pool.get('work.performance.contract')
        wpc_ids = wpc_obj.search(cr, uid, [('id','=',wpc_id)])
        wpc = wpc_obj.browse(cr, uid, wpc_ids)
        
        if wpc:
            res['name'] = str(wpc.contract_number) + str(' тоот гэрээ')
            res['type'] = wpc.type
            
            res['contract_number'] = wpc.contract_number
            res['contract_date'] = wpc.contract_date
            
            res['customer_material'] = wpc.customer_material
            res['performer_material'] = wpc.performer_material
            res['contract_amount'] = wpc.contract_amount
            
            res['performer_amounts_5'] = wpc.performer_material / 20
            
            res['company_id'] = wpc.company_id.id
            res['executive_director'] = wpc.executive_director.id
            res['consumer_name'] = wpc.consumer_name.id
            res['consumer_job'] = wpc.consumer_job.id
            res['consumer_phone'] = wpc.consumer_phone
            res['executive_director'] = wpc.executive_director.id
            res['headman_name'] = wpc.headman_name.id
            res['headman_job'] = wpc.headman_job.id
            res['headman_phone'] = wpc.headman_phone
            
            res['contractor_company'] = wpc.contractor_company.id
            res['contractor_name'] = wpc.contractor_name.id
            res['contractor_job'] = wpc.contractor_job
            res['contractor_phone'] = wpc.contractor_phone
        
        
        return {'value':res}
    
    def onchange_changing_type(self, cr, uid, ids, changing_type, wpc_id, contract_number, context=None):
        res = {}
        obj = self.browse(cr, uid, ids)
        wpc_obj = self.pool.get('work.performance.contract')
        wpc_ids = wpc_obj.search(cr, uid, [('id','=',wpc_id)])
        wpc = wpc_obj.browse(cr, uid, wpc_ids)
        cont_number = ''
        if wpc:
            cont_number = wpc.contract_number
        else:
            cont_number = ''
            
        ch_name = ''
        if changing_type == 'change':
            ch_name = ' тоот гэрээний өөрчлөлт'
        else:
            ch_name = ' тоот гэрээний нэмэлт өөрчлөлт'
            
        text1 = ''
        text2 = ''
        if changing_type == 'change':
            text1 = '4. Энэхүү өөрчлөлт болон Төсвийг гэрээ баталсан өдрөөс мөрдөх ба ' + '<b>' + str(contract_number) + '</b>' + ' тоот гэрээний салшгүй хэсэг болно.'
            text2 = '5. Талуудын хооронд байгуулсан ' + '<b>' + str(contract_number) + '</b>' + ' тоот Гэрээний бусад заалт хэвээр мөрдөгдөнө.'
        elif changing_type == 'amendment':
            text1 = '5. Энэхүү өөрчлөлт болон Төсвийг гэрээ баталсан өдрөөс мөрдөх ба ' + '<b>' + str(contract_number) + '</b>' + ' тоот гэрээний салшгүй хэсэг болно.'
            text2 = '6. Талуудын хооронд байгуулсан ' + '<b>' + str(contract_number) + '</b>' + ' тоот Гэрээний бусад заалт хэвээр мөрдөгдөнө.'
        
        res['name'] = str(cont_number) + ch_name
        res['html_5'] = text1
        res['html_6'] = text2
        
        return {'value':res}
    
    def onchange_customer_amounts(self, cr, uid, ids, customer_material, customer_material_diff, context=None):
        res = {}
        res['customer_material_amendment'] = customer_material + customer_material_diff
        return {'value':res}
    
    def onchange_performer_amounts(self, cr, uid, ids, performer_material, performer_material_diff, context=None):
        res = {}
        res['performer_material_amendment'] = performer_material + performer_material_diff
        return {'value':res}
    
    def onchange_contract_amounts(self, cr, uid, ids, contract_amount, contract_amount_diff, context=None):
        res = {}
        res['contract_amount_amendment'] = contract_amount + contract_amount_diff
        return {'value':res}
    
    def onchange_to_html_2(self, cr, uid, ids, changing_type, customer_material, customer_material_diff, customer_material_amendment, performer_material, performer_material_diff, performer_material_amendment, context=None):
        res = {}
        text1 = ''
        if changing_type == 'change':
            text1 = '1. Гэрээний тусгай нөхцөлийн 7-д “Захиалагчаас нийлүүлэх материал ' + str(customer_material) + ' төгрөг” гэснийг '
        elif changing_type == 'amendment':
            text1 = '2. Гэрээний тусгай нөхцөлийн 7-д “Захиалагчаас нийлүүлэх материал ' + str(customer_material) + ' төгрөг” гэснийг '
        
        text2 = str(customer_material_diff) + ' төгрөгөөр нэмэгдүүлж "' + '<b>' + 'Захиалагчаас нийлүүлэх материал ' + str(customer_material_amendment) + ' төгрөг' + '</b>' + '” гэж, Гүйцэтгэгчээс нийлүүлэх материал '
        text3 = str(performer_material) + ' төгрөг” гэснийг ' + str(performer_material_diff) + ' төгрөгөөр нэмэгдүүлж “' + '<b>' + 'Гүйцэтгэгчээс нийлүүлэх материал ' + str(performer_material_amendment) + ' төгрөг' + '</b>' + '" гэж,'
        
        res['performer_amounts_5_amendment'] = performer_material_amendment / 20
        res['html_2'] = text1 + text2 + text3
        return {'value':res}
    
    def onchange_to_html_3(self, cr, uid, ids, changing_type, contract_amount, contract_amount_diff, contract_amount_amendment, context=None):
        res = {}
        text1 = ''
        if changing_type == 'change':
            text1 = '2. Гэрээний тусгай нөхцөлийн 9-т “Гэрээний үнэ НӨАТ багтсан ' + '<b>' + str(contract_amount) + ' / ' + str(self.verbose_format(cr, uid, ids, contract_amount, context)) + ' / ' + '</b>' + ' төгрөг байна” гэснийг '
        elif changing_type == 'amendment':
            text1 = '3. Гэрээний тусгай нөхцөлийн 9-т “Гэрээний үнэ НӨАТ багтсан ' + '<b>' + str(contract_amount) + ' / ' + str(self.verbose_format(cr, uid, ids, contract_amount, context)) + ' / ' + '</b>' + ' төгрөг байна” гэснийг '
        
        #text1 = '2. Гэрээний тусгай нөхцөлийн 9-т “Гэрээний үнэ НӨАТ багтсан  ' + str(contract_amount) + ' / ' + str(self.verbose_format(cr, uid, ids, contract_amount, context)) + ' / ' + ' төгрөг байна” гэснийг '
        text2 = str(contract_amount_diff) + ' төгрөгөөр нэмэгдүүлж, “Гэрээний үнэ НӨАТ багтсан ' + '<b>' + str(contract_amount_amendment) + ' / ' + str(self.verbose_format(cr, uid, ids, contract_amount_amendment, context)) + ' / ' + '</b>' + 'төгрөг байна” гэж,'
        res['html_3'] = text1 + text2
        return {'value':res}
    
    def onchange_to_html_4(self, cr, uid, ids, changing_type, performer_amounts_5, performer_amounts_5_amendment, context=None):
        res = {}
        text1 = ''
        if changing_type == 'change':
            text1 = '3. Гэрээний тусгай нөхцөлийн 17-д “Гүйцэтгэгчийн ажиллах хүчний зардал болон бусад зардлын үнийн дүнгийн 5 хувь буюу ' + str(performer_amounts_5) + ' төгрөг” гэснийг '
        elif changing_type == 'amendment':
            text1 = '4. Гэрээний тусгай нөхцөлийн 17-д “Гүйцэтгэгчийн ажиллах хүчний зардал болон бусад зардлын үнийн дүнгийн 5 хувь буюу ' + str(performer_amounts_5) + ' төгрөг” гэснийг '
        
        text2 = '<b>' + '“Гүйцэтгэгчийн ажлын хөлс болон бусад зардлын үнийн дүнгийн 5 хувь буюу ' + str(performer_amounts_5_amendment) + ' төгрөг”' + '</b>' + ' гэж тус тус өөрчлөв. /нэмэлт төсвийг хавсаргав/'
        
        res['html_4'] = text1 + text2
        return {'value':res}
    
    #===========================================================================
    # def onchange_name(self, cr, uid, ids, name, context=None):
    #     res = {}
    #     text1 = '1. Гэрээний тусгай нөхцөлийн 4-т заасан Гүйцэтгэх ажил, түүний байршилд “........................” гэж нэмэв.'
    #     text2 = ' ажлыг Иргэний, Барилгын болон бусад хууль тогтоомж, БНбД, улсын болон компанийн стандартын дагуу хийж гүйцэтгэхтэй холбогдон Захиалагч болон Гүйцэтгэгчийн эрх үүргийг тодорхойлж тэдний хооронд үүсэх харилцааг зохицуулна.'
    #     real_name = ''
    #     if name:
    #         real_name = name
    #     else:
    #         real_name = '..........'
    #     res['html_1'] = str(text1) + '<b>' + str(real_name) + '</b>' + str(text2)
    #     
    #     return {'value':res}
    #===========================================================================
    
    def onchange_company_id(self, cr, uid, ids, company_id, contractor_company, wpc_id, context=None):
        res = {}
        text1 = '           Нэг талаас '
        text2 = ' /цаашид “Захиалагч” гэх/, нөгөө талаас '
        text3 = ' /цаашид “Гүйцэтгэгч” гэх/ нар / цаашид хамтад нь Талууд гэх/ талуудын хооронд '
        text4 = ''
        text5 = ''
        
        if wpc_id:
            wpc_obj = self.pool.get('work.performance.contract')
            wpc_id_s = wpc_obj.search(cr, uid, [('id','=',wpc_id)])
            wpc = wpc_obj.browse(cr, uid, wpc_id_s)
            
            print 'ffff---------------------o', wpc_id, wpc.contract_date, wpc.contract_date[5:7]
            text4 = wpc.contract_date[:4] + str('оны') + wpc.contract_date[5:7] + str('сарын') + wpc.contract_date[9:] + str('-ны өдөр байгуулсан ')
            text5 = wpc.contract_number + str(' тоот гэрээнд ') + '<b>' + '.............' + '</b>' + str(' ажил нэмэгдсэнтэй холбогдуулан дараах нэмэлт, өөрчлөлт оруулав.')
        
        comp_name = ''
        part_name = ''
        if company_id:
            company_obj = self.pool.get('res.company')
            company_id_s = company_obj.search(cr, uid, [('id','=',company_id)])
            company = company_obj.browse(cr, uid, company_id_s)
            comp_name = company.name
        else:
            comp_name = '..........'
            
        if contractor_company:
            partner_obj = self.pool.get('res.partner')
            partner_id = partner_obj.search(cr, uid, [('id','=',contractor_company)])
            partner = partner_obj.browse(cr, uid, partner_id)
            part_name = partner.name
        else:
            part_name = '..........'
        
        res['html_description'] = str(text1) + '<b>' + str(comp_name) + '</b>' + str(text2) + '<b>' + str(part_name) + '</b>' + str(text3) + str(text4) + str(text5)
        
        return {'value':res}
    
    def onchange_contractor_company(self, cr, uid, ids, contractor_company, company_id, wpc_id, context=None):
        res = {}
        text1 = '           Нэг талаас '
        text2 = ' ХХК /цаашид “Захиалагч” гэх/, нөгөө талаас '
        text3 = ' /цаашид “Гүйцэтгэгч” гэх/ нар / цаашид хамтад нь Талууд гэх/ талуудын хооронд '
        text4 = ''
        text5 = ''
        
        if wpc_id:
            wpc_obj = self.pool.get('work.performance.contract')
            wpc_id_s = wpc_obj.search(cr, uid, [('id','=',wpc_id)])
            wpc = wpc_obj.browse(cr, uid, wpc_id_s)
            
            print 'ffff---------------------o', wpc_id, wpc.contract_date, wpc.contract_date[5:7]
            text4 = wpc.contract_date[:4] + str('оны') + wpc.contract_date[5:7] + str('сарын') + wpc.contract_date[9:] + str('-ны өдөр байгуулсан ')
            text5 = wpc.contract_number + str(' тоот гэрээнд ') + '<b>' + '.............' + '</b>' + str(' ажил нэмэгдсэнтэй холбогдуулан дараах нэмэлт, өөрчлөлт оруулав.')
            
        comp_name = ''
        part_name = ''
        if company_id:
            company_obj = self.pool.get('res.company')
            company_id_s = company_obj.search(cr, uid, [('id','=',company_id)])
            company = company_obj.browse(cr, uid, company_id_s)
            comp_name = company.name
        else:
            comp_name = '..........'
            
        if contractor_company:
            partner_obj = self.pool.get('res.partner')
            partner_id = partner_obj.search(cr, uid, [('id','=',contractor_company)])
            partner = partner_obj.browse(cr, uid, partner_id)
            res['contractor_address'] = partner.address_for_contract
            part_name = partner.name
        else:
            part_name = '..........'
            res['contractor_address'] = ''
        
        res['html_description'] = str(text1) + '<b>' + str(comp_name) + '</b>' + str(text2) + '<b>' + str(part_name) + '</b>' + str(text3) + str(text4) + str(text5)
        
        return {'value':res}
    
    def onchange_consumer_name(self, cr, uid, ids, consumer_name, context=None):
        res = {}
        if consumer_name:
            user_obj = self.pool.get('res.users')
            user_id = user_obj.search(cr, uid, [('id','=',consumer_name)])
            user = user_obj.browse(cr, uid, user_id)
            
            emp_obj = self.pool.get('hr.employee')
            emp_id = emp_obj.search(cr, uid, [('user_id','=',consumer_name)])
            emp = emp_obj.browse(cr, uid, emp_id)
            
            res['consumer_job'] = emp.job_id.id
            #res['consumer_phone'] = emp.work_phone
            res['consumer_phone'] = '77002020'
        else:
            res['consumer_job'] = False
            res['consumer_phone'] = False
        return {'value':res}
    
    def onchange_headman_name(self, cr, uid, ids, headman_name, context=None):
        res = {}
        if headman_name:
            user_obj = self.pool.get('res.users')
            user_id = user_obj.search(cr, uid, [('id','=',headman_name)])
            user = user_obj.browse(cr, uid, user_id)
            
            emp_obj = self.pool.get('hr.employee')
            emp_id = emp_obj.search(cr, uid, [('user_id','=',headman_name)])
            emp = emp_obj.browse(cr, uid, emp_id)
            
            res['headman_job'] = emp.job_id.id
            #res['headman_phone'] = emp.work_phone
            res['headman_phone'] = '77002020'
        else:
            res['headman_job'] = False
            res['headman_phone'] = False
            
        return {'value':res}
    
    def onchange_respondent_name(self, cr, uid, ids, respondent_name, context=None):
        res = {}
        if respondent_name:
            user_obj = self.pool.get('res.users')
            user_id = user_obj.search(cr, uid, [('id','=',respondent_name)])
            user = user_obj.browse(cr, uid, user_id)
            
            emp_obj = self.pool.get('hr.employee')
            emp_id = emp_obj.search(cr, uid, [('user_id','=',respondent_name)])
            emp = emp_obj.browse(cr, uid, emp_id)
            
            res['respondent_job'] = emp.job_id.id
            res['respondent_phone'] = emp.work_phone
            #res['respondent_phone'] = '77002020'
        else:
            res['respondent_job'] = False
            res['respondent_phone'] = False
            
        return {'value':res}
    
    def onchange_contractor_name(self, cr, uid, ids, contractor_name, context=None):
        res = {}
        if contractor_name:
            print 'lllllllll', contractor_name
            partner_obj = self.pool.get('res.partner')
            partner_id = partner_obj.search(cr, uid, [('id','=',contractor_name)])
            partner = partner_obj.browse(cr, uid, partner_id)
            
            res['contractor_job'] = partner.function
            res['contractor_phone'] = partner.phone
        else:
            res['contractor_job'] = False
            res['contractor_phone'] = False
            
        return {'value':res}
    
    #===========================================================================
    # def to_control(self, cr, uid, ids, *args):
    #     self.write(cr, uid, ids, {'state': 'control'})
    #     return True
    #===========================================================================
    
    

    