import time

from openerp.osv import fields, osv

class contract_history(osv.osv):
    _name = "contract.history"
    _description = "Contarct History"
    
    _order = 'create_date desc'
    _columns = {
        'general_type':fields.char('general_type'),
        'manager_name':fields.char('manager_name'),
        'general_type':fields.char('general_type'),
        'mark_adv_type':fields.char('mark_adv_type'),
        'mark_contract_amount':fields.float('mark_contract_amount'),
        'date1': fields.date('Date', help="Default start date for this Analytic Account."),
        'sale_contract_type':fields.char('sale_contract_type'),
        'descriptions':fields.char('descriptions'),        
        'sale_door_amount':fields.float('sale_door_amount'),
        'sale_discount':fields.float('sale_discount'),
        'sale_discounted_amount':fields.float('sale_discounted_amount'),
        
        'sale_guarantee_year':fields.integer('sale_guarantee_year'),
        'sale_loss_percent':fields.float('sale_loss_percent'),
        'sale_valid_contract_percent':fields.float('Valid contract percent'),
        'code':fields.char('code'),
        'company_name':fields.char('company_name'),
        
        'sale_project_name':fields.char('sale_project_name'),
        'sale_biulding_name':fields.char('sale_biulding_name'),
        
        'sale_door_name':fields.char('sale_door_name'),
        
        'sale_to_commission_season':fields.char('sale_to_commission_season'),
        'sale_entrance':fields.integer('Entrance'),
        'sale_garage_number':fields.char('sale_garage_number'),
        'sale_addition_furniture':fields.char('sale_addition_furniture'),
        'houseroom_size':fields.float('Houseroom size'),
        
        
        'date_start': fields.date('Start Date', help="Default start date for this Analytic Account."),
        'date_stop': fields.date('End Date', help="Default end date for this Analytic Account."),
        'partner':fields.char('Partner'),
        'contract_id': fields.many2one('account.analytic.account', 'Sales Contract'),
        
        'contract_history_schedule_id':fields.one2many('contract.history.schedule','contract_history_id','Contract history schedule'),
        'company_id':fields.many2one('res.company',
                                     'Company'),
        'partner_id': fields.many2one('res.partner', 'Partner', ondelete='cascade', help="Select a partner which will use analytic account specified in analytic default (e.g. create new customer invoice or Sales order if we select this partner, it will automatically take this as an analytic account)"),
        'sale_building_id':fields.many2one('building.building','Building'),
        'total_square': fields.float('Total square'),
        'sale_floor':fields.integer('Floor'), 
        'manager_id': fields.many2one('res.users','Sales Manager'),
        'sale_payment_schedule_id':fields.one2many('sales.payment.schedule','contract_id','Contract'),
   
    }
    
    def contract_history_report(self,cr, uid, ids, context=None):
        if context is None:
            context = {}
        data = {}
        self_obj = self.browse(cr, uid, ids)[0]        
        data['name'] = self_obj.code
        return self.pool['report'].get_action(cr, uid, [], 'ierp_contract.report_contract_history', data=data, context=context)
    
    def contract_history_report_garage(self,cr, uid, ids, context=None):
        if context is None:
            context = {}
        data = {}
        self_obj = self.browse(cr, uid, ids)[0]        
        data['name'] = self_obj.code
        return self.pool['report'].get_action(cr, uid, [], 'ierp_contract.report_contract_history_garage', data=data, context=context)

    
  