# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import logging

from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _
from openerp.tools import *
from datetime import date, timedelta, datetime
from email import _name
import time
from openerp import netsvc
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp
from openerp.models import FIELDS_TO_PGTYPES

_logger = logging.getLogger(__name__)


class contract_sub_type(osv.Model):
    _name = 'contract.sub.type'
    _columns = {
        'type': fields.selection([('product','Product'),('work','Work'),('other','Other'),('sales','Sales'),('marketing','Marketing')],'General type'),       
        'name': fields.char('Type name',required=True),
        
        }

class account_analytic_account(osv.Model):
      _inherit = 'account.analytic.account'
      def _count_invoice(self, cr, uid, ids, field_name, arg, context=None):
          LogInvoice = self.pool['account.invoice']
          return {
              contract_id: {
                    'invoice_count': LogInvoice.search_count(cr, uid, [('contract_id', '=', contract_id)], context=context),
              }
              for contract_id in ids
         }
      
      
      def return_action_to_invoice_open(self, cr, uid, ids, context=None):
        """ This opens the xml view specified in xml_id for the current vehicle """
        if context is None:
            context = {}
        if context.get('xml_id'):
            res = self.pool.get('ir.actions.act_window').for_xml_id(cr, uid ,'account', context['xml_id'], context=context)
            res['context'] = context
            #------------- res['context'].update({'default_vehicle_id': ids[0]})
            res['domain'] = [('contract_id','=', ids[0])]
            return res
        return False
      _columns = {
         'contract_project_id': fields.many2one('project.project','Project'),
         'parent_code': fields.boolean('Parent code'),
         'invoice_count': fields.function(_count_invoice, type='integer', string='Invoice', multi=True),
         'general_type': fields.selection([('product','Product'),('work','Work'),
                                           ('other','Other'),],'General type'),
         'general_type_2': fields.selection([('sales','Sales'),
                                           ('marketing','Marketing')],'General type'),
         'sub_type': fields.many2one('contract.sub.type','Sub type'),
         'start_date': fields.date('Start date'),
         'end_date': fields.date('End date'),
         'amount_number': fields.float('Amount number'),
         'amount_letter': fields.char('Amount letter'),
         'budget_amount': fields.float('Budget amount'),
         'quarantee_date': fields.char('Quarantee date'),
         'quarantee_percent': fields.float('Quarantee percent'),
         'quarantee_payment': fields.float('Quarantee payment'),
         'insurance': fields.boolean('Insurance'),
         'work_experience_insurance': fields.text('Work experience insurance'),
         'addition_payment': fields.integer('Addition payment'),
         'inferable': fields.boolean('Inferable'),
         'performance_payment': fields.float('Performance payment'),
         'addition_comment': fields.text('Addition comment'),
         'location': fields.char('Location'),
         'interpreter': fields.boolean('Interpreter'),
         'interpreter_name': fields.char('Interpreter name'),
         'interpreter_address': fields.char('Interpreter address'),
         'interpreter_partner': fields.char('interpreter partner'),
         #'accident': fields.boolean('Accident'),
         'accident_name': fields.text('Accident name'),
         #'accident_people': fields.integer('Accident people'),
         #'accident_amount': fields.float('Accident amount'),
         'loss': fields.float('Loss'),
         'loss_max': fields.float('Loss max'),
         'cost': fields.float('Cost'),
         'cost1': fields.float('Cost1'),
         'advance_amount': fields.float('Advance amount'),
         'advance_percent': fields.float('Advance percent'),
         'remain_payment': fields.float('Remain payment'),
         'deadline_date': fields.date('Deadline date'),
         'date1': fields.date('Date'),
         'execute_date': fields.date('Execute date'),
         'employee': fields.integer('Employee'),
         'payment': fields.integer('Payment'),
         'next_payment': fields.integer('Next payment'),
         'delivery_payment': fields.integer('Delivery payment'),
         'additional_condition': fields.char('Additional condition'),
         'product_insurance': fields.text('Product insurance'),
         'work_cost': fields.float('Work cost'),
         'material_cost': fields.float('Material cost'),
         'interpreter_material_cost': fields.float('Interpreter material cost'),
         'transport_cost': fields.float('Transport cost'),
         'machine_cost': fields.float('Machine cost'),
         'work_line_id': fields.one2many('contract.work.line', 'account_analytic_account_id','Work line'),
         'invoice_id': fields.many2one('account.invoice','Invoice'),
         'work_tag': fields.many2many('contract.work.tag','contract_work_tag_rel','account_analytic_account_id','contract_work_tag_id','Tags'),        
            #Борлуулалтын гэрээ

            'sale_contract_type':fields.selection([('apartment', 'Apartment'),
                                              ('garage', 'Garage'),
                                              ('lease', 'Lease')
                                              ], 'Type'),
            'sale_discount_type':fields.selection([('discount', 'Discount'),
                                              ('amount', 'Amount')], 'Discount type'),
            'sale_door_amount': fields.float('Amount'),
            'sale_discount': fields.float('Sale discount'),
            'sale_amount': fields.integer('Sale amount'),
            'sale_discounted_amount':fields.float('Discounted amount'),
            'date_discount':fields.float('Date discount'),
            'date_discounted_amount':fields.float('Date discounted amount'),
            'conditional_discount':fields.float('Conditional discount'),
            'conditional_discounted_amount':fields.float('Conditional discounted amount'),
            'choice_date':fields.date('Choice date'),
            'sale_building_id':fields.many2one('building.building','Building'),
            'sale_door_id':fields.many2one('product.template','Door'),
            'sale_entrance':fields.integer('Entrance'),
            'sale_floor':fields.integer('Floor'),
            'sale_key_receive':fields.date('Key receive date'),
            'sale_certification':fields.date('Certification'),
            'sale_payment_schedule_id':fields.one2many('sales.payment.schedule','contract_id','Contract'),
            'contract_history_id':fields.one2many('contract.history','contract_id','Contract'),
            'sale_to_commission_season':fields.many2one('to.commission.season','To commission season'),
            'commissioned_season':fields.date('Commissioned season'),
            'company_loss_percent':fields.float('Company loss percent'),
            'contract_end_penalty':fields.float('Contract end penalty'),
            'sale_valid_contract_percent':fields.float('Valid contract percent'),
            'sale_valid_contract_date':fields.date('Valid contract date'),
            'sale_guarantee_year':fields.integer('Guarantee year'),
            'sale_garage_number':fields.char('Garage number'),
            'sale_project_id':fields.many2one('project.project','Project'),
            'sale_loss': fields.float('Loss'),
            'houseroom_size':fields.float('Houseroom size'),
            'sale_lease_type': fields.selection([('bank','Bank'), #Түрээсийн төрөл
                                       ('salon','Beauty salon'),
                                       ('minimarket','Nomin minimarket'),
                                       ('massage','Massage'),
                                       ('food_court','Food court'),
                                       ('na','n/a')], 'Lease type', select = True),
            'sale_lease_month': fields.integer('Lease month'),
            'sale_addition_furniture': fields.many2one('building.furniture','Addition furniture'),
            'sale_loss_percent': fields.float('Loss percent'),
            'sale_m2_price': fields.float('Price m2'),
            'sale_gear': fields.many2one('building.gear','Gear information'),
            'total_square': fields.float('Total square'),
            #'contract_template': fields.html('Contract template'),
        
            #Маркетингийн гэрээ
            
            'mark_contract_amount':fields.float('Contract_amount'),
            #'mark_customer_id': fields.many2one('res.partner','Customer'),
            #===================================================================
            # 'mark_street': fields.char('Street'),  
            # 'mark_city': fields.char('City'),
            # 'mark_country_id': fields.char('Country'),
            # 'mark_website': fields.char('Website'),
            # 'mark_phone': fields.char('Phone'),
            # 'mark_mobile': fields.char('Mobile'),
            # 'mark_fax': fields.char('Fax'),
            # 'mark_email': fields.char('Email'),  
            #===================================================================
            'mark_approved_person_id':fields.many2one('res.users', 'Approved person'),
            'mark_delegate_person_id':fields.many2one('res.users', 'Delegate person'),
            'sale_service_prepayment':fields.many2one('product.product','Service prepayment'),
            'mark_payment_schedule_id':fields.one2many('marketing.payment.schedule','contract_id','Payment schedule'),
            'mark_adv_type':fields.many2one('adv.type','Chanel'),
            'mark_invoice_is':fields.boolean('Invoice', readonly=True),
            'contract_finish_year': fields.char('Finish year'),
            'contract_finish_month': fields.char('Finish month'),
          
             'contract_start_year': fields.char('Start year'),
             'contract_start_month': fields.char('start month'),
             'contract_start_day': fields.char('start day'),
             'pre_payment_percent': fields.float('Pre payment'),
         }
      
      def onchange_date_discount(self, cr, uid, ids, sale_discounted_amount, date_discount,  context=None):
       if sale_discounted_amount > 0 and date_discount > 0:
           sum = sale_discounted_amount-date_discount
           return {'value': {'date_discounted_amount': sum,}}
      def onchange_conditional_discount(self, cr, uid, ids,conditional_discount, sale_discounted_amount, date_discounted_amount, sale_door_amount,  context=None):
       if sale_door_amount > 0 and sale_discounted_amount > 0 and date_discounted_amount > 0:
           sum = date_discounted_amount - conditional_discount
       elif sale_door_amount > 0 and sale_discounted_amount > 0 and date_discounted_amount == 0:
           sum = sale_discounted_amount - conditional_discount
       elif sale_door_amount > 0 and sale_discounted_amount == 0 and date_discounted_amount == 0:
           sum = sale_door_amount - conditional_discount
       elif sale_door_amount > 0 and sale_discounted_amount == 0 and date_discounted_amount > 0:
           sum = date_discounted_amount - conditional_discount
       elif sale_door_amount == 0:
           raise osv.except_osv(_('Warning!'), _('Та гэрээний дүн талбарыг оруулна уу !!!'))
           
       return {'value': {'conditional_discounted_amount': sum,}}
      
       
      
      def on_change_general_type(self, cr, uid,context=None):
        
          return {'value' : {'accident' : False}}
      
      #=========================================================================
      # def create(self, cr, uid, vals, context=None):
      #   if vals.get('sale_discounted_amount'):
      #       if vals.get('sale_payment_schedule_id'):
      #           amount = 0
      #           for line in vals['sale_payment_schedule_id']:
      #               #print "sale_payment_schedule_id: ", vals['sale_payment_schedule_id']
      #               amount = amount + line[2]['amount']   
      #           if amount != vals['sale_discounted_amount']:
      #               raise osv.except_osv(_('Warning!'), _('payment percentage of amount to mistaken !!!'))
      #   return super(account_analytic_account, self).create(cr, uid, vals, context=None)
      #=========================================================================
    
   
      #=========================================================================
      # def write(self, cr, uid, ids, vals, context=None):
      #   # stage change: update date_last_stage_update
      #   
      #   if 'stage_id' in vals:
      #       vals['date_last_stage_update'] = fields.datetime.now()
      #   if vals.get('user_id'):
      #       vals['date_open'] = fields.datetime.now()
      #   # stage change with new stage: update probability and date_closed
      #   if vals.get('stage_id') and not vals.get('probability'):
      #       onchange_stage_values = self.onchange_stage_id(cr, uid, ids, vals.get('stage_id'), context=context)['value']
      #       vals.update(onchange_stage_values)
      #   if vals.get('type'):
      #       if vals['type'] == 'opportunity':
      #           if vals.get('interest_project_id') and vals.get('building_id') and vals.get('door_id'):
      #               info=self.pool.get('sales.information')
      #               information=info.browse(cr, uid, info.search(cr, uid, [('product_id','=',vals['door_id'])]))
      #               employee=self.pool.get('hr.employee')
      #               emp = employee.browse(cr, uid, employee.search(cr, uid, [('user_id', '=', vals['user_id'])]))
      #               if information.state == 'speaking':
      #                   info.write(cr, uid, information.id,{
      #                                       'state': 'speaking',
      #                                       'manager_id': [(4, vals['user_id'])],
      #                                       })
      #               if information.state == 'unsold':
      #                   info.write(cr, uid, information.id,{
      #                                       'state': 'speaking',
      #                                       'manager_id': [(6, 0, [vals['user_id']])],
      #                                       })
      #   obj = self.browse(cr, uid, ids[0])
      #   print "sssssssssssssssss", obj.id 
      #   if obj.type == 'opportunity':
      #       if vals.get('interest_project_id') and vals.get('building_id') and vals.get('door_id'):
      #           info=self.pool.get('sales.information')
      #           information=info.browse(cr, uid, info.search(cr, uid, [('product_id','=',vals['door_id'])]))
      #           employee=self.pool.get('hr.employee')
      #           emp = employee.browse(cr, uid, employee.search(cr, uid, [('user_id', '=', vals['user_id'])]))
      #           if information.state == 'speaking':
      #               info.write(cr, uid, information.id,{
      #                                   'state': 'speaking',
      #                                   'manager_id': [(4, vals['user_id'])],
      #                                   })
      #           if information.state == 'unsold':
      #               info.write(cr, uid, information.id,{
      #                                   'state': 'speaking',
      #                                   'manager_id': [(6, 0, [vals['user_id']])],
      #                                   })
      #                          
      #   return super(crm_lead, self).write(cr, uid, ids, vals, context=context)
      #=========================================================================
      
      def on_change_work_cost(self, cr, uid, ids, work_cost, material_cost, transport_cost, machine_cost, budget_amount, context=None):
        #need to cast in float because the value receveid from web client maybe an integer (Javascript and JSON do not
        #make any difference between 3.0 and 3). This cause a problem if you encode, for example, 2 liters at 1.5 per
        #liter => total is computed as 3.0, then trigger an onchange that recomputes price_per_liter as 3/2=1 (instead
        #of 3.0/2=1.5)
        #If there is no change in the result, we return an empty dict to prevent an infinite loop due to the 3 intertwine
        #onchange. And in order to verify that there is no change in the result, we have to limit the precision of the 
        #computation to 2 decimal  
        work_cost = float(work_cost)
        material_cost = float(material_cost)
        transport_cost = float(transport_cost)
        machine_cost = float(machine_cost)
        budget_amount = float(budget_amount)
        #if work_cost > 0 and material_cost > 0 and 
        round(work_cost+material_cost+transport_cost+machine_cost,2) != budget_amount
        return {'value' : {'budget_amount' : round(work_cost+material_cost+transport_cost+machine_cost,2),}}

      def on_change_material_cost(self, cr, uid, ids, work_cost, material_cost, transport_cost, machine_cost, budget_amount, context=None):
        #need to cast in float because the value receveid from web client maybe an integer (Javascript and JSON do not
        #make any difference between 3.0 and 3). This cause a problem if you encode, for example, 2 liters at 1.5 per
        #liter => total is computed as 3.0, then trigger an onchange that recomputes price_per_liter as 3/2=1 (instead
        #of 3.0/2=1.5)
        #If there is no change in the result, we return an empty dict to prevent an infinite loop due to the 3 intertwine
        #onchange. And in order to verify that there is no change in the result, we have to limit the precision of the 
        #computation to 2 decimal  
        work_cost = float(work_cost)
        material_cost = float(material_cost)
        transport_cost = float(transport_cost)
        machine_cost = float(machine_cost)
        budget_amount = float(budget_amount)
        #if work_cost > 0 and material_cost > 0 and 
        round(work_cost+material_cost+transport_cost+machine_cost,2) != budget_amount
        return {'value' : {'budget_amount' : round(work_cost+material_cost+transport_cost+machine_cost,2),}}
    
      def on_change_transport_cost(self, cr, uid, ids, work_cost, material_cost, transport_cost, machine_cost, budget_amount, context=None):
        #need to cast in float because the value receveid from web client maybe an integer (Javascript and JSON do not
        #make any difference between 3.0 and 3). This cause a problem if you encode, for example, 2 liters at 1.5 per
        #liter => total is computed as 3.0, then trigger an onchange that recomputes price_per_liter as 3/2=1 (instead
        #of 3.0/2=1.5)
        #If there is no change in the result, we return an empty dict to prevent an infinite loop due to the 3 intertwine
        #onchange. And in order to verify that there is no change in the result, we have to limit the precision of the 
        #computation to 2 decimal  
        work_cost = float(work_cost)
        material_cost = float(material_cost)
        transport_cost = float(transport_cost)
        machine_cost = float(machine_cost)
        budget_amount = float(budget_amount)
        #if work_cost > 0 and material_cost > 0 and 
        round(work_cost+material_cost+transport_cost+machine_cost,2) != budget_amount
        return {'value' : {'budget_amount' : round(work_cost+material_cost+transport_cost+machine_cost,2),}}
      def on_change_machine_cost(self, cr, uid, ids, work_cost, material_cost, transport_cost, machine_cost, budget_amount, context=None):
        #need to cast in float because the value receveid from web client maybe an integer (Javascript and JSON do not
        #make any difference between 3.0 and 3). This cause a problem if you encode, for example, 2 liters at 1.5 per
        #liter => total is computed as 3.0, then trigger an onchange that recomputes price_per_liter as 3/2=1 (instead
        #of 3.0/2=1.5)
        #If there is no change in the result, we return an empty dict to prevent an infinite loop due to the 3 intertwine
        #onchange. And in order to verify that there is no change in the result, we have to limit the precision of the 
        #computation to 2 decimal  
        work_cost = float(work_cost)
        material_cost = float(material_cost)
        transport_cost = float(transport_cost)
        machine_cost = float(machine_cost)
        budget_amount = float(budget_amount)
        #if work_cost > 0 and material_cost > 0 and 
        round(work_cost+material_cost+transport_cost+machine_cost,2) != budget_amount
        return {'value' : {'budget_amount' : round(work_cost+material_cost+transport_cost+machine_cost,2),}}
    
#
    
    
      #Борлуулалтын гэрээн дээр хаалга сонгогдоход хийгдэх onchange
      def sales_door_onchange(self, cr, uid, ids, sale_door_id):
        door = self.pool.get('product.template').browse(cr, uid, sale_door_id)
        return {'value':{'sale_entrance': door.entrance,
                         'sale_floor': door.floor,
                         #'sale_door_amount': door.list_price,
                         'houseroom_size': door.houseroom,
                         'total_square':door.total_squaring}}
 
      def sales_building_onchange(self, cr, uid, ids, sale_building_id):
        building = self.pool.get('building.building').browse(cr, uid, sale_building_id)
        return {'value':{'sale_to_commission_season': building.to_commission_season.id or False,
                         'sale_addition_furniture': building.furniture.id or False,
                         'sale_gear': building.gear.id or False,}}
               
      #Борлуулалтын гэрээн дээр хөнгөлөгдсөн дүн бодогдох onchange
      def sale_discount_onchange(self, cr, uid, ids, sale_door_amount, sale_discount_type, sale_amount, sale_discount):
        if sale_discount_type == 'discount':
            discounted_amount = sale_door_amount - (sale_door_amount/100)*sale_discount
            sale_amount = ''
        elif sale_discount_type == 'amount':
            discounted_amount = sale_door_amount - sale_amount
            sale_discount = ''
        else:
            discounted_amount = sale_door_amount
            sale_amount = ''
            sale_discount = ''
        return {'value':{'sale_discounted_amount': discounted_amount,
                         'sale_amount':sale_amount,
                         'sale_discount':sale_discount }}
     
      def write(self, cr, uid, ids, vals, context=None):
        changed_some_attribute=False
        info = self.browse(cr,uid,ids)
        if 'date_start' in vals:
            if vals['date_start'] != False:
                vals.update({'contract_start_year':vals['date_start'].split('-')[0]})    
                vals.update({'contract_start_month':vals['date_start'].split('-')[1]})    
                vals.update({'contract_start_day':vals['date_start'].split('-')[2]})
            
            else: 
                #raise osv.except_osv(_('Анхааруулга'), _('Гэрээ эхлэх огноог оруулна уу !!!'))
                pass        
        if 'sale_valid_contract_percent' in vals.keys() and 'sale_discounted_amount' in vals.keys():
           vals.update({'pre_payment_percent':(vals['sale_valid_contract_percent']/vals['sale_discounted_amount']*100)})   
        elif 'sale_valid_contract_percent' in vals.keys() :
            vals.update({'pre_payment_percent':(vals['sale_valid_contract_percent']/info.sale_discounted_amount*100)}) 
        elif 'sale_discounted_amount' in vals.keys():
            vals.update({'pre_payment_percent':(info.sale_valid_contract_percent/vals['sale_discounted_amount']*100)}) 
            
        
        contract_name=info.name
        general_type=info.general_type_2
        manager_name=info.manager_id.name
        
        date1=info.date1
        #print '........................... 22222222............',info.date.split('-')[0],info.date.split('-')[1],info.date.split('-')[2]
        sale_contract_type=info.sale_contract_type
        
        sale_door_amount=info.sale_door_amount
        sale_discount=info.sale_discount
        sale_discounted_amount=info.sale_discounted_amount
        
        sale_guarantee_year=info.sale_guarantee_year
        sale_loss_percent=info.sale_loss_percent
        
        code=info.code
        company_name=info.company_id.name
        
        sale_project_name=info.sale_project_id.name
        sale_biulding_name=info.sale_building_id.name
        
        sale_door_name=info.sale_door_id.name
        sale_to_commission_season=info.sale_to_commission_season.name
        
        sale_garage_number=info.sale_garage_number
        sale_addition_furniture=info.sale_addition_furniture.name
        
        
        date_start=info.date_start
        date_stop=info.date
        
        mark_contract_amount=info.mark_contract_amount
        mark_adv_type=info.mark_adv_type.name
        contract_id=info.id
        contract_history=self.pool.get('contract.history')
        partner=info.partner_id.name
        
        partner_id=info.partner_id.id
        total_square=info.total_square
        sale_building_id=info.sale_building_id.id
        sale_floor=info.sale_floor
        company_id=info.company_id.id
        sale_entrance=info.sale_entrance
        houseroom_size=info.houseroom_size
        
        sale_valid_contract_percent=info.sale_valid_contract_percent
        manager_id=info.manager_id.id
        sale_payment_schedule_id=info.sale_payment_schedule_id
        sale_contract_type=info.sale_contract_type
        descriptions=info.description
        contract_new=contract_history.create(cr,uid,{'contract_name':contract_name,'general_type':general_type,'manager_name':manager_name,'date1':date1,
                                                     'sale_contract_type':sale_contract_type,'sale_door_amount':sale_door_amount,'sale_discount':sale_discount,'sale_discounted_amount':sale_discounted_amount,
                                                     'sale_guarantee_year':sale_guarantee_year,'sale_loss_percent':sale_loss_percent,'code':code,'company_name':company_name,
                                                     'sale_project_name':sale_project_name,'sale_biulding_name':sale_biulding_name,'sale_door_name':sale_door_name,'sale_to_commission_season':sale_to_commission_season,
                                                     'sale_garage_number':sale_garage_number,'sale_addition_furniture':sale_addition_furniture,'date_start':date_start,'date_stop':date_stop,
                                                     'contract_id':contract_id,'partner':partner,
                                                     'mark_contract_amount':mark_contract_amount,
                                                     
                                                     'partner_id':partner_id,
                                                     'total_square':total_square,
                                                     'sale_building_id':sale_building_id,
                                                     'sale_floor':sale_floor,
                                                     'manager_id':manager_id,
                                                     'company_id':company_id,
                                                     'sale_entrance':sale_entrance,
                                                     'sale_valid_contract_percent':sale_valid_contract_percent,
                                                     'sale_payment_schedule_id':sale_payment_schedule_id,
                                                     'descriptions':descriptions
                                                     })
        #res = super(account_analytic_account, self).write(cr, uid, ids, vals, context=context)
        res = super(account_analytic_account, self).write(cr, uid, ids, vals, context=context)
        contract_history_schedule=self.pool.get('contract.history.schedule')
        for line in info.sale_payment_schedule_id:
            contract_history_schedule.create(cr,uid,{                                                     
                                                     'date':line.date,
                                                     'amount':line.amount,
                                                     'percent':line.percent,
                                                     'contract_history_id':contract_new,
                                                     'loss':line.loss
                                                     })

               
        return res
       
        #Борлуулалтын гэрээн дээр m2 ийн үнэ бодогдох onchange
      def sale_m2_onchange(self, cr, uid, ids, sale_door_amount, total_square):
        m2_amount = 0
        if total_square != 0:
            m2_amount = float(sale_door_amount)/total_square
        return {'value':{'sale_m2_price': m2_amount }}
     

      def set_pending(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        count = 0
        acc_analytic_obj = self.pool.get('account.analytic.account')
        acc_analytic = acc_analytic_obj.search(cr, uid, [('sale_door_id', '=', obj.sale_door_id.id),('state','=','pending'), ('general_type_2','=','sales')])
        if acc_analytic != []:
            raise osv.except_osv(_('Warning!'), _(u'Сонгогдсон байранд гэрээ бүртгэгдсэн байна !!!'))
        for line in obj.sale_payment_schedule_id:
            count += line.amount
        if count != obj.sale_discounted_amount:
           raise osv.except_osv(_('Анхааруулга!'), _('Төлбөрийн хуваарь буруу үүсгэсэн байна !!!'))
            
        contract_code = False
            #Борлуулалтын гэрээний дугаар автоматаар дугаарлах
        if obj.general_type_2 == 'sales':
            if obj.sale_contract_type != 'lease':
                if len(obj.sale_door_id.name)==4:
                    cont4=u'%s'%obj.sale_door_id.name
                if len(obj.sale_door_id.name)==3:
                    cont4='0'+u'%s'%obj.sale_door_id.name
                if len(obj.sale_door_id.name)==2:
                    cont4='00'+u'%s'%obj.sale_door_id.name
                if len(obj.sale_door_id.name)==1:
                    cont4='000'+u'%s'%obj.sale_door_id.name
                if len(obj.sale_building_id.name)==3:
                    cont3=u'%s'%obj.sale_building_id.name
                if len(obj.sale_building_id.name)==2:
                    cont3='0'+u'%s'%obj.sale_building_id.name
                if len(obj.sale_building_id.name)==1:
                    cont3='00'+u'%s'%obj.sale_building_id.name
                if len(obj.sale_building_id.name)==4:
                    cont3='000'+u'%s'%obj.sale_building_id.name
                cont_obj=self.browse(cr, uid, self.search(cr, uid, [('general_type_2','=','sales')]))
                i=0
                for line in cont_obj:
                    if line.state == 'pending':
                        i=i+1
                    if line.state == 'close':
                        i=i+1
                    if line.state == 'cancelled':
                        i=i+1
                i=i+1
                cont2=u'%s'%(i%10)
                i=i/10
                cont2=u'%s'%(i%10)+cont2
                i=i/10
                cont2=u'%s'%(i%10)+cont2
                i=i/10
                cont2=u'%s'%(i%10)+cont2
                cont1=obj.sale_building_id.project_id.name
                contract_code=u'%s'%cont1+u'%s'%cont2+u'%s'%cont3+u'%s'%cont4
            else:
                contract_code=False
            
            #Борлуулалтын гэрээнээс борлуулалтын мэдээг зарсан төлөврүү автоматаар шилжүүлж байгаа
            inf=self.pool.get('sales.information')
            information = inf.browse(cr, uid, inf.search(cr, uid, [('product_id','=',obj.sale_door_id.id)]))
            inf.write(cr, uid, information.id,{
                                                'state': 'sold',
                                                'manager_id':[(6, 0 , [obj.manager_id.id])], 
                                                })
            
            
            #Маркетингийн гэрээний дугаар автоматаар дугаарлах
            
        adv = self.pool.get('adv.type')
        if obj.general_type_2 == 'marketing':
            adv_type = adv.browse(cr, uid, adv.search(cr, uid, [('id','=',obj.mark_adv_type.id)] ))
            con1 = u'%s'%adv_type.type_abb
            con_obj=self.browse(cr, uid, self.search(cr, uid, [('general_type_2','=','marketing')]))
            i=0
            for line in con_obj:
                if line.state == 'pending':
                    i=i+1
                if line.state == 'close':
                    i=i+1
                if line.state == 'cancelled':
                    i=i+1
            i=i+1
            con2=u'%s'%(i%10)
            i=i/10
            con2=u'%s'%(i%10)+con2
            i=i/10
            con2=u'%s'%(i%10)+con2
            i=i/10
            con2=u'%s'%(i%10)+con2
            now_date=time.strftime('%Y-%m-%d')
            contract_code = u'%s'%con1+u'%s'%con2+u'%s'%now_date[0:4]+u'%s'%now_date[5:7]+u'%s'%now_date[8:10]

            
        

        
        #=======================================================================
        # #Борлуулалтын гэрээнээс борлуулалтын мэдээг зарсан төлөврүү автоматаар шилжүүлж байгаа
        # inf=self.pool.get('sales.information')
        # information = inf.browse(cr, uid, inf.search(cr, uid, [('product_id','=',obj.sale_door_id.id)]))
        # inf.write(cr, uid, information.id,{
        #                                     'state': 'sold',
        #                                     'manager_id':[(6, 0 , [obj.manager_id.id])], 
        #                                     })
        #=======================================================================
        self.write(cr, uid, ids, {'state': 'pending',
                                          'code': contract_code}, context=context)
        #Ажил гүйцэтгэх гэрээ дугаарлах
        if obj.general_type == 'work':    
                cont_obj=self.browse(cr, uid, self.search(cr, uid, [('general_type','=','work')]))
                i=0
                for line in cont_obj:
                    if line.state == 'pending':
                        i=i+1
                    if line.state == 'close':
                        i=i+1
                    if line.state == 'cancelled':
                        i=i+1
                cont2=u'%s'%(i%10)
                i=i/10
                cont2=u'%s'%(i%10)+cont2
                i=i/10
                cont2=u'%s'%(i%10)+cont2
                i=i/10
                cont2=u'%s'%(i%10)+cont2
                cont1=u'АГ'+u'%s'%time.strftime('%Y%m%d-')
                contract_code=u'%s'%cont1+u'%s'%cont2
        else:
                if obj.general_type == 'product':
                    cont_obj=self.browse(cr, uid, self.search(cr, uid, [('general_type','=','product')]))
                    i=0
                    for line in cont_obj:
                        if line.state == 'pending':
                            i=i+1
                        if line.state == 'close':
                            i=i+1
                        if line.state == 'cancelled':
                            i=i+1
                    cont2=u'%s'%(i%10)
                    i=i/10
                    cont2=u'%s'%(i%10)+cont2
                    i=i/10
                    cont2=u'%s'%(i%10)+cont2
                    i=i/10
                    cont2=u'%s'%(i%10)+cont2
                    cont1=u'БН'+u'%s'%time.strftime('%Y%m%d-')
                    contract_code=u'%s'%cont1+u'%s'%cont2
                else:
                            #Бусад гэрээ дугаарлах
                    if obj.general_type == 'other':
            
                        cont_obj=self.browse(cr, uid, self.search(cr, uid, [('general_type','=','other')]))
                        i=0
                        for line in cont_obj:
                            if line.state == 'pending':
                                i=i+1
                            if line.state == 'close':
                                i=i+1
                            if line.state == 'cancelled':
                                i=i+1
                        cont2=u'%s'%(i%10)
                        i=i/10
                        cont2=u'%s'%(i%10)+cont2
                        i=i/10
                        cont2=u'%s'%(i%10)+cont2
                        i=i/10
                        cont2=u'%s'%(i%10)+cont2
                        cont1=u'Б'+u'%s'%time.strftime('%Y%m%d-')
                        contract_code=u'%s'%cont1+u'%s'%cont2
        self.write(cr, uid, ids, {'state': 'pending',
                                      'code': contract_code}, context=context)    
    
    
      def set_cancel(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        count = 0
        acc_analytic_obj = self.pool.get('account.analytic.account')

       #========================================================================
       #  #Борлуулалтын гэрээнээс борлуулалтын мэдээг зарсан төлөврүү автоматаар шилжүүлж байгаа
       #  inf=self.pool.get('sales.information')
       #  information = inf.browse(cr, uid, inf.search(cr, uid, [('product_id','=',obj.sale_door_id.id)]))
       # 
       #  inf.write(cr, uid, information.id,{
       #                                      'state': 'unsold',
       #                                      'manager_id': [(6, 0 , '')], 
       #                                      })
       #========================================================================


        self.write(cr, uid, ids, {'state': 'cancelled',
                                          }, context=context)
     


      #Борлуулалтын гэрээнээс нэхэмжлэл үүсгэх
                        
      #=========================================================================
      # def sale_action_create_invoice(self, cr, uid, ids, context=None):
      #   obj = self.browse(cr, uid, ids)[0]
      #   invoice = self.pool.get('account.invoice')
      #   journal_obj = self.pool.get('account.journal')
      #   sch_obj = self.pool.get('sales.payment.schedule')
      #  
      #   currency_id = obj.company_id.currency_id.id
      #   journal_ids = journal_obj.search(cr, uid, [('type', '=','sale'),('company_id', '=', obj.company_id.id or False)], limit=1)
      #   fpos = obj.partner_id.property_account_position or False
      #   if obj.sale_service_prepayment.property_account_income.id or obj.sale_service_prepayment.property_account_expense.id:
      #       for line in obj.sale_payment_schedule_id:
      #           invoice_line = []
      #           invoice_line.append((0, 0, {
      #                                       'product_id': obj.sale_service_prepayment.id,
      #                                       'name': obj.name,
      #                                       'account_id': obj.sale_service_prepayment.property_account_income.id or obj.sale_service_prepayment.property_account_expense.id,
      #                                       'quantity': line.amount,
      #                                       'price_unit': obj.sale_service_prepayment.list_price,
      #                                       }))
      #           
      #           sch_invoice = invoice.create(cr, uid, {
      #                                   'partner_id': obj.partner_id.id,
      #                                   'date_invoice': time.strftime('%Y-%m-%d'),
      #                                   'journal_id': len(journal_ids) and journal_ids[0] or False,
      #                                   'account_id': obj.partner_id.property_account_receivable.id,
      #                                   'type': 'out_invoice',
      #                                   'user_id': obj.sale_manager_id.id,
      #                                   'currency_id': currency_id,
      #                                   'origin': obj.code,
      #                                   'fiscal_position': fpos and fpos.id,
      #                                   'company_id': obj.company_id.id or False,
      #                                   'invoice_line': invoice_line,
      #                                   'date_due': line.date,
      #                                    })
      #           sch_obj.write(cr, uid, line.id, {'invoice_id': sch_invoice})
      #       
      #   return True
      #=========================================================================
        


      #Маркетингийн гэрээнээс нэхэмжлэл үүсгэх

      def mark_action_create_invoice(self, cr, uid, ids, context=None):
          obj = self.browse(cr, uid, ids)[0]
          invoice = self.pool.get('account.invoice')
          journal_obj = self.pool.get('account.journal')
          sch_obj = self.pool.get('marketing.payment.schedule')
          journal_ids = journal_obj.search(cr, uid, [('type', '=','purchase'),('company_id', '=', obj.company_id.id or False)], limit=1)
          fpos = obj.partner_id.property_account_position or False
          if obj.sale_service_prepayment.property_account_income.id or obj.sale_service_prepayment.property_account_expense.id:
              invoice_lines = []
              for line in obj.mark_payment_schedule_id:
                  invoice_line = []
                  invoice_line.append((0, 0, {
                                            'name': obj.name,
                                            'account_id': obj.sale_service_prepayment.property_account_income.id or obj.sale_service_prepayment.property_account_expense.id,
                                            'quantity': 1,
                                            'price_unit': line.amount,
                                            }))
                
                  sch_invoice = invoice.create(cr, uid, {
                                        'type': 'in_invoice',
                                        'company_id': obj.company_id.id or False,
                                        'partner_id': obj.partner_id.id,
                                        'date_invoice': time.strftime('%Y-%m-%d'),
                                        'date_due': line.date,
                                        'origin': obj.code,
                                        'account_id': obj.partner_id.property_account_payable.id,
                                        'journal_id': len(journal_ids) and journal_ids[0] or False,
                                        'reference_type': 'none',
                                        'user_id': obj.mark_approved_person_id.id,
                                        'invoice_line': invoice_line,
                                        'fiscal_position': fpos and fpos.id,
                                                                                 })
              self.write(cr, uid, ids, {'mark_invoice_is': True})
            
          return True


      #Ажил гүйцэтгэх гэрээ байгуулахад урьдчилгаа дүнгээр нэхэмжлэл үүсгэх
      def contract_work_create_invoice(self, cr, uid, ids, context=None):
          obj = self.browse(cr, uid, ids)[0]
          invoice = self.pool.get('account.invoice')
          journal_obj = self.pool.get('account.journal')
          #sch_obj = self.pool.get('marketing.payment.schedule')
          journal_ids = journal_obj.search(cr, uid, [('type', '=','purchase'),('company_id', '=', obj.company_id.id or False)], limit=1)
          fpos = obj.partner_id.property_account_position or False
          invoice_lines = []        
          invoice_line = []
          invoice_line.append((0, 0, {
                                            'name': obj.name,
                                            'account_id': obj.partner_id.property_account_payable.id,
                                            'price_unit': obj.advance_amount,
                                            'quantity': 1,
                                            }))
                
          sch_invoice = invoice.create(cr, uid, {
                                        'type': 'in_invoice',
                                        'company_id': obj.company_id.id or False,
                                        'partner_id': obj.partner_id.id,
                                        'contract_id': obj.id,
                                        'date_invoice': time.strftime('%Y-%m-%d'),
                                        'date_due': time.strftime('%Y-%m-%d'),
                                        'origin': obj.code,
                                        'account_id': obj.partner_id.property_account_payable.id,
                                        'journal_id': len(journal_ids) and journal_ids[0] or False,
                                        'reference_type': 'none',
                                        'invoice_line': invoice_line,
                                        'fiscal_position': fpos and fpos.id,
                                                                             })
          self.write(cr, uid, ids, {'invoice_id': sch_invoice
                                    })
          return True
# Ажил гүйцэтгэх гэрээнд ажил бүртгэхэд ашиглаж байгаа класс
       
      #=========================================================================
      # def _compute_payments11(self, cr, uid, inv):
      #   #partial_lines = lines = self.env['account.move.line']
      #   print inv.move_id
      #=========================================================================
        
#         for line in inv.move_id.line_id:
#             if line.account_id != self.account_id:
#                 continue
#             if line.reconcile_id:
#                 lines |= line.reconcile_id.line_id
#             elif line.reconcile_partial_id:
#                 lines |= line.reconcile_partial_id.line_partial_ids
#             print "222"
            #partial_lines += line
       # self.payment_ids = (lines - partial_lines).sorted()
        
      def sale_action_compute_loss(self, cr, uid, ids, context=None):
          obj = self.browse(cr, uid, ids)[0]
          sch = self.pool.get('sales.payment.schedule')
          inv = self.pool.get('account.invoice')
          move = self.pool.get('account.move.line')
          day = '%Y-%m-%d'
          for schedule_line in obj.sale_payment_schedule_id:
              obj_line = sch.browse(cr, uid, sch.search(cr, uid, [('id', '=', schedule_line.id)]))
              invoice = inv.browse(cr, uid, schedule_line.invoice_id.id, context=context)
              #=================================================================
              # self._compute_payments11(cr, uid, invoice)
              #=================================================================
              loss = 0
              payment = 0
              for payment_line in invoice.payment_ids:
                  if invoice.date_due < payment_line.date:
                      
                      a = datetime.strptime(payment_line.date, day)
                      b = datetime.strptime(invoice.date_due, day)
                      timedelta = a-b
                      delta_day=timedelta.days
                      loss = loss + (payment_line.credit*obj.sale_loss_percent/100)*delta_day
                  
                  payment = payment + payment_line.credit
                  
                  #--------------- if payment_line.date =< invoice.date_due:
              if invoice.state == 'paid':
                  sch.write(cr, uid, schedule_line.id, {'state': 'paid'})
              else:
                  if invoice.date_due < time.strftime('%Y-%m-%d'):
                      if invoice.date_due != False:
                          now_date = time.strftime('%Y-%m-%d')
                          a = datetime.strptime(now_date, day)
                          b = datetime.strptime(invoice.date_due, day)
                          
                          timedelta = a - b
                          delta_day=timedelta.days
                          loss = loss + delta_day*(invoice.amount_total-payment)*obj.sale_loss_percent/100
                      else:
                       raise osv.except_osv(_('Warning!'), _('invoice not created'))
              sch.write(cr, uid, schedule_line.id, {'loss': loss})       
              
          return True

# Ажил гүйцэтгэх гэрээнд ажил бүртгэхэд ашиглаж байгаа класс

class contract_work_line (osv.osv):  
    _name = 'contract.work.line'
    _columns = { 
          #'phase_id': fields.many2one('project.task.type','Phase'),
          'phase_id': fields.many2one('project.task.phase','Phase'),
          'task_id': fields.many2one('project.project.task','Task'),
          'uom': fields.many2one('product.uom','UOM'),
          'work_count': fields.float('Volume of work'),
          'contract_price': fields.float('Price'),
          'work_start_date': fields.date('Start date'),
          'work_end_date': fields.date('End date'), 
          'account_analytic_account_id': fields.many2one('account.analytic.account','Account analytic account'),  
                 }

#Борлуулалтын гэрээний төлбөрийн хуваарь    
class sales_payment_schedule(osv.osv):
    _name = 'sales.payment.schedule'
    _description = "Payment schedule"
    
    def _get_state(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        state = 0
        
        for line in self.browse(cr, uid, ids):
            if line.contract_id.state == 'pending':
                res[line.id] = 1
             
            else:
                res[line.id] = 0
        
        return res
    
    def _percent_calculate(self, cr, uid, ids,name, args, context = None):
        if ids:
           
           percent = 0.0 
           obj = self.browse(cr, uid,ids)[0]
           onepercent=obj.contract_id.sale_discounted_amount/100
           percent=obj.amount/onepercent
           
           return {ids[0]:percent}
   
      #=========================================================================
      # def write(self, cr, uid, ids, vals, context=None):
      #     res = super(account_analytic_account, self).write(cr, uid, ids, vals, context=context)   
      # print 'changed write save'
      # # Борлуулалтын гэрээний төлбөрийн хуваарь дахь хувь автоматаар тооцоолох
      # if ids:   
      #     percent = 0
      #     contract=self.browse(cr, uid, ids)[0]
      #     sch_obj = self.pool.get('sales.payment.schedule')
      #     if contract.sale_discounted_amount:
      #         schedule = sch_obj.browse(cr, uid, sch_obj.search(cr, uid, [('contract_id','=',contract.id)]))
      #         onepercent=contract.sale_discounted_amount/100
      #         for line in schedule:
      #             percent=line.amount/onepercent
      #             sch_obj.write(cr, uid, line.id, {'percent': percent})
      #     #===================================================================
      #     # print "ssssssssssssss", contract.sale_payment_schedule_id
      #     # print "asdasdasdasdasdasd"
      #     #===================================================================
      #     schedule = sch_obj.browse(cr, uid, sch_obj.search(cr, uid, [('contract_id','=',contract.id)]))
      #     if schedule:
      #         amount = 0
      #         for line in schedule:
      #             amount = amount + line.amount
      #         if amount != contract.sale_discounted_amount:
      #             #print "amount: ", amount
      #             raise osv.except_osv(_('Warning!'), _('Task bom matching !!!'))
      # return res
      #=========================================================================
    
    _columns = {
                'date':fields.date('Payment date'),
                'amount':fields.float('Payment amount'),
                'percent': fields.function(_percent_calculate, method=True, type ="float", store =True, string='Contract percent'),
                'contract_id': fields.many2one('account.analytic.account', 'Sales Contract'),
                'loss': fields.float('Loss', readonly = True),
                'customer_id': fields.many2one('res.partner','Customer'),
                'contract_code': fields.char('Code'),
                'parent_state': fields.function(_get_state,type="integer",string='Parent state', readonly=True),
                'state': fields.selection([('paid', 'Paid'),
                                           ('unpaid', 'Unpaid')], 'State', readonly = True),
                'order_id':fields.many2one('sale.order', 'Sale Order', readonly=True),
                'invoice_id':fields.many2one('account.invoice', 'Invoice ', readonly=True),
               }
    _defaults = {
                'amount': 0,
                'state': 'unpaid',
                }

      #Борлуулалтын төлбөрийн хуваариас нэхэмжлэл үүсгэх

    def sale_action_create_invoice(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        invoice = self.pool.get('account.invoice')
        journal_obj = self.pool.get('account.journal')
        cont = self.pool.get('account.analytic.account')
        
        obj_cont = cont.browse(cr, uid, cont.search(cr, uid, [('id','=',obj.contract_id.id)]))
        currency_id = obj_cont.company_id.currency_id.id
        journal_ids = journal_obj.search(cr, uid, [('type', '=','sale'),('company_id', '=', obj_cont.company_id.id or False)], limit=1)
        fpos = obj_cont.partner_id.property_account_position or False
        invoice_line = []
        invoice_line.append((0, 0, {
                                    'name': obj_cont.name,
                                    'account_id': obj_cont.sale_door_id.property_account_income.id or obj_cont.sale_door_id.property_account_expense.id,
                                    'quantity': 1,
                                    'price_unit': obj.amount,
                                    }))
        
        sch_invoice = invoice.create(cr, uid, {
                                'partner_id': obj_cont.partner_id.id,
                                'date_invoice': time.strftime('%Y-%m-%d'),
                                'journal_id': len(journal_ids) and journal_ids[0] or False,
                                'account_id': obj_cont.partner_id.property_account_receivable.id,
                                'type': 'out_invoice',
                                'user_id': obj_cont.manager_id.id,
                                'currency_id': currency_id,
                                'origin': obj_cont.code,
                                'fiscal_position': fpos and fpos.id,
                                'company_id': obj_cont.company_id.id or False,
                                'invoice_line': invoice_line,
                                'date_due': obj.date,
                                 })
        self.write(cr, uid, ids, {'invoice_id': sch_invoice})
        return True
    def create(self, cr, uid, vals, context=None):
        counter_create=0
        #print '111111111111111111111 schedule create:',counter_create
        #print '111111111111111111111 schedule create:',vals['contract_id'],vals['date'],vals['amount'],vals['percent'],
        
        
        contract_obj = self.pool.get('account.analytic.account')
        
        if 'contract_id' in vals:
            contract = contract_obj.search(cr, uid,[('id','=',vals['contract_id'])])
            contract_id = contract_obj.browse(cr, uid, contract)[0]
            
            payment_schedule_obj = self.pool.get('sales.payment.schedule')
            payment_schedule_id = payment_schedule_obj.search(cr, uid, [('contract_id','=',vals['contract_id']),('date','=',vals['date'])])
            i = 0
            for line in payment_schedule_id:
                i += 1
            if i > 1:
              raise osv.except_osv(_('Анхааруулга!'), _('Нэг өдөр олон төлбөрийн мөр үүсэхгүй'))
                
            payment_schedule_id = payment_schedule_obj.search(cr, uid, [('contract_id','=',vals['contract_id']),('date','=',vals['date']),('amount','=',vals['amount'])])
           
            if payment_schedule_id !=[]:
                for line in payment_schedule_obj.browse(cr, uid, payment_schedule_id):
                #   print 'contract same :',line.contract_id,line.amount
                   return
             
            if contract_id:
              
                                    vals.update({
                                                 'customer_id':contract_id.partner_id.id,
                                                 'contract_code':contract_id.code,
                        }, context=context)
               #vals.update({'qty_balance':vals['qty_balance']})
        
        counter_create=counter_create+ 1
        return super(sales_payment_schedule, self).create(cr, uid, vals, context=context)
    
#Маркитенгийн гэрээний төлбөрийн хуваарь    
class mark_payment_schedule(osv.osv):
    _name = 'marketing.payment.schedule'
    _columns = {               
                'date': fields.date('Payment date'),
                'amount': fields.integer('Payment amount'),
                'contract_id': fields.many2one('account.analytic.account', 'Sales Contract'),
                }


class fleet_vehicle_tag(osv.Model):
    _name = 'contract.work.tag'
    _columns = {
        'name': fields.char('Name', required=True, translate=True),
    }

