# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from openerp.osv import fields, osv


class sale_contract_wizard(osv.osv_memory):
    _name = 'contract.end.wizard'
    _description = 'Contract end'

    _columns = {
        'date': fields.date('Date', required=True),
    }

    _defaults = {
        'date': lambda *a: time.strftime('%Y-%m-%d')
    }

    def check_report(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        data = self.read(cr, uid, ids)[0]
        
        datas = {
            'ids': context.get('active_ids', []),
            'model': 'account.analytic.account',
            'form': data,
            'date':data['date']
        }

        datas['form']['active_ids'] = context.get('active_ids', False)
        acc_obj = self.pool.get('account.analytic.account')
        analytic_acc_id = 0
        analytic_acc_id = context.get('active_ids', [0])
        analytic_acc = acc_obj.browse(cr, uid, acc_obj.search(cr, uid, [('id', '=', analytic_acc_id)]))
      
        if analytic_acc.general_type_2 != False:
            if analytic_acc.general_type_2 == 'sales':
                        
                return self.pool['report'].get_action(cr, uid, [], 'ierp_contract.sale_contract_end', data=datas, context=context)
        
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
