# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from report import report_sxw
import time

class report_cur_ex_pur(report_sxw.rml_parse):
    
    def _get_value(self, cr, uid, context=None):
        obj = self.pool.get('currency.exchange.purchase').browse(cr, uid, context['active_id'])
        line_ids = self.pool.get('account.move.line').search(cr, uid, [('move_id','=',obj.move1_id.id)])
        line = self.pool.get('account.move.line').browse(cr, uid, line_ids[0])
        return line.name
    
    def _get_employee(self, cr, uid, context=None):
        employee_id = self.pool.get('hr.employee').search(cr, uid, [('user_id','=',uid)])
        if employee_id != []:
            employee = self.pool.get('hr.employee').browse(cr, uid, employee_id[0])
        else:
            employee = self.pool.get('hr.employee').browse(cr, uid, uid)
        return unicode(employee.name)
    
    _name = 'report.cur.ex.purchase'
    def __init__(self, cr, uid, name, context):
        super(report_cur_ex_pur, self).__init__(cr, uid, name, context = context)
        self.localcontext.update({
            'time': time,
            'value': self._get_value(cr, uid, context),
            'employee': self._get_employee(cr, uid, context),
        })
    
report_sxw.report_sxw('report.cur.ex.purchase', 'currency.exchange.purchase', 'addons/currency_exchange/report/report_purchase.rml', parser=report_cur_ex_pur, header=False )

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
