# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2014 iERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : iERP@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp

class project_drawing(osv.osv):
    _name = 'project.drawing'
    _description = "NCD project drawing"
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    _columns = {
                'project_id':fields.many2one('project.project','Project',required=True, help=u'Харьялагдах төслийн нэрийг сонгож оруулна'), #Төслийн нэр
                'building_id':fields.many2one('building.building','Building', help=u'Барилгын дугаарыг үсэг тоо тэмдэгт ашиглан оруулах боломжтой'), #Барилгын дугаар
                'name':fields.char('Draw Name',required=True, help=u'Зурах зургийн нэрийг үсэг, тоо, тэмдэгт ашиглан оруулах боломжтой'), #Зургийн нэр
                'cipher':fields.char('Draw cipher', help=u'Зургийн шифрийг үсэг тоо тэмдэгт ашиглан оруулах боломжтой'), #Шифр
                'interpreter_id':fields.many2one('res.partner','Interpreter company', help=u'Зургийн ажил гүйцэтгэгч компанийн мэдээллээс сонгоно', track_visibility='onchange'), #Гүйцэтгэгч байгууллага
                'draw_end_date':fields.date('Draw end date', help=u'Зургийн ажил гүйцэтгэгч ажилтан ажилаа дуусгасан огноог сонгоно'),#Дууссан огноо
                'drawer_ermployee_id':fields.many2one('hr.employee','Drawer employee', help=u'Зургийн ажил гүйцэтгэгч ажилтаны нэрийг сонгоно', track_visibility='onchange'), #Зургийн автор
                'inspected_date':fields.date('Inspected date', help=u'Магадлал хийгдсэн огноог оруулна'), #Магадлал хийгдсэн огноо
                'change_date':fields.date('Change date', help=u'Зургийн өөрчлөлт хийгдсэн огноог сонгоно'), #Өөрчлөлт хийгдсэн огноо
                'receipt_date':fields.date('Receipt date', help=u'Зургийн ажил гүйцэтгэгч ажилтан анх хүлээж авсан огноог сонгоно'), #Хүлээн авсан огноо
                'ois_length':fields.float('Ois length', help=u'Барилгын уртын ойсорх хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Урт ойсорх
                'inside_wall_length':fields.float('Inside wall length', help=u'Барилгын уртын дотор ханаас авсан хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Урт дотор ханаас
                'outside_wall_length':fields.float('Outside wall length', help=u'Барилгын уртын гадна хананаас авсан хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Урт гадна хананаас
                'ois_width':fields.float('Ois width', help=u'Барилгын өргөний ойсорх хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Өргөн ойсоорх
                'inside_wall_width':fields.float('Inside wall width', help=u'Барилгын өргөний дотор ханаас авсан хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Өргөн дотор ханаас
                'outside_wall_width':fields.float('Outside wall width', help=u'Барилгын өргөний гадна хананаас авсан хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Өргөн гадна ханаас
                'building_heigth':fields.float('Heigth', help=u'Барилгын нийт уртыг бүхэл болон бутархай тоо  ашиглан оруулах боломжтой'), #Барилгын хэмжээ - Өндөр          
                'building_floor_number':fields.integer('Floor number', help=u'Давхрын тоог оруулна'), #Давхрын тоо
                'building_door_number':fields.integer('Doors number', help=u'Тухайн барилгын хүчин чадлыг  харгалзах хэмжих нэгжинд нь тааруулж бүхэл болон бутархай тоогоор оруулах боломжтой'), #Айлын тоо, хүчин чадал
                #'door_unit':fields.many2one('product.uom','Unit'),
                'ois_base':fields.float('Base', help=u'Барилгын ойсоорх талбайг бүхэл болон бутархай тоог ашиглан оруулах боломжтой'), #Ойсоорх талбай-Суурь
                'ois_cellar':fields.float('Cellar', help=u'Зоорийн давхрыг бүхэл болон бутархай тоог ашиглан оруулах боломжтой'), #Ойсоорх талбай-Зоорь
                'uncurrent_floor':fields.char('Uncurrent floor', help=u'Давтагдахгуй давхарыг бүхэл тоо ашиглан оруулах боломжтой'), #Давтагдахгүй давхар
                'recurrent_floor':fields.char('Recurrent floor', help=u'Давтагдах давхарыг бүхэл тоо ашиглан оруулах боломжтой'), #Давтагдах давхар
                'building_basic_structure':fields.char('Building basic structure', help=u'Барилгын үндсэн хийц бүтцийн талаар мэдээллийг  үсэг, тоо, тэмдэгт ашиглан оруулах боломжтой'), #Барилгын үндсэн бүтэц
                'building_base_design':fields.char('Building base design', help=u'Барилгын суурийн хийц бүтцийн талаар мэдээллийг  үсэг, тоо, тэмдэгт ашиглан оруулах боломжтой'), #Барилгын суурийн хийц
                'building_capacy':fields.float('Building capacy', help=u'Барилгын нийт талбайг бүхэл болон бутархай тоог ашиглан оруулах боломжтой'), #Барилгын эзэлхүүн
                'building_volume':fields.float('Building volume'), #Барилгын эзэлхүүн
                'total_square_building':fields.many2many('total.space','total_space_rel','total_square_building','name','Total square building', help=u'Барилгын айлуудын нийт талбайг бүхэл болон бутархай тоог ашиглан шинээр үүсгэж болон сонгож оруулах боломжтой'),#Барилгын нийт талбай
                'living_space':fields.float('Living space', help=u'Барилгын нийт айлуудын  талбайг бүхэл болон бутархай тоог ашиглан оруулах боломжтой '), #Ашигтай талбай
                'sold_out_space':fields.many2many('sold.space','sold_space_rel','sold_out_space','name','Sold out space', help=u'Барилгын айлуудын нийт борлогдох талбайг бүхэл болон бутархай тоог ашиглан шинээр үүсгэж болон сонгож оруулах боломжтой'), #Борлогдох талбай/айлын
                'public_space':fields.float('Public space', help=u'Барилгын нийт нийтийн эзэмшлийн талбайг бүхэл болон бутархай тоог ашиглан оруулах боломжтой'), #Нийтийн эзэмшлийн талбай
                'park_space':fields.float('Park space', help=u'Барилгын нийт зогсоолын талбайг бүхэл болон бутархай тоог ашиглан оруулах боломжтой '), #Зогсоолийн талбай
                'park_number':fields.integer('Park number', help=u'Барилгын нийт зогсоолын тоог оруулна'), #Зогсоолын тоо
                'car_park_space':fields.float('Car park space'), #Авто зогсоолийн талбай
                'on_foot_space':fields.float('On foot space'), #Явган зам
                'green_area':fields.float('Green area'), #Ногоон байгууламж
                'rest_space':fields.float('Rest space'), #Амрах талбай
                'sport_space':fields.float('Sport space'), #Спорт талбай
                'tree_count':fields.char('Tree count', help=u'Мод, бутны тоо талаар мэдээллийг үсэг, тоо, тэмдэгт ашиглан оруулах боломжтой'), #Мод бутны тоо
                'choice_block':fields.many2one('choice.block','Choice block'),
                'object_name':fields.char('Object name', help=u'Обьектийн нэрийг үсэг, тоо, тэмдэгт ашиглан оруулах боломжтой'), #Обеъктын нэр
                #'bnbd_standarts':fields.many2many('bnbd.standart','bnbd_standart_rel','bnbd_standarts','name','BNbD standart', help=u'БНБД стандартуудыг үүсгэж, сонгож өгөх боломжтой'), #БНбД стандартууд
                'building_dedication':fields.char('Building dedication', help=u'Барилгын зориулалтыг үсэг, тоо, тэмдэгт ашиглан тодорхойлох боломжтой'), #Барилгын зориулалт
                #'building_basic_spend':fields.char('Building basic spend'), #Барилгын ерөнхий зарцуулалт
                'well_number':fields.char('Well number'), # Худгийн дугаар
                'building_strain':fields.float('Building strain', help=u'Барилгын ачааллийг Вт-р оруулна'), #Барилгын ачаалал
                'date_planned_start':fields.date('Date planned start', help=u'Зургийн ажлыг эхлэхээр төлөвлөсөн огноо оруулна'), #Эхлэхээр төлөвлөсөн огноо
                'date_planned_end':fields.date('Date planned end', help=u'Зургийн ажлыг дуусахаар төлөвлөсөн огноо оруулна'), #Дуусахаар төлөвлөсөн огноо
                'request_description':fields.text('Request description', help=u'Тухайн барилгын зургийн талаар нэмэлт мэдээлэл үсэг, тоо, тэмдэгт ашиглан тодорхойлох боломжтой'), #Хүсэлтийн тайлбар
                'door_id':fields.many2one('product.template','Door', help=u'Хаалганы дугаарыг үсэг, тоо, тэмдэгт ашиглан оруулах боломжтой'), #Хаалганы дугаар
                'door_entrance':fields.integer('Entrance', help=u'Тоотын байрлах орц'), #Орц
                'door_floor':fields.integer('Floor', help=u'Тоотын байрлах давхар'), #Давхар
                'door_type':fields.many2one('door.type','Door type', help=u'А, В, С зэрэг айлын төрлийг үсэг ашиглаж оруулах ба оруулсан төрлөөс сонгох боломжтой'), #Хаалганы төрөл
                'room_code':fields.integer('Room code', help=u'Өрөөний дугаарыг үсэг, тоо, тэмдэгт ашиглан оруулах боломжтой'), #Өрөөний дугаар
                'work_process':fields.integer('Percent', help=u'Зургийн ажлын гүйцэтгэлийн хувийг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Гүйцэтгэлийн хувь
                'comment':fields.text('Comment', help=u'Тухайн зургийн өөрчлөлт орсон талаарх мэдээллийг үсэг, тоо, тэмдэгт ашиглан тодорхойлох боломжтой'), #Өөрчлөлтийн тайлбар
                'drawing_change_id': fields.one2many('drawing.change', 'draw_id', 'Drawing Change History'),
                'author_check_id': fields.one2many('drawing.author', 'draw_id', 'Author checks'),
                'type':fields.selection([('ba','BA'),
                                         ('bb','BB'),
                                         ('has','HAS'),
                                         ('tsbu','TsBU'),
                                         ('hd','HD'),
                                         ('dg_ht','DG,HT'),
                                         ('out_warm','Out warm'),
                                         ('out_electric','Out electric'),
                                         ('out_sanitation','Out sanitation'),
                                         ('out_signal','Out signal'),
                                         ('out_appointment','Out appointment'),
                                         ('in_design','In design'),
                                         ('sketch','Sketch'),
                                         ('technology_guidance','Technology guidance')],'Type',help=u'Зургийн төрөл сонгож оруулна', required=True),
                'land_size':fields.float('Land size', help=u'Газрын хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Газрын хэмжээ
                'land_size_uom':fields.many2one('product.uom','Land uom'),
                'building_total_size':fields.float('Building total size', help=u'Барилгажих нийт хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Барилгажих нийт хэмжээ
                'green_percent':fields.float('Green percent', help=u'Ногоон байгууламжийн эзлэх хувь хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Ногоон байгууламжийн эзлэх хувь
                'building_behind_size':fields.float('Building behind size', help=u'Барилга хоорондын зайг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Барилга хоорондын зай 
                'building_block_total_size':fields.float('Building block total size', help=u'Орон сууцны барилгын нийт хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Орон сууцны барилгын нийт талбай                             
                'sale_service_total_size':fields.float('Sales service total size', help=u'Худалдаа үйлчилгээний барилгын нийт хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), # Худалдаа үйлчилгээний барилгын нийт талбай             
                'planned_total_size_building':fields.float('Planned total size building', help=u'Төлөвлөгдөж буй нийт барилгын тоог бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Төлөвлөгдөж буй нийт барилгын тоо
                #'planned_building':fields.many2one('product.uom','Planned building uom'), # ширхэг, блок
                'planned_floor_count':fields.integer('Planned floor count'), #Төлөвлөгдөж буй давхрын тоо
                'planned_rate':fields.float('Planned rate', help=u'Төлөвлөгдөж буй хүчин чадлийг хэмжих нэгжийг нь сонгож өгөн бүхэл болон бутархай тоо ашиглан оруулах боломжтой'),#Төлөвлөгдөж буй хүчин чадал
                'palnned_rate_uom':fields.many2one('product.uom','Planned rate uom'),
                'planned_outside_park':fields.integer('Planned outside park', help=u'Орон сууцны барилгын нийт хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Төлөвлөгдөж буй гадна зогсоолын тоо                            
                'planned_inside_park':fields.integer('Planned inside park', help=u'Төлөвлөгдөж буй гадна зогсоолын тоо хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Төлөвлөгдөж буй дотор зогсоолын тоо                            
                'planned_green_building':fields.float('Planned green building', help=u'Төлөвлөгдөж буй ногоон байгууламжийн хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Төлөвлөгдөж буй  ногоон байгууламж                             
                'planned_sport_square':fields.float('Planned sport square', help=u'Төлөвлөгдөж буй спорт талбай хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Төлөвлөгдөж буй спорт талбай                                    
                'planned_rest_square':fields.float('Planned rest square', help=u'Төлөвлөгдөж буй амрах талбай хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Төлөвлөгдөж буй амрах талбай                                     
                'planned_road':fields.float('Planned road', help=u'Төлөвлөгдөж буй авто зам талбайн хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'), #Төлөвлөгдөж буй авто зам    
                'planned_side_walk':fields.float('Planned site walk', help=u'Төлөвлөгдөж буй явган хүний зам талбайн хэмжээг бүхэл болон бутархай тоо ашиглан оруулах боломжтой'),  #Төлөвлөгдөж буй явган хүний зам                                 
                'country_state':fields.many2one('res.country.state','Country state'),
                'district':fields.char('District'),
                'section':fields.char('Section'),
                'address':fields.char('Address'),
                'phase_id':fields.many2one('project.task.phase','Phase'),
                'work_id':fields.many2one('project.project.task','Work'),
                'technology_guidance':fields.char('Technology guidance'),
                'state': fields.selection([
                        ('draft', 'Draft'),
                        ('work_disposition', 'Work disposition'),
                        ('task', 'Task'),
                        ('check', 'Check'),
                        ('confirm', 'Confirm'),
                        #('inspect', 'Inspect'),
                        ('send_to_project','Send to project')
                        ], 'State', readonly=True, select=True, track_visibility='onchange'),
                'ois_to_building':fields.boolean('Ois to building'),
                }
                
                #track_visibility='always'
    _defaults = {
                 'state': 'draft',
                 }
    
    #===========================================================================
    # def create(self, cr, uid, vals, context=None):
    #     draw_id = super(project_drawing, self).create(cr, uid, vals, context=context)
    #     door = self.pool.get('product.product')
    #     if vals.get('building_id') and vals.get('door_floor') and vals.get('door_entrance') and vals.get('door_type'):
    #         door_id = door.browse(cr, uid, door.search(cr, uid, [('')]))
    #     
    #     return draw_id
    #===========================================================================

    
    def action_cancel_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True

    def action_to_work_disposition(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'work_disposition'})
        return True
    
    def action_to_task(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'task'})
        return True
    
    def action_to_check(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]  
        self.write(cr, uid, ids, {'state': 'check'})
        return True
    
    def action_to_confirm(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'confirm'})
        return True
    
    #===========================================================================
    # def action_to_inspect(self, cr, uid, ids, context=None):
    #     self.write(cr, uid, ids, {'state': 'inspect'})
    #     return True
    #===========================================================================
    
    def action_to_send_to_project(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'send_to_project'})
        return True
    
    def onchange_building_id(self, cr, uid, ids, building_id, type, context=None):
        res = {}
        
        #raise osv.except_osv(("ffffffffffff!"), ("Та <<Зургийн төрөл>> -г сонгосны дараа энэ үйлдлийг хийх боломжтой!"))
        if building_id != False:
            if type in 'ba,bb,has,tsbu,hd,dg_ht':
                building_obj = self.pool.get('building.building')
                bld_id = building_obj.search(cr, uid, [('id','=',building_id)])
                bld = building_obj.browse(cr, uid, bld_id)
                
                res['ois_length']=bld.ois_length
                res['ois_width']=bld.ois_width
                res['inside_wall_length']=bld.inside_wall_length
                res['inside_wall_width']=bld.inside_wall_width
                res['outside_wall_length']=bld.outside_wall_length
                res['outside_wall_width']=bld.outside_wall_width
                res['building_heigth']=bld.building_heigth
                res['building_floor_number']=bld.building_floor_number
                res['building_door_number']=bld.building_door_number
                #return {'value':res}
        else:
            res['ois_length']=0
            res['ois_width']=0
            res['inside_wall_length']=0
            res['inside_wall_width']=0
            res['outside_wall_length']=0
            res['outside_wall_width']=0
            res['building_heigth']=0
            res['building_floor_number']=0
            res['building_door_number']=0
            res['ois_to_building']=False
        return {'value':res}
        #return res
    
    def create(self, cr, uid, vals, context=None):
        context = dict(context or {})
        
        if vals['ois_to_building'] == True:
            #Herwee building_id baiwal hiih vildel
            if vals['building_id']:
                building_obj = self.pool.get('building.building')
                bld_id = building_obj.search(cr, uid, [('id','=',vals['building_id'])])
                #bld = building_obj.browse(cr, uid, bld_id)
                
                building_obj.write(cr, uid, bld_id,{
                                'ois_length':vals['ois_length'],
                                'ois_width':vals['ois_width'],
                                'inside_wall_length':vals['inside_wall_length'],
                                'inside_wall_width':vals['inside_wall_width'],
                                'outside_wall_length':vals['outside_wall_length'],
                                'outside_wall_width':vals['outside_wall_width'],
                                'building_heigth':vals['building_heigth'],
                                'building_floor_number':vals['building_floor_number'],
                                'building_door_number':vals['building_door_number'],
                                 })
                
            #Herwee building_id baihgvi bol hiih vildel
            else:
                raise osv.except_osv(("Анхааруулга!"), ("Та <<Барилгын дугаарт ойсын мэдээллийг шинэчлэх>> -талбарын сонголтыг буцаана уу! Барилгын дугаар байхгүй тул шинэчлэх үйлдэл хийгдэхгүй"))
        
        project_drawing_id = super(project_drawing, self).create(cr, uid, vals, context=context)
        return project_drawing_id
    
    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid, ids)[0]
        building_id = ''
        change = self.pool.get('drawing.change')
        logged_emp = self.pool.get('hr.employee').search(cr, uid, [('user_id', '=', uid)], context=context)
        lemp = self.pool.get('hr.employee').browse(cr, uid, logged_emp)
        if vals.get('comment'):
            if obj.state != 'draft':
                change.create(cr, uid, {
                                'change_employee': lemp.id,
                                'edited_date': time.strftime('%Y-%m-%d'),
                                'comment': vals['comment'],
                                'draw_id': obj.id,
                                 })
        ois_length = 0.0
        ois_width = 0.0
        inside_wall_length = 0.0
        inside_wall_width = 0.0
        outside_wall_length = 0.0
        outside_wall_width = 0.0
        building_heigth = 0.0
        building_floor_number = 0
        building_door_number = 0
        #ois_to_building -g vnen esehiig shalgah
        ois_to_building = ''
        if 'ois_to_building' in vals:
            ois_to_building = vals['ois_to_building']
        else:
            ois_to_building = obj.ois_to_building
        if ois_to_building == True:
            #building_id -d obj eswel vals-n alin bolohiig togtooj utga ogoh
            if 'building_id' in vals:
                building_id = vals['building_id']
            else:
                building_id = obj.building_id.id
        
            #Herwee building_id baiwal hiih vildel
            if building_id:
                building_obj = self.pool.get('building.building')
                bld_id = building_obj.search(cr, uid, [('id','=',building_id)])
                #bld = building_obj.browse(cr, uid, bld_id)
                if 'ois_length' in vals:
                    ois_length = vals['ois_length']
                else:
                    ois_length = obj.ois_length
                if 'ois_width' in vals:
                    ois_width = vals['ois_width']
                else:
                    ois_width = obj.ois_width
                if 'inside_wall_length' in vals:
                    inside_wall_length = vals['inside_wall_length']
                else:
                    inside_wall_length = obj.inside_wall_length
                if 'inside_wall_width' in vals:
                    inside_wall_width = vals['inside_wall_width']
                else:
                    inside_wall_width = obj.inside_wall_width
                if 'outside_wall_length' in vals:
                    outside_wall_length = vals['outside_wall_length']
                else:
                    outside_wall_length = obj.outside_wall_length
                if 'outside_wall_width' in vals:
                    outside_wall_width = vals['outside_wall_width']
                else:
                    outside_wall_width = obj.outside_wall_width
                if 'building_heigth' in vals:
                    building_heigth = vals['building_heigth']
                else:
                    building_heigth = obj.building_heigth
                if 'building_floor_number' in vals:
                    building_floor_number = vals['building_floor_number']
                else:
                    building_floor_number = obj.building_floor_number
                if 'building_door_number' in vals:
                    building_door_number = vals['building_door_number']
                else:
                    building_door_number = obj.building_door_number
                building_obj.write(cr, uid, bld_id,{
                                'ois_length':ois_length,
                                'ois_width':ois_width,
                                'inside_wall_length':inside_wall_length,
                                'inside_wall_width':inside_wall_width,
                                'outside_wall_length':outside_wall_length,
                                'outside_wall_width':outside_wall_width,
                                'building_heigth':building_heigth,
                                'building_floor_number':building_floor_number,
                                'building_door_number':building_door_number,
                                 })
                
            #Herwee building_id baihgvi bol hiih vildel
            else:
                raise osv.except_osv(("Анхааруулга!"), ("Та <<Барилгын дугаарт ойсын мэдээллийг шинэчлэх>> -талбарын сонголтыг буцаана уу! Барилгын дугаар байхгүй тул шинэчлэх үйлдэл хийгдэхгүй"))
            
        return super(project_drawing, self).write(cr, uid, ids, vals, context=context)
    
    
class drawing_type(osv.osv):
    _name = 'drawing.type'
    _description = "NCD project drawing type"
    _columns = {
                'name':fields.char('Door type'),
                }

        
class drawing_change(osv.osv):
    _name = 'drawing.change'
    _description = "NCD project drawing change"
    _columns = {
                'change_employee':fields.many2one('hr.employee','Changed Employee'),
                'edited_date':fields.date('Edited date'),
                'comment':fields.text('Comment'),
                'draw_id': fields.many2one('project.drawing', 'Project Draw'),
                }

class drawing_author(osv.osv):
    _name = 'drawing.author'
    _description = "Authors"
    _columns = {
                'issue':fields.char('Issue'),
                'issue_date':fields.date('Issue date'),
                'solution':fields.char('Solution'),
                'solution_date': fields.date('Solution date'),
                'draw_id': fields.many2one('project.drawing', 'Project Draw'),
                }
    
class sold_space(osv.osv):
    _name = 'sold.space'
    _description = "Sold space"
    _columns = {
                'name':fields.float('Sold space'),
                'sold_space_id':fields.many2one('project.drawing','sold_out_space',invisible=True, readonly = True),
                }
    
class total_space(osv.osv):
    _name = 'total.space'
    _description = "Total space"
    _columns = {
                'name':fields.float('Total space'),
                'total_space_id':fields.many2one('project.drawing','total_square_building',invisible=True, readonly = True),
                }    
    
    
class bnbd_standart(osv.osv):
        _name = 'bnbd.standart'
        _description = "BNBD standart"
        _columns = {
                'name':fields.char('BNBD standart'),
                'bnbd_standart_id':fields.many2one('project.drawing','.',invisible=True, readonly = True),
                }       