# -*- coding: utf-8 -*-

from openerp import models
from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp



class pcd_attachment(models.Model):
    _name = 'pcd.attachment'
    #PCD - pre contract draw
    _description = "PCD attachment"
    _columns = {
                #'image_main':fields.binary('Image main',store = True),
                'image_main':fields.many2many('ir.attachment','pcd_im_rel', 'pcd_id', 'pcd_im_id','Image main', attachment=True),
                'date':fields.date('Date'),
                'attachment_id':fields.many2one('pre.contract.draw', 'PCD'),
    }
    _defaults = {
                 'date': lambda self, cr, uid, context: fields.date.today(),
                 }

class pre_contract_draw(models.Model):
    _name = 'pre.contract.draw'
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    #_description = "Pre contract draw"
    _columns = {
                'name':fields.char('Contract name'),
                'code':fields.char('Contract code'),
                'start_date':fields.date('Start date'),
                'end_date':fields.date('End date'),
                'partner_id':fields.many2one('res.partner','Partner'),
                'project_id':fields.many2one('project.project', 'Project'),
                # 'type':fields.selection([
                #                          ('sketch','Sketch'),#Эскиз зураг,
                #                          ('ba','BA'),#Барилга архитектур АЗ
                #                          ('bb','BB'),#Барилга бүтээц АЗ
                #                          ('has','HAS'),#Халаалт агаар сэлгэлт АЗ
                #                          ('tsbu','TsBU'),#Цэвэр бохир ус АЗ
                #                          ('hd','HD'),#Холбоо дохиолол АЗ
                #                          ('dg_ht','DG,HT'),#Дотор гэрэлтүүлэг, Хүчит төхөөрөмж АЗ
                #                          ('out_warm','Out warm'),#Гадна дулаан
                #                          ('out_electric','Out electric'),#Гадна цахилгаан
                #                          ('out_sanitation','Out sanitation'),#Гадна цэвэр бохир
                #                          ('out_signal','Out signal'),#Гадна холбоо дохиолол
                #                          ('out_appointment','Out appointment'),#Гадна тохижилт
                #                          ('in_design','In design'),#Интерьер дизайн
                #                          ('technology_guidance','Technology guidance'),#Технологийн заавар
                #                          ('brochure','Brochure'),#Танилцуулга, брошур
                #                          ('contract_attachment','Contract attachment'),#Гэрээний хавсралт
                #                          ('project_detail','Project detail'),#Төслийн дэлгэрэнгүй мэдээлэл
                #                          ('general_plan','General plan'),#Ерөнхий төлөвлөгөө
                #                          ('elevation','Elevation'),#Өндөржилт
                #                          ('background_mapping','Background mapping'),#Дэвсгэр зураг
                #                          ('geological_conclusions','Geological conclusions'),#Геологийн дүгнэлт
                #                          ],'Type',help=u'Choose type of design', required=True),#Төрөл
                
                'attachment_ids':fields.one2many('pcd.attachment', 'attachment_id', 'PCD attachments'),#Хавсралтууд
                
                'state': fields.selection([
                    ('new', 'New'),
                    ('process', 'Process'),
                    ('closed', 'Closed'),
                    ], 'State'),
                
                #changed
                'user_ids':fields.many2many('res.users','pcd_user_rel', 'pcd_u_id', 'pcd_user_id','Users'),#Хамаатай ажилчид
                'duration':fields.char('Duration'),#Үргэлжлэх хугацаа
                'type_id':fields.many2one('pcd.contract.type','Type'),#Төрөл
                'performance_act':fields.boolean('Performance act'),#Гүйцэтгэл акт хийсэн эсэх
                'is_handovered':fields.boolean('Is handovered'),#Зураг хүлээлгэж өгсөн эсэх
                'handovered_size':fields.integer('Handovered size'),#Хэмжээ
                'contractor_id':fields.many2one('pcd.contractor','PCD contractor'),#Гэрээлэгч
    }
    _defaults = {
                 'state': 'new',
                 }
    #===========================================================================
    # _sql_constraints = [
    #     ('project_id', 'unique (project_id)', u' Энэ төсөлд дэлгэрэнгүй мэдээлэл бүртгэсэн байна! Дэлгэрэнгүй мэдээллийг нэг төсөлд нэг л удаа бүртгэх боломжтой')
    # ]
    #===========================================================================
    
    

    def action_to_new(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'new'})
        return True

    def action_to_process(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'process'})
        return True

    def action_to_closed(self, cr, uid, ids, context=None):
        #=======================================================================
        # sale_line_info = 0
        # for record in self.browse(cr, uid, ids, context=context):
        #     if record.block_info_id:
        #         for block_line in record.block_info_id:
        #             print  'ooooo', block_line.type_id.id
        #             if record.block_sales_id:
        #                 for sales_line in record.block_sales_id:
        #                     if sales_line.type_id.id == block_line.type_id.id:
        #                         print 'mmmmmmmmmmmmmmmm'
        #                         sale_line_info += sales_line.households_square
        #                         print 'kkkkkkkkk', sale_line_info
        #                       
        #                 block_line.block_total_square=sale_line_info
        #             sale_line_info = 0
        #     else:
        #         pass
        #=======================================================================
        self.write(cr, uid, ids, {'state': 'closed'})
        
        return True
    


class pcd_contract_type(models.Model):
    _name = 'pcd.contract.type'
    #PCD - pre contract draw type
    #_description = "PCD contract type"
    _columns = {
                'name':fields.char('Name'),
    }

class pcd_contractor(models.Model):
    _name = 'pcd.contractor'
    #PCD - pre contractor draw
    #_description = "PCD contractor type"
    _columns = {
                'name':fields.char('Name'),
    }
    
    
    