# -*- coding: utf-8 -*-

from openerp import models
from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp

class tbab_author(models.Model):
    _name = 'tbab.author'
    _description = "Tbab author"
    
        
    def _get_default_employee_id(self, cr, uid, context=None):
        emp_obj = self.pool.get('hr.employee')
        emp_id = emp_obj.search(cr, uid, [('user_id','=',uid)])
        emps = emp_obj.browse(cr, uid, emp_id)
        return emps.id or False
        
    def _get_default_job_id(self, cr, uid, context=None):
        emp_obj = self.pool.get('hr.employee')
        emp_id = emp_obj.search(cr, uid, [('user_id','=',uid)])
        emps = emp_obj.browse(cr, uid, emp_id)
        return emps.job_id.id or False
    
    _columns = {
                'reviewed_date':fields.date('Reviewed date'),#Хяналт хийсэн огноо
                'draw_id':fields.many2one('tbab.request.for.design', 'Draw'),#Зураг
                'project_id':fields.many2one('project.project','Project'),#Төсөл
                'project_phase_id':fields.many2one('project.task.phase', 'Phase'),#Барилгын талбайн ажлын үе шат
                'note':fields.text('Note'),#Хяналт хийсэн тэмдэглэл
                'employee_id':fields.many2one('hr.employee','Employee'),#Ажилтан
                'job_id':fields.many2one('hr.job','Job'),#Албан тушаал
                'state': fields.selection([
                        ('draft', 'Draft'),#Ноорог
                        ('cancelled', 'Cancelled'),#Цуцлагдсан
                        ('approved', 'Approved'),#Батлагдсан
                        ], 'State',),#Төлөв
                
                'draw_defective':fields.text('Draw defective'),#Суурь шалтгаан
                'draw_solution':fields.text('Draw solution'),#Зөрчил арилгах арга зам, шийдэл
                'resolver_id':fields.many2one('hr.employee','Resolver'),#Хариуцсан хүн
                'is_resolved':fields.boolean('Is resolved'),#Арилсан эсэх
                'resolved_date':fields.date('Resolved date'),#Огноо
                
    }
    
    _defaults = {
                 'employee_id':_get_default_employee_id,
                 'job_id':_get_default_job_id,
                 'state': 'draft',
                 }
    
    
    def action_to_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
    def action_to_cancel(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'cancelled'})
    def action_to_approve(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'approved'})
    
    def onchange_draw_id(self, cr, uid, ids, draw_id, context=None):
        res = {}
        if draw_id != None:
            request_obj = self.pool.get('tbab.request.for.design')
            request_id = request_obj.search(cr, uid, [('id','=',draw_id)])
            request = request_obj.browse(cr, uid, request_id)
            res['project_id']=request.project_id.id or False
            res['project_phase_id']=request.project_phase_id.id or False
            return {'value':res}
    
    