# -*- coding: utf-8 -*-

from openerp import models
from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp

class tbab_calendar_event(models.Model):
    _name = 'tbab.calendar.event'
    _description = "Tbab calendar event"
    
    def name_get(self, cr, uid, ids, context=None):
        if isinstance(ids, (list, tuple)) and not len(ids):
            return []
        if isinstance(ids, (long, int)):
            ids = [ids]
        reads = self.read(cr, uid, ids, ['name'], context=context)
        res = []
        for record in reads:
            name = record['name']
            res.append((record['id'], name))
        return res

    
    
    def name_search(self, cr, uid, name, args=None, operator='ilike', context=None, limit=100):
        if args is None:
            args = []
        if context is None:
            context = {}
        ids = []
        if name:
            ids = self.search(cr, uid, [('name', 'ilike', name)] + args, limit=limit)
        return self.name_get(cr, uid, ids, context=context)
    
    def _get_default_employee_id(self, cr, uid, context=None):
        emp_obj = self.pool.get('hr.employee')
        emp_id = emp_obj.search(cr, uid, [('user_id','=',uid)])
        emps = emp_obj.browse(cr, uid, emp_id)
        return emps.id or False
    
    def _get_default_employee_ids(self, cr, uid, context=None):
        emp_obj = self.pool.get('hr.employee')
        emp_id = emp_obj.search(cr, uid, [('user_id','=',uid)])
        emps = emp_obj.browse(cr, uid, emp_id)
        return [(4, emps.id)] or False
    _columns = {
                'name':fields.char('Name', required=True),#Уулзалтын нэр
                'employee_id':fields.many2one('hr.employee','Employee', required=True),#Үүсгэсэн ажилтан
                'employee_ids':fields.many2many('hr.employee','tbab_ce_id','tbab_ce_hr_rel','tbab_calendar_event_id', 'Employees'),#Оролцогчид
                'start_date':fields.datetime('Start date'),#Эхлэх огноо
                'end_date':fields.datetime('End date'),#Дуусах огноо
                'description':fields.text('Description'),#Тайлбар
    }
    _defaults = {
                 'employee_id':_get_default_employee_id,
                 'employee_ids':_get_default_employee_ids,
                 }