# -*- coding: utf-8 -*-

from openerp import models
from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp

class tbab_block_type(models.Model):
    _name = 'tbab.block.type'
    _description = "Tbab block type"
    _columns = {
                'name':fields.char('Name'),
    }

class tbab_block_info(models.Model):
    _name = 'tbab.block.info'
    _description = "Tbab block info"
    
    
    _columns = {
                'type_id':fields.many2one('tbab.block.type', 'Type'),
                'number_of_households':fields.integer('Number of households'),
                'number_of_garages':fields.integer('Number of garages'),
                'info_id':fields.many2one('tbab.more.info.project', 'Info'),
                'basement_total':fields.float('Basement total'),
                'basement_available':fields.float('Basement available'),
                'services':fields.float('Services'),
                'apartment_square':fields.float('Apartment square'),
                'block_total_square':fields.float('Block total square'),
                #'block_total_square': fields.function(_block_total_square, type='integer',string="HH"),
                
    }
    
    _sql_constraints = [
        ('type_id', 'unique (type_id)', u' Энэ Блокын мэдээллийг бүртгэсэн байна! Нэг Блок-д нэг удаа мэдээлэл бүртгэх боломжтой ')
    ]

class tbab_block_sales_info(models.Model):
    _name = 'tbab.block.sales.info'
    _description = "Tbab block sales info"
    _columns = {
                'type_id':fields.many2one('tbab.block.type', 'Type'),
                'households':fields.char('Households'),
                'households_square':fields.float('Households square'),
                'sales_id':fields.many2one('tbab.more.info.project', 'Sales info'),
                
    }

class tmip_attachment(models.Model):
    _name = 'tmip.attachment'
    _description = "TMIP attachment"
    _columns = {
                #'image_main':fields.binary('Image main',store = True),
                'image_main':fields.many2many('ir.attachment','tm_im_rel', 'tm_id', 'tm_im_id','Image main', attachment=True),
                'date':fields.date('Date'),
                'attachment_id':fields.many2one('tbab.more.info.project', 'TMIP'),
                
    }
    _defaults = {
                 'date': lambda self, cr, uid, context: fields.date.today(),
                 }

class tbab_more_info_project(models.Model):
    _name = 'tbab.more.info.project'
    _description = "Tbab more info project"
    _columns = {
                #GENERAL INFO
                'project_id':fields.many2one('project.project', 'Project'),
                'attachment_ids':fields.one2many('tmip.attachment', 'attachment_id', 'TMIP attachments'),#Хавсралтууд
                
                
                'land_area':fields.float('Land area'),
                'building_area':fields.float('Building area'),
                'percent':fields.float('Percent'),
                'number_of_floors':fields.integer('Number of floors'),
                'state': fields.selection([
                    ('draft', 'Draft'),
                    ('cancel', 'Cancel'),
                    ('approve', 'Approve'),
                    ], 'State'),
                #'image_main':fields.many2many('ir.attachment','tmip_im_rel', 'tmip_id', 'tmip_im_id','Image main', attachment=True),#Хавсралт файл
                #BLOCK INFO
                'block_info_id':fields.one2many('tbab.block.info','info_id', 'Block info'),
                #SALES INFO
                'block_sales_id':fields.one2many('tbab.block.sales.info','sales_id', 'Block sales info'),
                'sales_total_square':fields.float('Sales total square'),
                'profit_percent':fields.float('Profit percent'),
                'total_area_wall':fields.float('Total area wall'),
                
    }
    _defaults = {
                 'state': 'draft',
                 }
    _sql_constraints = [
        ('project_id', 'unique (project_id)', u' Энэ төсөлд дэлгэрэнгүй мэдээлэл бүртгэсэн байна! Дэлгэрэнгүй мэдээллийг нэг төсөлд нэг л удаа бүртгэх боломжтой')
    ]
    
    

    def action_to_draft(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True

    def action_to_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'cancel'})
        return True

    def action_to_approve(self, cr, uid, ids, context=None):
        sale_line_info = 0
        for record in self.browse(cr, uid, ids, context=context):
            if record.block_info_id:
                for block_line in record.block_info_id:
                    print  'ooooo', block_line.type_id.id
                    if record.block_sales_id:
                        for sales_line in record.block_sales_id:
                            if sales_line.type_id.id == block_line.type_id.id:
                                print 'mmmmmmmmmmmmmmmm'
                                sale_line_info += sales_line.households_square
                                print 'kkkkkkkkk', sale_line_info
                              
                        block_line.block_total_square=sale_line_info
                    sale_line_info = 0
            else:
                pass
        self.write(cr, uid, ids, {'state': 'approve'})
        
        return True
    
    
    
    
    