# -*- coding: utf-8 -*-

from openerp import models
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta, datetime
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp
from openerp.tools import float_is_zero
from openerp.tools.translate import _

class tbab_request_for_design(models.Model):
    _name = 'tbab.request.for.design'
    #_description = "Tbab request for design"
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    
    def _percents_get(self, cr, uid, ids, field_names, args,vals, context=None):
        res = {}
        cr.execute("SELECT draw_id, COALESCE(SUM(percent),0) FROM draw_performance_info WHERE draw_id IN %s GROUP BY draw_id",(tuple(ids),))
        percent = dict(cr.fetchall())
        for task in self.browse(cr, uid, ids, context=context):
            if percent.get(task.id, 0.0) > 100.0:
                raise osv.except_osv(_('Алдаа!'),_("Гүйцэтгэлийн хувь талбарын нийлбэр 100-с их байж болохгүй!"))
            elif percent.get(task.id, 0.0) < 0.0:
                raise osv.except_osv(_('Алдаа!'),_("Гүйцэтгэлийн хувь талбарын нийлбэр 0-с бага байж болохгүй!"))
            elif percent.get(task.id, 0.0) == 100.0:
                res[task.id] = {'progress': 99.0}
            elif task.state == 'send_to_project':
                res[task.id] = {'progress': 100.0}
            else:
                res[task.id] = {'progress': percent.get(task.id, 0.0)}
        return res
    
    def copy(self, cr, uid, id, default=None, context=None): 
        raise osv.except_osv(_('Warning!'),_("Duplicate is not allowed"))
    
    _columns = {
                #Ерөнхий хэсэг
                'name':fields.char('Name',copy=False),#Request design order number - Захиалгын дугаар
                'final_picture':fields.many2many('ir.attachment','trfd_fp_rel', 'fp_id', 'trfd_fp_id','Final picture'),#Батлагдсан зураг
                'parent_id':fields.many2one('tbab.request.for.design','Parent'),#Эхний хувилбар
                'state': fields.selection([
                        ('draft', 'Draft'),#Ноорог
                        ('request', 'Request'),#Хүсэлт
                        ('distribution', 'Distribution'),#Хуваарилалт
                        ('performance', 'Performance'),#Гүйцэтгэл
                        ('closed', 'Closed'),#Дууссан
                        ('send_to_project','Send to project'),#Төсөлд өгсөн
                        ('stand_by', 'Stand by'),#Түр зогссон
                        ('cancelled', 'Cancelled'),#Цуцлагдсан
                        ], 'State', track_visibility='onchange'),#Төлөв
                'progress': fields.function(_percents_get, string='Progress', multi='hours', group_operator="avg",type='float',
                    help="If the task has a progress of 99.99% you should close the task if it's finished or reevaluate the time",
                    store = True),
                'is_electronic':fields.boolean('Is electronic'),#Цахимаар өгсөн
                'is_printed':fields.boolean('Is printed'),#Хэвлэмэлээр өгсөн
                
                #Хүсэлтийн хэсэг
                'project_id':fields.many2one('project.project','Project'),#Төсөл
                'project_phase_id':fields.many2one('project.task.phase','Phase'),#Төслийн үе шат
                'user_id':fields.many2one('res.users','User', required=True),#Хүсэлт гаргаж буй ажилтан
                'department_id':fields.many2one('hr.department','Department'),#Хүлээн авах алба, нэгж
                'type':fields.selection([
                                         ('sketch','Sketch'),#Эскиз зураг,
                                         ('ba','BA'),#Барилга архитектур АЗ
                                         ('bb','BB'),#Барилга бүтээц АЗ
                                         ('has','HAS'),#Халаалт агаар сэлгэлт АЗ
                                         ('tsbu','TsBU'),#Цэвэр бохир ус АЗ
                                         ('hd','HD'),#Холбоо дохиолол АЗ
                                         ('dg_ht','DG,HT'),#Дотор гэрэлтүүлэг, Хүчит төхөөрөмж АЗ
                                         ('out_warm','Out warm'),#Гадна дулаан
                                         ('out_electric','Out electric'),#Гадна цахилгаан
                                         ('out_sanitation','Out sanitation'),#Гадна цэвэр бохир
                                         ('out_signal','Out signal'),#Гадна холбоо дохиолол
                                         ('out_appointment','Out appointment'),#Гадна тохижилт
                                         ('in_design','In design'),#Интерьер дизайн
                                         ('technology_guidance','Technology guidance'),#Технологийн заавар
                                         ('brochure','Brochure'),#Танилцуулга, брошур
                                         ('contract_attachment','Contract attachment'),#Гэрээний хавсралт
                                         ('project_detail','Project detail'),#Төслийн дэлгэрэнгүй мэдээлэл
                                         ('general_plan','General plan'),#Ерөнхий төлөвлөгөө
                                         ('elevation','Elevation'),#Өндөржилт
                                         ('background_mapping','Background mapping'),#Дэвсгэр зураг
                                         ('geological_conclusions','Geological conclusions'),#Геологийн дүгнэлт
                                         ],'Type',help=u'Choose type of design', required=True),#Төрөл
                'image_description': fields.char("Image description", required=True),#Зургийн тайлбар
                'image_example': fields.boolean("Image example"),#Жишээ зураг
                
                'image_main': fields.binary("Image main"),
                'image_2': fields.binary("Image 2"),
                'image_3': fields.binary("Image 3"),
                'design_type':fields.selection([
                                         ('3d_render','3D render'),#3D рендер
                                         ('ceiling_work_drawings','Ceiling work drawings'),#Таазны ажлын зураг
                                         ('wall_photoshop','Wall photoshop'),#Ханын дэлгээс
                                         ('plita_photoshop','Plita photoshop'),#Плитаны дэлгээс
                                         ('floor_work_drawings','Floor work drawings'),#Шалны ажлын зураг
                                         ('furniture_drawings','Furniture drawings'),#Тавилгын зураг
                                         ('material_selection','Material selection'),#Материал сонголт
                                         ],'Design type'),#Интерьерийн төрөл
                'brochure_type':fields.selection([
                                         ('3d_exteriors','3D exteriors'),#3D экстерьер
                                         ('3d_interiors','3D interiors'),#3D интерьер
                                         ('2d_plan','2D plan'),#2D план
                                         ('3d_plan','3D plan'),#3D план
                                         ('3d_selection','3D selection'),#Сонголтын 3D
                                         ],'Brochure type'),#Брошурын төрөл
                'drawings_type':fields.selection([
                                         ('work_drawings','Work drawings'),#Ажлын зураг
                                         ('site_drawings','Site drawings'),#Талбайн зураг
                                         ],'Drawings type'),#Зургийн зориулалт
                'architectural_planning_assignment':fields.many2many('ir.attachment','trfd_apa_rel', 'trfd_id', 'trfd_apa_id','Architectural planning assignment', attachment=True),#Архитектур төлөвлөлтийн даалгавар
                'certificate_land_possession':fields.many2many('ir.attachment','trfd_clp_rel', 'clp_id', 'trfd_clp_id','Certificate land possession'),#Газар эзэмших гэрчилгээ
                'cadastral_mapping':fields.many2many('ir.attachment','trfd_cm_rel', 'cm_id', 'trfd_cm_id','Cadastral mapping'),#Кадастрын зураглал
                'background_mapping':fields.many2many('ir.attachment','trfd_bm_rel', 'bm_id', 'trfd_bm_id','Background mapping'),#Дэвсгэр зураг
                'elevation':fields.many2many('ir.attachment','trfd_e_rel', 'e_id', 'trfd_e_id','Elevation'),#Өндөржилт
                'address_location':fields.char('Address location'),#Хаяг байршил
                'project_research':fields.char('Project research'),#Төслийн судалгаа
                'project_purpose':fields.char('Project purpose'),#Төслийн зориулалт
                'engineering_lines':fields.char('Engineering lines'),#Инженерийн шугам сүлжээ
                'geological_conclusions':fields.char('Geological conclusions'),#Геологийн дүгнэлт
                'ordered_date':fields.date('Ordered date'),#Зургийн захиалга бүрэн өгсөн огноо
                'end_date':fields.date('End date'),#Зургийн захиалга дуусах огноо
                'justification':fields.char('Justification'),#Зураг төсөл боловсруулах үндэслэл
                'building_grades':fields.char('Building grades'),#Барилгын зэрэглэл
                'design_trends':fields.char('Design trends'),#Дизайны чиг хандлага
                'creation_selection':fields.char('Creation selection'),#Бүтээцийн сонголт
                'material_selection':fields.char('Material selection'),#Материалын сонголт
                'furniture_selection':fields.char('Furniture selection'),#Тавилгын сонголт
                'equipment_selection':fields.char('Equipment selection'),#Тоноглолын сонголт
                'equipment_selection_date':fields.date('Equipment selection date'),#Тоноглолын сонголт хийгдсэн огноо
                'special_conditions':fields.text('Special conditions'),#Тусгай нөхцөл, шаардлага
                
                'construction_purpose':fields.char('Construction purpose'),#Барилгын зориулалт
                'capacity':fields.char('Capacity'),#Хүчин чадал
                
                
                #Хуваарилалтын хэсэг
                'distribution_type':fields.selection([('internal','Internal'),#Дотоод ажилтнаар
                                         #('in_architecture','In architecture'),
                                         ('external','External')],#Гадны байгууллагаар
                                        'Distribution type'),#Хуваарилалтын төрөл
                'partner_company':fields.many2one('res.partner','Partner company'),#Гүйцэтгэгч байгууллага
                'partner_employee':fields.char('Partner employee'),#Хариуцсан хүн
                'reviewer_id':fields.many2one('hr.employee','Reviewer'),#Хянагч ажилтан
                'partner_phone':fields.char('Partner phone'),#Утас
                'partner_email':fields.char('Partner email'),#И-мэйл
                'employee_id':fields.many2one('hr.employee','Employee'),#Гүйцэтгэгч ажилтан
                'planned_start_date':fields.date('Planned start date'),#Эхлэхээр төлөвлөсөн огноо
                'planned_end_date':fields.date('Planned end date'),#Дуусахаар төлөвлөсөн огноо
                'distributed_employee':fields.many2one('hr.employee','Distributed employee'),#Хуваарилсан ажилтан
                'distributed_employee_job':fields.many2one('hr.job','Distributed employee job'),#Хуваарилсан ажилтны албан тушаал
                #Гүйцэтгэлийн хэсэг
                'performance_id':fields.one2many('draw.performance.info','draw_id','Performance'),#Гүйцэтгэлийн мөр
                'eg_cipher':fields.char('EG cipher'),#ЕГ шифр
                'tg_cipher':fields.char('TG cipher'),#ТГ шифр
                'note':fields.text('Note'),#Нэмэлт тайлбар
                'approved_employee':fields.many2one('hr.employee','Approved employee'),#Баталсан ажилтан
                'approved_employee_job':fields.many2one('hr.job','Approved employee job'),#Баталсан ажилтны албан тушаал
                'approved_date':fields.date('Approved date'),#Баталсан огноо
                'timeout': fields.integer('Хугацааны хэмнэлт, хэтрэлт'),
                #Мэйл илгээхэд автоматжуулалтын хэсэг
                'user_mail_created':fields.boolean('UMC'),#Хүсэлт гаргаж буй ажилтанд мэйл илгээсэн эсэх
                'employee_mail_created':fields.boolean('EMC'),#Гүйцэтгэгч ажилтанд мэйл илгээсэн эсэх
                'distributed_employee_mail_created':fields.boolean('DEMC'),#Хуваарилсан ажилтанд мэйл илгээсэн эсэх
                'state_mail_created':fields.boolean('SMC'),#Төлвийн өөрчлөлтөд мэйл үүссэн эсэх
                'performance_updated_mail_created':fields.boolean('PUMC'),#Гүйцэтгэл оруулахад мэйл үүссэн эсэх
                'partner_mail_created':fields.boolean('PMC'),#Дагагчдад мэйл илгээсэн
                
                'state_id_before': fields.selection([('draft', 'Ноорог'),
                                                  ('request', 'Хүсэлт'),
                                                  ('distribution', 'Хуваарилалт'),
                                                  ('performance', 'Гүйцэтгэл'),
                                                  ('closed', 'Дууссан'),
                                                  ('send_to_project', 'Батлагдсан'),
                                                  ('stand_by', 'Түр зогссон'),
                                                  ('cancelled', 'Цуцлагдсан')], 'Өмнөх төлөв'),
                
                #'have_planned_end_date':fields.boolean('Have planned end date'),#Дуусахаар төлөвлөсөн огноо байгаа эсэх
                }
    _defaults = {
                 'name': lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'tbab.request.for.design'),
                 'user_id':lambda self, cr, uid, context: uid,
                 'state': 'draft',
                 'total_percents': 100.0,
                 'state_id_before': 'draft',
                 #'have_planned_end_date': False,
                 }
    
    def action_to_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
    def action_to_request(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'request', 'ordered_date': date.today()})
    def action_to_performance(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'performance'})
    def action_to_distribution(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)
        emp_obj_id = self.pool.get('hr.employee').search(cr,uid,[('user_id','=', uid)])
        emp_info = self.pool.get('hr.employee').browse(cr,uid,emp_obj_id)
        print 'aaaaaaaa', emp_obj_id, emp_info
        self.write(cr, uid, ids, {'state': 'distribution',
                                  'distributed_employee': emp_info.id,
                                  'distributed_employee_job': emp_info.job_id.id,
                                  })
        return True
    def action_to_redistribution(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'request'})
        
        #self.write(cr, uid, ids, {'state': 'distribution'})
    def action_to_closed(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'closed'})
    def action_send_to_project(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)
        emp_obj_id = self.pool.get('hr.employee').search(cr,uid,[('user_id','=', uid)])
        emp_info = self.pool.get('hr.employee').browse(cr,uid,emp_obj_id)
        if obj.planned_end_date:
        	aaaa = datetime.strptime(obj.planned_end_date, '%Y-%m-%d')
        	bb = aaaa.date() - date.today()
        	cc = bb.days
        else:
        	aaaa = date.today()
        	cc = 0
        self.write(cr, uid, ids, {'state': 'send_to_project',
                                  'approved_employee': emp_info.id,
                                  'approved_employee_job': emp_info.job_id.id,
                                  'approved_date': date.today(),
                                  'planned_end_date': date.today(),
                                  'timeout': cc,
                                  })
        return True
    def action_to_stand_by(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'stand_by'})
    def action_to_cancelled(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'cancelled'})
    def onchange_distribution_type(self, cr, uid, ids, distribution_type, context=None):
        res = {}
        if distribution_type == 'internal':
            res['partner_company']= False
            res['partner_employee']= None
        elif distribution_type == 'external':
            res['employee_id']= False
        return {'value':res}
    
    def onchange_type(self, cr, uid, ids, type, context=None):
        res = {}
        img_obj = self.pool.get('tbab.type.image').search(cr,uid,[('type','=',type)])
        if img_obj:
            img_id = self.pool.get('tbab.type.image').browse(cr,uid,img_obj)
            if img_id.type == 'sketch':
                res['image_main'] = img_id.image_main
                res['image_2'] = img_id.image_2
                res['image_3'] = img_id.image_3
            else:
                res['image_main'] = img_id.image_main
        else:
            res['image_main'] = None
            res['image_2'] = None
            res['image_3'] = None
            
        return {'value':res}
    
    
    def onchange_parent_id(self, cr, uid, ids, parent_id, context=None):
        obj = self.browse(cr, uid,ids)
        res = {}
        context = dict(context or {})
        print 'yyyyyyy', parent_id
        par_obj = self.pool.get('tbab.request.for.design').search(cr,uid,[('id','=',parent_id)])
        parent_id = self.pool.get('tbab.request.for.design').browse(cr,uid,par_obj)
        print 'ddddddddddddddd', parent_id
        if parent_id:
            res['project_id'] = parent_id.project_id.id or False
            res['project_phase_id'] = parent_id.project_phase_id.id or False
            res['user_id'] = parent_id.user_id.id or False
            res['department_id'] = parent_id.department_id.id or False
            res['type'] = parent_id.type
            res['image_main'] = parent_id.image_main or False
            res['image_2'] = parent_id.image_2 or False
            res['image_3'] = parent_id.image_3 or False
            res['design_type'] = parent_id.design_type or False
            res['brochure_type'] = parent_id.brochure_type or False
            res['drawings_type'] = parent_id.drawings_type or False
            res['geological_conclusions'] = parent_id.geological_conclusions or False
            res['engineering_lines'] = parent_id.engineering_lines or False
            res['project_research'] = parent_id.project_research or False
            res['project_purpose'] = parent_id.project_purpose or False
            res['building_grades'] = parent_id.building_grades or False
            res['construction_purpose'] = parent_id.construction_purpose or False
            res['capacity'] = parent_id.capacity or False
            res['address_location'] = parent_id.address_location or False
            res['justification'] = parent_id.justification or False
            res['design_trends'] = parent_id.design_trends or False
            res['creation_selection'] = parent_id.creation_selection or False
            res['material_selection'] = parent_id.material_selection or False
            res['furniture_selection'] = parent_id.furniture_selection or False
            res['equipment_selection'] = parent_id.equipment_selection or False
            res['equipment_selection_date'] = parent_id.equipment_selection_date or False
            res['ordered_date'] = date.today()
            
        return {'value':res}
    
    #Hereglehgvi bgaa onchange - onchange_ped....... Daraa ereg bolwol ashiglana
    def onchange_ped(self, cr, uid, ids, planned_end_date, context=None):
        res = {}
        if planned_end_date:
            res['have_planned_end_date'] = True
        else:
            res['have_planned_end_date'] = False
        return {'value':res}

    def create(self, cr, uid, vals, context=None):
        
        context = dict(context or {})
        req_obj = self.pool.get('tbab.request.for.design')
        
        if 'type' in vals:
            if vals['type'] == 'sketch':
                #===============================================================
                # if 'architectural_planning_assignment' in vals:
                #     if vals['architectural_planning_assignment'] == [[6, False, []]]:
                #         raise osv.except_osv(_('Анхаар!'),_("Архитектур төлөвлөлтийн даалгавар талбарт заавал зураг оруулна уу!"))
                #===============================================================
                if 'certificate_land_possession' in vals:
                    if vals['certificate_land_possession'] == [[6, False, []]]:
                        raise osv.except_osv(_('Анхаар!'),_("Газар эзэмших гэрчилгээ - талбарт заавал зураг оруулна уу!"))
                if 'cadastral_mapping' in vals:
                    if vals['cadastral_mapping'] == [[6, False, []]]:
                        raise osv.except_osv(_('Анхаар!'),_("Кадастрын зураглал - талбарт заавал зураг оруулна уу!"))
                #===============================================================
                # if 'background_mapping' in vals:
                #     if vals['background_mapping'] == [[6, False, []]]:
                #         raise osv.except_osv(_('Анхаар!'),_("Дэвсгэр зураг - талбарт заавал зураг оруулна уу!"))
                #===============================================================
            #if vals['type'] != ('sketch,elevation,background_mapping,geological_conclusions,project_detail,technology_guidance,contract_attachment'):
            elif vals['type'] == 'ba' or vals['type'] == 'bb' or vals['type'] == 'has' or vals['type'] == 'tsbu' or vals['type'] == 'hd' or vals['type'] == 'dg_ht':
                if 'drawings_type' in vals:
                    if vals['drawings_type'] == False:
                        raise osv.except_osv(_('Анхаар!'),_("Зургийн зориулалт - талбарт заавал утга сонгоно уу!"))
                elif obj.drawings_type == False:
                    raise osv.except_osv(_('Анхаар!'),_("Зургийн зориулалт - талбарт заавал утга сонгоно уу!"))
        
        task_id = super(tbab_request_for_design, self).create(cr, uid, vals, context=None)
        #self._store_history(cr, uid, [task_id], context=context)
        return task_id
    
    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid,ids)
        if context is None:
            context = {}
        
        if 'type' in vals:
            if vals['type'] == 'sketch':
                #===============================================================
                # if 'architectural_planning_assignment' in vals:
                #     if vals['architectural_planning_assignment'] == [[6, False, []]]:
                #         raise osv.except_osv(_('Анхаар!'),_("Архитектур төлөвлөлтийн даалгавар - талбарт заавал зураг оруулна уу!"))
                # elif not obj.architectural_planning_assignment:
                #     raise osv.except_osv(_('Анхаар!'),_("Архитектур төлөвлөлтийн даалгавар талбарт заавал зураг оруулна уу!"))
                #===============================================================
                if 'certificate_land_possession' in vals:
                    if vals['certificate_land_possession'] == [[6, False, []]]:
                        raise osv.except_osv(_('Анхаар!'),_("Газар эзэмших гэрчилгээ - талбарт заавал зураг оруулна уу!"))
                elif not obj.certificate_land_possession:
                    raise osv.except_osv(_('Анхаар!'),_("Газар эзэмших гэрчилгээ - талбарт заавал зураг оруулна уу!"))
                if 'cadastral_mapping' in vals:
                    if vals['cadastral_mapping'] == [[6, False, []]]:
                        raise osv.except_osv(_('Анхаар!'),_("Кадастрын зураглал - талбарт заавал зураг оруулна уу!"))
                elif not obj.cadastral_mapping:
                    raise osv.except_osv(_('Анхаар!'),_("Кадастрын зураглал - талбарт заавал зураг оруулна уу!"))
                #===============================================================
                # if 'background_mapping' in vals:
                #     if vals['background_mapping'] == [[6, False, []]]:
                #         raise osv.except_osv(_('Анхаар!'),_("Дэвсгэр зураг - талбарт заавал зураг оруулна уу!"))
                # elif not obj.background_mapping:
                #     raise osv.except_osv(_('Анхаар!'),_("Дэвсгэр зураг - талбарт заавал зураг оруулна уу!"))
                #===============================================================
            elif vals['type'] == 'ba' or vals['type'] == 'bb' or vals['type'] == 'has' or vals['type'] == 'tsbu' or vals['type'] == 'hd' or vals['type'] == 'dg_ht':
                if 'drawings_type' in vals:
                    if vals['drawings_type'] == False:
                        raise osv.except_osv(_('Анхаар!'),_("Зургийн зориулалт - талбарт заавал утга сонгоно уу!"))
                elif obj.drawings_type == False:
                    raise osv.except_osv(_('Анхаар!'),_("Зургийн зориулалт - талбарт заавал утга сонгоно уу!"))
        elif obj.type == 'sketch':
            #===================================================================
            # if 'architectural_planning_assignment' in vals:
            #     if vals['architectural_planning_assignment'] == [[6, False, []]]:
            #         raise osv.except_osv(_('Анхаар!'),_("Архитектур төлөвлөлтийн даалгавар - талбарт заавал зураг оруулна уу!"))
            #===================================================================
            if 'certificate_land_possession' in vals:
                if vals['certificate_land_possession'] == [[6, False, []]]:
                    raise osv.except_osv(_('Анхаар!'),_("Газар эзэмших гэрчилгээ - талбарт заавал зураг оруулна уу!"))
            if 'cadastral_mapping' in vals:
                if vals['cadastral_mapping'] == [[6, False, []]]:
                    raise osv.except_osv(_('Анхаар!'),_("Кадастрын зураглал - талбарт заавал зураг оруулна уу!"))
            #===================================================================
            # if 'background_mapping' in vals:
            #     if vals['background_mapping'] == [[6, False, []]]:
            #         raise osv.except_osv(_('Анхаар!'),_("Дэвсгэр зураг - талбарт заавал зураг оруулна уу!"))
            #===================================================================
        elif obj.type == 'ba' or obj.type == 'bb' or obj.type == 'has' or obj.type == 'tsbu' or obj.type == 'hd' or obj.type == 'dg_ht':
            print 'aaaaaasaaaaaaaaaaa',obj.type, obj.drawings_type
            if 'drawings_type' in vals:
                if vals['drawings_type'] == False:
                    raise osv.except_osv(_('Анхаар!'),_("Зургийн зориулалт - талбарт заавал утга сонгоно уу!"))
            #elif obj.drawings_type == False:
            #    raise osv.except_osv(_('Анхаар!'),_("Зургийн зориулалт - талбарт заавал утга сонгоно уу!"))
        
        #Ajiltan zasch bolohgvi talbariig zassan ved shalgah nohtsolvvd
        if_group_draw_user_public = self.pool['res.users'].has_group(cr, uid, 'ierp_draw.group_draw_user_public')
        if_group_draw_user = self.pool['res.users'].has_group(cr, uid, 'ierp_draw.group_draw_user')
        if_group_draw_manager = self.pool['res.users'].has_group(cr, uid, 'ierp_draw.group_draw_manager')
        if_group_draw_headman = self.pool['res.users'].has_group(cr, uid, 'ierp_draw.group_draw_headmans')
            #Huwaarilaltiin medeelel heseg
        if 'distribution_type' in vals:
            if vals['distribution_type'] != obj.distribution_type:
                if if_group_draw_manager:
                    vals['distribution_type'] = vals['distribution_type']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Хуваарилалтын төрөл>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        if 'partner_company' in vals:
            if vals['partner_company'] != obj.partner_company.id:
                if if_group_draw_manager:
                    vals['partner_company'] = vals['partner_company']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Гүйцэтгэгч байгууллага>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        if 'partner_employee' in vals:
            if vals['partner_employee'] != obj.partner_employee:
                if if_group_draw_manager:
                    vals['partner_employee'] = vals['partner_employee']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Хариуцсан хүн>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        if 'partner_phone' in vals:
            if vals['partner_phone'] != obj.partner_phone:
                if if_group_draw_manager:
                    vals['partner_phone'] = vals['partner_phone']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Утас>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        if 'partner_email' in vals:
            if vals['partner_email'] != obj.partner_email:
                if if_group_draw_manager:
                    vals['partner_email'] = vals['partner_email']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<И-мэйл>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        if 'reviewer_id' in vals:
            if vals['reviewer_id'] != obj.reviewer_id.id:
                if if_group_draw_manager:
                    vals['reviewer_id'] = vals['reviewer_id']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Хянагч ажилтан>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        if 'planned_start_date' in vals:
            if vals['planned_start_date'] != obj.planned_start_date:
                if if_group_draw_manager:
                    vals['planned_start_date'] = vals['planned_start_date']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Эхлэхээр төлөвлөсөн огноо>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        if 'planned_end_date' in vals:
            if vals['planned_end_date'] != obj.planned_end_date:
                if if_group_draw_manager:
                    vals['planned_end_date'] = vals['planned_end_date']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Дуусахаар төлөвлөсөн огноо>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        
        
        if 'state' in vals:
            vals['write_date'] = fields.datetime.now()
            self.write(cr, uid, ids, {'state_id_before': obj.state,
                                      'state_mail_created': False}, context=context)
        if 'user_id' in vals:
            vals['user_id'] = vals['user_id']
            self.write(cr, uid, ids, {'user_mail_created': False}, context=context)
        if 'employee_id' in vals:
            if vals['employee_id'] != obj.employee_id.id:
                if if_group_draw_manager:
                    vals['employee_id'] = vals['employee_id']
                    self.write(cr, uid, ids, {'employee_mail_created': False}, context=context)
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Гүйцэтгэгч ажилтан>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        if 'reviewer_id' in vals:
            if vals['reviewer_id'] != obj.reviewer_id.id:
                if if_group_draw_manager:
                    vals['reviewer_id'] = vals['reviewer_id']
                    self.write(cr, uid, ids, {'employee_mail_created': False}, context=context)
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Хянагч ажилтан>> -талбарыг засч болохгүй, та зөвхөн хүсэлтийн мэдээлэл хэсгийг засах боломжтой!"))
        if 'distributed_employee' in vals:
            vals['distributed_employee'] = vals['distributed_employee']
            self.write(cr, uid, ids, {'distributed_employee_mail_created': False}, context=context)
        if 'performance_id' in vals:
            vals['performance_id'] = vals['performance_id']
            self.write(cr, uid, ids, {'performance_updated_mail_created': False}, context=context)
        if 'message_follower_ids' in vals:
            if obj.message_follower_ids != vals['message_follower_ids']:
                self.write(cr, uid, ids, {'partner_mail_created': False}, context=context)
        
        #self.write(cr, uid, ids, {'have_planned_end_date': vals['have_planned_end_date']}, context=context)
        return super(tbab_request_for_design,self).write(cr, uid, ids, vals, context)
    
    


class draw_performance_info(models.Model):
    _name = 'draw.performance.info'
    _description = "Draw performance info"
    _columns = {
                'performance':fields.char('Performance'),#Гүйцэтгэл
                'attachment':fields.binary('attachment'),#Зураг
                'percent':fields.float('Percent'),#Гүйцэтгэлийн хувь
                'date':fields.datetime('Date'),#Огноо
                'user_id':fields.many2one('res.users','User'),#Гүйцэтгэсэн
                'draw_id':fields.many2one('tbab.request.for.design','Draw'),
                
    }
    _defaults = {
                 'user_id':lambda self, cr, uid, context: uid,
                 'date':lambda self, cr, uid, context: fields.datetime.now(),
                 }

class tbab_type_image(models.Model):
    _name = 'tbab.type.image'
    _description = "Tbab type image"
    _columns = {
                'type':fields.selection([
                                         ('sketch','Sketch'),#Эскиз зураг,
                                         ('ba','BA'),#Барилга архитектур АЗ
                                         ('bb','BB'),#Барилга бүтээц АЗ
                                         ('has','HAS'),#Халаалт агаар сэлгэлт АЗ
                                         ('tsbu','TsBU'),#Цэвэр бохир ус АЗ
                                         ('hd','HD'),#Холбоо дохиолол АЗ
                                         ('dg_ht','DG,HT'),#Дотор гэрэлтүүлэг, Хүчит төхөөрөмж АЗ
                                         ('out_warm','Out warm'),#Гадна дулаан
                                         ('out_electric','Out electric'),#Гадна цахилгаан
                                         ('out_sanitation','Out sanitation'),#Гадна цэвэр бохир
                                         ('out_signal','Out signal'),#Гадна холбоо дохиолол
                                         ('out_appointment','Out appointment'),#Гадна тохижилт
                                         ('in_design','In design'),#Интерьер дизайн
                                         ('technology_guidance','Technology guidance'),#Технологийн заавар
                                         ('brochure','Brochure'),#Танилцуулга, брошур
                                         ('contract_attachment','Contract attachment'),#Гэрээний хавсралт
                                         ('project_detail','Project detail'),#Төслийн дэлгэрэнгүй мэдээлэл
                                         ('general_plan','General plan'),#Ерөнхий төлөвлөгөө
                                         ('elevation','Elevation'),#Өндөржилт
                                         ('background_mapping','Background mapping'),#Дэвсгэр зураг
                                         ('geological_conclusions','Geological conclusions'),#Геологийн дүгнэлт
                                         ],'Type',help=u'Choose type of design', required=True),#Төрөл
                'image_main': fields.binary("Image main"),
                'image_2': fields.binary("Image 2"),
                'image_3': fields.binary("Image 3"),
                
    }
    _sql_constraints = [
        ('type', 'unique (type)', u'Нэг төрлийг нэг л удаа бүртгэх боломжтой. Энэ төрлийг өмнө нь бүртгэсэн байна, та өөр төрөлд бүртгэнэ үү!')
    ]
    
    #===========================================================================
    # _defaults = {
    #              'user_id':lambda self, cr, uid, context: uid,
    #              'date':lambda self, cr, uid, context: fields.datetime.now(),
    #              }
    #===========================================================================

    #===========================================================================
    # def create(self, cr, uid, vals, context=None):
    #     context = dict(context or {})
    #     req_obj = self.pool.get('tbab.request.for.design')
    #     
    #     task_id = super(tbab_task, self).create(cr, uid, vals, context=None)
    #     #self._store_history(cr, uid, [task_id], context=context)
    #     return task_id
    #===========================================================================

