# -*- coding: utf-8 -*-
##############################################################################
#
#                       iERP Consulting
#
##############################################################################

from openerp import tools
from openerp.osv import fields, osv

from openerp.tools.sql import drop_view_if_exists
from datetime import date, timedelta, datetime
from calendar import month, day_abbr, day_name

class draw_performer_report(osv.osv):
    _name = "draw.performer.report"
    _description = "Draw performer report"
    _auto = False
    #_rec_name = 'date'

    _columns = {
        'name':fields.char('Name',copy=False),#Request design order number - Захиалгын дугаар
        'final_picture':fields.many2many('ir.attachment','trfd_fp_rel', 'fp_id', 'trfd_fp_id','Final picture'),#Батлагдсан зураг
        #'parent_id':fields.many2one('tbab.request.for.design','Parent'),#Эхний хувилбар
        'state': fields.selection([
                ('draft', 'Draft'),#Ноорог
                ('request', 'Request'),#Хүсэлт
                ('distribution', 'Distribution'),#Хуваарилалт
                ('performance', 'Performance'),#Гүйцэтгэл
                ('closed', 'Closed'),#Дууссан
                ('send_to_project','Send to project'),#Төсөлд өгсөн
                ('stand_by', 'Stand by'),#Түр зогссон
                ('cancelled', 'Cancelled'),#Цуцлагдсан
                ], 'State', track_visibility='onchange'),#Төлөв
        'progress': fields.float(string='Progress', group_operator="avg"),
        'is_electronic':fields.boolean('Is electronic'),#Цахимаар өгсөн
        'is_printed':fields.boolean('Is printed'),#Хэвлэмэлээр өгсөн
        
        #Хүсэлтийн хэсэг
        'project_id':fields.many2one('project.project','Project'),#Төсөл
        'project_phase_id':fields.many2one('project.task.phase','Phase'),#Төслийн үе шат
        'user_id':fields.many2one('res.users','User'),#Хүсэлт гаргаж буй ажилтан
        'department_id':fields.many2one('hr.department','Department'),#Хүлээн авах алба, нэгж
        'type':fields.selection([
                                 ('sketch','Sketch'),#Эскиз зураг,
                                 ('ba','BA'),#Барилга архитектур АЗ
                                 ('bb','BB'),#Барилга бүтээц АЗ
                                 ('has','HAS'),#Халаалт агаар сэлгэлт АЗ
                                 ('tsbu','TsBU'),#Цэвэр бохир ус АЗ
                                 ('hd','HD'),#Холбоо дохиолол АЗ
                                 ('dg_ht','DG,HT'),#Дотор гэрэлтүүлэг, Хүчит төхөөрөмж АЗ
                                 ('out_warm','Out warm'),#Гадна дулаан
                                 ('out_electric','Out electric'),#Гадна цахилгаан
                                 ('out_sanitation','Out sanitation'),#Гадна цэвэр бохир
                                 ('out_signal','Out signal'),#Гадна холбоо дохиолол
                                 ('out_appointment','Out appointment'),#Гадна тохижилт
                                 ('in_design','In design'),#Интерьер дизайн
                                 ('technology_guidance','Technology guidance'),#Технологийн заавар
                                 ('brochure','Brochure'),#Танилцуулга, брошур
                                 ('contract_attachment','Contract attachment'),#Гэрээний хавсралт
                                 ('project_detail','Project detail'),#Төслийн дэлгэрэнгүй мэдээлэл
                                 ('general_plan','General plan'),#Ерөнхий төлөвлөгөө
                                 ('elevation','Elevation'),#Өндөржилт
                                 ('background_mapping','Background mapping'),#Дэвсгэр зураг
                                 ('geological_conclusions','Geological conclusions'),#Геологийн дүгнэлт
                                 ],'Type',help=u'Choose type of design', required=True),#Төрөл
        'image_description': fields.char("Image description", required=True),#Зургийн тайлбар
        #=======================================================================
        # 'image_example': fields.boolean("Image example"),#Жишээ зураг
        # 
        # 'image_main': fields.binary("Image main"),
        # 'image_2': fields.binary("Image 2"),
        # 'image_3': fields.binary("Image 3"),
        #=======================================================================
        'design_type':fields.selection([
                                 ('3d_render','3D render'),#3D рендер
                                 ('ceiling_work_drawings','Ceiling work drawings'),#Таазны ажлын зураг
                                 ('wall_photoshop','Wall photoshop'),#Ханын дэлгээс
                                 ('plita_photoshop','Plita photoshop'),#Плитаны дэлгээс
                                 ('floor_work_drawings','Floor work drawings'),#Шалны ажлын зураг
                                 ('furniture_drawings','Furniture drawings'),#Тавилгын зураг
                                 ('material_selection','Material selection'),#Материал сонголт
                                 ],'Design type'),#Интерьерийн төрөл
        'brochure_type':fields.selection([
                                 ('3d_exteriors','3D exteriors'),#3D экстерьер
                                 ('3d_interiors','3D interiors'),#3D интерьер
                                 ('2d_plan','2D plan'),#2D план
                                 ('3d_plan','3D plan'),#3D план
                                 ('3d_selection','3D selection'),#Сонголтын 3D
                                 ],'Brochure type'),#Брошурын төрөл
        'drawings_type':fields.selection([
                                 ('work_drawings','Work drawings'),#Ажлын зураг
                                 ('site_drawings','Site drawings'),#Талбайн зураг
                                 ],'Drawings type'),#Зургийн зориулалт
        
        'ordered_date':fields.date('Ordered date'),#Зургийн захиалга бүрэн өгсөн огноо
        'end_date':fields.date('End date'),#Зургийн захиалга дуусах огноо
        'justification':fields.char('Justification'),#Зураг төсөл боловсруулах үндэслэл
        'special_conditions':fields.text('Special conditions'),#Тусгай нөхцөл, шаардлага
        
        'construction_purpose':fields.char('Construction purpose'),#Барилгын зориулалт
        'capacity':fields.char('Capacity'),#Хүчин чадал
        
        
        #Хуваарилалтын хэсэг
        'distribution_type':fields.selection([('internal','Internal'),#Дотоод ажилтнаар
                                 #('in_architecture','In architecture'),
                                 ('external','External')],#Гадны байгууллагаар
                                'Distribution type'),#Хуваарилалтын төрөл
        'partner_company':fields.many2one('res.partner','Partner company'),#Гүйцэтгэгч байгууллага
        'partner_employee':fields.char('Partner employee'),#Хариуцсан хүн
        'reviewer_id':fields.many2one('hr.employee','Reviewer'),#Хянагч ажилтан
        'partner_phone':fields.char('Partner phone'),#Утас
        'partner_email':fields.char('Partner email'),#И-мэйл
        'employee_id':fields.many2one('hr.employee','Employee'),#Гүйцэтгэгч ажилтан
        'planned_start_date':fields.date('Planned start date'),#Эхлэхээр төлөвлөсөн огноо
        'planned_end_date':fields.date('Planned end date'),#Дуусахаар төлөвлөсөн огноо
        'distributed_employee':fields.many2one('hr.employee','Distributed employee'),#Хуваарилсан ажилтан
        'distributed_employee_job':fields.many2one('hr.job','Distributed employee job'),#Хуваарилсан ажилтны албан тушаал
        #Гүйцэтгэлийн хэсэг
        #'performance_id':fields.one2many('draw.performance.info','draw_id','Performance'),#Гүйцэтгэлийн мөр
        'eg_cipher':fields.char('EG cipher'),#ЕГ шифр
        'tg_cipher':fields.char('TG cipher'),#ТГ шифр
        'note':fields.text('Note'),#Нэмэлт тайлбар
        'approved_employee':fields.many2one('hr.employee','Approved employee'),#Баталсан ажилтан
        'approved_employee_job':fields.many2one('hr.job','Approved employee job'),#Баталсан ажилтны албан тушаал
        'approved_date':fields.date('Approved date'),#Баталсан огноо
        'timeout': fields.integer('Хугацааны хэмнэлт, хэтрэлт'),
        
        'state_id_before': fields.selection([('draft', 'Ноорог'),
                                          ('request', 'Хүсэлт'),
                                          ('distribution', 'Хуваарилалт'),
                                          ('performance', 'Гүйцэтгэл'),
                                          ('closed', 'Дууссан'),
                                          ('send_to_project', 'Батлагдсан'),
                                          ('stand_by', 'Түр зогссон'),
                                          ('cancelled', 'Цуцлагдсан')], 'Өмнөх төлөв'),
        
        'performance':fields.char('Performance'),#Гүйцэтгэл
        'attachment':fields.binary('attachment'),#Зураг
        'percent':fields.float('Percent', group_operator="avg"),#Гүйцэтгэлийн хувь
        'date':fields.datetime('Date'),#Огноо
        'line_user_id':fields.many2one('res.users','Line user'),#Гүйцэтгэсэн
        #'draw_id':fields.many2one('tbab.request.for.design','Draw'),
        
    }

    def init(self, cr):
        drop_view_if_exists(cr, 'draw_performer_report')
        cr.execute("""
            create or replace view draw_performer_report as (
                SELECT
                    dpi.id,
                    dpi.performance,
                    dpi.attachment,
                    avg(dpi.percent) as percent,
                    dpi.date,
                    dpi.user_id as line_user_id,
                    
                    
                    trfd.name,
                    trfd.final_picture,
                    avg(trfd.progress) as progress,
                    trfd.state,
                    trfd.is_electronic,
                    trfd.is_printed,
                    trfd.user_id,
                    
                    trfd.project_id,
                    trfd.project_phase_id,
                    trfd.department_id,
                    trfd.type,
                    trfd.image_description,
                    trfd.design_type,
                    trfd.brochure_type,
                    trfd.drawings_type,
                    trfd.ordered_date,
                    trfd.end_date,
                    trfd.justification,
                    trfd.special_conditions,
                    trfd.construction_purpose,
                    trfd.capacity,
                    
                    trfd.distribution_type,
                    trfd.partner_company,
                    trfd.partner_employee,
                    trfd.partner_phone,
                    trfd.partner_email,
                    trfd.planned_start_date,
                    trfd.planned_end_date,
                    trfd.eg_cipher,
                    trfd.tg_cipher,
                    trfd.note,
                    trfd.approved_date,
                    trfd.timeout,
                    trfd.state_id_before,
                    
                    trfd.reviewer_id,
                    trfd.employee_id,
                    trfd.distributed_employee,
                    trfd.distributed_employee_job,
                    trfd.approved_employee,
                    trfd.approved_employee_job
                    
                FROM
                    draw_performance_info as dpi,
                    tbab_request_for_design as trfd
                    
                WHERE
                    dpi.draw_id = trfd.id
                GROUP BY
                    dpi.id,
                    trfd.id,
                    dpi.percent,
                    trfd.progress
            )""")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
