# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import logging
import time
import datetime
from datetime import datetime
from datetime import time
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _
from bsddb.dbtables import _columns_key, _columns

class fleet_vechicle_odometer(osv.osv):
    _inherit = 'fleet.vehicle.odometer'

    def _vehicle_log_name_get_fnction(self, cr, uid, ids, prop, unknow_none, context=None):
        res = {}
        for record in self.browse(cr, uid, ids, context=context):
            name = record.vehicle_id.name
            if record.date:
                if name==False:
                    name= ''
                else:
                    name = record.vehicle_id.name
                    name = name+ ' / '+ str(record.date)
            res[record.id] = name
        return res
    _columns = {
                'name': fields.function(_vehicle_log_name_get_fnction, type="char", string='Name', store=True),
                }


class fleet_vehicle_type(osv.Model):
    _name = 'fleet.vehicle.type'
    _columns = {
                'type': fields.selection([('special','Special'),('hoister','Hoister')],'Type',),
                'name': fields.char('Name',required=True),
                
                }
class fleet_vehicle(osv.Model):
    _inherit = 'fleet.vehicle'
    
    def _vehicle_name_get_fnc(self, cr, uid, ids, prop, unknow_none, context=None):
        res = {}
        for record in self.browse(cr, uid, ids, context=context):
                if record.rent == False:
                    res[record.id] = record.model_id.brand_id.name + '/' + record.model_id.modelname + ' / ' + record.license_plate
                else:
                        res[record.id] = record.model_id.brand_id.name + '/' + record.model_id.modelname + ' / ' + record.license_plate + ' / ' + u'Түрээс'                             
        return res
    
    _columns = {
        'name': fields.function(_vehicle_name_get_fnc, type="char", string='Name', store=True),
        'vehicle_code': fields.char('Vehicle code'),
        'type': fields.selection([('special','Special'),('hoister','Hoister')],'Type'),  
        'sub_type': fields.many2one('fleet.vehicle.type','Vehicle sub type'),
        'owner_com_name': fields.char('Owner company name'),
        'wheel_mark': fields.char('Wheel mark'),
        'wheel_type': fields.selection([('summer','Summer'),('winter','Winter'),('four_season','Four Season')],'Wheel type'),
        'insurance_status': fields.boolean('Insurance status'),
        'insurance_com_name': fields.char('Insurance company name'),
        'safety_status': fields.boolean('Safety status'),
        'cranest_name': fields.char('Cranest name'),
        'crane_strop': fields.char('Crane strop'),
        'signalman_name': fields.char('Signalman name'),
        'generation_rate': fields.char('Generetion rate'),
        'exam_first_time': fields.date('Exam first time'),
        'exam_next_time': fields.date('Exam next time'),
        'duty_status': fields.boolean('Duty status'),
        'duty_paid_time': fields.date('Duty paid time'),
        'made_date': fields.date('Made date'),
        'cranest_phone': fields.char('Cranest phone'),
        'ekrater_name': fields.char('Ekrater name'),
        'operator_name': fields.char('Operator name'),
        'technical_result': fields.char('Technical result'),
        'car_type': fields.selection([('passenger_car','Passenger car'),('bus','Bus')],'Car type'),
        'rent': fields.boolean('Rent'),
        'self': fields.boolean('Self'),
        'safety_plan': fields.binary('Safety plan'),
        'vehicle_result': fields.binary('Vehicle result'),
        'made_country': fields.char('Made country'),
        'incomer_date': fields.date('Incomer date'),
        'gas_rate': fields.float('Gas rate'),
        'vin': fields.char('VIN'), #Vehicle idendification number
        
        'is_local_service': fields.boolean('Is local service'), #Дотоод ажилчдад үйлчлэх
        }
    
    _defaults = {
                'is_local_service': False,
        }
    
class fleet_order(osv.Model):
    _name = 'fleet.order'
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    _columns = {
        
        'fon': fields.char('Fon',readonly=True,copy=False),
        'name': fields.text('Name',required=True ),
        'type': fields.selection([('special','Special'),('hoister','Hoister')],'Type'),
        'sub_type': fields.many2one('fleet.vehicle.type','Vehicle sub type',required=True),
        'office_type': fields.selection([('tua','TUA'),('haa','HAA'),('swiss','Swiss')],'Office type'),
        'project_id': fields.many2one('project.project','Project'),
        'phase_id': fields.many2one('project.task.phase','Project phase'),
        'reserved_date': fields.datetime('Reserved date', readonly=True),
        'marshrut': fields.text('Marshrut'),
        'to_address': fields.char('To address'),
        'to_customer': fields.char('To customer'),
        'to_phone': fields.char('To phone'),
        'comment': fields.text('Comment'),
        #'assistants': fields.char('Assistants'),
        'execute_date': fields.datetime('Execute date'),
        'executed_time': fields.date('Executed time'),
        'continuity_time': fields.float('Continuity time'),
        'rate': fields.char('Rate', required=True),
        'complaint': fields.text('Complaint'),
        'description': fields.text('Description'),
        'fleet_vehicle_id': fields.many2one('fleet.vehicle','Fleet Vehicle'),
        'customer_name': fields.many2one('res.users','Customer Name'),
        'customer_phone': fields.char('Customer Phone'),
        #'vehicle_distribution': fields.char('Vehicle distribution'),
        'serve_time': fields.integer('Serve time'),
        'execute_time_start': fields.datetime('Execute time start'),
        'execute_time_end': fields.datetime('Execute time end'),
        'driver_phone': fields.char('Driver phone'),
        'driver_name': fields.many2one('res.partner', 'Driver name'),
        'unit_type': fields.selection([('trip','Trip'),('motohour','Moto hour'),('km','Km')],'Unit type'),
        'unit_price': fields.integer('Unit price'),
        'total_price': fields.float('Total price',readonly=True),
        'company_id': fields.many2one('res.company','Company'),
        'invoice_id': fields.many2one('account.invoice','Invoice'),
        'state': fields.selection([
                    ('draft', 'Draft'),
                    ('request', 'Request'),
                    ('distributed','Distributed'),
                    ('confirmed', 'Confirmed'),
                    ('invoiced','Invoiced'),
                    ('complete','Complete'),
                    ('canceled','Canceled')
                    ], 'State', readonly=True, select=True),
                }
    _defaults = {
                 'fon': lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'fleet.order'),
                 'state': 'draft',
                 'reserved_date':fields.datetime.now,
                 'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
                 'customer_name':lambda obj, cr, uid, context: uid,
                 }
    
    def action_cancel_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True
    def action_to_request(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'request'})
        return True  
    def action_to_distribute(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        if not obj.fleet_vehicle_id:
             raise osv.except_osv(_('Warning'),_('Choose vehicle'))
        self.write(cr, uid, ids, {'state': 'distributed'})
        return True
    def action_to_confirm(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        if not obj.office_type ==False:
            if obj.continuity_time != 0 and obj.unit_type != False and obj.unit_price != 0:
                self.write(cr, uid, ids, {'state': 'confirmed'})
            else:
                raise osv.except_osv(_('Warning'),_('Invaled unit type,continuity time,unit price !!!'))     
        else:
            raise osv.except_osv(_('Warning'),_('Invaled office type !!!'))
        return True
    def action_to_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'canceled'})
        return True
    def action_to_complete(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'complete'})
        return True
    
    
    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid, ids)
        
        #Ajiltan zasch bolohgvi talbariig zassan ved shalgah nohtsolvvd
        if_group_fleet_user = self.pool['res.users'].has_group(cr, uid, 'ierp_fleet_management.group_fleet_engineer')
        if_group_fleet_manager = self.pool['res.users'].has_group(cr, uid, 'fleet.group_fleet_manager')
        if_group_fleet_headman = self.pool['res.users'].has_group(cr, uid, 'ierp_fleet_management.group_fleet_resources')
            #Bvh medeelel heseg(Public Information page)
        if 'fleet_vehicle_id' in vals:
            if vals['fleet_vehicle_id'] != obj.fleet_vehicle_id.id:
                if if_group_fleet_user or if_group_fleet_manager or if_group_fleet_headman:
                    vals['fleet_vehicle_id'] = vals['fleet_vehicle_id']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Тээврийн хэрэгслийн нэр>> -талбарыг засч болохгүй, та зөвхөн захиалгын мэдээлэл хэсгийг засах боломжтой!"))
        if 'execute_time_start' in vals:
            if vals['execute_time_start'] != obj.execute_time_start:
                if if_group_fleet_user or if_group_fleet_manager or if_group_fleet_headman:
                    vals['execute_time_start'] = vals['execute_time_start']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Ажил гүйцэтгэх хугацаа>> -талбаруудыг засч болохгүй, та зөвхөн захиалгын мэдээлэл хэсгийг засах боломжтой!"))
        if 'execute_time_end' in vals:
            if vals['execute_time_end'] != obj.execute_time_end:
                if if_group_fleet_user or if_group_fleet_manager or if_group_fleet_headman:
                    vals['execute_time_end'] = vals['execute_time_end']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Ажил гүйцэтгэх хугацаа>> -талбаруудыг засч болохгүй, та зөвхөн захиалгын мэдээлэл хэсгийг засах боломжтой!"))
        if 'driver_name' in vals:
            if vals['driver_name'] != obj.driver_name.id:
                if if_group_fleet_user or if_group_fleet_manager or if_group_fleet_headman:
                    vals['driver_name'] = vals['driver_name']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Жолоочийн нэр>> -талбарыг засч болохгүй, та зөвхөн захиалгын мэдээлэл хэсгийг засах боломжтой!"))
        if 'driver_phone' in vals:
            if vals['driver_phone'] != obj.driver_phone:
                if if_group_fleet_user or if_group_fleet_manager or if_group_fleet_headman:
                    vals['driver_phone'] = vals['driver_phone']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Жолоочийн утас>> -талбарыг засч болохгүй, та зөвхөн захиалгын мэдээлэл хэсгийг засах боломжтой!"))
        if 'comment' in vals:
            if vals['comment'] != obj.comment:
                if if_group_fleet_user or if_group_fleet_manager or if_group_fleet_headman:
                    vals['comment'] = vals['comment']
                else:
                    raise osv.except_osv(_("Буруу үйлдэл!"), _("Та <<Хуваарилалтын тайлбар>> -талбарыг засч болохгүй, та зөвхөн захиалгын мэдээлэл хэсгийг засах боломжтой!"))
        
         
        return super(fleet_order, self).write(cr, uid, ids, vals, context=context)
    
    
    def action_create_invoice(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        invoice = self.pool.get('account.invoice')
        journal_obj = self.pool.get('account.journal')
        par_obj = self.pool.get('fleet.vehicle')        #Zahialgaas nehemjlel uusgehdee hariltsag ch kompanii medeelel harahad heregleh
        #sch_obj = self.pool.get('sales.payment.schedule')
       
        currency_id = obj.company_id.currency_id.id
        journal_ids = journal_obj.search(cr, uid, [('type', '=','purchase'),('company_id', '=', obj.company_id.id or False)], limit=1)
        par_ids = par_obj.browse(cr, uid, par_obj.search(cr, uid, [('id','=',obj.fleet_vehicle_id.id)]))
        fpos = par_ids.driver_id.property_account_position or False
        invoice_lines = []
             
        invoice_line = []
        invoice_line.append((0, 0, {
                                        'name': obj.name,
                                        'account_id': par_ids.driver_id.property_account_payable.id,
                                        'unit_type': obj.unit_type,
                                        'price_unit': obj.unit_price,
                                        'quantity': obj.continuity_time,
                                        'price_subtotal': obj.total_price,
                                        
        }))
            
        sch_invoice = invoice.create(cr, uid, {
                                    'account_id': par_ids.driver_id.property_account_payable.id,
                                    'type': 'in_invoice',
                                    'partner_id': par_ids.driver_id.id,
                                    'currency_id': currency_id,
                                    'journal_id': len(journal_ids) and journal_ids[0] or False,
                                    'date_invoice': obj.executed_time,
                                    'fiscal_position': fpos and fpos.id,
                                    'company_id': obj.company_id.id or False,
                                    'invoice_line': invoice_line,
                                    'date_due': obj.executed_time,
                                    'comment': obj.description,
                                     })
        self.write(cr, uid, ids, {'state': 'invoiced',
                                  'invoice_id': sch_invoice})
        return True
    
    #teevriin zaialgand mashin huvaarilalt hiihed teevriin heregseliin medeelel oruulahad tuhain teevriin heregseliin joloochiin medeelel haragdah
    def on_change_vehicle_driver(self, cr, uid, ids, fleet_vehicle_id, context=None):
        if not fleet_vehicle_id:
            return {}
        par_obj = self.pool.get('res.partner')
        vehicle = self.pool.get('fleet.vehicle').browse(cr, uid, fleet_vehicle_id, context=context)
        phone = par_obj.browse(cr, uid, par_obj.search(cr, uid,[('id','=',vehicle.driver_id.id)]))
        driver = vehicle.driver_id.id
        mobile = phone.mobile or phone.phone
        return {
            'value': {
                'driver_name': driver,
                'driver_phone': mobile,
            }
        }
        
    #===========================================================================
    # def onchange_fleet_vehicle_id(self, cr, uid, ids, fleet_vehicle_id, context=None):
    #     res = {}
    #     if fleet_vehicle_id != None:
    #         decr_obj = self.pool.get('ir.attachment')
    #         decr_id = decr_obj.search(cr, uid, [('id','=',decree_id)])
    #         decr = decr_obj.browse(cr, uid, decr_id)
    #         res['driver_name']=fleet_vehicle_id.driver_id.id
    #         res['decree_date']=fleet_vehicle_id.driver_id.phone or fleet_vehicle_id.driver_id.mobile
    #         return {'value':res}
    #===========================================================================
        
    def on_change_continuity_time(self, cr, uid, ids, continuity_time, unit_price, total_price, context=None):
        #need to cast in float because the value receveid from web client maybe an integer (Javascript and JSON do not
        #make any difference between 3.0 and 3). This cause a problem if you encode, for example, 2 liters at 1.5 per
        #liter => total is computed as 3.0, then trigger an onchange that recomputes price_per_liter as 3/2=1 (instead
        #of 3.0/2=1.5)
        #If there is no change in the result, we return an empty dict to prevent an infinite loop due to the 3 intertwine
        #onchange. And in order to verify that there is no change in the result, we have to limit the precision of the 
        #computation to 2 decimal
        continuity_time = float(continuity_time)
        unit_price = float(unit_price)
        total_price = float(total_price)
        if continuity_time > 0 and unit_price > 0 and round(continuity_time*unit_price,2) != total_price:
            return {'value' : {'total_price' : round(continuity_time * unit_price,2),}}
        
    def on_change_unit_price(self, cr, uid, ids, continuity_time, unit_price, total_price, context=None):
        #need to cast in float because the value receveid from web client maybe an integer (Javascript and JSON do not
        #make any difference between 3.0 and 3). This cause a problem if you encode, for example, 2 liters at 1.5 per
        #liter => total is computed as 3.0, then trigger an onchange that recomputes price_per_liter as 3/2=1 (instead
        #of 3.0/2=1.5)
        #If there is no change in the result, we return an empty dict to prevent an infinite loop due to the 3 intertwine
        #onchange. And in order to verify that there is no change in the result, we have to limit the precision of the 
        #computation to 2 decimal
        continuity_time = float(continuity_time)
        unit_price = float(unit_price)
        total_price = float(total_price)
        if continuity_time > 0 and unit_price > 0 and round(continuity_time*unit_price,2) != total_price:
            return {'value' : {'total_price' : round(continuity_time * unit_price,2),}}
     
    def action_view_invoice(self, cr, uid, ids, context=None):
        mod_obj = self.pool.get('ir.model.data')
        act_obj = self.pool.get('ir.actions.act_window')

        result = mod_obj.get_object_reference(cr, uid, 'account', 'action_invoice_tree1')
        id = result and result[1] or False
        result = act_obj.read(cr, uid, [id], context=context)[0]
        #compute the number of invoices to display
        inv_ids = []
        for so in self.browse(cr, uid, ids, context=context):
            inv_ids += [invoice.id for invoice in so.invoice_id]
        #choose the view_mode accordingly
        if len(inv_ids)>1:
            result['domain'] = "[('id','in',["+','.join(map(str, inv_ids))+"])]"
        else:
            res = mod_obj.get_object_reference(cr, uid, 'account', 'invoice_form')
            result['views'] = [(res and res[1] or False, 'form')]
            result['res_id'] = inv_ids and inv_ids[0] or False
        
        return result

class fleet_vehicle_log_fuel (osv.Model):
    _inherit = 'fleet.vehicle.log.fuel'
    
    def on_change_road(self, cr, uid, ids, road, gas_rate1, liter, context=None):
        #need to cast in float because the value receveid from web client maybe an integer (Javascript and JSON do not
        #make any difference between 3.0 and 3). This cause a problem if you encode, for example, 2 liters at 1.5 per
        #liter => total is computed as 3.0, then trigger an onchange that recomputes price_per_liter as 3/2=1 (instead
        #of 3.0/2=1.5)
        #If there is no change in the result, we return an empty dict to prevent an infinite loop due to the 3 intertwine
        #onchange. And in order to verify that there is no change in the result, we have to limit the precision of the 
        #computation to 2 decimal
        road = float(road)
        gas_rate1 = float(gas_rate1)
        liter = float(liter)
        if road > 0 and gas_rate1 > 0 and round((road*gas_rate1)/100,2) != liter:
            return {'value' : {'liter' : round((road * gas_rate1)/ 100,2),}}
    def on_change_vehicle(self, cr, uid, ids, vehicle_id, context=None):
        if not vehicle_id:
            return {}
        odometer_unit = self.pool.get('fleet.vehicle').browse(cr, uid, vehicle_id, context=context).odometer_unit
        gas_rate = self.pool.get('fleet.vehicle').browse(cr, uid, vehicle_id, context=context).gas_rate
        return {
            'value': {
                'odometer_unit': odometer_unit,
                'gas_rate': gas_rate,
                'gas_rate1': gas_rate,
            }
        }
        
    _columns = {
                
         'project_id': fields.many2one('project.project','Project'),
         'phase_id': fields.many2one('project.task.phase','Project phase'),      
         'road': fields.float('Road'),      
         'gas_rate': fields.related('vehicle_id', 'gas_rate', type='float', string='Gas rate',store=True ,readonly=True),
         'gas_rate1': fields.float('Gas rate1')      #Teevriin heregseliin yavsan zain hemjeeg oruulahad readonly talbar horiglodog uchir davhar uusgej ashiglav
         
    }
