# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class vehicle_information_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "vehicle.information.report"
    _description = "Vehicle information report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
    }
    _defaults = {
        'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
    }
    

    def get_export_data(self, cr, uid, ids, context=None):
       if context is None:
           context = {}
       form = self.browse(cr, uid, ids[0], context=context)
       user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
       datas = {'ids': context.get('active_ids', [])}
       datas['form'] = self.read(cr, uid, ids)[0]
       data = datas['form']
       
          
       vehicle = self.pool.get('fleet.vehicle')
       vehicle_inf = vehicle.browse(cr, uid)
       rent= vehicle.search(cr,uid,[('rent','=',False)]) 
       ezxf = xlwt.easyxf
       
       styles = self.get_easyxf_styles()
       style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
       style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
       style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
       style_table_header = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
       book = xlwt.Workbook(encoding='utf8')
       sheet = book.add_sheet('Vehicle information')
       sheet.write(1, 1, u'Байгууллагын нэр:', ezxf('font: bold on;align:wrap off,vert centre;'))
       sheet.write(1, 2, u'%s' %user.company_id.name, ezxf('font: bold on;align:wrap off,vert centre;'))
       sheet.write_merge(4, 6, 0, 0, u'№', style_table_header)
       sheet.write_merge(4, 6, 1, 1, u'Тээврийн хэрэгслийн нэр', style_table_header)
       sheet.write_merge(4, 6, 2, 2, u'Улсын дугаар', style_table_header)
       sheet.write_merge(4, 6, 3, 3, u'Аралын дугаар', style_table_header)
       sheet.write_merge(4, 6, 4, 4, u'Моторын багтаамж', style_table_header)
       sheet.write_merge(4, 6, 5, 5, u'Үйлдвэрлэсэн улс', style_table_header)
       sheet.write_merge(4, 6, 6, 6, u'Үйлдвэрлэсэн огноо', style_table_header)
       sheet.write_merge(4, 6, 7, 7, u'Явсан км', style_table_header)
       sheet.write_merge(4, 6, 8, 8, u'Эд хариуцагч', style_table_header)
       rowx = 7
       i=1
       rowx = 7
       i=1
       for line in vehicle.browse(cr, uid,rent): 
            sheet.write(rowx, 0, u'%s' %i, style_table)
            i=i+1
            sheet.write(rowx, 1, u'%s' %line.model_id.name, style_table)
            sheet.write(rowx, 2, u'%s' %line.license_plate, style_table)
            
            if line.vin==False:
                sheet.write(rowx, 3, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 3, u'%s' %line.vin, style_table)
            if line.vin_sn==False:
                sheet.write(rowx, 4, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 4, u'%s' %line.vin_sn, style_table)
            if line.made_country==False:
                sheet.write(rowx, 5, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 5, u'%s' %line.made_country, style_table)
            if  line.made_date==False:
                sheet.write(rowx, 6, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 6, u'%s' %line.made_date, style_table)
            if  line.odometer==False:
                sheet.write(rowx, 7, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 7, u'%s' %line.odometer, style_table) 
            if line.operator_name==False:
                sheet.write(rowx, 8, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 8, u'%s' %line.operator_name, style_table) 
            rowx = rowx + 1
        
       inch = 1000
       inch1 = 900
       sheet.col(0).width = 1*inch
       sheet.col(1).width = 6*inch1
       sheet.col(2).width = 3*inch
       sheet.col(3).width = 3*inch
       sheet.col(4).width = 4*inch
       sheet.col(5).width = 4*inch
       sheet.col(6).width = 4*inch
       sheet.col(7).width = 4*inch
       sheet.col(8).width = 6*inch
       rowx = rowx+2
       sheet.write(rowx, 1, u'Тайлан гаргасан:', ezxf('font: bold off;align:wrap off,vert centre;'))
       rowx+=2
       sheet.write(rowx, 1, u'Хянасан:', ezxf('font: bold off;align:wrap off,vert centre;'))
       return {'data':book}
vehicle_information_report()