# -*- coding: utf-8 -*-
##############################################################################
#
#                       iERP Consulting
#
##############################################################################

from openerp import tools
from openerp.osv import fields, osv

from openerp.tools.sql import drop_view_if_exists
from datetime import date, timedelta, datetime
from calendar import month, day_abbr, day_name

class job_history_report(osv.osv):
    _name = "job.history.report"
    _description = "Job history report"
    _auto = False
    #_rec_name = 'date'

    _columns = {
        'employee_id': fields.many2one('hr.employee','Employee', readonly=True),
        'job_id': fields.many2one('hr.job','Job', readonly=True),
        'department_id': fields.many2one('hr.department','Department', readonly=True),
        'accession_date': fields.date('Accession date', readonly=True), 
        'left_date': fields.date('Left date', readonly=True), 
        'show_date': fields.date('Show date', readonly=True), 
        
        'no_of_employee': fields.integer('Current Number of Employees', copy=False, help="Ажиллаж буй ажилчдын тоо"),
        'no_of_recruitment': fields.integer('Expected New Employees', copy=False, help="Шинээр авах ажилчдын тоо"),
        'no_of_hired_employee': fields.integer('Hired Employees', copy=False, help="Ажлын байрны нийт ажилчдын тоо"),
        
    }
    _defaults = {
                 'history_date': lambda self, cr, uid, c: self._create_months(cr, uid, 'internal.training', context=c),
                 }

    def init(self, cr):
        drop_view_if_exists(cr, 'job_history_report')
        cr.execute("""
            create or replace view job_history_report as (
                SELECT
                    he.id as id,
                    he.accession_date as accession_date,
                    he.left_date as left_date,
                    hj.id as job_id,
                    hj.no_of_employee as no_of_employee,
                    hj.no_of_recruitment as no_of_recruitment,
                    hj.no_of_hired_employee as no_of_hired_employee,
                    hj.department_id as department_id,
                    he.accession_date as show_date,
                    
                    he.id as employee_id
                    
                FROM  
                    hr_employee he 
                  LEFT JOIN hr_job hj on (he.job_id = hj.id)
                  LEFT JOIN hr_department hd on (hd.id = hj.department_id)
                
                GROUP BY
                    he.id,
                    he.accession_date,
                    he.left_date,
                    hj.id,
                    hj.no_of_employee,
                    hj.no_of_recruitment,
                    hj.no_of_hired_employee,
                    hj.department_id,
                    he.id
            )""")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
