# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class application_applicant(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "application.applicant"
    _description = "Application applicant"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'hr_applicant_id':fields.many2one('hr.applicant','Hr applicant'),
        'education_id':fields.many2one('education','Education'),
        'training_course_id':fields.many2one('training.course','Training course'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        app_applicant = self.pool.get('hr.applicant')
        app = app_applicant.search(cr, uid, [('id','=',data['hr_applicant_id'][0])])
        ap = app_applicant.browse(cr, uid, app)
        
        cr.execute("""select e.how_year from hr_applicant as e where e.id = %s """%(data['hr_applicant_id'][0]))
        apppp  = cr.dictfetchall()
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal left;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        
        
        style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Application applicant')
        sheet.write_merge(0, 2, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(0, 4, u'Санамж:', ezxf('font:bold off, height 160, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write(1, 5, u'1. Анкетыг гаргацтай, үг товчлохгүйгээр бичнэ үү.', ezxf('font: bold off, height 160, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write(2, 5, u'2. Анкетанд хавсаргасан материалыг буцааж олгохгүйг анхаарна уу.', ezxf('font: bold off, height 160, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(3, 4, 5, 11, u'3. Энэхүү анкет бөглөснөөр манай компани таны өмнө ямар нэгэн хариуцлага хүлээхгүй болно.', ezxf('font: bold off, height 160, name Times New Roman;align:wrap on,vert top;'))
        sheet.write_merge(6, 6, 3, 8, u'АЖИЛ ГОРИЛОГЧИЙН АНКЕТ', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
        
        
        sheet.write_merge(8, 8, 0, 3, u'1. Таны сонирхож буй албан тушаал:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.job_id.name == False:
            sheet.write_merge(8, 8, 4, 6, u'', styleb)
        else:
            sheet.write_merge(8, 8, 4, 6, u'%s' %ap.job_id.name, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(8, 14, 8, 9, u'Сүүлийн 3 сарын дотор авхуулсан 3:4 хэмжээтэй зураг /Photo 3*4/', ezxf('font: bold off, name Times New Roman;borders: top thin, left thin, bottom thin, right thin;align:wrap on,horizontal centre, vert top;'))
        sheet.write_merge(10, 10, 0, 3, u'2. Сонирхож буй өөр албан тушаал:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))  
        if ap.pretend_second_job == False:
            sheet.write_merge(10, 10, 4, 6, u'', styleb)
        else:
            sheet.write_merge(10, 10, 4, 6, u'%s' %ap.pretend_second_job, ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))  
        sheet.write_merge(12, 12, 0, 3, u'3. Таны хүсч буй цалин:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.salary_expected == False:
            sheet.write_merge(12, 12, 4, 6, u'', styleb)
        else:
            sheet.write_merge(12, 12, 4, 6, u'%s' %ap.salary_expected, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(14, 14, 0, 3, u'4. Ажилд орох боломжтой огноо:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.hire_out == False:
            sheet.write_merge(14, 14, 4, 6, u'', styleb)
        else:
            sheet.write_merge(14, 14, 4, 6, u'%s' %ap.hire_out, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        
        sheet.write(16, 4, u'НЭГ. ЕРӨНХИЙ МЭДЭЭЛЭЛ', ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(18, 18, 0, 1, u'Ургийн овог:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.surname == False:
            sheet.write_merge(18, 18, 2, 4, u'', styleb)
        else:
            sheet.write_merge(18, 18, 2, 4, u'%s' %ap.surname, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write(18, 6, u'Нас:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.age == False:
            sheet.write(18, 7, u'', styleb)
        else:
            sheet.write(18, 7, u'%s' %ap.age, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write(18, 9, u'Хүйс:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.gender == 'male':
            sheet.write(18, 10, u'Эрэгтэй' , ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        elif ap.gender == 'female':
            sheet.write(18, 10, u'Эмэгтэй' , ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        else:
            sheet.write(18, 10, u'' , styleb)
        sheet.write_merge(20, 20, 0, 1, u'Эцэг/эх/-ийн нэр:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.last_name == False:
            sheet.write_merge(20, 20, 2, 4, u'', styleb)
        else:
            sheet.write_merge(20, 20, 2, 4, u'%s' %ap.last_name, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(20, 20, 6, 7, u'Төрсөн аймаг, хот:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.place_of_birth == False:
            sheet.write_merge(20, 20, 8, 10, u'', styleb)
        else:
            sheet.write_merge(20, 20, 8, 10, u'%s' %ap.place_of_birth, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(22, 22, 0, 1, u'Өөрийн нэр:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.name == False:
            sheet.write_merge(22, 22, 2, 4, u'', styleb)
        else:
            sheet.write_merge(22, 22, 2, 4, u'%s' %ap.name, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(22, 22, 6, 9, u'Жолооны үнэмлэхний ангилал:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        driver_type = ''
        for driver in ap.driver_type_id:
            if driver_type =='':
               driver_type +=  driver.name
            else:
                driver_type = driver_type + ',' + driver.name
        sheet.write(22, 10, u'%s' %driver_type, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(24, 24, 0, 1, u'Төрсөн огноо:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.birthday == False:
            sheet.write_merge(24, 24, 2, 4, u'', styleb)
        else:
            sheet.write_merge(24, 24, 2, 4, u'%s' %ap.birthday, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(24, 24, 6, 7, u'Гар утасны дугаар:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.partner_mobile == False:
            sheet.write_merge(24, 24, 8, 10, u'', styleb)
        else:
            sheet.write_merge(24, 24, 8, 10, u'%s' %ap.partner_mobile, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(26, 26, 0, 1, u'Регистрийн дугаар:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.register_number == False:
            sheet.write_merge(26, 26, 2, 4, u'', styleb)
        else:
            sheet.write_merge(26, 26, 2, 4, u'%s' %ap.register_number, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(26, 26, 6, 7, u'И-мэйл хаяг:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.email_from == False:
            sheet.write_merge(26, 26, 8, 10, u'', styleb)
        else:
            sheet.write_merge(26, 26, 8, 10, u'%s' %ap.email_from, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(28, 28, 0, 1, u'Гэрийн хаяг:', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        if ap.pass_address == False:
            sheet.write_merge(28, 28, 2, 10, u'', styleb)
        else:
            sheet.write_merge(28, 28, 2, 10, u'%s' %ap.pass_address, ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        
        sheet.write(30, 4, u'ХОЁР. БОЛОВСРОЛ БОЛОН СУРГАЛТ', ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write(32, 6, u'*Хамгийн сүүлд төгссөн сургуулиас эхлэн бичнэ үү.', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        
        sheet.write(33, 0, u'А. Ерөнхий боловсрол болон их, дээд сургууль', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(35, 35, 0, 1, u'Он', style_table_header)
        sheet.write(36, 0, u'Элссэн', style_table_header)
        sheet.write(36, 1, u'Төгссөн', style_table_header)
        sheet.write_merge(35, 36, 2, 3, u'Хаана', style_table_header)
        sheet.write_merge(35, 36, 4, 5, u'Сургуулийн нэр', style_table_header)
        sheet.write_merge(35, 36, 6, 7, u'Эзэмшсэн мэргэжил', style_table_header)
        sheet.write_merge(35, 36, 8, 8, u'Эрдмийн зэрэг', style_table_header)
        sheet.write_merge(35, 36, 9, 9, u'Голч дүн', style_table_header)
        sheet.write_merge(35, 36, 10, 11, u'Хамгаалсан сэдэв', style_table_header)
        
        rowx = 37
        rowxx = rowx + 1
        
        edu_obj = self.pool.get('education')
        edu = edu_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])

        for line in edu_obj.browse(cr, uid, edu):
            if line.edu_start == False:
                sheet.write_merge(rowx, rowxx, 0, 0, u'', style_table)
            else:
                sheet.write_merge(rowx, rowxx, 0, 0, u'%s' %line.edu_start, style_table)
            if line.edu_finish == False:
                sheet.write_merge(rowx, rowxx, 1, 1, u'', style_table)
            else:
                sheet.write_merge(rowx, rowxx, 1, 1, u'%s' %line.edu_finish, style_table)
            if line.edu_where == False:
                sheet.write_merge(rowx, rowxx, 2, 3, u'', style_table)
            else:
                sheet.write_merge(rowx, rowxx, 2, 3, u'%s' %line.edu_where, style_table)
            if line.name == False:
                sheet.write_merge(rowx, rowxx, 4, 5, u'', style_table)
            else:
                sheet.write_merge(rowx, rowxx, 4, 5, u'%s' %line.name, style_table)
            if line.edu_profession == False:
                sheet.write_merge(rowx, rowxx, 6, 7, u'', style_table)
            else:
                sheet.write_merge(rowx, rowxx, 6, 7, u'%s' %line.edu_profession, style_table)
            if line.edu_graduation == False:
                sheet.write_merge(rowx, rowxx, 8, 8, u'', style_table)
            else:
                sheet.write_merge(rowx, rowxx, 8, 8, u'%s' %line.edu_graduation, style_table)
            if line.edu_rate == False:
                sheet.write_merge(rowx, rowxx, 9, 9, u'', style_table)
            else:
                sheet.write_merge(rowx, rowxx, 9, 9, u'%s' %line.edu_rate, style_table)
            if line.diploma_subject == False:
                sheet.write_merge(rowx, rowxx, 10, 11, u'', style_table)
            else:
                sheet.write_merge(rowx, rowxx, 10, 11, u'%s' %line.diploma_subject, style_table)
            rowx = rowx + 2
            rowxx = rowxx + 2
        
        rown = rowxx + 1
        sheet.write(rown, 0, u'Б. Мэргэжлийн сургалт, дамжаа', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        rowy = rown + 2
        rowc = rowy + 1
        sheet.write_merge(rowy, rowy, 0, 1, u'Он', style_table_header)
        sheet.write(rowc, 0, u'Элссэн', style_table_header)
        sheet.write(rowc, 1, u'Төгссөн', style_table_header)
        sheet.write_merge(rowy, rowc, 2, 4, u'Хаана', style_table_header)
        sheet.write_merge(rowy, rowc, 5, 8, u'Байгууллагын нэр', style_table_header)
        sheet.write_merge(rowy, rowc, 9, 11, u'Ямар чиглэлээр', style_table_header)
        
        rowm = rowc + 1
        rowmm = rowm + 1
        tc_obj = self.pool.get('training.course')
        tc = tc_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        
        for line1 in tc_obj.browse(cr, uid, tc):
            if line1.start_date == False:
                sheet.write_merge(rowm, rowmm, 0, 0, u'', style_table)
            else:
                sheet.write_merge(rowm, rowmm, 0, 0, u'%s' %line1.start_date, style_table)
            if line1.finish_date == False:
                sheet.write_merge(rowm, rowmm, 1, 1, u'', style_table)
            else:
                sheet.write_merge(rowm, rowmm, 1, 1, u'%s' %line1.finish_date, style_table)
            if line1.where == False:
                sheet.write_merge(rowm, rowmm, 2, 4, u'', style_table)
            else:
                sheet.write_merge(rowm, rowmm, 2, 4, u'%s' %line1.where, style_table)
            if line1.name == False:
                sheet.write_merge(rowm, rowmm, 5, 8, u'', style_table)
            else:
                sheet.write_merge(rowm, rowmm, 5, 8, u'%s' %line1.name, style_table)
            if line1.training_profession == False:
                sheet.write_merge(rowm, rowmm, 9, 11, u'', style_table)
            else:
                sheet.write_merge(rowm, rowmm, 9, 11, u'%s' %line1.training_profession, style_table)
            rowm = rowm + 1
            rowmm = rowmm + 1
        
        rowb = rowmm + 1
        sheet.write(rowb, 0, u'В. Мэргэшсэн зэрэг (мэргэшсэн нягтлан бодогч, эдийн засагч, инженер зэргийг хамруулан бичнэ.)', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        rowd = rowb + 2
        rowe = rowd + 1
        sheet.write_merge(rowd, rowd, 0, 3, u'Он', style_table_header)
        sheet.write_merge(rowe, rowe, 0, 1, u'Элссэн', style_table_header)
        sheet.write_merge(rowe, rowe, 2, 3, u'Төгссөн', style_table_header)
        sheet.write_merge(rowd, rowe, 4, 11, u'Мэргэшсэн зэргийн нэр', style_table_header)
        
        rowf = rowe + 1
        pro_obj = self.pool.get('professionalize')
        pr = pro_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        
        for line2 in pro_obj.browse(cr, uid, pr):
            if line2.pro_start == False:
                sheet.write_merge(rowf, rowf, 0, 1, u'', style_table)
            else:
                sheet.write_merge(rowf, rowf, 0, 1, u'%s' %line2.pro_start, style_table)
            if line2.pro_finish == False:
                sheet.write_merge(rowf, rowf, 2, 3, u'', style_table)
            else:
                sheet.write_merge(rowf, rowf, 2, 3, u'%s' %line2.pro_finish, style_table)
            if line2.name == False:
                sheet.write_merge(rowf, rowf, 4, 11, u'', style_table)
            else:
                sheet.write_merge(rowf, rowf, 4, 11, u'%s' %line2.name, style_table)
            rowf = rowf + 1
            
        rowg = rowf + 1
        roww = rowg+1
        sheet.write(rowg, 0, u'Г. Мэргэжлийн дадлага', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write(roww, 6, u'*Хамрагдаж байсан сургалтуудыг оны дарааллаар бичнэ үү.', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        
        rowh = roww + 2
        rowi = rowh + 1
        sheet.write_merge(rowh, rowh, 0, 1, u'Он', style_table_header)
        sheet.write(rowi, 0, u'Элссэн', style_table_header)
        sheet.write(rowi, 1, u'Төгссөн', style_table_header)
        sheet.write_merge(rowh, rowi, 2, 3, u'Суралцсан хугацаа', style_table_header)
        sheet.write_merge(rowh, rowi, 4, 5, u'Хаана', style_table_header)
        sheet.write_merge(rowh, rowi, 6, 8, u'Ямар байгууллагад', style_table_header)
        sheet.write_merge(rowh, rowi, 9, 11, u'Ямар чиглэлээр', style_table_header)
        
        rowj = rowi + 1
        rowjj = rowj + 1
        prac_obj = self.pool.get('hr.practice')
        prac = prac_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        
        for line3 in prac_obj.browse(cr, uid, prac):
            if line3.practice_start == False:
                sheet.write_merge(rowj, rowjj, 0, 0, u'', style_table)
            else:
                sheet.write_merge(rowj, rowjj, 0, 0, u'%s' %line3.practice_start, style_table)
            if line3.practice_end == False:
                sheet.write_merge(rowj, rowjj, 1, 1, u'', style_table)
            else:
                sheet.write_merge(rowj, rowjj, 1, 1, u'%s' %line3.practice_end, style_table)
            if line3.practice_date == False:
                sheet.write_merge(rowj, rowjj, 2, 3, u'', style_table)
            else:
                sheet.write_merge(rowj, rowjj, 2, 3, u'%s' %line3.practice_date, style_table)
            if line3.practice_department == False:
                sheet.write_merge(rowj, rowjj, 4, 5, u'', style_table)
            else:
                sheet.write_merge(rowj, rowjj, 4, 5, u'%s' %line3.practice_department, style_table)
            if line3.name == False:
                sheet.write_merge(rowj, rowjj, 6, 8, u'', style_table)
            else:
                sheet.write_merge(rowj, rowjj, 6, 8, u'%s' %line3.name, style_table)
            if line3.course_name == False:
                sheet.write_merge(rowj, rowjj, 9, 11, u'', style_table)
            else:
                sheet.write_merge(rowj, rowjj, 9, 11, u'%s' %line3.course_name, style_table)
            rowj = rowj + 1
            rowjj = rowjj + 1
        
        employment_obj = self.pool.get('employment')
        acc_per_obj = self.pool.get('account.period')
        employment = employment_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        empl = employment_obj.browse(cr, uid, employment)
        
        cr.execute("""select e.name, e.org_start, e.director_name, e.org_finish, e.org_position, e.org_reason, e.org_phone, e.id as eid from employment as e 
                       left join hr_applicant as a on e.hr_applicant_id = a.id 
                       where a.id = %s order by e.id desc limit 3"""%(data['hr_applicant_id'][0]))
        lastid  = cr.dictfetchall()
        
      
        rowk = rowjj + 1
        rowl = rowk + 1
        
        
        sheet.write(rowk, 4, u'ГУРАВ. АЖИЛЛАСАН БАЙДАЛ', ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write(rowl, 6, u'*Хамгийн сүүлд ажилласан газраасаа эхэлж бичнэ үү.', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre;'))
        rowo = rowl + 2
        
        if lastid == []:
            rowaaa = rowo + 1
        else:
            for line5 in lastid:
                acc_per = acc_per_obj.search(cr, uid, [('id','=',line5['org_start'])])
                acc_per1 = acc_per_obj.search(cr, uid, [('id','=',line5['org_finish'])])
                acc_per_id = acc_per_obj.browse(cr, uid, acc_per)
                acc_per_id1 = acc_per_obj.browse(cr, uid, acc_per1)
                rowp = rowo + 1
                rowq = rowp + 1
                rowr = rowq + 1
                rows = rowr + 1
                rowt = rows + 1
                rowu = rowt + 1
                rowv = rowu + 1
                rowz = rowv + 1
                rowa = rowz + 1
                rowaaa = rowa + 1
                sheet.write_merge(rowo, rowo, 0, 11, u'', styletlr)
                
                sheet.write_merge(rowp, rowp, 0, 1, u'Байгууллагын нэр:', stylel)
                if line5['name'] == False:
                    sheet.write_merge(rowp, rowp, 2, 4, u'', styleb)
                else:
                    sheet.write_merge(rowp, rowp, 2, 4, u'%s' %line5['name'], style_no_border)
                sheet.write_merge(rowp, rowp, 5, 6, u'Удирдлагын нэр:', style_no_border)
                if line5['director_name'] == None:
                    sheet.write_merge(rowp, rowp, 7, 11, u'', stylebr)
                else:
                    sheet.write_merge(rowp, rowp, 7, 11, u'%s' %line5['director_name'], styler)
                sheet.write_merge(rowq, rowq, 0, 11, u'', stylelr)
                sheet.write_merge(rowr, rowr, 0, 1, u'Утас:', stylel)
                if line5['org_phone']==None:
                    sheet.write_merge(rowr, rowr, 2, 11, u'', stylebr)
                else:
                    sheet.write_merge(rowr, rowr, 2, 11, u'%s' %line5['org_phone'], styler)
                sheet.write_merge(rows, rows, 0, 11, u'', stylelr)
                sheet.write_merge(rowt, rowt, 0, 1, u'Орсон он сар:', stylel)
                if acc_per_id.name == False:
                    sheet.write_merge(rowt, rowt, 2, 4, u'', styleb)
                else:
                    sheet.write_merge(rowt, rowt, 2, 4, u'%s' %acc_per_id.name, style_no_border)
                sheet.write_merge(rowt, rowt, 5, 6, u'Гарсан он сар:', style_no_border)
                if acc_per_id1.name == False:
                    sheet.write_merge(rowt, rowt, 7, 11, u'', stylebr)
                else:
                    sheet.write_merge(rowt, rowt, 7, 11, u'%s' %acc_per_id1.name, styler)
                sheet.write_merge(rowu, rowu, 0, 11, u'', stylelr)
                sheet.write_merge(rowv, rowv, 0, 1, u'Албан тушаал:', stylel)
                if line5['org_position'] == None:
                    sheet.write_merge(rowv, rowv, 2, 11, u'', stylebr)
                else:
                    sheet.write_merge(rowv, rowv, 2, 11, u'%s' %line5['org_position'], styler)
                sheet.write_merge(rowz, rowz, 0, 11, u'', stylelr)
                sheet.write_merge(rowa, rowa, 0, 2, u'Ажлаас гарсан шалтгаан:', stylel)
                if line5['org_reason'] == None:
                    sheet.write_merge(rowa, rowa, 3, 11, u'', stylebr)
                else:
                    sheet.write_merge(rowa, rowa, 3, 11, u'%s' %line5['org_reason'], styler)
                sheet.write_merge(rowaaa, rowaaa, 0, 11, u'', styleblr)
                rowo = rowaaa + 1
            
        rowaa = rowaaa + 2
        rowab = rowaa + 1

        sheet.write_merge(rowaa, rowaa, 0, 11, u'Хэрэв та 6 сараас дээш ажил эрхлээгүй бол шалтгаанаа бичнэ үү.', style_no_border)
        if ap.employment_description == False:
            sheet.write_merge(rowab, rowab, 0, 11, u'', style_no_border)
        else:
            sheet.write_merge(rowab, rowab, 0, 11, u'%s' %ap.employment_description, style_no_border)
        rowac = rowab + 2
        rowad = rowac + 1
        rowae = rowad + 1
        
        notify_obj = self.pool.get('notify.people')
        notify_people = notify_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        notify = notify_obj.browse(cr, uid, notify_people)

        sheet.write_merge(rowac, rowac, 0, 11, u'Таны ажил мэргэжил, туршлага, ур чадварын талаар тодорхойлолт гаргах хүний тухай мэдээлэл', style_no_border)
        sheet.write_merge(rowad, rowae, 0, 0, u'№', style_table_header)
        sheet.write_merge(rowad, rowae, 1, 2, u'Овог', style_table_header)
        sheet.write_merge(rowad, rowae, 3, 4, u'Нэр', style_table_header)
        sheet.write_merge(rowad, rowae, 5, 6, u'Ажилладаг байгууллагын нэр', style_table_header)
        sheet.write_merge(rowad, rowae, 7, 8, u'Албан тушаал', style_table_header)
        sheet.write_merge(rowad, rowae, 9, 9, u'Утас', style_table_header)
        sheet.write_merge(rowad, rowae, 10, 11, u'Э-шуудан', style_table_header)

        rowaf = rowae + 1
        rowaff = rowaf + 1
        number = 1

        for line4 in notify_obj.browse(cr, uid, notify_people):
            if line4 == False:
                sheet.write_merge(rowaf, rowaff, 0, 0, u'', style_table)
            else:
                sheet.write_merge(rowaf, rowaff, 0, 0, u'%s' %number, style_table)
            if line4.relation_last_name == False:
                sheet.write_merge(rowaf, rowaff, 1, 2, u'', style_table)
            else:
                sheet.write_merge(rowaf, rowaff, 1, 2, u'%s' %line4.relation_last_name, style_table)
            if line4.relation_first_name == False:
                sheet.write_merge(rowaf, rowaff, 3, 4, u'', style_table)
            else:
                sheet.write_merge(rowaf, rowaff, 3, 4, u'%s' %line4.relation_first_name, style_table)
            if line4.relation_organization == False:
                sheet.write_merge(rowaf, rowaff, 5, 6, u'', style_table)
            else:
                sheet.write_merge(rowaf, rowaff, 5, 6, u'%s' %line4.relation_organization, style_table)
            if line4.relation_position == False:
                sheet.write_merge(rowaf, rowaff, 7, 8, u'', style_table)
            else:
                sheet.write_merge(rowaf, rowaff, 7, 8, u'%s' %line4.relation_position, style_table)
            if line4.relation_phone == False:
                sheet.write_merge(rowaf, rowaff, 9, 9, u'', style_table)
            else:
                sheet.write_merge(rowaf, rowaff, 9, 9, u'%s' %line4.relation_phone, style_table)
            if line4.e_mail == False:
                sheet.write_merge(rowaf, rowaff, 10, 11, u'', style_table)
            else:
                sheet.write_merge(rowaf, rowaff, 10, 11, u'%s' %line4.e_mail, style_table)
            number = number + 1
            rowaf = rowaf + 2
            rowaff = rowaff + 2

        rowag = rowaff + 1
        rowah = rowag + 2
        rowai = rowah + 2
        
        
        sheet.write(rowag, 4, u'ДӨРӨВ. УР ЧАДВАР', ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(rowah, rowah, 0, 11, u'А. Гадаад хэлний мэдлэг: (Тохирох багананд +тэмдэг тавина уу)', style_no_border)
        sheet.write_merge(rowai, rowai, 0, 3, u'Хэлний төрөл', style_table_header)
        sheet.write_merge(rowai, rowai, 4, 5, u'Ярих', style_table_header)
        sheet.write_merge(rowai, rowai, 6, 7, u'Сонсох', style_table_header)
        sheet.write_merge(rowai, rowai, 8, 9, u'Унших', style_table_header)
        sheet.write_merge(rowai, rowai, 10, 11, u'Бичих', style_table_header)
        
        lang_obj = self.pool.get('hr.language')
        language = lang_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        lang = lang_obj.browse(cr, uid, language)
        
        rowaj = rowai + 1
        
        for line6 in lang_obj.browse(cr, uid, language):
            sheet.write_merge(rowaj, rowaj, 0, 3, u'%s' %line6.name.name, style_table)
            
            if line6.lang_speak == 'bad':
                sheet.write_merge(rowaj, rowaj, 4, 5, u'Муу', style_table)
            elif line6.lang_speak == 'middle':
                sheet.write_merge(rowaj, rowaj, 4, 5, u'Дунд', style_table)
            elif line6.lang_speak == 'good':
                sheet.write_merge(rowaj, rowaj, 4, 5, u'Сайн', style_table)
            else:
                sheet.write_merge(rowaj, rowaj, 4, 5, u'', style_table)
            
            if line6.lang_listen == 'bad':
                sheet.write_merge(rowaj, rowaj, 6, 7, u'Муу', style_table)
            elif line6.lang_listen == 'middle':
                sheet.write_merge(rowaj, rowaj, 6, 7, u'Дунд', style_table)
            elif line6.lang_listen == 'good':
                sheet.write_merge(rowaj, rowaj, 6, 7, u'Сайн', style_table)
            else:
                sheet.write_merge(rowaj, rowaj, 6, 7, u'', style_table)
                
            if line6.lang_read == 'bad':
                sheet.write_merge(rowaj, rowaj, 8, 9, u'Муу', style_table)
            elif line6.lang_read == 'middle':
                sheet.write_merge(rowaj, rowaj, 8, 9, u'Дунд', style_table)
            elif line6.lang_read == 'good':
                sheet.write_merge(rowaj, rowaj, 8, 9, u'Сайн', style_table)
            else:
                sheet.write_merge(rowaj, rowaj, 8, 9, u'', style_table)
            
            if line6.lang_write == 'bad':
                sheet.write_merge(rowaj, rowaj, 10, 11, u'Муу', style_table)
            elif line6.lang_write == 'middle':
                sheet.write_merge(rowaj, rowaj, 10, 11, u'Дунд', style_table)
            elif line6.lang_write == 'good':
                sheet.write_merge(rowaj, rowaj, 10, 11, u'Сайн', style_table)
            else:
                sheet.write_merge(rowaj, rowaj, 10, 11, u'', style_table)
            
            rowaj = rowaj + 1
            
        rowak = rowaj + 1
        rowal = rowak + 2
        
        sheet.write_merge(rowak, rowak, 0, 11, u'Албан ёсны түвшин тогтоох шалгалт', style_no_border)
        sheet.write_merge(rowal, rowal, 0, 3, u'Огноо', style_table_header)
        sheet.write_merge(rowal, rowal, 4, 7, u'Хэлний шалгалтын нэр', style_table_header)
        sheet.write_merge(rowal, rowal, 8, 11, u'Дүн, оноо', style_table_header)
        
        rowam = rowal + 1
        
        lang_exam_obj = self.pool.get('hr.language.exam')
        language_exam = lang_exam_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        lang_exam = lang_exam_obj.browse(cr, uid, language_exam)
        
        for line7 in lang_exam_obj.browse(cr, uid, language_exam):
            if line7.exam_date == False:
                sheet.write_merge(rowam, rowam, 0, 3, u'', style_table)
            else:
                sheet.write_merge(rowam, rowam, 0, 3, u'%s' %line7.exam_date, style_table)
            if line7.name == False:
                sheet.write_merge(rowam, rowam, 4, 7, u'', style_table)
            else:
                sheet.write_merge(rowam, rowam, 4, 7, u'%s' %line7.name, style_table)
            if line7.exam_score == False:
                sheet.write_merge(rowam, rowam, 8, 11, u'', style_table)
            else:
                sheet.write_merge(rowam, rowam, 8, 11, u'%s' %line7.exam_score, style_table)
            rowam = rowam + 1
        rowan = rowam + 1
        rowao = rowan + 2
        rowap = rowao + 1
        
        sheet.write_merge(rowan, rowan, 0, 11, u'Б. Компьютерийн мэдлэг:', style_no_border)
        sheet.write_merge(rowao, rowap, 0, 2, u'Програмын нэр', style_table_header)
        sheet.write_merge(rowao, rowap, 3, 5, u'Бүрэн эзэмшсэн', style_table_header)
        sheet.write_merge(rowao, rowap, 6, 8, u'Хэрэглээний түвшинд эзэмшсэн', style_table_header)
        sheet.write_merge(rowao, rowap, 9, 11, u'Анхан шатны түвшинд эзэмшсэн', style_table_header)
        
        rowaq = rowap + 1
        
        com_skill_obj = self.pool.get('computer.skill')
        com_skill = com_skill_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        
        for line8 in com_skill_obj.browse(cr, uid, com_skill):
            sheet.write_merge(rowaq, rowaq, 0, 2, u'%s' %line8.name.name, style_table)
            if line8.use_skill == 'bad':
                sheet.write_merge(rowaq, rowaq, 9, 11, u'+', style_checking)
                sheet.write_merge(rowaq, rowaq, 6, 8, u'', style_table)
                sheet.write_merge(rowaq, rowaq, 3, 5, u'', style_table)
            elif line8.use_skill == 'middle':
                sheet.write_merge(rowaq, rowaq, 6, 8, u'+', style_checking)
                sheet.write_merge(rowaq, rowaq, 9, 11, u'', style_table)
                sheet.write_merge(rowaq, rowaq, 3, 5, u'', style_table)
            elif line8.use_skill == 'good':
                sheet.write_merge(rowaq, rowaq, 3, 5, u'+', style_checking)
                sheet.write_merge(rowaq, rowaq, 6, 8, u'', style_table)
                sheet.write_merge(rowaq, rowaq, 9, 11, u'', style_table)
            else:
                sheet.write_merge(rowaq, rowaq, 3, 5, u'', style_table)
                sheet.write_merge(rowaq, rowaq, 6, 8, u'', style_table)
                sheet.write_merge(rowaq, rowaq, 9, 11, u'', style_table)
            
            rowaq = rowaq + 1
        rowar = rowaq + 1
        rowas = rowar + 2
        
        sheet.write_merge(rowar, rowar, 0, 11, u'В. Авъяас чадвар:', style_no_border)
        sheet.write_merge(rowas, rowas, 0, 1, u'Төрөл', style_table_header)
        sheet.write_merge(rowas, rowas, 2, 3, u'Нэр', style_table_header)
        sheet.write_merge(rowas, rowas, 4, 5, u'Хичээллэсэн жил', style_table_header)
        sheet.write_merge(rowas, rowas, 6, 7, u'Зэрэг, цол', style_table_header)
        sheet.write_merge(rowas, rowas, 8, 11, u'Амжилт', style_table_header)
        
        rowat = rowas + 1
        rowatt = rowat + 1
        
        hr_cap_obj = self.pool.get('hr.capability')
        hr_cap = hr_cap_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        
        for line9 in hr_cap_obj.browse(cr, uid, hr_cap):
            if line9.cap_type == False:
                sheet.write_merge(rowat, rowatt, 0, 1, u'', style_table)
            else:
                sheet.write_merge(rowat, rowatt, 0, 1, u'%s' %line9.cap_type, style_table)
            if line9.name == False:
                sheet.write_merge(rowat, rowatt, 2, 3, u'', style_table)
            else:
                sheet.write_merge(rowat, rowatt, 2, 3, u'%s' %line9.name, style_table)
            if line9.studied_time == False:
                sheet.write_merge(rowat, rowatt, 4, 5, u'', style_table)
            else:
                sheet.write_merge(rowat, rowatt, 4, 5, u'%s' %line9.studied_time, style_table)
            if line9.rank == False:
                sheet.write_merge(rowat, rowatt, 6, 7, u'', style_table)
            else:
                sheet.write_merge(rowat, rowatt, 6, 7, u'%s' %line9.rank, style_table)
            if line9.achievement == False:
                sheet.write_merge(rowat, rowatt, 8, 11, u'', style_table)
            else:
                sheet.write_merge(rowat, rowatt, 8, 11, u'%s' %line9.achievement, style_table)
            rowat = rowat + 2
            rowatt = rowatt + 2
        rowau = rowatt + 1
        rowav = rowau + 2
        
        sheet.write(rowau, 4, u'ТАВ. ШАГНАЛ', ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(rowav, rowav, 0, 2, u'Огноо', style_table_header)
        sheet.write_merge(rowav, rowav, 3, 4, u'Хаанаас', style_table_header)
        sheet.write_merge(rowav, rowav, 5, 8, u'Шагналын нэр', style_table_header)
        sheet.write_merge(rowav, rowav, 9, 11, u'Тайлбар', style_table_header)
        
        rowaw = rowav + 1
        rowaww = rowaw + 1
        
        gov_award_obj = self.pool.get('government.award')
        gov_award = gov_award_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        
        for line12 in gov_award_obj.browse(cr, uid, gov_award):
            if line12.gov_award_date == False:
                sheet.write_merge(rowaw, rowaww, 0, 2, u'', style_table)
            else:
                sheet.write_merge(rowaw, rowaww, 0, 2, u'%s' %line12.gov_award_date, style_table)
            if line12.gov_award_where == False:
                sheet.write_merge(rowaw, rowaww, 3, 4, u'', style_table)
            else:
                sheet.write_merge(rowaw, rowaww, 3, 4, u'%s' %line12.gov_award_where, style_table)
            if line12.name == False:
                sheet.write_merge(rowaw, rowaww, 5, 8, u'', style_table)
            else:
                sheet.write_merge(rowaw, rowaww, 5, 8, u'%s' %line12.name, style_table)
            if line12.gov_award_description == False:
                sheet.write_merge(rowaw, rowaww, 9, 11, u'', style_table)
            else:
                sheet.write_merge(rowaw, rowaww, 9, 11, u'%s' %line12.gov_award_description, style_table)
            rowaw = rowaw + 2
            rowaww = rowaww + 2
            
        rowax = rowaww + 1
        roway = rowax + 1
        rowaz = roway + 2
        
        sheet.write(rowax, 3, u'ЗУРГАА. ХУВЬ ХҮНИЙ МЭДЭЭЛЭЛ', ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(roway, roway, 0, 11, u'А. Таны давуу болон сул талууд:', style_no_border)
        sheet.write_merge(rowaz, rowaz, 0, 5, u'Таны давуу тал', style_table_header)
        sheet.write_merge(rowaz, rowaz, 6, 11, u'Таны сул тал', style_table_header)
        
        rowaab = rowaz + 1
        rowaabb = rowaab + 1
        
        if ap.advantage == False:
            sheet.write_merge(rowaab, rowaabb, 0, 5, u'', style_table)
        else:
            sheet.write_merge(rowaab, rowaabb, 0, 5, u'%s' %ap.advantage, style_table)
        if ap.vice == False:
            sheet.write_merge(rowaab, rowaabb, 6, 11, u'', style_table)
        else:
            sheet.write_merge(rowaab, rowaabb, 6, 11, u'%s' %ap.vice, style_table)
        
        rowaac = rowaabb + 2
        rowaad = rowaac + 1
        rowaae = rowaad + 1
        
        sheet.write_merge(rowaac, rowaac, 0, 11, u'Б. Таны ирээдүйн зорилго:', style_no_border)
        if ap.five_year == False:
            sheet.write_merge(rowaad, rowaae, 0, 11, u'', styleb)
        else:
            sheet.write_merge(rowaad, rowaae, 0, 11, u'%s' %ap.five_year, style_no_border)
        
        rowaaf = rowaae + 2
        rowaag = rowaaf + 2
        
        sheet.write_merge(rowaaf, rowaaf, 0, 11, u'В. Манай компанид тогтвор суурьшилтай ажиллах хугацаа:', style_no_border)
        if ap.how_year == 'to_one':
            sheet.write_merge(rowaag, rowaag, 0, 11, u'1 жил хүртэл', style_no_border)
        elif ap.how_year == 'one_to_three':
            sheet.write_merge(rowaag, rowaag, 0, 11, u'1 - 3 жил', style_no_border)
        elif ap.how_year == 'three_to':
            sheet.write_merge(rowaag, rowaag, 0, 11, u'3 -аас дээш жил', style_no_border)
        else:
            sheet.write_merge(rowaag, rowaag, 0, 11, u'', styleb)
        
        rowaah = rowaag + 2
        rowaai = rowaah + 2
        rowaaj = rowaai + 1
        
        sheet.write_merge(rowaah, rowaah, 0, 11, u'Г. Гэр бүлийн байдал: Зөвхөн ам бүлд байгаа хүмүүс', style_no_border)
        sheet.write_merge(rowaai, rowaaj, 0, 0, u'Овог', style_table_header)
        sheet.write_merge(rowaai, rowaaj, 1, 1, u'Нэр', style_table_header)
        sheet.write_merge(rowaai, rowaaj, 2, 3, u'Таны хэн болох', style_table_header)
        sheet.write_merge(rowaai, rowaaj, 4, 5, u'Төрсөн огноо', style_table_header)
        sheet.write_merge(rowaai, rowaaj, 6, 7, u'Ажилладаг байгууллага', style_table_header)
        sheet.write_merge(rowaai, rowaaj, 8, 9, u'Албан тушаал', style_table_header)
        sheet.write_merge(rowaai, rowaaj, 10, 11, u'Холбоо барих утас', style_table_header)
        
        rowaak = rowaaj + 1
        rowaakk = rowaak + 1
        
        live_people_obj = self.pool.get('live.people')
        live_people = live_people_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
        
        for line10 in live_people_obj.browse(cr, uid, live_people):
            if line10.live_last_name == False:
                sheet.write_merge(rowaak, rowaakk, 0, 0, u'', style_table)
            else:
                sheet.write_merge(rowaak, rowaakk, 0, 0, u'%s' %line10.live_last_name, style_table)
            if line10.live_first_name == False:
                sheet.write_merge(rowaak, rowaakk, 1, 1, u'', style_table)
            else:
                sheet.write_merge(rowaak, rowaakk, 1, 1, u'%s' %line10.live_first_name, style_table)
            if line10.name == False:
                sheet.write_merge(rowaak, rowaakk, 2, 3, u'', style_table)
            else:
                sheet.write_merge(rowaak, rowaakk, 2, 3, u'%s' %line10.name, style_table)
            if line10.live_birth == False:
                sheet.write_merge(rowaak, rowaakk, 4, 5, u'', style_table)
            else:
                sheet.write_merge(rowaak, rowaakk, 4, 5, u'%s' %line10.live_birth, style_table)
            if line10.live_work_organization == False:
                sheet.write_merge(rowaak, rowaakk, 6, 7, u'', style_table)
            else:
                sheet.write_merge(rowaak, rowaakk, 6, 7, u'%s' %line10.live_work_organization, style_table)
            if line10.live_position == False:
                sheet.write_merge(rowaak, rowaakk, 8, 9, u'', style_table)
            else:
                sheet.write_merge(rowaak, rowaakk, 8, 9, u'%s' %line10.live_position, style_table)
            if line10.live_contact == False:
                sheet.write_merge(rowaak, rowaakk, 10, 11, u'', style_table)
            else:
                sheet.write_merge(rowaak, rowaakk, 10, 11, u'%s' %line10.live_contact, style_table)
            rowaak = rowaak + 2
            rowaakk = rowaakk + 2
        rowaal = rowaakk + 1
        rowaam = rowaal + 1
        rowaamm = rowaam + 1
        
        sheet.write_merge(rowaal, rowaal, 0, 11, u'Д. Таны эрүүл мэндийн байдал:', style_no_border)
        if ap.your_health == False:
            sheet.write_merge(rowaam, rowaamm, 0, 11, u'', styleb)
        else:
            sheet.write_merge(rowaam, rowaamm, 0, 11, u'%s' %ap.your_health, style_no_border)
        
        rowaaoo = rowaamm + 2
        rowaao = rowaaoo + 2
        sheet.write_merge(rowaaoo, rowaaoo, 0, 11, u'Е. Таны “Номин Констракшн” ХХК-д ажилладаг ойрын хамаатан садан, найз нөхөд', style_no_border)
        
        if ap.somebody == True:
            sheet.write(rowaao, 8, u'Тийм', style_table)
            sheet.write(rowaao, 7, u'+', style_checking)
            sheet.write(rowaao, 10, u'', style_table)
            sheet.write(rowaao, 11, u'Үгүй', style_table)
            rowaap = rowaao + 2
            sheet.write_merge(rowaap, rowaap, 0, 3, u'Таны хэн болох', style_table_header)
            sheet.write_merge(rowaap, rowaap, 4, 7, u'Албан тушаал', style_table_header)
            sheet.write_merge(rowaap, rowaap, 8, 11, u'Нэр', style_table_header)
            hr_your_rel_obj = self.pool.get('hr.your.relation')
            hr_your_rel = hr_your_rel_obj.search(cr, uid, [('hr_applicant_id','=',data['hr_applicant_id'][0])])
            rowaaq = rowaap + 1
                
            for line11 in hr_your_rel_obj.browse(cr, uid, hr_your_rel):
                if line11.name == False:
                    sheet.write_merge(rowaaq, rowaaq, 0, 3, u'', style_table)
                else:
                    sheet.write_merge(rowaaq, rowaaq, 0, 3, u'%s' %line11.name, style_table)
                if line11.your_relation_position == False:
                    sheet.write_merge(rowaaq, rowaaq, 4, 7, u'', style_table)
                else:
                    sheet.write_merge(rowaaq, rowaaq, 4, 7, u'%s' %line11.your_relation_position, style_table)
                if line11.hr_employee_id == False:
                    sheet.write_merge(rowaaq, rowaaq, 8, 11, u'', style_table)
                else:
                    sheet.write_merge(rowaaq, rowaaq, 8, 11, u'%s' %line11.hr_employee_id.name, style_table)
                rowaaq = rowaaq + 1
                rowaar = rowaaq + 1
        else:
            sheet.write(rowaao, 8, u'Тийм', style_table)
            sheet.write(rowaao, 7, u'', style_table)
            sheet.write(rowaao, 10, u'+', style_checking)
            sheet.write(rowaao, 11, u'Үгүй', style_table)
            rowaar = rowaao
        rowaar = rowaar + 1
        rowaas = rowaar + 2
        
        sheet.write_merge(rowaar, rowaar, 0, 11, u'Ажлын зарын талаарх мэдээлэл авсан эх сурвалж:', ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))
        if ap.source_id.name == False:
            sheet.write_merge(rowaas, rowaas, 0, 11, u'', styleb)
        else:
            sheet.write_merge(rowaas, rowaas, 0, 11, u'%s' %ap.source_id.name, style_no_border)
        
        rowaat = rowaas + 2
        rowaau = rowaat + 1
        
        sheet.write_merge(rowaat, rowaat, 0, 11, u'Дээрх бүх мэдээллийг үнэн зөв бөглөсөн: ................................  /                      /', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre, horizontal center;'))
        sheet.write_merge(rowaau, rowaau, 4, 11, u'(гарын үсэг)', ezxf('font: bold off, name Times New Roman;align:wrap off,vert centre, horizontal center;'))
        
        rowaav = rowaau + 1
        rowaaw = rowaav + 1
        rowaax = rowaaw + 1
        rowaay = rowaax + 1
        
        sheet.write_merge(rowaav, rowaav, 0, 11, u'Анкетанд хавсаргах материалын жагсаалт:', ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))
        sheet.write_merge(rowaaw, rowaaw, 1, 11, u'1. Цээж зураг -1 хувь /3*4/', style_no_border)
        sheet.write_merge(rowaax, rowaax, 1, 11, u'2. Иргэний үнэмлэхний хуулбар', style_no_border)
        sheet.write_merge(rowaay, rowaay, 1, 11, u'3. Мэргэжлийн үнэмлэх, дипломын хуулбар', style_no_border)
        rowaaz = rowaay + 2
        sheet.write(rowaaz, 5, u'ТАНД АМЖИЛТ ХҮСЬЕ', ezxf('font: bold on, name Times New Roman;align:wrap off,vert centre;'))
        
        
        inch = 2000
        inch1 = 5000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 1*inch
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 1*inch
        sheet.col(6).width = 1*inch
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 1*inch
        sheet.col(10).width = 1*inch
        sheet.col(11).width = 1*inch
        
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

application_applicant()