# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class application_complaint_account(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "application.complaint.account"
    _description = "Application complaint account"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'hr_employee_id':fields.many2one('hr.employee','Hr employee'),
        'application_complaint_account_id':fields.many2one('application.complaint','Application complaint account'),
        
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        empl_obj = self.pool.get('hr.employee')
        empl = empl_obj.browse(cr, uid, ids)
                
        
        child_obj = self.browse(cr, uid, ids)
        
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal left;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        
        
        style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        book = xlwt.Workbook(encoding='utf8')
        
        sheet = book.add_sheet('Application complaint account')
        

            
        cr.execute("""select resource_resource.company_id as compid, hr_employee.name_related,
                hr_employee.id as empid, hr_employee.last_name, hr_job.name as jname, 
                application_complaint.hr_employee_id as appid, application_complaint.date, 
                application_complaint.comment, application_complaint.decision, hr_department.name as depname,
                application_complaint.deliver_date, res_company.name as compname,
                application_complaint.name as appname, hr_department.id as depid
                from 
                public.resource_resource,
                public.hr_employee, 
                public.application_complaint,
                public.hr_department,
                public.hr_job,
                public.res_company
                where 
                  resource_resource.id = hr_employee.resource_id AND
                  application_complaint.hr_employee_id = hr_employee.id AND
                  hr_job.id = hr_employee.job_id AND
                  res_company.id = resource_resource.company_id AND
                  hr_department.id = hr_employee.department_id
                order by hr_department.id, hr_employee.name_related""")
        app_comps  = cr.dictfetchall()
        
        sheet.write_merge(0, 2, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(4, 4, 3, 8, u'ӨРГӨДӨЛ ГОМДЛЫН БҮРТГЭЛ', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
        sheet.write_merge(5, 5, 3, 8, u'(Алба, хэлтсээр)', ezxf('font: bold off, height 200, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
        sheet.write_merge(7, 9, 2, 2, u'№', style_table_header)
        sheet.write_merge(7, 9, 3, 3, u'Огноо', style_table_header)
        sheet.write_merge(7, 9, 4, 7, u'Өргөдлийн утга', style_table_header)
        sheet.write_merge(7, 9, 8, 10, u'Шийдвэрлэсэн байдал', style_table_header)
        sheet.write_merge(7, 9, 11, 11, u'Танилцуулсан огноо', style_table_header)
        
        rowx = 10
        rowy = rowx + 1
        
        if app_comps:
            i=1
            c=0
            g = 0
            related =''
        
            for line in app_comps:
                if line['depid'] == c:
                    i=1
                    if line['name_related'] == related:
                        g = 0
                    else:
                        if line['name_related'] == None:
                            sheet.write_merge(rowx, rowy, 1, 2, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 1, 2, u'%s' %line['name_related'], style_no_border)
                        if line['appname'] == None:
                            sheet.write_merge(rowx, rowy, 3, 4, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line['appname'], style_no_border)
                        if line['compname'] == None:
                            sheet.write_merge(rowx, rowy, 5, 6, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line['compname'], style_no_border)
                        rowy +=2
                        rowx +=2
                        if line['appid'] == related:
                            g = 0
                        else:
                            app_comp_obj = self.pool.get('application.complaint')
                            app_comp_id = app_comp_obj.search(cr, uid, [('hr_employee_id','=',line['appid'])])
                            app_id = app_comp_obj.browse(cr, uid, app_comp_id)
                            for line1 in app_id:
                                sheet.write_merge(rowx, rowy, 2, 2, u'%s' %i, style_table)
                                if line1.date == False:
                                    sheet.write_merge(rowx, rowy, 3, 3, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 3, 3, u'%s' %line1.date, style_table)
                                if line1.comment == False:
                                    sheet.write_merge(rowx, rowy, 4, 7, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 4, 7, u'%s' %line1.comment, style_table)
                                if line1.decision == False:
                                    sheet.write_merge(rowx, rowy, 8, 10, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 8, 10, u'%s' %line1.decision, style_table)
                                if line1.deliver_date == False:
                                    sheet.write_merge(rowx, rowy, 11, 11, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 11, 11, u'%s' %line1.deliver_date, style_table)
                                
                                rowy +=2
                                rowx +=2
                                i=i+1
                                
                            related = line['appid']
                        related = line['name_related']
                        
                else:
                    i=1
                    sheet.write_merge(rowx, rowx, 0, 3, u'%s' %line['depname'], ezxf('font: bold on;align:wrap off,vert centre, horiz left;'))
                    rowy += 1
                    rowx += 1
                    if line['name_related'] == related:
                        g = 0
                    else:
                        if line['name_related'] == None:
                            sheet.write_merge(rowx, rowy, 1, 2, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 1, 2, u'%s' %line['name_related'], style_no_border)
                        if line['appname'] == None:
                            sheet.write_merge(rowx, rowy, 3, 4, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line['appname'], style_no_border)
                        if line['compname'] == None:
                            sheet.write_merge(rowx, rowy, 5, 6, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line['compname'], style_no_border)
                        rowy +=2
                        rowx +=2
                        if line['appid'] == related:
                            g = 0
                        else:
                            app_comp_obj = self.pool.get('application.complaint')
                            app_comp_id = app_comp_obj.search(cr, uid, [('hr_employee_id','=',line['appid'])])
                            app_id = app_comp_obj.browse(cr, uid, app_comp_id)
                            #,('is_child','=',True)]
                            for line1 in app_id:
                                sheet.write_merge(rowx, rowy, 2, 2, u'%s' %i, style_table)
                                if line1.date == False:
                                    sheet.write_merge(rowx, rowy, 3, 3, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 3, 3, u'%s' %line1.date, style_table)
                                if line1.comment == False:
                                    sheet.write_merge(rowx, rowy, 4, 7, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 4, 7, u'%s' %line1.comment, style_table)
                                if line1.decision == False:
                                    sheet.write_merge(rowx, rowy, 8, 10, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 8, 10, u'%s' %line1.decision, style_table)
                                if line1.deliver_date == False:
                                    sheet.write_merge(rowx, rowy, 11, 11, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 11, 11, u'%s' %line1.deliver_date, style_table)
                                rowy +=2
                                rowx +=2
                                i=i+1
                            
                            related = line['appid']
                        related = line['name_related']
                    c = line['depid']
        rowy = rowy + 2
        sheet.write_merge(rowy, rowy, 1, 10, u'Бүртгэл хянасан: Хүний нөөцийн албаны дарга.....................................', ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        rowy = rowy + 1
        sheet.write_merge(rowy, rowy, 1, 10, u'Бүртгэл гаргасан:  Хүний нөөцийн менежер....................................', ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))

        inch = 2000
        inch1 = 5000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 1*inch
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 1*inch
        sheet.col(6).width = 1*inch
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 1*inch
        sheet.col(10).width = 1*inch
        sheet.col(11).width = 1*inch
        
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

application_complaint_account()