# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta


class application_employee(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "application.employee"
    _description = "Application employee"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'hr_employee_id':fields.many2one('hr.employee','Hr employee'),
        'education_id':fields.many2one('education','Education'),
        'training_course_id':fields.many2one('training.course','Training course'),
        'res_type':fields.selection([('by_employee', 'By employee'),('by_employees', 'Employees')], 'Res type', required=True),
        
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 140; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 140; borders: right thin; align: wrap on, vertical center, horizontal left;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 140; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 140; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        
        style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_small = ezxf('font: bold off, name Times New Roman, height 160; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_sm_i = ezxf('font: bold off, italic on, name Times New Roman, height 160; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        book = xlwt.Workbook(encoding='utf8')
        
        
        
        emp_obj = self.browse(cr, uid, ids)
        
        if emp_obj.res_type == 'by_employee':
            sheet = book.add_sheet('Application employee')
            sheet.portrait = True
            sheet.write_merge(0, 2, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
        
            hr_employee = self.pool.get('hr.employee')
            employee = hr_employee.search(cr, uid, [('id','=',data['hr_employee_id'][0])])
            emp = hr_employee.browse(cr, uid, employee)
            
            sheet.write_merge(3, 3, 3, 8, u'АЖИЛТНЫ АНКЕТ', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
            sheet.write_merge(6, 11, 9, 10, u'Сүүлийн 3 сарын дотор авхуулсан 3:4 хэмжээтэй зураг /Photo 3*4/', ezxf('font: bold off, name Times New Roman;borders: top thin, left thin, bottom thin, right thin;align:wrap on,horizontal centre, vert top;'))    
            
            sheet.write_merge(4, 4, 2, 9, u'Манай компанийн нэгэн гишүүн болсон танд баяр хүргье.', ezxf('font: bold on, height 200, name Times New Roman;align:wrap off,vert centre, horiz centre;'))
            
            sheet.write_merge(6, 6, 0, 1, u'Ажилтны овог:', style_no_border)
            if emp.last_name == False:
                sheet.write_merge(6, 6, 2, 3, u'', style_no_border)
            else:
                sheet.write_merge(6, 6, 2, 3, u'%s' %emp.last_name, style_no_border)
            sheet.write_merge(6, 6, 4, 5, u'Ажилтны нэр:', style_no_border)
            sheet.write_merge(6, 6, 6, 7, u'%s' %emp.name, style_no_border)
            
            sheet.write_merge(8, 8, 0, 1, u'Гэр бүлтэй эсэх', style_no_border)
            
            if emp.marital == 'married':
                sheet.write(8, 4, u'Тийм', style_table)
                sheet.write(8, 3, u'+', style_checking)
                sheet.write(8, 6, u'', style_table)
                sheet.write(8, 7, u'Үгүй', style_table)
            else:
                sheet.write(8, 4, u'Тийм', style_table)
                sheet.write(8, 3, u'', style_table)
                sheet.write(8, 6, u'+', style_checking)
                sheet.write(8, 7, u'Үгүй', style_table)
            
            sheet.write_merge(11, 11, 1, 7, u'1. Гэр бүлийн байдал:', ezxf('font: bold on, height 200, name Times New Roman;align:wrap off,vert centre, horiz left;'))
            
            sheet.write_merge(13, 15, 0, 0, u'Таны хэн болох:', style_table_header)
            sheet.write_merge(13, 15, 1, 1, u'Овог:', style_table_header)
            sheet.write_merge(13, 15, 2, 2, u'Нэр:', style_table_header)
            sheet.write_merge(13, 15, 3, 4, u'Төрсөн огноо:', style_table_header)
            sheet.write_merge(13, 15, 5, 5, u'Нас:', style_table_header)
            sheet.write_merge(13, 15, 6, 6, u'Хүйс:', style_table_header)
            sheet.write_merge(13, 15, 7, 8, u'Ажилладаг байгууллага:', style_table_header)
            sheet.write_merge(13, 15, 9, 9, u'Албан тушаал:', style_table_header)
            sheet.write_merge(13, 15, 10, 11, u'Холбоо барих утас:', style_table_header)
            
            i = 16
            ab = i + 1
            cr.execute("""select l.name, live_last_name, live_first_name, live_birth, live_age, 
                        live_work_organization, live_position, l.gender, live_contact, l.is_child from live_people as l 
                        left join hr_employee as e on l.hr_employee_id = e.id 
                        where e.id = %s order by l.is_child"""%(data['hr_employee_id'][0]))
            live_info  = cr.dictfetchall()
            
            for line0 in live_info:
                if line0['is_child'] == False:
                    sheet.write_merge(i, ab, 0, 0, u'%s' %line0['name'], style_table)
                    sheet.write_merge(i, ab, 1, 1, u'%s' %line0['live_last_name'], style_table)
                    sheet.write_merge(i, ab, 2, 2, u'%s' %line0['live_first_name'], style_table)
                    sheet.write_merge(i, ab, 3, 4, u'%s' %line0['live_birth'], style_table)
                    sheet.write_merge(i, ab, 5, 5, u'%s' %line0['live_age'], style_table)
                    if line0['gender'] == 'male':
                        sheet.write_merge(i, ab, 6, 6, u'Эрэгтэй', style_table)
                    else:
                        sheet.write_merge(i, ab, 6, 6, u'Эмэгтэй', style_table)
                        
                    sheet.write_merge(i, ab, 7, 8, u'%s' %line0['live_work_organization'], style_table)
                    sheet.write_merge(i, ab, 9, 9, u'%s' %line0['live_position'], style_table)
                    sheet.write_merge(i, ab, 10, 11, u'%s' %line0['live_contact'], style_table)
                    ab = ab + 1
            n = ab+1
            sheet.write_merge(n, n, 0, 2, u'Хүүхдийн овог', style_table_header)
            sheet.write_merge(n, n, 3, 5, u'Хүүхдийн нэр', style_table_header)
            sheet.write_merge(n, n, 6, 8, u'Төрсөн огноо', style_table_header)
            sheet.write_merge(n, n, 9, 11, u'Сургууль, цэцэрлэг', style_table_header)
            
            zaaz = n + 1
            for line1 in live_info:
                
                if line1['is_child'] == True:
                    sheet.write_merge(zaaz, zaaz, 0, 2, u'%s' %line1['live_last_name'], style_table)
                    sheet.write_merge(zaaz, zaaz, 3, 5, u'%s' %line1['live_first_name'], style_table)
                    sheet.write_merge(zaaz, zaaz, 6, 8, u'%s' %line1['live_birth'], style_table)
                    sheet.write_merge(zaaz, zaaz, 9, 11, u'%s' %line1['live_work_organization'], style_table)
                    zaaz = zaaz + 1
            a = zaaz + 2
            b = a + 2
            c = b + 2
            d = c + 2
            z = d + 1
            sheet.write_merge(a, a, 1, 11, u'2. Холбоо барих хаяг:', ezxf('font: bold on, height 200, name Times New Roman;align:wrap off,vert centre, horiz left;'))
            
            sheet.write_merge(b, b, 0, 3, u'Гэрийн хаяг: /Иргэний үнэмлэх дээрх/', style_no_border)
            if emp.dependence_address == False:
                sheet.write_merge(b, b, 4, 11, u'', style_no_border)
            else:
                sheet.write_merge(b, b, 4, 11, u'%s' %emp.dependence_address, style_no_border)
            sheet.write_merge(c, c, 0, 3, u'Одоо оршин суугаа газрын хаяг', style_no_border)
            if emp.home_address == False:
                sheet.write_merge(c, c, 4, 11, u'', style_no_border)
            else:
                sheet.write_merge(c, c, 4, 11, u'%s' %emp.home_address, style_no_border)
            sheet.write_merge(d, d, 0, 2, u'Амьдарч буй байрны өмчлөл', style_no_border)
            if emp.apartment_type == 'own_house':
                sheet.write(d, 3, u'+', style_checking)
                sheet.write(d, 5, u'', style_checking)
                sheet.write(d, 7, u'', style_checking)
                sheet.write(d, 9, u'', style_checking)
            elif emp.apartment_type == 'rental':
                sheet.write(d, 5, u'+', style_checking)
                sheet.write(d, 3, u'', style_checking)
                sheet.write(d, 7, u'', style_checking)
                sheet.write(d, 9, u'', style_checking)
            elif emp.apartment_type == 'organization':
                sheet.write(d, 7, u'+', style_checking)
                sheet.write(d, 3, u'', style_checking)
                sheet.write(d, 5, u'', style_checking)
                sheet.write(d, 9, u'', style_checking)
            elif emp.apartment_type == 'state_apartment':
                sheet.write(d, 9, u'+', style_checking)
                sheet.write(d, 3, u'', style_checking)
                sheet.write(d, 5, u'', style_checking)
                sheet.write(d, 7, u'', style_checking)
            else:
                sheet.write(d, 3, u'', style_checking)
                sheet.write(d, 5, u'', style_checking)
                sheet.write(d, 7, u'', style_checking)
                sheet.write(d, 9, u'', style_checking)
            sheet.write(d, 4, u'Өөрийн', style_no_border)
            sheet.write(d, 6, u'Түрээс', style_no_border)
            sheet.write_merge(d, z, 8, 8, u'Аав, ээжийн', style_no_border)
            sheet.write_merge(d, z, 10, 11, u'Хамаатан садангийн', style_no_border)
            
            e = z + 2
            az = e + 1
            
            sheet.write_merge(e, e, 0, 2, u'Амьдарч буй байрны төрөл', style_no_border)
            sheet.write(e, 3, u'', style_table)
            sheet.write_merge(e, az, 4, 4, u'Орон сууц', style_no_border)
            sheet.write(e, 5, u'', style_table)
            sheet.write_merge(e, az, 6, 6, u'Хашаа байшин', style_no_border)
            sheet.write(e, 7, u'', style_table)
            sheet.write_merge(e, az, 8, 9, u'Хашаа гэр', style_no_border)
            
            f = az + 2
            g =  f + 2
            ac = g + 2
            h = ac + 1
            
            sheet.write_merge(f, f, 1, 11, u'3. Төрсөн аав, ээж, ах, эгч, дүү талаарх мэдээлэл', ezxf('font: bold on, height 200, name Times New Roman;align:wrap off,vert centre, horiz left;'))
            
            sheet.write_merge(g, ac, 0, 0, u'Таны хэн болох:', style_table_header)
            sheet.write_merge(g, ac, 1, 1, u'Овог:', style_table_header)
            sheet.write_merge(g, ac, 2, 2, u'Нэр:', style_table_header)
            sheet.write_merge(g, ac, 3, 4, u'Төрсөн огноо:', style_table_header)
            sheet.write_merge(g, ac, 5, 5, u'Нас:', style_table_header)
            sheet.write_merge(g, ac, 6, 8, u'Ажилладаг байгууллага:', style_table_header)
            sheet.write_merge(g, ac, 9, 10, u'Албан тушаал:', style_table_header)
            sheet.write_merge(g, ac, 11, 11, u'Холбоо барих утас:', style_table_header)
            
            hr_rel_obj = self.pool.get('hr.relationship')
            hr_rel = hr_rel_obj.search(cr, uid, [('hr_employee_id','=',data['hr_employee_id'][0])])
            ad = h + 1
            for line2 in hr_rel_obj.browse(cr, uid, hr_rel):
                
                sheet.write_merge(h, ad, 0, 0, u'%s' %line2.name, style_table)
                sheet.write_merge(h, ad, 1, 1, u'%s' %line2.relationship_last_name, style_table)
                sheet.write_merge(h, ad, 2, 2, u'%s' %line2.relationship_first_name, style_table)
                sheet.write_merge(h, ad, 3, 4, u'%s' %line2.birth, style_table)
                sheet.write_merge(h, ad, 5, 5, u'%s' %line2.age, style_table)
                sheet.write_merge(h, ad, 6, 8, u'%s' %line2.work_organization, style_table)
                sheet.write_merge(h, ad, 9, 10, u'%s' %line2.relationship_position, style_table)
                sheet.write_merge(h, ad, 11, 11, u'%s' %line2.relationship_contact, style_table)
                h = h + 2
                ad = ad + 2
            j = ad + 1
            k = j + 1
            m = k + 1
            
            sheet.write_merge(j, j, 1, 11, u'4. Таны хобби, чөлөөт цагаараа хийдэг зүйлс', ezxf('font: bold on, height 200, name Times New Roman;align:wrap off,vert centre, horiz left;'))
            if emp.hobby == False:
                sheet.write_merge(k, m, 0, 11, u'', style_no_border)
            else:
                sheet.write_merge(k, m, 0, 11, u'%s' %emp.hobby, style_no_border)
            
            o = m + 2
            p = o + 2
            
            sheet.write_merge(o, o, 1, 11, u'5. Номин Констракшн ХХК болон охин компаниудад таны танил, найз нөхөд, хамаатан садан ажилладаг эсэх:', ezxf('font: bold on, height 200, name Times New Roman;align:wrap off,vert centre, horiz left;'))
            
            if emp.somebody == True:
                sheet.write(p, 2, u'+', style_checking)
                sheet.write(p, 3, u'Тийм', style_table)
                sheet.write(p, 5, u'', style_table)
                sheet.write(p, 6, u'Үгүй', style_table)
            else:
                sheet.write(p, 2, u'', style_table)
                sheet.write(p, 3, u'Тийм', style_table)
                sheet.write(p, 5, u'+', style_checking)
                sheet.write(p, 6, u'Үгүй', style_table)
            
            q = p + 2
            r = q + 1
            
            sheet.write_merge(q, q, 0, 2, u'Таны хэн болох', style_table_header)
            sheet.write_merge(q, q, 3, 5, u'Нэр', style_table_header)
            sheet.write_merge(q, q, 6, 8, u'Газар, нэгж', style_table_header)
            sheet.write_merge(q, q, 9, 11, u'Албан тушаал', style_table_header)
            
            hr_your_rel_obj = self.pool.get('hr.your.relation')
            hr_your_rel = hr_your_rel_obj.search(cr, uid, [('hr_employee_id','=',data['hr_employee_id'][0])])
            
            for line3 in hr_your_rel_obj.browse(cr, uid, hr_your_rel):
                sheet.write_merge(r, r, 0, 2, u'%s' %line3.name, style_table)
                sheet.write_merge(r, r, 3, 5, u'%s' %line3.hr_employee_id.name, style_table)
                sheet.write_merge(r, r, 6, 8, u'%s' %line3.your_relation_organization, style_table)
                sheet.write_merge(r, r, 9, 11, u'%s' %line3.your_relation_position, style_table)
                r = r + 1
            t = r + 2
            v = t + 2
            sheet.write_merge(t, v, 0, 11, u'Миний өгсөн мэдээлэл бүр үнэн зөв бөгөөд ямар нэгэн зүйл буруу буюу худал байсны улмаас учирсан хохирлыг бүрэн хариуцах ба хэрэв шаардлагатай бол энэ нь тус компанитай байгуулсан хөдөлмөрийн гэрээ цуцлах үндэслэл болохыг би зөвшөөрч байна.',ezxf('font: bold on, height 200, name Times New Roman;align:wrap on,vert centre, horiz left;'))
            w = v + 2
            x = w + 2
            y = x + 2
            sheet.write_merge(w, w, 1, 11, u'Гарын үсэг:',ezxf('font: bold on, height 200, name Times New Roman;align:wrap on,vert centre, horiz left;'))
            sheet.write_merge(x, x, 1, 11, u'Огноо:',ezxf('font: bold on, height 200, name Times New Roman;align:wrap on,vert centre, horiz left;'))
            sheet.write_merge(y, y, 0, 11, u'ТАНД АЖЛЫН ӨНДӨР АМЖИЛТ ХҮСЬЕ:',ezxf('font: bold on, height 220, name Times New Roman;align:wrap off,vert centre, horiz center;'))
        
            inch = 2000
            inch1 = 5000
            sheet.col(0).width = 1*inch
            sheet.col(1).width = 1*inch
            sheet.col(2).width = 1*inch
            sheet.col(3).width = 1*inch
            sheet.col(4).width = 1*inch
            sheet.col(5).width = 1*inch
            sheet.col(6).width = 1*inch
            sheet.col(7).width = 1*inch
            sheet.col(8).width = 1*inch
            sheet.col(9).width = 1*inch
            sheet.col(10).width = 1*inch
            sheet.col(11).width = 1*inch
        
        else:
            sheet = book.add_sheet('Employees')
            sheet.portrait = False
            cr.execute("""select e.*
                    from hr_employee as e, resource_resource as r 
                    where r.id = e.resource_id and
                    r.active = True
                    order by id asc""")
            employees  = cr.dictfetchall()
            
            sheet.write_merge(0, 1, 0, 2, u'', style_table)    
            sheet.write_merge(1, 1, 5, 6, u'АЖИЛТНУУДЫН СУДАЛГАА', ezxf('font: bold on, height 200, name Times New Roman;align:wrap on,vert centre, horiz centre;'))    
            
            sheet.write(3, 0, u'№', style_table_header)
            sheet.write(3, 1, u'Ажилтны овог', style_table_header)
            sheet.write(3, 2, u'Ажилтны нэр', style_table_header)
            sheet.write(3, 3, u'Ажилтны код', style_table_header)
            sheet.write(3, 4, u'Хүйс', style_table_header)
            sheet.write(3, 5, u'Гэрийн хаяг', style_table_header)
            sheet.write(3, 6, u'Гэрийн утас', style_table_header)
            sheet.write(3, 7, u'Орон сууцны мэдээлэл', style_table_header)
            sheet.write(3, 8, u'Хэлтэс', style_table_header)
            sheet.write(3, 9, u'Албан тушаал', style_table_header)
            sheet.write(3, 10, u'Үндсэн мэргэжил', style_table_header)
            sheet.write(3, 11, u'Ажиллаж буй жил(сараар)', style_table_header)
            
            i = 4
            j= i + 2
            k = 1
            for line0 in employees:
                if line0:
                    sheet.write_merge(i, j, 0, 0, u'%s' %k, style_table)
                    if line0['last_name'] == None:
                        sheet.write_merge(i, j, 1, 1, u'', style_table)
                    else:
                        sheet.write_merge(i, j, 1, 1, u'%s' %line0['last_name'], style_table)
                    sheet.write_merge(i, j, 2, 2, u'%s' %line0['name_related'], style_table)
                    sheet.write_merge(i, j, 3, 3, u'%s' %line0['employee_code'], style_table)
                    if line0['gender'] == 'male':
                        sheet.write_merge(i, j, 4, 4, u'Эрэгтэй', style_table)
                    elif line0['gender'] == 'female':
                        sheet.write_merge(i, j, 4, 4, u'Эмэгтэй', style_table)
                    else:
                        sheet.write_merge(i, j, 4, 4, u'Хүйсийн мэдээллээ бөглөөгүй!', style_table_sm_i)
                    if line0['home_address'] == None:
                        sheet.write_merge(i, j, 5, 5, u'', style_table_small)
                    else:
                        sheet.write_merge(i, j, 5, 5, u'%s' %line0['home_address'], style_table_small)
                    if line0['home_phone'] == None:
                        sheet.write_merge(i, j, 6, 6, u'', style_table)
                    else:
                        sheet.write_merge(i, j, 6, 6, u'%s' %line0['home_phone'], style_table)
                    
                    if line0['apartment_type'] == 'state_apartment':
                        sheet.write_merge(i, j, 7, 7, u'Хамаатан садангийн', style_table)
                    elif line0['apartment_type'] == 'organizzation':
                        sheet.write_merge(i, j, 7, 7, u'Эцэг эхийн', style_table)
                    elif line0['apartment_type'] == 'rental':
                        sheet.write_merge(i, j, 7, 7, u'Түрээсийн', style_table)
                    elif line0['apartment_type'] == 'own_house':
                        sheet.write_merge(i, j, 7, 7, u'Хувийн хашаа байшин', style_table)
                    else:
                        sheet.write_merge(i, j, 7, 7, u'', style_table)
                    
                    if line0['department_id'] == None:
                        sheet.write_merge(i, j, 8, 8, u'', style_table)
                    else:
                        dep_obj = self.pool.get('hr.department')
                        deps = dep_obj.search(cr, uid, [('id','=',line0['department_id'])])
                        deps_id = dep_obj.browse(cr, uid, deps)
                        sheet.write_merge(i, j, 8, 8, u'%s' %deps_id.name, style_table)
                    
                    if line0['job_id'] == None:
                        sheet.write_merge(i, j, 9, 9, u'', style_table)
                    else:
                        job_obj = self.pool.get('hr.job')
                        jobs = job_obj.search(cr, uid, [('id','=',line0['job_id'])])
                        jobs_id = job_obj.browse(cr, uid, jobs)
                        sheet.write_merge(i, j, 9, 9, u'%s' %jobs_id.name, style_table)
                    
                    if line0['profession_id'] == None:
                        sheet.write_merge(i, j, 10, 10, u'', style_table)
                    else:
                        prof_obj = self.pool.get('basis.profession')
                        profs = prof_obj.search(cr, uid, [('id','=',line0['profession_id'])])
                        profs_id = prof_obj.browse(cr, uid, profs)
                        sheet.write_merge(i, j, 10, 10, u'%s' %profs_id.name, style_table)
                    
                    sheet.write_merge(i, j, 11, 11, u'%s' %line0['working_year'], style_table)
                    i = i + 3
                    j = j + 3
                    k = k + 1
        
            inch = 1500
            sheet.col(0).width = 1*inch
            sheet.col(1).width = 2*inch
            sheet.col(2).width = 2*inch
            sheet.col(3).width = 2*inch
            sheet.col(4).width = 2*inch
            sheet.col(5).width = 2*inch
            sheet.col(6).width = 2*inch
            sheet.col(7).width = 2*inch
            sheet.col(8).width = 2*inch
            sheet.col(9).width = 2*inch
            sheet.col(10).width = 2*inch
            sheet.col(11).width = 2*inch
            
            inch1 = 500
            sheet.row(0).height = 1*inch1
            sheet.row(1).height = 1*inch1
            sheet.row(2).height = 1*inch1
            sheet.row(3).height = 1*inch1
        
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

application_employee()