# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class award_list_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "award.list.report"
    _description = "Award list report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company'),
        'hr_employee_id':fields.many2one('hr.employee','Employee Name'), 
        }
    
    #_defaults = {
    #   'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    #}
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        queryString="""SELECT 
                      a.name AS award_name, 
                      e.last_name || ' овогтой ' AS last_name, 
                      a.received_date, 
                      c.name company_name, 
                      e.name_related name_related, 
                      j.name AS position_name,
                      c.id company_id,
                      e.id employee_id,
                      d.name department_name,
                      d.id depid
                     FROM 
                      award_list a
                      left outer join res_partner part    on (part.id=a.company_name)
                      left outer join hr_employee e  on (a.hr_employee_id =e.id)
                      left outer join hr_department d on (d.id = e.department_id)
                      left outer join res_company c on (c.id = part.company_id) 
                      left outer join hr_job j on (j.id = e.job_id)
                     Where a.hr_employee_id =e.id
                     """
        
#         if not data['hr_employee_id']:
#             print "List is empty"
#         else: 
#             queryString=queryString+" AND a.hr_employee_id ="+str((data['hr_employee_id'][0]))
#                                          
#         if not data['company_id']:
#             print "List is empty"
#         else: 
#             queryString=queryString+" AND d.company_id="+str((data['company_id'][0]))
#      
        queryString+=" order by   d.name asc ,e.name_related asc ,a.received_date desc  "
        print queryString
        cr.execute(queryString)
        apppp  = cr.dictfetchall()
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal left;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        
        
        style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Award List')
        
        sheet.write_merge(0, 2, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
       
        sheet.write_merge(3, 3, 3, 8, u'ШАГНАЛЫН БҮРТГЭЛ', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))
        
        sheet.write_merge(6, 8, 2, 2, u'№', style_table_header)
        sheet.write_merge(6, 8, 3, 9, u'Шагналын нэр', style_table_header)
        sheet.write_merge(6, 8, 10, 11, u'Шагнал авсан огноо', style_table_header)
        
        rowx=9
        rowy=rowx+1
     
        if apppp:
            i=1
            c=0
            g = 0
            relatedEmpId =0
            relatedName=''
            
            for award in apppp:
                
                
                last_name=''
                first_name=''
                full_name=''
                if award['name_related']!= None:
                    first_name=award['name_related']
                    
                last_name=award['last_name']
                
                full_name = u'%s'%last_name + u'%s'%first_name
                
                
                if award['depid']==c:
                    if award['name_related']==relatedName:
                        g=0
                    else:
                        i=1
                       
                        
                        if award['name_related'] == None:
                            sheet.write_merge(rowx, rowy, 1, 4, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 1, 4, u'%s' %full_name, style_no_border)
                        
                        
                        if award['company_name'] == None:
                            sheet.write_merge(rowx, rowy, 5, 7, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 5, 7, u'%s' %award['company_name'], style_no_border)
                            
                        if award['position_name'] == None:
                             sheet.write_merge(rowx, rowy, 8, 11, u'', styleb)
                        else:
                             sheet.write_merge(rowx, rowy, 8, 11, u'%s' %award['position_name'], style_no_border)
                        rowx +=2
                        rowy +=2
                else:
                    i=1
                    relatedName=''
                    if award['department_name'] == None:
                        sheet.write_merge(rowx, rowx, 0, 1, u'', styleb)
                    else:
                        sheet.write_merge(rowx, rowx, 0, 1, u'%s' %award['department_name'], ezxf('font: bold on;align:wrap off,vert centre, horiz left;'))
                        
                    rowy += 1
                    rowx += 1
                    print "here 1"
                    
                    if award['name_related'] == relatedName:
                        g = 0
                    else:
                        if award['name_related'] == None:
                            sheet.write_merge(rowx, rowy, 1, 4, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 1, 4, u'%s' %full_name, style_no_border)
                        
                        
                        if award['company_name'] == None:
                            sheet.write_merge(rowx, rowy, 5, 7, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 5, 7, u'%s' %award['company_name'], style_no_border)
                            
                        if award['position_name'] == None:
                             sheet.write_merge(rowx, rowy, 8, 11, u'', styleb)
                        else:
                             sheet.write_merge(rowx, rowy, 8, 11, u'%s' %award['position_name'], style_no_border)
                        rowx +=2
                        rowy +=2
                        
                        
                sheet.write_merge(rowx,rowy, 2, 2, u'%s' %str(i), style_table)       
                if award['award_name'] == None:
                    sheet.write_merge(rowx,rowy, 3, 9, u'', style_table)
                else:
                    sheet.write_merge(rowx,rowy, 3, 9, u'%s' %award['award_name'], style_table)
                
                if award['received_date'] == None:
                    sheet.write_merge(rowx,rowy, 10, 11, u'', style_table)
                else:
                    sheet.write_merge(rowx,rowy, 10, 11, u'%s' %award['received_date'], style_table)
                    
                rowx +=2
                rowy +=2    
                i+=1
                relatedEmpId=award['employee_id']
                relatedName=award['name_related']      
                c = award['depid']        
        
        
        rowy+=2
        rowx+=2
        sheet.write_merge(rowx, rowy, 1, 10, "Бүртгэл хянасан: Хүний нөөцийн албаны дарга................", ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        rowy +=2
        rowx+=2
        sheet.write_merge(rowx, rowy, 1, 10, "Бүртгэл гаргасан: Хүний нөөцийн менежер....................", ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        
        inch = 2000
        inch1 = 5000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 1*inch
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 1*inch
        sheet.col(6).width = 1*inch
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 1*inch
        sheet.col(10).width = 1*inch
        sheet.col(11).width = 1*inch
        
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

award_list_report()