# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class children_research(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "children.research"
    _description = "Children research"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'hr_employee_id':fields.many2one('hr.employee','Hr employee'),
        'live_people_id':fields.many2one('live.people','Live people'),
        'research_type':fields.selection([('by_employees', 'Companies'), ('by_departments', 'Departments')], 'Research type', required=True),
        
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        empl_obj = self.pool.get('hr.employee')
        empl = empl_obj.browse(cr, uid, ids)
                
        
        child_obj = self.browse(cr, uid, ids)
        
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal left;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        style_italic_underline = ezxf('font: bold off, italic on, underline on, name Times New Roman, height 200; align: wrap on, vertical center, horizontal right;')
        style_italic = ezxf('font: bold off, italic on, name Times New Roman, height 200; align: wrap on, vertical center, horizontal right;')
        
        
        style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        book = xlwt.Workbook(encoding='utf8')
        
        sheet = book.add_sheet('Children research')
        k1 = 0
        k2 = 0
        
        #Filter by companies
        if child_obj.research_type == 'by_employees':
            cr.execute("""select resource_resource.company_id as compid, res_company.name as compname, live_first_name, hr_employee.name_related,
                    live_people.hr_employee_id as livid, hr_employee.id as empid, hr_employee.last_name,
                    hr_job.name as jname, live_birth, explanation, live_age, live_people.gender
                    from 
                    public.live_people,
                    public.hr_employee, 
                    public.resource_resource,
                    public.hr_job,
                    public.res_company
                    where 
                      live_people.hr_employee_id = hr_employee.id AND
                      resource_resource.id = hr_employee.id AND
                      hr_job.id = hr_employee.job_id and
                      res_company.id = resource_resource.company_id AND
                      is_child = True AND
                      active = True
                    order by res_company.id,hr_employee.name_related""")
            children  = cr.dictfetchall()
            
            sheet.write_merge(0, 2, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
            sheet.write_merge(4, 4, 2, 9, u'АЖИЛТНУУДЫН ХҮҮХДИЙН СУДАЛГАА', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
            sheet.write_merge(5, 5, 3, 8, u'(Компаниар)', ezxf('font: bold off, height 200, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
            sheet.write_merge(9, 10, 2, 2, u'№', style_table_header)
            sheet.write_merge(9, 10, 3, 4, u'Хүүхдийн нэр', style_table_header)
            sheet.write_merge(9, 10, 5, 6, u'Төрсөн огноо', style_table_header)
            sheet.write_merge(9, 10, 7, 7, u'Нас', style_table_header)
            sheet.write_merge(9, 10, 8, 8, u'Хүйс', style_table_header)
            sheet.write_merge(9, 10, 9, 10, u'Тайлбар', style_table_header)
            rowx = 11
            rowy = rowx + 1
            
            if children:
                i=1
                c=0
                g = 0
                related =''
                
            
                for line in children:
                    if line['compid'] == c:
                        i=1
                        if line['name_related'] == related:
                            g = 0
                        else:
                            if line['name_related'] ==  None:
                                sheet.write_merge(rowx, rowy, 1, 2, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 1, 2, u'%s' %line['name_related'], style_no_border)
                            if line['last_name'] == None:
                                sheet.write_merge(rowx, rowy, 3, 4, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line['last_name'], style_no_border)
                            if line['jname'] == None:
                                sheet.write_merge(rowx, rowy, 5, 6, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line['jname'], style_no_border)
                            rowy +=2
                            rowx +=2
                            if line['livid'] == related:
                                g = 0
                            else:
                                live_people_obj = self.pool.get('live.people')
                                live_people_id = live_people_obj.search(cr, uid, [('hr_employee_id','=',line['livid']),('is_child','=',True)])
                                live_id = live_people_obj.browse(cr, uid, live_people_id)
                                for line1 in live_id:
                                    sheet.write_merge(rowx, rowy, 2, 2, u'%s' %i, style_table)
                                    if line1.live_first_name == False:
                                        sheet.write_merge(rowx, rowy, 3, 4, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line1.live_first_name, style_table)
                                    if line1.live_birth == False:
                                        sheet.write_merge(rowx, rowy, 5, 6, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line1.live_birth, style_table)
                                    if line1.live_age == False:
                                        sheet.write_merge(rowx, rowy, 7, 7, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 7, 7, u'%s' %line1.live_age, style_table)
                                    if line1.gender == False:
                                        sheet.write_merge(rowx, rowy, 8, 8, u'', style_table)
                                    elif line1.gender == 'male':
                                        sheet.write_merge(rowx, rowy, 8, 8, u'Эрэгтэй', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 8, 8, u'Эмэгтэй', style_table)
                                    if line1.explanation == False:
                                        sheet.write_merge(rowx, rowy, 9, 10, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 9, 10, u'%s' %line1.explanation, style_table)
                                    rowy +=2
                                    rowx +=2
                                    i=i+1
                                    k1 += 1
                                    
                                related = line['livid']
                            related = line['name_related']
                            
                    else:
                        i=1
                        sheet.write_merge(rowx, rowx, 0, 3, u'%s' %line['compname'], ezxf('font: bold on;align:wrap off,vert centre, horiz left;'))
                        rowy += 1
                        rowx += 1
                        if line['name_related'] == related:
                            g = 0
                        else:
                            if line['name_related'] ==  None:
                                sheet.write_merge(rowx, rowy, 1, 2, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 1, 2, u'%s' %line['name_related'], style_no_border)
                            if line['last_name'] == None:
                                sheet.write_merge(rowx, rowy, 3, 4, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line['last_name'], style_no_border)
                            if line['jname'] == None:
                                sheet.write_merge(rowx, rowy, 5, 6, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line['jname'], style_no_border)
                            rowy +=2
                            rowx +=2
                            if line['livid'] == related:
                                g = 0
                            else:
                                live_people_obj = self.pool.get('live.people')
                                live_people_id = live_people_obj.search(cr, uid, [('hr_employee_id','=',line['livid']),('is_child','=',True)])
                                live_id = live_people_obj.browse(cr, uid, live_people_id)
                                for line2 in live_id:
                                    sheet.write_merge(rowx, rowy, 2, 2, u'%s' %i, style_table)
                                    if line2.live_first_name == False:
                                        sheet.write_merge(rowx, rowy, 3, 4, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line2.live_first_name, style_table)
                                    if line2.live_birth == False:
                                        sheet.write_merge(rowx, rowy, 5, 6, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line2.live_birth, style_table)
                                    if line2.live_age == False:
                                        sheet.write_merge(rowx, rowy, 7, 7, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 7, 7, u'%s' %line2.live_age, style_table)
                                    if line2.gender == False:
                                        sheet.write_merge(rowx, rowy, 8, 8, u'', style_table)
                                    elif line2.gender == 'male':
                                        sheet.write_merge(rowx, rowy, 8, 8, u'Эрэгтэй', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 8, 8, u'Эмэгтэй', style_table)
                                    if line2.explanation == False:
                                        sheet.write_merge(rowx, rowy, 9, 10, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 9, 10, u'%s' %line2.explanation, style_table)
                                    rowy +=2
                                    rowx +=2
                                    i=i+1
                                    k2 += 1
                                
                                related = line['livid']
                            related = line['name_related']
                        c = line['compid']
                
        #Filter by departments
        else:
            cr.execute("""select hr_department.id as depp, hr_department.name, live_first_name, hr_employee.name_related, hr_job.id,
                    live_people.hr_employee_id as livid, hr_employee.id as empid, hr_employee.last_name,
                    hr_job.name as jname, live_birth, explanation, live_age, live_people.gender,
                    res_company.name as compname
                    from 
                    public.live_people,
                    public.hr_employee, 
                    public.hr_department,
                    public.resource_resource,
                    public.res_company,
                    public.hr_job
                    where 
                      live_people.hr_employee_id = hr_employee.id AND
                      hr_department.id = hr_employee.department_id AND
                      hr_job.id = hr_employee.job_id and
                      resource_resource.id = hr_employee.id and
                      res_company.id = resource_resource.company_id AND
                      is_child = True AND
                      active = True
                    order by hr_department.id,hr_employee.name_related""")
            children  = cr.dictfetchall()
            
            sheet.write_merge(0, 2, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
            sheet.write_merge(4, 4, 2, 9, u'АЖИЛТНУУДЫН ХҮҮХДИЙН СУДАЛГАА', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
            sheet.write_merge(5, 5, 3, 8, u'(Алба, хэлтсээр)', ezxf('font: bold off, height 200, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
            sheet.write_merge(9, 10, 2, 2, u'№', style_table_header)
            sheet.write_merge(9, 10, 3, 4, u'Хүүхдийн нэр', style_table_header)
            sheet.write_merge(9, 10, 5, 6, u'Төрсөн огноо', style_table_header)
            sheet.write_merge(9, 10, 7, 7, u'Нас', style_table_header)
            sheet.write_merge(9, 10, 8, 8, u'Хүйс', style_table_header)
            sheet.write_merge(9, 10, 9, 10, u'Тайлбар', style_table_header)
            rowx = 11
            rowy = rowx + 1
            
            
            if children:
                i=1
                c=0
                g = 0
                related =''
                
            
                for line in children:   
                    if line['depp'] == c:
                        i=1
                        if line['name_related'] == related:
                            g = 0
                        else:
                            if line['name_related'] == None:
                                sheet.write_merge(rowx, rowy, 1, 2, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 1, 2, u'%s' %line['name_related'], style_no_border)
                            if line['last_name'] == None:
                                sheet.write_merge(rowx, rowy, 3, 4, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line['last_name'], style_no_border)
                            if line['jname'] == None:
                                sheet.write_merge(rowx, rowy, 5, 6, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line['jname'], style_no_border)
                            if line['compname'] == None:
                                sheet.write_merge(rowx, rowy, 7, 8, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 7, 8, u'%s' %line['compname'], style_no_border)
                            rowy +=2
                            rowx +=2
                            if line['livid'] == related:
                                g = 0
                            else:
                                live_people_obj = self.pool.get('live.people')
                                live_people_id = live_people_obj.search(cr, uid, [('hr_employee_id','=',line['livid']),('is_child','=',True)])
                                live_id = live_people_obj.browse(cr, uid, live_people_id)
                                for line1 in live_id:
                                    sheet.write_merge(rowx, rowy, 2, 2, u'%s' %i, style_table)
                                    if line1.live_first_name == False:
                                        sheet.write_merge(rowx, rowy, 3, 4, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line1.live_first_name, style_table)
                                    if line1.live_birth == False:
                                        sheet.write_merge(rowx, rowy, 5, 6, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line1.live_birth, style_table)
                                    if line1.live_age == False:
                                        sheet.write_merge(rowx, rowy, 7, 7, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 7, 7, u'%s' %line1.live_age, style_table)
                                    if line1.gender == False:
                                        sheet.write_merge(rowx, rowy, 8, 8, u'', style_table)
                                    elif line1.gender == 'male':
                                        sheet.write_merge(rowx, rowy, 8, 8, u'Эрэгтэй', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 8, 8, u'Эмэгтэй', style_table)
                                    if line1.explanation == False:
                                        sheet.write_merge(rowx, rowy, 9, 10, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 9, 10, u'%s' %line1.explanation, style_table)
                                    rowy +=2
                                    rowx +=2
                                    i=i+1
                                    k1 += 1
                                    
                                related = line['livid']
                            related = line['name_related']
                    else:
                        i=1
                        sheet.write_merge(rowx, rowx, 0, 3, u'%s' %line['name'], ezxf('font: bold on;align:wrap off,vert centre, horiz left;'))
                        rowy += 1
                        rowx += 1
                        if line['name_related'] == related:
                            g = 0
                        else:
                            if line['name_related'] == None:
                                sheet.write_merge(rowx, rowy, 1, 2, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 1, 2, u'%s' %line['name_related'], style_no_border)
                            if line['last_name'] == None:
                                sheet.write_merge(rowx, rowy, 3, 4, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line['last_name'], style_no_border)
                            if line['jname'] == None:
                                sheet.write_merge(rowx, rowy, 5, 6, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line['jname'], style_no_border)
                            if line['compname'] == None:
                                sheet.write_merge(rowx, rowy, 7, 8, u'', styleb)
                            else:
                                sheet.write_merge(rowx, rowy, 7, 8, u'%s' %line['compname'], style_no_border)
                            rowy +=2
                            rowx +=2
                            if line['livid'] == related:
                                g = 0
                            else:
                                live_people_obj = self.pool.get('live.people')
                                live_people_id = live_people_obj.search(cr, uid, [('hr_employee_id','=',line['livid']),('is_child','=',True)])
                                live_id = live_people_obj.browse(cr, uid, live_people_id)
                                for line2 in live_id:
                                    sheet.write_merge(rowx, rowy, 2, 2, u'%s' %i, style_table)
                                    if line2.live_first_name == False:
                                        sheet.write_merge(rowx, rowy, 3, 4, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 3, 4, u'%s' %line2.live_first_name, style_table)
                                    if line2.live_birth == False:
                                        sheet.write_merge(rowx, rowy, 5, 6, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 5, 6, u'%s' %line2.live_birth, style_table)
                                    if line2.live_age == False:
                                        sheet.write_merge(rowx, rowy, 7, 7, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 7, 7, u'%s' %line2.live_age, style_table)
                                    if line2.gender == False:
                                        sheet.write_merge(rowx, rowy, 8, 8, u'', style_table)
                                    elif line2.gender == 'male':
                                        sheet.write_merge(rowx, rowy, 8, 8, u'Эрэгтэй', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 8, 8, u'Эмэгтэй', style_table)
                                    if line2.explanation == False:
                                        sheet.write_merge(rowx, rowy, 9, 10, u'', style_table)
                                    else:
                                        sheet.write_merge(rowx, rowy, 9, 10, u'%s' %line2.explanation, style_table)
                                    rowy +=2
                                    rowx +=2
                                    i=i+1
                                    k2 += 1
                                    
                                related = line['livid']
                            related = line['name_related']
                        c = line['depp']
        child_number = k1 + k2
        sheet.write_merge(7, 7, 5, 7, u'Нийт хүүхдийн тоо :', style_italic_underline)
        sheet.write(7, 8, u'%s' %child_number, style_italic)
        rowy = rowy + 2
        sheet.write_merge(rowy, rowy, 1, 10, u'Бүртгэл хянасан: Хүний нөөцийн албаны дарга.....................................', ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        rowy = rowy + 1
        sheet.write_merge(rowy, rowy, 1, 10, u'Бүртгэл гаргасан:  Хүний нөөцийн менежер....................................', ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
    
            
            
        inch = 2000
        inch1 = 5000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 1*inch
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 1*inch
        sheet.col(6).width = 1*inch
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 1*inch
        sheet.col(10).width = 1*inch
        sheet.col(11).width = 1*inch
        
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

children_research()