# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class contract_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "contract.report"
    _description = "Contract report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company'),
        }
    
    #_defaults = {
    #   'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    #}
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        queryString="""select * from (
                        select  substr(emp.last_name,1,1) || '.'||emp.name_related AS employee_name,job.name job_name,contr.date_start, contr.wage,
                                                        contr.advantages,contr.state,contr.job_id,contr.employee_id,comp.id company_id,comp.name company_name,' Үндсэн' type_name
                             from hr_contract contr,hr_employee emp, hr_job job, hr_department dep,res_company comp,hr_contract_type typ
                             where contr.employee_id=emp.id and contr.job_id=job.id 
                             and dep.id=emp.department_id and comp.id=dep.company_id
                             and typ.id=contr.type_id and 
                             typ.id=1 
                        
                           union
                                
                        select  substr(emp.last_name,1,1) || '.'||emp.name_related AS employee_name,job.name job_name,contr.trial_date_start, contr.wage,
                                                        contr.advantages,contr.state,contr.job_id,contr.employee_id,comp.id company_id,comp.name company_name,' Гэрээт' type_name
                             from hr_contract contr,hr_employee emp, hr_job job, hr_department dep,res_company comp,hr_contract_type typ
                             where contr.employee_id=emp.id and contr.job_id=job.id 
                             and dep.id=emp.department_id and comp.id=dep.company_id
                             and typ.id=contr.type_id and 
                             typ.id=2
                        ) a 
                     """
    
        
#         if not data['company_id']:
#             print "List is empty"
#         else: 
#             queryString=queryString+" AND att.company_id="+str((data['company_id'][0]))
     
        queryString+=" order by company_name asc,type_name desc, date_start desc,employee_name asc "
        print queryString
        cr.execute(queryString)
        apppp  = cr.dictfetchall()
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal left;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        
        
        style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        
        style_table_numbering = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin;')
        
        style_table_number = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal right; borders: top thin, left thin, bottom thin, right thin;')
        
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Salary changed report')
        sheet.write_merge(1, 3, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
       
        sheet.write_merge(4, 6, 1, 10, u'ЦАЛИНГИЙН ӨӨРЧЛӨЛТЙН БҮРТГЭЛ', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))
        
        sheet.write_merge(9, 12, 1, 1, u'№', style_table_header)
        sheet.write_merge(9, 12, 2, 3, u'Албан тушаал', style_table_header)
        sheet.write_merge(9, 12, 4, 5, u'Цалингийн өөрчлөлийн огноо', style_table_header)
        sheet.write_merge(9, 12, 6, 7, u'Сарын олговол зохих цалин', style_table_header)
        sheet.write_merge(9, 12, 8, 11, u'Нэмэлт тайлбар', style_table_header)
       
        rowx=13
        rowy=rowx+1
        
        c=''
        relatedName=''
        relatedEmpId =0
        
        if apppp:
            i=1
            g = 0
            
            for contracts in apppp:
                
                if contracts['company_name']+contracts['type_name']==c:
                    if contracts['employee_name']==relatedName:
                        g=0
                    else:
                        i=1
                       
                        if contracts['employee_name'] == None:
                            sheet.write_merge(rowx, rowy, 2, 4, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 2, 4, u'%s' %contracts['employee_name'], style_no_border)
                                                    
                        rowx +=2
                        rowy +=2
                else:
                    i=1
                    relatedName=''
                    if contracts['company_name'] == None:
                        sheet.write_merge(rowx, rowx, 0, 3, u'', styleb)
                    else:
                        sheet.write_merge(rowx, rowx, 0, 3, u'%s' %(contracts['company_name']), ezxf('font: bold on;align:wrap off,vert centre, horiz left;'))
                        sheet.write_merge(rowx, rowx, 4, 7, u'%s' %(contracts['type_name']), ezxf('font: bold on;align:wrap off,vert centre, horiz left;'))
                    rowy += 1
                    rowx += 1
                    print "here 1"
                    
                    if contracts['employee_name'] == relatedName:
                        g = 0
                    else:
                        if contracts['employee_name'] == None:
                            sheet.write_merge(rowx, rowy, 2, 4, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 2, 4, u'%s' %contracts['employee_name'], style_no_border)
                        
                        rowx +=2
                        rowy +=2
                        
                        
                sheet.write_merge(rowx, rowy, 1, 1, u'%s' %str(i), style_table_numbering)  
                    
                
                if contracts['job_name'] == None:
                        sheet.write_merge(rowx, rowy, 2, 3, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 2, 3, u'%s' %contracts['job_name'], style_table)
                
                if contracts['date_start'] == None:
                        sheet.write_merge(rowx, rowy, 4, 5, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 4, 5, u'%s' %contracts['date_start'], style_table)
               
                if contracts['wage'] == None:
                        sheet.write_merge(rowx, rowy, 6, 7, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 6, 7, u'%s' %contracts['wage'], style_table_number)
                
                if contracts['advantages'] == None:
                        sheet.write_merge(rowx, rowy, 8, 11, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 8, 11, u'%s' %contracts['advantages'], style_table)
                    
                rowx +=2
                rowy +=2    
                i+=1
                relatedEmpId=contracts['employee_id']
                relatedName=contracts['employee_name']      
                c = contracts['company_name']+contracts['type_name']       
        
           
        
        rowy+=2
        rowx+=2
        sheet.write_merge(rowx, rowy, 1, 10, "Бүртгэл хянасан: Хүний нөөцийн албаны дарга................", ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        rowy +=2
        rowx+=2
        sheet.write_merge(rowx, rowy, 1, 10, "Бүртгэл гаргасан:  Хүний нөөцийн менежер...................", ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        inch = 2000
        
        inch1 = 5000
        sheet.col(0).width = 1000
        sheet.col(1).width = 1000
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 2000
        sheet.col(6).width = 2000
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 4000
        sheet.col(10).width = 2000
        sheet.col(11).width = 2000
        
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

contract_report()