# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class employee_out_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "employee.out.report"
    _description = "out report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company'),
        }
    
    #_defaults = {
    #   'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    #}
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        queryString="""select  dep.id department_id,dep.name department_name, substr(emp.last_name,1,1) || '.'||emp.name_related AS employee_name,
                          job.name job_name,out_r.id reason_id,out_r.name reason_name,to_char(emp.left_date, 'YYYY-MM-DD') left_date, 
                          comp.id company_id,comp.name company_name,emp.decree_number,emp.decree_date
                      from hr_employee emp, hr_job job, hr_department dep,res_company comp,out_reason out_r
                     where dep.id=emp.department_id and comp.id=dep.company_id and emp.job_id=job.id and out_r.id=emp.out_reason_id 
                     and emp.out_reason_id is not null and emp.left_date is not null
                     """
    
        
#         if not data['company_id']:
#             print "List is empty"
#         else: 
#             queryString=queryString+" AND att.company_id="+str((data['company_id'][0]))
     
        queryString+=" order by comp.name asc,out_r.name asc,emp.left_date desc,emp.name_related asc "
        print queryString
        cr.execute(queryString)
        apppp  = cr.dictfetchall()
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal left;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        
        
        style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        
        style_table_numbering = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin;')
        
        style_table_number = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal right; borders: top thin, left thin, bottom thin, right thin;')
        
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('out report')
        sheet.write_merge(1, 3, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
       
        sheet.write_merge(4, 6, 1, 10, u'АЖЛААС ГАРСАН АЖИЛЛАГСАДЫН БҮРТГЭЛ', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))
        
        sheet.write_merge(9, 12, 1, 1, u'№', style_table_header)
        
        sheet.write_merge(9, 12, 2, 3, u'Ажилтны овог нэр', style_table_header)
        sheet.write_merge(9, 12, 4, 5, u'Албан тушаал', style_table_header)
        sheet.write_merge(9, 12, 6, 7, u'Гарсан огноо', style_table_header)
        sheet.write_merge(9, 12, 8, 9, u'Тушаалын дугаар', style_table_header)
        sheet.write_merge(9, 12, 10, 11, u'Тушаалын огноо', style_table_header)
       
        rowx=13
        rowy=rowx+1
        
        
        if apppp:
            i=1
            c=0
            g = 0
        
            reasonName=''
            
            for employee_out in apppp:
                
                if employee_out['company_id']==c:
                    if employee_out['reason_name']==reasonName:
                        g=0
                    else:
                        i=1
                       
                        if employee_out['reason_name'] == None:
                            sheet.write_merge(rowx, rowy, 2, 5, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 2, 5, u'%s' %employee_out['reason_name'], style_no_border)
                                                    
                        rowx +=2
                        rowy +=2
                else:
                    i=1
                    reasonName=''
                    if employee_out['company_name'] == None:
                        sheet.write_merge(rowx, rowx, 0, 5, u'', styleb)
                    else:
                        sheet.write_merge(rowx, rowx, 0, 5, u'%s' %employee_out['company_name'], ezxf('font: bold on;align:wrap off,vert centre, horiz left;'))
                        
                    rowy += 1
                    rowx += 1
                    print "here 1"
                    
                    if employee_out['reason_name'] == reasonName:
                        g = 0
                    else:
                        if employee_out['reason_name'] == None:
                            sheet.write_merge(rowx, rowy, 2, 5, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowy, 2, 5, u'%s' %employee_out['reason_name'], style_no_border)
                        
                        rowx +=2
                        rowy +=2
                        
                        
                sheet.write_merge(rowx, rowy, 1, 1, u'%s' %str(i), style_table_numbering)  
                    
                
                if employee_out['employee_name'] == None:
                        sheet.write_merge(rowx, rowy, 2, 3, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 2, 3, u'%s' %employee_out['employee_name'], style_table)
                
                if employee_out['job_name'] == None:
                        sheet.write_merge(rowx, rowy, 4, 5, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 4, 5, u'%s' %employee_out['job_name'], style_table)
               
                if employee_out['left_date'] == None:
                        sheet.write_merge(rowx, rowy, 6, 7, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 6, 7, u'%s' %employee_out['left_date'], style_table_number)
                
                if employee_out['decree_number'] == None:
                        sheet.write_merge(rowx, rowy, 8, 9, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 8, 9, u'%s' %employee_out['decree_number'], style_table)
                
                if employee_out['decree_date'] == None:
                        sheet.write_merge(rowx, rowy, 10, 11, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 10, 11, u'%s' %employee_out['decree_date'], style_table)
                
                    
                rowx +=2
                rowy +=2    
                i+=1
                
                reasonName=employee_out['reason_name']      
                c = employee_out['company_id']        
        
           
        
        rowy+=2
        rowx+=2
        sheet.write_merge(rowx, rowy, 1, 10, "Бүртгэл хянасан: Хүний нөөцийн албаны дарга................", ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        rowy +=2
        rowx+=2
        sheet.write_merge(rowx, rowy, 1, 10, "Бүртгэл гаргасан:  Хүний нөөцийн менежер...................", ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        inch = 2000
        
        inch1 = 5000
        sheet.col(0).width = 2000
        sheet.col(1).width = 2000
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 2000
        sheet.col(6).width = 2000
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 2000
        sheet.col(10).width = 2000
        sheet.col(11).width = 2000
        
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

employee_out_report()