# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class policy_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "policy.report"
    _description = "Policy report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company'),
        }
    
    #_defaults = {
    #   'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    #}
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        queryString="""SELECT 
                           att.doc_type, 
                           att.name, 
                           att.doc_date, 
                           att.doc_number, 
                           att.comment, 
                           att.company_id, 
                           res_company.name AS company_name,
                           att.to_where,
                           att.to_whom,
                           att.onchange_notes
                        FROM 
                          ir_attachment att
                          left join  
                          res_company
                        ON 
                          res_company.id =  att.company_id
                        where doc_type in ('sent_paper','received_paper','decree')
                                
                     """
    
        
#         if not data['company_id']:
#             print "List is empty"
#         else: 
#             queryString=queryString+" AND att.company_id="+str((data['company_id'][0]))
     
        queryString+=" order by  res_company.name asc ,att.doc_date desc"
        #print queryString
        cr.execute(queryString)
        apppp  = cr.dictfetchall()
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal left;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        
        
        style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Policy report')
        sheet.write_merge(0, 2, 0, 3, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
       
        sheet.write_merge(4, 4, 2, 11, u'БОЛОВСРУУЛСАН ДҮРЭМ ЖУРМЫН БҮРТГЭЛ', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))
        
        sheet.write_merge(6, 8, 1, 1, u'№', style_table_header)
        sheet.write_merge(6, 8, 2, 4, u'Дүрэм журмын нэр', style_table_header)
        sheet.write_merge(6, 8, 5, 5, u'Батлагдсан огноо', style_table_header)
        sheet.write_merge(6, 8, 6, 8, u'Утга', style_table_header)
        sheet.write_merge(6, 8, 9, 11, u'Өөрчлөлтийн тэмдэглэл', style_table_header)
        
        rowx=9
        rowy=rowx+2
        
        
        if apppp:
            i=1
            c=0
            related=''
            
            for policies in apppp:
                
                if policies['company_id'] == c:
                    print "i:=" +str(i)
                else:
                    i=1
                    sheet.write_merge(rowx, rowy, 0, 5, u'%s' %policies['company_name'], ezxf('font: bold on;align:wrap off,vert centre, horiz left;'))
                    rowx += 3
                    rowy += 3
                
                c=policies['company_id']
                    
                sheet.write_merge(rowx, rowy, 1, 1, u'%s' %str(i), style_table)  
                    
                if policies['name'] == None:
                        sheet.write_merge(rowx, rowy, 2, 4, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 2, 4, u'%s' %policies['name'], style_table)
                
                if policies['doc_date'] == None:
                        sheet.write_merge(rowx, rowy, 5, 5, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 5, 5, u'%s' %policies['doc_date'], style_table)
                
                if policies['comment'] == None:
                     sheet.write_merge(rowx, rowy, 6, 8, u'', style_table)
                else:
                     sheet.write_merge(rowx, rowy, 6, 8, u'%s' %policies['comment'], style_table)
                
                if policies['onchange_notes'] == None:
                        sheet.write_merge(rowx, rowy, 9, 11, u'', style_table)
                else:
                        sheet.write_merge(rowx, rowy, 9, 11, u'%s' %policies['onchange_notes'], style_table)
               
  
                
                rowy +=3
                rowx +=3
                i=i+1   
            
        
#         rowy+=2
#         rowx+=2
#         sheet.write_merge(rowx, rowy, 1, 10, "Бүртгэл хянасан: Хүний нөөцийн албаны дарга................", ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
#         rowy +=2
#         rowx+=2
#         sheet.write_merge(rowx, rowy, 1, 10, "Бүртгэл гаргасан:  Захирлын туслах.........................", ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        inch = 2000
        inch1 = 5000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 1*inch
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 2500
        sheet.col(6).width = 1500
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 1*inch
        sheet.col(10).width = 1*inch
        sheet.col(11).width = 1*inch
        
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

policy_report()