# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class training_execution_account(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "training.execution.account"
    _description = "Training execution account"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'hr_employee_id':fields.many2one('hr.employee','Hr employee'),
        'training_execution_account_id':fields.many2one('training.execution','Training execution account'),
        
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        styletlr = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, right thin;')
        stylel = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin; align: wrap on, vertical center, horizontal left;')
        styler = ezxf('font: bold off, name Times New Roman, height 200; borders: right thin; align: wrap on, vertical center, horizontal left;')
        styleb = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin; align: wrap on, vertical center, horizontal center;')
        stylebl = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin; align: wrap on, vertical center, horizontal center;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin; align: wrap on, vertical center, horizontal center;')
        styleblr = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, left thin, right thin; align: wrap on, vertical center, horizontal left;')
        stylelr = ezxf('font: bold off, name Times New Roman, height 200; borders: left thin, right thin; align: wrap on, vertical center, horizontal center;')
        style_no_border = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;')
        style_table_fill = ezxf('pattern: pattern solid, fore_colour black; font: bold off, name Times New Roman, height 140; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_checking = ezxf('font: bold on, name Times New Roman, height 240; align: horizontal center, vertical center; borders: top thin, left thin, right thin, bottom thin;')
        
        
        style1 = ezxf('font: bold off; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off, name Times New Roman; align: wrap on, vertical center, horizontal center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour ice_blue;')
        book = xlwt.Workbook(encoding='utf8')
        
        sheet = book.add_sheet('Training execution account')
                    
        cr.execute("""select execution_line.hr_employee_id, execution_line.id as exid,
                execution_line.name as last_name, execution_line.department_name, execution_line.position_name,
                training_execution.id as trid, training_execution.internal_training_id, 
                training_execution.inst_date, training_execution.end_date, training_execution.inst_budget,
                internal_training.name as itname, training_execution.name as trname, 
                training_execution.is_plan as isplan, training_execution.variation_cost
                from 
                public.execution_line, 
                public.training_execution,
                public.internal_training
                where 
                    internal_training.id = training_execution.internal_training_id and
                    training_execution.id = execution_line.training_execution_id
                order by training_execution.id, execution_line.training_execution_id""")
        tr_execs  = cr.dictfetchall()
        
        sheet.write_merge(0, 2, 0, 6, u'', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(4, 4, 5, 17, u'СУРГАЛТЫН БҮРТГЭЛ', ezxf('font: bold on, height 280, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
        sheet.write_merge(5, 5, 6, 16, u'(Зохион байгуулсан сургалтаар)', ezxf('font: bold off, height 200, name Times New Roman;align:wrap off,vert centre, horiz centre;'))    
        sheet.write_merge(7, 9, 2, 2, u'№', style_table_header)
        sheet.write_merge(7, 9, 3, 6, u'Ажилтны нэр', style_table_header)
        sheet.write_merge(7, 9, 7, 10, u'Ажилтны овог', style_table_header)
        sheet.write_merge(7, 9, 11, 15, u'Алба, хэлтэс', style_table_header)
        sheet.write_merge(7, 9, 16, 20, u'Албан тушаал', style_table_header)
        
        rowx = 10
        rowy = rowx + 1
        
        if tr_execs:
            i=1
            c=0
            g = 0
            related =''
            tog = ''
            for line in tr_execs:
                if line['trid'] == c:
                    i=1
                    if line['itname'] == related:
                        g = 0
                    else:
                        if line['isplan'] == None:
                            sheet.write_merge(rowx, rowy, 1, 5, u'', styleb)
                        elif line['isplan'] == 'no':
                            sheet.write_merge(rowx, rowy, 1, 5, u'Төлөвлөгөөт бус', style_no_border)
                        else:
                            sheet.write_merge(rowx, rowy, 1, 5, u'Төлөвлөгөөт', style_no_border)
                        sheet.write_merge(rowx, rowx, 6, 9, u'Эхэлсэн огноо:', styleb)
                        sheet.write_merge(rowy, rowy, 6, 9, u'Дууссан огноо:', styleb)
                        if line['inst_date'] == None:
                            sheet.write_merge(rowx, rowx, 10, 12, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowx, 10, 12, u'%s' %line['inst_date'], style_no_border)
                        if line['end_date'] == None:
                            sheet.write_merge(rowy, rowy, 10, 12, u'', styleb)
                        else:
                            sheet.write_merge(rowy, rowy, 10, 12, u'%s' %line['end_date'], style_no_border)
                        sheet.write_merge(rowx, rowx, 13, 18, u'Нийт төсөв:', styleb)
                        sheet.write_merge(rowy, rowy, 13, 18, u'Зардлын хэтрэлт, хэмнэлт:', styleb)
                        if line['inst_budget'] == None:
                            sheet.write_merge(rowx, rowx, 19, 21, u'', styleb)
                        else:
                            #tog = str(line['inst_budget']) + '$'
                            sheet.write_merge(rowx, rowx, 19, 21, u'%s' %line['inst_budget'], style_no_border)
                        if line['variation_cost'] == None:
                            sheet.write_merge(rowy, rowy, 19, 21, u'', styleb)
                        else:
                            #tog = str(line['inst_budget']) + '$'
                            sheet.write_merge(rowy, rowy, 19, 21, u'%s' %line['variation_cost'], style_no_border)
                        rowy +=3
                        rowx +=3
                        if line['itname'] == related:
                            g = 0
                        else:
                            training_execution_obj = self.pool.get('execution.line')
                            training_exec_id = training_execution_obj.search(cr, uid, [('id','=',line['training_execution_id'])])
                            tr_id = training_execution_obj.browse(cr, uid, training_exec_id)
                            #,('is_child','=',True)]1
                            for line1 in tr_id:
                                sheet.write_merge(rowx, rowy, 2, 2, u'%s' %i, style_table)
                                if line1.hr_employee_id == False:
                                    sheet.write_merge(rowx, rowy, 3, 6, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 3, 6, u'%s' %line1.hr_employee_id.name, style_table)
                                if line1.name == False:
                                    sheet.write_merge(rowx, rowy, 7, 10, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 7, 10, u'%s' %line1.name, style_table)
                                if line1.department_name == False:
                                    sheet.write_merge(rowx, rowy, 11, 15, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 11, 15, u'%s' %line1.department_name.name, style_table)
                                if line1.position_name == False:
                                    sheet.write_merge(rowx, rowy, 16, 20, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 16, 20, u'%s' %line1.position_name.name, style_table)
                                
                                rowy +=2
                                rowx +=2
                                i=i+1
                                
                            related = line['itname']
                        related = line['itname']
                        
                else:
                    i=1
                    sheet.write_merge(rowx, rowx, 0, 5, u'%s' %line['itname'], ezxf('font: bold on;align:wrap off,vert centre, horiz left;'))
                    rowy += 1
                    rowx += 1
                    if line['itname'] == related:
                        g = 0
                    else:
                        if line['isplan'] == None:
                            sheet.write_merge(rowx, rowy, 1, 5, u'', styleb)
                        elif line['isplan'] == 'no':
                            sheet.write_merge(rowx, rowy, 1, 5, u'Төлөвлөгөөт бус', style_no_border)
                        else:
                            sheet.write_merge(rowx, rowy, 1, 5, u'Төлөвлөгөөт', style_no_border)
                        sheet.write_merge(rowx, rowx, 6, 9, u'Эхэлсэн огноо:', styleb)
                        sheet.write_merge(rowy, rowy, 6, 9, u'Дууссан огноо:', styleb)
                        if line['inst_date'] == None:
                            sheet.write_merge(rowx, rowx, 10, 12, u'', styleb)
                        else:
                            sheet.write_merge(rowx, rowx, 10, 12, u'%s' %line['inst_date'], style_no_border)
                        if line['end_date'] == None:
                            sheet.write_merge(rowy, rowy, 10, 12, u'', styleb)
                        else:
                            sheet.write_merge(rowy, rowy, 10, 12, u'%s' %line['end_date'], style_no_border)
                        sheet.write_merge(rowx, rowx, 13, 18, u'Нийт төсөв:', styleb)
                        sheet.write_merge(rowy, rowy, 13, 18, u'Зардлын хэтрэлт, хэмнэлт:', styleb)
                        if line['inst_budget'] == None:
                            sheet.write_merge(rowx, rowx, 19, 21, u'', styleb)
                        else:
                            #tog = str(line['inst_budget']) + '$'
                            sheet.write_merge(rowx, rowx, 19, 21, u'%s' %line['inst_budget'], style_no_border)
                        if line['variation_cost'] == None:
                            sheet.write_merge(rowy, rowy, 19, 21, u'', styleb)
                        else:
                            #tog = str(line['inst_budget']) + '$'
                            sheet.write_merge(rowy, rowy, 19, 21, u'%s' %line['variation_cost'], style_no_border)
                        rowy +=3
                        rowx +=3
                        if line['exid'] == related:
                            g = 0
                        else:
                            training_execution_obj = self.pool.get('execution.line')
                            training_exec_id = training_execution_obj.search(cr, uid, [('training_execution_id','=',line['trid'])])
                            tr_id = training_execution_obj.browse(cr, uid, training_exec_id)
                            #,('is_child','=',True)]1
                            for line1 in tr_id:
                                sheet.write_merge(rowx, rowy, 2, 2, u'%s' %i, style_table)
                                if line1.hr_employee_id == False:
                                    sheet.write_merge(rowx, rowy, 3, 6, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 3, 6, u'%s' %line1.hr_employee_id.name, style_table)
                                if line1.name == False:
                                    sheet.write_merge(rowx, rowy, 7, 10, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 7, 10, u'%s' %line1.name, style_table)
                                if line1.department_name == False:
                                    sheet.write_merge(rowx, rowy, 11, 15, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 11, 15, u'%s' %line1.department_name.name, style_table)
                                if line1.position_name == False:
                                    sheet.write_merge(rowx, rowy, 16, 20, u'', style_table)
                                else:
                                    sheet.write_merge(rowx, rowy, 16, 20, u'%s' %line1.position_name.name, style_table)
                                
                                rowy +=2
                                rowx +=2
                                i=i+1
                            
                            related = line['exid']
                        related = line['itname']
                    c = line['trid']
        rowy = rowy + 2
        sheet.write_merge(rowy, rowy, 4, 18, u'Бүртгэл хянасан: Хүний нөөцийн албаны дарга.....................................', ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))
        rowy = rowy + 1
        sheet.write_merge(rowy, rowy, 4, 18, u'Бүртгэл гаргасан:  Хүний нөөцийн менежер....................................', ezxf('font: bold off, name Times New Roman, height 200; align: wrap on, vertical center, horizontal center;'))

        inch = 1000
        inch1 = 5000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 1*inch
        sheet.col(2).width = 1*inch
        sheet.col(3).width = 1*inch
        sheet.col(4).width = 1*inch
        sheet.col(5).width = 1*inch
        sheet.col(6).width = 1*inch
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 1*inch
        sheet.col(10).width = 1*inch
        sheet.col(11).width = 1*inch
        sheet.col(12).width = 1*inch
        sheet.col(13).width = 1*inch
        sheet.col(14).width = 1*inch
        sheet.col(15).width = 1*inch
        sheet.col(16).width = 1*inch
        sheet.col(17).width = 1*inch
        sheet.col(18).width = 1*inch
        sheet.col(19).width = 1*inch
        sheet.col(20).width = 1*inch
        sheet.col(21).width = 1*inch
        sheet.col(22).width = 1*inch
        #----------------------------------------------------------- inch = 1000
        #----------------------------------------------------------- inch1 = 900
        #------------------------------------------- sheet.col(0).width = 1*inch
        #------------------------------------------ sheet.col(1).width = 5*inch1
        #------------------------------------------- sheet.col(2).width = 3*inch
        #------------------------------------------- sheet.col(3).width = 2*inch
        #------------------------------------------- sheet.col(4).width = 4*inch
        #------------------------------------------- sheet.col(5).width = 6*inch
        #------------------------------------------- sheet.col(6).width = 2*inch
        #------------------------------------------- sheet.col(7).width = 4*inch
        #------------------------------------------ sheet.col(8).width = 2*inch1
        #------------------------------------------- sheet.col(9).width = 4*inch
        
        return {'data':book}

training_execution_account()