# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2014 iERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : iERP@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp
from openerp.tools.translate import _

class hr_advance_salary(osv.osv):
    _name = 'hr.advance.salary'
    _description = "HR advance salary"
    _columns = {
                'name':fields.char('Name'),
                'company_id':fields.many2one('res.company','Company name'),
                'start_date':fields.date('Start date'),
                'end_date':fields.date('End date'),
                'like_percent':fields.integer('Like percent',required=True),
                'hr_advance_salary_line_id': fields.one2many('hr.advance.salary.line', 'advance_id', 'Employee'),
                'state': fields.selection([
                    ('draft', 'Draft'),
                    ('confirm', 'Confirm')
                    ], 'State', readonly=True, select=True),
                }
    _defaults = {
                 'state': 'draft',
                 }
    def action_compute(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        advance_line_obj = self.pool.get('hr.advance.salary.line')
        if obj.hr_advance_salary_line_id !=[]:
            for line in obj.hr_advance_salary_line_id:
                #salary = (line.name*obj.like_percent)/100
                advance_line_obj.write(cr, uid, line.id,{'advance_percent':obj.like_percent,
                                                         #'first_advance_salary':0,
                                                         })
                
            
        #return True
    
    def action_total_compute(self, cr, uid, ids, *args):
        advance_line_obj = self.pool.get('hr.advance.salary.line')
        obj = self.browse(cr, uid, ids)
        urjver = 0
        total_calculate = 0
        for line in obj.hr_advance_salary_line_id:
            urjver = (line.name/line.working_hours*line.regular_hours_advance*line.advance_percent)/100
            total_calculate = urjver+line.annual_leave_pay-line.other_deduction+line.other_incentive
            advance_line_obj.write(cr, uid, line.id, {
                                            'first_advance_salary':urjver,
                                            'total_advance_salary':total_calculate,
                                            })
                
            
        return True
    
    def action_cancel_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        advance_line_obj = self.pool.get('hr.advance.salary.line')
        obj = self.browse(cr, uid, ids)
        for line in obj.hr_advance_salary_line_id:
            advance_line_obj.write(cr, uid, line.id, {
                                                'first_advance_salary':0,
                                                'total_advance_salary':0,
                                                })
        return True

    def action_to_confirm(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'confirm'})
        #advance_line_obj = self.pool.get('hr.advance.salary.line')
        #obj = self.browse(cr, uid, ids)
        #urjver = 0
        #total_calculate = 0
        #for line in obj.hr_advance_salary_line_id:
            #urjver = (line.name*line.advance_percent)/100
            #total_calculate = urjver+line.annual_leave_pay-line.other_deduction+line.other_incentive
            #advance_line_obj.write(cr, uid, line.id, {
                                            #'first_advance_salary':urjver,
                                            #'total_advance_salary':total_calculate,
                                            #})
        return True
    
    def action_advance_salary(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        emp_obj = self.pool.get('hr.employee')
        ad_sal_line_obj = self.pool.get('hr.advance.salary.line')
        dep_obj = self.pool.get('hr.department')
        hr_contract_obj = self.pool.get('hr.contract')
        empl_info_obj = self.pool.get('employee.info')
        record_obj = self.pool.get('hr.hour.record')
        dep_id = dep_obj.search(cr, uid, [('company_id','=',obj.company_id.id)],order='sequence asc')
        if dep_id:
            #contract_wage = 0
            #contract_percent = 0
            
            emp_id = emp_obj.search(cr, uid, [('company_id','=',obj.company_id.id),('department_id','=',dep_id)])
            if obj.hr_advance_salary_line_id.id == False:
                #for line in emp_obj.browse(cr, uid, emp_id):
                    #if line.contract_id.id!=False:
                        #contract_wage = line.contract_id.wage
                       #contract_percent = line.contract_id.percent
                    #else:
                        #contract_percent = 0
                        #contract_wage = 0
                record_id = record_obj.search(cr, uid, [('start_date','=',obj.start_date),('end_date','=',obj.end_date)])
                record = record_obj.browse(cr, uid, record_id) 
                    #line_hours = empl_info_obj.search(cr, uid, [('employee_id','=',line.id)])
                for re in record:
                    if re !=[]:
                        working_hours = 0
                        for emp_line in re.employee_info_id:
                            print'lloooogggg',re,  emp_line
                                #print "fggggg",hours.working_hours
                            working_hours = emp_line.working_hours
                            regular_hours_advance = emp_line.regular_hours
                            cont_id = hr_contract_obj.search(cr, uid, [('employee_id','=',emp_line.employee_id.id)])
                            cont = hr_contract_obj.browse(cr, uid, cont_id)
                            print'llllllggggg',cont.wage
                            ad_sal_line_obj.create(cr, uid, {
                                                         'employee_id':emp_line.employee_id.id,
                                                         'advance_id':obj.id,
                                                         'working_hours':working_hours,
                                                         'regular_hours_advance':regular_hours_advance,
                                                         'advance_percent':obj.like_percent,
                                                         'employee_code':emp_line.name,
                                                         'department_name':emp_line.department_name.id,
                                                         'department_code':emp_line.department_code,
                                                         'card_number':emp_line.employee_id.bank_account_id.acc_number,
                                                         'position_name':emp_line.job_id.id,
                                                         'name':cont.wage,
                                                         })
        else:
           raise osv.except_osv(_('Error!'),_("Selected employees."))
       
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('hr.advance.salary.line')
        for line in obj.hr_advance_salary_line_id:
            line_obj.unlink(cr, uid, line.id)
        return super(hr_advance_salary, self).unlink(cr, uid, ids, context=context)

        return True


class hr_advance_salary_line(osv.osv):
    _name = 'hr.advance.salary.line'
    _description = "HR advance salary line"
    _columns = {
                'name':fields.float('Basic salary',required=True, readonly=True),
                'department_code':fields.char('Department code', readonly=True),
                'department_name':fields.many2one('hr.department','Department', readonly=True),
                'employee_code':fields.char('Employee code', readonly=True),
                'position_name':fields.many2one('hr.job','Position', readonly=True),
                'working_hours':fields.float('Working hours',readonly=True),
                'regular_hours_advance':fields.float('Regular hours advance',readonly=True),
                'advance_percent':fields.integer('Advance percent'),
                'first_advance_salary':fields.float('First advance salary', readonly=True),
                'annual_leave_pay':fields.float('Annual leave pay'),
                'card_number':fields.char('Card number', readonly=True),
                'other_deduction':fields.float('Other deduction'),
                'other_incentive':fields.float('Other incentive'),
                'total_advance_salary':fields.float('Total advance salary', readonly=True),
                'employee_id':fields.many2one('hr.employee', 'Employee', readonly=True),
                'advance_id':fields.many2one('hr.advance.salary','Advance salary'),
                }
    
    def onchange_employee_name(self, cr, uid, ids, empl_id, context=None):
        res = {}
        if ids:
            obj = self.browse(cr, uid, ids)[0]
            print "llllllllll",empl_id
            if empl_id:
                #print "aaaaaaaaaa",empl_id 
                empl_obj = self.pool.get('hr.employee')
                empl = empl_obj.browse(cr, uid, empl_id)[0]
                empl = emp_obj.search(cr, uid, [('company_id','=',obj.company_id.id)])
                #print "ddddddddddd",empl
                res['employee_code']=empl.employee_code
                res['card_number']=empl.bank_account_id.acc_number
                res['department_name']=empl.department_id.id
                res['department_code']=empl.department_id.code
                res['position_name']=empl.job_id.id
                res['name']=empl.contract_id.wage
                res['advance_percent']=empl.contract_id.percent
                return {'value':res}
    
    