# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import logging
import re
import requests
import datetime
import time
from dateutil.parser import parse
from datetime import timedelta, date
# from pytz import timezone
# import pytz

from openerp.tools import DEFAULT_SERVER_DATE_FORMAT, DEFAULT_SERVER_DATETIME_FORMAT

from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _

class hr_hour_record(osv.osv):
    _name = 'hr.hour.record'
    
    _columns = {
                'company_id':fields.many2one('res.company','Company', required=True),
                #'like_late':fields.integer('Late pay'),
                'start_date':fields.date('Start date', required=True),
                'end_date':fields.date('End date', required=True),
                'employee_info_id':fields.one2many('employee.info','hr_hour_id','Employee info'),
                'state':fields.selection([('draft','Draft'),
                                          ('confirm','Confirm')],'State'),
                }
    
    _defaults = {
                'company_id': lambda obj,cr,uid,c=None:obj.pool.get('res.company')._company_default_get(cr,uid,'hr.hour.record',context=c),
                'start_date':time.strftime('%Y-%m-01'),
                'end_date':datetime.date.today(),
                'state': 'draft',
                 }
    def action_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True
    
    def action_confirm(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'confirm'})
        return True
    
    def action_compute(self, cr, uid, ids, *args):
        #Old code
        obj = self.browse(cr, uid, ids)[0]
        emp_info_obj = self.pool.get('employee.info')
        overtime_calculate = 0
        if obj.employee_info_id !=[]:
            for line in obj.employee_info_id:
                overtime_calculate = line.sat_overtime + line.overhours
                emp_info_obj.write(cr, uid, line.id,{ #'late_pay':obj.like_late,
                                                     'total_overtime':overtime_calculate,
                                                         })
                                                         
        

                
    def action_attendance(self, cr, uid, ids=0, Context=None):
#         user_pool = self.pool.get('res.users')
#         user = user_pool.browse(cr, SUPERUSER_ID, uid)
#         if pytz.timezone(user.partner_id.tz):
#             tz = pytz.timezone(user.partner_id.tz)
#             print tz
#         else:
#             tz = pytz.timezone('Asia/Ulaanbaatar')
#         print tz

        device_datetime = datetime.datetime(datetime.datetime.now().year,datetime.datetime.now().month,datetime.datetime.now().day,datetime.datetime.now().hour+9,datetime.datetime.now().minute,datetime.datetime.now().second)
        tzdiff = device_datetime - datetime.datetime.now()
        tzdiff = datetime.timedelta(0, round(tzdiff.total_seconds()/3600)*3600)

        attendance_devices = self.pool.get('hr.attendance.machines')
        all_results = ''
        attendance_devices_ids = attendance_devices.search(cr, uid, [('id','>',0)])
        for device_info in attendance_devices.browse(cr, uid, attendance_devices_ids):
            login_session = requests.session()
            device_ip = device_info.ip_add
            try:
                login_page = login_session.get("http://" + device_ip + "/csl/login", timeout=60, verify=False)
            except:
                continue
            
            if login_page.status_code == requests.codes.ok:
                login_params = {'username': device_info.user_name, 'userpwd': device_info.user_password}
                login_result = login_session.post("http://" + device_ip + "/csl/check", login_params, verify=False)
        
                if login_result.status_code == requests.codes.ok:
                    page_desktop = login_session.get("http://" + device_ip + "/csl/desktop", verify=False)
        
                    ip_candidates = re.findall(r"\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b", page_desktop.text)
                    if(ip_candidates):
                        if device_ip in ip_candidates:
                            page_datetime_result = login_session.get("http://" + device_ip + "/form/Device?act=3", verify=False)
                            datetime_match = re.search(r'Date\((\d{4}),(\d{2}),(\d{2}),(\d{2}),(\d{2}),(\d{2})\)', page_datetime_result.text, re.M|re.I)
                            
                            if datetime_match:
                                device_datetime = datetime.datetime(int(datetime_match.group(1)),int(datetime_match.group(2))+1,int(datetime_match.group(3)),int(datetime_match.group(4)),int(datetime_match.group(5)),int(datetime_match.group(6)))
                                tzdiff = device_datetime - datetime.datetime.now()
                                tzdiff = datetime.timedelta(0, round(tzdiff.total_seconds()/3600)*3600)
                            
                            pattern = re.compile(r'<input[^>]+name=uid[^>]+value=([0-9]*)>', re.IGNORECASE)
                            uids = []
                            for uid_match in pattern.finditer(login_result.text):
                                uids.append(int(uid_match.group(1)))
                            #print uids
                            from_day = datetime.datetime.now() - datetime.timedelta(0, 3600*24*33)
                            from_date = from_day.strftime("%Y-%m-%d")
                            to_day = datetime.datetime.now() + datetime.timedelta(0, 3600*24)
                            to_date = to_day.strftime("%Y-%m-%d")
                            date_params = {'sdate': from_date, 'period': '0', 'edate': to_date, 'uid':uids }
                            r = login_session.post("http://" + device_ip + "/form/Download", data=date_params, stream=True, allow_redirects=True, verify=False)
                            if r.status_code == 200:
                                all_results = all_results + r.content
                                #with open(local_filename, 'wb') as f:
                                    #for chunk in r.iter_content():
                                        #f.write(chunk)
                                        
        result_lines = all_results.split('\n')
        #remove empty lines:
        result_lines = filter(lambda x: not re.match(r'^\s*$', x), result_lines)
        all_results = [];

        for result_line in result_lines:
            time_info = result_line.split('\t')
            clicked_time_orig = parse(time_info[2])
            clicked_time = clicked_time_orig - tzdiff
            all_results.append({'duid':time_info[0],'time':clicked_time, 'time_orig':clicked_time_orig})

        #sort by clicked_time 
        all_results = sorted(all_results, key=lambda k: (k['duid'], k['time'], k['time_orig']))
        
        for result_info in all_results:
            device_user_id = result_info['duid']
            clicked_time = result_info['time'].strftime(DEFAULT_SERVER_DATETIME_FORMAT)
            clicked_time_orig = result_info['time_orig'].strftime(DEFAULT_SERVER_DATETIME_FORMAT)
            emp_obj = self.pool.get('hr.employee')
            employee_id = emp_obj.search(cr, uid, [('att_code','=',device_user_id)])
            if employee_id:
                attd_obj = self.pool.get('hr.attendance')
                clicked_time_from = result_info['time'] - datetime.timedelta(0,300)
                clicked_time_to = result_info['time'] + datetime.timedelta(0,300)
                clicked_time_fromstr = clicked_time_from.strftime(DEFAULT_SERVER_DATETIME_FORMAT)
                clicked_time_tostr = clicked_time_to.strftime(DEFAULT_SERVER_DATETIME_FORMAT)
                attd_exists_id = attd_obj.search(cr, uid, [('employee_id','=',employee_id[0]), ('name','>',clicked_time_fromstr), ('name','<',clicked_time_tostr)])
                if attd_exists_id == []:
                    attd_last_id = attd_obj.search(cr, uid, [('employee_id','=',employee_id[0])], limit=1, order='name DESC')
                    new_action = 'sign_in'
                    worked_hours = 0
                    if attd_last_id:
                        attd_info = attd_obj.browse(cr, uid, attd_last_id)[0]
                        if attd_info.action == 'sign_in':
                            new_action = 'sign_out'
                            # Compute time elapsed between sign-in and sign-out
                            last_signin_datetime = parse(attd_info.name)
                            workedhours_datetime = (result_info['time'] - last_signin_datetime)
                            worked_hours = ((workedhours_datetime.seconds) / 60) / 60
                    attd_obj.create(cr, uid, {
                        'employee_id':employee_id[0],
                        'name':clicked_time,
                        'action': new_action,
                        'worked_hours': worked_hours,
                        #'timezone_diff': tzdiff.total_seconds(),
                        'clicked_datetime': clicked_time_orig
                    })

            
        
    
    def action_employee_hour(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)
        emp_obj = self.pool.get('hr.employee')
        emp_inf_obj = self.pool.get('employee.info')
        hr_payslip = self.pool.get('hr.payslip')
        date_from = obj.start_date
        date_to = obj.end_date

        #dep_obj = self.pool.get('hr.department')
        #hr_contract_obj = self.pool.get('hr.contract')
        #dep_ids = dep_obj.search(cr, uid, [('company_id','=',obj.company_id.id)],order='sequence asc')
        #if dep_ids != []:
            #for dep_id in dep_ids:
        emp_ids = emp_obj.search(cr, uid, [
            ('company_id','=',obj.company_id.id)
            #,('department_id','=',dep_id)
        ],order='department_id asc')
        if emp_ids != []:
            for emp_id in emp_ids:
                line = emp_obj.browse(cr, uid, emp_id)
                #if line.contract_id.id!=False:
                    #contract_wage = line.contract_id.wage
                #else:
                    #contract_wage = 0
                
            #Фонд цаг бодох (Odoo hr_payroll -оос үндсэн функцээс дуудаж ашиглав.):
                contract_ids = hr_payslip.get_contract(cr, uid, line, date_from, date_to)
                #Хэрэв public holiday г.м ашиглах болбол үндсэн модулийн энэ функцыг шалгаарай:
                work_day_lines = hr_payslip.get_worked_day_lines(cr, uid, contract_ids, date_from, date_to)
                working_hours = 0
                if work_day_lines != []:
                    for work_day_line in work_day_lines:
                        working_hours = working_hours + work_day_line['number_of_hours']
            #Ажилласан цаг бодох:
                times = self.calculate_worked_time(cr, uid, emp_id, date_from, date_to, contract_ids)
                
                emp_inf = emp_inf_obj.search(cr, uid, [('employee_id','=',emp_id), ('hr_hour_id','=',obj.id)],limit=1)
                if emp_inf == []:
                    emp_inf_obj.create(cr, uid, {
                            'employee_id':line.id,
                            'hr_hour_id':obj.id,
                            'working_hours': working_hours,
                            'regular_hours': times['all']/3600,
                            'name':line.employee_code,
                            'department_name':line.department_id.id,
                            'department_code':line.department_id.code,
                            'job_id':line.job_id.id,
                            
                            'sat_overtime':0,
                            'total_overtime': times['over_time']/3600,
                            'absent_hours': (times['late_time']+times['early_time'])/3600,
                            'lagged_time':times['late_time']/60,
                            #'late_pay':times['late_time']/60,
                            #'late_amount':fields.float('Amount'),
                            'holiday_hours':0,
                            'click_problem':times['problem'],
                            'worked_in_time':times['in_worktime']/3600,
                            #'late_pay':obj.like_late,
                    })
                else:
                    emp_inf_obj.write(cr, uid, emp_inf, {
                         'working_hours': working_hours,
                         'regular_hours': times['all']/3600,
                         'name':line.employee_code,
                         'department_name':line.department_id.id,
                         'department_code':line.department_id.code,
                         'job_id':line.job_id.id,
                         'sat_overtime':0,
                         
                         
                            'total_overtime': times['over_time']/3600,
                            'absent_hours': (times['late_time']+times['early_time'])/3600,
                            'lagged_time':times['late_time']/60,
                            #'late_pay':,
                            #'late_amount':fields.float('Amount'),
                            'holiday_hours':0,
                            'click_problem':times['problem'],
                            'worked_in_time':times['in_worktime']/3600,
                            #'late_pay':obj.like_late,
                         
                         
                    })

            #else:
             #raise osv.except_osv(_('Error!'),_("Selected employees."))
        return True
    
    def calculate_worked_time(self, cr, uid, emp_id, date_from, date_to, contract_ids, context=None):
        hr_attendance = self.pool.get('hr.attendance')
        #Амралтыг нэмэхдээ санаа авахаар:
        #def was_on_leave(employee_id, datetime_day, context=None):
            #res = False
            #day = datetime_day.strftime("%Y-%m-%d")
            #holiday_ids = self.pool.get('hr.holidays').search(cr, uid, [('state','=','validate'),('employee_id','=',employee_id),('type','=','remove'),('date_from','<=',day),('date_to','>=',day)])
            #if holiday_ids:
                #res = self.pool.get('hr.holidays').browse(cr, uid, holiday_ids, context=context)[0].holiday_status_id.name
            #return res
        
        start_date = datetime.datetime.strptime(date_from,"%Y-%m-%d")
        end_date = datetime.datetime.strptime(date_to,"%Y-%m-%d")
        start_date_str = datetime.datetime.strftime(start_date, "%Y-%m-%d %H:%M:%S")
        end_date_str = datetime.datetime.strftime(end_date+datetime.timedelta(0,86400), "%Y-%m-%d %H:%M:%S")

        #Хэрвээ олон гэрээ нэг ажилтан дээр байх тохиолдолд ажиллахгүй
        contract = self.pool.get('hr.contract').browse(cr, uid, contract_ids, context=context)
        if contract.working_hours:
            working_weekdays = contract.working_hours.get_weekdays()[0]
            
            
        #calendar_attendance_obj = self.pool.get('resource.calendar.attendance')
        #calendar_attendance_ids = calendar_attendance_obj.search(cr, uid, [('calendar_id','=',contract.working_hours.id)], context=context)
        #cal_at_times = {}
        #for cal_at_id in calendar_attendance_ids:
            #cal_attendance = calendar_attendance_obj.browse(cr, uid, cal_at_id)
            #dow = cal_attendance.dayofweek
            #cal_at_times[dow] = cal_attendance
        
        #workdays = {}
        #holidays = []
        #total_days = (end_date - start_date).days + 1 #inclusive 5 days
        #for day_number in range(total_days):
            #current_date = (start_date + datetime.timedelta(days = day_number))
            #if current_date.weekday() in working_weekdays:
                #if contract.working_hours:
                    #print contract.working_hours.get_working_intervals_of_day(current_date)
                #workdays.append(current_date)
            #else:
                #holidays.append(current_date)
            
        
        #cr.execute("""SELECT id, employee_id, name, extract(hour from name)
                            #FROM hr_attendance
                             #WHERE name >= (timestamp '""" + start_date_str + """' - (timezone_diff*(interval '1 seconds'))) AND name < (timestamp '""" + end_date_str + """' - (timezone_diff*(interval '1 seconds'))) AND employee_id=""" + str(emp_id) + """
                             #order by name ASC
                             #""")
        #employee_attendances = cr.dictfetchall()
        #clicked_times = cr.execute('SELECT action, clicked_datetime FROM hr_attendance WHERE clicked_datetime>=\'' + start_date_str + '\' AND clicked_datetime<\'' + end_date_str + '\' AND employee_id=\'' + str(emp_id) + '\' GROUP BY hr_attendance.id, EXTRACT(DAY FROM clicked_datetime) ORDER BY clicked_datetime')
        #print 'ooppppppppppppppppo',clicked_times
        #clicked_timesfetch = cr.dictfetchall()
        
        attendances = hr_attendance.search(cr, uid, [('clicked_datetime','>=',start_date_str ),('clicked_datetime','<',end_date_str),('employee_id','=',emp_id)], order='name ASC')
        
        times = {'all':0, 'in_worktime':0, 'weekend_worked':0, 'over_time':0, 'late_time':0, 'early_time':0, 'counter': 1, 'problem':True}
        
        for attendance_id in attendances:
            attendance_click = hr_attendance.browse(cr, uid, attendance_id)
            
            clicked_time = datetime.datetime.strptime(attendance_click.clicked_datetime,"%Y-%m-%d %H:%M:%S")
            
            try:
                prev_time
            except NameError:
                #хамгийн анхных
                times = {'all':0, 'in_worktime':0, 'weekend_worked':0, 'over_time':0, 'late_time':0, 'early_time':0, 'counter': 1, 'problem':False}
                if len(attendances) == 1:
                    times['problem'] = True
                    
            else:
                if prev_time.date() == clicked_time.date():
                    if attendance_click.action == 'sign_out':
                        all_worked_time = (clicked_time - prev_time).total_seconds()
                        times['all'] = times['all'] + all_worked_time
                        if contract.working_hours:
                            #resource module-ын функцыг ашиглаж байгаа:
                            worktimes_inday = contract.working_hours.get_working_intervals_of_day(prev_time, clicked_time)
                            #print'priiiiiiiiiiiiiiiv_time',prev_time
                            #print'loooogggg',worktimes_inday
                            if clicked_time.weekday() in working_weekdays:
                                working_intervals = []
                                work_dt = prev_time.replace(hour=0, minute=0, second=0)
                                for calendar_working_days in contract.working_hours.get_attendances_for_weekdays([prev_time.weekday()]):
                                    
                                    for calendar_working_day in calendar_working_days:
                                        working_interval = (
                                            work_dt.replace(hour=int(calendar_working_day.hour_from)),
                                            work_dt.replace(hour=int(calendar_working_day.hour_to))
                                        )
                                        working_intervals.append((working_interval))
                                        
                                
                                working_intervals = self.pool.get('resource.calendar').interval_clean(working_intervals)
                                
                            worked_hours = 0
                           
                            for worktime in worktimes_inday:
                                if len(worktime) > 1:
                                    worktime = self.pool.get('resource.calendar').interval_clean(worktime)
                                    i = 0
                                    for worktime_times in worktime:
                                        worked_hours = worked_hours + (worktime_times[1] - worktime_times[0]).total_seconds()
                                        
                                        if working_intervals[i][0] < worktime_times[0]:
                                            late_time = worktime_times[0] - working_intervals[i][0]
                                            times['late_time'] = times['late_time'] + late_time.total_seconds()
   
                                        if working_intervals[i][1] > worktime_times[1]:
                                            early_time = working_intervals[i][1] - worktime_times[1]
                                            times['early_time'] = times['early_time'] + early_time.total_seconds()
                                            
                                        i = i + 1
                                        
                            if worked_hours == 0:
                                if not clicked_time.weekday() in working_weekdays:
                                    times['weekend_worked'] = times['weekend_worked'] + all_worked_time
                                else:
                                    times['over_time'] = times['over_time'] + all_worked_time
                            else:
                                    times['over_time'] = times['over_time'] + (all_worked_time - worked_hours)
                            
                            times['in_worktime'] = times['in_worktime'] + worked_hours
                        
                    times['counter'] = times['counter'] + 1
                else:
                    if not times['counter'] % 2 == 0:
                        #Хэрвээ нийт даралтын тоо өдөрт сондгой байвал асуудалтай гэж тэмдэглэнэ. Дутуу буюу илүү дарсан байх магадлалтай буюу гараар шалгах хэрэгтэй
                        times['problem'] = True
                    times['counter'] = 1
                    
            prev_time = clicked_time
                
        return times
    
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('employee.info')
        for line in obj.employee_info_id:
            line_obj.unlink(cr, uid, line.id)
        return super(hr_hour_record, self).unlink(cr, uid, ids, context=context)

class employee_info(osv.osv):
    _name = 'employee.info'
    
    _columns = {
                'hr_hour_id':fields.many2one('hr.hour.record','Hr hour'),
                'employee_id':fields.many2one('hr.employee','Employee'),
                'department_code':fields.char('Department code'),
                'department_name':fields.many2one('hr.department','Department'),
                'name':fields.char('Employee code'),
                'job_id':fields.many2one('hr.job','Job'),
                'working_hours':fields.float('Working hours'),
                'regular_hours':fields.float('Regular hours'),
                'sat_overtime':fields.float('Sat overtime'),
                'overhours':fields.float('Overhours'),
                'total_overtime':fields.float('Total overtime'),
                'sick_hours':fields.float('Sick hours'),
                'free_hours':fields.float('Left hours'),
                'absent_hours':fields.float('Absent hours'),
                'annual_leave_days':fields.float('Annual leave days'),
                'other':fields.float('Other'),
                'lagged_time':fields.float('Lagged time'),
                #'late_pay':fields.float('Late amount'),
                #'late_amount':fields.float('Amount'),
                'holiday_hours':fields.float('Holiday hours'),
                }
    def onchange_employee_info(self, cr, uid, ids, empl_id, context=None):
        res = {}
        if ids:
            obj = self.browse(cr, uid, ids)[0]
            #print "llllllllll",empl_id
            if empl_id:
                #print "aaaaaaaaaa",empl_id 
                empl_obj = self.pool.get('hr.employee')
                empl = empl_obj.browse(cr, uid, empl_id)[0]
                empl = emp_obj.search(cr, uid, [('company_id','=',obj.company_id.id)])
                #print "ddddddddddd",empl
                res['name']=empl.employee_code
                res['department_name']=empl.department_id.id
                res['department_code']=empl.department_id.code
                res['job_id']=empl.job_id.id
                return {'value':res}

class hr_attendance(osv.osv):
    _inherit = 'hr.attendance'
    _columns = {
           #'timezone_diff':fields.integer('Timezone diff'),
           'clicked_datetime':fields.datetime('Clicked Time'),
           'click_problem':fields.boolean('Click Problem'),
           'worked_in_time':fields.float('Worked in time'),
           }
    
class attendance_detail(osv.osv):
    _name = 'attendance.detail'
    
    _columns = {
               'name':fields.char('Name'),
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               'start_date':fields.date('Start date'),
               'end_date':fields.date('End date'),
               'detail_line_id': fields.one2many('detail.line','attendance_detail_id','Detail line'),
               'state': fields.selection([
                    ('draft', 'Draft'),
                    ('cancel', 'Cancel'),
                    ('approve', 'Approve'),
                    ], 'State'),
                
               }
    _defaults = {
                 'state': 'draft',
                 }  
                 
    def daterange(self, start_date, end_date):
        for n in range(int ((end_date - start_date).days)):
            yield start_date + timedelta(n)
            
    def action_detail_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True

    def action_detail_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'cancel'})
        return True
    
    def action_detail_approve(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'approve'})
        
    def action_attendance_download(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        emp_obj = self.pool.get('hr.employee')
        emp_inf_obj = self.pool.get('employee.info')
        hr_payslip = self.pool.get('hr.payslip')
        detail_line_obj = self.pool.get('detail.line')
        date_from = obj.start_date
        date_to = obj.end_date
        emp_id = obj.hr_employee_id

        employee_info = emp_obj.browse(cr, uid, emp_id)
        
        #Фонд цаг бодох (Odoo hr_payroll -оос үндсэн функцээс дуудаж ашиглав.):
        contract_ids = hr_payslip.get_contract(cr, uid, emp_id, date_from, date_to)
        #Хэрэв public holiday г.м ашиглах болбол үндсэн модулийн энэ функцыг шалгаарай:
        start_date = datetime.datetime.strptime(str(date_from),"%Y-%m-%d")
        end_date = datetime.datetime.strptime(str(date_to),"%Y-%m-%d")

        contract = self.pool.get('hr.contract').browse(cr, uid, contract_ids, context=context)

        if contract.working_hours:
            working_weekdays = contract.working_hours.get_weekdays()[0]
            #worktimes_inday = contract.working_hours.get_working_intervals_of_day(date_line)
            dayofweek = {}
            for line in contract.working_hours.attendance_ids:
                key = int(line.dayofweek)
                if not key in dayofweek:
                    dayofweek[key] = []

                dayofweek[key].append([line.hour_from, line.hour_to])
                

        else:
            return False
        
        old_ids = detail_line_obj.search(cr, uid, [('attendance_detail_id','=',obj.id)])
        detail_line_obj.unlink(cr, uid, old_ids, context=context)
        
        for date_line in obj.daterange(start_date, end_date):
            hour_from = 0
            hour_to = 0
            lunchtime_from = 0
            lunchtime_to = 0
            worked_hour_from = 0
            worked_hour_to = 0
            in_tea_went = 0
            in_tea_come = 0
            lunch_time = 0
            late = 0
            early_went = 0
            total_late = 0
            outside = 0
            overtime = 0
            worked_time = 0
            
            
            worktimes_inday = []
            
            line_weekday = date_line.weekday()
            if line_weekday in dayofweek:
                worktimes_inday = dayofweek[line_weekday]
            
                if len(worktimes_inday) == 2:
                    hour_from = worktimes_inday[0][0]
                    hour_to = worktimes_inday[1][1]
                    lunchtime_from = worktimes_inday[0][1]
                    lunchtime_to = worktimes_inday[1][0]
                    lunch_time = lunchtime_to - lunchtime_from
                elif len(worktimes_inday) == 1:
                    hour_from = worktimes_inday[0][0]
                    hour_to = worktimes_inday[0][1]

                
            attd_obj = self.pool.get('hr.attendance')
            
            fromstr = date_line.strftime("%Y-%m-%d") + ' 00:00:00'
            tostr = date_line.strftime("%Y-%m-%d") +' 23:59:59'
            attd_exists_id = attd_obj.search(cr, uid, [('employee_id','=',emp_id.id), ('clicked_datetime','>',fromstr), ('clicked_datetime','<',tostr)], order='clicked_datetime')

            if attd_exists_id != []:
                clicked = []
                for line in attd_exists_id:
                    clicked_info = attd_obj.browse(cr, uid, line)
                    d = datetime.datetime.strptime(clicked_info['clicked_datetime'],"%Y-%m-%d %H:%M:%S")
                    clicked_time = float(d.hour) + float(d.minute) / 60
                    clicked.append(clicked_time)
                    
                worked_hour_from = clicked[0]    
                if len(clicked) == 4:
                    worked_hour_to = clicked[3]
                    in_tea_went = clicked[1]
                    in_tea_come = clicked[2]
                elif len(clicked) == 2:
                    worked_hour_to = clicked[1]
                    
                # Хэрэв дээрх 2 тохиолдлоос өөр тэгш тоотой даралт байвал эхлэл төгсгөлийг авна.
                elif len(clicked) % 2 == 0:
                    worked_hour_to = clicked[0]
                    if len(worktimes_inday) == 2:
                        #worktimes_inday[0][1]
                        #worktimes_inday[1][0]
                        in_tea_went = clicked[1]
                        in_tea_come = clicked[2]
                    
                # Хэрэв сондгой тоотой дарсан байвал өдөр дамнаж ажиллах хувааритай эсэхийг шалгана.
                elif len(worktimes_inday) > 0 and worktimes_inday[0][0] == 0:
                    worked_hour_to = 0
                elif len(worktimes_inday) > 0 and worktimes_inday[0][0] == 0:
                    worked_hour_from = 0
                    worked_hour_to = clicked[0]
                    
                # Хэрэв өдөр дамнаж ажиллаагүй, сондгой байвал хамгийн эхэнд ба, хамгийн сүүлд дарсан даралтаар авна
                elif len(clicked) > 1:
                    worked_hour_to = clicked[0]
                
            #else:
                #Error
                
                
            if hour_from > 0 and hour_to > 0:
                if worked_hour_from > 0 and worked_hour_to > 0:    
                    
                    if hour_from < worked_hour_from:
                        late = worked_hour_from - hour_from
                    if worked_hour_to > 0 and worked_hour_to < hour_to:
                        early_went = hour_to - worked_hour_to
                    
                    if lunchtime_to > 0 and lunchtime_from > 0:
                        if in_tea_come > 0 and in_tea_went > 0:
                            lunch_time_exceed = (in_tea_come - in_tea_went) - (lunchtime_to - lunchtime_from)
                            if lunch_time_exceed > 0:
                                if late > 0:
                                    late = late + lunch_time_exceed
                                else:
                                    late = lunch_time_exceed
                    
                    
                    #Энэ хэсгийг шалгаарай:
                    if early_went > 0 and late > 0:
                        total_late = early_went + late
                    elif early_went > 0:
                        total_late = early_went
                    elif late > 0:
                        total_late = late
                        
                    
                    if hour_from > worked_hour_from:
                        overtime = hour_from - worked_hour_from
                    if worked_hour_to > hour_to:
                        if overtime <= 0:
                            overtime = worked_hour_to - hour_to
                        else:
                            overtime = overtime + (worked_hour_to - hour_to)
                    
                    if late > 0 and overtime > late:
                        overtime = overtime - late
                    else:
                        overtime = 0
                        
                    if worked_hour_to > 0 and worked_hour_from > 0:
                        worked_time = worked_hour_to - worked_hour_from
                        if lunchtime_to > 0 and lunchtime_from > 0:
                            worked_time = worked_time - (lunchtime_to - lunchtime_from)
                            if in_tea_come > 0 and in_tea_went > 0 and lunch_time_exceed > 0:
                                worked_time = worked_time - lunch_time_exceed
                                
            elif worked_hour_from > 0 and worked_hour_to > 0:
                 worked_time = worked_hour_to - worked_hour_from
                 overtime = worked_time
                               
            
            #outside = 
            
            detail_line = detail_line_obj.search(cr, uid, [('attendance_detail_id','=',obj.id), ('detail_date','=',date_line), ('hr_employee_id','=',emp_id.id)],limit=1)
            if detail_line == []:
                detail_line_obj.create(cr, uid, {
                    'hr_employee_id':emp_id.id,
                    'attendance_detail_id':obj.id,
                    'detail_date':date_line,
                    'hour_from':hour_from,
                    'hour_to':hour_to,
                    'lunchtime_from':lunchtime_from,
                    'lunchtime_to':lunchtime_to,
                    'worked_hour_from':worked_hour_from,
                    'worked_hour_to':worked_hour_to,
                    'in_tea_went':in_tea_went,
                    'in_tea_come':in_tea_come,
                    'late':late,
                    'early_went':early_went,
                    'total_late':total_late,
                    'outside':outside,
                    'overtime':overtime,
                    'worked_time': worked_time
                })
            #else:
                #detail_line_obj.write(cr, uid, detail_line, {
                    #'hour_from':hour_from,
                    #'hour_to':hour_to,
                    #'lunchtime_from':lunchtime_from,
                    #'lunchtime_to':lunchtime_to,
                    #'worked_hour_from':worked_hour_from,
                    #'worked_hour_to':worked_hour_to,
                    #'in_tea_went':in_tea_went,
                    #'in_tea_come':in_tea_come,
                    
                #})
         
        return True    
        
    def action_detail_calculate(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        return True     
        
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('detail.line')
        for line in obj.detail_line_id:
            line_obj.unlink(cr, uid, line.id)
        return super(attendance_detail, self).unlink(cr, uid, ids, context=context)   
       
class detail_line(osv.osv):
    _name = 'detail.line'
    _columns = {
               'detail_date':fields.date('Detail date'),
               'hour_from':fields.float('Hour from'),
               'hour_to':fields.float('Hour to'),
               'lunchtime_from':fields.float('Lunch from'),
               'lunchtime_to':fields.float('Lunch to'),
               'worked_hour_from':fields.float('Come'),
               'worked_hour_to':fields.float('Went'),
               'in_tea_went':fields.float('In tea went'),
               'in_tea_come':fields.float('In tea come'),
               'late':fields.float('Late'),
               'early_went':fields.float('Early went'),
               'total_late':fields.float('Total late'),
               'outside':fields.float('Outside'),
               'overtime':fields.float('Overtime'),
               'worked_time':fields.float('Worked time'),
               'attendance_detail_id':fields.many2one('attendance.detail','Attendance detail'),
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               }         
