# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import logging

from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _
import time

class hr_payroll_end(osv.osv):
    _name = 'hr.payroll.end'
    
    _columns = {
                'department_id':fields.many2one('hr.department','Department'),
                'start_date':fields.date('Start date'),
                'end_date':fields.date('End date'),
                'company_id':fields.many2one('res.company','Company'),
                #'like_percent':fields.integer('Daily meal pay',required=True),
                #'like_late':fields.integer('Late pay',required=True),
                'line_id':fields.one2many('hr.payroll.end.line','payroll_end_id','Hr payroll end line'),
                'state':fields.selection([('draft','Draft'),
                                          ('confirm','Confirm')],'State'),
                
                }
    _defaults = {
                 'state': 'draft',
                 }
    
    #def action_compute(self, cr, uid, ids, *args):
        #obj = self.browse(cr, uid, ids)[0]
        #end_line_obj = self.pool.get('hr.payroll.end.line')
        #if obj.line_id !=[]:
            #for line in obj.line_id:
                #salary = (line.name*obj.like_percent)/100
                #end_line_obj.write(cr, uid, line.id,{'food_amount':obj.like_percent,
                                                     #'lagged_minutes':obj.like_late,
                                                         #})
    
    def action_cancel_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        pay_line_obj = self.pool.get('hr.payroll.end.line')
        obj = self.browse(cr, uid, ids)
        for line in obj.line_id:
            pay_line_obj.write(cr, uid, line.id, {
                                                'contract_bonus':0,
                                                })
        return True

    def action_to_confirm(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'confirm'})
        pay_line_obj = self.pool.get('hr.payroll.end.line')
        obj = self.browse(cr, uid, ids)
        bonus_calculate = 0
        for line in obj.line_id:
            bonus_calculate = (line.contract_amount*line.contract_percent)/100
            pay_line_obj.write(cr, uid, line.id, {
                                            'contract_bonus':bonus_calculate,
                                            })
        return {
            'name': _('Compose Email'),
            'type': 'ir.actions.act_window',
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'create.account',
            'view_id': False,
            'target': 'new',
        }
        
    def action_payroll_end(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        emp_obj = self.pool.get('hr.employee')
        ad_pay_line_obj = self.pool.get('hr.payroll.end.line')
        ad_line_obj = self.pool.get('hr.advance.salary.line')
        de_line_obj = self.pool.get('deduction.line')
        dep_obj = self.pool.get('hr.department')
        empl_info_obj = self.pool.get('employee.info')
        incentive_line_obj = self.pool.get('incentive.line')
        dep_id = dep_obj.search(cr, uid, [('company_id','=',obj.company_id.id)],order='sequence asc')
        if dep_id:
            contract_wage = 0
            contract_food = 0
            cont_percent = 0
            inc_percent = 0
            squ_percent = 0
            #mill_fund = 0
            working_hours = 0
            emp_id = emp_obj.search(cr, uid, [('company_id','=',obj.company_id.id),('department_id','=',dep_id)])
            if obj.line_id.id == False:
                for line in emp_obj.browse(cr, uid, emp_id):
                    if line.contract_id.id!=False:
                        contract_wage = line.contract_id.wage
                        contract_food = line.contract_id.food_amount
                        cont_percent = line.contract_id.contract_percent
                        inc_percent = line.contract_id.income_percent
                        squ_percent = line.contract_id.square_percent
                        #mill_fund = line.contract_id.mill_fund_id
                    else:
                        #mill_fund = 0
                        squ_percent = 0
                        inc_percent = 0
                        cont_percent = 0
                        contract_food = 0
                        contract_wage = 0
                    line_hours = empl_info_obj.search(cr, uid, [('employee_id','=',line.id)])
                    if line_hours !=[]:
                        for hours in empl_info_obj.browse(cr, uid, line_hours):
                            working_hours = hours.working_hours
                            regular_hours = hours.regular_hours
                            total_hours = hours.total_overtime
                            lagged_minutes = hours.lagged_time 
                            #late_pay = hours.late_pay
                            holiday_hours = hours.holiday_hours   
                            
                    line_advance = ad_line_obj.search(cr, uid, [('employee_id','=',line.id)])
                    if line_advance !=[]:
                        for advan in ad_line_obj.browse(cr, uid, line_advance):
                            advance_salary = advan.total_advance_salary
                            
                    line_deduction = de_line_obj.search(cr, uid, [('hr_employee_id','=',line.id)])
                    if line_deduction !=[]:
                        for deduc in de_line_obj.browse(cr, uid, line_deduction):
                            other_deduction = deduc.other_deduction
                            recievable76 = deduc.recievable76        
                            
                    line_incentive = incentive_line_obj.search(cr, uid, [('hr_employee_id','=',line.id)])
                    if line_incentive !=[]:
                        for incentive in incentive_line_obj.browse(cr, uid, line_incentive):
                            total_result_percent = incentive.result_percent
                            #inc_spf_acc = incentive.inc_spf_acc
                            sick_pay = incentive.sick_pay
                            maternity_pay = incentive.maternity_pay
                            annual_leave_pay = incentive.annual_leave_pay
                            bonus_salary = incentive.bonus
                            salary_done = incentive.salary_done
                            other_insentive = incentive.other_inc
                            contract_amount = incentive.contract_amount
                            income_amount = incentive.income_amount               
                    ad_pay_line_obj.create(cr, uid, {
                                                     'employee_info_id':line.id,
                                                     'payroll_end_id':obj.id,
                                                     'hr_advance_salary_line_id':line.id,
                                                     'deduction_id':line.id,
                                                     'incentive_id':line.id,
                                                     'working_hours':working_hours,
                                                     'regular_hours':regular_hours,
                                                     'total_hours':hours.total_overtime,
                                                     'holiday_hours':hours.holiday_hours,
                                                     'lagged_minutes':hours.lagged_time,
                                                     #'late_pay':hours.late_pay,
                                                     'basic_salary':0,
                                                     'employee_code':line.employee_code,
                                                     'card_number':line.bank_account_id.acc_number,
                                                     'department_name':line.department_id.id,
                                                     'department_code':line.department_id.code,
                                                     'food_amount':contract_food,
                                                     'basic_salary':contract_wage,
                                                     'contract_percent':cont_percent,
                                                     'income_percent':inc_percent,
                                                     'inc_square_percent':squ_percent,
                                                     #'mill_fund_id':mill_fund,
                                                     'advance_salary':advan.total_advance_salary,
                                                     'other_deduction':deduc.other_deduction,
                                                     'recievable76':deduc.recievable76,
                                                     'total_result_percent':incentive.result_percent,
                                                     #'inc_spf_acc':incentive.inc_spf_acc,
                                                     'sick_pay':incentive.sick_pay,
                                                     'maternity_pay':incentive.maternity_pay,
                                                     'annual_leave_pay':incentive.annual_leave_pay,
                                                     'bonus_salary':incentive.bonus,
                                                     'salary_done':incentive.salary_done,
                                                     'other_insentive':incentive.other_inc,
                                                     'contract_amount':incentive.contract_amount,
                                                     'income_amount':incentive.income_amount,
                                                     })
                    
            else:
                raise osv.except_osv(_('Error!'),_("Selected employees."))
            return True 
            
    def action_total_compute(self, cr, uid, ids, *args):
        payroll_line_obj = self.pool.get('hr.payroll.end.line')
        obj = self.browse(cr, uid, ids)
        urjver = 0
        hour_calculate = 0
        happy_time = 0
        square_calculate = 0
        contract_calculate = 0
        income_calculate = 0
        sum_calculate = 0
        sum_total = 0
        shi_calculate = 0
        meal_calculate = 0
        shi_meal_calculate = 0
        pit_calculate = 0
        total_calculate = 0
        hand_calculate = 0
        debit_calculate = 0
        #mill_calculate = 0
        for line in obj.line_id:
            if line.working_hours > 0.0 and line.regular_hours>0.0:
                urjver = (line.basic_salary/line.working_hours*line.regular_hours*line.total_result_percent)/100
                #total_calculate = urjver+line.annual_leave_pay-line.other_deduction+line.other_incentive
                hour_calculate = line.basic_salary/line.working_hours*1.5*line.total_hours
                happy_time = line.basic_salary/line.working_hours*2*line.holiday_hours
                square_calculate = (urjver*line.inc_square_percent)/100
                contract_calculate = (line.contract_amount*line.contract_percent)/100
                income_calculate = (line.income_amount*line.income_percent)/100
                meal_calculate = line.working_hours/8*line.food_amount
                sum_calculate = hour_calculate+happy_time+line.annual_leave_pay+line.bonus_salary+meal_calculate+line.other_insentive+square_calculate+contract_calculate+income_calculate
                sum_total = line.cal_salary+line.salary_done+sum_calculate
                lagged_calculate = line.basic_salary/line.working_hours/60*line.late_pay*line.lagged_minutes
                if sum_total >= 1920000:
                    shi_calculate = 192000
                else:
                    shi_calculate = (sum_total*10)/100
                    
                if sum_total-meal_calculate >= 1920000:
                    shi_meal_calculate = 192000
                else:
                    shi_meal_calculate = ((sum_total-meal_calculate)*10)/100
                    
                if sum_total-shi_meal_calculate >= 70000:
                    pit_calculate = ((sum_total-shi_meal_calculate)*10)/100-7000
                else:
                    pit_calculate = 0        
                    
                total_calculate = shi_calculate+pit_calculate+line.advance_salary+lagged_calculate+line.other_deduction+line.recievable76
                hand_calculate = sum_total-total_calculate+line.sick_pay+line.maternity_pay
                if total_calculate-sum_total < 0:
                    debit_calculate = 0
                else:
                    debit_calculate = total_calculate-sum_total
                #mill_calculate = line.cal_salary*line.mill_fund_id-line.salary_done*line.mill_fund_id            
                payroll_line_obj.write(cr, uid, line.id, {
                                                'cal_salary':urjver,
                                                'hours_salary':hour_calculate,
                                                'holiday_salary':happy_time,
                                                'inc_square':square_calculate,
                                                'contract_bonus':contract_calculate,
                                                'income_bonus':income_calculate,
                                                'total_incentive':sum_calculate,
                                                'total_salary':sum_total,
                                                'meal_pay':meal_calculate,
                                                'shi':shi_calculate,
                                                'shi_meal':shi_meal_calculate,
                                                'pit':pit_calculate,
                                                'deduction_lagged':lagged_calculate,
                                                'total_deduction':total_calculate,
                                                'on_hand':hand_calculate,
                                                'debit':debit_calculate,
                                                #'mill_amount':mill_calculate,
                                                
                                                })
                
            
        return True 
                  
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('hr.payroll.end.line')
        for line in obj.line_id:
            line_obj.unlink(cr, uid, line.id)
        return super(hr_payroll_end, self).unlink(cr, uid, ids, context=context)
                
class hr_payroll_end_line(osv.osv):
    _name = 'hr.payroll.end.line'
    
    _columns = {
                'department_code':fields.char('Department code', readonly=True),
                'department_name':fields.many2one('hr.department','Department', readonly=True),
                'employee_code':fields.char('Employee code', readonly=True),
                'basic_salary':fields.float('Basic salary', readonly=True),
                'working_hours':fields.float('Working hours', readonly=True),
                'regular_hours':fields.float('Regular hours', readonly=True),
                'cal_salary':fields.float('Cal salary', readonly=True),
                'total_hours':fields.float('Total hours', readonly=True),
                'hours_salary':fields.float('Hours salary', readonly=True),
                'holiday_hours':fields.float('Holiday hours', readonly=True),
                'holiday_salary':fields.float('Holiday salary', readonly=True),
                #'inc_spf_acc':fields.float('Inc spf acc'),
                'sick_pay':fields.float('Sick pay'),
                'annual_leave_pay':fields.float('Annual leave pay'),
                'maternity_pay':fields.float('Maternity pay'),
                'bonus_salary':fields.float('Bonus salary'),
                'food_amount':fields.float('Food amount', readonly=True),
                'meal_pay':fields.float('Meal pay', readonly=True),
                'other_insentive':fields.float('Other insentive', readonly=True),
                'inc_square_percent':fields.integer('Inc square percent'),
                'inc_square':fields.float('Inc square', readonly=True),
                'contract_amount':fields.float('Contract amount'),
                'contract_percent':fields.float('Contract percent'),
                'contract_bonus':fields.float('Contract bonus', readonly=True),
                'income_amount':fields.float('Income amount'),
                'income_percent':fields.integer('Income percent'),
                'income_bonus':fields.float('Income bonus', readonly=True),
                'salary_done':fields.float('Salary done'),
                'total_incentive':fields.float('Total incentive', readonly=True),
                'total_salary':fields.float('Total salary', readonly=True),
                'shi':fields.float('Shi', readonly=True),
                'shi_meal':fields.float('Except meal', readonly=True),
                'pit':fields.float('Pit', readonly=True),
                'advance_salary':fields.float('Advance salary'),
                'lagged_minutes':fields.float('Lagged minutes', readonly=True),
                'late_pay':fields.float('Late amount', readonly=True),
                'deduction_lagged':fields.float('Deduction lagged', readonly=True),
                'other_deduction':fields.float('Other deduction', readonly=True),
                'recievable76':fields.float('Recievable 76'),
                'total_deduction':fields.float('Total deduction', readonly=True),
                'on_hand':fields.float('On hand', readonly=True),
                'debit':fields.float('Debit', readonly=True),
                #'mill_fund_id':fields.integer('Mill fund'),
                #'mill_amount':fields.float('Mill amount'),
                'hoh_fund':fields.float('Hoh fund'),
                'total_result_percent':fields.float('Total result percent'),
                'card_number':fields.char('Card number', readonly=True),
                'payroll_end_id':fields.many2one('hr.payroll.end','Hr payroll end'),
                'employee_id':fields.many2one('hr.employee','Employee', readonly=True),
                }
    def onchange_employee_name(self, cr, uid, ids, empl_id, context=None):
        res = {}
        if ids:
            obj = self.browse(cr, uid, ids)[0]
            if empl_id:
                empl_obj = self.pool.get('hr.employee')
                empl = empl_obj.browse(cr, uid, empl_id)[0]
                empl = emp_obj.search(cr, uid, [('company_id','=',obj.company_id.id)])
                res['employee_code']=empl.employee_code
                res['card_number']=empl.bank_account_id.acc_number
                res['department_name']=empl.department_id.id
                res['department_code']=empl.department_id.code
                res['food_amount']=empl.contract_id.food_amount
                res['contract_percent']=empl.contract_id.contract_percent
                res['income_percent']=empl.contract_id.income_percent
                res['inc_square_percent']=empl.contract_id.square_percent
                #res['mill_fund_id']=empl.contract_id.mill_fund_id
                #res['name']=empl.contract_id.wage
                return {'value':res}
            
#===============================================================================
# class millionaire_fund_saving(osv.osv):
#     _name = 'millionaire.fund.saving'
#     
#     _columns = {
#                 'department_id':fields.many2one('hr.department','Department'),
#                 'hr_employee_id':fields.many2one('hr.employee','Employee'),
#                 'name':fields.char('Name'),
#                 'start_date':fields.date('Start date'),
#                 'end_date':fields.date('End date'),
#                 'millionaire_code':fields.many2one('hr.salary.rule.category','Millionaire code'),
#                 'company_id':fields.many2one('res.company','Company'),
#                 'millionaire_id':fields.one2many('millionaire.line','fund_id','Millionaire line'),
#                 'state':fields.selection([('draft','Draft'),
#                                           ('confirm','Confirm')],'State'),
#                 
#                 }
#     _defaults = {
#                  'state': 'draft',
#                  } 
#     
#     def action_draft(self, cr, uid, ids, *args):
#         self.write(cr, uid, ids, {'state': 'draft'})
#         return True
# 
#     def action_confirm(self, cr, uid, ids, context=None):
#         self.write(cr, uid, ids, {'state': 'confirm'})
#         return True
#     
#     def action_millionaire_calculate(self, cr, uid, ids, context=None):
#          obj = self.browse(cr, uid, ids)[0]
#          emp_obj = self.pool.get('hr.employee')
#          payslip_obj = self.pool.get('hr.payslip')
#          millionaire_line_obj = self.pool.get('millionaire.line')
#         #period_obj = self.pool.get('account.period')
#          payslip_line_obj = self.pool.get('hr.payslip.line')
#          
#          if obj.millionaire_id:
#              mill_line_id = millionaire_line_obj.search(cr, uid, [('fund_id','=',obj.id)])
#              for line_id in obj.millionaire_id:
#                  #account_period_id = period_obj.search(cr, uid, [('id','=',line_id.period_id.id)])
#                  #per_id = period_obj.browse(cr, uid, account_period_id)
#                  hr_payslip = payslip_obj.search(cr, uid, [('employee_id','=',line_id.hr_employee_id.id),('date_from','=',obj.start_date),('date_to','=',obj.end_date)])
#                  payslip_id = payslip_obj.browse(cr, uid, hr_payslip)
#                  mill_line_id = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.millionaire_code.id)])
#                  payslip_line_id = payslip_line_obj.browse(cr, uid, mill_line_id)
#                  millionaire_line_obj.write(cr, uid, line_id.id, {
#                                                                 'millionaire_amount':payslip_line_id.total,
#                                                                 },context=context)
#          return True
#     
#     def action_fund(self, cr, uid, ids, context=None):
#         obj = self.browse(cr, uid, ids)[0]
#         emp_obj = self.pool.get('hr.employee')
#         millionaire_line_obj = self.pool.get('millionaire.line')
#         #ad_pay_line_obj = self.pool.get('hr.payroll.end.line')
#         dep_obj = self.pool.get('hr.department')
#         dep_id = dep_obj.search(cr, uid, [('company_id','=',obj.company_id.id)],order='sequence asc')
#         if dep_id:
#             emp_id = emp_obj.search(cr, uid, [('company_id','=',obj.company_id.id),('department_id','=',dep_id)])
#             if obj.millionaire_id.id == False:
#                 for line in emp_obj.browse(cr, uid, emp_id):
#                     
#                     #line_ad_pay = ad_pay_line_obj.search(cr, uid, [('employee_id','=',line.id)])
#                     #if line_ad_pay !=[]:
#                         #for ad_pay in ad_pay_line_obj.browse(cr, uid, line_ad_pay):
#                             #millionaire_amount = ad_pay.mill_amount
#                             
#                     millionaire_line_obj.create(cr, uid, {
#                                                      'hr_employee_id':line.id,
#                                                      'fund_id':obj.id,
#                                                      'employee_code':line.employee_code,
#                                                      'department_name':line.department_id.id,
#                                                      'department_code':line.department_id.code,
#                                                      'name':line.last_name,
#                                                      'register_number':line.register_number,
#                                                      'position_name':line.job_id.id,
#                                                      #'millionaire_amount':ad_pay.mill_amount,
#                                                      })
#             else:
#                 raise osv.except_osv(_('Error!'),_("Selected employees."))
#             return True
#         
#         
#     def unlink(self, cr, uid, ids, context=None):
#         obj = self.browse(cr, uid, ids)[0]
#         line_obj = self.pool.get('millionaire.line')
#         for line in obj.millionaire_id:
#             line_obj.unlink(cr, uid, line.id)
#         return super(millionaire_fund_saving, self).unlink(cr, uid, ids, context=context)
#             
# class millionaire_line(osv.osv):
#     _name = 'millionaire.line'
#     _columns = {
#                'name':fields.char('Last name'),
#                'department_code':fields.char('Department code'),
#                'department_name':fields.many2one('hr.department','Department'),
#                'position_name':fields.many2one('hr.job','Position'),
#                'employee_code':fields.char('Employee code'),
#                'register_number':fields.char('Register number'),
#                'fund_account':fields.many2one('account.account','Fund account'),
#                'purpose':fields.char('Purpose'),
#                'millionaire_amount':fields.float('Millionaire amount'),
#                'fund_id':fields.many2one('millionaire.fund.saving','Millionaire fund saving'),
#                'hr_employee_id':fields.many2one('hr.employee','Employee'),
#                }
#     
#     def onchange_employee(self, cr, uid, ids, empl_id, context=None):
#         res = {}
#         if ids:
#             obj = self.browse(cr, uid, ids)[0]
#             if empl_id:
#                 empl_obj = self.pool.get('hr.employee')
#                 empl = empl_obj.browse(cr, uid, empl_id)[0]
#                 res['name']=empl.last_name
#                 res['employee_code']=empl.employee_code
#                 res['department_name']=empl.department_id.id
#                 res['department_code']=empl.department_id.code
#                 res['register_number']=empl.register_number
#                 res['position_name']=empl.job_id.id
#                 return {'value':res}              
#===============================================================================
    
class salary_incentive(osv.osv):
    _name = 'salary.incentive'
    
    _columns = {
                'department_id':fields.many2one('hr.department','Department'),
                'name':fields.date('Start date'),
                'end_date':fields.date('End date'),
                'company_id':fields.many2one('res.company','Company'),
                'incentive_id':fields.one2many('incentive.line','salary_incentive_id','Incentive line'),
                'state':fields.selection([('draft','Draft'),
                                          ('confirm','Confirm')],'State'),
                
                }
    _defaults = {
                 'state': 'draft',
                 }
    
    def action_incentive_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True

    def action_incentive_confirm(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'confirm'})
        return True    
    
    def action_incentive(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        emp_obj = self.pool.get('hr.employee')
        incentive_line_obj = self.pool.get('incentive.line')
        sick_obj = self.pool.get('sick.benefit')
        maternity_obj = self.pool.get('maternity.benefit')
        annual_obj = self.pool.get('annual.leave')
        dep_obj = self.pool.get('hr.department')
        dep_id = dep_obj.search(cr, uid, [('company_id','=',obj.company_id.id)],order='sequence asc')
        if dep_id:
            emp_id = emp_obj.search(cr, uid, [('company_id','=',obj.company_id.id),('department_id','=',dep_id)])
            if obj.incentive_id.id == False:

                for line in emp_obj.browse(cr, uid, emp_id):
                    annual_leave_pay = 0.0
                    sick_pay = 0.0
                    employer_pay = 0.0
                    maternity_pay = 0.0
                    social_insurance_pay = 0.0
                    sick_id = sick_obj.search(cr, uid, [('hr_employee_id','=',line.id),('date','>=',obj.name),('date','<=',obj.end_date)])
                    if sick_id !=[]:
                        sick = sick_obj.browse(cr, uid, sick_id)
                        sick_pay = sick.giving_total
                        employer_pay = sick.employer_pay
                        social_insurance_pay = sick.social_insurance_pay
                        
                    maternity_id = maternity_obj.search(cr, uid, [('hr_employee_id','=',line.id),('date','>=',obj.name),('date','<=',obj.end_date)])
                    if maternity_id !=[]:
                        maternity = maternity_obj.browse(cr, uid, maternity_id)
                        maternity_pay = maternity.social_insurance_pay
                        
                    annual_id = annual_obj.search(cr, uid, [('hr_employee_id','=',line.id),('date','>=',obj.name),('date','<=',obj.end_date)])
                    if annual_id !=[]:
                        annual = annual_obj.browse(cr, uid, annual_id)
                        annual_leave_pay = annual.annual_pay        
                    
                    incentive_line_obj.create(cr, uid, {
                                                     'hr_employee_id':line.id,
                                                     'salary_incentive_id':obj.id,
                                                     'employee_code':line.employee_code,
                                                     'department_name':line.department_id.id,
                                                     'department_code':line.department_id.code,
                                                     'sick_pay':sick_pay,
                                                     'employer_pay':employer_pay,
                                                     'social_insurance_pay':social_insurance_pay,
                                                     'maternity_pay':maternity_pay,
                                                     'annual_leave_pay':annual_leave_pay,
                                                     'name':line.last_name,
                                                     'position_name':line.job_id.id,
                                                     })
            else:
                raise osv.except_osv(_('Error!'),_("Selected employees."))
            return True 
        
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('incentive.line')
        for line in obj.incentive_id:
            line_obj.unlink(cr, uid, line.id)
        return super(salary_incentive, self).unlink(cr, uid, ids, context=context)
    
class incentive_line(osv.osv):
    _name = 'incentive.line'
    _columns = {
               'name':fields.char('Last name'),
               'department_code':fields.char('Department code'),
               'department_name':fields.many2one('hr.department','Department'),
               'position_name':fields.many2one('hr.job','Position'),
               'employee_code':fields.char('Employee code'),
               'result_percent':fields.integer('Result percent'),
               #'inc_spf_acc':fields.float('Professional accountant'),
               'sick_pay':fields.float('Sick pay'),
               'employer_pay':fields.float('Employer pay'),
               'social_insurance_pay':fields.float('Social insurance pay'),
               'maternity_pay':fields.float('Maternity pay'),
               'annual_leave_pay':fields.float('Annual leave pay'),
               'bonus':fields.float('Bonus'),
               'salary_done':fields.float('Salary done'),
               'other_inc':fields.float('Other incentive'),
               'contract_amount':fields.float('Contract amount'),
               'income_amount':fields.float('Income amount'),
               'salary_incentive_id':fields.many2one('salary.incentive','Salary incentive'),
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               }
    
    def onchange_incentive(self, cr, uid, ids, empl_id, context=None):
        res = {}
        if ids:
            obj = self.browse(cr, uid, ids)[0]
            if empl_id:
                empl_obj = self.pool.get('hr.employee')
                empl = empl_obj.browse(cr, uid, empl_id)[0]
                res['name']=empl.last_name
                res['employee_code']=empl.employee_code
                res['department_name']=empl.department_id.id
                res['department_code']=empl.department_id.code
                res['position_name']=empl.job_id.id
                return {'value':res}   
            
class call_limit(osv.osv):
    _name = 'call.limit'
    
    _columns = {
                'department_id':fields.many2one('hr.department','Department'),
                'name':fields.date('Start date'),
                'end_date':fields.date('End date'),
                'company_id':fields.many2one('res.company','Company'),
                'limit_id':fields.one2many('limit.line','call_limit_id','Limit line'),
                'state':fields.selection([('draft','Draft'),
                                          ('confirm','Confirm')],'State'),
                }
    _defaults = {
                 'state': 'draft',
                 'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'account.settings', context=c),
                 }
    
    def action_call_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True

    def action_call_confirm(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)
        move_obj = self.pool.get('account.move')
        move_line_obj = self.pool.get('account.move.line')
        account_settings_obj = self.pool.get('account.settings')
        partner_obj = self.pool.get('res.partner')
        acc_set_id = account_settings_obj.search(cr, uid, [('company_id','=',obj.company_id.id)])
        period_id = self.pool.get('account.period').find(cr, uid, context=context)[0]

        if acc_set_id != []:
            acc_sett = account_settings_obj.browse(cr, uid, acc_set_id)
            for line in obj.limit_id:
                
                if line.hr_employee_id.user_id.id !=False:
                    partner = partner_obj.browse(cr, uid, line.hr_employee_id.user_id.partner_id.id)
                    move_id = move_obj.create(cr, uid, {
                                              'name':'/',
                                              'period_id':period_id,
                                              'company_id':obj.company_id.id,
                                              'journal_id':acc_sett.journal_id.id,
                                              'date':time.strftime("%Y-%m-%d"),
                                              'ref':'/',
                                              })
                    move_line_obj.create(cr, uid, {
                                                    'name': '/',
                                                    'move_id': move_id,
                                                    'account_id': acc_sett.receivable_account.id,
                                                    'debit': 0.0,
                                                    'credit': line.receivable_call,
                                                    'ref': '/',
                                                    'period_id': period_id,
                                                    'journal_id': acc_sett.journal_id.id,
                                                    'date': time.strftime("%Y-%m-%d"),
                                                    'partner_id': partner.id
                                                   })
                    move_line_obj.create(cr, uid, {
                                                    'name': '/',
                                                    'move_id': move_id,
                                                    'account_id': partner.property_account_receivable.id,
                                                    'debit': line.receivable_call,
                                                    'credit':0.0,
                                                    'ref': '/',
                                                    'period_id': period_id,
                                                    'journal_id': acc_sett.journal_id.id,
                                                    'date': time.strftime("%Y-%m-%d"),
                                                    'partner_id': partner.id
                                                   })
                else:
                    raise osv.except_osv(_('Warning!'),_("Та хүний нөөц дээр холбоотой хэрэглэгчийг сонгоно уу!"))
        else:
            raise osv.except_osv(_('Warning!'),_("Та дансны тохиргоо үүсгэнэ үү!"))
        
        self.write(cr, uid, ids, {'state': 'confirm'})
        return True    
    
    def action_call(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        emp_obj = self.pool.get('hr.employee')
        limit_line_obj = self.pool.get('limit.line')
        dep_obj = self.pool.get('hr.department')
        empl_info_obj = self.pool.get('employee.info')
        dep_id = dep_obj.search(cr, uid, [('company_id','=',obj.company_id.id)],order='sequence asc')
        if dep_id:
            emp_id = emp_obj.search(cr, uid, [('company_id','=',obj.company_id.id),('department_id','=',dep_id)])
            if obj.limit_id.id == False:
                working_hours = 0.0
                worked_hours = 0.0
                for line in emp_obj.browse(cr, uid, emp_id):
                    
                    line_hours = empl_info_obj.search(cr, uid, [('employee_id','=',line.id)])
                    if line_hours !=[]:
                        for hours in empl_info_obj.browse(cr, uid, line_hours):
                            working_hours = hours.working_hours
                            worked_hours = hours.regular_hours
                            
                    limit_line_obj.create(cr, uid, {
                                                     'hr_employee_id':line.id,
                                                     'call_limit_id':obj.id,
                                                     'employee_info_id':line.id,
                                                     'working_hours':working_hours,
                                                     'worked_hours':worked_hours,
                                                     'employee_code':line.employee_code,
                                                     'department_name':line.department_id.id,
                                                     'department_code':line.department_id.code,
                                                     'name':line.last_name,
                                                     'position_name':line.job_id.id,
                                                     'register_number':line.register_number,
                                                     'work_phone':line.mobile_phone,
                                                     'call_limit':line.mobil_limit,
                                                     
                                                     })
            else:
                raise osv.except_osv(_('Error!'),_("Selected employees."))
            return True
        
    def action_call_compute(self, cr, uid, ids, *args):
        limit_obj = self.pool.get('limit.line')
        obj = self.browse(cr, uid, ids)
        day_calculate = 0
        receivable_calculate = 0
        expense_calculate = 0
        payment_calculate = 0
        vat_calculate = 0
        for line in obj.limit_id:
            if line.working_hours > 0.0 and line.worked_hours>0.0:
                day_calculate = line.call_limit/line.working_hours*line.worked_hours
                payment_calculate = line.vat/0.11*0.1
                vat_calculate = line.vat/0.11*0.01
                #print 'jjjjjjjjjjjjjjj', line.worked_days
                if line.call_payment <= line.worked_days:
                    receivable_calculate = 0
                else:
                    receivable_calculate = line.call_payment-line.worked_days
                expense_calculate = line.call_payment-receivable_calculate    
                limit_obj.write(cr, uid, line.id, {
                                                'worked_days':day_calculate,
                                                'call_payment':payment_calculate,
                                                'vat_amount':vat_calculate,
                                                'receivable_call':receivable_calculate,
                                                'expense_call':expense_calculate,
                                                })
                
            
        return True     
        
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('limit.line')
        for line in obj.limit_id:
            line_obj.unlink(cr, uid, line.id)
        return super(call_limit, self).unlink(cr, uid, ids, context=context)
    
class limit_line(osv.osv):
    _name = 'limit.line'
    _columns = {
               'name':fields.char('Last name'),
               'department_code':fields.char('Department code'),
               'department_name':fields.many2one('hr.department','Department'),
               'position_name':fields.many2one('hr.job','Position'),
               'register_number':fields.char('Register number'),
               'work_phone':fields.char('Work phone'),
               'working_hours':fields.float('Working hours'),
               'worked_hours':fields.float('Worked hours'),
               'call_limit':fields.float('Call limit'),
               'worked_days':fields.float('Worked days'),
               'vat':fields.float('VAT'),
               'call_payment':fields.float('Call payment'),
               'vat_amount':fields.float('VAT amount'),
               'receivable_call':fields.float('Receivable call'),
               'expense_call':fields.float('Expense call'),
               'employee_code':fields.char('Employee code'),
               'call_limit_id':fields.many2one('call.limit','Call limit'),
               'company_id':fields.many2one('res.company','Company'),
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               }
    
    def onchange_limit(self, cr, uid, ids, empl_id, context=None):
        res = {}
        if ids:
            obj = self.browse(cr, uid, ids)[0]
            if empl_id:
                empl_obj = self.pool.get('hr.employee')
                empl = empl_obj.browse(cr, uid, empl_id)[0]
                res['name']=empl.last_name
                res['register_number']=empl.register_number
                res['work_phone']=empl.mobile_phone
                res['call_limit']=empl.mobil_limit
                res['employee_code']=empl.employee_code
                res['department_name']=empl.department_id.id
                res['department_code']=empl.department_id.code
                res['position_name']=empl.job_id.id
                return {'value':res} 
            
class account_settings(osv.osv):
    _name = 'account.settings'
    _columns = {
                'company_id':fields.many2one('res.company','Company'),
               'journal_id':fields.many2one('account.journal','Journal'),
               'receivable_account':fields.many2one('account.account','Receivable account'),
               'call_limit_id':fields.many2one('call.limit','Call limit'),
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               }        
    
    _defaults = {
                 'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'account.settings', context=c),
                 }
    
class salary_deduction(osv.osv):
    _name = 'salary.deduction'
    
    _columns = {
                'department_id':fields.many2one('hr.department','Department'),
                'name':fields.date('Start date'),
                'end_date':fields.date('End date'),
                'company_id':fields.many2one('res.company','Company'),
                'deduction_id':fields.one2many('deduction.line','salary_deduction_id','Deduction line'),
                'state':fields.selection([('draft','Draft'),
                                          ('confirm','Confirm')],'State'),
                
                }
    _defaults = {
                 'state': 'draft',
                 }
    
    def action_deduction_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True

    def action_deduction_confirm(self, cr, uid, ids, context=None):
        #obj = self.browse(cr, uid, ids)[0]
        #deduction_line_obj = self.pool.get('deduction.line')
        #deduction_amount = 0.0
        #for line in obj.deduction_id:
            #if line.total_deduction >0.0 and line.recievable76 >0.0:
                #deduction_amount = line.total_deduction-line.recievable76
                #deduction_line_obj.write(cr, uid, line.id, {
                                                #'total_deduction':deduction_amount,
                                               
                                                #})
        self.write(cr, uid, ids, {'state': 'confirm'})
        return True    
    
    def action_deduction(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        emp_obj = self.pool.get('hr.employee')
        deduction_line_obj = self.pool.get('deduction.line')
        pen_obj = self.pool.get('hr.penalty')
        par_obj = self.pool.get('res.partner')
        dep_obj = self.pool.get('hr.department')
        dep_id = dep_obj.search(cr, uid, [('company_id','=',obj.company_id.id)],order='sequence asc')
        if dep_id:
            emp_id = emp_obj.search(cr, uid, [('company_id','=',obj.company_id.id),('department_id','=',dep_id)])
            if obj.deduction_id.id == False:
                property = 0.0
                for line in emp_obj.browse(cr, uid, emp_id):
                    penalty_amount = 0.0
                    penal_id = pen_obj.search(cr, uid, [('hr_employee_id','=',line.id),('date','>=',obj.name),('date','<=',obj.end_date)])
                    #print "loggg",penal_id
                    if penal_id !=[]:
                        penalty = pen_obj.browse(cr, uid, penal_id)
                        penalty_amount = penalty.amount
                       
                        
                    deduction_line_obj.create(cr, uid, {
                                                     'hr_employee_id':line.id,
                                                     'salary_deduction_id':obj.id,
                                                     'employee_code':line.employee_code,
                                                     'department_name':line.department_id.id,
                                                     'department_code':line.department_id.code,
                                                     'penalty_amount':penalty_amount,
                                                     'name':line.last_name,
                                                     'position_name':line.job_id.id,
                                                     'total_deduction':line.user_id.partner_id.credit,
                                                     })
            else:
                raise osv.except_osv(_('Error!'),_("Selected employees."))
            return True 
        
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('deduction.line')
        for line in obj.deduction_id:
            line_obj.unlink(cr, uid, line.id)
        return super(salary_deduction, self).unlink(cr, uid, ids, context=context)
    
class deduction_line(osv.osv):
    _name = 'deduction.line'
    _columns = {
               'name':fields.char('Last name'),
               'department_code':fields.char('Department code'),
               'department_name':fields.many2one('hr.department','Department'),
               'position_name':fields.many2one('hr.job','Position'),
               'employee_code':fields.char('Employee code'),
               'other_deduction':fields.float('Other deduction'),
               'total_deduction':fields.float('Total deduction'),
               'recievable76':fields.float('Recievable 76'),
               'penalty_amount':fields.float('Penalty amount'),
               'salary_deduction_id':fields.many2one('salary.deduction','Salary deduction'),
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               }
    
    def onchange_deduction(self, cr, uid, ids, empl_id, context=None):
        res = {}
        if ids:
            obj = self.browse(cr, uid, ids)[0]
            if empl_id:
                empl_obj = self.pool.get('hr.employee')
                empl = empl_obj.browse(cr, uid, empl_id)[0]
                res['name']=empl.last_name
                res['employee_code']=empl.employee_code
                res['department_name']=empl.department_id.id
                res['department_code']=empl.department_id.code
                res['position_name']=empl.job_id.id
                return {'value':res}  
            
class sick_benefit(osv.osv):
    _name = 'sick.benefit'
    
    def _day_compute(self, cr, uid, ids, name, args,context=None):
        res = {}
        amount = 0.0
        for record in self.browse(cr, uid, ids, context=context):
            res[record.id] = 'none'
            sum_amount = 0.0
            sum_day = 0.0
            for line in record.sick_line_id:
                    sum_day += line.day
                    sum_amount += line.amount
            if sum_amount >0.0 and sum_day >0.0:
                amount = sum_amount/sum_day
            res[record.id] = amount
        
        
        return res
    
    _columns = {
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               'register_number':fields.char('Register number'),
               'ndd':fields.char('Ndd'),
               'date':fields.date('Date'),
               'number':fields.char('Number'),
               'start_date':fields.date('Start date'),
               'end_date':fields.date('End date'),
               'seniority':fields.integer('Seniority'),
               'day_work':fields.function(_day_compute,string='Day work',type='float'),
               'percent':fields.float('Percent'),
               'day_wages':fields.float('Day wages'),
               'total':fields.float('Total'),
               'employer':fields.float('Employer'),
               'social_insurance':fields.float('Social insurance'),
               'giving_total':fields.float('Giving total'),
               'employer_pay':fields.float('Employer pay'),
               'wages_code':fields.many2one('hr.salary.rule.category','Wages code'),
               'day_code':fields.many2one('hr.salary.rule.category','Day code'),
               'social_insurance_pay':fields.float('Social insurance pay'),
               'sick_line_id': fields.one2many('sick.line','sick_benefit_id','Sick line'),
               'state': fields.selection([
                    ('draft', 'Draft'),
                    ('cancel', 'Cancel'),
                    ('approve', 'Approve'),
                    ], 'State'),
               }
    _defaults = {
                 'state': 'draft',
                 }
    def action_benefit_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True

    def action_benefit_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'cancel'})
        return True
    
    def action_benefit_approve(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'approve'})
              
    def onchange_sick_benefit(self, cr, uid, ids, empl_id, context=None):
        res = {}
        if empl_id:
            empl_obj = self.pool.get('hr.employee')
            empl = empl_obj.browse(cr, uid, empl_id)[0]
            res['ndd']=empl.ndd
            res['register_number']=empl.register_number
            res['seniority']=empl.seniority
            return {'value':res} 
        
    #def onchange_day_work(self, cr, uid, ids, sum_month, sum_day,  context=None):
       #if sum_month > 0 and sum_day > 0:
           #sum = sum_month/sum_day
           #return {'value': {'day_work': sum,}}
       
    def onchange_day_wages(self, cr, uid, ids, day_work, percent,  context=None):
       if day_work > 0 and percent > 0:
           sum = day_work*percent/100
           return {'value': {'day_wages': sum,}}
       
    def onchange_total(self, cr, uid, ids, day_wages, employer, social_insurance,  context=None):
       if employer > 0 and social_insurance > 0 and social_insurance > 0:
           sum = employer+social_insurance
           sum_insurance = day_wages*social_insurance
           return {'value': {
                             'total': sum,
                             'social_insurance_pay': sum_insurance,
                             }}   
                              
    def onchange_giving_total(self, cr, uid, ids, day_wages, employer, context=None):
       if day_wages > 0 and employer > 0:
           sum = day_wages*employer
           return {'value': {'employer_pay': sum,}}
       
    def onchange_giving(self, cr, uid, ids, employer_pay, social_insurance_pay, context=None):
       if employer_pay > 0 and social_insurance_pay > 0:
           sum = employer_pay+social_insurance_pay
           return {'value': {'giving_total': sum,}}
       
    def action_sick_calculate(self, cr, uid, ids, context=None):
         obj = self.browse(cr, uid, ids)[0]
         emp_obj = self.pool.get('hr.employee')
         payslip_obj = self.pool.get('hr.payslip')
         sick_line_obj = self.pool.get('sick.line')
         period_obj = self.pool.get('account.period')
         payslip_line_obj = self.pool.get('hr.payslip.line')
         
         if obj.hr_employee_id:
             sic_line_id = sick_line_obj.search(cr, uid, [('sick_benefit_id','=',obj.id)])
             for line_id in sick_line_obj.browse(cr, uid, sic_line_id):
                 account_period_id = period_obj.search(cr, uid, [('id','=',line_id.period_id.id)])
                 per_id = period_obj.browse(cr, uid, account_period_id)
                 hr_payslip = payslip_obj.search(cr, uid, [('employee_id','=',obj.hr_employee_id.id),('date_from','=',per_id.date_start),('date_to','=',per_id.date_stop)])
                 payslip_id = payslip_obj.browse(cr, uid, hr_payslip)
                 account_period_id = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.wages_code.id)])
                 account_period_id1 = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.day_code.id)])
                 payslip_line_id = payslip_line_obj.browse(cr, uid, account_period_id)
                 payslip_line_id1 = payslip_line_obj.browse(cr, uid, account_period_id1)
                 sick_line_obj.write(cr, uid, line_id.id, {
                                                                'amount':payslip_line_id.total,
                                                                'day':payslip_line_id1.total
                                                                },context=context)
         return True    
       
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('sick.line')
        for line in obj.sick_line_id:
            line_obj.unlink(cr, uid, line.id)
        return super(sick_benefit, self).unlink(cr, uid, ids, context=context)   
       
class sick_line(osv.osv):
    _name = 'sick.line'
    _columns = {
               'period_id': fields.many2one('account.period','Period'),
               'amount':fields.float('Salary'),
               'day':fields.float('Day'),
               'sick_benefit_id':fields.many2one('sick.benefit','Sick benefit'),
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               }        
       
       
class maternity_benefit(osv.osv):
    _name = 'maternity.benefit'
    
    def _day_work_compute(self, cr, uid, ids, name, args,context=None):
        res = {}
        amount = 0.0
        for record in self.browse(cr, uid, ids, context=context):
            res[record.id] = 'none'
            sum_amount = 0.0
            #sum_day = 0.0
            for line in record.maternity_line_id:
                    #sum_day += line.day
                    sum_amount += line.amount
            if sum_amount >0.0: #and sum_day >0.0:
                amount = sum_amount/12
            res[record.id] = amount
        
        
        return res
    
    
    _columns = {
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               'register_number':fields.char('Register number'),
               'ndd':fields.char('Ndd'),
               'date':fields.date('Date'),
               'number':fields.char('Number'),
               'start_date':fields.date('Start date'),
               'end_date':fields.date('End date'),
               'seniority':fields.integer('Seniority'),
               'sum_day':fields.float('Sum day'),
               'monthly_average':fields.function(_day_work_compute,string='Monthly average salary',type='float'),
               'day_work':fields.float('Day work'),
               'percent':fields.float('Percent'),
               'day_wages':fields.float('Day wages'),
               'social_insurance':fields.float('Social insurance'),
               'social_insurance_pay':fields.float('Social insurance pay'),
               'wages_code':fields.many2one('hr.salary.rule.category','Wages code'),
               #'day_code':fields.many2one('hr.salary.rule.category','Day code'),
               'monthly_day':fields.float('Monthly day'),
               'rule_id':fields.many2one('hr.salary.rule','Salary rule'),
               'maternity_line_id': fields.one2many('maternity.line','maternity_benefit_id','Maternity line'),
               'state': fields.selection([
                    ('draft', 'Draft'),
                    ('cancel', 'Cancel'),
                    ('approve', 'Approve'),
                    ], 'State'),
               }
    _defaults = {
                 'state': 'draft',
                 }
    def action_maternity_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True

    def action_maternity_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'cancel'})
        return True
    
    def action_maternity_approve(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'approve'})
              
    def onchange_maternity_benefit(self, cr, uid, ids, empl_id, context=None):
        res = {}
        if empl_id:
            empl_obj = self.pool.get('hr.employee')
            empl = empl_obj.browse(cr, uid, empl_id)[0]
            res['ndd']=empl.ndd
            res['register_number']=empl.register_number
            res['seniority']=empl.seniority
            return {'value':res}
        
    def onchange_monthly_day(self, cr, uid, ids, monthly_average, monthly_day,  context=None):
       if monthly_average > 0 and monthly_day > 0:
           sum = monthly_average/monthly_day
           return {'value': {'day_work': sum,}}    
        
    def onchange_wages(self, cr, uid, ids, day_work, percent,  context=None):
       if day_work > 0 and percent > 0:
           sum = day_work*percent/100
           return {'value': {'day_wages': sum,}}
       
    def onchange_insurance(self, cr, uid, ids, day_wages, social_insurance,  context=None):
       if day_wages > 0 and social_insurance > 0:
           sum = day_wages*social_insurance
           return {'value': {'social_insurance_pay': sum,}}
       
    def action_calculate(self, cr, uid, ids, context=None):
         obj = self.browse(cr, uid, ids)[0]
         emp_obj = self.pool.get('hr.employee')
         payslip_obj = self.pool.get('hr.payslip')
         maternity_line_obj = self.pool.get('maternity.line')
         period_obj = self.pool.get('account.period')
         payslip_line_obj = self.pool.get('hr.payslip.line')
         
         if obj.hr_employee_id:
             mat_line_id = maternity_line_obj.search(cr, uid, [('maternity_benefit_id','=',obj.id)])
             for line_id in maternity_line_obj.browse(cr, uid, mat_line_id):
                 account_period_id = period_obj.search(cr, uid, [('id','=',line_id.period_id.id)])
                 per_id = period_obj.browse(cr, uid, account_period_id)
                 hr_payslip = payslip_obj.search(cr, uid, [('employee_id','=',obj.hr_employee_id.id),('date_from','=',per_id.date_start),('date_to','=',per_id.date_stop)])
                 payslip_id = payslip_obj.browse(cr, uid, hr_payslip)
                 account_period_id = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.wages_code.id)])
                 #account_period_id1 = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.day_code.id)])
                 payslip_line_id = payslip_line_obj.browse(cr, uid, account_period_id)
                 #payslip_line_id1 = payslip_line_obj.browse(cr, uid, account_period_id1)
                 maternity_line_obj.write(cr, uid, line_id.id, {
                                                                'amount':payslip_line_id.total,
                                                                #'day':payslip_line_id1.total
                                                                },context=context)
         return True    
       
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('maternity.line')
        for line in obj.maternity_line_id:
            line_obj.unlink(cr, uid, line.id)
        return super(maternity_benefit, self).unlink(cr, uid, ids, context=context)               
        #mat_id = period_obj.search(cr, uid, [('date_start','=',payslip.date_from),('date_stop','=',payslip.date_to)])
        
class maternity_line(osv.osv):
    _name = 'maternity.line'
    _columns = {
               'period_id': fields.many2one('account.period','Period'),
               'amount':fields.float('Salary'),
               #'day':fields.float('Day'),
               'maternity_benefit_id':fields.many2one('maternity.benefit','Maternity benefit'),
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               }
    
class annual_leave(osv.osv):
    _name = 'annual.leave'
    
    def _salary_compute(self, cr, uid, ids, name, args,context=None):
        res = {}
        amount = 0.0
        for record in self.browse(cr, uid, ids, context=context):
            res[record.id] = 'none'
            sum_salary = 0.0
            sum_hours = 0.0
            for line in record.annual_line_id:
                    sum_hours += line.total_hours
                    sum_salary += line.calculate_salary
            if sum_salary >0.0 and sum_hours >0.0:
                amount = sum_salary/sum_hours
            res[record.id] = amount
        
        return res
    
    _columns = {
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               'decree_date':fields.date('Decree date'),
               'decree_number':fields.char('Decree number'),
               'date':fields.date('Date'),
               'annual_leave_day':fields.integer('Annual leave day'),
               'day_wages':fields.function(_salary_compute,string='Day wages',type='float'),
               'annual_pay':fields.float('Annual pay'),
               'duration':fields.char('Duration'),
               'working_hours':fields.many2one('hr.salary.rule.category','Working hours'),
               'overtime':fields.many2one('hr.salary.rule.category','Оvertime'),
               'holiday_hours':fields.many2one('hr.salary.rule.category','Holiday hours'),
               'total_salary':fields.many2one('hr.salary.rule.category','Total salary'),
               'meal_pay':fields.many2one('hr.salary.rule.category','Meal pay'),
               'bonus':fields.many2one('hr.salary.rule.category','Bonus'),
               'rule_id':fields.many2one('hr.salary.rule','Salary rule'),
               'annual_line_id': fields.one2many('annual.line','annual_leave_id','Annual line'),
               'state': fields.selection([
                    ('draft', 'Draft'),
                    ('cancel', 'Cancel'),
                    ('approve', 'Approve'),
                    ], 'State'),
               }
    _defaults = {
                 'state': 'draft',
                 }
    def action_annual_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True

    def action_annual_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'cancel'})
        return True
    
    def action_annual_approve(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'approve'})
        
    def onchange_annual(self, cr, uid, ids, day_wages, annual_leave_day,  context=None):
       if day_wages > 0 and annual_leave_day > 0:
           sum = day_wages*annual_leave_day
           return {'value': {'annual_pay': sum,}}    
              
    #def onchange_annual_leave(self, cr, uid, ids, empl_id, context=None):
        #res = {}
        #if empl_id:
            #empl_obj = self.pool.get('hr.employee')
            #empl = empl_obj.browse(cr, uid, empl_id)[0]
            #res['ndd']=empl.ndd
            #res['register_number']=empl.register_number
            #res['seniority']=empl.seniority
            #return {'value':res} 
            
    def action_calculate_annual(self, cr, uid, ids, context=None):
         obj = self.browse(cr, uid, ids)[0]
         emp_obj = self.pool.get('hr.employee')
         payslip_obj = self.pool.get('hr.payslip')
         annual_line_obj = self.pool.get('annual.line')
         period_obj = self.pool.get('account.period')
         payslip_line_obj = self.pool.get('hr.payslip.line')
         
         if obj.hr_employee_id:
             ann_line_id = annual_line_obj.search(cr, uid, [('annual_leave_id','=',obj.id)])
             for line_id in annual_line_obj.browse(cr, uid, ann_line_id):
                 account_period_id = period_obj.search(cr, uid, [('id','=',line_id.period_id.id)])
                 per_id = period_obj.browse(cr, uid, account_period_id)
                 hr_payslip = payslip_obj.search(cr, uid, [('employee_id','=',obj.hr_employee_id.id),('date_from','=',per_id.date_start),('date_to','=',per_id.date_stop)])
                 payslip_id = payslip_obj.browse(cr, uid, hr_payslip)
                 account_period_id = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.working_hours.id)])
                 account_period_id1 = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.overtime.id)])
                 account_period_id2 = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.holiday_hours.id)])
                 account_period_id3 = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.total_salary.id)])
                 account_period_id4 = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.meal_pay.id)])
                 account_period_id5 = payslip_line_obj.search(cr, uid, [('slip_id','=',payslip_id.id),('category_id','=',obj.bonus.id)])
                 
                 payslip_line_id = payslip_line_obj.browse(cr, uid, account_period_id)
                 payslip_line_id1 = payslip_line_obj.browse(cr, uid, account_period_id1)
                 payslip_line_id2 = payslip_line_obj.browse(cr, uid, account_period_id2)
                 payslip_line_id3 = payslip_line_obj.browse(cr, uid, account_period_id3)
                 payslip_line_id4 = payslip_line_obj.browse(cr, uid, account_period_id4)
                 payslip_line_id5 = payslip_line_obj.browse(cr, uid, account_period_id5)
                 annual_line_obj.write(cr, uid, line_id.id, {
                                                                'working_hours':payslip_line_id.total,
                                                                'overtime':payslip_line_id1.total,
                                                                'holiday_hours':payslip_line_id2.total,
                                                                'total_hours':payslip_line_id.total+payslip_line_id1.total+payslip_line_id2.total,
                                                                'total_salary':payslip_line_id3.total,
                                                                'meal_pay':payslip_line_id4.total,
                                                                'bonus':payslip_line_id5.total,
                                                                'calculate_salary':payslip_line_id3.total-payslip_line_id4.total-payslip_line_id5.total
                                                                },context=context)
         return True        
            
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('annual.line')
        for line in obj.annual_line_id:
            line_obj.unlink(cr, uid, line.id)
        return super(annual_leave, self).unlink(cr, uid, ids, context=context)            
       
class annual_line(osv.osv):
    _name = 'annual.line'
    _columns = {
               'period_id': fields.many2one('account.period','Period'),
               'working_hours':fields.float('Working hours'),
               'overtime':fields.float('Оvertime'),
               'holiday_hours':fields.float('Holiday hours'),
               'total_hours':fields.float('Total hours'),
               'total_salary':fields.float('Total salary'),
               'meal_pay':fields.float('Meal pay'),
               'bonus':fields.float('Bonus'),
               'calculate_salary':fields.float('Calculate salary'),
               'annual_leave_id':fields.many2one('annual.leave','Annual leave'),
               'hr_employee_id':fields.many2one('hr.employee','Employee'),
               }       
       
       
       
       
          
    
    