# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class advance_bank_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "advance.bank.report"
    _description = "Advance bank report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'advance_id':fields.many2one('hr.advance.salary','Employee'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        advance = self.pool.get('hr.advance.salary.line')
        advan = advance.search(cr, uid, [('advance_id','=',data['advance_id'][0])])
        advance_salary = self.pool.get('hr.advance.salary')
        adv = advance_salary.search(cr, uid, [('id','=',data['advance_id'][0])])
        ad = advance_salary.browse(cr, uid, adv)
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Advance bank')
        sheet.write(1, 1, u'Байгууллагын нэр:', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(1, 2, u'%s' %ad.company_id.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(3, 4, u'%s' %ad.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(2, 8, u'Огноо:', ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(2, 9, time.strftime('%Y-%m-%d'))
        sheet.write_merge(4, 6, 0, 0, u'№', style_table_header)
        sheet.write(4, 1, u'Дебит', style_table_header)
        sheet.write(4, 4, u'Кредит', style_table_header)
        sheet.write_merge(4, 6, 5, 5, u'Ажилтны нэр', style_table_header)
        sheet.write_merge(4, 6, 7, 7, u'Дүн', style_table_header)
        sheet.write_merge(5, 6, 1, 1, u'Дотоод дансны дугаар', style_table_header)
        sheet.write_merge(4, 6, 2, 2, u'Нэр', style_table_header)
        sheet.write_merge(4, 6, 3, 3, u'Валют', style_table_header)
        sheet.write_merge(5, 6, 4, 4, u'Картын дугаар', style_table_header)
        sheet.write_merge(4, 6, 6, 6, u'Влт', style_table_header)
        sheet.write_merge(4, 6, 8, 9, u'Гүйлгээний утга', style_table_header)
        rowx = 7
        i=1
        for line in advance.browse(cr, uid, advan):
            sheet.write(rowx, 0, u'%s' %i, style_table)
            i=i+1
            sheet.write(rowx, 1, u'%s' %'', style_table)
            sheet.write(rowx, 2, u'%s' %'', style_table)
            sheet.write(rowx, 3, u'%s' %'mnt', style_table)
            sheet.write(rowx, 4, u'%s' %line.card_number, style_table)
            sheet.write(rowx, 5, u'%s' %line.employee_id.name, style_table)
            sheet.write(rowx, 6, u'%s' %'mnt', style_table)
            sheet.write(rowx, 7, u'%s' %line.total_advance_salary, style_table)
            sheet.write_merge(rowx, rowx, 8, 9, u'%s' %'', style_table)
            rowx = rowx + 1    
        
        inch = 1000
        inch1 = 900
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 5*inch1
        sheet.col(2).width = 3*inch
        sheet.col(3).width = 2*inch
        sheet.col(4).width = 4*inch
        sheet.col(5).width = 6*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 4*inch
        sheet.col(8).width = 2*inch1
        sheet.col(9).width = 4*inch
        
        sheet.write(rowx, 5, u'Гүйцэтгэх захирал:', ezxf('font: bold off;align:wrap off,vert centre;'))
        #k=k+1
        #sheet.write(rowx, 5, u'Нягтлан бодогч:', ezxf('font: bold off;align:wrap off,vert centre;'))
        
        return {'data':book}

advance_bank_report()