# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class millionaire_general(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "millionaire.general"
    _description = "Millionaire general"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'fund_id':fields.many2one('millionaire.fund.saving','Millionaire fund saving'),
        'millionaire_id':fields.many2one('millionaire.line','Millionaire line'),
        
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        obj = self.browse(cr, uid, ids)[0]
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Millionaire general')
        sheet.write(0, 3, u'Саятан сангийн тайлан', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(1, 1, u'%s' %obj.company_id.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(1, 5, u'Тайлант үе:', ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(1, 6, time.strftime('%Y-%m-%d'))
        sheet.write_merge(2, 4, 0, 0, u'д/д', style_table_header1)
        sheet.write_merge(2, 4, 1, 1, u'Регистрийн дугаар', style_table_header1)
        sheet.write_merge(2, 4, 2, 2, u'Овог', style_table_header1)
        sheet.write_merge(2, 4, 3, 3, u'Нэр', style_table_header1)
        sheet.write_merge(2, 4, 4, 4, u'Саятан дансны дугаар', style_table_header1)
        sheet.write_merge(2, 4, 5, 5, u'Гүйлгээний утга', style_table_header1)
        sheet.write_merge(2, 4, 6, 6, u'Саятан сангийн дүн', style_table_header1)
        rowx = 5
        
        mill_fund = self.pool.get('millionaire.fund.saving')
        mill = mill_fund.browse(cr, uid, mill_fund.search(cr, uid, [('id','=',data['fund_id'][0])]))
        
        cr.execute("""select hr_department.id, hr_department.code, hr_department.name,hr_employee.name_related,hr_employee.register_number,hr_employee.last_name,millionaire_line.millionaire_amount,millionaire_line.purpose  
                    from 
                      public.millionaire_fund_saving, 
                      public.millionaire_line,  
                      public.hr_employee, 
                      public.hr_department
                    
                    where 
                      millionaire_line.hr_employee_id = hr_employee.id AND
                      millionaire_fund_saving.id = millionaire_line.fund_id AND
                      hr_department.id = hr_employee.department_id
                      and  millionaire_fund_saving.id = %s
                    order by hr_department.id,hr_employee.name_related"""%(data['fund_id'][0]))
        millionaire_obj  = cr.dictfetchall()
        
        
        if millionaire_obj:
            i=1
            c=0
            g = 0
            related =''
            sum_BASIC = 0
            sum = 0
            for line in millionaire_obj:
                
                if line['id'] == c:
                    if line['name_related'] == related:
                        g = 0
                    else:
                        sheet.write(rowx, 0, u'%s' %i, style_table)
                        sheet.write(rowx, 1, u'%s' %line['register_number'], style_table)
                        sheet.write(rowx, 2, u'%s' %line['last_name'], style_table)
                        sheet.write(rowx, 3, u'%s' %line['name_related'], style_table)
                        sheet.write(rowx, 4, u'', style_table)
                        sheet.write(rowx, 5, u'%s' %line['purpose'], style_table)
                        sheet.write(rowx, 6, u'%s' %line['millionaire_amount'], style_table)
                        sum_BASIC += line['millionaire_amount']
                        sum += line['millionaire_amount']
                        rowx +=1
                        i=i+1
                        related = line['name_related']
                else: 
                    if c != 0:
                        sheet.write_merge(rowx, rowx, 0, 5, u'Хэлтсийн дүн', ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 6, sum_BASIC, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        rowx +=1
                    sheet.write_merge(rowx, rowx, 0, 1, u'%s' %line['code'], ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                    sheet.write_merge(rowx, rowx, 2, 4, u'%s' %line['name'], ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                    rowx +=1
                    sum_BASIC = 0
                    
                    c = line['id']
                    if line['name_related'] == related:
                        g = 0
                    else:
                        sheet.write(rowx, 0, u'%s' %i, style_table)
                        sheet.write(rowx, 1, u'%s' %line['register_number'], style_table)
                        sheet.write(rowx, 2, u'%s' %line['last_name'], style_table)
                        sheet.write(rowx, 3, u'%s' %line['name_related'], style_table)
                        sheet.write(rowx, 4, u'', style_table)
                        sheet.write(rowx, 5, u'%s' %line['purpose'], style_table)
                        sheet.write(rowx, 6, u'%s' %line['millionaire_amount'], style_table)
                        sum_BASIC += line['millionaire_amount']
                        sum += line['millionaire_amount']
                        rowx +=1
                        i=i+1
                        related = line['name_related']
        if c != 0:
                sheet.write_merge(rowx, rowx, 0, 5, u'Хэлтсийн дүн', ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 6, sum_BASIC, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                rowx +=1
            
        inch = 1000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 3*inch
        sheet.col(2).width = 5*inch
        sheet.col(3).width = 5*inch
        sheet.col(4).width = 5*inch
        sheet.col(5).width = 5*inch
        sheet.col(6).width = 3*inch
        
        
        sheet.write_merge(rowx, rowx, 0, 5, u'Нийт дүн', style_table_header1)
        sheet.write(rowx, 6, sum, style_table_header1)
        rowx +=1
        
        
        
        return {'data':book}

millionaire_general()