# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class monthly_advance_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "monthly.advance.report"
    _description = "Monthly advance report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'advance_id':fields.many2one('hr.advance.salary','Employee'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        advance = self.pool.get('hr.advance.salary.line')
        advan = advance.search(cr, uid, [('advance_id','=',data['advance_id'][0])])
        advance_salary = self.pool.get('hr.advance.salary')
        adv = advance_salary.search(cr, uid, [('id','=',data['advance_id'][0])])
        ad = advance_salary.browse(cr, uid, adv)
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Monthly advance')
        sheet.write(0, 5, u'Сарын урьдчилгаа цалин дэлгэрэнгүй', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(1, 1, u'%s' %ad.company_id.name, ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(1, 14, u'Тайлант үе:', ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(1, 15, time.strftime('%Y-%m-%d'))
        sheet.write_merge(2, 4, 0, 0, u'№', style_table_header)
        sheet.write_merge(2, 4, 1, 1, u'Хэлтсийн код', style_table_header)
        sheet.write_merge(2, 4, 2, 2, u'Хэлтсийн нэр', style_table_header)
        sheet.write_merge(2, 4, 3, 3, u'Ажилтны код', style_table_header)
        sheet.write_merge(2, 4, 4, 4, u'Ажилтны нэр', style_table_header)
        sheet.write_merge(2, 4, 5, 5, u'Албан тушаал', style_table_header)
        sheet.write_merge(2, 4, 6, 6, u'Үндсэн цалин', style_table_header)
        sheet.write_merge(2, 4, 7, 7, u'Хагас сарын фонд цаг', style_table_header)
        sheet.write_merge(2, 4, 8, 8, u'Ажилласан цаг урьдчилгаа', style_table_header)
        sheet.write_merge(2, 4, 9, 9, u'Урьдчилгаа олгох хувь', style_table_header)
        sheet.write_merge(2, 4, 10, 10, u'Урьдчилгаа цалин', style_table_header)
        sheet.write_merge(2, 4, 11, 11, u'Амралтын мөнгө', style_table_header)
        sheet.write_merge(2, 4, 12, 12, u'Бусад суутгал', style_table_header)
        sheet.write_merge(2, 4, 13, 13, u'Бусад нэмэгдэл', style_table_header)
        sheet.write_merge(2, 4, 14, 14, u'Нийт урьдчилгаа', style_table_header)
        sheet.write_merge(2, 4, 15, 15, u'Картын дугаар', style_table_header)
        rowx = 5
        i=1
        sum_wage = 0
        sum_working_hours = 0
        sum_regular_hours_advance = 0
        sum_first_advance_salary = 0
        sum_annual_leave_pay = 0
        sum_other_deduction = 0
        sum_other_incentive = 0
        sum_total_advance_salary = 0
        for line in advance.browse(cr, uid, advan):
            sheet.write(rowx, 0, u'%s' %i, style_table)
            i=i+1
            sheet.write(rowx, 1, u'%s' %line.department_code, style_table)
            sheet.write(rowx, 2, u'%s' %line.department_name.name, style_table)
            sheet.write(rowx, 3, u'%s' %line.employee_code, style_table)
            sheet.write(rowx, 4, u'%s' %line.employee_id.name, style_table)
            sheet.write(rowx, 5, u'%s' %line.position_name.name, style_table)
            sheet.write(rowx, 6, u'%s' %line.name, style_table)
            sum_wage += line.name
            sheet.write(rowx, 7, u'%s' %line.working_hours, style_table)
            sum_working_hours += line.working_hours
            sheet.write(rowx, 8, u'%s' %line.regular_hours_advance, style_table)
            sum_regular_hours_advance += line.regular_hours_advance
            sheet.write(rowx, 9, u'%s' %line.advance_percent, style_table)
            sheet.write(rowx, 10, u'%s' %line.first_advance_salary, style_table)
            sum_first_advance_salary += line.first_advance_salary
            sheet.write(rowx, 11, u'%s' %line.annual_leave_pay, style_table)
            sum_annual_leave_pay += line.annual_leave_pay
            sheet.write(rowx, 12, u'%s' %line.other_deduction, style_table)
            sum_other_deduction += line.other_deduction
            sheet.write(rowx, 13, u'%s' %line.other_incentive, style_table)
            sum_other_incentive += line.other_incentive
            sheet.write(rowx, 14, u'%s' %line.total_advance_salary, style_table)
            sum_total_advance_salary += line.total_advance_salary
            sheet.write(rowx, 15, u'%s' %line.card_number, style_table)
            rowx = rowx + 1    
        
        inch = 1000
        inch1 = 900
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 3*inch1
        sheet.col(2).width = 6*inch
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 6*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 3*inch
        sheet.col(13).width = 3*inch
        sheet.col(14).width = 3*inch
        sheet.col(15).width = 3*inch
        
        sheet.write_merge(rowx, rowx, 0, 5, u'Нийт дүн', ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 6, sum_wage, ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 7, sum_working_hours, ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 8, sum_regular_hours_advance, ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 9, u'', ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 10, sum_first_advance_salary, ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 11, sum_annual_leave_pay, ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 12, sum_other_deduction, ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 13, sum_other_incentive, ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 14, sum_total_advance_salary, ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        sheet.write(rowx, 15, u'', ezxf('font: bold on;align:wrap off,vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;'))
        
        rowx = rowx + 2
        
        sheet.write_merge(rowx, rowx, 8, 9, u'ГҮЙЦЭТГЭХ ЗАХИРАЛ:', ezxf('font: bold off;align:wrap off,vert centre;'))
        rowx = rowx + 1
        sheet.write_merge(rowx, rowx, 8, 9, u'АХЛАХ НЯ-БО:', ezxf('font: bold off;align:wrap off,vert centre;'))
        rowx = rowx + 1
        sheet.write_merge(rowx, rowx, 8, 9, u'ЦАЛИНГИЙН НЯ-БО:', ezxf('font: bold off;align:wrap off,vert centre;'))
        
        return {'data':book}

monthly_advance_report()