# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class monthly_salary_bank(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "monthly.salary.bank"
    _description = "Monthly salary bank"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'payslip_id':fields.many2one('hr.payslip','Hr payslip'),
        'payslip_run_id': fields.many2one('hr.payslip.run', 'Payslip Batches'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        pay_run = self.pool.get('hr.payslip.run')
        pa_run = pay_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])])
        p_run = pay_run.browse(cr, uid, pa_run)
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Monthly salary')
        #sheet.write(0, 2, u'Сарын сүүлийн цалин:', ezxf('font: bold on;align:wrap off,vert centre;'))
        #sheet.write(1, 2, u'%s' %pap.company_id.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(1, 4, u'%s' %p_run.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        #sheet.write(1, 7, u'Тайлант үе:', ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(0, 8, time.strftime('%Y-%m-%d'))
        sheet.write_merge(2, 4, 0, 0, u'№', style_table_header)
        sheet.write(2, 1, u'Дебит', style_table_header)
        sheet.write(2, 4, u'Кредит', style_table_header)
        sheet.write_merge(2, 4, 5, 5, u'Ажилтны нэр', style_table_header)
        sheet.write_merge(2, 4, 7, 7, u'Дүн', style_table_header)
        sheet.write_merge(3, 4, 1, 1, u'Дотоод дансны дугаар', style_table_header)
        sheet.write_merge(2, 4, 2, 2, u'Нэр', style_table_header)
        sheet.write_merge(2, 4, 3, 3, u'Валют', style_table_header)
        sheet.write_merge(3, 4, 4, 4, u'Картын дугаар', style_table_header)
        sheet.write_merge(2, 4, 6, 6, u'Влт', style_table_header)
        sheet.write_merge(2, 4, 8, 9, u'Гүйлгээний утга', style_table_header)
        rowx = 5
        payslip_line_obj = self.pool.get('hr.payslip.line')
        payslip = self.pool.get('hr.payslip')
        payslip_run=self.pool.get('hr.payslip.run')
        run = payslip_run.browse(cr, uid, payslip_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])]))
        
        pay = payslip.search(cr, uid, [('payslip_run_id','=',data['payslip_run_id'][0])])
        #print'jjjjjjo',pay
        i=1
        for line1 in run.slip_ids:
            sheet.write(rowx, 0, u'%s' %i, style_table)
            i=i+1
            sheet.write(rowx, 1, u'%s' %'', style_table)
            sheet.write(rowx, 2, u'%s' %'', style_table)
            sheet.write(rowx, 3, u'%s' %'mnt', style_table)
            sheet.write(rowx, 4, u'%s' %line1.employee_id.bank_account_id.acc_number, style_table)
            sheet.write(rowx, 5, u'%s' %line1.employee_id.name, style_table)
            sheet.write(rowx, 6, u'%s' %'mnt', style_table)
            sheet.write_merge(rowx, rowx, 8, 9, u'%s' %'', style_table)
            for line2 in line1.line_ids:
                if line2.code == 'BASIC':
                    sheet.write(rowx, 7, u'%s' %line2.total, style_table)                                                                                                                                           
            rowx += 1
            
        inch = 1000
        inch1 = 900
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 5*inch1
        sheet.col(2).width = 3*inch
        sheet.col(3).width = 2*inch
        sheet.col(4).width = 4*inch
        sheet.col(5).width = 6*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 4*inch
        sheet.col(8).width = 2*inch1
        sheet.col(9).width = 4*inch
        rowx += 2
        
        sheet.write(rowx, 5, u'Гүйцэтгэх захирал:', ezxf('font: bold off;align:wrap off,vert centre;'))
        #sheet.write(rowx, 5, u'Нягтлан бодогч:', ezxf('font: bold off;align:wrap off,vert centre;'))
        
        return {'data':book}

monthly_salary_bank()