# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class monthly_salary_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "monthly.salary.report"
    _description = "Monthly salary report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'payslip_id':fields.many2one('hr.payslip','Hr payslip'),
        'payslip_run_id': fields.many2one('hr.payslip.run', 'Payslip Batches'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
      

        pay_slip = self.pool.get('hr.payslip.run')
        pa = pay_slip.search(cr, uid, [('id','=',data['payslip_run_id'][0])])
        pap = pay_slip.browse(cr, uid, pa)
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Monthly salary')
        sheet.write(0, 4, u'Сарын сүүлийн цалин', ezxf('font: bold on;align:wrap off,vert centre;'))
        #sheet.write(1, 2, u'%s' %pap.company_id.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(2, 4, u'%s' %pap.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(1, 9, u'Тайлант үе:', ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(1, 10, time.strftime('%Y-%m-%d'))
        sheet.write_merge(4, 6, 0, 0, u'№', style_table_header)
        sheet.write_merge(4, 6, 1, 1, u'Код', style_table_header)
        sheet.write_merge(4, 6, 2, 2, u'Нэр', style_table_header)
        sheet.write_merge(4, 6, 3, 3, u'Үндсэн цалин', style_table_header)
        sheet.write_merge(4, 6, 4, 4, u'Сар фонд цаг', style_table_header)
        sheet.write_merge(4, 6, 5, 5, u'Ажилласан цаг', style_table_header)
        sheet.write_merge(4, 6, 6, 6, u'Авсан үр дүн', style_table_header)
        sheet.write_merge(4, 6, 7, 7, u'Бодогдсон цалин', style_table_header)
        sheet.write_merge(4, 6, 8, 8, u'Илүү цаг', style_table_header)
        sheet.write_merge(4, 6, 9, 9, u'Илүү цагийн нэмэгдэл', style_table_header)
        sheet.write_merge(4, 6, 10, 10, u'Баярын цаг', style_table_header)
        sheet.write_merge(4, 6, 11, 11, u'Баярын цагийн нэмэгдэл', style_table_header)
        sheet.write_merge(4, 6, 12, 12, u'Мэргэшсэн ня-бо нэмэгдэл', style_table_header)
        sheet.write_merge(4, 6, 13, 13, u'Актны мөнгө', style_table_header)
        sheet.write_merge(4, 6, 14, 14, u'Амралтын мөнгө', style_table_header)
        sheet.write_merge(4, 6, 15, 15, u'Жирэмсний мөнгө', style_table_header)
        sheet.write_merge(4, 6, 16, 16, u'Урамшуулалт цалин', style_table_header)
        sheet.write_merge(4, 6, 17, 17, u'Хоолны нэмэгдэл', style_table_header)
        sheet.write_merge(4, 6, 18, 18, u'Бусад нэмэгдэл', style_table_header)
        sheet.write_merge(4, 6, 19, 19, u'Талбайн нэмэгдэл', style_table_header)
        sheet.write_merge(4, 6, 20, 20, u'Гэрээний дүн', style_table_header)
        sheet.write_merge(4, 6, 21, 21, u'Оруулсан мөнгө', style_table_header)
        sheet.write_merge(4, 6, 22, 22, u'Гэрээний хувь', style_table_header)
        sheet.write_merge(4, 6, 23, 23, u'Орлогын хувь', style_table_header)
        sheet.write_merge(4, 6, 24, 24, u'Гэрээний урамшуулал', style_table_header)
        sheet.write_merge(4, 6, 25, 25, u'Орлогын урамшуулал', style_table_header)
        sheet.write_merge(4, 6, 26, 26, u'Хийснээр цалин', style_table_header)
        sheet.write_merge(4, 6, 27, 27, u'Нийт нэмэгдэл', style_table_header)
        sheet.write_merge(4, 6, 28, 28, u'Олговол зохих', style_table_header)
        sheet.write_merge(4, 6, 29, 29, u'НДШ', style_table_header)
        sheet.write_merge(4, 6, 30, 30, u'ХХОАТ', style_table_header)
        sheet.write_merge(4, 6, 31, 31, u'Урьдчилгаа', style_table_header)
        sheet.write_merge(4, 6, 32, 32, u'Хоцролтын минут', style_table_header)
        sheet.write_merge(4, 6, 33, 33, u'Хоцролтын дүн', style_table_header)
        sheet.write_merge(4, 6, 34, 34, u'Бусад суутгал', style_table_header)
        sheet.write_merge(4, 6, 35, 35, u'Авлага 76', style_table_header)
        sheet.write_merge(4, 6, 36, 36, u'Суутгалын дүн', style_table_header)
        sheet.write_merge(4, 6, 37, 37, u'Гарт олгох', style_table_header)
        sheet.write_merge(4, 6, 38, 38, u'Өр', style_table_header)
        sheet.write_merge(4, 6, 39, 39, u'Хох сан', style_table_header)
        sheet.write_merge(4, 6, 40, 40, u'Гарын үсэг', style_table_header)
        rowx = 7
        payslip_line_obj = self.pool.get('hr.payslip.line')
        payslip = self.pool.get('hr.payslip')
        payslip_run=self.pool.get('hr.payslip.run')
        run = payslip_run.browse(cr, uid, payslip_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])]))
        
        pay = payslip.search(cr, uid, [('payslip_run_id','=',data['payslip_run_id'][0])])
        
        #print'jjjjjjo',pay
        cr.execute("""select hr_department.id, hr_department.code as kkk, hr_department.name,hr_payslip_line.code, hr_employee.name_related,hr_employee.employee_code, hr_payslip_line.total
                    from 
                      public.hr_payslip, 
                      public.hr_payslip_line,
                      public.hr_payslip_run,  
                      public.hr_employee, 
                      public.hr_department
                    
                    where 
                      hr_payslip.employee_id = hr_employee.id AND
                      hr_payslip.id = hr_payslip_line.slip_id AND
                      hr_payslip_run.id = hr_payslip.payslip_run_id AND
                      hr_department.id = hr_employee.department_id
                      and  hr_payslip_run.id = %s
                    order by hr_department.id,hr_employee.name_related"""%(data['payslip_run_id'][0]))
        payslip_obj  = cr.dictfetchall()
        
        if payslip_obj:
            i=1
            c=0
            rowy = 0
            g = 0
            related =''
            sum_BPD = 0
            sum_WH = 0
            sum_RH = 0
            sum_RP = 0
            sum_CS = 0
            sum_OT = 0
            sum_OTI = 0
            sum_PT = 0
            sum_PTI = 0
            sum_CPA = 0
            sum_SP = 0
            sum_ALP = 0
            sum_MP = 0
            sum_BONUS = 0
            sum_MV = 0
            sum_OI = 0
            sum_SQI = 0
            sum_CA = 0
            sum_IA = 0
            sum_CP = 0
            sum_IP = 0
            sum_CI = 0
            sum_II = 0
            sum_SD = 0
            sum_TI = 0
            sum_TS = 0
            sum_SEMP = 0
            sum_PIT = 0
            sum_AS = 0
            sum_LMIN = 0
            sum_LA = 0
            sum_OD = 0
            sum_REC76 = 0
            sum_TD = 0
            sum_OH = 0
            sum_DEBT = 0
            sum_SFUND = 0
            sum_total_BPD = 0
            sum_total_WH = 0
            sum_total_RH = 0
            sum_total_RP = 0
            sum_total_CS = 0
            sum_total_OT = 0
            sum_total_OTI = 0
            sum_total_PT = 0
            sum_total_PTI = 0
            sum_total_CPA = 0
            sum_total_SP = 0
            sum_total_ALP = 0
            sum_total_MP = 0
            sum_total_BONUS = 0
            sum_total_MV = 0
            sum_total_OI = 0
            sum_total_SQI = 0
            sum_total_CA = 0
            sum_total_IA = 0
            sum_total_CP = 0
            sum_total_IP = 0
            sum_total_CI = 0
            sum_total_II = 0
            sum_total_SD = 0
            sum_total_TI = 0
            sum_total_TS = 0
            sum_total_SEMP = 0
            sum_total_PIT = 0
            sum_total_AS = 0
            sum_total_LMIN = 0
            sum_total_LA = 0
            sum_total_OD = 0
            sum_total_REC76 = 0
            sum_total_TD = 0
            sum_total_OH = 0
            sum_total_DEBT = 0
            sum_total_SFUND = 0
            for line in payslip_obj:
                
                if line['id'] == c:
                    if line['name_related'] == related:
                        g = 0
                    else:
                        #if line['code'] == 'BPD':
                            #sheet.write(rowy, 3, u'%s' %line['total'], style_table)
                            #sum_BPD += line['total']
                        #if line['code'] == 'WH':
                            #sheet.write(rowy, 4, u'%s' %line['total'], style_table)
                            #sum_WH += line['total']
                        #if line['code'] == 'RH':
                            #sheet.write(rowy, 5, u'%s' %line['total'], style_table)
                            #sum_RH += line['total']
                        #if line['code'] == 'RP':
                            #sheet.write(rowy, 6, u'%s' %line['total'], style_table)
                            #sum_RP += line['total']
                        #if line['code'] == 'CS':
                            #sheet.write(rowy, 7, u'%s' %line['total'], style_table)
                            #sum_CS += line['total']
                        #if line['code'] == 'OT':
                            #sheet.write(rowy, 8, u'%s' %line['total'], style_table)
                            #sum_OT += line['total']
                        #if line['code'] == 'OTI':
                            #sheet.write(rowy, 9, u'%s' %line['total'], style_table)
                            #sum_OTI += line['total']
                        #if line['code'] == 'PT':
                            #sheet.write(rowy, 10, u'%s' %line['total'], style_table)
                            #sum_PT += line['total']
                        #if line['code'] == 'PTI':
                            #sheet.write(rowy, 11, u'%s' %line['total'], style_table)
                            #sum_PTI += line['total']
                        #if line['code'] == 'CPA':
                            #sheet.write(rowy, 12, u'%s' %line['total'], style_table)
                            #sum_CPA += line['total']
                        #if line['code'] == 'SP':
                            #sheet.write(rowy, 13, u'%s' %line['total'], style_table)
                            #sum_SP += line['total']
                        #if line['code'] == 'ALP':
                            #sheet.write(rowy, 14, u'%s' %line['total'], style_table)
                            #sum_ALP += line['total']
                        #if line['code'] == 'MP':
                            #sheet.write(rowy, 15, u'%s' %line['total'], style_table)
                            #sum_MP += line['total']
                        #if line['code'] == 'BONUS':
                            #sheet.write(rowy, 16, u'%s' %line['total'], style_table)
                            #sum_BONUS += line['total']
                        #if line['code'] == 'MV':
                            #sheet.write(rowy, 17, u'%s' %line['total'], style_table)
                            #sum_MV += line['total']
                        #if line['code'] == 'OI':
                            #sheet.write(rowy, 18, u'%s' %line['total'], style_table)
                            #sum_OI += line['total']
                        #if line['code'] == 'SQI':
                            #sheet.write(rowy, 19, u'%s' %line['total'], style_table)
                            #sum_SQI += line['total']
                        #if line['code'] == 'CA':
                            #sheet.write(rowy, 20, u'%s' %line['total'], style_table)
                            #sum_CA += line['total']
                        #if line['code'] == 'IA':
                            #sheet.write(rowy, 21, u'%s' %line['total'], style_table)
                            #sum_IA += line['total']
                        #if line['code'] == 'CP':
                            #sheet.write(rowy, 22, u'%s' %line['total'], style_table)
                            #sum_CP += line['total']
                        #if line['code'] == 'IP':
                            #sheet.write(rowy, 23, u'%s' %line['total'], style_table)
                            #sum_IP += line['total']
                        #if line['code'] == 'CI':
                            #sheet.write(rowy, 24, u'%s' %line['total'], style_table)
                            #sum_CI += line['total']
                        #if line['code'] == 'II':
                            #sheet.write(rowy, 25, u'%s' %line['total'], style_table)
                            #sum_II += line['total']
                        #if line['code'] == 'SD':
                            #sheet.write(rowy, 26, u'%s' %line['total'], style_table)
                            #sum_SD += line['total']
                        #if line['code'] == 'TI':
                            #sheet.write(rowy, 27, u'%s' %line['total'], style_table)
                            #sum_TI += line['total']
                        #if line['code'] == 'TS':
                            #sheet.write(rowy, 28, u'%s' %line['total'], style_table)
                            #sum_TS += line['total']
                        #if line['code'] == 'SEMP':
                            #sheet.write(rowy, 29, u'%s' %line['total'], style_table)
                            #sum_SEMP += line['total']
                        #if line['code'] == 'PIT':
                            #sheet.write(rowy, 30, u'%s' %line['total'], style_table)
                            #sum_PIT += line['total']
                        #if line['code'] == 'AS':
                            #sheet.write(rowy, 31, u'%s' %line['total'], style_table)
                            #sum_AS += line['total']
                        #if line['code'] == 'LMIN':
                            #sheet.write(rowy, 32, u'%s' %line['total'], style_table)
                            #sum_LMIN += line['total']
                        #if line['code'] == 'LA':
                            #sheet.write(rowy, 33, u'%s' %line['total'], style_table)
                            #sum_LA += line['total']
                        #if line['code'] == 'OD':
                            #sheet.write(rowy, 34, u'%s' %line['total'], style_table)
                            #sum_OD += line['total']
                        #if line['code'] == 'REC76':
                            #sheet.write(rowy, 35, u'%s' %line['total'], style_table)
                            #sum_REC76 += line['total']
                        #if line['code'] == 'TD':
                            #sheet.write(rowy, 36, u'%s' %line['total'], style_table)
                            #sum_TD += line['total']
                        #if line['code'] == 'OH':
                            #sheet.write(rowy, 37, u'%s' %line['total'], style_table)
                            #sum_OH += line['total']
                        #if line['code'] == 'DEBT':
                            #sheet.write(rowy, 38, u'%s' %line['total'], style_table)
                            #sum_DEBT += line['total']
                        #if line['code'] == 'SFUND':
                            #sheet.write(rowy, 39, u'%s' %line['total'], style_table)
                            #sum_SFUND += line['total']                                                                                                                                                
                            #sheet.write(rowy, 40, u'', style_table)
                        
                        sheet.write(rowx, 0, u'%s' %i, style_table)
                        sheet.write(rowx, 1, u'%s' %line['employee_code'], style_table)
                        sheet.write(rowx, 2, u'%s' %line['name_related'], style_table)
                        rowy +=1
                        rowx +=1
                        i=i+1
                        related = line['name_related']
                else: 
                    if c != 0:
                        sheet.write_merge(rowx, rowx, 0, 2, u'Хэлтсийн дүн', ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 3, sum_BPD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 4, sum_WH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 5, sum_RH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 6, sum_RP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 7, sum_CS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 8, sum_OT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 9, sum_OTI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 10, sum_PT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 11, sum_PTI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 12, sum_CPA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 13, sum_SP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 14, sum_ALP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 15, sum_MP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 16, sum_BONUS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 17, sum_MV, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 18, sum_OI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 19, sum_SQI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 20, sum_CA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 21, sum_IA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 22, sum_CP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 23, sum_IP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 24, sum_CI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 25, sum_II, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 26, sum_SD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 27, sum_TI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 28, sum_TS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 29, sum_SEMP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 30, sum_PIT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 31, sum_AS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 32, sum_LMIN, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 33, sum_LA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 34, sum_OD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 35, sum_REC76, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 36, sum_TD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 37, sum_OH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 38, sum_DEBT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        sheet.write(rowx, 39, sum_SFUND, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                        rowx +=1
                        
                    sheet.write_merge(rowx, rowx, 0, 2, u'%s' %line['name'], ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                    rowy = rowx
                    rowx +=1
                    sum_BPD = 0
                    sum_WH = 0
                    sum_RH = 0
                    sum_RP = 0
                    sum_CS = 0
                    sum_OT = 0
                    sum_OTI = 0
                    sum_PT = 0
                    sum_PTI = 0
                    sum_CPA = 0
                    sum_SP = 0
                    sum_ALP = 0
                    sum_MP = 0
                    sum_BONUS = 0
                    sum_MV = 0
                    sum_OI = 0
                    sum_SQI = 0
                    sum_CA = 0
                    sum_IA = 0
                    sum_CP = 0
                    sum_IP = 0
                    sum_CI = 0
                    sum_II = 0
                    sum_SD = 0
                    sum_TI = 0
                    sum_TS = 0
                    sum_SEMP = 0
                    sum_PIT = 0
                    sum_AS = 0
                    sum_LMIN = 0
                    sum_LA = 0
                    sum_OD = 0
                    sum_REC76 = 0
                    sum_TD = 0
                    sum_OH = 0
                    sum_DEBT = 0
                    sum_SFUND = 0
                    c = line['id']
               
                if line['code'] == 'BPD':
                    sheet.write(rowy, 3, u'%s' %line['total'], style_table)
                    sum_BPD += line['total']
                    sum_total_BPD += line['total']
                if line['code'] == 'WH':
                    sheet.write(rowy, 4, u'%s' %line['total'], style_table)
                    sum_WH += line['total']
                    sum_total_WH += line['total']
                if line['code'] == 'RH':
                    sheet.write(rowy, 5, u'%s' %line['total'], style_table)
                    sum_RH += line['total']
                    sum_total_RH += line['total']
                if line['code'] == 'RP':
                    sheet.write(rowy, 6, u'%s' %line['total'], style_table)
                    sum_RP += line['total']
                    sum_total_RP += line['total']
                if line['code'] == 'CS':
                    sheet.write(rowy, 7, u'%s' %line['total'], style_table)
                    sum_CS += line['total']
                    sum_total_CS += line['total']
                if line['code'] == 'OT':
                    sheet.write(rowy, 8, u'%s' %line['total'], style_table)
                    sum_OT += line['total']
                    sum_total_OT += line['total']
                if line['code'] == 'OTI':
                    sheet.write(rowy, 9, u'%s' %line['total'], style_table)
                    sum_OTI += line['total']
                    sum_total_OTI += line['total']
                if line['code'] == 'PT':
                    sheet.write(rowy, 10, u'%s' %line['total'], style_table)
                    sum_PT += line['total']
                    sum_total_PT += line['total']
                if line['code'] == 'PTI':
                    sheet.write(rowy, 11, u'%s' %line['total'], style_table)
                    sum_PTI += line['total']
                    sum_total_PTI += line['total']
                if line['code'] == 'CPA':
                    sheet.write(rowy, 12, u'%s' %line['total'], style_table)
                    sum_CPA += line['total']
                    sum_total_CPA += line['total']
                if line['code'] == 'SP':
                    sheet.write(rowy, 13, u'%s' %line['total'], style_table)
                    sum_SP += line['total']
                    sum_total_SP += line['total']
                if line['code'] == 'ALP':
                    sheet.write(rowy, 14, u'%s' %line['total'], style_table)
                    sum_ALP += line['total']
                    sum_total_ALP += line['total']
                if line['code'] == 'MP':
                    sheet.write(rowy, 15, u'%s' %line['total'], style_table)
                    sum_MP += line['total']
                    sum_total_MP += line['total']
                if line['code'] == 'BONUS':
                    sheet.write(rowy, 16, u'%s' %line['total'], style_table)
                    sum_BONUS += line['total']
                    sum_total_BONUS += line['total']
                if line['code'] == 'MV':
                    sheet.write(rowy, 17, u'%s' %line['total'], style_table)
                    sum_MV += line['total']
                    sum_total_MV += line['total']
                if line['code'] == 'OI':
                    sheet.write(rowy, 18, u'%s' %line['total'], style_table)
                    sum_OI += line['total']
                    sum_total_OI += line['total']
                if line['code'] == 'SQI':
                    sheet.write(rowy, 19, u'%s' %line['total'], style_table)
                    sum_SQI += line['total']
                    sum_total_SQI += line['total']
                if line['code'] == 'CA':
                    sheet.write(rowy, 20, u'%s' %line['total'], style_table)
                    sum_CA += line['total']
                    sum_total_CA += line['total']
                if line['code'] == 'IA':
                    sheet.write(rowy, 21, u'%s' %line['total'], style_table)
                    sum_IA += line['total']
                    sum_total_IA += line['total']
                if line['code'] == 'CP':
                    sheet.write(rowy, 22, u'%s' %line['total'], style_table)
                    sum_CP += line['total']
                    sum_total_CP += line['total']
                if line['code'] == 'IP':
                    sheet.write(rowy, 23, u'%s' %line['total'], style_table)
                    sum_IP += line['total']
                    sum_total_IP += line['total']
                if line['code'] == 'CI':
                    sheet.write(rowy, 24, u'%s' %line['total'], style_table)
                    sum_CI += line['total']
                    sum_total_CI += line['total']
                if line['code'] == 'II':
                    sheet.write(rowy, 25, u'%s' %line['total'], style_table)
                    sum_II += line['total']
                    sum_total_II += line['total']
                if line['code'] == 'SD':
                    sheet.write(rowy, 26, u'%s' %line['total'], style_table)
                    sum_SD += line['total']
                    sum_total_SD += line['total']
                if line['code'] == 'TI':
                    sheet.write(rowy, 27, u'%s' %line['total'], style_table)
                    sum_TI += line['total']
                    sum_total_TI += line['total']
                if line['code'] == 'TS':
                    sheet.write(rowy, 28, u'%s' %line['total'], style_table)
                    sum_TS += line['total']
                    sum_total_TS += line['total']
                if line['code'] == 'SEMP':
                    sheet.write(rowy, 29, u'%s' %line['total'], style_table)
                    sum_SEMP += line['total']
                    sum_total_SEMP += line['total']
                if line['code'] == 'PIT':
                    sheet.write(rowy, 30, u'%s' %line['total'], style_table)
                    sum_PIT += line['total']
                    sum_total_PIT += line['total']
                if line['code'] == 'AS':
                    sheet.write(rowy, 31, u'%s' %line['total'], style_table)
                    sum_AS += line['total']
                    sum_total_AS += line['total']
                if line['code'] == 'LMIN':
                    sheet.write(rowy, 32, u'%s' %line['total'], style_table)
                    sum_LMIN += line['total']
                    sum_total_LMIN += line['total']
                if line['code'] == 'LA':
                    sheet.write(rowy, 33, u'%s' %line['total'], style_table)
                    sum_LA += line['total']
                    sum_total_LA += line['total']
                if line['code'] == 'OD':
                    sheet.write(rowy, 34, u'%s' %line['total'], style_table)
                    sum_OD += line['total']
                    sum_total_OD += line['total']
                if line['code'] == 'REC76':
                    sheet.write(rowy, 35, u'%s' %line['total'], style_table)
                    sum_REC76 += line['total']
                    sum_total_REC76 += line['total']
                if line['code'] == 'TD':
                    sheet.write(rowy, 36, u'%s' %line['total'], style_table)
                    sum_TD += line['total']
                    sum_total_TD += line['total']
                if line['code'] == 'OH':
                    sheet.write(rowy, 37, u'%s' %line['total'], style_table)
                    sum_OH += line['total']
                    sum_total_OH += line['total']
                if line['code'] == 'DEBT':
                    sheet.write(rowy, 38, u'%s' %line['total'], style_table)
                    sum_DEBT += line['total']
                    sum_total_DEBT += line['total']
                if line['code'] == 'SFUND':
                    sheet.write(rowy, 39, u'%s' %line['total'], style_table)
                    sum_SFUND += line['total']
                    sum_total_SFUND += line['total']                                                                                                                                                
                    sheet.write(rowy, 40, u'', style_table)
        
        if c != 0:
                sheet.write_merge(rowx, rowx, 0, 2, u'Хэлтсийн дүн', ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 3, sum_BPD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 4, sum_WH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 5, sum_RH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 6, sum_RP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 7, sum_CS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 8, sum_OT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 9, sum_OTI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 10, sum_PT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 11, sum_PTI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 12, sum_CPA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 13, sum_SP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 14, sum_ALP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 15, sum_MP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 16, sum_BONUS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 17, sum_MV, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 18, sum_OI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 19, sum_SQI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 20, sum_CA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 21, sum_IA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 22, sum_CP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 23, sum_IP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 24, sum_CI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 25, sum_II, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 26, sum_SD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 27, sum_TI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 28, sum_TS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 29, sum_SEMP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 30, sum_PIT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 31, sum_AS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 32, sum_LMIN, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 33, sum_LA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 34, sum_OD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 35, sum_REC76, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 36, sum_TD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 37, sum_OH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 38, sum_DEBT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                sheet.write(rowx, 39, sum_SFUND, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
                rowx +=1            
                
        
        inch = 1000
        inch1 = 900
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 5*inch1
        
        sheet.write_merge(rowx, rowx, 0, 2, u'Нийт дүн', ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 3, sum_total_BPD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 4, sum_total_WH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 5, sum_total_RH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 6, sum_total_RP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 7, sum_total_CS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 8, sum_total_OT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 9, sum_total_OTI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 10, sum_total_PT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 11, sum_total_PTI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 12, sum_total_CPA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 13, sum_total_SP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 14, sum_total_ALP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 15, sum_total_MP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 16, sum_total_BONUS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 17, sum_total_MV, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 18, sum_total_OI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 19, sum_total_SQI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 20, sum_total_CA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 21, sum_total_IA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 22, sum_total_CP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 23, sum_total_IP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 24, sum_total_CI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 25, sum_total_II, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 26, sum_total_SD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 27, sum_total_TI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 28, sum_total_TS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 29, sum_total_SEMP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 30, sum_total_PIT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 31, sum_total_AS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 32, sum_total_LMIN, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 33, sum_total_LA, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 34, sum_total_OD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 35, sum_total_REC76, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 36, sum_total_TD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 37, sum_total_OH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 38, sum_total_DEBT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 39, sum_total_SFUND, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        
        rowx += 2
        
        sheet.write(rowx, 9, u'ГҮЙЦЭТГЭХ ЗАХИРАЛ:', ezxf('font: bold off;align:wrap off,vert centre;'))
        rowx += 2
        sheet.write(rowx, 9, u'АХНЛАХ НЯ-БО:', ezxf('font: bold off;align:wrap off,vert centre;'))
        rowx += 2
        sheet.write(rowx, 9, u'ЦАЛИНГИЙН НЯ-БО:', ezxf('font: bold off;align:wrap off,vert centre;'))
        
        return {'data':book}

monthly_salary_report()