# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class monthly_united(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "monthly.united"
    _description = "Monthly united"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'payslip_id':fields.many2one('hr.payslip','Hr payslip'),
        'payslip_run_id': fields.many2one('hr.payslip.run', 'Payslip Batches'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        pay_run = self.pool.get('hr.payslip.run')
        pa_run = pay_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])])
        p_run = pay_run.browse(cr, uid, pa_run)
        
        #pay_line_obj = self.pool.get('hr.payslip')
        #pa_line = pay_line_obj.search(cr, uid, [('payslip_run_id','=',data['payslip_run_id'][0])])
        #p_line = pay_line_obj.browse(cr, uid, pa_line)
        
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Monthly salary')
        sheet.write(0, 6, u'Сарын сүүл нэгтгэл цалин', ezxf('font: bold on;align:wrap off,vert centre;'))
        #sheet.write(2, 1, u'%s' %p_line.company_id.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(2, 6, u'%s' %p_run.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        #sheet.write(1, 7, u'Тайлант үе:', ezxf('font: bold off;align:wrap off,vert centre;'))
        #sheet.write(0, 8, time.strftime('%Y-%m-%d'))
        sheet.write_merge(4, 5, 0, 0, u'№', style_table_header1)
        sheet.write_merge(4, 5, 1, 1, u'Код', style_table_header1)
        sheet.write_merge(4, 5, 2, 2, u'Нэр', style_table_header1)
        sheet.write_merge(4, 5, 3, 3, u'Үндсэн цалин', style_table_header1)
        sheet.write_merge(4, 5, 4, 4, u'Бодгдсон цалин', style_table_header1)
        sheet.write_merge(4, 5, 5, 5, u'Илүү цагийн нэмэгдэл', style_table_header1)
        sheet.write_merge(4, 5, 6, 6, u'Баярын цагийн нэмэгдэл', style_table_header1)
        sheet.write_merge(4, 5, 7, 7, u'Актны мөнгө', style_table_header1)
        sheet.write_merge(4, 5, 8, 8, u'Жат', style_table_header1)
        sheet.write_merge(4, 5, 9, 9, u'Амралтын мөнгө', style_table_header1)
        sheet.write_merge(4, 5, 10, 10, u'Шагналт цалин', style_table_header1)
        sheet.write_merge(4, 5, 11, 11, u'Хоол нэмэгдэл', style_table_header1)
        sheet.write_merge(4, 5, 12, 12, u'Нийт нэмэгдэл', style_table_header1)
        sheet.write_merge(4, 5, 13, 13, u'Олговол зохих', style_table_header1)
        sheet.write_merge(4, 5, 14, 14, u'НДШ ажиллагч', style_table_header1)
        sheet.write_merge(4, 5, 15, 15, u'Урьдчилгаа', style_table_header1)
        sheet.write_merge(4, 5, 16, 16, u'Авлага 76', style_table_header1)
        sheet.write_merge(4, 5, 17, 17, u'Суутгалын дүн', style_table_header1)
        sheet.write_merge(4, 5, 18, 18, u'Гарт олгох', style_table_header1)
        sheet.write_merge(4, 5, 19, 19, u'Өр', style_table_header1)
        rowx = 6
        payslip_line_obj = self.pool.get('hr.payslip.line')
        payslip = self.pool.get('hr.payslip')
        payslip_run=self.pool.get('hr.payslip.run')
        run = payslip_run.browse(cr, uid, payslip_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])]))
        
        pay = payslip.search(cr, uid, [('payslip_run_id','=',data['payslip_run_id'][0])])
        #print'jjjjjjo',pay
        
        cr.execute("""select hr_department.id, hr_department.code as kkk, hr_department.name,hr_payslip_line.code,sum(hr_payslip_line.total)
                    from 
                      public.hr_payslip, 
                      public.hr_payslip_line,
                      public.hr_payslip_run,  
                      public.hr_employee, 
                      public.hr_department
                    
                    where 
                      hr_payslip.employee_id = hr_employee.id AND
                      hr_payslip.id = hr_payslip_line.slip_id AND
                      hr_payslip_run.id = hr_payslip.payslip_run_id AND
                      hr_department.id = hr_employee.department_id
                      and  hr_payslip_run.id = %s
                    group by hr_department.id,kkk,hr_department.name,hr_payslip_line.code
                    order by hr_department.id"""%(data['payslip_run_id'][0]))
        payslip_obj  = cr.dictfetchall()
        
        if payslip_obj:
            i=1
            c=0
            rowy = 0
            g = 0
            sum_BPD = 0
            sum_CS = 0
            sum_OTI = 0
            sum_PTI = 0
            sum_SP = 0
            sum_MP = 0
            sum_ALP = 0
            sum_BONUS = 0
            sum_MV = 0
            sum_TI = 0
            sum_TS = 0
            sum_SEMP = 0
            sum_AS = 0
            sum_REC76 = 0
            sum_TD = 0
            #sum_OH = 0
            #sum_DEBT = 0
            for line in payslip_obj:
                
                if line['id'] == c:
                    
                   g = 0
                else: 
                    sheet.write(rowx, 0, u'%s' %i, style_table)
                    sheet.write(rowx, 1, u'%s' %line['kkk'], style_table)
                    sheet.write(rowx, 2, u'%s' %line['name'], style_table)
                    rowy = rowx
                    rowx +=1
                    i=i+1
                    c = line['id']
               
                if line['code'] == 'BASIC':
                    sheet.write(rowy, 3, u'%s' %line['sum'], style_table)
                    sum_BPD += line['sum']
                if line['code'] == 'CS':
                    sheet.write(rowy, 4, u'%s' %line['sum'], style_table)
                    sum_CS += line['sum']
                if line['code'] == 'OTI':
                    sheet.write(rowy, 5, u'%s' %line['sum'], style_table)
                    sum_OTI += line['sum']
                if line['code'] == 'PTI':
                    sheet.write(rowy, 6, u'%s' %line['sum'], style_table)
                    sum_PTI += line['sum']
                if line['code'] == 'SP':
                    sheet.write(rowy, 7, u'%s' %line['sum'], style_table)
                    sum_SP += line['sum']
                if line['code'] == 'MP':
                    sheet.write(rowy, 8, u'%s' %line['sum'], style_table)
                    sum_MP += line['sum']
                if line['code'] == 'ALP':
                    sheet.write(rowy, 9, u'%s' %line['sum'], style_table)
                    sum_ALP += line['sum']
                if line['code'] == 'BONUS':
                    sheet.write(rowy, 10, u'%s' %line['sum'], style_table)
                    sum_BONUS += line['sum']
                if line['code'] == 'MV':
                    sheet.write(rowy, 11, u'%s' %line['sum'], style_table)
                    sum_MV += line['sum']
                if line['code'] == 'TI':
                    sheet.write(rowy, 12, u'%s' %line['sum'], style_table)
                    sum_TI += line['sum']
                if line['code'] == 'TS':
                    sheet.write(rowy, 13, u'%s' %line['sum'], style_table)
                    sum_TS += line['sum']
                if line['code'] == 'SEMP':
                    sheet.write(rowy, 14, u'%s' %line['sum'], style_table)
                    sum_SEMP += line['sum']
                if line['code'] == 'AS':
                    sheet.write(rowy, 15, u'%s' %line['sum'], style_table)
                    sum_AS += line['sum']
                if line['code'] == 'REC76':
                    sheet.write(rowy, 16, u'%s' %line['sum'], style_table)
                    sum_REC76 += line['sum']
                if line['code'] == 'TD':
                    sheet.write(rowy, 17, u'%s' %line['sum'], style_table)
                    sum_TD += line['sum']
                if line['code'] == 'OH':
                    sheet.write(rowy, 18, u'%s' %line['sum'], style_table)
                    #sum_OH += line['sum']
                if line['code'] == 'DEBT':
                    sheet.write(rowy, 19, u'%s' %line['sum'], style_table)
                    #sum_DEBT += line['sum']                                   
                  
        inch = 1000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 3*inch
        sheet.col(2).width = 5*inch
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 4*inch
        sheet.col(6).width = 4*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 3*inch
        sheet.col(13).width = 3*inch
        sheet.col(14).width = 3*inch
        sheet.col(15).width = 3*inch
        sheet.col(16).width = 3*inch
        sheet.col(17).width = 3*inch
        sheet.col(18).width = 3*inch
        sheet.col(19).width = 3*inch
        #rowx = 1
        
        sheet.write_merge(rowx, rowx, 0, 2, u'Нийт дүн', ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 3, sum_BPD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 4, sum_CS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 5, sum_OTI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 6, sum_PTI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 7, sum_SP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 8, sum_MP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 9, sum_ALP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 10, sum_BONUS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 11, sum_MV, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 12, sum_TI, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 13, sum_TS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 14, sum_SEMP, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 15, sum_AS, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 16, sum_REC76, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        sheet.write(rowx, 17, sum_TD, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        #sheet.write(rowx, 18, sum_OH, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        #sheet.write(rowx, 19, sum_DEBT, ezxf('font: bold on;align:wrap off,vert centre, horiz center;'))
        
        return {'data':book}

monthly_united()