# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class payables_social_online(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "payables.social.online"
    _description = "Payables social online"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'payslip_id':fields.many2one('hr.payslip','Hr payslip'),
        'payslip_run_id': fields.many2one('hr.payslip.run', 'Payslip Batches'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        #style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Payables social online')
        sheet.write(0, 0, u'ovog', style_table_header)
        sheet.write(0, 1, u'name', style_table_header)
        sheet.write(0, 2, u'register', style_table_header)
        sheet.write(0, 3, u'nd_dugaar', style_table_header)
        sheet.write(0, 4, u'emd_dugaar', style_table_header)
        sheet.write(0, 5, u'undsen_nemegdel_tsalin', style_table_header)
        sheet.write(0, 6, u'shagnalt_tsalin', style_table_header)
        sheet.write(0, 7, u'busad_nemegdel_tsalin', style_table_header)
        sheet.write(0, 8, u'hool_unaa', style_table_header)
        sheet.write(0, 9, u'tulee_nuurs', style_table_header)
        sheet.write(0, 10, u'niit', style_table_header)
        sheet.write(0, 11, u'daat_turul', style_table_header)
        sheet.write(0, 12, u'hyazgaar', style_table_header)
        sheet.write(0, 13, u'countryid', style_table_header)
        sheet.write(0, 14, u'occ_code', style_table_header)
        sheet.write(0, 15, u'loc_code', style_table_header)
        sheet.write(0, 16, u'cellphone', style_table_header)
        sheet.write(0, 17, u'email', style_table_header)
        rowx = 1
        payslip_line_obj = self.pool.get('hr.payslip.line')
        payslip = self.pool.get('hr.payslip')
        payslip_run=self.pool.get('hr.payslip.run')
        run = payslip_run.browse(cr, uid, payslip_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])]))
        
        pay = payslip.search(cr, uid, [('payslip_run_id','=',data['payslip_run_id'][0])])
        #print'jjjjjjo',pay
        for line1 in run.slip_ids:
            sheet.write(rowx, 0, u'%s' %line1.employee_id.last_name, style_table)
            sheet.write(rowx, 1, u'%s' %line1.employee_id.name, style_table)
            sheet.write(rowx, 2, u'%s' %line1.employee_id.register_number, style_table)
            sheet.write(rowx, 3, u'%s' %line1.employee_id.ndd, style_table)
            sheet.write(rowx, 4, u'%s' %line1.employee_id.emdd, style_table)
            for line2 in line1.line_ids:
                if line2.code == 'BASIC':
                    sheet.write(rowx, 5, u'%s' %line2.total, style_table)
            sheet.write(rowx, 6, u'%s' %'', style_table)
            sheet.write(rowx, 7, u'%s' %'', style_table)
            sheet.write(rowx, 8, u'%s' %'', style_table)
            sheet.write(rowx, 9, u'%s' %'', style_table)
            sheet.write(rowx, 10, u'%s' %'', style_table)
            sheet.write(rowx, 11, u'%s' %'', style_table)
            sheet.write(rowx, 12, u'%s' %'', style_table)
            sheet.write(rowx, 13, u'%s' %line1.employee_id.country_id.name, style_table)
            sheet.write(rowx, 14, u'%s' %'', style_table)
            sheet.write(rowx, 15, u'%s' %'', style_table)
            sheet.write(rowx, 16, u'%s' %'', style_table)
            sheet.write(rowx, 17, u'%s' %line1.employee_id.work_email, style_table)                                                                                                                                                   
            rowx += 1
            
        inch = 1000
        sheet.col(0).width = 3*inch
        sheet.col(1).width = 3*inch
        sheet.col(2).width = 3*inch
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 3*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        return {'data':book}

payables_social_online()