# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta
from xlwt.Utils import rowcol_to_cell


class payables_social_security(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "payables.social.security"
    _description = "Payables social security"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'payslip_id':fields.many2one('hr.payslip','Hr payslip'),
        'payslip_run_id': fields.many2one('hr.payslip.run', 'Payslip Batches'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        #pay_run = self.pool.get('hr.payslip.run')
        #pa_run = pay_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])])
        #p_run = pay_run.browse(cr, uid, pa_run)
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Monthly salary')
        sheet.write_merge(1, 2, 2, 11, u'................... ХХК -АЖИЛ ОЛГОГЧИЙН 20.. ОНД АЖИЛЛАЖ БУЙ ДААТГУУЛАГЧДЫН 20....ОНЫ ..ДУГААР САРД НОГДУУЛАХ НИЙГМИЙН ДААТГАЛЫН ШИМТГЭЛ', ezxf('font: bold on;align:wrap on,vert centre;'))
        #sheet.write(1, 2, u'%s' %pap.company_id.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        #sheet.write(1, 4, u'%s' %p_run.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        #sheet.write(1, 7, u'Тайлант үе:', ezxf('font: bold off;align:wrap off,vert centre;'))
        #sheet.write(0, 8, time.strftime('%Y-%m-%d'))
        sheet.write_merge(4, 8, 0, 0, u'№', style_table_header1)
        sheet.write_merge(4, 8, 1, 1, u'Даатгуулагчийн овог', style_table_header1)
        sheet.write_merge(4, 8, 2, 2, u'Даатгуулагчийн нэр', style_table_header1)
        sheet.write_merge(4, 8, 3, 3, u'Албан тушаал', style_table_header1)
        sheet.write_merge(4, 8, 4, 4, u'Регистрийн дугаар', style_table_header1)
        sheet.write_merge(4, 8, 5, 5, u'Нийгмийн даатгалын дэвтрийн дугаар', style_table_header1)
        sheet.write_merge(4, 8, 6, 6, u'Эрүүд мэндийн даатгалын гэрчилгээний дугаар', style_table_header1)
        sheet.write_merge(4, 8, 7, 7, u'Хөдөлмөрийн хөлс түүнтэй адилтгах орлого', style_table_header1)
        sheet.write_merge(4, 5, 8, 10, u'Нийгмийн даатгалын санд төлсөн шимтгэл', style_table_header1)
        sheet.write_merge(6, 8, 8, 8, u'Нийт дүн', style_table_header1)
        sheet.write_merge(6, 6, 9, 10, u'Үүнээс', style_table_header1)
        sheet.write_merge(7, 8, 9, 9, u'Ажил олгогч', style_table_header1)
        sheet.write_merge(7, 8, 10, 10, u'Даатгуулагч', style_table_header1)
        sheet.write_merge(4, 8, 11, 11, u'Даатгуулагчийн төрөл', style_table_header1)
        sheet.write_merge(4, 8, 12, 12, u'Дээд хэмжээ хязгаарлах эсэх', style_table_header1)
        sheet.write_merge(4, 8, 13, 13, u'Хоолны мөнгө О.Зохих', style_table_header1)
        sheet.write(9, 0, u'A', style_table_header1)
        sheet.write(9, 1, u'', style_table_header1)
        sheet.write(9, 2, u'B', style_table_header1)
        sheet.write(9, 3, u'Г', style_table_header1)
        sheet.write(9, 4, u'1', style_table_header1)
        sheet.write(9, 5, u'2', style_table_header1)
        sheet.write(9, 6, u'3', style_table_header1)
        sheet.write(9, 7, u'4', style_table_header1)
        sheet.write(9, 8, u'5', style_table_header1)
        sheet.write(9, 9, u'6', style_table_header1)
        sheet.write(9, 10, u'7', style_table_header1)
        sheet.write(9, 11, u'8', style_table_header1)
        sheet.write(9, 12, u'9', style_table_header1)
        sheet.write(9, 13, u'11', style_table_header1)
        sheet.write(10, 0, u'', style_table_header1)
        sheet.write(10, 1, u'', style_table_header1)
        sheet.write(10, 2, u'', style_table_header1)
        sheet.write(10, 3, u'', style_table_header1)
        sheet.write(10, 4, u'', style_table_header1)
        sheet.write(10, 5, u'', style_table_header1)
        sheet.write(10, 6, u'', style_table_header1)
        sheet.write(10, 7, u'TS', style_table_header1)
        sheet.write(10, 8, u'6+7', style_table_header1)
        sheet.write(10, 9, u'', style_table_header1)
        sheet.write(10, 10, u'', style_table_header1)
        sheet.write(10, 11, u'', style_table_header1)
        sheet.write(10, 12, u'', style_table_header1)
        sheet.write(10, 13, u'', style_table_header1)
        rowx = 11
        payslip_line_obj = self.pool.get('hr.payslip.line')
        payslip = self.pool.get('hr.payslip')
        payslip_run=self.pool.get('hr.payslip.run')
        run = payslip_run.browse(cr, uid, payslip_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])]))
        
        pay = payslip.search(cr, uid, [('payslip_run_id','=',data['payslip_run_id'][0])])
        #print'jjjjjjo',pay
        i=1
        j = 11
        for line1 in run.slip_ids:
            sheet.write(rowx, 0, u'%s' %i, style_table)
            i=i+1
            sheet.write(rowx, 1, u'%s' %line1.employee_id.last_name, style_table)
            sheet.write(rowx, 2, u'%s' %line1.employee_id.name, style_table)
            sheet.write(rowx, 3, u'%s' %line1.employee_id.job_id.name, style_table)
            sheet.write(rowx, 4, u'%s' %line1.employee_id.register_number, style_table)
            sheet.write(rowx, 5, u'%s' %line1.employee_id.ndd, style_table)
            sheet.write(rowx, 6, u'%s' %line1.employee_id.emdd, style_table)
            for line2 in line1.line_ids:
                
                hourly_cell = rowcol_to_cell(j, 9)
                hours_in_month = rowcol_to_cell(j, 10)
                
                if line2.code == 'BASIC':
                    sheet.write(rowx, 7, u'%s' %line2.total, style_table)
                #if line2.code == 'BASIC':
                    #sheet.write(rowx, 8, Formula("sum(J12:K12)"), style_table)
                    sheet.write(rowx, 8, xlwt.Formula("%s + %s" % (hourly_cell, hours_in_month)), style_table)
                if line2.code == 'BASIC':
                    sheet.write(rowx, 9, line2.total, style_table)
                if line2.code == 'BASIC':
                    sheet.write(rowx, 10, line2.total, style_table)
                    sheet.write(rowx, 11, u'1', style_table)
                    sheet.write(rowx, 12, u'1', style_table)
                if line2.code == 'BASIC':
                    sheet.write(rowx, 13, u'%s' %line2.total, style_table) 
            j += 1                                                                                                                                                              
            rowx += 1
            
            
        inch = 1000
        inch1 = 900
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 4*inch
        sheet.col(2).width = 4*inch
        sheet.col(3).width = 6*inch
        sheet.col(4).width = 4*inch
        sheet.col(5).width = 3*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 3*inch
        sheet.col(13).width = 3*inch
        rowx += 2
        
        sheet.write(rowx, 5, u'Гүйцэтгэх захирал:', ezxf('font: bold off;align:wrap off,vert centre;'))
        #sheet.write(rowx, 5, u'Нягтлан бодогч:', ezxf('font: bold off;align:wrap off,vert centre;'))
        
        return {'data':book}

payables_social_security()