# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class payroll_recapitulation(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "payroll.recapitulation"
    _description = "Payroll recapitulation"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'payslip_id':fields.many2one('hr.payslip','Hr payslip'),
        'payslip_run_id': fields.many2one('hr.payslip.run', 'Payslip Batches'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        pay_run = self.pool.get('hr.payslip.run')
        pa_run = pay_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])])
        p_run = pay_run.browse(cr, uid, pa_run)
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table1 = ezxf('font: bold off; align: wrap on, vert centre, horiz left;')
        style_table2 = ezxf('font: bold off; align: wrap on, vert centre, horiz left; borders: top thin;')
        style_table3 = ezxf('font: bold off; align: wrap on, vert centre, horiz left; borders: bottom thin;')
        style_table_header1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center;  pattern: pattern solid;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Payroll recapitulation')
        #----------------------- sheet.write(2, 1, u'Дебит', style_table_header)
        #---------------------- sheet.write(2, 4, u'Кредит', style_table_header)
        #----- sheet.write_merge(2, 4, 5, 5, u'Ажилтны нэр', style_table_header)
        #------------- sheet.write_merge(2, 4, 7, 7, u'Дүн', style_table_header)
        # sheet.write_merge(3, 4, 1, 1, u'Дотоод дансны дугаар', style_table_header)
        #------------- sheet.write_merge(2, 4, 2, 2, u'Нэр', style_table_header)
        #----------- sheet.write_merge(2, 4, 3, 3, u'Валют', style_table_header)
        #--- sheet.write_merge(3, 4, 4, 4, u'Картын дугаар', style_table_header)
        #------------- sheet.write_merge(2, 4, 6, 6, u'Влт', style_table_header)
        #- sheet.write_merge(2, 4, 8, 9, u'Гүйлгээний утга', style_table_header)
        rowx = 0
        payslip_line_obj = self.pool.get('hr.payslip.line')
        payslip = self.pool.get('hr.payslip')
        payslip_run=self.pool.get('hr.payslip.run')
        run = payslip_run.browse(cr, uid, payslip_run.search(cr, uid, [('id','=',data['payslip_run_id'][0])]))
        
        pay = payslip.search(cr, uid, [('payslip_run_id','=',data['payslip_run_id'][0])])
        
        for line1 in run.slip_ids:
            sheet.write(rowx, 0, u'%s' %run.name, ezxf('font: bold off;align:wrap off,vert centre;'))
            rowx += 1
            sheet.write(rowx, 0, u'%s' %line1.employee_id.department_id.name, style_table1)
            sheet.write(rowx, 1, u'%s' %line1.employee_id.job_id.name, style_table1)
            sheet.write(rowx, 2, u'%s' %line1.employee_id.register_number, style_table1)
            sheet.write(rowx, 3, u'%s' %line1.employee_id.name, style_table1)
            rowx += 1
            for line2 in line1.line_ids:
                if line2.code == 'BPD':
                    sheet.write(rowx, 0, u'Үндсэн цалин', style_table2)
                    sheet.write(rowx, 1, u'%s' %line2.total, style_table2)
                if line2.code == 'RP':
                    sheet.write(rowx, 2, u'Авсан үр дүн', style_table2)
                    sheet.write(rowx, 3, u'%s' %line2.total, style_table2)
                if line2.code == 'SEMP':
                    sheet.write(rowx, 4, u'НДШ ажиллагч', style_table2)
                    sheet.write(rowx, 5, u'%s' %line2.total, style_table2)                                                                                                                                                   
            rowx += 1
            for line3 in line1.line_ids:
                if line3.code == 'WH':
                    sheet.write(rowx, 0, u'Фонд цаг', style_table1)
                    sheet.write(rowx, 1, u'%s' %line3.total, style_table1)
                if line3.code == 'BONUS':
                    sheet.write(rowx, 2, u'Урамшуулалт цалин', style_table1)
                    sheet.write(rowx, 3, u'%s' %line3.total, style_table1)
                if line3.code == 'PIT':
                    sheet.write(rowx, 4, u'ХХОАТ', style_table1)
                    sheet.write(rowx, 5, u'%s' %line3.total, style_table1)                                                                                                                                                   
            rowx += 1
            for line4 in line1.line_ids:
                if line4.code == 'RH':
                    sheet.write(rowx, 0, u'Ажилласан цаг', style_table1)
                    sheet.write(rowx, 1, u'%s' %line4.total, style_table1)
                if line4.code == 'ALP':
                    sheet.write(rowx, 2, u'Амралтын мөнгө', style_table1)
                    sheet.write(rowx, 3, u'%s' %line4.total, style_table1)
                if line4.code == 'AS':
                    sheet.write(rowx, 4, u'Урьдчилгаа цалин', style_table1)
                    sheet.write(rowx, 5, u'%s' %line4.total, style_table1)                                                                                                                                                   
            rowx += 1
            for line5 in line1.line_ids:
                if line5.code == 'CS':
                    sheet.write(rowx, 0, u'Бодогдсон цалин', style_table1)
                    sheet.write(rowx, 1, u'%s' %line5.total, style_table1)
                if line5.code == 'SP':
                    sheet.write(rowx, 2, u'Акт', style_table1)
                    sheet.write(rowx, 3, u'%s' %line5.total, style_table1)
                if line5.code == 'LA':
                    sheet.write(rowx, 4, u'Тас минут суутгал', style_table1)
                    sheet.write(rowx, 5, u'%s' %line5.total, style_table1)                                                                                                                                                   
            rowx += 1
            for line6 in line1.line_ids:
                if line6.code == 'OT':
                    sheet.write(rowx, 0, u'Илүү цаг', style_table1)
                    sheet.write(rowx, 1, u'%s' %line6.total, style_table1)
                if line6.code == 'MP':
                    sheet.write(rowx, 2, u'ЖАТ', style_table1)
                    sheet.write(rowx, 3, u'%s' %line6.total, style_table1)
                if line6.code == 'REC76':
                    sheet.write(rowx, 4, u'Авлага 76', style_table1)
                    sheet.write(rowx, 5, u'%s' %line6.total, style_table1)                                                                                                                                                   
            rowx += 1
            for line7 in line1.line_ids:
                if line7.code == 'OTI':
                    sheet.write(rowx, 0, u'И/ц нэмэгдэл', style_table1)
                    sheet.write(rowx, 1, u'%s' %line7.total, style_table1)
                if line7.code == 'MV':
                    sheet.write(rowx, 2, u'Хоол нэмэгдэл', style_table1)
                    sheet.write(rowx, 3, u'%s' %line7.total, style_table1)
                if line7.code == 'OD':
                    sheet.write(rowx, 4, u'Бусад суутгал', style_table1)
                    sheet.write(rowx, 5, u'%s' %line7.total, style_table1)                                                                                                                                                   
            rowx += 1
            for line8 in line1.line_ids:
                if line8.code == 'PT':
                    sheet.write(rowx, 0, u'Баярын цаг', style_table1)
                    sheet.write(rowx, 1, u'%s' %line8.total, style_table1)
                if line8.code == 'OI':
                    sheet.write(rowx, 2, u'Бусад нэмэгдэл', style_table1)
                    sheet.write(rowx, 3, u'%s' %line8.total, style_table1)
                if line8.code == 'TD':
                    sheet.write(rowx, 4, u'Суутгалын дүн', style_table1)
                    sheet.write(rowx, 5, u'%s' %line8.total, style_table1)                                                                                                                                                   
            rowx += 1
            for line9 in line1.line_ids:
                if line9.code == 'PTI':
                    sheet.write(rowx, 0, u'Б/ц нэмэгдэл', style_table1)
                    sheet.write(rowx, 1, u'%s' %line9.total, style_table1)
                if line9.code == 'SQI':
                    sheet.write(rowx, 2, u'Талбайн нэмэгдэл', style_table1)
                    sheet.write(rowx, 3, u'%s' %line9.total, style_table1)
                if line9.code == 'MFA':
                    sheet.write(rowx, 4, u'Саятан сан', style_table1)
                    sheet.write(rowx, 5, u'%s' %line9.total, style_table1)                                                                                                                                                   
            rowx += 1
            for line10 in line1.line_ids:
                if line10.code == 'SD':
                    sheet.write(rowx, 0, u'Хийснээр цалин', style_table3)
                    sheet.write(rowx, 1, u'%s' %line10.total, style_table3)
                if line10.code == 'TI':
                    sheet.write(rowx, 2, u'Нэмэгдлийн дүн', style_table3)
                    sheet.write(rowx, 3, u'%s' %line10.total, style_table3)
                if line10.code == 'BASIC':
                    sheet.write(rowx, 4, u'', style_table3)
                    sheet.write(rowx, 5, u'', style_table3)                                                                                                                                                   
            rowx += 1
            for line11 in line1.line_ids:
                if line11.code == 'OH':
                    sheet.write(rowx, 2, u'Олговол зохих', style_table1)
                    sheet.write(rowx, 3, u'%s' %line11.total, style_table1)                                                                                                                                                   
            rowx += 1
            
            
        inch = 1000
        sheet.col(0).width = 5*inch
        sheet.col(1).width = 5*inch
        sheet.col(2).width = 5*inch
        sheet.col(3).width = 5*inch
        sheet.col(4).width = 5*inch
        
        return {'data':book}

payroll_recapitulation()