# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class sick_benefit_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "sick.benefit.report"
    _description = "Sick benefit report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'sick_benefit_id':fields.many2one('sick.benefit','Sick benefit'),
        'sick_line_id': fields.many2one('sick.line', 'Sick line'),
        'start_date': fields.date('Start date'),
        'end_date': fields.date('End date'),
        
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        obj = self.browse(cr, uid, ids)[0]
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Sick benefit report')
        sheet.write(0, 4, u'Актний мөнгө бодсон тооцоо', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(2, 2, 1, 2, u'%s' %obj.company_id.name, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(2, 16, u'Тайлант үе:', ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(2, 17, time.strftime('%Y-%m-%d'))
        sheet.write_merge(3, 5, 0, 0, u'д/д', style_table_header1)
        sheet.write_merge(3, 5, 1, 1, u'Нэр', style_table_header1)
        sheet.write_merge(3, 5, 2, 2, u'НДШ дэвтэр', style_table_header1)
        sheet.write_merge(3, 3, 3, 5, u'Эмнэлгийн хуудас', style_table_header1)
        sheet.write_merge(4, 5, 3, 3, u'Дугаар', style_table_header1)
        sheet.write_merge(4, 5, 4, 4, u'Эхэлсэн огноо', style_table_header1)
        sheet.write_merge(4, 5, 5, 5, u'Дууссан огноо', style_table_header1)
        sheet.write_merge(3, 5, 6, 6, u'Ажилласан жил', style_table_header1)
        sheet.write_merge(3, 5, 7, 7, u'3 сарын нийлбэр цалин', style_table_header1)
        sheet.write_merge(3, 5, 8, 8, u'3 сарын нийлбэр хоног', style_table_header1)
        sheet.write_merge(3, 3, 9, 11, u'Тэтгэмж бодох', style_table_header1)
        sheet.write_merge(4, 5, 9, 9, u'Нэг өдрийн хөлс', style_table_header1)
        sheet.write_merge(4, 5, 10, 10, u'Хувь', style_table_header1)
        sheet.write_merge(4, 5, 11, 11, u'Нэг өдөрт ноогдох', style_table_header1)
        sheet.write_merge(3, 3, 12, 14, u'Хоног', style_table_header1)
        sheet.write_merge(4, 5, 12, 12, u'Бүгд', style_table_header1)
        sheet.write_merge(4, 5, 13, 13, u'Ажил олгогч', style_table_header1)
        sheet.write_merge(4, 5, 14, 14, u'НД', style_table_header1)
        sheet.write_merge(3, 3, 15, 17, u'Олгох тэтгэмж', style_table_header1)
        sheet.write_merge(4, 5, 15, 15, u'Бүгд', style_table_header1)
        sheet.write_merge(4, 5, 16, 16, u'Ажил олгогчоос', style_table_header1)
        sheet.write_merge(4, 5, 17, 17, u'НД', style_table_header1)
        rowx = 6
        
        sick_ben = self.pool.get('sick.benefit')
        obj = self.browse(cr, uid, ids)[0]
        sick_id = sick_ben.search(cr, uid, [('date','>=',obj.start_date),('date','<=',obj.end_date)])
        
        i=1
        for line1 in sick_ben.browse(cr, uid, sick_id):
            if line1.hr_employee_id.company_id.id == obj.company_id.id:
                sheet.write(rowx, 0, u'%s' %i, style_table)
                i=i+1
                sheet.write(rowx, 1, u'%s' %line1.hr_employee_id.name, style_table)
                sheet.write(rowx, 2, u'%s' %line1.ndd, style_table)
                sheet.write(rowx, 3, u'%s' %line1.number, style_table)
                sheet.write(rowx, 4, u'%s' %line1.start_date, style_table)
                sheet.write(rowx, 5, u'%s' %line1.end_date, style_table)
                sheet.write(rowx, 6, u'%s' %line1.seniority, style_table)
                sum_amount = 0
                sum_day = 0
                for line2 in line1.sick_line_id:
                    sum_amount += line2.amount
                    sum_day += line2.day
                sheet.write(rowx, 7, u'%s' %sum_amount, style_table)
                sheet.write(rowx, 8, u'%s' %sum_day, style_table)
                sheet.write(rowx, 9, u'%s' %line1.day_work, style_table)
                sheet.write(rowx, 10, u'%s' %line1.percent, style_table)
                sheet.write(rowx, 11, u'%s' %line1.day_wages, style_table)
                sheet.write(rowx, 12, u'%s' %line1.total, style_table)
                sheet.write(rowx, 13, u'%s' %line1.employer, style_table)
                sheet.write(rowx, 14, u'%s' %line1.social_insurance, style_table)
                sheet.write(rowx, 15, u'%s' %line1.giving_total, style_table)
                sheet.write(rowx, 16, u'%s' %line1.employer_pay, style_table)
                sheet.write(rowx, 17, u'%s' %line1.social_insurance_pay, style_table)                                                                                                                                          
                rowx += 1
            
        inch = 1000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 3*inch
        sheet.col(2).width = 3*inch
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 3*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 3*inch
        rowx += 2
        
        sheet.write(rowx, 5, u'ГҮЙЦЭТНЭХ ЗАХИРАЛ:', ezxf('font: bold off;align:wrap off,vert centre;'))
        rowx += 2
        sheet.write(rowx, 5, u'ЦАЛИНГИЙН НЯ-БО:', ezxf('font: bold off;align:wrap off,vert centre;'))
        
        return {'data':book}

sick_benefit_report()