# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
import time
import re
from datetime import datetime
import openerp.netsvc
from openerp.tools.translate import _


class city_aimag(osv.osv):
	_name = 'city.aimag'
	_columns = {
		'name': fields.char(u'Name', size=64,required=True),
	}
city_aimag()

class district_sum(osv.osv):
	_name = 'district.sum'
	_columns = {
		'name': fields.char(u'Name', size=64,required=True),
		'city_id': fields.many2one('res.country.state',u'Which city and aimag', size=64,required=True),
		'is_district': fields.boolean(u'Is district?'),
	}
	_defaults = {
        'is_district': lambda *a: 1,
    }
district_sum()

class res_partner_category(osv.osv):
	_name="res.partner.type"
	_columns={
				'name': fields.char('Category Name', required=True, size=64, translate=True),
				'parent_id': fields.many2one('res.partner.type', 'Parent Category', select=True, ondelete='cascade'),
	            'category_type': fields.selection([
							            ('customer_type',u'Customer type'),
							            ('business_type',u'Business type')],u'Type'),
              }
	_defaults = {
    	'category_type':'customer_type', 
    }
res_partner_category()
	
######  New Debtor #################################################################
class debtor(osv.osv):
	_name="res.partner"
	_inherit="res.partner"
	_description="Debtor"
		
	_columns={
		'company_id':fields.many2one('res.company','Company'),

#		'name': fields.char(u'Loan name', size=128, required=True),
		'code':fields.char(u'Customer ID', size=16, readonly=True),
		'is_debtor':fields.boolean(u'Is debtor'),
		'is_trustee':fields.boolean(u'Is trustee'),
		'debtor_type': fields.many2one('res.partner.type',u'Customer type',domain=[('category_type','=','customer_type')]),
        'business_type': fields.many2one('res.partner.type',u'Business type',domain=[('category_type','=','business_type')]),
		
		'last_name': fields.char(u'Last name', size=128),
		'family_name': fields.char(u'Family name', size=128),
		'register_no': fields.char(u'Registration number', size=10),
		'password_no': fields.char(u'ID card number', size=9),
		'photo': fields.binary(u'Photo'),
		'district_sum': fields.many2one('district.sum', u'Sum, district'),
		'stamp': fields.binary(u'Stamp'),
		'signature': fields.binary(u'Signature'),
		'age': fields.integer(u'Age'),
		'sex': fields.selection([
                        ('male',u'Male'),
                        ('female',u'Female')], u'Gender'),
        #'birthdate': fields.date(u'Birth date'),
        'work_phone': fields.char(u'Work phone', size=20),
        'work_address': fields.text(u'Work address'),

		'stamp': fields.binary(u'Stamp'),
        'registration_no': fields.char('Registration number',size=32),
        'established_date': fields.date('Date of Enterprise registration'),
	}
	
	_defaults = {
		'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
        'code': lambda self, cr, uid, context: self.pool.get('ir.sequence').get(cr, uid, 'res.partner'),
        'active': lambda *a: 1,

    }
	
	_sql_constraints = [
        ('uniq_regn_no', 'unique (code,register_no)', u'Registration number must be unique!')
   ]
   	def onchange_register(self,cr,uid,ids,reg):
		war = {}
		val = {}
		
		match = re.search(u'[А-Я]{2}\d\d\d\d\d\d\d\d', reg)
		if len(reg) != 10:
			raise osv.except_osv(_(u'Warning!'), _(u'Wrong registration number(%s)'%(len(reg))))
			val['register_no'] = ''
		elif match:
			print 'match reg'
		else:
			raise osv.except_osv(_(u'Warning!'), _(u'Wrong registration number(Upper case or Mongolian letter)'))
			val['register_no'] = ''
		return {'value':val}
	
	def onchange_city_aimag(self,cr,uid,ids,city_a):
		domain = {'district_sum':[('city_id','=',city_a)]}
		val = {'district_sum':False,'street2':''}
		return {'domain':domain,'value':val}
	
	def onchange_password(self,cr,uid,ids,password):
		war = {}
		val = {}
		logger.notifyChannel("-----------DEBUG title", netsvc.LOG_DEBUG,password)
		if password == False:
			val['password_no'] = ''
		else:	
			match = re.search(u'[А-Я]{2}\d\d\d\d\d\d\d', password)
			if len(password) != 9:
				raise osv.except_osv(_(u'Warning!'), _(u'Wrong ID card number(%s)'%(len(password))))
				val['password_no'] = ''
			elif match:                      
				print 'match pass'
			else:
				raise osv.except_osv(_(u'Warning!'), _(u'Wrong ID card number(Upper case or Mongolian letter)'))
				val['password_no'] = ''
		return {'value':val}

debtor()

