# -*- coding: utf-8 -*-
import time
from datetime import datetime
from datetime import date
from dateutil.relativedelta import relativedelta

from openerp.osv import osv, fields
import openerp.netsvc
import openerp.pooler
from openerp.tools.translate import _
import openerp.addons.decimal_precision as dp

class loan_account_statement(osv.osv):
	_name="loan.account.statement"
	_description=u"Loan Account Statement"
	
	_columns={
		'contract_id':fields.many2one('loan.order',u'Loan contract'),
		'changed_date':fields.date('Date'),
		
		'name':fields.char('Transaction remark', size=128),
		'amount': fields.float('Disbursement', digits=(16,2)),
		'payment': fields.float('Repayment', digits=(16,2)),
		'debit_xx': fields.float('Debit', digits=(16,2)),
		'credit_xx': fields.float('Credit', digits=(16,2)),
		'interest': fields.float('Interest charge', digits=(16,2)),
		'loss': fields.float('Surcharge', digits=(16,2)),
		'risk': fields.float('Risk amount', digits=(16,2)),
		'company_id':fields.many2one('res.company','Company'),

	}
	_defaults = {
		'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
        'amount': 0,
        'changed_date': date.today().strftime('%Y-%m-%d'),
        'payment': 0,
        'debit_xx': 0,
        'credit_xx': 0,
        'interest': 0,
        'loss': 0,
        'risk': 0,
    }
loan_account_statement()

class loan_history(osv.osv):
	_name="loan.history"
	_description=u"Loan history"
	
	_columns={
		'contract_id':fields.many2one('loan.order',u'Contract number'),
		'name':fields.char(u'Description', size=128, required=True),
		'changed_date':fields.date('Date'),
	}
	
	_defaults = {
        'changed_date': date.today().strftime('%Y-%m-%d'),
    }
	
	def print_statement(self,cr,uid,ids,vals,context={}):  
		obj = self.browse(cr,uid,ids)[0]
		context['loan_id'] = obj.contract_id.id
		context['history_id'] = obj.id
		context['h_date'] = obj.write_date
		data = False
		return {
            'type'         : 'ir.actions.report.xml',
            'context':context,
            'report_name'   : 'loan.statement',
            'datas': {
                    'model':'loan.order',
                    'id': context.get('active_ids') and context.get('active_ids')[0] or False,
                    'ids': context.get('active_ids') and context.get('active_ids') or [],
                    'report_type': 'pdf',
                    'form':data,
                },
            'nodestroy': False
        }
		
loan_history()
