# -*- coding: utf-8 -*-
import time
from datetime import datetime
from datetime import date
from dateutil.relativedelta import relativedelta
from openerp.osv import osv, fields
import openerp.netsvc
import calendar
import openerp.pooler
from openerp.tools.translate import _
import openerp.addons.decimal_precision as dp
from openerp.tools import DEFAULT_SERVER_DATE_FORMAT, DEFAULT_SERVER_DATETIME_FORMAT
from lxml import etree
import simplejson

class loan_order(osv.osv):
          
    def _get_month_days(self,x):
        return {
            1:31, 2:28, 3:31, 4:30, 5:31, 6:30, 7:31, 8:31, 9:30, 10:31, 11:30, 12:31
        }.get(x)
    
    def _check_payment_day(self, cr, uid, ids, field_name, arg, context=None):
        res = {}
        today = fields.date.context_today(self,cr,uid,context=context)
        state = ''
        testdate = today[:7]
        dd = 0
        
        for obj in self.browse(cr, uid, ids):
            month = int(today[5:7])
            year = int(today[:4])
            days = 0
            if obj.end_of_month == True:
                days = str(self._get_month_days(month))
            else:
                days = str(obj.payment_day)
            if days < 10:
                days = '0'+days
            
            testdate = testdate +'-'+ days   
            graid = self.pool.get('loan.schedule').search(cr,uid,[('contract_id','=',obj.id)])
            if graid != []:
                gra = self.pool.get('loan.schedule').browse(cr,uid,graid[0])
                if gra.is_paid != 'un_paid':
                    state = 'normal'
                else:
                    dd = self._get_days(today,gra.payment_date,0)
                    if dd <= -3:
                        if gra.prior_id != 0:
                            pgra = self.pool.get('loan.schedule').browse(cr,uid,gra.prior_id)
                            if pgra.is_paid == 'un_paid':
                                state = 'danger'
                            else:
                                state = 'normal'
                        else:
                            state = 'normal'
                    else:
                        if -3 < dd and dd < 0:
                            if gra.prior_id != 0:
                                pgra = self.pool.get('loan.schedule').browse(cr,uid,gra.prior_id)
                                if pgra.is_paid == 'un_paid':
                                    state = 'danger'
                                else:
                                    state = 'warning'
                            else:
                                state = 'warning'
                        else:
                            state = 'danger'
            else:
                state = 'normal'
            res[obj.id] = state
            testdate = today[:7]
        return res

    _columns = {
        'ref_name':fields.char('Reference name',readonly=True),
        'coming_payment_day':fields.function(_check_payment_day,type='char',method=True,string=u'Coming payment day'),    
        'company_id':fields.many2one('res.company','Company'),
        'name': fields.char(u'Contract number', size=64, select=True,readonly=True),
        'product_id': fields.many2one('loan.product',u'Loan product', domain=[('loan_product_type','=','loan_product')],states={'cancel':[('readonly',True)],'payment':[('readonly',True)],'confirmed':[('readonly',True)],'paid':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)]},required=True),
        
        'period':fields.integer(u'Period',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]},required=True),
        'number_of_loans':fields.integer(u'Number of loans',states={'cancel':[('readonly',True)],'draft':[('readonly',True)],'confirmed':[('readonly',True)], 'payment':[('readonly',True)],'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        'total_percent': fields.float(u'Percent on loan amount',digits = (16,2),readonly=True,store=True),
        'installment_date': fields.date(u'Installment date',required=True,states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        'close_date': fields.date(u'Expire date',readonly=True),
        
        'payment_day':fields.integer('Date of montly repayment',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        'end_of_month': fields.boolean(u'End of month',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        
        'repayment_in_1st_month': fields.boolean(u'Repayment in 1st month?',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        
        'fixed_payment':fields.float('Fixed repayment amount',digits = (16,2),states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]},store=True),
        
        'loan_balance':fields.float(u'Loan balance',digits = (16,2),store=True,states={'cancel':[('readonly',True)],'payment':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        'loss_percent':fields.float(u'Loss percent',digits = (16,2),store=True,states={'cancel':[('readonly',True)],'payment':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]},
        required=True),
        
        'amount':fields.float(u'Loan amount',digits = (16,2),store=True,states={'cancel':[('readonly',True)],'payment':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]},required=True),
        'interest':fields.float(u'Loan interest',digits = (16,2),states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]},required=True),
        'decision':fields.char(u'Decision', size=128,states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}, help="Тушаал шийдвэр тогтоолын дугаар байна."),
        'late_day':fields.integer(u'Beyond days'),
        'loan_state': fields.selection([
                        ('d00','Normal'),
                        ('d90','Past due loans'),
                        ('d180','Abnormal loans'),
                        ('d360','Doubted loans'),
                        ('d361g','Bad loan')], u'Loan state',readonly=True,required=True),
        'issued_economist': fields.many2one('hr.employee','Initially confirmed by',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]},required=True),
        'current_economist': fields.many2one('hr.employee',u'Current economist',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]},required=True),
        'loan_purpose': fields.many2one('loan.purpose',u'Purpose',domain=[('parent_id','!=',False)],states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]},required=True),
        
        'is_custom_period': fields.boolean(u'Custom period',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        'is_custom_amount': fields.boolean(u'Custom amount',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        'is_custom_interest': fields.boolean(u'Custom interest',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        
        'collaterals': fields.one2many('loan.collateral','contract_id',u'Collaterals',
#                    states={'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}
        ),
        'negative_info': fields.one2many('negative.info','contract_id','Negative information'),
        'loan_history': fields.one2many('loan.account.statement','contract_id',u'Loan history', readonly=True),
        
        'schedules': fields.one2many('loan.schedule','contract_id',u'Graphics'),
        'schedule_type': fields.selection([('type1','Fixed repayment PMT'),('type3','Fixed loan repayment'), ('type5','Loan reapyment on last')],u'Graphic type',states={'confirmed':[('readonly',True)], 'approved':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]},required=True),
        
        'cash_journal': fields.many2one('account.journal',u'Cash journal',domain=[('type','=','cash')],states={'cancel':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        'bank_journal': fields.many2one('account.journal',u'Bank journal',domain=[('type','=','bank')],states={'cancel':[('readonly',True)],'payment':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        
        'payment_type': fields.selection([
                        ('cash','Cash'),
                        ('bank','Bank')], u'Payment type'),
        
        'date_order':fields.date('Order Date', required=True, states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)], 'payment':[('readonly',True)],'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}, select=True, help="Date on which this document has been created."),
        'date_approve':fields.date('Date Approved', readonly=1, select=True, help="Date on which purchase order has been approved"),
        'partner_id':fields.many2one('res.partner', 'Debtor', domain=[('is_debtor','=',True,)],required=True, states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}, change_default=True),
        'sponsor_id':fields.many2one('res.partner', 'Sponsor debtor',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        'partner_address':fields.char(u'Address', size=256,states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
        'state': fields.selection([
                ('draft', 'Request for Quotation'),
                ('confirmed', 'Waiting Approval'),
                ('approved', 'Approved'),
                ('payment', 'Wait Payment'),
                ('paid', 'Paid'),
                ('done', 'Closed'),
                ('cancel', 'Cancelled')
            ], 'States', track_visibility='onchange',readonly=True, help="Help...", select=True),
        'validator' : fields.many2one('res.users', 'Validated by', readonly=True),
        'request_history':fields.one2many('loan.request.history','contract_id','Loan request history',readonly=True),
        'notes': fields.text('Other',states={'cancel':[('readonly',True)],'confirmed':[('readonly',True)],'payment':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)],'paid':[('readonly',True)]}),
    }
    _defaults = {
        'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
        'date_order': fields.date.context_today,
        'installment_date':fields.date.context_today,
        'state': 'draft',
        'late_day': 0,
        'repayment_in_1st_month': False,
        'loss_percent': 0,
        'loan_state': lambda *a: 'd00',
        'payment_day': lambda *a: 25,
    }
    _sql_constraints = [
        ('name_uniq', 'unique(name)', 'Contract number must be unique!'),
    ]
    _name = "loan.order"
    _description = "Loan Order"
    _order = "name desc"



#   ---------------------------------MY----------------------------------------
    def onchange_schedule_type(self, cr, uid, ids, schtype,interest,amount,period,is_first,pay_day,installment_date,product_id):
        val = {}
        read_obj = self.pool.get('loan.product')
        objs = read_obj.browse(cr, uid, read_obj.search(cr, uid, [('id','=',product_id)]))
        start_year = int(installment_date[:4])
        start_month = int(installment_date[5:7])
        start_day = int(installment_date[8:])
        mxvv = 0
        if pay_day > start_day:
            sd = pay_day - start_day
        else:
            sd = self._get_months_days(start_year,start_month) - start_day + pay_day

        val['fixed_payment'] = 0
        if schtype=='type1':
            if interest <= 0:
                raise osv.except_osv(_('Warning'), _('Insert interest!'))    
            if amount <= 0:
                raise osv.except_osv(_('Warning'), _('Insert amount!'))    
            if period <= 0:
                raise osv.except_osv(_('Warning'), _('Insert period!'))
            for obj in objs:
                if is_first == True:
                    if obj.period_type == 'day':
                        c = (float(interest)/100.0)/30.0
                    else:
                        c = float(interest)/100.0
                    pmt = float(amount) /float(((1-(1/(1+(c))**float(period+1)))/(c)))

                else:
                    if obj.period_type == 'day':
                        c = (float(interest)/100.0)/30
                    else:
                        c = float(interest)/100.0
                    pmt = float(amount) /float(((1-(1/(1+(c))**float(period-1)))/(c)))
        
            val['fixed_payment'] = pmt
            
        return {'value':val}

    def onchange_partner_id(self, cr, uid, ids, partner_id):
        if not partner_id:
            print "tess"
            return {'value':{'partner_address': '','number_of_loans':''}}
        else:
            partner = self.pool.get('res.partner').browse(cr, uid, partner_id)
            for cat in partner.category_id:
                print "aaas",cat.name
            fre = self.pool.get('loan.order').search(cr,uid,[('state','!=','draft'),('partner_id','=',partner_id)])
            fre = len(fre)+1
            partner = self.pool.get('res.partner').browse(cr, uid, partner_id)
            address = unicode(partner.country_id.name or '') +', '+ unicode(partner.state_id.name or '') +', '+ unicode(partner.district_sum.name or '') +', '+ unicode(partner.street2 or '')
            return {'value':{'partner_address': address,'number_of_loans':fre}}

    def onchange_sponsor_id(self, cr, uid, ids, s_id,p_id):
        val = {}
        war = {}
        print p_id,'c----'
        if p_id:
            if p_id == s_id:
                war['message'] = 'Not yourself!'
                war['title'] = 'Warning!'
                val['sponsor_id'] = False
        else:
            war['message'] = 'Choose debtor!'
            war['title'] = 'Warning!'
            val['sponsor_id'] = False
            
        return {'value':val,'warning':war}

    def onchange_journal(self, cr, uid, ids,pt,jid,pid):
        war = {}
        val = {}
        journal = self.pool.get('account.journal').browse(cr,uid,jid)
        product = self.pool.get('loan.product').browse(cr,uid,pid)
        if journal.default_credit_account_id.currency_id.id != product.currency.id and journal.default_credit_account_id.currency_id.id != False:
            war['message'] = product.currency.name +u' тай '+pt+u' сонго'
            val['cash_journal'] = False
            val['bank_journal'] = False    
        else:
            val['account_balance'] = journal.default_credit_account_id.balance        
        return {'value':val,'warning':war}

    def onchange_loss(self, cr, uid, ids,interest,loss):
        war = {}
        val = {}
        if interest >= 0:
            if loss <= 20:
                val['loss_percent'] = loss
                return {'value':val}
            else:
                val['loss_percent'] = 0
                war['message'] = 'Loss percent must be less than 20%'
                return {'value':val,'warning':war}
        else:
            val['loss_percent'] = 0
            war['message'] = 'Insert interest.'
            return {'value':val,'warning':war}

    def calc_total_percent(self,cr,uid,ids,vals,context={}):  
        read_obj = self.read(cr,uid,ids)[0]
        colls = read_obj['collaterals']
        if colls != []:
            amount = read_obj['amount']
            total_p = 0.0
            for col in self.pool.get('loan.collateral').browse(cr,uid,colls):
                price = col.price
                per = amount*100/price
                self.pool.get('loan.collateral').write(cr,uid,col.id,{'percent':per})
                total_p += per
            print 'Total percent',self.pool.get('loan.order').write(cr,uid,read_obj['id'],{'total_percent':total_p})    
                
    def onchange_contract(self, cr, uid, ids,pid):
        val = {}
        hrid = self.pool.get('hr.employee').search(cr, uid, [('user_id','=',uid)])
        val['issued_economist'] = hrid
        return {'value':val}
    
    

    def onchange_eco(self, cr, uid, ids, eid):
        val = {}
        val['current_economist'] = eid
        return {'value':val}
    
    def setTimeDiff(self, cr, uid, ids, ti,lpr,tidiff):
        war = {}
        val = {}
        if tidiff == False:
            lpro = self.pool.get('loan.product').browse(cr, uid, lpr)
            tmin = lpro.min_period
            tmax = lpro.max_period
            if tmin > ti or ti > tmax:
                val['period'] = 0
                war['title'] = 'Invalid period\n'    
                war['message'] = 'Value must be from %d to %d '%(tmin,tmax)
                return {'value':val, 'warning':war}
        return {}        
        
    def setTotalDiff(self, cr, uid, ids, to,lpr,todiff):
        war = {}
        val = {}
        if todiff == False:
            lpro = self.pool.get('loan.product').browse(cr, uid, lpr)
            tmin = lpro.min_amount
            tmax = lpro.max_amount
            if tmin > to or to > tmax:
                val['amount'] = 0
                war['title'] = 'Invalid amount\n'    
                war['message'] = 'Value must be from %d to %d '%(tmin,tmax)
                return {'value':val, 'warning':war}
        return {}        

    def checkPaymentDay(self, cr, uid, ids, pday):
        war = {}
        val = {}    
        if pday > 31:
            val['payment_day'] = 25
            war['title'] = 'Invalid payment day\n'    
            war['message'] = 'Value must be from 1 to 28 '
            return {'value':val, 'warning':war}
        return {}            
        
    def setRateDiff(self, cr, uid, ids, ra,lpr,radiff):
        war = {}
        val = {}    
        if radiff == False:
            lpro = self.pool.get('loan.product').browse(cr, uid, lpr)
            tmin = lpro.min_interest
            tmax = lpro.max_interest
            if tmin > ra or ra > tmax:
                val['interest'] = 0
                war['title'] = 'Invalid interest\n'    
                war['message'] = 'Value must be from %d to %d '%(tmin,tmax)
                return {'value':val, 'warning':war}
        return {}            

    def checkTime(self, cr, uid, ids, ti,pid,tidiff):
        war = {}
        val = {}
        if pid != 0:
            if tidiff == False:
                pro = self.pool.get('loan.product').browse(cr, uid, pid)
                tmin = pro.min_period
                tmax = pro.max_period
        
                if tmin <= ti and ti <= tmax:
                    val['period'] = ti
                else:
                    val['period'] = 0
                    war['title'] = 'Invalid period'
                    war['message'] = 'Value must be from %d to %d '%(tmin,tmax)
                return {'value':val, 'warning':war}
            else:
                val['period'] = ti
                return {'value':val}        
        else:
            val['period'] = 0
            war['title'] = u'Choose loan product!'    
            war['message'] = 'Choose loan product!'        
            return {'value':val, 'warning':war}
    
    def checkTotal(self, cr, uid, ids, tot,pid,todiff):
        print 'args',tot,pid,todiff
        war = {}
        val = {}
        if pid != 0:
            if todiff == False:
                pro = self.pool.get('loan.product').browse(cr, uid, pid)
                tmin = pro.min_amount
                tmax = pro.max_amount
        
                if tmin <= tot and tot <= tmax:
                    val['amount'] = tot
                    val['loan_balance'] = tot
                else:
                    val['amount'] = 0
                    war['title'] = 'Invalid amount!'    
                    war['message'] = 'Value must be from %d to %d '%(tmin,tmax)
                return {'value':val, 'warning':war}
            else:
                val['amount'] = tot
                val['loan_balance'] = tot
                return {'value':val}    
        else:
            val['amount'] = 0
            war['title'] = 'Choose loan product'    
            war['message'] = 'Choose loan product!'        
            return {'value':val, 'warning':war}
    
    def checkRate(self, cr, uid, ids, ra,pid,radiff):
        war = {}
        val = {}
        if pid != 0:
            if radiff == False:
                pro = self.pool.get('loan.product').browse(cr, uid, pid)
                rmin = pro.min_interest
                rmax = pro.max_interest
        
                if rmin <= ra and ra <= rmax:
                    val['interest'] = ra
                    val['loss_percent'] = (float(ra)/100)*20
                else:
                    val['interest'] = 0
                    val['loss_percent'] = 0
                    war['title'] = 'Invalid interest!'    
                    war['message'] = 'Value must be from %d to %d '%(rmin,rmax)
        
                return {'value':val, 'warning':war}
            else:
                val['interest'] = ra
                val['loss_percent'] = (ra/100)*20
                return {'value':val}        
        else:
            val['interest'] = 0
            val['loss_percent'] = 0
            war['title'] = 'Choose loan product!'    
            war['message'] = 'Choose loan product!'        
            return {'value':val, 'warning':war}
    
    def _get_months_days(self,year,month):
        return calendar.monthrange(year, month)[1]

    def _calc_interest(self, begin, end, interest, period, ptype):  
        xvv = 0.0
        return xvv
    
    def calc_graphics(self,cr,uid,ids,vals,context={}):  
    
        read_obj = self.read(cr,uid,ids)[0]
        gids = read_obj['schedules']
        self.pool.get('loan.schedule').unlink(cr,uid,gids)
        print '______DONE____reset all graphics'
        
        product = self.browse(cr,uid,ids)[0].product_id
        period_type = product.period_type
        
        gtype = read_obj['schedule_type']
        t = read_obj['period']
        installment_date = read_obj['installment_date']
        xvv = read_obj['interest']
        pay_day = read_obj['payment_day']
        eom = read_obj['end_of_month']
        vzeel = read_obj['amount']
        custom = read_obj['fixed_payment']
        today = read_obj['date_order']
        pay_loan_payment = read_obj['repayment_in_1st_month']
        dddd = ''
        
        start_year = int(installment_date[:4])
        start_month = int(installment_date[5:7])
        start_day = int(installment_date[8:])
        
        gid = 0
        sd = 0
        mxvv = 0.0
        vld = 0.0

        
        
        if gtype == 'type1':
            if period_type == 'mounth':
                c = xvv/100
                a = 1+c
                b = 1/pow(a,t)
                d = (1-b)/c
                niit = vzeel/d
                niit = custom
                
                if eom == True:
                    pay_day = self._get_months_days(start_year,start_month)
                if pay_day != start_day or pay_day == start_day:
                    sd = 0
                    if pay_day > start_day:
                        sd = pay_day - start_day
                        print '----',sd
                    else:
                        sd = self._get_months_days(start_year,start_month) - start_day + pay_day
                        if start_month<12:
                            start_month += 1
                        else:
                            start_month=1
                            start_year += 1
                    if start_year/4==0:
                        if start_month==2 and pay_day==29:
                            pay_day=29
                        elif start_month==2 and pay_day==30:
                            pay_day=29
                        else:
                            pay_day=read_obj['payment_day']
                    else:
                        if start_month==2 and pay_day==29:
                            pay_day=28
                        elif start_month==2 and pay_day==30:
                            pay_day=28
    
                    mxvv = vzeel*c/30*sd
                    
                    vzt = 0
                    if pay_loan_payment == True:
                        
                        vzt = niit - mxvv
                        vld = vzeel - vzt
                        t -= 1
                    else:
                        vld = vzeel
                        t -= 1
                    to_pa = vzt+mxvv
                    dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,to_pa,vld,vzt,dddd,0)
                    start_day = pay_day
                else:
                    vld = vzeel 
                start_month += 1
                if start_year/4==0:
                    if start_month==2 and pay_day==29:
                        pay_day=29
                    elif start_month==2 and pay_day==30:
                        pay_day=29
                    else:
                        pay_day=read_obj['payment_day']
                else:
                    if start_month==2 and pay_day==29:
                        pay_day=28
                    elif start_month==2 and pay_day==30:
                        pay_day=28
                    else:
                        pay_day=read_obj['payment_day']
                for i in range(0,t):
                    if start_month > 12:
                        start_year += 1
                        start_month = 1
                        
                    prem = 0
                    prey = 0
                    if start_month == 1:
                        prem = 12
                        prey = start_year - 1
                    else:
                        prem = start_month-1
                        prey = start_year
                    
                    if eom == True:
                        pay_day = self._get_months_days(prey,prem)
                    d0 = date(prey, prem, start_day)
                    
                    if eom == True:
                        pay_day = self._get_months_days(start_year,start_month)
                        start_day = pay_day
                    else:
                        start_day = pay_day
                    d1 = date(start_year, start_month, pay_day)
                    
                    delta = d1 - d0
                    sd = delta.days - (start_day-pay_day)
                    
                    mxvv = vld*c/30*sd    
                    vz = niit-mxvv
                    vld0 = vld
                    vld -= vz
                    if i == t-1:
                        niit = mxvv + vld0
                        dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                        gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,0,vld0,dddd,gid)
                        break
                    
                    print start_year,start_month,pay_day,sd,'---',vz,' xvv=',mxvv,'niit',niit,'balance=',vld
                    dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,vld,vz,dddd,gid)
                    start_month += 1
            else:
                c = xvv/100
                a = 1+c
                b = 1/pow(a,t)
                d = (1-b)/c
                niit = vzeel/d
                niit = custom
                mxvv = 0.0
                pday = 0
                vzt = 0
                vld = vzeel

                if eom == True:
                    pay_day = self._get_months_days(start_year,start_month)
                if pay_day <= start_day:
                    pay_day = start_day
                else:
                    pay_day = start_day
                
                for days in range(1,t+1):
                    mxvv = vzeel*c/30
                    if start_month:
                        end_day = str(self._get_month_days(start_month))
                    if pay_day == end_day:
                        pay_day = 0
                        start_month +=1
                    else:
                        dddd = str(start_year)+'-'+str(start_month)+'-'+str(end_day)
                        ddddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                        pay_day +=1
                        if dddd == ddddd:
                                dddd = str(start_year)+'-'+str(start_month)+'-'+str(end_day)
                                pay_day = 1
                                start_month +=1
                        else:
                            if int(pay_day) > int(end_day):
                                dddd = str(start_year)+'-'+str(start_month)+'-'+str(end_day)
                                pay_day = 1
                                start_month +=1
                        if start_month > 12:
                            start_year +=1
                            start_month = 1
                        dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                        




                    if start_year/4==0:
                        if start_month==2 and pay_day==29:
                            pay_day=29
                        elif start_month==2 and pay_day==30:
                            pay_day=29
                        else:
                            pay_day=read_obj['payment_day']
                    else:
                        if start_month==2 and pay_day==29:
                            pay_day=28
                        elif start_month==2 and pay_day==30:
                            pay_day=28
                    vz = 0
                    if pay_loan_payment == True:
                        sd = 1
                        mxvv = vld*c/30*sd    
                        vz = niit-mxvv
                        vld0 = vld
                    else:
                        if days == 1:
                            sd = 1
                            mxvv = vld*c/30*sd
                            niit = mxvv
                        else:
                            sd = 1
                            mxvv = vld*c/30*sd
                            niit = custom
                            vz = niit-mxvv
                            
                    if vld < vz:
                        vz = vld
                        niit = vz+mxvv
                        vld -=vz
                        gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,vld,vz,dddd,gid)
                        break
                    vld -=vz
                    t -= 1
                #    dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,vld,vz,dddd,gid)
                    
                    
        
        if gtype == 'type3':
            if period_type == 'mounth':
                if custom == 0:
                    raise osv.except_osv(_('Warning!'), _('Insert pay amount!'))
                    return
            
                vz = custom
                c = xvv/100
    
                if pay_day != start_day or pay_day == start_day:
                    sd = 0
                    if pay_day > start_day:
                        sd = pay_day - start_day
                        print '----',sd
                    else:
                        sd = self._get_months_days(start_year,start_month) - start_day + pay_day
                        if start_month<12:
                            start_month += 1
                        else:
                            start_year += 1
                            start_month=1
                    if start_year/4==0:
                        if start_month==2 and pay_day==29:
                            pay_day=29
                        elif start_month==2 and pay_day==30:
                            pay_day=29
                        else:
                            pay_day=read_obj['payment_day']
                    else:
                        if start_month==2 and pay_day==29:
                            pay_day=28
                        elif start_month==2 and pay_day==30:
                            pay_day=28
                        else:
                            pay_day=read_obj['payment_day']
                    mxvv = vzeel*c/30*sd
                    
                    vzt = vz
                    if pay_loan_payment == True:
                          
                        niit = vzt + mxvv
                        vld = vzeel - vzt
                        t -= 1
                    else:
                        vld = vzeel
                        vzt = 0
                        t -= 1
                    print start_year,start_month,start_day,sd,'---','0',' xvv=',mxvv,'niit',mxvv,'balance=',vzeel
                    to_pa = vzt+mxvv
                    dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,to_pa,vld,vzt,dddd,0)
                    start_day = pay_day
                else:
                    vld = vzeel
                if start_month<12:
                    start_month += 1
                else:
                    start_month=1
                    start_year += 1
                if start_year/4==0:
                    if start_month==2 and pay_day==29:
                        pay_day=29
                    elif start_month==2 and pay_day==30:
                        pay_day=29
                    else:
                        pay_day=read_obj['payment_day']
                else:
                    if start_month==2 and pay_day==29:
                        pay_day=28
                    elif start_month==2 and pay_day==30:
                        pay_day=28
                    else:
                        pay_day=read_obj['payment_day']
                for i in range(0,t):
                    if start_month > 12:
                        start_year += 1
                        start_month = 1
                    
                    prem = 0
                    prey = 0
                    if start_month == 1:
                        prem = 12
                        prey = start_year - 1
                    else:
                        prem = start_month-1
                        prey = start_year
                    
                    print 'pre',prey,prem        
                    if eom == True:
                        pay_day = self._get_months_days(prey,prem)
                    d0 = date(prey, prem, pay_day)
                    if eom == True:
                        pay_day = self._get_months_days(start_year,start_month)
                        start_day = pay_day
                    d1 = date(start_year, start_month, pay_day)
                    delta = d1 - d0
                    sd = delta.days - (start_day-pay_day)
    
                    mxvv = vld*c/30*sd
                    niit = vz + mxvv
                    
                    print i,'=i'
                    if vld-vz <= 0:
                        if eom == True:
                            pay_day = self._get_months_days(start_year,start_month)
                            print sd,start_month,'------AAA-' 
                        else:
                            sd = self._get_months_days(start_year,start_month)-(start_day-pay_day)
                        mxvv = vld*c/30*sd
                        niit = vld + mxvv
                        dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                        gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,0,vld,dddd,gid)
                        break;
                    
                    if i == t-1:
                        niit = mxvv + vld
                        print "tesss",start_year,start_month,pay_day,sd,'---',vzeel,' xvv=',mxvv,'niit=',niit,'balance=',vld
                        dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                        gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,0,vld,dddd,gid)    
                        break
                        
                    vld -= vz
                    print "alddaaa",start_year,start_month,pay_day,sd,'---',vz,' xvv=',mxvv,'niit=',niit,'balance=',vld
                    dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,vld,vz,dddd,gid)
                    start_month += 1
            else:
                if custom == 0:
                    raise osv.except_osv(_('Warning!'), _('Insert pay amount!'))
                    return
            
                vz = custom
                c = xvv/100
                niit = 0.0
                vld = vzeel
                if pay_day <= start_day:
                    pay_day = start_day
                else:
                    pay_day = start_day
                for days in range(0,t-1):                    
                    mxvv = vzeel*c/30
                    if start_month:
                        end_day = str(self._get_month_days(start_month))
                    if pay_day == end_day:
                        pay_day = 0
                        start_month +=1
                    else:
                        dddd = str(start_year)+'-'+str(start_month)+'-'+str(end_day)
                        ddddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                        pay_day +=1
                        if dddd == ddddd:
                                dddd = str(start_year)+'-'+str(start_month)+'-'+str(end_day)
                                pay_day = 1
                                start_month +=1
                        else:
                            if int(pay_day) > int(end_day):
                                dddd = str(start_year)+'-'+str(start_month)+'-'+str(end_day)
                                pay_day = 1
                                start_month +=1
                        dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    if start_month > 12:
                        start_year +=1
                        start_month = 1
                    dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    if start_year/4==0:
                        if start_month==2 and pay_day==29:
                            pay_day=29
                        elif start_month==2 and pay_day==30:
                            pay_day=29
                        else:
                            pay_day=read_obj['payment_day']
                    else:
                        if start_month==2 and pay_day==29:
                            pay_day=28
                        elif start_month==2 and pay_day==30:
                            pay_day=28
                            
                    if pay_loan_payment == True:
                        sd = 1
                        mxvv = vld*c/30*sd    
                        niit = vz+mxvv
                        vld0 = vld
                    else:
                        if days==0:
                            sd = 1
                            mxvv = vld*c/30*sd    
                            niit = mxvv
                            vz = 0
                        else:
                            sd = 1
                            vz = custom
                            mxvv = vld*c/30*sd    
                            niit = vz+mxvv
                    if vld == 0.0:
                        break
                    else:
                        vld -=vz
                        t -= 1
                        gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,vld,vz,dddd,gid)
                if vld > vz:
                    pay_day +=1
                    vz = vld
                    mxvv = vld*c/30*sd
                    niit = vz + mxvv
                    vld -=vz
                    gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,vld,vz,dddd,gid)
                         


        if gtype == 'type5':
            if period_type == 'mounth':
                c = xvv/100
                if eom == True:
                    pay_day = self._get_months_days(start_year,start_month)
                if pay_day != start_day:
    
                    sd = 0
    
                    if pay_day > start_day:
                        sd = pay_day - start_day
                        print '----',sd
                    else:
                        print "pay_day",pay_day,start_day,start_month
                        sd = self._get_months_days(start_year,start_month) - start_day + pay_day
                       # start_month += 1
                    if start_year/4==0:
                        if start_month==2 and pay_day==29:
                            pay_day=29
                        elif start_month==2 and pay_day==30:
                            pay_day=29
                    else:
                        if start_month==2 and pay_day==29:
                            pay_day=28
                        elif start_month==2 and pay_day==30:
                            pay_day=28
    
    
                    print '+++++  +++t',t,mxvv,sd,pay_day
                    mxvv = vzeel*c/30*sd
                    
                    vzt = 0
                    if pay_loan_payment == True:
                        niit = vzt + mxvv
                        vld = vzeel - vzt
                        t -= 1
                    else:
                        vld = vzeel
                        vzt = 0
                        t -= 1
                    print '+++++  +++t',t,mxvv,sd
                    print start_year,start_month,start_day,sd,'---','0',' xvv=',mxvv,'niit',mxvv,'balance=',vzeel
                    to_pa = vzt+mxvv
                    dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,to_pa,vld,vzt,dddd,0)
                    start_day = pay_day
                else:
                    vld = vzeel
    
                    
                start_month += 1
                prem = 0
                prey = 0
                for i in range(1,t):
     
                    if start_month > 12:
                        start_year += 1
                        start_month = 1
                    
                    if start_month == 1:
                        prem = 12
                        prey = start_year - 1
                    else:
                        prem = start_month-1
                        prey = start_year
                    
                    print 'pre',prey,prem  
                    if eom == True:
                        pay_day = self._get_months_days(prey,prem)      
                    d0 = date(prey, prem, pay_day)
                    if eom == True:
                        pay_day = self._get_months_days(start_year,start_month)
                        start_day = pay_day
    
                    d1 = date(start_year, start_month, pay_day)
                    delta = d1 - d0
                    sd = delta.days - (start_day-pay_day)
                    one = 0
                    
                    start_day = pay_day
                    
                    mxvv = vzeel*c/30*sd
                    print start_year,start_month,pay_day,sd,'---  0 xvv=',mxvv,'balance=',vzeel
                    dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,mxvv,vzeel,0,dddd,gid)
                    start_month += 1    
                if start_year/4==0:
                    if start_month==2 and pay_day==29:
                        pay_day=29
                    elif start_month==2 and pay_day==30:
                        pay_day=29
                    else:
                        pay_day=read_obj['payment_day']
                else:
                    if start_month==2 and pay_day==29:
                        pay_day=28
                    elif start_month==2 and pay_day==30:
                        pay_day=28
                    else:
                        pay_day=read_obj['payment_day']
                    
                if start_month > 12:
                    start_year += 1
                    start_month = 1
                prem = 0
                if start_month == 1:
                    prem = 12
                    prey = start_year
                else:
                    prem = start_month - 1
                    prey = start_year
                    
                if eom == True:
                    pay_day = self._get_months_days(start_year,start_month)
                    
                    
                sd = self._get_months_days(prey,prem)    
                print start_year,start_month,pay_day,sd,'--- ',vzeel,'xvv=',mxvv,'balance=','0'
                dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                print 'last date',dddd,c,sd,vzeel
                mxvv = vzeel*c/30*sd
                niit = mxvv + vzeel
                gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,0,vzeel,dddd,gid)
                
            else:
            
                c = xvv/100
                niit = 0.0
                vld = vzeel
                vld0 = 0
                if pay_day <= start_day:
                    pay_day = start_day
                else:
                    pay_day = start_day
                for days in range(1,t):                    
                    mxvv = vzeel*c/30
                    if start_month:
                        end_day = str(self._get_month_days(start_month))
                    if pay_day == end_day:
                        pay_day = 0
                        start_month +=1
                    else:
                        dddd = str(start_year)+'-'+str(start_month)+'-'+str(end_day)
                        ddddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                        pay_day +=1
                        if dddd == ddddd:
                                dddd = str(start_year)+'-'+str(start_month)+'-'+str(end_day)
                                pay_day = 1
                                start_month +=1
                        else:
                            if int(pay_day) > int(end_day):
                                dddd = str(start_year)+'-'+str(start_month)+'-'+str(end_day)
                                pay_day = 1
                                start_month +=1
                        dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    if start_month > 12:
                        start_year +=1
                        start_month = 1
                    dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day)
                    if start_year/4==0:
                        if start_month==2 and pay_day==29:
                            pay_day=29
                        elif start_month==2 and pay_day==30:
                            pay_day=29
                        else:
                            pay_day=read_obj['payment_day']
                    else:
                        if start_month==2 and pay_day==29:
                            pay_day=28
                        elif start_month==2 and pay_day==30:
                            pay_day=28
                            
                    sd = 1
                    mxvv = vzeel*c/30*sd
                    niit = mxvv
                    gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,vzeel,0,dddd,gid)                       
                    t -= 1

                mxvv = vzeel*c/30*sd
                niit = mxvv + vzeel
                vzeel1 = vzeel
                vzeel1 -=vld
                dddd = str(start_year)+'-'+str(start_month)+'-'+str(pay_day+1)
                
                gid = self._create_graph(cr,uid,read_obj['id'],mxvv,sd,niit,vzeel1,vld,dddd,gid)
                    
        print 'Close date',self.write(cr,uid,ids,{'close_date':dddd
                                                  })
    
    def _create_graph(self,cr,uid,cg_id,xvv,md,to_pa,balance,ma_lo,pa_da,pr_id):
        gid = self.pool.get('loan.schedule').create(cr, uid, {
                    'contract_id':cg_id,
                    'interest_payment':xvv,
                    'days':md,
                    'total_payment':to_pa,
                    'balance':balance,
                    'loan_payment':ma_lo,
                    'payment_date':pa_da,
                    'prior_id':pr_id,
                    })
        return gid                
            
    def reset_graphics(self,cr,uid,ids,vals,context={}):  
        read_obj = self.read(cr,uid,ids)[0]
        gids = read_obj['schedules']
        self.pool.get('loan.schedule').unlink(cr,uid,gids)
        print '______DONE____reset all graphics'
    
    def print_graphics(self,cr,uid,ids,vals,context={}):  
        read_obj = self.read(cr,uid,ids)
        return {
                'type': 'ir.actions.report.xml',
                'context': context,
                'report_name': 'loan.schedule',
                'datas': {
                'model': 'loan.order',
                'id': context.get('active_ids') and context.get('active_ids')[0] or False,
                'ids': context.get('active_ids') and context.get('active_ids') or [],
                'report_type': 'pdf',
                'form': vals,
                },
                'nodestroy': False
            }

    def _get_days(self,now,last,m):
        last_year = int(last[:4])
        last_mounth = int(last[5:7])+m
        last_day = int(last[8:])    
        
        if last_mounth > 12:
            last_mounth = 1
            last_year += 1
        
        now_year = int(now[:4])
        now_mounth = int(now[5:7])
        now_day = int(now[8:])    
        
        d0 = date(last_year, last_mounth, last_day)
        d1 = date(now_year, now_mounth, now_day)
        delta = d1 - d0
        return delta.days

#   ---------------------------------ERP----------------------------------------
    def create(self, cr, uid, vals, context=None):
        if vals['amount'] <= 0:
            raise osv.except_osv(_('Invalid amount!'), _('Insert loan amount!'))
        if vals['period'] <= 0:
            raise osv.except_osv(_('Invalid period!'), _('Insert loan period!'))
        if vals['interest'] < 0:
            raise osv.except_osv(_('Invalid interest!'), _('Insert loan interest!'))
        if vals['loss_percent'] <= 0:
            raise osv.except_osv(_('Invalid loss percent!'), _('Insert loss percent!'))    
        return super(loan_order, self).create(cr, uid, vals, context=context)

    def unlink(self, cr, uid, ids, context=None):
        loan_orders = self.read(cr, uid, ids, ['state'], context=context)
        unlink_ids = []
        for s in loan_orders:
            if s['state'] in ['draft','cancel']:
                unlink_ids.append(s['id'])
            else:
                raise osv.except_osv(_('Invalid action !'), _('In order to delete a loan order, it must be cancelled first!'))
        return super(loan_order, self).unlink(cr, uid, unlink_ids, context=context)

    def action_order_cancel(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        self.write(cr, uid, ids, {'state': 'cancel'})
        req_history_obj = self.pool.get('loan.request.history')
        req_history_obj.create(cr, uid, {
                                         'name':u'%s зээлдэгч хүсэлт цуцлав.'%obj.partner_id.name,
                                         'date_id':obj.date_order,
                                         'request_loan_interest':obj.interest,
                                         'confirm_loan_amount':obj.amount,
                                         'period_id':obj.period,
                                         'company_id':obj.company_id.id,
                                         'contract_id':obj.id,
                                         })
        print 'Cancel-------------'
        return True

    def action_confirm_order(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        fre = self.pool.get('loan.order').search(cr,uid,[('state','!=','draft'),('partner_id','=',obj.partner_id.id)])
        fre = len(fre)+1

        for id in ids:
            if self.browse(cr, uid, [id])[0].amount <= 0:
                raise osv.except_osv(_('Warning!'), _('Insert loan amount!'))
            if self.browse(cr, uid, [id])[0].schedules == []:
                raise osv.except_osv(_('Warning!'), _('Зээлийн график үүсгэнэ үү!'))
            
            self.write(cr, uid, [id], {'state' : 'confirmed',
                                       'number_of_loans':fre,
                                       'name':self.pool.get('ir.sequence').get(cr, uid, 'loan.order')})
            req_history_obj = self.pool.get('loan.request.history')

            req_history_obj.create(cr, uid, {
                                             'name':u'%s зээлдэгч хүсэлт гаргав.'%obj.partner_id.name,
                                             'date_id':obj.date_order,
                                             'request_loan_interest':obj.interest,
                                             'confirm_loan_amount':obj.amount,
                                             'period_id':obj.period,
                                             'company_id':obj.company_id.id,
                                             'contract_id':obj.id,
                                             })
        return True

    def action_approve_order(self, cr, uid, ids, context=None):
        read_obj = self.read(cr,uid,ids)[0]
        date = read_obj['date_order']
        name = read_obj['name'][:2]
        code = read_obj['name'][12:]
        self.write(cr, uid, ids, {'state': 'approved', 
                                  'validator' : uid, 
                                  'ref_name':u'%s/%s%s'%(name,date,code),
                                  'date_approve': read_obj['date_order'],
                                  })
        req_history_obj = self.pool.get('loan.request.history')
        obj = self.browse(cr, uid, ids)[0]
        req_history_obj.create(cr, uid, {
                                         'name':u'%s зээлдэгчид зээл олгов.'%obj.partner_id.name,
                                         'date_id':obj.date_order,
                                         'request_loan_interest':obj.interest,
                                         'confirm_loan_amount':obj.amount,
                                         'period_id':obj.period,
                                         'company_id':obj.company_id.id,
                                         'contract_id':obj.id,
                                         })
        return True

    def action_payment_order(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'payment'})
        order = self.browse(cr,uid,ids)[0]
        period = self.pool.get('account.period')
        journal = 0
        cur_id = order.product_id.currency.id 
        if order.payment_type == 'cash':
            print '-------------Cashaar'
            journal = order.cash_journal
        else:
            print '-------------Bankaar'
            journal = order.bank_journal
                    
        print 'Payment-------------'
        if journal == [] or journal.id == False:
            raise osv.except_osv(_('Warning!'), _('Choose journal!'))
        res_currency_obj = self.pool.get('res.currency')
        res_users_obj = self.pool.get('res.users')

        company_currency_id = res_users_obj.browse(cr, uid, uid,context=context).company_id.currency_id.id
        
        currency_id = order.product_id.currency.id
        amount_currency = res_currency_obj.compute(cr,uid, currency_id,company_currency_id,order.amount, context=context)
        amount = 0.0
        if amount_currency == order.amount:
            amount_currency = 0.0
            amount = order.amount
        else:
            t = amount_currency
            amount_currency = order.amount
            amount = t
        am_id = 0.0
        period_id = period.search(cr, uid, [('date_start','<=',order.date_order),('date_stop','>=',order.date_order)])
        if period_id !=[]:
            am_id = self.pool.get('account.move').create(cr,uid, {
                                        'name':order.name,
                                        'journal_id':journal.id,
                                        'date':order.date_order,
                                        'period_id':period_id[0],
                                        'ref':order.name})
            if company_currency_id == currency_id:
                aml_one_one = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':order.partner_id.name + u'-т Зээл олгов.',
                                            'partner_id':order.partner_id.id,
                                            'account_id':journal.default_credit_account_id.id,
                                            'credit':amount,
                                            'date':order.date_order,
                                            'period_id':period_id[0],
                                            'move_id':am_id })
                                            
                aml_one_two = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':order.partner_id.name + u'-т Зээл олгов.',
                                            'partner_id':order.partner_id.id,
                                            'account_id':order.product_id.property_account_income.id,
                                            'debit':amount,
                                            'date':order.date_order,
                                            'period_id':period_id[0],
                                            'move_id':am_id })
            else:
                aml_one_one = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':order.partner_id.name + u'-т Зээл олгов.',
                                            'partner_id':order.partner_id.id,
                                            'account_id':journal.default_credit_account_id.id,
                                            'credit':amount,
                                            'date_created':order.date_order,
                                            'date':order.date_order,
                                            'period_id':period_id[0],
                                            'currency_id':currency_id,
                                            'amount_currency':amount_currency*(-1),
                                            'move_id':am_id })
                                            
                aml_one_two = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':order.partner_id.name + u'-т Зээл олгов.',
                                            'partner_id':order.partner_id.id,
                                            'account_id':order.product_id.property_account_income.id,
                                            'debit':amount,
                                            'date_created':order.date_order,
                                            'date':order.date_order,
                                            'period_id':period_id[0],
                                            'currency_id':currency_id,
                                            'amount_currency':amount_currency,
                                            'move_id':am_id })
        else:
            raise osv.except_osv(_('Warning!'), _('Дараа оны санхүүгийн жил үүсгэнэ үү!'))

                                    
            print 'Return AM',am_id
        amove = self.pool.get('account.move').browse(cr,uid,am_id)
        amove.button_validate()
        self.write(cr, uid, ids, {'state': 'paid'})
        
        sid = self.pool.get('loan.account.statement').create(cr,uid, {
                                    'contract_id':order.id,
                                    'name':order.partner_id.name+u'-т Зээл олгов.',
                                    'changed_date':order.date_order,
                                    'amount':order.amount})
        
        return am_id

    def _get_days(self,now,last,m):
        last_year = int(last[:4])
        last_mounth = int(last[5:7]) + m
        last_day = int(last[8:])    
        
        if last_mounth > 12:
            last_mounth = 1
            last_year += 1
        
        now_year = int(now[:4])
        now_mounth = int(now[5:7])
        now_day = int(now[8:])    
        
        d0 = date(last_year, last_mounth, last_day)
        d1 = date(now_year, now_mounth, now_day)
        print 'last',last_year, last_mounth, last_day,'now',now_year, now_mounth, now_day
        delta = d1 - d0
        return delta.days

    def action_change_loan_state(self, cr, uid, ids, context=None):
        print 'Change state-------------'
        lorder = self.browse(cr,uid,ids)[0]
        old_ls = lorder.loan_state
        new_ls = ''
        old_desc = ''
        new_desc = ''
        
        today = fields.date.context_today(self,cr,uid,context=context)
        
        last_date = ''
        last_date = lorder.close_date
        print 'lastdate',last_date
        print '-----day',self._get_days(today,last_date,0)        
        days = 0
        days = self._get_days(today,last_date,0)
        
        condition = ''
        
        if old_ls == 'd00':
            old_desc = u'Хэвийн'
            condition = 'product_id'
        elif old_ls == 'd90':
            old_desc = u'Хугацаа хэтэрсэн'
            condition = 'xxz_product'
        elif old_ls == 'd180':
            old_desc = u'Хэвийн бус'
            condition = 'xb_product'
        elif old_ls == 'd360':
            old_desc = u'Эргэлзээтэй зээл'
            condition = 'ez_product'
        elif old_ls == 'd361g':
            old_desc = u'Муу зээл'
            condition = 'mz_product'
        
        pro_id = ''
        cid = self.pool.get('configure.product').search(cr,uid,[(condition,'=',lorder.product_id.id)])
        if cid == []:
            raise osv.except_osv(_('Warning'), _('Not found configure!'))
             
        config = self.pool.get('configure.product').browse(cr,uid,cid[0])
        print '--------------c id',cid
        
        if days <= 0:
            print u'Хэвийн',days
            new_desc = u'Хэвийн'
            new_ls = 'd00'
            pro_id = config.product_id.id
        elif 90 >= days and days > 0:
            print u'Хугацаа хэтэрсэн',days
            new_desc = u'Хугацаа хэтэрсэн'
            new_ls = 'd90'
            pro_id = config.xxz_product.id
        elif 180 >= days and days > 90:
            print u'Хэвийн бус',days
            new_desc = u'Хэвийн бус'
            new_ls = 'd180'
            pro_id = config.xb_product.id
        elif 360 >= days and days > 180:
            print u'Эргэлзээтэй зээл',days
            new_desc = u'Эргэлзээтэй зээл'
            new_ls = 'd360'
            pro_id = config.ez_product.id
        elif days > 360:
            print u'Муу зээл',days
            new_desc = u'Муу зээл'
            new_ls = 'd361g'
            pro_id = config.mz_product.id

        print old_ls,new_ls,today,last_date,days 
        
        if days > 0:
            print 'Loan Late days',self.pool.get('loan.order').write(cr,uid,lorder.id,{'late_day':days})
               
        if old_ls != new_ls:
            lh = self.pool.get('loan.account.statement').create(cr,uid, {
                                        'contract_id':lorder.id,
                                        'changed_date':lorder.date_order,
                                        'name':u'Зээлийн ангилал шилжив: from "'+unicode(old_desc)+'" to "'+unicode(new_desc)+'"',
                                        })
            
            print 'changed obj created',self.pool.get('changed.loan.state.info').create(cr,uid,
                                                                        {'contract_id':lorder.id,
                                                                         'state_from':old_desc,
                                                                         'state_to':new_desc,})
            
            print 'Loan state update',self.pool.get('loan.order').write(cr,uid,lorder.id,
                                                                       {'loan_state':new_ls,
                                                                        'product_id':pro_id})
        else:
            print 'Nothing............ loan state'
        
        return True

    def print_all_statement(self,cr,uid,ids,vals,context={}):  
        obj = self.browse(cr,uid,ids)[0]
        print '_________all statement_____',obj.id
    
    def copy(self, cr, uid, id, default=None, context=None):
        if not default:
            default = {}
        default.update({
            'state':'draft',
            'name': self.pool.get('ir.sequence').get(cr, uid, 'loan.order'),
        })
        return super(loan_order, self).copy(cr, uid, id, default, context)

loan_order()

######  Collateral type #############################################################
class changed_loan_state_info(osv.osv):
    
    _name="changed.loan.state.info"
    _description="Changed State"
    _columns = { 
        'contract_id':fields.many2one('loan.order','Contract number'),
        'changed_date':fields.date('Date'),
        'state_from':fields.char('From state',size=32),
        'state_to':fields.char('To state',size=32),
        'risk_amount':fields.float('Risk amount',digits=(12,0)),
    }
changed_loan_state_info()

######  Loan Graphic #################################################################

class loan_schedule(osv.osv):
    _name="loan.schedule"
    _description=u"Loan schedule"
    _order="prior_id"
    
    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False, submenu=False):
        res = super(loan_schedule,self).fields_view_get(cr, uid, view_id, view_type, context, toolbar=toolbar, submenu=submenu)
        doc = etree.XML(res['arch'])
        nodes = doc.xpath("//button[@name='write']")
        for node in nodes:
            modifiers = {'invisible' : 1}
            node.set('modifiers', simplejson.dumps(modifiers))
        res['arch'] = etree.tostring(doc)
        return res
    
    def _get_grap_name(self, cr, uid, ids, field_name, arg, context=None):
        res = {}
        i = 1
        d = 0
        number = 0
        for record in self.browse(cr, uid, ids):
            number += 1
            if record.prior_id != 0:
                pid = self.browse(cr, uid, record.prior_id)
                while pid.id != 0:
                    pid = self.browse(cr, uid, pid.prior_id)
                    d = record.id - pid.id
                    if d >1:
                        d = 1
                    else:
                        d = record.id - pid.id
                        i += d
            else:
                pid = self.browse(cr, uid, record.id)
            gname = str(number)+'. '+str(record.payment_date)
            res[record.id] = gname
        
        return res

    def edit_graphics(self, cr, uid, ids, context=None):
        now = self.browse(cr,uid,ids)[0]
        con = now.contract_id
        print '--writed------',con.interest,ids[0]
        gtype = con.schedule_type
        rate = con.interest
        print 'GTYPE-',gtype
        
        if 0 <= now.loan_payment:
            pre_balance = con.loan_balance 
            if now.prior_id != 0:
                pre = self.pool.get('loan.schedule').browse(cr, uid, now.prior_id)
                pre_balance = pre.balance

            balance = pre_balance - now.loan_payment
            niit = now.loan_payment    + now.interest_payment
            print 'writed self',self.pool.get('loan.schedule').write(cr,uid,now.id,                             
                                                                    {'loan_payment':now.loan_payment,
                                                                     'total_payment':niit,
                                                                     'balance':balance},context)
            print 'gacha....',now.loan_payment,niit,balance
            
            nextid = self.pool.get('loan.schedule').search(cr, uid, [('prior_id', '=',now.id)])
            print 'next',nextid
            
            last = 0
            niit = 0.0
            
            while nextid != []:
                vz = 0.0
                balance = 0.0
                now = self.pool.get('loan.schedule').browse(cr, uid, nextid[0])
                pre = self.pool.get('loan.schedule').browse(cr, uid, now.prior_id)
                if last == 1:
                    print 'deleted other',self.pool.get('loan.schedule').unlink(cr,uid,now.id,context) 
                    break   
                else:
                    c = rate/100
                    xvv = pre.balance*c/30*now.days    
                    if gtype == 'type1':
                        vz = now.total_payment - xvv
                        balance = pre.balance - vz
                        if balance <= 0 :
                            niit = xvv + pre.balance
                            vz = pre.balance
                            balance = 0
                            print gtype,'1vz',vz,'xvv',xvv,'niit',now.total_payment,'balance',balance
                            print gtype,'1writed  - Balance',self.pool.get('loan.schedule').write(cr,uid,now.id, 
                                            {'loan_payment':vz,
                                             'interest_payment':xvv,
                                             'total_payment':niit,
                                             'balance':balance},context)    
                            last = 1
                        
                        nextid = self.pool.get('loan.schedule').search(cr, uid, [('prior_id', '=',now.id)])
                        if nextid == [] and balance > 0:
                            vz += balance
                            balance = 0
                            niit = xvv + vz
                            print gtype,'1writed other',self.pool.get('loan.schedule').write(cr,uid,now.id,
                                                        {'loan_payment':vz,
                                                         'interest_payment':xvv,
                                                         'total_payment':niit,
                                                         'balance':balance},context)
                                                         
                        print gtype,'1vz',vz,'xvv',xvv,'niit',now.total_payment,'balance',balance
                        print gtype,'1writed other',self.pool.get('loan.schedule').write(cr,uid,now.id,
                                                        {'loan_payment':vz,
                                                         'interest_payment':xvv,
                                                         'balance':balance},context)

                    if gtype == 'type3' or gtype == 'type5':                    
                        niit = now.loan_payment + xvv
                        balance = pre.balance - now.loan_payment
                        if balance <= 0 :
                            niit = xvv + pre.balance
                            vz = pre.balance
                            balance = 0
                            print gtype,'2vz',now.loan_payment,'xvv',xvv,'niit',niit,'balance',balance, "aaaaaaaaaaaaaaaaaaaaaadd"
                            print gtype,'2writed  - Balance',self.pool.get('loan.schedule').write(cr,uid,now.id, 
                                            {'loan_payment':vz,
                                             'interest_payment':xvv,
                                             'total_payment':niit,
                                             'balance':balance},context)    
                            last = 1
                        nextid = self.pool.get('loan.schedule').search(cr, uid, [('prior_id', '=',now.id)])
                        if nextid == [] and balance > 0:
                                                niit = xvv + pre.balance
                                                vz = pre.balance
                                                balance = 0
                        print now.total_payment,'2vz',vz,'xvv',xvv,'niit',now.total_payment,'balance',balance,"last",last
                        print gtype,'2writed other',self.pool.get('loan.schedule').write(cr,uid,now.id,
                                                        {'total_payment':niit,
                                                         'loan_payment':vz,
                                                         'interest_payment':xvv,
                                                         'balance':balance},context)
                    else:
                        print now.total_payment,'2vz',vz,'xvv',xvv,'niit',now.total_payment,'balance',balance,"last",last
                        print gtype,'2writed other',self.pool.get('loan.schedule').write(cr,uid,now.id,
                            {'total_payment':niit,
                             'interest_payment':xvv,
                             'balance':balance},context)
                #bichilt
                nextid = self.pool.get('loan.schedule').search(cr, uid, [('prior_id', '=',now.id)])
        else:
            print ''
        
    _columns={
        'append_id':fields.many2one('loan.append',u'Append number'),
        'contract_id':fields.many2one('loan.order',u'Contract number'),
        'name':fields.function(_get_grap_name,type='char',method=True,string=u'Graphic name'),
        'interest_payment':fields.float(u'Interest',digits = (16,2), required=True,readonly=True),
        'total_payment':fields.float(u'Total payment', digits = (16,2),required=True,readonly=True),
        'balance':fields.float(u'Balance',digits = (16,2),required=True,readonly=True),
        'loan_payment':fields.float(u'Loan',digits = (16,2), required=True),
        'payment_date': fields.date(u'Date', required=True),
        'days': fields.integer('Interest charged days', required=True,readonly=True),
        'prior_id': fields.integer(u'Prior ID'),
        'is_paid': fields.selection([('un_paid','Un paid'),
                                     ('pre_paid','Prepaid'),
                                     ('late_paid','Late paid'),
                                     ('paid','Normal paid'),
                                     ('under_paid','Underpaid'),
                                    ],u'Is paid'),
        'remaining_loan':fields.float('Difference', digits = (16,2),required=True,readonly=True),
        'remaining_loss':fields.float('Remaining Loss',readonly=True),
        'remaining_interest':fields.float('Remaning Interest',readonly=True),
        'remaining_acc_interest':fields.float('Remaining Acc Interest',readonly=True),
        'paid_date': fields.date('Paid date', readonly=True),
    }
    _order = "payment_date asc"
    _defaults={
        'remaining_loan': lambda *a: 0,
        'is_paid': 'un_paid',
    }
    
loan_schedule()


######  Collateral type #############################################################

class collateral_type(osv.osv):
    
    _name="collateral.type"
    _description="Collateral type"
    _columns = { 
        'code':fields.char(u'Code',size=30,required=True),
        'name':fields.char(u'Name',size=30,required=True),
        'parent_id':fields.many2one('collateral.type',u'Parent',domain=[('parent_id','=',False)]),
        'remarks':fields.text('Description'),
        'company_id':fields.many2one('res.company','Company',required=True),
    }
    _defaults = {
         'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
         }
collateral_type()

class loan_collateral(osv.osv):
    _name="loan.collateral"
    _description="Collateral"
    
    _columns={
        'contract_id':fields.many2one('loan.order',u'Contract number'),
        'certificate_no':fields.char(u'Certificate number', size=64, required=True),
        'bvrtgel_no':fields.char(u'Registration number', size=64, required=True),
        'remark':fields.char(u'Remark', size=128),
        'name_type':fields.many2one('collateral.type','Collateral name', domain=[('parent_id','!=',False)], required=True),
        'parent_type':fields.many2one('collateral.type','Collateral type',domain=[('parent_id','=',False)],required=True),
        'location':fields.char(u'Location', size=128, required=True),
        'count':fields.integer(u'Quantity',required=True),
        'currency': fields.many2one('res.currency',u'Currency', required=True),
        'price':fields.float(u'Valuation price',digits = (16,2),required=True),
        'max_price':fields.float(u'Max valuation',digits = (16,2),required=True),
        'price_date': fields.date(u'Date of valuation', required=True),
        'percent':fields.float(u'Percent',digits = (16,2)),
        'company_id':fields.many2one('res.company','Company',required=True),
    }
    _defaults = {
             'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
             }
    def onchange_type(self, cr, uid, ids,coll_type):
        val = {}
        print 'id',coll_type
        coll = self.pool.get('collateral.type').browse(cr,uid,coll_type)
        cpid = self.pool.get('collateral.type').search(cr,uid,[('id','=',coll.parent_id.id)])
        print cpid,'-----------------------'
        val['parent_type'] = cpid[0]
        return {'value':val}
    
loan_collateral()

class loan_request_history(osv.osv):
    _name = 'loan.request.history'
    
    _columns = {
                'company_id':fields.many2one('res.company','Company',),
                'name':fields.char('Loan request name',),
                'date_id':fields.date('Loan request date'),
                'request_loan_interest':fields.float('Loan request interest',digits = (16,2),),
                'confirm_loan_amount':fields.float('Loan confirm amount',digits = (16,2),),
                'period_id':fields.float('Loan period',digits = (16,2),),
                'contract_id':fields.many2one('loan.order','Loan contract',),
                }
    _defaults = {
                 'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
                 }

class negative_info(osv.osv):
    _name="negative.info"
    _description="Negative Information"
    _columns={
        'company_id':fields.many2one('res.company','Company',required=True),
        'contract_id':fields.many2one('loan.order',u'Contract number'),
        'explanation':fields.char('Remarks on conflicts', size=256, required=True),
        'police_date': fields.date('Date of claim'),
        'attorney_date': fields.date('Date of submitted to procuratorate'),
        'judge_date': fields.date('Date of submitted to judge office'),
        'decided_date': fields.date('Date of decision'),
        'total_invoice':fields.float('Claimed amount',digits = (16,2)),
        'currency': fields.many2one('res.currency',u'Currency', required=True),
        'payment':fields.float(u'Assigned repayment amount',digits = (16,2)),
        'state':fields.boolean('Fulfillment'),
        'other': fields.text(u'Other'),    
    }
    _defaults = {
        'state': lambda *a: 0,
        'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,

    }
    
negative_info()    

#===============================================================================
# class product_product(osv.osv):
#     _inherit = 'product.product'
#     
# 
#     
#     def name_get(self, cr, user, ids, context=None):
#         if context is None:
#             context = {}
#         if isinstance(ids, (int, long)):
#             ids = [ids]
#         if not len(ids):
#             return []
#         
#         def _name_get(d):
#             name = d.get('name','')
#             code = d.get('default_code',False)
#             categ = d.get('category')
#             if code:
#                 name = '[%s] %s - %s' % (code,name,categ)
#             if d.get('variants'):
#                 name = name + ' - %s' % (d['variants'],)
#             return (d['id'], name)
#         partner_id = context.get('partner_id', False)
#         result = []
#         cr.execute("""select pro.id, pro.name_template, pro.default_code, pro.variants, temp.categ_id  from product_product as pro \
#         left join product_template as temp on temp.id=pro.product_tmpl_id where loan_product_type='loan_product'""")
#         pro = cr.dictfetchall()
#         for product in self.browse(cr, user, ids, context=context):
#                 mydict = {
#                           'id': product.id,
#                           'name': product.name,
#                           'default_code': product.default_code,
#                           'variants': product.variants,
#                           'category':product.categ_id.name
#                           }
#                 result.append(_name_get(mydict))
#         return result
#         
# product_product()
#===============================================================================


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
