# -*- coding: utf-8 -*-

from datetime import datetime, timedelta
from datetime import date
from dateutil.relativedelta import relativedelta
import time
import openerp.pooler
from openerp.osv import fields, osv
from openerp.tools.translate import _
from openerp.tools import DEFAULT_SERVER_DATE_FORMAT, DEFAULT_SERVER_DATETIME_FORMAT, float_compare
import openerp.addons.decimal_precision as dp
import openerp.netsvc
import logging

class edit_mb_mb(osv.osv_memory):
    _name = "edit.mb.mb"
    
    _columns = {
    }
    
    def act_getfile(self, cr, uid, ids, context=None):
        st_line = self.pool.get('account.bank.statement.line')
        cr.execute('''
            select l.id from account_bank_statement_line as l 
            left join account_bank_statement ab on ab.id=l.statement_id
            where l.date < '2014-09-08' and ab.state = 'confirm' and l.is_imported_move_line=True
        ''')
        fetched = cr.fetchall()
        if fetched:
            fet = [x[0] for x in fetched]
            for line in st_line.browse(cr, uid, fet):
                print "line : " ,line.name, line.statement_id.name
                if line.cash_move_type:
                    if line.partner_id:
                        cr.execute("select id from account_move_line where account_id=%s and partner_id=%s and name='%s' and date='%s' order by id desc limit 1"\
                                   %(line.account_id.id, line.partner_id.id, line.name, line.date))
                        fetched=cr.fetchone()
                        if fetched:
                            cr.execute('''
                                update account_move_line set cash_move_type=%s where id=%s
                            '''%(line.cash_move_type.id,fetched[0]))
                    else:
                        cr.execute("select id from account_move_line where account_id=%s and name='%s' and date='%s' order by id desc limit 1"\
                                   %(line.account_id.id,line.name, line.date))
                        fetched=cr.fetchone()
                        if fetched:
                            cr.execute('''
                                update account_move_line set cash_move_type=%s where id=%s
                            '''%(line.cash_move_type.id,fetched[0]))
                    
                                 
        return True
    
class loan_payment(osv.osv):
    _name = "loan.payment"
    _description = "Loan payment"

    def copy(self, cr, uid, id, default=None, context=None):
        if not default:
            default = {}
        default.update({
            'state': 'draft',
            'date_confirm': False,
            'name': self.pool.get('ir.sequence').get(cr, uid, 'loan.payment'),
        })
        return super(loan_payment, self).copy(cr, uid, id, default, context=context)

    _columns = {
        'company_id':fields.many2one('res.company','Company'),

        'cash_journal': fields.many2one('account.journal',u'Cash journal',domain=[('type','=','cash')],states={'waitpayment':[('readonly',True)],'paid':[('readonly',True)]}),
        'bank_journal': fields.many2one('account.journal',u'Bank journal',domain=[('type','=','bank')],states={'waitpayment':[('readonly',True)],'paid':[('readonly',True)]}),
        
        'payment_type': fields.selection([
                        ('cash','Cash'),
                        ('bank','Bank')], u'Payment type',states={'paid':[('readonly',True)]}),
        
        'loan_order': fields.many2one('loan.order','Loan contract number',domain=[('state', '=','paid')],required=True,states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'product_id': fields.many2one('loan.product',u'Loan product', domain=[('loan_product_type','=','loan_product')],states={'payment':[('readonly',True)],'confirmed':[('readonly',True)],'paid':[('readonly',True)], 'approved':[('readonly',True)],'done':[('readonly',True)]}),
        're_payment':fields.float(u'Diffrence repayment',digits = (16,2),store=True,select=True,states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'is_accumlate':fields.boolean(u'Have a accumlate interest?'),
        'accumlated':fields.float(u'Accumlated',digits = (16,2)),
        
        'xt_payment':fields.float(u'Interest payment',digits = (16,2),states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'xxt_payment':fields.float(u'Accumlated interest payment',digits = (16,2),states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'loss_payment':fields.float('Surcharge payment',digits = (16,2),states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'vzt_payment':fields.float(u'Loan repayment',digits = (16,2),states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'balance':fields.float(u'Loan balance',digits = (16,2),states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        
        'now_payment_amount':fields.float(u'Currently repayment amount',digits = (16,2),required=True,states={'paid':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        're_payment_now_amount':fields.float(u'Diffrence repayment Now amount',digits = (16,2),required=True,states={'paid':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
                    
        're_payment':fields.float(u'Diffrence repayment',digits = (16,2),store=True,select=True,states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'graphic': fields.many2one('loan.schedule','Graphic',states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'grap_pay': fields.float('Repayment amount',digits = (16,2),states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'is_undue_loss': fields.boolean('Is surcharged',states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'dont_pay_interest': fields.boolean("Don't pay interest",states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]},help="Графикийн дагуу хүү тооцох \n-Сонгосон тохиолдолд үлдсэн зээлийн үлдэгдлээс хүү төлөхгүй графикийн огноо ашиглахгүй.\n-Сонгоогүй тохиолдолд хугацаа хэтэрсэн огноогоор хүү тооцно."),
        'undue_loss_type': fields.selection([
            ('current_payment', 'Current'),#Тухайн сарын төлбөрөөс
            ('not_payment', 'Not Payment'),#төлөгдөөгүй зээлийн нийт дүн
            ],'Undue loss calculate type'),
            
        'is_compute': fields.selection([
            ('incomplete', 'Incomplete'),
            ('additional', 'Additional'),
            ('normal', 'Normal')],'Is compute'),
            
        'name': fields.char('Loan payment number', size=64,readonly=True, select=True),
            
        'state': fields.selection([
            ('draft', 'Draft'),
            ('confirmed', 'Confirmed'),
            ('waitpayment', 'Waiting payment'),
            ('paid', 'Paid'),
            ('cancel', 'Cancelled')
            ], 'State', readonly=True, help=u"Тусламж", select=True),
            
        'date_order': fields.date('Date', required=True, readonly=True, select=True, states={'draft': [('readonly', False)]}),
        'create_date': fields.datetime('Creation Date', readonly=True, select=True, help="Date on which sales order is created."),
        'date_confirm': fields.date('Confirmed date', readonly=True, select=True, help="Date on which sales order is confirmed."),
        'test_date': fields.date('Test date'),
        'user_id': fields.many2one('res.users', 'User', states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
        'partner_id': fields.many2one('res.partner', 'Debtor', readonly=True, states={'draft': [('readonly', False)]}, required=True),
        'partner_address': fields.char(u'Address', size=256,states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),

        'note': fields.text('Other',states={'confirmed':[('readonly',True)],'waitpayment':[('readonly',True)], 'paid':[('readonly',True)]}),
    }
    _defaults = {
        're_payment_now_amount':0.0,
        'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
        'date_order': fields.date.context_today,
        'state': 'draft',
        'dont_pay_interest': False,
        'is_compute': 'normal',
        'is_accumlate': False,
        'accumlated': 0,
        'user_id': lambda obj, cr, uid, context: uid,
        'undue_loss_type':'current_payment'
    }
    _sql_constraints = [
        ('name_uniq', 'unique(name)', 'Loan payment number must be unique!'),
    ]
    _order = 'name desc'

# ------------------------------MY---------------------------
    def _get_days(self,now,last):
        last_year = int(last[:4])
        last_mounth = int(last[5:7])
        last_day = int(last[8:])    
        
        now_year = int(now[:4])
        now_mounth = int(now[5:7])
        now_day = int(now[8:])    
        
        d0 = date(last_year, last_mounth, last_day)
        d1 = date(now_year, now_mounth, now_day)
        delta = d1 - d0
        return delta.days

    def _date_inc_dec(self,dddd,d):
        day = int(dddd[8:])
        month = int(dddd[5:7])
        year = int(dddd[:4])
        dd = date(year,month,day)+timedelta(days=d)
        return dd
    def onchange_journal(self, cr, uid, ids,pt,jid,pid):
        war = {}
        val = {}
        journal = self.pool.get('account.journal').browse(cr,uid,jid)
        product = self.pool.get('loan.product').browse(cr,uid,pid)
        if journal.default_credit_account_id.currency_id.id != product.currency.id and journal.default_credit_account_id.currency_id.id != False:
            war['message'] = product.currency.name +unicode(u' тай ')+pt+unicode(u' сонго')
            val['cash_journal'] = False
            val['bank_journal'] = False    
        else:
            val['account_balance'] = journal.default_credit_account_id.balance
        return {'value':val,'warning':war}
    
    #######################################################
    #    Өмнөх төлөгдөөгүй зээлийн хуваарийн төлөөгдөөгүй
    #      төлбөрүүдийг  тооцоолох функц                  #
    #######################################################
    def calculate_before_payments(self, cr, uid, ids, graphic, lorder, payment_date):
        '''Зээлийн гарфик сонгох үед өмнөх сарын нэмэгдсэн 
            хүүгийн төлбөр болон үндсэн зээлийн төлбөрийн үлдэгдэлийг авна
        '''
        res={}
        loan_payment =0
        loss_payment = 0
        remaining_interest=0
        remaining_acc_interest=0
        cr.execute('''select id from loan_schedule 
                    where 
                     contract_id=%s and payment_date < '%s' and id <>%s order by payment_date desc'''%(lorder.id, payment_date, graphic.id))
        fetched = cr.fetchall()
        print "fetched : " , fetched
        if fetched:
            print [x[0] for x in fetched]
            for schedule in self.pool.get('loan.schedule').browse(cr,uid,[x[0] for x in fetched]):
                if schedule.is_paid =='under_paid':
                   loan_payment += (schedule.remaining_loan*-1)
                   loss_payment += (schedule.remaining_loss*-1)
                   remaining_interest += (schedule.remaining_interest*-1)
                   remaining_acc_interest += (schedule.remaining_acc_interest*-1)
                elif schedule.is_paid =='un_paid': 
                    loan_payment += schedule.loan_payment
                else:
                    break
        res['loan_payment'] = loan_payment
        res['loss_payment'] = loss_payment
        res['remaining_interest'] = remaining_interest
        res['remaining_acc_interest'] = remaining_acc_interest
        return res
    

    def calc_payment(self,cr,uid,ids,vals,context={}):  
            '''ТӨЛӨЛТИЙГ ТООЦООЛОХ ФУНКЦ
            '''
            read_obj = self.browse(cr,uid,ids)[0]
            grap = read_obj.graphic
            lorder = read_obj.loan_order
            pay_date = read_obj.date_order
            grap_pay = read_obj.grap_pay
            if grap.name == None:
                grap_date = read_obj.date_order
            else:
                grap_number = grap.name.split('.',1)[0]
                grap_date = grap.payment_date
            now_pay_date = pay_date
            calc_before_payment = self.calculate_before_payments(cr, uid, ids, grap, lorder, grap.payment_date)
            last_date = ''
            now_pay_date = str(self._date_inc_dec(now_pay_date,0))
            
            #1 НЭМЭГДҮҮЛСЭН ХҮҮГИЙ ТӨЛБӨР ТООЦООЛОЛ
            loss = 0.0
            loss = self.compute_loss(cr, uid, read_obj, now_pay_date)
                
            #2 ХҮҮГИЙН ТӨЛБӨР ТООЦООЛОЛ and ХУРИМТЛАГДСАН ХҮҮГИЙН ТӨЛБӨР ТООЦООЛОЛ
            balance = lorder.loan_balance
            interest_payment, total_acc_interest = self.compute_interest(cr, uid, read_obj, lorder)

            #4 ҮНДСЭН ЗЭЭЛИЙН ТӨЛБӨР ТООЦООЛОЛ
            loan_payment = grap.loan_payment
                
            if grap.is_paid == 'under_paid':
                loan_payment = grap.remaining_loan*-1
                
            if calc_before_payment.has_key('loan_payment'):
                loan_payment += calc_before_payment['loan_payment']
                
            if lorder.schedule_type =='type5' and grap.loan_payment > 0:
                loan_payment = lorder.loan_balance
                
            re_payment1 = calc_before_payment['loan_payment']+calc_before_payment['loss_payment']+calc_before_payment['remaining_interest']+calc_before_payment['remaining_acc_interest']
            re_payment1 = re_payment1*-1
            now_pay1 = loan_payment+interest_payment+total_acc_interest+loss
            vzt = 0.0
            xt1 = 0
            r_payment = 0.0
            
            if lorder.schedule_type in ('type1','type3'):
                schedule_id = self.pool.get('loan.schedule').search(cr, uid, [('is_paid','=','un_paid'),('contract_id','=',lorder.id),('payment_date','<=',pay_date)])
                if schedule_id !=[]:
                    for sch_line in self.pool.get('loan.schedule').browse(cr, uid, schedule_id):
                        vzt += sch_line.loan_payment
                else:
                    vzt = grap.loan_payment
            else:
                history_id = self.pool.get('loan.account.statement').search(cr, uid, [('contract_id','=',lorder.id),('changed_date','<',now_pay_date)],order='changed_date desc')
                pay_amount = 0
                give_amount = 0
                if history_id != []:
                    for line in self.pool.get('loan.account.statement').browse(cr, uid, history_id):
                        if line.payment != 0.0:
                            give_amount = line.amount
                            pay_amount += line.payment
                        vzt = give_amount - pay_amount
                    else:
                        vzt = grap.loan_payment
                else:
                    vzt = grap.loan_payment
                    
                    
            pre_gra = self.pool.get('loan.schedule').browse(cr,uid,grap.id)
            re_payment = pre_gra.remaining_loan
            now_pay = xt1+total_acc_interest+loss+vzt-r_payment
            if vzt < 0:
                vzt = 0
#             if check_zuruu:
#                 r_payment = -r_payment 

            # Өмнөх зээлийн төлөлтийг дутуу төлсөн дохиолдолд доорх нөхцөл шалгагдана.     #
            # Эндээс өмнөх зээлийн дутуу төлсөн нөхцөл эхэлж байна                         #
            prev_amount = 0
            prev_xxt = 0
            prev_loss = 0
            xt_pay = 0
            loan_payment_id = self.search(cr, uid, [('state','=','paid'),('loan_order','=',lorder.id),('re_payment','<',0.0)],order='date_order desc')
            if loan_payment_id !=[]:
                loan_pay = self.browse(cr, uid, loan_payment_id)[0]
                if loan_pay.now_payment_amount < loan_pay.loss_payment:
                    prev_loss = loan_pay.grap_pay-loan_pay.now_payment_amount
                    loss = prev_loss+loss
                    xt1 = xt1+loan_pay.xt_payment
                    total_acc_interest = total_acc_interest+loan_pay.xxt_payment
                    vzt = vzt+loan_pay.vzt_payment
                    now_pay = loss+total_acc_interest+xt1+vzt
                if loan_pay.now_payment_amount < loan_pay.xxt_payment:
                    prev_xxt = loan_pay.grap_pay-loan_pay.now_payment_amount
                    total_acc_interest = total_acc_interest+prev_xxt
                    vzt = vzt+loan_pay.vzt_payment
                    xt1 = xt1+loan_pay.xt_payment
                    now_pay = total_acc_interest+xt1+vzt+loss
                if loan_pay.now_payment_amount<loan_pay.xt_payment:
                    xt_pay = loan_pay.grap_pay-loan_pay.now_payment_amount
                    vzt = vzt+loan_pay.vzt_payment
                    xt1 = xt1+xt_pay
                    now_pay = xt1+vzt+total_acc_interest+loss
                if loan_pay.now_payment_amount < loan_pay.vzt_payment:
                    prev_amount = loan_pay.grap_pay-loan_pay.now_payment_amount
                    vzt = vzt+prev_amount
                    now_pay = vzt+xt1+total_acc_interest+loss
            # Энд өмнөх зээл төлөлт дутуу төлсөн нөхцөл дуусч байна.                         #
          #  balance -= vzt
            values = {}
            values['loss_payment'] = loss
            values['xt_payment'] = interest_payment
            values['xxt_payment'] = total_acc_interest
            values['vzt_payment'] = loan_payment
            values['grap_pay'] = now_pay1
            values['re_payment'] = re_payment1
            balance = balance-loan_payment
            values['balance'] = balance
            self.write(cr,uid,ids,values)
            return True

    def _get_last_date(self,cr,uid,lid):
        loan = self.pool.get('loan.order').browse(cr,uid,lid)
        xtid = self.pool.get('loan.payment').search(cr,uid,[('state','=','paid'),('loan_order','=',lid),('xt_payment','>',0.0)],order='id')
        xxtid = self.pool.get('loan.xxt.payment').search(cr, uid, [('loan_order', '=',lid),('state','!=','draft'),('parent_id','<>',False)],order='id')
        print '--',xtid,xxtid
        xxtid1 = []
        if xxtid:
            for xxt in self.pool.get('loan.xxt.payment').browse(cr, uid, xxtid):
                if xxt.xxt_payment > 0.0 or xxt.pre_xxt_payment > 0:
                    xxtid1.append(xxt.id)
        xxtid=xxtid1
        last_date = ''
        if xtid == [] and xxtid == []: 
            last_date = loan.date_approve
            last_date = str(self._date_inc_dec(last_date,0))
            print 'First XXT--',last_date
        elif xtid != [] and xxtid == []:
            xt = self.pool.get('loan.payment').browse(cr,uid,xtid[len(xtid)-1])
            last_dates = xt.test_date
            last_date = str(self._date_inc_dec(last_dates,0))
            print 'tulult xiisen XT--',last_date
        elif xtid == [] and xxtid != []:
            xxt = self.pool.get('loan.xxt.payment').browse(cr,uid,xxtid[len(xxtid)-1])
            print "loggggg",xxt.test_date
            last_dates = xxt.test_date
            last_date = str(self._date_inc_dec(last_dates,0))
            print 'xurimtluulsan XXT--',last_date
        elif xtid != [] and xxtid != []:
            xt = self.pool.get('loan.payment').browse(cr,uid,xtid[len(xtid)-1])    
            xxt = self.pool.get('loan.xxt.payment').browse(cr,uid,xxtid[len(xxtid)-1])    
            print '--------',xt.test_date,xxt.test_date
            if xt.test_date <= xxt.test_date:
                last_date = xxt.test_date
            else:
                last_date = xt.test_date
            print 'xt<xxt XXT--',xt.test_date,xxt.test_date
        return last_date
    
    def onchange_graphic(self, cr, uid, ids, gid,loid,now_pay_date):
        val = {}
        war = {}
        gra = self.pool.get('loan.schedule').browse(cr,uid,gid)
        lorder = self.pool.get('loan.order').browse(cr,uid,loid)
        loss = 0 
    
        if lorder.loan_balance > 0:
        
            xxt_ids = self.pool.get('loan.xxt.payment').search(cr,uid,[('state','in',['confirmed','posted']),('loan_order','=',lorder.id)],order='id')
            total_xxt = 0.0
            xt1 = 0
            for xxt in self.pool.get('loan.xxt.payment').browse(cr,uid,xxt_ids):
                if xxt.test_date > now_pay_date:
                    raise osv.except_osv((u'Анхааруулга!'), (u"Хүү хуримтлуулсан өдрөөс өмнөх төлөлт хийх боломжгүй тул та \
                                                                хүү хуримтлуулсан өдөр болон тухайн өдрөөс хойших өдрийг сонгоно уу!"
                                                                ))
#                 total_xxt += xxt.xxt_payment
#             if gra.is_paid == 'paid':
#                 if gra.remaining_payment < 0:
#                     last_date = self._get_last_date(cr,uid,lorder.id)
#                     now_pay_date = str(self._date_inc_dec(now_pay_date,-1))
#                     sd = self._get_days(now_pay_date,last_date)
#                     rate = lorder.interest
#                     c = rate/100
#                     xt = lorder.loan_balance*c/30*sd
#                     xt = round(xt, 2)
#                     if total_xxt > 0:
#                         xt1 = xt -total_xxt
#                     else:
#                         xt1 = xt
#                     print '--dutuug tulux--',xt,sd,gra.remaining_payment
#                     blc = lorder.loan_balance + gra.remaining_payment
#                     return {'value':{'vzt_payment':(-1)*gra.remaining_payment,
#                                      'balance':blc,
#                                      'is_compute':'incomplete',
#                                      'grap_pay':(-1)*gra.remaining_payment + xt + total_xxt,
#                                      'xxt_payment':total_xxt,
#                                      'xt_payment':xt},
# #                            'warning':{'message':str(sd)+' '+now_pay_date+','+xt_obj.date_order},
#                            }
#                 else:
#                     last_date = self._get_last_date(cr,uid,lorder.id)
#                     print 'additional last_date',last_date
#                     now_pay_date = str(self._date_inc_dec(now_pay_date,0))
#                     sd = self._get_days(now_pay_date,last_date)
#                     balance = lorder.loan_balance
#                     rate = lorder.interest
#                     c = rate/100
#                     xt = balance*c/30*sd
#                     xt = round(xt, 2)
#                     if total_xxt >0:
#                         xt1 = xt-total_xxt
#                     else:
#                         xt1 = xt
#                     print sd,xt
#                     
#                     return {'value':{'grap_pay':xt + total_xxt,
#                                      'xt_payment':xt,
#                                      'xxt_payment':total_xxt,
#                                      'is_compute':'additional',
#                                     },
#                             }
# 
#             
#             if gra.prior_id == 0:
#                 last_date = self._get_last_date(cr,uid,lorder.id)
#                 now_pay_date = str(self._date_inc_dec(now_pay_date,0))
#                 sd = self._get_days(now_pay_date,last_date)
#                 print 'dates-',now_pay_date,last_date
#                 balance = lorder.loan_balance
#                 loss_per = lorder.loss_percent
#                 p_day = last_date[8:10]
#                 e_day = now_pay_date[8:10]
#                 dd =0 
#                 if e_day > p_day:
#                     dd = int(e_day) - int(p_day)
#                 rate = lorder.interest
#                 c = rate/100
#                 xt = balance*c/30*sd
#                 xt = round(xt, 2)
#                 if total_xxt >0.0:
#                     xt1 = xt - total_xxt
#                 else:
#                     xt1 = xt
#                 val['grap_pay'] = gra.loan_payment + total_xxt + xt1
#                 print 'First grap sd',sd,xt,total_xxt,gra.loan_payment,
#             else:
#                 last_date = self._get_last_date(cr,uid,lorder.id)
#                 now_pay_date = str(self._date_inc_dec(now_pay_date,0))
#                 print 'dates-',now_pay_date,last_date
#                 sd = self._get_days(now_pay_date,last_date)
#                 p_day = last_date[8:10]
#                 e_day = now_pay_date[8:10]
#                 dd =0 
#                 if e_day > p_day:
#                     dd = int(e_day) - int(p_day)
#                 balance = lorder.loan_balance
#                 rate = lorder.interest
#                 loss_per = lorder.loss_percent/100
#                 c = rate/100
#                 xt = balance*c/30*sd
#                 xt = round(xt, 2)
#                 if total_xxt >0:
#                     xt1 = xt-total_xxt
#                 else:
#                     xt1 = xt
#                 last = 0
#                 lastgid = self.pool.get('loan.schedule').search(cr,uid,[('contract_id','=',lorder.id),('prior_id','=',gra.id)])
#                 if lastgid == []:
#                     last = balance
#                 
#                 print 'LAST--------',last
#                 pre_gra = self.pool.get('loan.schedule').browse(cr,uid,gra.prior_id)
#                 
#                 lpayment = 0.0
#                 if balance > gra.balance:
#                     lpayment = balance - gra.balance
#                 else:
#                     lpayment = 0
#                 
#                 val['grap_pay'] = lpayment + total_xxt + xt1
#                 
#                 print 'Remaining payment',pre_gra.remaining_payment
#                 print 'sd',sd,'xt',xt
#                 print 'gra loan pay',gra.loan_payment,'total xxt',total_xxt
#                 print 'Grap balance',gra.balance,balance
#                 print 'vzt',lpayment,'grap pay',val['grap_pay']
#                 
#             print 'Now date',now_pay_date
#             return {'value':val}
#         else:
#             war['title'] = 'Warning!'
#             war['message'] = 'Loan paid, balance is 0.0'
#             val['graphic'] = False
            return  True#{'value':val,'warning':war}

    def _get_month_days(self,x):
        return {
            1:31, 2:28, 3:31, 4:30, 5:31, 6:30, 7:31, 8:31, 9:30, 10:31, 11:30, 12:31
        }.get(x)

    def onchange_loan_order(self, cr, uid, ids, lid,pay_date):
        val = {}
        if lid == '' or lid == False:
            return True
        else:
            lorder = self.pool.get('loan.order').browse(cr,uid,lid)
            gras = lorder.schedules
            if gras == []:
                raise osv.except_osv(_('Warning!'), _(lorder.name+' - must create graphics!'))
                return
        
        val['partner_id'] = lorder.partner_id.id
        val['product_id'] = lorder.product_id.id

        testdate = pay_date[:7]
        year = int(pay_date[:4])
        month = int(pay_date[5:7])
        last_date = self._get_last_date(cr,uid,lorder.id)
        now_pay_date = str(self._date_inc_dec(pay_date,0))
        sd = self._get_days(now_pay_date,last_date)
        dd = self._get_days(pay_date,last_date)
        balance = lorder.loan_balance
        days = 0
        domain = []
        print "test last",sd,last_date,dd
        if lorder.end_of_month == True:
            days = str(self._get_month_days(month))
        else:
            days = str(lorder.payment_day)
        if days < 10:
            days = '0'+days
        balanced = 0
        grap = 0
        loss = 0
        pay_amount = 0
        if lorder.product_id.period_type == 'day':
            graid = self.pool.get('loan.schedule').search(cr,uid,[('contract_id','=',lid),('is_paid','!=','paid'),('payment_date','=',now_pay_date)])
        else:
            paid = self.pool.get('loan.account.statement').search(cr, uid, [('interest','=',0.0),('payment','>',0.0),('contract_id','=',lid)])
            if paid !=[]:
                paid_obj = self.pool.get('loan.account.statement').browse(cr, uid, paid)
                for pa in paid_obj:
                    if pa.changed_date <= now_pay_date:
                        graid = self.pool.get('loan.schedule').search(cr,uid,[('contract_id','=',lid),('is_paid','=','paid')])
                        pay_amount = pa.payment
                    else:
                        pay_amount = pa.payment
                        graid = self.pool.get('loan.schedule').search(cr,uid,[('contract_id','=',lid),('is_paid','!=','paid')])
            else:
                graid = self.pool.get('loan.schedule').search(cr,uid,[('contract_id','=',lid),('is_paid','!=','paid')])
        if graid == []:
            rate = lorder.interest
            c = rate/100
            xt = balance*c/30*dd
            xt = round(xt, 2)
            balanced = balance+xt
            grap = []
            domain = []
        else:
            gra = self.pool.get('loan.schedule').browse(cr, uid, graid)
            for gr in gra:
                if gr.interest_payment == 0.0:
                    if dd > 0.0:
                        p_day = gr.payment_date[8:10]
                        e_day = now_pay_date[8:10]
                        rate = lorder.interest
                        c = rate/100
                        xt = balance*c/30*dd
                        xt = round(xt, 2)
                        balanced = xt
                        domain = []
                else:
                    if gr.payment_date[:7] == now_pay_date[:7]:
                        if gr.payment_date == now_pay_date:
                            grap = gr.id
                            domain = []
                        else:
                            grap = gr.id
                            domain = []
                    else:
                        if dd > 0.0:
                            rate = lorder.interest
                            c = rate/100
                            xt = (balance)*c/30*dd
                            xt = round(xt, 2)
                            balanced = xt
                            domain = []
                        else:
                            p_day = gr.payment_date
                            e_day = now_pay_date
                            day = self._get_days(e_day,p_day)
                            rate = lorder.interest
                            c = rate/100
                            xt = (balance+pay_amount)*c/30*day
                            xt = round(xt, 2)
                            balanced = xt
                            domain = []
        val['grap_pay'] = balanced
        val['graphic'] = grap
        val['loss_payment'] = loss
        return {'value':val,'domain':domain}
    
    def onchange_now_payment(self, cr, uid, ids, now_payment_amount, grap_pay):
        values = {}
        zuruu=0
        if now_payment_amount and grap_pay:
            zuruu = now_payment_amount - grap_pay
#         values['re_payment_now_amount'] = zuruu
#         self.write(cr,uid,ids,values)
        return {'value':{'re_payment_now_amount': zuruu}}
        
    def action_cancel(self, cr, uid, ids, context=None):
        '''Зээл төлөлт ноорог болон батлагдсан төлөвтэй үед цуцлах
        '''
        self.write(cr, uid, ids, {'state': 'draft'})
        print 'Cancel-------------'
        return True

    def action_draft(self, cr, uid, ids, context=None):
        '''Зээл төлөлтийг төлөгдсөн үед цуцлах
        '''
        obj = self.browse(cr, uid, ids)[0]
        
        move_obj = self.pool.get('account.move')
        loan_obj = self.pool.get('loan.order')
        history_obj = self.pool.get('loan.account.statement')
        xxt_obj = self.pool.get('loan.xxt.payment')
        payment_obj = self.pool.get('loan.payment')
        schedule_obj = self.pool.get('loan.schedule')
        
        #САНХҮҮГИЙН БИЧИЛТ ЦУЦЛАНА
        move_id = move_obj.search(cr, uid, [('payment_id','=',obj.id)])
        if move_id == []:
            move_id = move_obj.search(cr, uid, [('name','=',obj.name),('ref','=',obj.loan_order.name),('date','=',obj.date_order)])
            move_obj.write(cr, uid, move_id,{'state':'draft'})
            move_obj.unlink(cr, uid, move_id)
        else:
            move_obj.write(cr, uid, move_id,{'state':'draft'})
            move_obj.unlink(cr, uid, move_id)
        
        #ЗЭЭЛИЙН ГЭРЭЭ НЬ ДЭЭР ЗЭЭЛИЙН ҮЛДЭГДЭЛИЙГ ШИНЭЧЛЭХ
        loan_id=loan_obj.search(cr, uid, [('id','=',obj.loan_order.id)])
        loan = loan_obj.browse(cr, uid, loan_id)[0]
#         if loan.state == 'done':
#             loan_obj.write(cr,uid, loan_id,{'loan_balance':loan_balance,
#                                             'state':'paid'})
#         if obj.vzt_payment > 0.0:
#             loan_balance = loan.loan_balance+obj.vzt_payment
#             loan_obj.write(cr,uid, loan_id,{'loan_balance':loan_balance,
#                                             'state':'paid'})
        loan_balance = 0
        if obj.graphic.is_paid == 'paid' or obj.graphic.is_paid == 'late_paid' or obj.graphic.is_paid == 'pre_paid':
            loan_balance = loan.loan_balance
            remove_ids = history_obj.search(cr, uid, [('contract_id','=',loan_id),('loan_payment_id','=',ids[0])])
            if remove_ids:
                for his in history_obj.browse(cr, uid, remove_ids):
                    loan_balance += his.payment
            loan_obj.write(cr,uid, loan_id,{'loan_balance':loan_balance,
                                            'state':'paid'})
        elif obj.graphic.is_paid == 'under_paid':
            print fd
            loan_balance = loan.loan_balance+(obj.vzt_payment - (obj.graphic.remaining_loan*-1))
            loan_obj.write(cr,uid, loan_id,{'loan_balance':loan_balance,
                                            'state':'paid'})
            
        hist_id = history_obj.search(cr, uid, [('contract_id','=',loan_id),('changed_date','>',obj.date_order),('amount','=',0.0)])
        history_id=[]
        if len(hist_id) > 1:
            for h in history_obj.browse(cr, uid,hist_id):
                if h.debit_xx == 0:
                    raise osv.except_osv((u'Анхааруулга !'),(u'Та энэ зээлийн даараачийн төлөлтүүдийг цуцлана уу !'))
                else:
                    raise osv.except_osv((u'Анхааруулга !'),(u'Та энэ зээлийн төлөлтөөс хойш хийгдсэн хуримтлагдсан хүүг цуцлана уу !'))
        else:
            remove_ids = history_obj.search(cr, uid, [('contract_id','=',loan_id),('loan_payment_id','=',ids[0])])
            if remove_ids:
                history_obj.unlink(cr, uid, remove_ids, context=context)
#             if obj.xt_payment > 0.0 and obj.vzt_payment > 0.0 and obj.loss_payment and obj.xxt_payment >0.0:
#                 history_id = history_obj.search(cr, uid, [('contract_id','=',loan_id),('changed_date','=',obj.date_order),('payment','=',obj.vzt_payment),('interest','=',obj.xt_payment)])
#             elif obj.xt_payment > 0.0 and obj.vzt_payment > 0.0 and obj.loss_payment:
#                 history_id = history_obj.search(cr, uid, [('contract_id','=',loan_id),('changed_date','=',obj.date_order),('payment','=',obj.vzt_payment),('interest','=',obj.xt_payment)])
#             elif obj.xt_payment > 0.0 and obj.vzt_payment > 0.0:
#                 history_id = history_obj.search(cr, uid, [('contract_id','=',loan_id),('changed_date','=',obj.date_order),('payment','=',obj.vzt_payment),('interest','=',obj.xt_payment)])
#             elif obj.xt_payment > 0.0:
#                 history_id = history_obj.search(cr, uid, [('contract_id','=',loan_id),('changed_date','=',obj.date_order),('interest','=',obj.xt_payment)])
#             elif obj.vzt_payment > 0.0:
#                 history_id = history_obj.search(cr, uid, [('contract_id','=',loan_id),('changed_date','=',obj.date_order),('payment','=',obj.vzt_payment)])
            if obj.xxt_payment > 0.0:
                update_xxt_id = xxt_obj.search(cr, uid, [('loan_order','=',loan_id),('loan_payment_id','=',ids[0])])
                if update_xxt_id:
                    for update_xxt in xxt_obj.browse(cr, uid, update_xxt_id):
                        if update_xxt.state == 'paid' or update_xxt.state == 'under_paid':
                            if update_xxt.state == 'paid' and not update_xxt.parent_id:
                                xxt_obj.action_cancel(cr, uid,[update_xxt.id], context={})
                                xxt_obj.unlink(cr, uid,[update_xxt.id])
                            else:
                                xxt_obj.write(cr, uid, [update_xxt.id],{'state':'posted'})
                        elif update_xxt.state == 'posted' or update_xxt.state == 'confirmed':
                            xxt_obj.action_cancel(cr, uid,[update_xxt.id], context={})
                            xxt_obj.unlink(cr, uid,[update_xxt.id])
                            
            update_schedule_id = schedule_obj.search(cr, uid, [('contract_id','=',loan_id),('id','=',obj.graphic.id)])
            cr.execute('''
                select id from loan_payment where loan_order=%s and graphic=%s and id <> %s
            '''%(obj.loan_order.id, obj.graphic.id, obj.id))
            fetched = cr.fetchall()
            if update_schedule_id:
                if obj.now_payment_amount >= obj.grap_pay and fetched:
                    schedule_obj.write(cr, uid, update_schedule_id,{'is_paid':'under_paid',
                                                                    'remaining_loan':-obj.vzt_payment,
                                                                    'remaining_loss':-obj.loss_payment,
                                                                    'remaining_interest':-obj.xt_payment,
                                                                    'remaining_acc_interest':-obj.xxt_payment,
                                                                    'paid_date':False})
                else:
                    schedule_obj.write(cr, uid, update_schedule_id,{'is_paid':'un_paid',
                                                                        'remaining_loan':0.0,
                                                                        'remaining_loss':0.0,
                                                                        'remaining_interest':0.0,
                                                                        'remaining_acc_interest':0.0,
                                                                        'paid_date':False})
            
#             if history_id !=[]:
#                 history_obj.unlink(cr, uid, history_id, context=context)
#             if xxt_id !=[]:
#                 xxt_obj.write(cr, uid, xxt_id,{'state':'posted',
#                                                })
        return self.write(cr, uid, ids, {'state':'draft'})

    def action_to_confirmed(self, cr, uid, ids, context=None):
        obj = self.browse(cr,uid,ids)[0]
        if obj.xt_payment <= 0 and obj.xxt_payment <= 0 and obj.vzt_payment <= 0:
            raise osv.except_osv(_('Warning!'),_('Please compute all payments'))
        print '----------------Test confirmed------------',self.write(cr, uid, ids, {'state': 'confirmed',
                                                        'name':self.pool.get('ir.sequence').get(cr, uid, 'loan.payment'),
                                                        'date_confirm': fields.date.context_today(self,cr,uid,context=context)})
        return True

#-------------------------------------ERP------------------------------------------
    # Form filling
    def unlink(self, cr, uid, ids, context=None):
        sale_orders = self.read(cr, uid, ids, ['state'], context=context)
        unlink_ids = []
        for s in sale_orders:
            if s['state'] in ['draft', 'cancel']:
                unlink_ids.append(s['id'])
            else:
                raise osv.except_osv(_('Invalid action !'), _('In order to delete a confirmed sale order, you must cancel it before ! To cancel a sale order, you must first cancel related picking or delivery orders.'))

        return osv.osv.unlink(self, cr, uid, unlink_ids, context=context)

    def onchange_partner_id(self, cr, uid, ids, partner_id):
        partner = self.pool.get('res.partner')
        partner = self.pool.get('res.partner').browse(cr, uid, partner_id)
        address = unicode(partner.country_id.name or '') +', '+ unicode(partner.state_id.name or '') +', '+ unicode(partner.district_sum.name or '') +', '+ unicode(partner.street2 or '')
        return {'value':{'partner_address': address}}
        
    def button_dummy(self, cr, uid, ids, context=None):
        return True
    
    def payment_print(self, cr, uid, ids, vals, context=None):
        if context is None:
            context = {}
        
        datas = {
            'ids': context.get('active_ids', [])
        }
        datas['model'] = 'loan.payment'
        datas['form'] = self.read(cr, uid, ids)[0]
        
        return {
                'type': 'ir.actions.report.xml',
                'report_name': 'loan.payment',
                'datas': datas,
                'nodestroy': True
                }

    # def update_graphic функц нь зээлийн зээл төлөлтийн хуваарийн төлөвийг өөрчилнө.
    def update_graphic(self, cr, uid, ids, state, re_payment,context=None):
        obj = self.browse(self, cr, uid, id)[0]                               # тухайн обёкт буюу loan.payment-ыг obj хувьсагчид хадгалж байна
        schedule_obj = self.pool.get('loan.schedule')                         # schedule_obj хувьсагчид зээл төлөлтийн хуваарийн обёктыг хадгалж байна
        loan_obj = self.pool.get('loan.order')                                # loan_obj хувьсагчид зээл обёктыг хадгалж байна
        
        preg = schedule_obj.search(cr, uid, [('id','=',obj.graphic.prior_id),('is_paid','=','un_paid')])
        while preg != []:
            schedule_obj.write(cr, uid, preg[0],{'is_paid':'late_paid'})    
        gra = schedule_obj.browse(cr, uid, preg[0])    
        preg = schedule_obj.search(cr, uid, [('id','=',gra.prior_id),('is_paid','=','un_paid')])
        rr = schedule_obj.browse(cr, uid, o.graphic.id).remaining_payment
        if re_payment < 0:
            # Зээл төлөлт дутуу төлсөн бол дутуу төлсөн дүнг болон дутуу төлсөн болгож зээл төлөлтийн хуваарийг өөрчилж байна.
            schedule_obj.write(cr, uid, obj.graphic.id,{'remaining_payment':re_payment,'is_paid':'pre_paid'})
            
        else:
            # Зээл төлөлтийг илүү төлсөн болон илүү төлөөгүй бол илүү төлсөн дүнг болон зээл төлөлтийн хуваарийг хэвийн болгож өөрчилнө.
            schedule_obj.write(cr, uid, obj.graphic.id,{'remaining_payment':re_payment,'is_paid':'paid'})
        return True

        
    # def create_journal_entity функц нь санхүүгийн ажил гүйлгээг үүсгэнэ.
    # Санхүүгийн ажил гүйлгээ үүсгэх функц
    def create_journal_entiry(self, cr, uid, ids, paid_loss, paid_acc_interest, paid_interest, paid_loan,remaining_interest,overpayment,loan_and_over,context=None):
        obj = self.browse(cr,uid,ids)[0] 
        print paid_loss
        print paid_acc_interest
        print paid_interest
        print 'paid_loan == ', paid_loan
        print remaining_interest
        print  'overpayment == ',  overpayment
        print 'paid_loanSSS == ', paid_loan
        condition = ''
        if obj.loan_order.loan_state == 'd00':
            condition = 'product_id'
        elif obj.loan_order.loan_state == 'd90':
            condition = 'xxz_product'
        elif obj.loan_order.loan_state == 'd180':
            condition = 'xb_product'
        elif obj.loan_order.loan_state == 'd360':
            condition = 'ez_product'
        elif obj.loan_order.loan_state == 'd361g':
            condition = 'mz_product'
        print "aaaaaaaaaaaaaaaaaaaa",obj.loan_order.product_id.id,condition
        cid = self.pool.get('configure.loan.product').search(cr,uid,[(condition,'=',obj.loan_order.product_id.id)]) 
        if cid != []:
            config = self.pool.get('configure.loan.product').browse(cr,uid,cid)[0]
        else:
            raise osv.except_osv(_('Warning!'), _('Та бүтээгдэхүүний тохиргоог үүсгэнэ үү!'))
        interest_pro = config.xt_product
        loss_pro = config.loss_product
        accum_pro = config.xxt_product
        period = self.pool.get('account.period')
        # period хувьсагчид account.period буюу санхүүгийн мөчлөгийг хадгалж байна
        period_id = period.search(cr, uid, [('date_start','<=',obj.date_order),('date_stop','>=',obj.date_order)])
        # Зээл төлөлтийн төрөл болох банкаар эсвэл бэлэн мөнгөөр төлсөн бол санхүүгийн журналыг journal хувьсагчид хадгална.
        #print 'sdsdsdsdsdsdsdsdsdsd', config.journal_id
        
        if obj.payment_type == 'cash':
            journal = obj.cash_journal
        else:
            journal = obj.bank_journal
        if journal == []:
            raise osv.except_osv(_('Warning!'), _('Choose journal!'))
        account_move_id = 0
        
        res_users_obj = self.pool.get('res.users')
        res_currency_obj = self.pool.get('res.currency')
        company_currency_id = res_users_obj.browse(cr, uid, uid,context=context).company_id.currency_id.id
        currency_id = obj.loan_order.product_id.currency.id
        if company_currency_id !=[] and currency_id !=[]:
            if company_currency_id == currency_id:
                if obj.loan_order.loan_balance <= loan_and_over:
                    zuruu = loan_and_over-obj.loan_order.loan_balance
                    if zuruu > 0:
                         account_move_id = self.pool.get('account.move').create(cr,uid, {
                                    'name':obj.name,
                                    'date':obj.date_order,
                                    'period_id':period_id[0],
                                    'payment_id':obj.id,
                                    'journal_id':journal.id,
                                    'ref':obj.loan_order.name})
                         acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'date':obj.date_order,
                                            'debit':obj.loan_order.loan_balance,
                                            'move_id':account_move_id })
                         acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':obj.loan_order.product_id.property_account_expense.id,
                                            'credit':obj.loan_order.loan_balance,
                                            'date':obj.date_order,
                                            'move_id':account_move_id })
                         account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                         account_move.button_validate()
                         
                         # Илүүү төлөлтийн хэмжээгээр өглөг үүсгэх санхүүгийн бичилт
                         account_move_id = self.pool.get('account.move').create(cr,uid, {
                                            'name':obj.name,
                                            'date':obj.date_order,
                                            'period_id':period_id[0],
                                            'payment_id':obj.id,
                                            'journal_id':journal.id,
                                            'ref':obj.loan_order.name})
                         acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Зээлийн төлбөрийн өглөг.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'date':obj.date_order,
                                            'debit':zuruu,
                                            'move_id':account_move_id })
                         acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Зээлийн төлбөрийн өглөг.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':obj.partner_id.property_account_payable.id,
                                            'credit':zuruu,
                                            'date':obj.date_order,
                                            'move_id':account_move_id })
                         account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                         account_move.button_validate()
                     
                    else:
                         account_move_id = self.pool.get('account.move').create(cr,uid, {
                                    'name':obj.name,
                                    'date':obj.date_order,
                                    'period_id':period_id[0],
                                    'payment_id':obj.id,
                                    'journal_id':journal.id,
                                    'ref':obj.loan_order.name})
                         acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'date':obj.date_order,
                                            'debit':obj.loan_order.loan_balance,
                                            'move_id':account_move_id })
                         acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':obj.loan_order.product_id.property_account_expense.id,
                                            'credit':obj.loan_order.loan_balance,
                                            'date':obj.date_order,
                                            'move_id':account_move_id })
                         account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                         account_move.button_validate()
#                 if obj.balance == 0 and overpayment > 0:
#                      account_move_id = self.pool.get('account.move').create(cr,uid, {
#                                         'name':obj.name,
#                                         'date':obj.date_order,
#                                         'period_id':period_id[0],
#                                         'payment_id':obj.id,
#                                         'journal_id':journal.id,
#                                         'ref':obj.loan_order.name})
#                      acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
#                                         'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
#                                         'partner_id':obj.partner_id.id,
#                                         'account_id':journal.default_debit_account_id.id,
#                                         'date':obj.date_order,
#                                         'debit':paid_loan,
#                                         'move_id':account_move_id })
#                      acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
#                                         'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
#                                         'partner_id':obj.partner_id.id,
#                                         'account_id':obj.loan_order.product_id.property_account_expense.id,
#                                         'credit':paid_loan,
#                                         'date':obj.date_order,
#                                         'move_id':account_move_id })
#                      account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
#                      account_move.button_validate()
#                      # Илүүү төлөлтийн хэмжээгээр өглөг үүсгэх санхүүгийн бичилт
#                      account_move_id = self.pool.get('account.move').create(cr,uid, {
#                                         'name':obj.name,
#                                         'date':obj.date_order,
#                                         'period_id':period_id[0],
#                                         'payment_id':obj.id,
#                                         'journal_id':journal.id,
#                                         'ref':obj.loan_order.name})
#                      acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
#                                         'name':obj.partner_id.name+u' - Зээлийн төлбөрийн өглөг.',
#                                         'partner_id':obj.partner_id.id,
#                                         'account_id':journal.default_debit_account_id.id,
#                                         'date':obj.date_order,
#                                         'debit':overpayment,
#                                         'move_id':account_move_id })
#                      acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
#                                         'name':obj.partner_id.name+u' - Зээлийн төлбөрийн өглөг.',
#                                         'partner_id':obj.partner_id.id,
#                                         'account_id':obj.partner_id.property_account_payable.id,
#                                         'credit':overpayment,
#                                         'date':obj.date_order,
#                                         'move_id':account_move_id })
#                      account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
#                      account_move.button_validate()
#                      
#                 elif obj.balance == 0 and paid_loan == obj.vzt_payment :
#                      account_move_id = self.pool.get('account.move').create(cr,uid, {
#                                         'name':obj.name,
#                                         'date':obj.date_order,
#                                         'period_id':period_id[0],
#                                         'payment_id':obj.id,
#                                         'journal_id':journal.id,
#                                         'ref':obj.loan_order.name})
#                      acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
#                                         'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
#                                         'partner_id':obj.partner_id.id,
#                                         'account_id':journal.default_debit_account_id.id,
#                                         'date':obj.date_order,
#                                         'debit':paid_loan,
#                                         'move_id':account_move_id })
#                      acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
#                                         'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
#                                         'partner_id':obj.partner_id.id,
#                                         'account_id':obj.loan_order.product_id.property_account_expense.id,
#                                         'credit':paid_loan,
#                                         'date':obj.date_order,
#                                         'move_id':account_move_id })
#                      account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
#                      account_move.button_validate()
#                 # Зээл төлөлтийн санхүүгийн бичилт
                elif paid_loan > 0 or loan_and_over > 0:
                    paid_loan += overpayment
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                        'name':obj.name,
                                        'date':obj.date_order,
                                        'period_id':period_id[0],
                                        'payment_id':obj.id,
                                        'journal_id':journal.id,
                                        'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+u' - Үндсэн зээл төлөв.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':journal.default_debit_account_id.id,
                                        'date':obj.date_order,
                                        'debit':paid_loan,
                                        'move_id':account_move_id })
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+u' - Үндсэн зээл төлөв.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':obj.loan_order.product_id.property_account_expense.id,
                                        'credit':paid_loan,
                                        'date':obj.date_order,
                                        'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate()
                    
                # Нэмэгдүүлсэн хүү төлөлтийн санхүүгийн бичилт
                if paid_loss > 0 :
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                            'name':obj.name,
                                            'date':obj.date_order,
                                            'period_id':period_id[0],
                                            'payment_id':obj.id,
                                            'journal_id':journal.id,
                                            'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Нэмэгдүүлсэн хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'date':obj.date_order,
                                            'debit':paid_loss,
                                            'move_id':account_move_id })
                    
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Нэмэгдүүлсэн хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':loss_pro.property_account_income.id,
                                            'credit':paid_loss,
                                            'date':obj.date_order,
                                            'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate()
                    # Хуримтлагдсан хүүгийн төлөлтийн санхүүгийн бичилт
                if paid_acc_interest > 0 :
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                            'name':obj.name,
                                            'date':obj.date_order,
                                            'period_id':period_id[0],
                                            'payment_id':obj.id,
                                            'journal_id':journal.id,
                                            'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Хуримтлуулсан хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'date':obj.date_order,
                                            'debit':paid_acc_interest,
                                            'move_id':account_move_id })
                    
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Хуримтлуулсан хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':accum_pro.property_account_income.id,
                                            'credit':paid_acc_interest,
                                            'date':obj.date_order,
                                            'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate()
                # Хүүгийн төлөлтийн санхүүгийн бичилт
                if paid_interest > 0 :
                    print 'remaining_interest == ', remaining_interest
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                        'name':obj.name,
                                        'date':obj.date_order,
                                        'period_id':period_id[0],
                                        'payment_id':obj.id,
                                        'journal_id':journal.id,
                                        'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+u' - Зээлийн хүү төлөв.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':journal.default_debit_account_id.id,
                                        'date':obj.date_order,
                                        'debit':paid_interest,
                                        'move_id':account_move_id })
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+u' - Зээлийн хүү төлөв.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':interest_pro.property_account_income.id,
                                        'credit':paid_interest,
                                        'date':obj.date_order,
                                        'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate()
                # Дутуу төлсөн хүүгийн авлага үүсгэх санхүүгийн бичилт
                if remaining_interest > 0 :
#                     journal_id = self.pool.get('account.journal').search(cr,uid,[('type','=','sale')],limit=1)[0]
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                        'name':obj.name,
                                        'date':obj.date_order,
                                        'period_id':period_id[0],
                                        'payment_id':obj.id,
                                        'journal_id':config.journal_id.id,
                                        'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+ u' - Хүү хуримтлуулав.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':accum_pro.property_account_income.id,
                                        'debit':remaining_interest,
                                        'move_id':account_move_id })
          
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+ u' - Хүү хуримтлуулав.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':interest_pro.property_account_income.id,
                                        'credit':remaining_interest,
                                        'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate()
                    
            else:
                # Гадаад валютын зээлийн нэмэгдүүлсэн хүүгийн санхүүгийн бичилт
                if obj.loan_order.loan_balance <= loan_and_over:
                    zuruu = loan_and_over-obj.loan_order.loan_balance
                    if zuruu > 0:
                        amount_com_currency = res_currency_obj.compute(cr,uid, currency_id, company_currency_id, obj.loan_order.loan_balance, context=context)
                        account_move_id = self.pool.get('account.move').create(cr,uid, {
                                            'name':obj.name,
                                            'date':obj.date_order,
                                            'period_id':period_id[0],
                                            'payment_id':obj.id,
                                            'journal_id':journal.id,
                                            'ref':obj.loan_order.name})
                        acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'debit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':obj.loan_order.loan_balance,
                                            'move_id':account_move_id })
                        acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':obj.loan_order.product_id.property_account_expense.id,
                                            'credit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':obj.loan_order.loan_balance*(-1),
                                            'move_id':account_move_id })
                        account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                        account_move.button_validate()
                     # Илүүү төлөлтийн хэмжээгээр өглөг үүсгэх санхүүгийн бичилт
                        amount_com_currency = res_currency_obj.compute(cr,uid, currency_id, company_currency_id, zuruu, context=context)
                        account_move_id = self.pool.get('account.move').create(cr,uid, {
                                        'name':obj.name,
                                        'date':obj.date_order,
                                        'period_id':period_id[0],
                                        'payment_id':obj.id,
                                        'journal_id':journal.id,
                                        'ref':obj.loan_order.name})
                        acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+u' - Зээлийн төлбөрийн өглөг.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':journal.default_debit_account_id.id,
                                        'date':obj.date_order,
                                        'debit':amount_com_currency,
                                        'currency_id':currency_id,
                                        'amount_currency':zuruu,
                                        'move_id':account_move_id })
                        acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+u' - Зээлийн төлбөрийн өглөг.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':obj.partner_id.property_account_payable.id,
                                        'credit':amount_com_currency,
                                        'date':obj.date_order,
                                        'currency_id':currency_id,
                                        'amount_currency':zuruu*(-1),
                                        'move_id':account_move_id })
                        account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                        account_move.button_validate()
                     
#                 elif obj.balance == 0 and paid_loan == obj.vzt_payment :
#                     amount_com_currency = res_currency_obj.compute(cr,uid, currency_id, company_currency_id, paid_loan, context=context)
#                     account_move_id = self.pool.get('account.move').create(cr,uid, {
#                                             'name':obj.name,
#                                             'date':obj.date_order,
#                                             'period_id':period_id[0],
#                                             'payment_id':obj.id,
#                                             'journal_id':journal.id,
#                                             'ref':obj.loan_order.name})
#                     acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
#                                             'partner_id':obj.partner_id.id,
#                                             'account_id':journal.default_debit_account_id.id,
#                                             'debit':amount_com_currency,
#                                             'date':obj.date_order,
#                                             'currency_id':currency_id,
#                                             'amount_currency':paid_loan,
#                                             'move_id':account_move_id })
#                     
#                     acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':obj.partner_id.name+u' - Үндсэн зээл хаав.',
#                                             'partner_id':obj.partner_id.id,
#                                             'account_id':obj.loan_order.product_id.property_account_expense.id,
#                                             'credit':amount_com_currency,
#                                             'date':obj.date_order,
#                                             'currency_id':currency_id,
#                                             'amount_currency':paid_loan*(-1),
#                                             'move_id':account_move_id })
#                     account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
#                     account_move.button_validate()
                # Зээл төлөлтийн санхүүгийн бичилт
                elif paid_loan > 0:
                    paid_loan += overpayment
                    amount_com_currency = res_currency_obj.compute(cr,uid, currency_id, company_currency_id, paid_loan, context=context)
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                            'name':obj.name,
                                            'date':obj.date_order,
                                            'period_id':period_id[0],
                                            'payment_id':obj.id,
                                            'journal_id':journal.id,
                                            'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Үндсэн зээл төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'debit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':paid_loan,
                                            'move_id':account_move_id })
                    
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Үндсэн зээл төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':obj.loan_order.product_id.property_account_expense.id,
                                            'credit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':paid_loan*(-1),
                                            'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate()
                
                if paid_loss > 0 :
                    amount_com_currency = res_currency_obj.compute(cr,uid, currency_id,company_currency_id, paid_loss, context=context)
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                            'name':obj.name,
                                            'date':obj.date_order,
                                            'period_id':period_id[0],
                                            'payment_id':obj.id,
                                            'journal_id':journal.id,
                                            'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Нэмэгдүүлсэн хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'debit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':paid_loss,
                                            'move_id':account_move_id })
                    
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Нэмэгдүүлсэн хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':loss_pro.property_account_income.id,
                                            'credit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':paid_loss*(-1),
                                            'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate()
                # Гадаад валютын зээлийн хуримтлагдсан хүүгийн санхүүгийн бичилт
                if paid_acc_interest > 0 :
                    amount_com_currency = res_currency_obj.compute(cr,uid, currency_id, company_currency_id, paid_acc_interest, context=context)
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                            'name':obj.name,
                                            'date':obj.date_order,
                                            'period_id':period_id[0],
                                            'payment_id':obj.id,
                                            'journal_id':journal.id,
                                            'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Хуримтлуулсан хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'debit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':paid_acc_interest,
                                            'move_id':account_move_id })
                    
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Хуримтлуулсан хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':accum_pro.property_account_income.id,
                                            'credit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':paid_acc_interest*(-1),
                                            'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate()
                # Гадаад валютын зээлийн хүүгийн санхүүгийн бичилт
                if paid_interest > 0 :
                    amount_com_currency = res_currency_obj.compute(cr,uid, currency_id, company_currency_id, paid_interest, context=context)
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                            'name':obj.name,
                                            'date':obj.date_order,
                                            'period_id':period_id[0],
                                            'payment_id':obj.id,
                                            'journal_id':journal.id,
                                            'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Зээлийн хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':journal.default_debit_account_id.id,
                                            'debit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':paid_interest,
                                            'move_id':account_move_id })
                    
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                            'name':obj.partner_id.name+u' - Зээлийн хүү төлөв.',
                                            'partner_id':obj.partner_id.id,
                                            'account_id':interest_pro.property_account_income.id,
                                            'credit':amount_com_currency,
                                            'date':obj.date_order,
                                            'currency_id':currency_id,
                                            'amount_currency':paid_interest*(-1),
                                            'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate()
                # Гадаад валютын зээлийн дутуу төлсөн хүүгийн авлага үүсгэх санхүүгийн бичилт
                if remaining_interest>0:
#                     journal_id = self.pool.get('account.journal').search(cr,uid,[('type','=','sale')],limit=1)[0]
                    amount_com_currency = res_currency_obj.compute(cr,uid, currency_id, company_currency_id, remaining_interest, context=context)
                    account_move_id = self.pool.get('account.move').create(cr,uid, {
                                            'name':obj.name,
                                            'date':obj.date_order,
                                            'period_id':period_id[0],
                                            'payment_id':obj.id,
                                            'journal_id':config.journal_id.id,
                                            'ref':obj.loan_order.name})
                    acc_move_line_debit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+ u' - Хүү хуримтлуулав.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':accum_pro.property_account_income.id,
                                        'debit':amount_com_currency,
                                        'currency_id':currency_id,
                                        'amount_currency':remaining_interest,
                                        'move_id':account_move_id })
          
                    acc_move_line_credit = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':obj.partner_id.name+ u' - Хүү хуримтлуулав.',
                                        'partner_id':obj.partner_id.id,
                                        'account_id':interest_pro.property_account_income.id,
                                        'credit':amount_com_currency,
                                        'currency_id':currency_id,
                                        'amount_currency':remaining_interest*(-1),
                                        'move_id':account_move_id })
                    account_move = self.pool.get('account.move').browse(cr,uid,account_move_id)
                    account_move.button_validate() 
                # Гадаад валютын зээлийн үндсэн зээл төлөлтийн санхүүгийн бичилт    
                
        return True 
    
    def __set_loan_histroy_name(self, cr, uid, ids, type, loss_payment, acc_interest_payment, interest_payment, laon_payment, balance,overpayment):
        desc_name=''
        obj = self.browse(cr, uid, ids)[0]
        paid_amount = obj.now_payment_amount
        if type == 1:
            if balance <= 0:
                desc_name = u'Зээл хаав.'
            else:
                if loss_payment > 0:
                    desc_name =u'Нэмэгдүүлсэн хүүгийн төлбөр төлөв, '
                if acc_interest_payment > 0:
                    desc_name +=u'Хур.хүүгийн хүүгийн төлбөр төлөв, '
                if interest_payment > 0:
                    desc_name +=u'Хүүгийн төлбөр төлөв, '
                if laon_payment > 0:
                    desc_name +=u'Үндсэн зээлийн төлбөр төлөв.'
                if overpayment > 0:
                    desc_name +=u'Үндсэн зээлийн төлбөрөөс илүү төлөв.'
                    laon_payment += overpayment
            self.pool.get('loan.account.statement').create(cr,uid, {
                            'contract_id':obj.loan_order.id,
                            'write_date':obj.date_order,
                            'changed_date':obj.date_order,
                            'name':desc_name,
                            'interest':interest_payment, #ТӨЛЖ БУЙ ХҮҮГИЙН ТӨЛБӨР
                            'debit_xx':0.0,
                            'credit_xx':acc_interest_payment,  #ТӨЛЖ БУЙ ХУР ХҮҮ ТӨЛБӨР
                            'payment':laon_payment, #ҮНДСЭН ЗЭЭЛИЙН ТӨЛЖ БУЙ ДҮН
                            'loss':loss_payment, #ТӨЛЖ БУЙ НЭМЭГДҮҮЛСЭН ХҮҮ
                            'loan_payment_id':ids[0]
                           })
        elif type == 2:
            if loss_payment > 0:
                desc_name =u'Нэмэгдүүлсэн хүүгийн төлбөр дутуу төлөв, '
            if acc_interest_payment > 0:
                desc_name +=u'Хур.хүүгийн хүүгийн төлбөр төлөөгүй, '
            if interest_payment > 0:
                desc_name +=u'Хүүгийн төлбөр төлөөгүй , '
            if laon_payment > 0:
                desc_name +=u'Үндсэн зээлийн төлбөр төлөөгүй.'
            self.pool.get('loan.account.statement').create(cr,uid, {
                            'contract_id':obj.loan_order.id,
                            'write_date':obj.date_order,
                            'changed_date':obj.date_order,
                            'name':desc_name,
                            'interest':0.0, #ТӨЛЖ БУЙ ХҮҮГИЙН ТӨЛБӨР
                            'debit_xx':0.0,
                            'credit_xx':0.0,  #ТӨЛЖ БУЙ ХУР ХҮҮ ТӨЛБӨР
                            'payment':0.0, #ҮНДСЭН ЗЭЭЛИЙН ТӨЛЖ БУЙ ДҮН
                            'loss':paid_amount, #ТӨЛЖ БУЙ НЭМЭГДҮҮЛСЭН ХҮҮ
                            'loan_payment_id':ids[0]
                           })
            
        elif type == 3:
            if loss_payment > 0:
                desc_name =u'Нэмэгдүүлсэн хүүгийн төлбөр төлөв, '
            if acc_interest_payment > 0:
                desc_name +=u'Хур.хүүгийн хүүгийн төлбөр дутуу төлөв, '
            if interest_payment > 0:
                desc_name +=u'Хүүгийн төлбөр төлөөгүй , '
            if laon_payment > 0:
                desc_name +=u'Үндсэн зээлийн төлбөр төлөөгүй.'
            remaining_acc_interest=paid_amount-loss_payment
            self.pool.get('loan.account.statement').create(cr,uid, {
                            'contract_id':obj.loan_order.id,
                            'write_date':obj.date_order,
                            'changed_date':obj.date_order,
                            'name':desc_name,
                            'interest':0.0, #ТӨЛЖ БУЙ ХҮҮГИЙН ТӨЛБӨР
                            'debit_xx':0.0,
                            'credit_xx':remaining_acc_interest,  #ТӨЛЖ БУЙ ХУР ХҮҮ ТӨЛБӨР
                            'payment':0.0, #ҮНДСЭН ЗЭЭЛИЙН ТӨЛЖ БУЙ ДҮН
                            'loss':loss_payment, #ТӨЛЖ БУЙ НЭМЭГДҮҮЛСЭН ХҮҮ
                            'loan_payment_id':ids[0]
                           })
             
        elif type == 4:
            if loss_payment > 0:
                desc_name =u'Нэмэгдүүлсэн хүүгийн төлбөр төлөв, '
            if acc_interest_payment > 0:
                desc_name +=u'Хур.хүүгийн хүүгийн төлбөр төлөв, '
            if interest_payment > 0:
                desc_name +=u'Хүүгийн төлбөр дутуу төлөв, '
            if laon_payment > 0:
                desc_name +=u'Үндсэн зээлийн төлбөр төлөөгүй.'
            remaining_interest=paid_amount-loss_payment-acc_interest_payment
            self.pool.get('loan.account.statement').create(cr,uid, {
                            'contract_id':obj.loan_order.id,
                            'write_date':obj.date_order,
                            'changed_date':obj.date_order,
                            'name':desc_name,
                            'interest':remaining_interest, #ТӨЛЖ БУЙ ХҮҮГИЙН ТӨЛБӨР
                            'debit_xx':0.0,
                            'credit_xx':acc_interest_payment,  #ТӨЛЖ БУЙ ХУР ХҮҮ ТӨЛБӨР
                            'payment':0.0, #ҮНДСЭН ЗЭЭЛИЙН ТӨЛЖ БУЙ ДҮН
                            'loss':loss_payment, #ТӨЛЖ БУЙ НЭМЭГДҮҮЛСЭН ХҮҮ
                            'loan_payment_id':ids[0]
                           })
        elif type == 5:
            if loss_payment > 0:
                desc_name =u'Нэмэгдүүлсэн хүүгийн төлбөр төлөв, '
            if acc_interest_payment > 0:
                desc_name +=u'Хур.хүүгийн хүүгийн төлбөр төлөв, '
            if interest_payment > 0:
                desc_name +=u'Хүүгийн төлбөр төлөв, '
            if laon_payment > 0:
                desc_name +=u'Үндсэн зээлийн төлбөр дутуу төлөв.'
            remaining_loan=paid_amount-loss_payment-acc_interest_payment-interest_payment
            self.pool.get('loan.account.statement').create(cr,uid, {
                            'contract_id':obj.loan_order.id,
                            'write_date':obj.date_order,
                            'changed_date':obj.date_order,
                            'name':desc_name,
                            'interest':interest_payment, #ТӨЛЖ БУЙ ХҮҮГИЙН ТӨЛБӨР
                            'debit_xx':0.0,
                            'credit_xx':acc_interest_payment,  #ТӨЛЖ БУЙ ХУР ХҮҮ ТӨЛБӨР
                            'payment':remaining_loan, #ҮНДСЭН ЗЭЭЛИЙН ТӨЛЖ БУЙ ДҮН
                            'loss':loss_payment, #ТӨЛЖ БУЙ НЭМЭГДҮҮЛСЭН ХҮҮ 
                            'loan_payment_id':ids[0]
                           })
        return True
    
    def action_to_waitpayment(self, cr, uid, ids, context=None):
        '''Зээлийн төлөлт батлах
        '''
        obj = self.browse(cr, uid, ids)[0]
        schedule_obj = self.pool.get('loan.schedule')
        period = self.pool.get('account.period')
        period_id = period.search(cr, uid, [('date_start','<=',obj.date_order),('date_stop','>=',obj.date_order)])
        if period_id == []:
            raise osv.except_osv((u'Анхааруулга !'), (u'Дараа оны санхүүгийн жил үүсгэнэ үү!'))
        
        account_journal=[]
        if obj.payment_type == 'cash':
            account_journal = obj.cash_journal
        else:
            account_journal = obj.bank_journal
            
        if account_journal == []:
            raise osv.except_osv((u'Анхааруулга !'), (u'Журнал сонгогдоогүй байна !'))
        
        paid_amount = obj.now_payment_amount #ТӨЛСӨН ДҮН
        pay_amount = obj.grap_pay            #ТӨЛӨХ ДҮН
        laon_payment = obj.vzt_payment       #ҮНДСЭН ЗЭЭЛИЙН ДҮН
        loss_payment = obj.loss_payment      #НЭМЭГДҮҮЛСЭН ХҮҮГИЙН ТӨЛБӨР
        acc_interest_payment = obj.xxt_payment       #ХУРИМТЛАГДСАН ХҮҮГИЙН ТӨЛБӨР
        interest_payment = obj.xt_payment    #ХҮҮГИЙН ТӨЛБӨР
        loan = obj.balance                   #ЗЭЭЛИЙН ҮЛДЭГДЭЛ ТӨЛБӨР
        schedule_obj = obj.graphic
        paid_date = obj.date_order
        
        remaining_loan = 0.0
        remaining_interest = 0.0
        remaining_loss = 0.0
        remaining_acc_interest = 0.0
        desc_name = '' #ЗЭЭЛИЙН ТҮҮХИЙН НЭР
        test_date0 = str(self._date_inc_dec(obj.date_order,0))
        
        balance = obj.loan_order.loan_balance
        xxt_ids = self.pool.get('loan.xxt.payment').search(cr,uid,[('state','in',['posted','confirmed']),
                                                                    ('loan_order','=',obj.loan_order.id)],order='id')
        
        under_xxt_ids = self.pool.get('loan.xxt.payment').search(cr,uid,[('state','in',['under_paid']),
                                                                    ('loan_order','=',obj.loan_order.id)],order='id')
        if paid_amount >= pay_amount:
            #Үндсэн зээлийн төлөлт илүү төлөлт
            overpayment = paid_amount-pay_amount
            print "overpayment : " , overpayment
            #Үндсэн зээлийн төлбөр БОЛОН Үндсэн зээлийн төлөлт илүү төлөлт
            loan_and_over = paid_amount-loss_payment-acc_interest_payment-interest_payment
            print "loan_and_over : " , loan_and_over
            total = round(loss_payment+acc_interest_payment+interest_payment+laon_payment,2)
            remaining_loan = round(paid_amount,2)-total
            
            #ГРАФИК 
            self.update_loan_schedule(cr, uid, obj, schedule_obj.id, remaining_loan, remaining_interest, remaining_loss, remaining_acc_interest, paid_date)
            #ЖУРНАЛ ҮҮСГЭХ
            self.create_journal_entiry(cr, uid, ids, loss_payment, acc_interest_payment, interest_payment, laon_payment, remaining_interest, overpayment,loan_and_over, context)
            #ЗЭЭЛИЙН ГЭРЭЭ НЬ ДЭЭР ЗЭЭЛИЙН ҮЛД ШИНЭЧЛЭХ
            balance = balance - remaining_loan - laon_payment
            if balance <= 0:
                self.pool.get('loan.order').write(cr, uid, obj.loan_order.id, {'loan_balance': 0, 'state':'done'})
            else:
                self.pool.get('loan.order').write(cr, uid, obj.loan_order.id, {'loan_balance': balance})

            #ЗЭЭЛИЙН ТҮҮХРҮҮ БИЧИХ
            if loan_and_over >=  obj.loan_order.loan_balance:
                laon_payment = obj.loan_order.loan_balance
                
            self.__set_loan_histroy_name(cr, uid, ids, 1, loss_payment, acc_interest_payment, interest_payment, laon_payment, balance, overpayment)
            
            if xxt_ids:
                self.pool.get('loan.xxt.payment').write(cr, uid, xxt_ids, {'state': 'paid', 'loan_payment_id':ids[0]})
            
        elif paid_amount < loss_payment:
            remaining_loss=paid_amount-loss_payment
            remaining_loan=-laon_payment
            remaining_interest=-interest_payment
            remaining_acc_interest=-acc_interest_payment
            print 'remaining_interest ----', remaining_interest
            #ГРАФИК 
            self.update_loan_schedule(cr, uid, ids, schedule_obj.id, remaining_loan, remaining_interest, remaining_loss, remaining_acc_interest, paid_date)
             #ЖУРНАЛ ҮҮСГЭХ
            self.create_journal_entiry(cr, uid, ids, paid_amount, remaining_acc_interest, remaining_interest, remaining_loan, remaining_interest, 0,0, context)
             #ЗЭЭЛИЙН ТҮҮХИЙН НЭР
            self.__set_loan_histroy_name(cr, uid,ids, 2, loss_payment, acc_interest_payment, interest_payment, laon_payment,balance,0)
            if xxt_ids:
                self.pool.get('loan.xxt.payment').write(cr, uid, xxt_ids, {'state': 'under_paid','loan_payment_id':ids[0]})
            
            #ХУР ХҮҮ ДУТУУ ТӨЛСӨН ТОХИОЛДОЛД ХҮҮ ХУРИМТЛУУЛНА
            dont_xt = self.pool.get('loan.xxt.payment').create(cr,uid,
                                                    {'parent_id':False,
                                                     'loan_order':obj.loan_order.id,
                                                     'test_date':paid_date,
                                                     'partner_id':obj.partner_id.id,
                                                     'xxt_payment':interest_payment,
                                                     'pre_xxt_payment':acc_interest_payment
                                                     , 'loan_payment_id':ids[0]})
            self.pool.get('loan.xxt.payment').browse(cr,uid,dont_xt).action_to_confirm()
            self.pool.get('loan.account.statement').create(cr,uid, {
                                    'contract_id':obj.loan_order.id,
                                    'name':u'Дутуу төлсөн хүүг хуримтлуулав.',
                                    'write_date':paid_date,
                                    'changed_date':paid_date,
                                    'debit_xx':interest_payment,
                                    'loan_payment_id':ids[0]})

        elif paid_amount < loss_payment+acc_interest_payment:
            remaining_acc_interest=paid_amount-loss_payment-acc_interest_payment
            remaining_loan=-laon_payment
            remaining_interest=-interest_payment
            #ГРАФИК 
            self.update_loan_schedule(cr, uid, ids, schedule_obj.id, remaining_loan, remaining_interest, remaining_loss, remaining_acc_interest, paid_date)
            #ЖУРНАЛ ҮҮСГЭХ
            self.create_journal_entiry(cr, uid, ids, loss_payment, paid_amount-loss_payment, remaining_interest, remaining_loan, remaining_interest*-1, 0,0, context)
             #ЗЭЭЛИЙН ТҮҮХИЙН НЭР
            self.__set_loan_histroy_name(cr, uid, ids, 3, loss_payment, acc_interest_payment, interest_payment, laon_payment,balance,0)
            if xxt_ids:
                if len(xxt_ids) > 1:
                    under_xxt_ids = xxt_ids[len(xxt_ids)-1]
                    xxt_ids.pop(len(xxt_ids)-1)
                    self.pool.get('loan.xxt.payment').write(cr, uid, [under_xxt_ids], {'state': 'under_paid', 'loan_payment_id':ids[0]})
                    self.pool.get('loan.xxt.payment').write(cr, uid, xxt_ids, {'state': 'paid', 'loan_payment_id':ids[0]})
                else:
                    self.pool.get('loan.xxt.payment').write(cr, uid, xxt_ids, {'state': 'under_paid', 'loan_payment_id':ids[0]})
            #ХУР ХҮҮ ДУТУУ ТӨЛСӨН ТОХИОЛДОЛД ХҮҮ ХУРИМТЛУУЛНА
            dont_xt = self.pool.get('loan.xxt.payment').create(cr,uid,
                                                    {'parent_id':False,
                                                     'loan_order':obj.loan_order.id,
                                                     'test_date':paid_date,
                                                     'partner_id':obj.partner_id.id,
                                                     'xxt_payment':interest_payment,
                                                     'pre_xxt_payment':remaining_acc_interest*-1
                                                     , 'loan_payment_id':ids[0]})
            self.pool.get('loan.xxt.payment').browse(cr,uid,dont_xt).action_to_confirm()
            self.pool.get('loan.account.statement').create(cr,uid, {
                                    'contract_id':obj.loan_order.id,
                                    'name':u'Дутуу төлсөн хүүг хуримтлуулав.',
                                    'write_date':paid_date,
                                    'changed_date':paid_date,
                                    'debit_xx':interest_payment,
                                    'loan_payment_id':ids[0]})
#             if obj.xxt_payment > 0:
        elif paid_amount < loss_payment+acc_interest_payment+interest_payment:
            remaining_interest=paid_amount-loss_payment-acc_interest_payment-interest_payment
            print 'remaining_interest ----', remaining_interest
            remaining_loan=-laon_payment
             #ГРАФИК 
            self.update_loan_schedule(cr, uid, ids, schedule_obj.id, remaining_loan, remaining_interest, remaining_loss, remaining_acc_interest, paid_date)
            #ЖУРНАЛ ҮҮСГЭХ
            paid_interest = paid_amount-loss_payment-acc_interest_payment
            self.create_journal_entiry(cr, uid, ids, loss_payment, acc_interest_payment, paid_interest, remaining_loan, remaining_interest*-1, 0, 0, context)
             #ЗЭЭЛИЙН ТҮҮХИЙН НЭР
            self.__set_loan_histroy_name(cr, uid, ids, 4, loss_payment, acc_interest_payment, interest_payment, laon_payment,balance,0)
            if xxt_ids:
                self.pool.get('loan.xxt.payment').write(cr, uid, xxt_ids, {'state': 'paid', 'loan_payment_id':ids[0]})
                
            if under_xxt_ids:
                self.pool.get('loan.xxt.payment').write(cr, uid, under_xxt_ids, {'state': 'paid', 'loan_payment_id':ids[0]})
            #ХУР ХҮҮ ДУТУУ ТӨЛСӨН ТОХИОЛДОЛД ХҮҮ ХУРИМТЛУУЛНА
            dont_xt = self.pool.get('loan.xxt.payment').create(cr,uid,
                                                    {'parent_id':False,
                                                     'loan_order':obj.loan_order.id,
                                                     'test_date':paid_date,
                                                     'partner_id':obj.partner_id.id,
                                                     'xxt_payment':remaining_interest*-1
                                                     , 'loan_payment_id':ids[0]
                                                     })
            self.pool.get('loan.xxt.payment').browse(cr,uid,dont_xt).action_to_confirm()
            self.pool.get('loan.account.statement').create(cr,uid, {
                                    'contract_id':obj.loan_order.id,
                                    'name':u'Дутуу төлсөн хүүг хуримтлуулав.',
                                    'write_date':paid_date,
                                    'changed_date':paid_date,
                                    'debit_xx':remaining_interest*-1,
                                    'loan_payment_id':ids[0]})
        elif paid_amount < loss_payment+acc_interest_payment+interest_payment+laon_payment:
            remaining_loan=paid_amount-loss_payment-acc_interest_payment-interest_payment-laon_payment #ЗӨРҮҮ
            #ГРАФИК 
            self.update_loan_schedule(cr, uid, ids, schedule_obj.id, remaining_loan, remaining_interest, remaining_loss, remaining_acc_interest, paid_date)
            #ЖУРНАЛ ҮҮСГЭХ
            self.create_journal_entiry(cr, uid, ids, loss_payment, acc_interest_payment, interest_payment, paid_amount-loss_payment-acc_interest_payment-interest_payment, remaining_interest, 0, 0, context)
             #ЗЭЭЛИЙН ГЭРЭЭ НЬ ДЭЭР ЗЭЭЛИЙН ҮЛД ШИНЭЧЛЭХ
            balance = obj.loan_order.loan_balance - (paid_amount-loss_payment-acc_interest_payment-interest_payment)
            self.pool.get('loan.order').write(cr, uid, obj.loan_order.id, {'loan_balance': balance})
            #ЗЭЭЛИЙН ТҮҮХИЙН НЭР
            self.__set_loan_histroy_name(cr, uid, ids, 5, loss_payment, acc_interest_payment, interest_payment, laon_payment,balance,0)
            if xxt_ids:
                self.pool.get('loan.xxt.payment').write(cr, uid, xxt_ids, {'state': 'paid', 'loan_payment_id':ids[0]})
            if under_xxt_ids:
                self.pool.get('loan.xxt.payment').write(cr, uid, under_xxt_ids, {'state': 'paid', 'loan_payment_id':ids[0]})
        self.write(cr, uid, ids, {'state': 'paid','test_date':paid_date})
        
        
#         loss = obj.loss_payment                                 # loss хувьсагчид тооцоолсон нэмэгдүүлсэн хүүг хадгалж байна.
#         xt = obj.xt_payment                                     # xt хувьсагчид тооцоолсон хүүгийн төлбөрийг хадгалж байна.
#         xxt = obj.xxt_payment                                   # xxt хувьсагчид тооцоолсон хуримтлагдсан хүүгийн төлбөрийг хадгалж байна.
#         vzt = obj.vzt_payment                                   # vzt хувьсагчид тооцоолсон үндсэн зээлийн төлбөрийг хадгалж байна.
#         now_pay = obj.grap_pay                                  # now_pay хувьсагчид тооцоолсон төлөх дүнг хадгалж байна
#         r_pay = obj.re_payment                                  # r_pay хувьсагчид тооцоолсон зээлийн илүү болон дутуу төлөлтийг хадгалж байна
#         payment_amount = o.now_payment_amount                   # payment_amount хувьсагчид зээлийн төлсөн дүнг хадгалж байна.
#         
#         
#         if now_pay <= payment_amount:
#             # Төлөлтийн хуваарийн төлж буй дүн төлөх дүнгээс их бол илүү төлөлт
#             re_payment = payment_amount - now_pay               # re_payment хувьсагчид зээлийн илүү төлөлтийн зөрүүг бодож хадгална
#             
#             # state хувьсагчид тухайн зээл хугацаандаа хэвийн төлөгдсөн гэж үзэх бөгөөд хугацаандаа төлсөн гэсэн төлөлвийг буцаана
#             state = 'paid'
#             
#             # def update_graphic функцыг дуудан зээл төлөлтийн хуваарийн төлөв болон илүү төлөлтийн утгыг дамжуулж байна.
#             self.update_graphics(self, cr, uid, ids, state, re_payment,context=context)
#             
#             # def create_journal_entity функцЫг дуудан санхүүгийн ажил гүйлгээг үүсгэх утгуудыг дамжуулж байна
#             self.create_journal_entiry(self, cr, uid, ids, loss, xxt, xt, vzt,context=context)
#                 
#         else:
#             #Төлөлтийн хуваарийн төлөх дүн төлж буй дүнгээс бага бол дутуу төлөлт
#            re_payment = payment_amount - now_pay
#            
#            
#            
#            
#         cur_id = obj.loan_order.product_id.currency.id 
#            
# 
#             
#         currency_id = o.loan_order.product_id.currency.id
#         res_currency_obj = self.pool.get('res.currency')
#         res_users_obj = self.pool.get('res.users')
# 
#         company_currency_id = res_users_obj.browse(cr, uid, uid,context=context).company_id.currency_id.id
#         currency_id = o.loan_order.product_id.currency.id
#         test_date0 = str(self._date_inc_dec(o.date_order,0))
#         
#         
#         
# 
#         period_id = period.search(cr, uid, [('date_start','<=',o.date_order),('date_stop','>=',o.date_order)])
#         now_pay = now_pay - loss
#         #Хуримтлагдсан хүүгийн төлбөр төлөлт
#         if o.dont_pay_interest == True:
#             if o.xt_payment > 0:
#                 dont_xt = self.pool.get('loan.xxt.payment').create(cr,uid,
#                                                     {'parent_id':False,
#                                                      'loan_order':o.loan_order.id,
#                                                      'test_date':test_date0,
#                                                      'partner_id':o.partner_id.id,
#                                                      'xxt_payment':o.xt_payment})  
#                 self.pool.get('loan.xxt.payment').browse(cr,uid,dont_xt).action_to_confirm()
#                 print 'Dont pay interest accumlated',dont_xt
#         else:
#             if xxt > 0 and payment_amount>0:
#                 amount_currency = res_currency_obj.compute(cr,uid, company_currency_id, currency_id,xxt, context=context)
#                 amount = 0.0
#                 if xxt > payment_amount:
#                     print 'xxt payment_amount baga = ',xxt, payment_amount 
#                     if amount_currency == xxt:
#                         amount_currency = 0.0
#                         amount = payment_amount
#                         xxt = amount
#                     else:
#                         t = amount_currency
#                         amount_currency = xxt
#                         amount = payment_amount
#                         xxt = amount
#                 else:
#                     print 'xxt payment_amount ih = ',xxt, payment_amount 
#                     if amount_currency == xxt:
#                         amount_currency = 0.0
#                         amount = xxt
#                     else:
#                         t = amount_currency
#                         amount_currency = xxt
#                         amount = t
#                     
#                 payment_amount = payment_amount - amount
#                 am_id = self.pool.get('account.move').create(cr,uid, {
#                                         'name':o.name,
#                                         'period_id':period_id[0],
#                                         'journal_id':journal.id,
#                                         'date':o.date_order,
#                                         'payment_id':o.id,
#                                         'ref':o.loan_order.name})
#                                          
#                 aml_one_one = self.pool.get('account.move.line').create(cr,uid,{
#                                         'name':o.partner_id.name+u' - Хуримтлуулсан хүү төлөв.',
#                                         'partner_id':o.partner_id.id,
#                                         'account_id':journal.default_debit_account_id.id,
#                                         'debit':amount,
#                                         'date':o.date_order,
#                                         'move_id':am_id })
#  
#                 aml_one_one2 = self.pool.get('account.move.line').create(cr,uid,{
#                                         'name':o.partner_id.name+u' - Хуримтлуулсан хүү төлөв.',
#                                         'partner_id':o.partner_id.id,
#                                         'account_id':accum_pro.property_account_expense.id,
#                                         'credit':amount,
#                                         'date':o.date_order,
#                                         'move_id':am_id })
#                  
#                 amove = self.pool.get('account.move').browse(cr,uid,am_id)
#                 amove.button_validate()
#                                          
#                 xxt_ids = self.pool.get('loan.xxt.payment').search(cr,uid,[('state','in',['posted','confirmed']),
#                                                                        ('loan_order','=',o.loan_order.id)],order='id')                
#                 self.pool.get('loan.xxt.payment').write(cr, uid, xxt_ids, {'state': 'paid'})
#                                     
#             if o.is_accumlate == True:
#                 new_xxt = self.pool.get('loan.xxt.payment').create(cr,uid,
#                                                                         {'parent_id':False,
#                                                                          'loan_order':o.loan_order.id,
#                                                                          'test_date':test_date0,
#                                                                          'partner_id':o.partner_id.id,
#                                                                          'xxt_payment':o.accumlated,
#                                                                         })
#                 print 'nemelt xxt.payment created:',new_xxt,'accumlated+',o.accumlated
#                 self.pool.get('loan.xxt.payment').browse(cr,uid,new_xxt).action_to_confirm()
# #                self.pool.get('loan.xxt.payment').browse(cr,uid,new_xxt).action_to_payment()
#             else:
#                 print 'not new xxt'
#         # Хүүгийн төлбөр төлөлт
#         if xt > 0 and payment_amount>0:
#             
#             if period_id !=[]:
#                 amount_currency = res_currency_obj.compute(cr,uid, currency_id,company_currency_id, xt, context=context)
#                 amount = 0.0
#                 if xt > payment_amount:
#                     print 'xt payment_amount baga = ',xt, payment_amount 
#                     if amount_currency == xt:
#                         amount_currency = 0.0
#                         amount = payment_amount
#                         xt = amount
#                     else:
#                         t = amount_currency
#                         amount_currency = xt
#                         amount = payment_amount 
#                         xt = amount
#                 else:
#                     print 'xt payment_amount ih = ',xt, payment_amount 
#                     if amount_currency == xt:
#                         amount_currency = 0.0
#                         amount = xt
#                     else:
#                         t = amount_currency
#                         amount_currency = xt
#                         amount = t
#                 payment_amount = re_payment - amount
#                 print "payment amount ",payment_amount,amount
#                 am_id = self.pool.get('account.move').create(cr,uid, {
#                                         'name':o.name,
#                                         'date':o.date_order,
#                                         'journal_id':journal.id,
#                                         'payment_id':o.id,
#                                          'period_id':period_id[0],
#                                         'ref':o.loan_order.name})
#                 if company_currency_id == currency_id:                        
#                     aml_one_one = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':o.partner_id.name+u' - Зээлийн хүү төлөв.',
#                                             'partner_id':o.partner_id.id,
#                                             'account_id':journal.default_debit_account_id.id,
#                                             'debit':amount,
#                                             'date':o.date_order,
#                                             'period_id':period_id[0],
#                                             'move_id':am_id })
#          
#                     aml_one_one2 = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':o.partner_id.name+u' - Зээлийн хүү төлөв.',
#                                             'partner_id':o.partner_id.id,
#                                             'account_id':xt_pro.property_account_income.id,
#                                             'credit':amount,
#                                             'date':o.date_order,
#                                             'period_id':period_id[0],
#                                             'move_id':am_id })
#                 else:
#                     aml_one_one = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':o.partner_id.name+u' - Зээлийн хүү төлөв.',
#                                             'partner_id':o.partner_id.id,
#                                             'account_id':journal.default_debit_account_id.id,
#                                             'debit':amount,
#                                             'date':o.date_order,
#                                             'period_id':period_id[0],
#                                             'currency_id':currency_id,
#                                             'amount_currency':amount_currency,
#                                             'move_id':am_id })
#          
#                     aml_one_one2 = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':o.partner_id.name+u' - Зээлийн хүү төлөв.',
#                                             'partner_id':o.partner_id.id,
#                                             'account_id':xt_pro.property_account_income.id,
#                                             'credit':amount,
#                                             'date':o.date_order,
#                                             'period_id':period_id[0],
#                                             'currency_id':currency_id,
#                                             'amount_currency':amount_currency*(-1),
#                                             'move_id':am_id })
#             else:
#                 raise osv.except_osv(_('Warning!'), _('Дараа оны санхүүгийн жил үүсгэнэ үү!'))
#              
#             amove = self.pool.get('account.move').browse(cr,uid,am_id)
#             amove.button_validate()
#         # Үндсэн зээл төлөлт
#         if vzt > 0 and payment_amount>0:
#             print "ddddddddd",vzt,payment_amount
#             amount_currency = res_currency_obj.compute(cr,uid, currency_id,company_currency_id,vzt, context=context)
#             amount = 0.0
#             if vzt > payment_amount:
#                 print 'vzt payment_amount baga = ',vzt, payment_amount 
#                 if amount_currency == vzt:
#                     amount_currency = 0.0
#                     amount = payment_amount
#                     vzt = amount
#                 else:
#                     t = amount_currency
#                     amount_currency = vzt
#                     amount = payment_amount
#                     vzt = amount
#             else:
#                 print 'vzt payment_amount = ',vzt, payment_amount 
#                 if re_payment > 0.0:
#                     if amount_currency == vzt:
#                             amount_currency = 0.0
#                             amount = vzt+re_payment
#                     else:
#                         t = amount_currency
#                         amount_currency = vzt
#                         amount = t
#                 else:
#                     if amount_currency == vzt:
#                             amount_currency = 0.0
#                             amount = vzt
#                     else:
#                         t = amount_currency
#                         amount_currency = vzt
#                         amount = t+re_payment
#             period_id = period.search(cr, uid, [('date_start','<=',o.date_order),('date_stop','>=',o.date_order)])
#             if period_id !=[]:
#                 am_id = self.pool.get('account.move').create(cr,uid, {
#                                         'name':o.name,
#                                         'journal_id':journal.id,
#                                         'period_id':period_id[0],
#                                         'date':o.date_order,
#                                         'payment_id':o.id,
#                                         'ref':o.loan_order.name})
#                 if company_currency_id == currency_id:
#                     aml_one_one = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':o.partner_id.name+u' - Үндсэн зээл төлөв.',
#                                             'partner_id':o.partner_id.id,
#                                             'account_id':journal.default_debit_account_id.id,
#                                             'debit':amount,
#                                             'period_id':period_id[0],
#                                             'date':o.date_order,
#                                             'move_id':am_id })
#          
#                     aml_one_one2 = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':o.partner_id.name+u' - Үндсэн зээл төлөв.',
#                                             'partner_id':o.partner_id.id,
#                                             'account_id':o.loan_order.product_id.property_account_expense.id,
#                                             'credit':amount,
#                                             'period_id':period_id[0],
#                                             'date':o.date_order,
#                                             'move_id':am_id })
#                 else:
#                     aml_one_one = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':o.partner_id.name+u' - Үндсэн зээл төлөв.',
#                                             'partner_id':o.partner_id.id,
#                                             'account_id':journal.default_debit_account_id.id,
#                                             'debit':amount,
#                                             'period_id':period_id[0],
#                                             'date':o.date_order,
#                                             'currency_id':currency_id,
#                                             'amount_currency':amount_currency,
#                                             'move_id':am_id })
#          
#                     aml_one_one2 = self.pool.get('account.move.line').create(cr,uid,{
#                                             'name':o.partner_id.name+u' - Үндсэн зээл төлөв.',
#                                             'partner_id':o.partner_id.id,
#                                             'account_id':o.loan_order.product_id.property_account_expense.id,
#                                             'credit':amount,
#                                             'period_id':period_id[0],
#                                             'date':o.date_order,
#                                             'currency_id':currency_id,
#                                             'amount_currency':amount_currency*(-1),
#                                             'move_id':am_id })
#             else:
#                 raise osv.except_osv(_('Warning!'), _('Дараа оны санхүүгийн жил үүсгэнэ үү!'))
#              
#             amove = self.pool.get('account.move').browse(cr,uid,am_id)
#             amove.button_validate()
#          
#         vld = o.balance                    
#         lastgid = self.pool.get('loan.schedule').search(cr,uid,[('contract_id','=',o.loan_order.id),('prior_id','=',o.graphic.id)])
#         
#         if vld == 0 and re_payment == 0:
#             upd = self.pool.get('loan.order').write(cr, uid, o.loan_order.id, {'loan_balance': vld,'state':'done'})
#             for gra in o.loan_order.schedules:
#                 self.pool.get('loan.schedule').write(cr, uid, gra.id,{'is_paid':'paid'})    
#         else:
#             if re_payment > 0.0: 
#                 vld = vld - re_payment
#                 upd = self.pool.get('loan.order').write(cr, uid, o.loan_order.id, {'loan_balance': vld})
#             else:
#                 if o.loan_order.schedule_type == 'type5':                
#                     vld = vld
#                 if o.loan_order.schedule_type in ('type1','type3'):
#                     vld = vld - re_payment
#                 upd = self.pool.get('loan.order').write(cr, uid, o.loan_order.id, {'loan_balance': vld})
#          
#         print '---TESTDATE---',test_date0
#         self.write(cr, uid, ids, {'state': 'paid','test_date':test_date0})
#          
#         desc_name = ''
#         if xxt > 0 and payment_amount > 0.0:
#             if xxt < payment_amount:
#                 desc_name = desc_name + u'Хуримтлагдсан хүүгийн төлбөр,'
#             else:
#                 xxt = payment_amount
#                 desc_name = desc_name + u'Хуримтлагдсан хүүгийн дутуу төлбөр,'
#         else:
#             xxt = 0.0
#      #   if o.accumlated > 0:
#      #       desc_name = desc_name + u' Дутуу төлсөн хүүг хуримтлуулав,'
#         if xt > 0 and payment_amount == 0.0:
#             if xt < payment_amount:
#                 desc_name = desc_name + u' Хүүгийн төлбөр төлөв,'
#             else:
#                  xt = payment_amount
#                  desc_name = desc_name + u' Хүүгийн төлбөр дутуу төлөв,'
#         else:
#             xt = 0.0
#         if vzt > 0 and payment_amount == 0.0:
#             if vzt < payment_amount:
#                 desc_name = desc_name + u' Үндсэн зээлийн төлбөр төлөв,'
#             else:
#                 vzt = payment_amount
#                 desc_name = desc_name + u' Үндсэн зээлийн төлбөр дутуу төлөв,'
#         else:
#             vzt = 0.0
#         if loss > 0.0 and payment_amount > 0.0:
#             if loss < payment_amount:
#                 desc_name = desc_name + u' Нэмэгдүүлсэн хүүгийн төлбөр төлөв,'
#             else:
#                 desc_name = desc_name + u' Нэмэгдүүлсэн хүүгийн төлбөр дутуу төлөв,'
#         else:
#             loss = 0.0
#         print 'lpayment history statement',self.pool.get('loan.account.statement').create(cr,uid, {
#                                     'contract_id':o.loan_order.id,
#                                     'write_date':o.date_order,
#                                     'changed_date':o.date_order,
#                                     'name':desc_name,


#                                     'interest':xt,
#                                     'debit_xx':o.accumlated,
#                                     'payment':vzt,
#                                     'loss':loss,
#                                     'credit_xx':xxt})
        return True
    
    
    def __check_before_loan_schedule(self, cr, uid, graphic_id , order_id, payment_date):
        '''ТУХАЙН ТӨЛӨЛТ ХИЙЖ БУЙ ЗЭЭЛИЙН ГРАФИКААС 
           ӨМНӨ НЬ ДУТУУ ТӨЛСӨН БОЛОН ТӨЛӨГДӨӨГҮЙ БАЙГАА ГРАФИКЫГ ОЛНО
        '''
        res=[]
        cr.execute("select id from loan_schedule where\
                contract_id=%s and payment_date < '%s' and id <> %s and is_paid in ('un_paid','under_paid') order by payment_date asc"%(order_id,payment_date,graphic_id))
        fetched = cr.fetchall()
        if fetched:
            res = [x[0] for x in fetched]
        return res
    
    def update_loan_schedule(self, cr, uid, payment_obj, loan_schedule_id, remaining_loan, remaining_interest, remaining_loss, remaining_acc_interest, paid_date, context=None):
        '''ЗЭЭЛ ТӨЛӨЛТ БАТЛАХ ҮЕД ЗЭЭЛИЙН ГРАФИКЫГ ШИНЭЧИЛНЭ
        '''
        schedule_obj = self.pool.get('loan.schedule').browse(cr, uid, loan_schedule_id)
        #Зээлийн нэмэгдүүлсэн хүү эсвэл алданги 0-с их байх боломжгүй
        if remaining_acc_interest > 0 or remaining_interest > 0 or remaining_loss > 0:
            raise osv.except_osv(_('Error'), _('Interest or Loss or Acc_interest must be zero'))
        #Зээл төлөлтийн хуваарьлуу бичилт хийх
        else:
            before_graphic_ids = self.__check_before_loan_schedule(cr, uid, schedule_obj.id, schedule_obj.contract_id.id, schedule_obj.payment_date)
            if before_graphic_ids:
                for schedule in self.pool.get('loan.schedule').browse(cr, uid, before_graphic_ids):
                    self.pool.get('loan.schedule').write(cr, uid, schedule.id, {'is_paid':'late_paid', 'paid_date':paid_date})
                    
            self.pool.get('loan.schedule').write(cr, uid, loan_schedule_id, {'remaining_loan': remaining_loan,
                                                                            'remaining_interest': remaining_interest,
                                                                            'remaining_loss': remaining_loss,
                                                                            'remaining_acc_interest': remaining_acc_interest,
                                                                            })
        
         #Зээл графикын төлөв өөрчлөх
        if remaining_loan >= 0 and remaining_interest >=0 and remaining_loss >= 0 and remaining_acc_interest >= 0 and schedule_obj.payment_date == paid_date:
            schedule_obj.write({'is_paid':'paid','paid_date': paid_date})
        elif remaining_loan >= 0 and remaining_interest >=0 and remaining_loss >= 0 and remaining_acc_interest >= 0 and schedule_obj.payment_date < paid_date:
            schedule_obj.write({'is_paid': 'late_paid','paid_date': paid_date})
        elif remaining_loan >= 0 and remaining_interest >=0 and remaining_loss >= 0 and remaining_acc_interest >= 0 and schedule_obj.payment_date > paid_date:
            schedule_obj.write({'is_paid': 'pre_paid','paid_date': paid_date})
        elif remaining_loan < 0 or remaining_interest < 0 or remaining_loss < 0 or remaining_acc_interest < 0:
            schedule_obj.write({'is_paid': 'under_paid','paid_date': paid_date})
        
#             #Зээл төлөлтийн хуваарийн төлөв өөрчлөх
#             if remaining_loan >= 0 and schedule_obj.payment_date == paid_date:
#                 schedule_obj.write({'is_paid':'paid'})
#             elif remaining_loan >= 0 and schedule_obj.payment_date < paid_date:
#                 schedule_obj.write({'is_paid': 'late_paid'})
#             elif remaining_loan >= 0 and schedule_obj.payment_date > paid_date:
#                 schedule_obj.write({'is_paid': 'pre_paid'})
#             elif remaining_loan < 0:
#                 schedule_obj.write({'is_paid': 'under_paid'})
                
        return  {}
    
    def compute_loss(self, cr, uid, payment_obj,now_pay_date):
        '''АЛДАНГИ БУЮУ НЭМЭГДҮҮЛСЭН ХҮҮГИЙН ТӨЛБӨР ТООЦООЛОХ ФУНКЦ
            @payment_obj = Тухайн зээл төлөлтийн обект
            @now_pay_date = Тухайн төлөлт хийж буй огноо
        '''
        loss=0.0
        loan_payment_history_obj = self.pool.get('loan.account.statement')
        if payment_obj.is_undue_loss:
            loss_percent = payment_obj.loan_order.loss_percent
            loan_history = loan_payment_history_obj.search(cr, uid, [('contract_id','=',payment_obj.loan_order.id),('changed_date','<',now_pay_date)],order='changed_date desc')
            loan_history_date=False
            if loan_history != []:
                his_id = self.pool.get('loan.account.statement').browse(cr, uid, loan_history)[0]
                loan_history_date = his_id.changed_date
            if payment_obj.undue_loss_type == 'current_payment':
                graphic_loan_pay = payment_obj.graphic.loan_payment
                print "graphic_loan_pay : " , graphic_loan_pay
                
                before_res = self.calculate_before_payments(cr, uid, [], payment_obj.graphic, payment_obj.loan_order, now_pay_date)
                print "before_res : " , before_res
                if before_res.has_key('loan_payment'):
                    graphic_loan_pay += before_res['loan_payment']
                    
                #ӨМНӨХ ГРАФИКУУД ДЭЭР ТӨЛӨГДӨӨГҮЙ БАЙВАЛ ОЛНО
                before_graphic_ids = self.__check_before_loan_schedule(cr, uid, payment_obj.graphic.id, payment_obj.loan_order.id, now_pay_date)
                if before_graphic_ids:
                    for schedule in self.pool.get('loan.schedule').browse(cr, uid, before_graphic_ids):
                        if schedule.is_paid == 'un_paid':
                            loss_day = self._get_days(now_pay_date,schedule.payment_date)
                            loss += ((schedule.loan_payment*loss_percent)/100/30)*loss_day
                            
                #ТУХАЙН ТӨЛӨЛТ НЬ ДЭЭР БАЙГА ГРАФИК
                loss_day = self._get_days(now_pay_date,payment_obj.graphic.payment_date)
                loss += ((graphic_loan_pay*payment_obj.loan_order.loss_percent)/100/30)*loss_day
            elif payment_obj.undue_loss_type == 'not_payment':
                loss_day = self._get_days(now_pay_date,payment_obj.graphic.payment_date) #НИЙТ АЛДАНГИЙ ТООЦОХ ӨДӨР
                graphic_loan_pay = payment_obj.graphic.loan_payment + payment_obj.graphic.balance
                loss = ((graphic_loan_pay*payment_obj.loan_order.loss_percent)/100/30)*loss_day
        else:
            #ӨМНӨХ САРЫН ЗЭЭЛИЙН ГРАФИКУУДААС ДУТУУ ТӨЛСӨН БАЙВАЛ АЛДАНГИЙН ЗӨРҮҮГ АВНА
            before_graphic_ids = self.__check_before_loan_schedule(cr, uid, payment_obj.graphic.id, payment_obj.loan_order.id, now_pay_date)
            if before_graphic_ids:
                    for schedule in self.pool.get('loan.schedule').browse(cr, uid, before_graphic_ids):
                        if schedule.is_paid == 'under_paid':
                            loss += (schedule.remaining_loss*(-1))
        return loss
    
    def compute_interest(self, cr, uid, payment_obj, lorder):
        '''ХҮҮГИЙН ТӨЛБӨР ТООЦООЛОХ
        '''
        balance = lorder.loan_balance
        pay_date = payment_obj.date_order
        now_pay_date = pay_date
        now_pay_date = str(self._date_inc_dec(now_pay_date,0))
            
        rate = lorder.interest  #зээлийн хүү
        c = rate/100            #Зээлийн хүүг хувьруу шилжүүлнэ
        last_date = self._get_last_date(cr,uid,lorder.id) #тухайн гэрээний хамгийн сүүлийн төлөлтийн огноо
        print "last_date L " , last_date
        #хуримтлагдсан хүүгийн төлбөр байгаа бол авна
#         acc_interest_ids = self.pool.get('loan.xxt.payment').search(cr,uid,[('state','in',['posted','confirmed']),
#                                                                             ('loan_order','=',lorder.id),
#                                                                             ('test_date','<=',pay_date)],order='id')
        
        cr.execute('''
            select id from loan_xxt_payment where state in ('posted', 'confirmed') 
            and loan_order=%s and test_date <= '%s' order by id desc limit 1
        '''%(lorder.id, pay_date))
        acc_interest_ids = cr.fetchall()
        acc_interest_ids = [x[0] for x in acc_interest_ids]
        total_acc_interest = 0.0
        if acc_interest_ids != []:
            for xxt in self.pool.get('loan.xxt.payment').browse(cr,uid,acc_interest_ids):
                total_acc_interest += xxt.xxt_payment + xxt.pre_xxt_payment
                last_date = xxt.test_date
           #     interest_payment -= xxt.xxt_payment#
#                 self.pool.get('loan.xxt.payment').write(cr, uid, [xxt.id], {'loan_payment_id':payment_obj.id})
            sd = self._get_days(now_pay_date,last_date)-1
            if sd < 0:
                sd = 0
        else:
            sd = self._get_days(now_pay_date,last_date) #хүүгийн төлбөр тооцоолох нийт өдөр
            if sd < 0:
                sd = 0
        interest_payment = balance*c/30*sd    #тухай төлөлт хийж буй өдөрийн нийт хүүгийн төлбөр
        interest_payment = round(interest_payment, 2)
        return interest_payment, total_acc_interest
        
loan_payment()


#===============================================================================
# class loan_account_statement(osv.osv):
# 
#     _inherit = 'loan.account.statement'
# 
#     _columns = {
#                 'payment_id':fields.many2one('loan.payment','Loan payment')
#                 }
# 
# loan_account_statement()
#===============================================================================


class account_move(osv.osv):
    _inherit = 'account.move'
 
    _columns = {

                'payment_id':fields.many2one('loan.payment','Loan payment'),
                }
 
account_move()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: