# -*- coding: utf-8 -*-

from datetime import datetime, timedelta
from datetime import date
from dateutil.relativedelta import relativedelta
import time
import openerp.pooler
from openerp.osv import fields, osv
from openerp.tools.translate import _
from openerp.tools import DEFAULT_SERVER_DATE_FORMAT, DEFAULT_SERVER_DATETIME_FORMAT, float_compare
import openerp.addons.decimal_precision as dp
import openerp.netsvc

class accumlated_interest(osv.osv):
    _name = "accumlated.interest"
    _description = u"Accumlated interest"

    _columns = {
        'name': fields.date('Date', required=True, states={'confirmed':[('readonly',True)],'post':[('readonly',True)]}),
        'lines': fields.one2many('loan.xxt.payment','parent_id',u'Lines',required=True, readonly=True),
        'currency_id':fields.many2one('res.currency','Currency',required=True),
		'state': fields.selection([
            ('draft', 'Draft'),
            ('confirmed', 'Confirmed'),
            ('post', 'Posted'),
            ('cancel', 'Cancelled')
            ], 'State', readonly=True, help="HELP", select=True),
        'period_type':fields.selection([('day','Day'),
                                        ('mounth','Month')],'Period type',required=True),
        'user_id': fields.many2one('res.users', 'Employee', readonly=True),
        'company_id':fields.many2one('res.company','Company'),
    }
    
    
    _sql_constraints = [
        ('name_uniq', 'unique(name)', 'Date must be unique per month!'),
    ]
    
    _defaults = {
        'name': fields.date.context_today,
        'state': 'draft',
        'user_id': lambda obj, cr, uid, context: uid,
        'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,

    }


    def _get_month_days(self,x):
		return {
        	1:31, 2:28, 3:31, 4:30, 5:31, 6:30, 7:31, 8:31, 9:30, 10:31, 11:30, 12:31
        }.get(x)

    def _date_inc_dec(self,dddd,d):
        day = int(dddd[8:])
        month = int(dddd[5:7])
        year = int(dddd[:4])
        dd = date(year,month,day)+timedelta(days=d)
        return dd
         
    def action_to_compute(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        pro_id = self.pool.get('loan.product').search(cr, uid, [('loan_product_type','=','loan_product')])
        lids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('loan_state','=','d00')])
        print "ldddddddd",lids,len(lids)
        test_date = obj.name
        m = int(test_date[5:7])
        d = int(test_date[8:])
        xxt = 0
        if obj.period_type == 'mounth':
            if d != self._get_month_days(m):
                raise osv.except_osv(_('Warning !'), _('Today is not end of month!!!'))
        for loan in self.pool.get('loan.order').browse(cr,uid,lids):
            if loan.product_id.currency.id == obj.currency_id.id:
                xtid = self.pool.get('loan.payment').search(cr, uid, [('loan_order', '=',loan.id),('state','=','paid')],order='test_date')
                xxtid = self.pool.get('loan.xxt.payment').search(cr, uid, [('loan_order', '=',loan.id),('state','!=','draft')],order='id')
                last_date = ''

                if xtid == [] and xxtid == []: 
                    last_date = loan.date_approve
                    last_date = str(self._date_inc_dec(last_date,-1))
                    print 'First XXT--',last_date,loan.id
                elif xtid != [] and xxtid == []:
                    xt = self.pool.get('loan.payment').browse(cr,uid,xtid[len(xtid)-1])    
                    last_date = xt.test_date
                    print 'tulult xiisen XXT--',last_date,xt.test_date,loan.id
                elif xtid == [] and xxtid != []:
                    xxt = self.pool.get('loan.xxt.payment').browse(cr,uid,xxtid[len(xxtid)-1])    
                    last_date = xxt.test_date
                    print 'xurimtluulsan XXT--',last_date,loan.id   
                elif xtid != [] and xxtid != []:
                    xt = self.pool.get('loan.payment').browse(cr,uid,xtid[len(xtid)-1])    
                    xxt = self.pool.get('loan.xxt.payment').browse(cr,uid,xxtid[len(xxtid)-1])
                    if xt.test_date <= xxt.test_date:
                        last_date = xxt.test_date
                        last_date = str(self._date_inc_dec(last_date,-1))
                    else:
                        last_date = xt.test_date
                        last_date = str(self._date_inc_dec(last_date,-1))
                    print 'xt<xxt XXT--',xt.test_date,xxt.test_date,loan.id
                if test_date > last_date:
                    sd = self._get_days(test_date,last_date)
                    balance = loan.loan_balance
                    rate = loan.interest
                    if rate != 0:
                        c = rate/100
                        xxt = balance*c/30*sd
                        xxt = round(xxt, 2)
    #                print 'dates ',test_date,last_date,loan.name,loan.partner_id.name
                    if xxt > 0:
                        xxids = self.pool.get('loan.xxt.payment').search(cr,uid,[('state','in',['posted','confirmed']),('loan_order','=',loan.id)])
                        prexxt = 0.0
                        for pxxt in self.pool.get('loan.xxt.payment').browse(cr,uid,xxids):
                            prexxt += pxxt.xxt_payment 
                        xxtis = self.pool.get('loan.xxt.payment').search(cr, uid,[('parent_id','=',obj.id),('loan_order','=',loan.id)])
                        if xxtis == []:
                            self.pool.get('loan.xxt.payment').create(cr,uid,
                                                                                {'parent_id':obj.id,
                                                                                 'loan_order':loan.id,
                                                                                 'pre_xxt_payment':prexxt,
                                                                                 'test_date':test_date,
                                                                                 'partner_id':loan.partner_id.id,
                                                                                 'xxt_payment':xxt,
                                                                               })
                        else:
                            self.pool.get('loan.xxt.payment').write(cr, uid, xxtis,{'pre_xxt_payment':prexxt,
                                                                                    'test_date':test_date,
                                                                                    'xxt_payment':xxt,
                                                                                    })
                    else:
                        print '--XXT = 0 --rate',rate,'balance',balance,'sd',sd,'xxt',xxt
                else:
                    print "dd"
            else:
                raise osv.except_osv(_('Warning !'), _('Сонгосон валют дээр зээл байхгүй байна.'))

    def action_to_confirm(self, cr, uid, ids, context=None):
        read_obj = self.read(cr,uid,ids)[0]
        lids = read_obj['lines']
        
        add_xxts = self.pool.get('loan.xxt.payment').search(cr,uid,[('parent_id','=',False),('state','=','confirmed')])
        self.pool.get('loan.xxt.payment').write(cr,uid,add_xxts,{'parent_id':read_obj['id']})
        
        if lids != []:
            for xxt in self.pool.get('loan.xxt.payment').browse(cr,uid,lids):
                xxt.action_to_confirm()
            print '______DONE__confirm all lines',self.write(cr,uid,ids,{'state':'confirmed'})

    def action_to_post(self, cr, uid, ids, context=None):
        read_obj = self.read(cr,uid,ids)[0]
        lids = read_obj['lines']
        if lids != []:
            for xxt in self.pool.get('loan.xxt.payment').browse(cr,uid,lids):
                xxt.action_to_payment()
            print '______DONE__post all lines',self.write(cr,uid,ids,{'state':'post'})
 
    def action_to_delete(self, cr, uid, ids, context=None):
        read_obj = self.read(cr,uid,ids)[0]
        lids = read_obj['lines']
        if lids != []:
            self.pool.get('loan.xxt.payment').unlink(cr,uid,lids)
            print '______DONE____reset all lines'
        
    def _get_days(self,now,last):
                print "lasr",last
		last_year = int(last[:4])
		last_mounth = int(last[5:7])
		last_day = int(last[8:])	
		
		now_year = int(now[:4])
		now_mounth = int(now[5:7])
		now_day = int(now[8:])	
		
		d0 = date(last_year, last_mounth, last_day)
		d1 = date(now_year, now_mounth, now_day)
		delta = d1 - d0
		return delta.days
    
accumlated_interest()

class loan_xxt_payment(osv.osv):
    _name = "loan.xxt.payment"
    _description = "Accumlated interest payment"

    _columns = {
        'parent_id': fields.many2one('accumlated.interest','Parent'),
        'loan_order': fields.many2one('loan.order','Loan contract number',domain=[('state', '=','paid')],required=True,states={'draft': [('readonly', False)]}),
		'xxt_payment':fields.float(u'Current accumlated interest',digits = (16,2),store=True,states={'draft': [('readonly', False)]}),
		'pre_xxt_payment':fields.float(u'Previous accumlated interest',digits = (16,2),store=True,states={'draft': [('readonly', False)]}),
		'test_date': fields.date(u'Test огноо(test)',required=True,states={'draft': [('readonly', False)]}),
		
        'name': fields.char('AI number', size=64, required=True,
            readonly=True, states={'draft': [('readonly', False)]}, select=True),
            
        'state': fields.selection([
            ('draft', 'Draft'),
            ('confirmed', 'Confirmed'),
            ('waitpayment', 'Waiting post'),
            ('posted', 'Posted'),
            ('paid', 'Paid'),
            ('cancel', 'Cancelled')
            ], 'State', readonly=True, help="HELP", select=True),
        'partner_id': fields.many2one('res.partner', 'Debtor', readonly=True, states={'draft': [('readonly', False)]}, required=True, change_default=True, select=True),
        'partner_address': fields.char(u'Address', size=256),
        'company_id':fields.many2one('res.company','Company'),
    }
    _defaults = {
        'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
        'state': 'draft',
        'parent_id': False,
        'name': lambda self, cr, uid, context: self.pool.get('ir.sequence').get(cr, uid, 'loan.xxt.payment'),
    }
    _sql_constraints = [
        ('name_uniq', 'unique(name)', 'AI number must be unique!'),
    ]
    _order = 'name desc'

#-------------------------------------ERP------------------------------------------
 
    def action_to_confirm(self, cr, uid, ids, context=None):
        print '----------------Test confirmed------------',self.write(cr, uid, ids, {'state': 'confirmed'})
        return True

    def action_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'draft'})
        print 'Cancel-------------'
        return True

    # Form filling
    def unlink(self, cr, uid, ids, context=None):
        sale_orders = self.read(cr, uid, ids, ['state'], context=context)
        unlink_ids = []
        for s in sale_orders:
            if s['state'] in ['draft', 'cancel']:
                unlink_ids.append(s['id'])
            else:
                raise osv.except_osv(_('Invalid action !'), _('In order to delete a confirmed sale order, you must cancel it before ! To cancel a sale order, you must first cancel related picking or delivery orders.'))

        return osv.osv.unlink(self, cr, uid, unlink_ids, context=context)

    def action_cancel_draft(self, cr, uid, ids, *args):
        print 'cancel loan.xxt.payment nothing...'
        return True

    def button_dummy(self, cr, uid, ids, context=None):
        return True

    def action_to_payment(self, cr, uid, ids, context=None):
        
        o = self.browse(cr, uid, ids)[0]
        xxt = o.xxt_payment
        
        jid = self.pool.get('account.journal').search(cr,uid,[('type','=','sale')],limit=1)[0]
        
        condition = ''
        if o.loan_order.loan_state == 'd00':
            condition = 'product_id'
        elif o.loan_order.loan_state == 'd90':
            condition = 'xxz_product'
        elif old_ls == 'd180':
            condition = 'xb_product'
        elif o.loan_order.loan_state == 'd360':
            condition = 'ez_product'
        elif o.loan_order.loan_state == 'd361g':
            condition = 'mz_product'
        
        cid = self.pool.get('configure.loan.product').search(cr,uid,[(condition,'=',o.loan_order.product_id.id)])[0]
        config = self.pool.get('configure.loan.product').browse(cr,uid,cid)
        xt_pro = config.xt_product
        accum_pro = config.xxt_product
        
        currency_id = o.loan_order.product_id.currency.id
        res_currency_obj = self.pool.get('res.currency')
        res_users_obj = self.pool.get('res.users')
        period = self.pool.get('account.period')
        company_currency_id = res_users_obj.browse(cr, uid, uid,context=context).company_id.currency_id.id
        if xxt > 0:
            period_id = period.search(cr, uid, [('date_start','<=',o.parent_id.name),('date_stop','>=',o.parent_id.name)])[0]
            amount_currency = res_currency_obj.compute(cr,uid, company_currency_id,currency_id,xxt, context=context)
            amount = 0.0
            if amount_currency == xxt:
                amount_currency = 0.0
                amount = xxt
            else:
                t = amount_currency
                amount_currency = xxt
                amount = t
                
            am_id = self.pool.get('account.move').create(cr,uid, {
                                    'name':o.name,
                                    'journal_id':jid,
                                    'date':o.parent_id.name,
                                    'period_id':period_id,
                                    'ref':o.loan_order.name})
            if company_currency_id == currency_id:
                aml_line = self.pool.get('account.move.line').create(cr,uid,{
    									'name':o.partner_id.name+ u' - Хүү хуримтлуулав.',
    									'partner_id':o.partner_id.id,
    									'account_id':accum_pro.property_account_income.id,
    									'debit':amount,
    									'move_id':am_id })
          
                aml_line2 = self.pool.get('account.move.line').create(cr,uid,{
    									'name':o.partner_id.name+ u' - Хүү хуримтлуулав.',
    									'partner_id':o.partner_id.id,
    									'account_id':xt_pro.property_account_income.id,
    									'credit':amount,
    									'move_id':am_id })
            else:
                aml_line = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':o.partner_id.name+ u' - Хүү хуримтлуулав.',
                                        'partner_id':o.partner_id.id,
                                        'account_id':accum_pro.property_account_income.id,
                                        'debit':amount,
                                        'currency_id':currency_id,
                                        'amount_currency':amount_currency*(-1),
                                        'move_id':am_id })
          
                aml_line2 = self.pool.get('account.move.line').create(cr,uid,{
                                        'name':o.partner_id.name+ u' - Хүү хуримтлуулав.',
                                        'partner_id':o.partner_id.id,
                                        'account_id':xt_pro.property_account_income.id,
                                        'credit':amount,
                                        'currency_id':currency_id,
                                        'amount_currency':amount_currency*(-1),
                                        'move_id':am_id })        
        else:
	        raise osv.except_osv(_('Warning !'), _('Accumlated interest is invalid!'))

        amove = self.pool.get('account.move').browse(cr,uid,am_id)
        amove.button_validate()
        self.write(cr, uid, ids, {'state': 'posted'})
        print 'lp-xxt history',self.pool.get('loan.account.statement').create(cr,uid, {
                                    'contract_id':o.loan_order.id,
                                    'name':u'Хүү хуримтлуулав.',
                                    'write_date':o.test_date,
                                    'debit_xx':xxt})
        
        return am_id

loan_xxt_payment()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
