# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from c2c_reporting_tools.reports.standard_report import *
from c2c_reporting_tools.flowables.simple_row_table import *
from c2c_reporting_tools.c2c_helper import *
from c2c_reporting_tools.translation import _
from reportlab.platypus import *
from reportlab.lib.pagesizes import letter,A4,inch,cm
from reportlab.lib.colors import red, black, navy, white, green
from reportlab.lib.enums import TA_LEFT, TA_RIGHT, TA_CENTER, TA_JUSTIFY
from reportlab.lib.styles import ParagraphStyle
# from reportlab.graphics
 
 
class loan_append_schedule_report(StandardReport):
     
    ''' Зээлийн график төлөлтийн тайлан
    '''
     
    def get_story(self):
        ''' Тайлангийн өгөгдлүүдийг PDF форматаар зурна.
        '''
        story = []
        cr = self.cr
        uid = self.uid 
        context = self.context
        data = self.datas['form']
 
        # Styles        
        styNormalC = ParagraphStyle('normal',fontName='Helvetica-Bold', fontSize=12,leading=4,
                textColor=black,alignment=TA_CENTER, rightIndent=0,spaceAfter=5)
        styNormalR = ParagraphStyle('normal',fontName='DejaVu Sans', fontSize=8,leading=30,
                textColor=black,alignment=TA_RIGHT, rightIndent=50,spaceAfter=5)
        styNormalL = ParagraphStyle('normal',fontName='DejaVu Sans', fontSize=8,leading=30,
                textColor=black,alignment=TA_LEFT, rightIndent=50,spaceAfter=5)
        th_style = ParagraphStyle('tableheaderbold', fontName='Helvetica-Bold', fontSize=8, leading=8, 
                    alignment=TA_CENTER, leftIndent=3, rightIndent=3, spaceAfter=2, spaceBefore=2)
        td_right_style = ParagraphStyle('tabledataright', fontName='Helvetica-Bold', fontSize=8, leading=8, 
                        alignment=TA_RIGHT, leftIndent=3, rightIndent=1, spaceAfter=2, spaceBefore=2)
        td_left_style = ParagraphStyle('tabledataleft', fontName='Helvetica-Bold', fontSize=8, leading=8, 
                        alignment=TA_LEFT, leftIndent=1, rightIndent=1, spaceAfter=2, spaceBefore=2)
        td_left_style1 = ParagraphStyle('tabledataleft', fontName='Helvetica-Bold', fontSize=8, leading=8, 
                        alignment=TA_LEFT, leftIndent=1, rightIndent=1, spaceAfter=1, spaceBefore=2)
        td_center_style = ParagraphStyle('tabledatacenter', fontName='Helvetica', fontSize=8, leading=8, 
                        alignment=TA_CENTER, leftIndent=1, rightIndent=3, spaceAfter=1, spaceBefore=1, )
        td_center_bold_style = ParagraphStyle('tabledataleft', fontName='Helvetica-Bold', fontSize=8, leading=8, 
                        alignment=TA_CENTER, leftIndent=1, rightIndent=3, spaceAfter=1, spaceBefore=2)
        td_right_bold_style = ParagraphStyle('tabledataright', fontName='Helvetica-Bold', fontSize=8, leading=8, 
                        alignment=TA_RIGHT, leftIndent=3, rightIndent=1, spaceAfter=1, spaceBefore=2)
        nullpara = Paragraph('', td_right_style)
         
      
        tmpNormalL = ParagraphStyle('normal',fontName='DejaVu Sans', fontSize=8,leading=10,
                    textColor=black,alignment=TA_LEFT, leftIndent=40,spaceAfter=8, wordWrap = None)
        tmpNormalC = ParagraphStyle('normal',fontName='DejaVu Sans', fontSize=8,leading=10,
                    textColor=black,alignment=TA_CENTER, leftIndent=40,spaceAfter=5)
        tmpNormalR = ParagraphStyle('normal',fontName='DejaVu Sans', fontSize=8,leading=10,
                    textColor=black,alignment=TA_RIGHT, rightIndent=50,spaceAfter=5)
        tmpNormalLb = ParagraphStyle('normal',fontName='DejaVu Sans Bold', fontSize=10,leading=10,
                    textColor=black,alignment=TA_LEFT, leftIndent=40,spaceAfter=5)
        tmpStyleR = ParagraphStyle('normal',fontName='DejaVu Sans', fontSize=8,leading=10,
                textColor=black,alignment=TA_RIGHT, rightIndent=50,spaceAfter=5)
        tmpStyleL = ParagraphStyle('normal',fontName='DejaVu Sans', fontSize=8,leading=0,
                textColor=black,alignment=TA_LEFT, leftIndent=50,spaceAfter=5)
        tmpStyleC = ParagraphStyle('normal',fontName='DejaVu Sans', fontSize=8,leading=10,
                    textColor=black,alignment=TA_CENTER, rightIndent=20,spaceAfter=5)

         
        widths = [ 27*mm, 20*mm, 25*mm, 28*mm, 25*mm, 26*mm, 26*mm, 26*mm]
        style_list = [
            ('BOX', (0,0), (-1,-1), 0.60, colors.black),
            ('GRID', (0,0), (-1,2), 0.40, colors.black),
            ('LINEAFTER', (0,3),(-1,-2), 0.30, colors.grey),
            ('LINEBELOW', (0,3), (-1,-2), 0.30, colors.black),
            ('GRID', (0,-1),(-1,-2), 0.20, colors.black), # lightgrey
            ('VALIGN',(0,0),(-1,-1),'MIDDLE'),
            ('VALIGN',(0,0),(-1,-1),'MIDDLE'),
            ('LEFTPADDING', (0,0),(-1,-1), 1),
            ('RIGHTPADDING', (0,0),(-1,-1), 1),
            ('BOTTOMPADDING', (0,0),(-1,-1), 3),
            ('TOPPADDING', (0,0),(-1,-1), 3),
        ]
        
          
        grid = [[
            Paragraph(u'Хуваарийн нэр', th_style),
            Paragraph(u'Огноо', th_style),
            Paragraph(u'Хүү бодогдсон хоног', th_style),
            Paragraph(u'Зээл', th_style),
            Paragraph(u'Хүү', th_style),
            Paragraph(u'Нийт төлбөр', th_style),
            Paragraph(u'Үлдэгдэл', th_style),
            Paragraph(u'илүү/дутуу(+/-)', th_style),
        ]]
        
        company = data['company_id'][1]
        
        line = self.pool.get('res.company').browse(cr,uid,data['company_id'][0])
        if line['logo'] !=False:
            image =base64.decodestring(line['logo'])
            file = StringIO.StringIO(image)
            im = Image(file,2*cm,1.8*cm)
            im.hAlign = 'RIGHT'
            
            tit = [[
                im,
                Paragraph(u'Байгууллагын нэр : %s' % company, styNormalL)
            ]]
        else:
              tit = [[
                Paragraph(u'Байгууллагын нэр : %s' % company, styNormalR)
            ]]
        t = Table(tit,'80%',repeatRows=1)
        story.append(t)

         
        i=1
        sum = 0
        append_obj = self.pool.get('loan.append')
        loan = append_obj.browse(cr, uid, context['active_id'])
        story.append(Paragraph(u"%s зээлдэгчийн %s дугаартай зээлийн зээл, хүү төлөх хуваарь"%(loan.partner_id.name,loan.name), styNormalC))
        story.append(Spacer(8,8))

        story.append(Spacer(5,5))
        story.append(Paragraph(u"Хэвлэсэн огноо : %s" % time.strftime('%Y-%m-%d'),tmpStyleR))
        story.append(Spacer(5,5))
        interest_sum = 0.0
        day_sum = 0.0
        loan_sum = 0.0
        total_sum = 0.0
        i = 0
        for grap in loan.schedules:
            i +=1
            row = [
                Paragraph(u'%s'%(str(i)+". "+grap.payment_date), th_style),
                Paragraph(u'%s'%grap.payment_date, th_style),
                Paragraph(u'%s'%grap.days, th_style),
                Paragraph(u'%s'%grap.loan_payment, th_style),
                Paragraph(u'%s'%grap.interest_payment, th_style),
                Paragraph(u'%s'%grap.total_payment, th_style),
                Paragraph(u'%s'%grap.balance, th_style),
                Paragraph(u'%s'%grap.remaining_payment, th_style),
            ]
            grid.append( row )
            day_sum += grap.days
            interest_sum += grap.interest_payment
            loan_sum += grap.loan_payment
            total_sum += grap.total_payment
        row = [
            Paragraph(u'Дүн', td_center_bold_style),
            nullpara,
            Paragraph(u"%s"% day_sum , td_center_bold_style),
            Paragraph(u"%s"% loan_sum, td_center_bold_style),
            Paragraph(u"%s"%interest_sum , td_center_bold_style),
            Paragraph(u"%s"%total_sum , td_center_bold_style),
            nullpara,
            nullpara,
        ]
        grid.append( row )
                 
        t = Table(grid,'80%',repeatRows=2)
        t.setStyle(TableStyle(style_list))
        t._argW = widths
    
        story.append(t)   
        story.append(Spacer(20,20))
        tsGrid = TableStyle([
                ('GRID', (0,0), (-1,-1), 0.25, colors.white),
                ('FONT', (0,0),(-1,-1),'Helvetica', 8)
        ])
        grd = [
            [Paragraph(u'Зээлдүүлэгчийг төлөөлж:', td_left_style), 
             Paragraph(u'Зээлдэгчийг төлөөлж:', td_left_style)],
            [Paragraph(u'Захирал....................................../<font color="white">_____________________</font>/', td_left_style)
             ,Paragraph(u'Зээлдэгч: %s/<font color="white">_____________________</font>/'%loan.partner_id.name, td_left_style)],
            [Paragraph(u'Эдийн засагч: %s/<font color="white">_____________________</font>/'%loan.current_economist.name, td_left_style)
             ,nullpara]
        ]
        story.append(Table(grd, style=tsGrid, colWidths=[100*mm,100*mm]))
        return story
 
loan_append_schedule_report('report.loan.append.schedule', "Зээл, хүү төлөх хуваарь", 'loan.order', StandardReport.A4_PORTRAIT)


