# -*- coding: utf-8 -*-
from report import report_sxw
from osv import osv
from tools.translate import _
import time
import datetime

class report_partner_agreement(report_sxw.rml_parse):
	_name = 'report.partner.agreement'
	
	def _get_company(self,cr,uid,context):
		res = {}
		cids = self.pool.get('res.company').search(cr,uid,[('id','!=',-1)],limit=1)
		company = self.pool.get('res.company').browse(cr,uid,cids[len(cids)-1])
		res['name'] = company.name
		res['city'] = company.city
		res['register'] = company.company_registry
		res['street'] = company.street
		res['phone'] = company.phone
		res['email'] = company.email
		res['country'] = company.country_id.name
		return res

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def __init__(self, cr, uid, name, context):
		super(report_partner_agreement, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'company_name': self._get_company(cr,uid,context)['name'],
        	'user':self._get_user(cr,uid,context),
        })
	
report_sxw.report_sxw('report.partner.agreement', 'loan.order', 'addons/bbsb_loan/report/report_10_partner_agreement.rml', parser=report_partner_agreement, header=False )
