# -*- coding: utf-8 -*-
from report import report_sxw
from openerp.osv import osv
from tools.translate import _
import time
import datetime

class report_contract_collateral(report_sxw.rml_parse):
	_name = 'report.contract.collateral'
	
	def _get_company(self,cr,uid,context):
		res = {}
		cids = self.pool.get('res.company').search(cr,uid,[('id','!=',-1)],limit=1)
		company = self.pool.get('res.company').browse(cr,uid,cids[len(cids)-1])
		res['name'] = company.name
		res['city'] = company.city
		res['register'] = company.company_registry
		res['street'] = company.street
		res['phone'] = company.phone
		res['email'] = company.email
		res['country'] = company.country_id.name
		return res

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def _get_pmt(self,lid):
		pmt = 0.0
		lorder = self.pool.get('loan.order').browse(self.cr,self.uid,lid)
		t = lorder.period
		xvv = lorder.interest
		amount = lorder.amount
		if lorder.schedule_type == 'type1':
			c = xvv/100
			a = 1+c
			b = 1/pow(a,t)
			d = (1-b)/c
			pmt = amount/d	
			print '__',lid,pmt
		elif lorder.schedule_type == 'type2':
			pmt = lorder.fixed_payment
		else:
			pmt = 0
		
		pmt = round(pmt,2)	
		return pmt

	def _get_graphics(self,loid):
		gids = self.pool.get('loan.schedule').search(self.cr,self.uid,[('contract_id','=',loid)],order = 'id')
		print gids,'------GRAPS'
		grap = self.pool.get('loan.schedule').browse(self.cr,self.uid,gids)
		return grap

	def _get_grap_total(self,loid):
		res = {}
		gids = self.pool.get('loan.schedule').search(self.cr,self.uid,[('contract_id','=',loid)],order = 'id')
		print gids,'------GRAPS totals'
		xvv = 0.0
		lp = 0.0
		tp = 0.0
		for grap in self.pool.get('loan.schedule').browse(self.cr,self.uid,gids):
			xvv += grap.interest_payment
			lp += grap.loan_payment
			tp += grap.total_payment
		res['xvv'] = xvv
		res['lp'] = lp
		res['tp'] = tp	
		return res

	def __init__(self, cr, uid, name, context):
		super(report_contract_collateral, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'company_name': self._get_company(cr,uid,context)['name'],
        	'company_city': self._get_company(cr,uid,context)['city'],
        	'company_street': self._get_company(cr,uid,context)['street'],
        	'company_phone': self._get_company(cr,uid,context)['phone'],
        	'company_email': self._get_company(cr,uid,context)['email'],
        	'company_country': self._get_company(cr,uid,context)['country'],
        	'pmt_amount':self._get_pmt,
        	'get_graphics': self._get_graphics,
        	'get_grap_total': self._get_grap_total,
        })
	
report_sxw.report_sxw('report.contract.collateral', 'loan.order', 'addons/bbsb_loan/report/report_11_contract_collateral.rml', parser=report_contract_collateral, header=False )
