# -*- coding: utf-8 -*-
from report import report_sxw
from osv import osv
from tools.translate import _
import time
import datetime

class report_loan_history(report_sxw.rml_parse):
	_name = 'report.loan.history'
	
	def _get_company(self,cr,uid,context):
		res = {}
		cids = self.pool.get('res.company').search(cr,uid,[('id','!=',-1)],limit=1)
		company = self.pool.get('res.company').browse(cr,uid,cids[len(cids)-1])
		res['name'] = company.name
		res['city'] = company.city
		res['register'] = company.company_registry
		res['street'] = company.street
		res['phone'] = company.phone
		res['email'] = company.email
		res['country'] = company.country_id.name
		return res

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def _get_statements(self,lid):
		number = 1 
		sids = self.pool.get('loan.account.statement').search(self.cr,self.uid,[('contract_id','=',lid)],order='changed_date')
		statements = self.pool.get('loan.account.statement').browse(self.cr,self.uid,sids)
		print len(sids)
		number += 1
		return statements	

	def __init__(self, cr, uid, name, context):
		super(report_loan_history, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'company_name': self._get_company(cr,uid,context)['name'],
        	'company_city': self._get_company(cr,uid,context)['city'],
        	'company_street': self._get_company(cr,uid,context)['street'],
        	'company_phone': self._get_company(cr,uid,context)['phone'],
        	'company_email': self._get_company(cr,uid,context)['email'],
        	'company_country': self._get_company(cr,uid,context)['country'],
        	'get_statements':self._get_statements,
        })
	
report_sxw.report_sxw('report.loan.histoty', 'loan.order', 'addons/bbsb_loan/report/report_12_loan_history.rml', parser=report_loan_history, header=False )
