# -*- coding: utf-8 -*-
from report import report_sxw
from osv import osv
from tools.translate import _
import time
import datetime

class report_loan_statement(report_sxw.rml_parse):
	_name = 'report.loan.statement'
	
	def _get_contract(self,cr,uid,context):
		res = {}
		lid = context['loan_id']
		loan = self.pool.get('loan.order').browse(cr,uid,lid)
		
		res['name'] = loan.name
		res['partner'] = loan.partner_id.name
		res['balance'] = loan.loan_balance
		res['interest'] = loan.interest
		res['h_date'] = context['h_date']
		return res

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def _get_statements(self,cr,uid,context):
		hid = context['history_id']
		sids = self.pool.get('loan.account.statement').search(cr,uid,[('history_id','=',hid)],order='id')
		
		statements = self.pool.get('loan.account.statement').browse(cr,uid,sids)
		print sids
		return statements

	def __init__(self, cr, uid, name, context):
		super(report_loan_statement, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'contract': self._get_contract(cr,uid,context),
        	'get_statements':self._get_statements(cr,uid,context),
        })
	
report_sxw.report_sxw('report.loan.statement', 'loan.order', 'addons/bbsb_loan/report/report_13_loan_statement.rml', parser=report_loan_statement, header=False )
