# -*- coding: utf-8 -*-
from report import report_sxw
from osv import osv
from tools.translate import _
import time
import datetime

class report_loan_order_info(report_sxw.rml_parse):
	_name = 'report.loan.order.info'
	
	def _get_loans(self,cr,uid,context):
		res = []
		loans = None
		product_id = context['product']
		if product_id:
			lids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),
												('date_approve','>=',context['from_date']),
												('date_approve','<=',context['to_date']),('product_id','=',product_id[0])])
		else:
			lids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),
												('date_approve','>=',context['from_date']),
												('date_approve','<=',context['to_date'])])
			if lids == []:
				raise osv.except_osv(_('Warning!'),_('Таны сонгосон хугацаанд зээл олгогдоогүй байна!'))

			loans = self.pool.get('loan.order').browse(cr,uid,lids)
						
		return loans

	def __init__(self, cr, uid, name, context):
		super(report_loan_order_info, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'time_from': context['from_date'],
        	'time_to': context['to_date'],
        	'get_loans': self._get_loans(cr,uid,context),
        })
	
report_sxw.report_sxw('report.loan.order.info', 'loan.order', 'addons/bbsb_loan/report/report_14_loan_order_info.rml', parser=report_loan_order_info, header=False )
