# -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import date
from osv import osv
import datetime
from tools.translate import _
from c2c_reporting_tools.reports.standard_report import *
from c2c_reporting_tools.flowables.simple_row_table import *
from c2c_reporting_tools.c2c_helper import *
from c2c_reporting_tools.translation import _
from reportlab.platypus import *
from reportlab.lib.colors import red, black, navy, white, green
from reportlab.lib.enums import TA_LEFT, TA_RIGHT, TA_CENTER, TA_JUSTIFY
from reportlab.lib.pagesizes import letter,A4,inch,cm
from pkgutil import get_loader

class report_loans_info(report_sxw.rml_parse):
	_name = 'report.loans.info'

	def _get_loans(self,cr,uid,context):
		res = []
		pid = context['product']
		loids = []
		if pid:
			lids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('product_id','=',pid[0]),('date_approve','>=',context['from_date']),('date_approve','<=',context['to_date'])])
		else:
			lids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('date_approve','>=',context['from_date']),('date_approve','<=',context['to_date'])])
		for lid in lids:
			loids.append(lid)
			
		#if loids == []:
		#	raise osv.except_osv(_('Warning!'),_('Not found loans'))
		loans = self.pool.get('loan.order').browse(cr,uid,loids)
		return loans

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def _get_loan_history(self,lid):
		res = {}
		date_from = self.ctx['from_date']
		date_to = self.ctx['to_date']
		
		lorder = self.pool.get('loan.order').browse(self.cr,self.uid,lid)
		hids = []
		lhids = self.pool.get('loan.account.statement').search(self.cr,self.uid,
													[('write_date','>=',date_from),
													 ('write_date','<=',date_to),])
		
		l_balance = 0
		debit = 0
		credit = 0
		
		if lorder.date_approve == date_from:
			f_balance = lorder.amount
		elif lorder.date_approve > date_from:
			f_balance = lorder.amount
			credit = lorder.amount
		else:
			f_balance = lorder.loan_balance
			
		for hline in lhids:
 				self.cr.execute("select sum(payment) from loan_account_statement "
                   "where "
                   "changed_date >= %s and changed_date <= %s and contract_id = %s",
                    (date_from, date_to, lid))
             	fetched = self.cr.fetchone()
             	if fetched !=None:
                	debit += fetched[0]
		
		if debit > 0:
			l_balance = credit - debit
		else:
			l_balance = f_balance - debit
			
		res['f_balance'] = f_balance
		res['l_balance'] = l_balance
		res['debit'] = debit
		res['credit'] = credit
		
		check_id = lorder['id']
		
		if check_id == lid and self.check == False:
		
			self.check = True;
			self.check_id = lid
			self.total_zf_balance += f_balance
			self.total_zl_balance += l_balance
			self.total_zcredit += credit
			self.total_zdebit += debit
		elif self.check_id != lid and self.check==True:
			self.check_id = lid
			self.total_zf_balance += f_balance
			self.total_zl_balance += l_balance
			self.total_zcredit += credit
			self.total_zdebit += debit
			
		
				
		return res

	def _get_xxt_history(self,lid):
		res = {}
		date_from = self.ctx['from_date']
		date_to = self.ctx['to_date']
		
		lorder = self.pool.get('loan.order').browse(self.cr,self.uid,lid)
		
		lhids0 = self.pool.get('loan.account.statement').search(self.cr,self.uid,[('write_date','<',date_from)])
		hids = []
		lhids = self.pool.get('loan.account.statement').search(self.cr,self.uid,
													[('write_date','>=',date_from),
													 ('write_date','<=',date_to),])
		
		f_balance = 0
		l_balance = 0

		debit0 = 0
		credit0 = 0
		for his in self.pool.get('loan.account.statement').browse(self.cr,self.uid,lhids0):
			debit0 += his.debit_xx
			credit0 += his.credit_xx
		
		debit1 = 0
		credit1 = 0
# 		for his in self.pool.get('loan.account.statement').browse(self.cr,self.uid,lhids):
		for hline in lhids:
				self.cr.execute("select sum(debit_xx) from loan_account_statement "
                   "where "
                   "changed_date >= %s and changed_date <= %s and contract_id = %s",
                    (date_from, date_to, lid))
             	fetched = self.cr.fetchone()
             	if fetched !=None:
                	debit1 += fetched[0]
                	
               	self.cr.execute("select sum(credit_xx) from loan_account_statement "
                   "where "
                   "changed_date >= %s and changed_date <= %s and contract_id = %s",
                    (date_from, date_to, lid))
             	fetched = self.cr.fetchone()
             	if fetched !=None:
                	credit1 += fetched[0]
		
		debit = 0 
		credit = 0
		
		if lorder.date_approve == date_from:
			f_balance = 0
			debit = debit1
			credit = credit1
		elif lorder.date_approve > date_from:
			f_balance = 0
			debit = debit1
			credit = credit1
		else:
			f_balance = debit0 - credit0
			debit = debit1
			credit = credit1
			
		if debit > 0:
			l_balance = debit - credit
		else:
			l_balance = f_balance - credit

		xxtid = self.pool.get('loan.xxt.payment').search(self.cr, self.uid, [('loan_order', '=',lorder.id),('state','!=','draft')],order='id desc')
		xtid = self.pool.get('loan.payment').search(self.cr, self.uid, [('loan_order', '=',lorder.id),('state','=','paid')],order='id desc')
		last_date = ''
		one = 0
		if xtid == [] and xxtid == []: 
			last_date = lorder.date_approve
			one = 1
		elif xtid != [] and xxtid == []:
			xt = self.pool.get('loan.payment').browse(self.cr,self.uid,xtid[0])    
			last_date = xt.date_order
			one = 1
		elif xtid == [] and xxtid != []:
			xxt = self.pool.get('loan.xxt.payment').browse(self.cr,self.uid,xxtid[0])    
			last_date = xxt.test_date
		elif xtid != [] and xxtid != []:
			# xt- хүүгийн төлбөр
			xt = self.pool.get('loan.payment').browse(self.cr,self.uid,xtid[0])
			#xxt - хуримтлагдсан хүүгийн төлбөр    
			xxt = self.pool.get('loan.xxt.payment').browse(self.cr,self.uid,xxtid[0])    
			if xt.date_order <= xxt.test_date:
				last_date = xxt.test_date
				one = 1
			else:
				last_date = xt.date_order
		
		d0 = date(int(last_date[:4]),int(last_date[5:7]),int(last_date[8:]))
		
		d1 = date(int(date_to[:4]),int(date_to[5:7]),int(date_to[8:]))
		
		delta = d1 - d0
		sd = delta.days
		c = lorder.interest/100
		txvv = lorder.loan_balance*c/30*sd
# 		test = _get_balance(self,self.cr,self.uid,lid)
		res['f_balance'] = f_balance
		res['l_balance'] = l_balance
		res['debit'] = debit
		res['credit'] = credit
		res['t_xvv'] = txvv
		
		check_id = lorder['id']
		
		if check_id == lid and self.check_xx == False:
			self.total_f_balance += f_balance
			self.total_l_balance += l_balance
			self.total_credit += credit
			self.total_debit += debit
			self.total_txvv += txvv
			self.check_xx = True
			self.check_xx_id = lid
		elif self.check_xx_id != lid and self.check_xx == True:
			self.check_xx_id = lid
			self.total_f_balance += f_balance
			self.total_l_balance += l_balance
			self.total_credit += credit
			self.total_debit += debit
			self.total_txvv += txvv
			
		return res
	
	
	
	def _get_total_zf_balance(self):
		return self.total_zf_balance

	def _get_total_zl_balance(self):
		return self.total_zl_balance

	def _get_total_zcredit(self):
		return self.total_zcredit
        
	def _get_total_zdebit(self):
		return self.total_zdebit

	def _get_total_f_balance(self):
		return self.total_f_balance

	def _get_total_l_balance(self):
		return self.total_l_balance

	def _get_total_credit(self):
		return self.total_credit
        
	def _get_total_debit(self):
		return self.total_debit
#
	def _get_total_txvv(self):
		return self.total_txvv
                
	def __init__(self, cr, uid, name, context):
		super(report_loans_info, self).__init__(cr, uid, name, context=context)
		self.ctx = context
		self.check = False
		self.check_xx = False
		self.check_id = 0
		self.check_xx_id = 0
		self.total_zf_balance = 0.0
		self.total_zl_balance = 0.0
		self.total_zcredit = 0.0
		self.total_zdebit = 0.0
		self.total_f_balance = 0.0
		self.total_l_balance = 0.0
		self.total_credit = 0.0
		self.total_debit = 0.0
		self.total_txvv = 0.0
		
		com_logo = self.pool.get('res.company').browse(cr, uid, [1])[0].logo
		print "com_logo : " , com_logo
		image =base64.decodestring(com_logo)
		file = StringIO.StringIO(image)
		im = Image(file,2*cm,1.8*cm)
		im.hAlign = 'RIGHT'
		print "im : " , im
		self.localcontext.update({
        	'time': time,
			'user':self._get_user(cr,uid,context),
        	'from_date':context['from_date'],
        	'to_date':context['to_date'],
        	'get_loan_history':self._get_loan_history,
        	'get_xxt_history':self._get_xxt_history,
        	'loans':self._get_loans(cr,uid,context),
			'im':com_logo,
        	'get_total_zfbalance':self._get_total_zf_balance,
        	'get_total_zlbalance':self._get_total_zl_balance,
        	'get_total_fbalance':self._get_total_f_balance,
        	'get_total_lbalance':self._get_total_l_balance,
        	'get_total_txvv':self._get_total_txvv,
        	'get_total_zdebit':self._get_total_zdebit,
        	'get_total_debit':self._get_total_debit,
        	'get_total_zcredit':self._get_total_zcredit,
        	'get_total_credit':self._get_total_credit,
        })
		
		
report_sxw.report_sxw('report.loans.info', 'loan.order', 'addons/bbsb_loan/report/report_1_loans_info.rml', parser=report_loans_info, header = False )

class report_loans_export(StandardReport):
    ''' Зээлийн тайлан excel export хийх class
    '''
    def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name
	
    def _get_loans(self,cr,uid,context):
		res = []
		pid = context['product']
		loids = []
		if pid:
			lids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('product_id','=',pid[0]),('date_approve','>=',context['from_date']),('date_approve','<=',context['to_date'])])
		else:
			lids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('date_approve','>=',context['from_date']),('date_approve','<=',context['to_date'])])
		for lid in lids:
			loids.append(lid)
			
		if loids == []:
			raise osv.except_osv(_('Warning!'),_('Not found loans'))
			
		loans = self.pool.get('loan.order').browse(cr,uid,loids)
		return loans

    def _get_loan_history(self,lid):
		res = {}
		date_from = self.context['from_date']
		date_to = self.context['to_date']
		lorder = self.pool.get('loan.order').browse(self.cr,self.uid,lid)
		hids = []
		lhids = self.pool.get('loan.account.statement').search(self.cr,self.uid,
													[('write_date','>=',date_from),
													 ('write_date','<=',date_to),])
		l_balance = 0
		debit = 0
		credit = 0
		
		if lorder.date_approve == date_from:
			f_balance = lorder.amount
		elif lorder.date_approve > date_from:
			f_balance = lorder.amount
			credit = lorder.amount
		else:
			f_balance = lorder.loan_balance
			
		for hline in lhids:
 				self.cr.execute("select sum(payment) from loan_account_statement "
                   "where "
                   "changed_date >= %s and changed_date <= %s and contract_id = %s",
                    (date_from, date_to, lid))
             	fetched = self.cr.fetchone()
             	if fetched !=None:
                	debit += fetched[0]
		
		if debit > 0:
			l_balance = credit - debit
		else:
			l_balance = f_balance - debit
		res['f_balance'] = f_balance
		res['l_balance'] = l_balance
		res['debit'] = debit
		res['credit'] = credit
		
		return res

    def _get_xxt_history(self,lid):
		res = {}
		date_from = self.context['from_date']
		date_to = self.context['to_date']
		
		lorder = self.pool.get('loan.order').browse(self.cr,self.uid,lid)
		
		lhids0 = self.pool.get('loan.account.statement').search(self.cr,self.uid,[('write_date','<',date_from)])
		hids = []
		lhids = self.pool.get('loan.account.statement').search(self.cr,self.uid,
													[('write_date','>=',date_from),
													 ('write_date','<=',date_to),])
		
		f_balance = 0
		l_balance = 0

		debit0 = 0
		credit0 = 0
		for his in self.pool.get('loan.account.statement').browse(self.cr,self.uid,lhids0):
			debit0 += his.debit_xx
			credit0 += his.credit_xx
		
		debit1 = 0
		credit1 = 0
		for hline in lhids:
				self.cr.execute("select sum(debit_xx) from loan_account_statement "
                   "where "
                   "changed_date >= %s and changed_date <= %s and contract_id = %s",
                    (date_from, date_to, lid))
             	fetched = self.cr.fetchone()
             	if fetched !=None:
                	debit1 += fetched[0]
                	
               	self.cr.execute("select sum(credit_xx) from loan_account_statement "
                   "where "
                   "changed_date >= %s and changed_date <= %s and contract_id = %s",
                    (date_from, date_to, lid))
             	fetched = self.cr.fetchone()
             	if fetched !=None:
                	credit1 += fetched[0]
		
		debit = 0 
		credit = 0
		
		if lorder.date_approve == date_from:
			f_balance = 0
			debit = debit1
			credit = credit1
		elif lorder.date_approve > date_from:
			f_balance = 0
			debit = debit1
			credit = credit1
		else:
			f_balance = debit0 - credit0
			debit = debit1
			credit = credit1
			
		if debit > 0:
			l_balance = debit - credit
		else:
			l_balance = f_balance - credit

		xxtid = self.pool.get('loan.xxt.payment').search(self.cr, self.uid, [('loan_order', '=',lorder.id),('state','!=','draft')],order='id desc')
		xtid = self.pool.get('loan.payment').search(self.cr, self.uid, [('loan_order', '=',lorder.id),('state','!=','paid')],order='id desc')
		last_date = ''
		one = 0
		if xtid == [] and xxtid == []: 
			last_date = lorder.date_approve
			one = 1
		elif xtid != [] and xxtid == []:
			xt = self.pool.get('loan.payment').browse(self.cr,self.uid,xtid[0])    
			last_date = xt.date_order
			one = 1
		elif xtid == [] and xxtid != []:
			xxt = self.pool.get('loan.xxt.payment').browse(self.cr,self.uid,xxtid[0])
			last_date = xxt.test_date
		elif xtid != [] and xxtid != []:
			# xt- хүүгийн төлбөр
			xt = self.pool.get('loan.payment').browse(self.cr,self.uid,xtid[0])
			#xxt - хуримтлагдсан хүүгийн төлбөр    
			xxt = self.pool.get('loan.xxt.payment').browse(self.cr,self.uid,xxtid[0])    
			if xt.date_order <= xxt.test_date:
				last_date = xxt.test_date
				one = 1
			else:
				last_date = xt.date_order
		d0 = date(int(last_date[:4]),int(last_date[5:7]),int(last_date[8:]))
		d1 = date(int(date_to[:4]),int(date_to[5:7]),int(date_to[8:]))
		delta = d1 - d0
		sd = delta.days
		c = lorder.interest/100
		txvv = lorder.loan_balance*c/30*sd
		res['f_balance'] = f_balance
		res['l_balance'] = l_balance
		res['debit'] = debit
		res['credit'] = credit
		if txvv > 0.0:
			res['t_xvv'] = txvv
		else:
			res['t_xvv'] = 0
		
		return res

	
    def export_report(self, cr, uid, data, context):
    	res = []
    	res2 ={}
    	count = 0
    	date_from  = context['from_date']
    	date_to = context['to_date']
    	f_balance = 0
    	l_balance = 0
    	debit = 0
    	credit = 0
    	if data == []:
    		raise osv.except_osv(_('Warning!'),_('Not found loans'))
    	else:
    		loans = self._get_loans(cr, uid, context)
    		index = 0
    		for loan in loans:
	    		 res2 = {
					 'contract' : loan.name,
					 'product_name' : loan.product_id.name ,
					 'partner_name' : loan.partner_id.name,
					 'installment_date' : loan.installment_date,
					 'close_date' : loan.close_date,
					 'interest' : loan.interest,
					 'f_balance' : self._get_loan_history(loan.id)['f_balance'],
					 'debit' : self._get_loan_history(loan.id)['debit'],
					 'credit' : self._get_loan_history(loan.id)['credit'],
					 'l_balance' : self._get_loan_history(loan.id)['l_balance'],
					 'hhf_balance' : self._get_xxt_history(loan.id)['f_balance'],
					 'hhdebit' : self._get_xxt_history(loan.id)['debit'],
			  		 'hhcredit' : self._get_xxt_history(loan.id)['credit'],
				   	 'hhl_balance' : self._get_xxt_history(loan.id)['l_balance'],
				   	 't_xvv' : self._get_xxt_history(loan.id)['t_xvv'],
				   	 'current_economist' : loan.current_economist.id,
				   	 'user_name' : self._get_user(cr,uid,context),
				   	 }
	    	 	 res.append(res2)
	    	
     	 	return res
	
	

report_loans_export('report.laons.export', "Loans Report", 'loan.order', StandardReport.A4_PORTRAIT)


