# -*- coding: utf-8 -*-
from report import report_sxw
import time
from osv import osv
import datetime
from tools.translate import _

class report_season_info(report_sxw.rml_parse):
	_name = 'report.season.report.info'
	
	def _get_loans(self,cr,uid,context):
		print context['from_date'],context['to_date']
		product_id = context['product']
		if product_id:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('product_id','=',product_id[0])])
		else:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid')])
		if loids == []:
			raise osv.except_osv(_('Warning!'),_('Not found loans'))
			
		loans = self.pool.get('loan.order').browse(cr,uid,loids)
		return loans

    
	def _get_company(self,cr,uid,context):
		res = {}
		cids = self.pool.get('res.company').search(cr,uid,[('id','!=',-1)],limit=1)
		print '+cids',cids
		company = self.pool.get('res.company').browse(cr,uid,cids[len(cids)-1])
		res['name'] = company.name
		res['city'] = company.city
		res['register'] = company.company_registry
		res['street'] = company.street
		return res
    
	def __init__(self, cr, uid, name, context):
		super(report_season_info, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'company_name': self._get_company(cr,uid,context)['name'],
        	'company_city': self._get_company(cr,uid,context)['city'],
        	'company_street': self._get_company(cr,uid,context)['street'],
        	'company_register': self._get_company(cr,uid,context)['register'],
        	'from_date':context['from_date'],
        	'to_date':context['to_date'],
        	'loans':self._get_loans(cr,uid,context),
        })
	
report_sxw.report_sxw('report.season.report.info', 'loan.order', 'addons/bbsb_loan/report/report_2_season_info.rml', parser=report_season_info, header = False )

