# -*- coding: utf-8 -*-
from report import report_sxw
import time
import datetime

class report_all_partners(report_sxw.rml_parse):
	_name = 'report.all.partners'
	
	def _get_company(self,cr,uid,context):
		res = {}
		cids = self.pool.get('res.company').search(cr,uid,[('id','!=',-1)],limit=1)
		company = self.pool.get('res.company').browse(cr,uid,cids[len(cids)-1])
		res['name'] = company.name
		res['city'] = company.city
		res['register'] = company.company_registry
		res['street'] = company.street
		res['phone'] = company.phone
		res['email'] = company.email
		res['country'] = company.country_id.name
		return res

	def _get_partners(self,cr,uid,context):
		loids = self.pool.get('loan.order').search(cr,uid,[('state','in',['paid','approved'])])
		paids = []
		for loan in self.pool.get('loan.order').browse(cr,uid,loids):
			paids.append(loan.partner_id.id)
		
		partners = self.pool.get('res.partner').browse(cr,uid,paids)
		return partners

	def _get_code(self,pid):
		lid = self.pool.get('loan.order').search(self.cr,self.uid,[('partner_id','=',pid),('state','in',['paid'])])
		lorder = self.pool.get('loan.order').browse(self.cr,self.uid,lid)[0]
		return lorder.name

	
	def _get_date(self,pid):
		lid = self.pool.get('loan.order').search(self.cr,self.uid,[('partner_id','=',pid),('state','in',['paid'])])
		lorder = self.pool.get('loan.order').browse(self.cr,self.uid,lid)[0]
		return lorder.date_approve

	def _get_eco(self,pid):
		partner = self.pool.get('res.partner').browse(self.cr,self.uid,pid)
		lid = self.pool.get('loan.order').search(self.cr,self.uid,[('partner_id','=',pid),('state','in',['paid'])])
		lorder = self.pool.get('loan.order').browse(self.cr,self.uid,lid)[0]
		return lorder.current_economist.id

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def __init__(self, cr, uid, name, context):
		super(report_all_partners, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'from_date':context['from_date'],
        	'to_date':context['to_date'],
        	'company_name': self._get_company(cr,uid,context)['name'],
        	'partners':self._get_partners(cr,uid,context),
        	'get_contract_code':self._get_code,
        	'get_economist':self._get_eco,
        	'user':self._get_user(cr,uid,context),
        	'get_contract_date':self._get_date,
        })
	
report_sxw.report_sxw('report.all.partners', 'res.partner', 'addons/bbsb_loan/report/report_5_all_partners.rml', parser=report_all_partners, header=False )



