# -*- coding: utf-8 -*-
from report import report_sxw
import time
import datetime

class report_collaterals(report_sxw.rml_parse):
	_name = 'report.collateral'
	
	def _get_company(self,cr,uid,context):
		res = {}
		cids = self.pool.get('res.company').search(cr,uid,[('id','!=',-1)],limit=1)
		company = self.pool.get('res.company').browse(cr,uid,cids[len(cids)-1])
		res['name'] = company.name
		res['city'] = company.city
		res['register'] = company.company_registry
		res['street'] = company.street
		res['phone'] = company.phone
		res['email'] = company.email
		res['country'] = company.country_id.name
		return res

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def _get_collaterals(self,cr,uid,context):
		cids = self.pool.get('loan.collateral').search(cr,uid,[('contract_id','!=',-1)])
		colls = self.pool.get('loan.collateral').browse(cr,uid,cids)
		return colls
	
	def _get_contract(self,cid):
		res = {}
		lorder = self.pool.get('loan.order').browse(self.cr,self.uid,cid)
		res['partner'] = lorder.partner_id.name
		res['balance'] = lorder.loan_balance
		res['name'] = lorder.name
		res['economist'] = lorder.current_economist.name
		return res
		
	def __init__(self, cr, uid, name, context):
		super(report_collaterals, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'from_date':context['from_date'],
        	'to_date':context['to_date'],
        	'company_name': self._get_company(cr,uid,context)['name'],
        	'user':self._get_user(cr,uid,context),
        	'collaterals':self._get_collaterals(cr,uid,context),
        	'get_contract':self._get_contract,
        })
	
report_sxw.report_sxw('report.collateral', 'loan.order', 'addons/bbsb_loan/report/report_6_collaterals.rml', parser=report_collaterals, header=False )
