# -*- coding: utf-8 -*-
from report import report_sxw
import time
import datetime

class report_late_loan(report_sxw.rml_parse):
	_name = 'report.late.loan'
	
	def _get_company(self,cr,uid,context):
		res = {}
		cids = self.pool.get('res.company').search(cr,uid,[('id','!=',-1)],limit=1)
		company = self.pool.get('res.company').browse(cr,uid,cids[len(cids)-1])
		res['name'] = company.name
		res['city'] = company.city
		res['register'] = company.company_registry
		res['street'] = company.street
		res['phone'] = company.phone
		res['email'] = company.email
		res['country'] = company.country_id.name
		return res

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def _get_xxz(self,cr,uid,context):
		res = []
		from_d = context['from_date']
		to_d = context['to_date']
		product_id = context['product']
		if product_id:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('loan_state','=','d90'),('product_id','=',product_id[0])])
		else:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('loan_state','=','d90')])
		i = 1
		for loan in self.pool.get('loan.order').browse(cr,uid,loids):
			temp = ()
			temp = temp + (i,loan.name,loan.partner_id.code,loan.partner_id.name,loan.installment_date,loan.close_date,loan.late_day,loan.amount,loan.loan_balance)
			
			lxxids = self.pool.get('loan.xxt.payment').search(cr,uid,[('loan_order','=',loan.id),('state','=','posted')])
			xxt0 = 0.0
			for lxxp in self.pool.get('loan.xxt.payment').browse(cr,uid,lxxids):
				xxt0 += lxxp.xxt_payment

			lpids = self.pool.get('loan.payment').search(cr,uid,[('loan_order','=',loan.id),
																 ('date_confirm','>=',from_d),	
																 ('date_confirm','<=',to_d),
																 ('state','=','paid')])
			vz = 0.0
			xt = 0.0
			xxt = 0.0
			loss = 0.0
			for lp in self.pool.get('loan.payment').browse(cr,uid,lpids):
				loss += lp.loss_payment
				vz += lp.vzt_payment
				xt += lp.xt_payment
				xxt += lp.xxt_payment
			
			temp = temp + (xxt0,vz,xt,xxt,loss,loan.issued_economist.name,loan.current_economist.name)
			print '#-',temp
			res.append(temp)
			res.append(temp)
			i += 1
			return res


	def _get_xbz(self,cr,uid,context):
		res = {}
		product_id = context['product']
		if product_id:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('loan_state','=','d180'),('product_id','=',product_id[0])])
		else:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('loan_state','=','d180')])
		loans = self.pool.get('loan.order').browse(cr,uid,loids)
		res['loans'] = loans
		return res

	def _get_ez(self,cr,uid,context):
		res = {}
		product_id = context['product']
		if product_id:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('loan_state','=','d360'),('product_id','=',product_id[0])])
		else:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('loan_state','=','d360')])
		loans = self.pool.get('loan.order').browse(cr,uid,loids)
		res['loans'] = loans
		return res

	def _get_mz(self,cr,uid,context):
		res = {}
		product_id = context['product']
		if product_id:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('loan_state','=','d360g'),('product_id','=',product_id[0])])
		else:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('loan_state','=','d360g')])
		loans = self.pool.get('loan.order').browse(cr,uid,loids)
		res['loans'] = loans
		return res		
	
	def __init__(self, cr, uid, name, context):
		super(report_late_loan, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'from_date':context['from_date'],
        	'to_date':context['to_date'],
        	'company_name': self._get_company(cr,uid,context)['name'],
        	'user':self._get_user(cr,uid,context),
        	'get_xxz':self._get_xxz(cr,uid,context),
        	'get_xbz':self._get_xbz(cr,uid,context),
        	'get_ez':self._get_ez(cr,uid,context),
        	'get_mz':self._get_mz(cr,uid,context),
        })
	
report_sxw.report_sxw('report.late.loan', 'loan.order', 'addons/bbsb_loan/report/report_7_late_loan.rml', parser=report_late_loan, header=False )
