# -*- coding: utf-8 -*-
from report import report_sxw
import time
import datetime

class report_changed_state(report_sxw.rml_parse):
	_name = 'report.changed.state'
	
	def _get_company(self,cr,uid,context):
		res = {}
		cids = self.pool.get('res.company').search(cr,uid,[('id','!=',-1)],limit=1)
		company = self.pool.get('res.company').browse(cr,uid,cids[len(cids)-1])
		res['name'] = company.name
		res['city'] = company.city
		res['register'] = company.company_registry
		res['street'] = company.street
		res['phone'] = company.phone
		res['email'] = company.email
		res['country'] = company.country_id.name
		return res

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def _get_loans(self,cr,uid,context):
		product_id = context['product']
		if product_id:
			loids = self.pool.get('loan.order').search(cr,uid,[('loan_state','!=','d00'),('product_id','=',product_id[0])])
		else:
			loids = self.pool.get('loan.order').search(cr,uid,[('loan_state','!=','d00')])
		loans = self.pool.get('loan.order').browse(cr,uid,loids)
		return loans
	def _get_states(self,lid):
		res = {}
		cid = self.pool.get('loan.risk.foundation').search(self.cr,self.uid,[('loan_order','=',lid)],order='id')
		clsi = self.pool.get('loan.risk.foundation').browse(self.cr,self.uid,cid[len(cid)-1])
		res['old_ls'] = clsi.loan_current_state
		res['new_ls'] = clsi.loan_next_state
		res['risk_amount'] = clsi.risk_amount
		res['risk_percent'] = clsi.risk_percent
		return res

	def _get_others(self,lid):
		res = {}
		xxtids = self.pool.get('loan.xxt.payment').search(self.cr,self.uid,[('loan_order','=',lid),('state','=','posted')])
		total = 0.0
		for xxt in self.pool.get('loan.xxt.payment').browse(self.cr,self.uid,xxtids):
			total += xxt.xxt_payment
		res['xxt'] = total
		return res
		
	def __init__(self, cr, uid, name, context):
		super(report_changed_state, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'from_date':context['from_date'],
        	'to_date':context['to_date'],
        	'company_name': self._get_company(cr,uid,context)['name'],
        	'user':self._get_user(cr,uid,context),
        	'get_loans':self._get_loans(cr,uid,context),
        	'get_others':self._get_others,
        	'get_states':self._get_states,
        })
	
report_sxw.report_sxw('report.changed.state', 'loan.order', 'addons/bbsb_loan/report/report_8_changed_state.rml', parser=report_changed_state, header=False )
