# -*- coding: utf-8 -*-
from report import report_sxw
from osv import osv
from tools.translate import _
import time
import datetime

class report_closing_loan(report_sxw.rml_parse):
	_name = 'report.closing.loan'
	
	def _get_company(self,cr,uid,context):
		res = {}
		cids = self.pool.get('res.company').search(cr,uid,[('id','!=',-1)],limit=1)
		company = self.pool.get('res.company').browse(cr,uid,cids[len(cids)-1])
		res['name'] = company.name
		res['city'] = company.city
		res['register'] = company.company_registry
		res['street'] = company.street
		res['phone'] = company.phone
		res['email'] = company.email
		res['country'] = company.country_id.name
		return res

	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name

	def _get_loans(self,cr,uid,context):
		today = time.strftime('%Y-%m')
		product_id = context['product']
		cids = []
		if product_id:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('product_id','=',product_id[0])])
		else:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid')])
		for loan in self.pool.get('loan.order').browse(cr,uid,loids):
			if loan.close_date[:7] == today:
				cids.append(loan.id)
		loans = self.pool.get('loan.order').browse(cr,uid,cids)
		return loans


	def _get_xxt_interest(self,lid):
		res = {}
		xxtids = self.pool.get('loan.xxt.payment').search(self.cr,self.uid,[('loan_order','=',lid),('state','=','posted')])
		total = 0.0
		for xxt in self.pool.get('loan.xxt.payment').browse(self.cr,self.uid,xxtids):
			total += xxt.xxt_payment
		return total

	def _get_others(self,cr,uid,context):
		res = {}
		today = time.strftime('%Y-%m')
# 		today = '2013-11'
		product_id = context['product']
		cids = []
		if product_id:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid'),('product_id','=',product_id[0])])
		else:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','=','paid')])
		for loan in self.pool.get('loan.order').browse(cr,uid,loids):
			print loan.close_date[:7]
			if loan.close_date[:7] == today:
				cids.append(loan.id)
		ti = 0.0
		tb = 0.0
		for loan in self.pool.get('loan.order').browse(cr,uid,cids):
			print "aaaa",loan.loan_balance
			tb += loan.loan_balance
			xxtids = self.pool.get('loan.xxt.payment').search(self.cr,self.uid,[('loan_order','=',loan.id),('state','=','posted')])
			total = 0.0
			for xxt in self.pool.get('loan.xxt.payment').browse(self.cr,self.uid,xxtids):
				total += xxt.xxt_payment
			ti += total
		res['balance'] = tb
		res['xxt'] = ti 
		return res

	def __init__(self, cr, uid, name, context):
		super(report_closing_loan, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({
        	'time': time,
        	'company_name': self._get_company(cr,uid,context)['name'],
        	'user':self._get_user(cr,uid,context),
        	'get_loans':self._get_loans(cr,uid,context),
        	'get_totals':self._get_others(cr,uid,context),
        	'get_xxt_interest':self._get_xxt_interest,
        })
	
report_sxw.report_sxw('report.closing.loan', 'loan.order', 'addons/bbsb_loan/report/report_9_closing_loan.rml', parser=report_closing_loan, header=False )
