# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields
from dateutil import parser

from lxml import etree
import time, datetime
from openerp.tools.translate import _
import openerp.netsvc
import xlwt
from xlwt import *
import base64
from reportlab.platypus import *
from StringIO import StringIO
from operator import itemgetter
import logging
from PIL import Image  


class loan_report_wizard(osv.osv_memory):
    _inherit = 'abstract.report.excel'
    _name = 'loan.schedule.report'
    _description = 'Loan Report Wizard'
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),        
        'note':fields.char(u'Тайлангийн нэр',size=64,readonly=True),
        'from_date': fields.date(u'Эхлэх огноо',required=True),
        'to_date': fields.date(u'Дуусах огноо',required=True),
        'product':fields.many2one('loan.product',u'Зээлийн бүтээгдэхүүн',domain="[('loan_product_type','in',['loan_product'])]"),
    }
    
    _defaults = {
        'company_id': lambda self, cr, uid, ctx: self.pool.get('res.company')._company_default_get(cr, uid, 'res.user', context=ctx),
        'note': u'Зээл төлөлтийн хуваарь тайлан',
        'from_date': lambda * a: time.strftime('%Y-01-01'),
        'to_date': fields.date.context_today,
    }

    def print_report(self, cr, uid, ids, context=None):
        data = self.read(cr,uid,ids,[])[0]
        context['from_date'] = data['from_date']
        context['to_date'] = data['to_date']
        context['product'] = data['product']
        
        return {
            'type'         : 'ir.actions.report.xml',
            'context':context,
            'report_name'   : 'loan.schedule',
            'datas': {
                    'model':'loan.order',
                    'id': context.get('active_ids') and context.get('active_ids')[0] or False,
                    'ids': context.get('active_ids') and context.get('active_ids') or [],
                    'report_type': 'pdf',
                    'form':data,
                },
            'nodestroy': False
        }
    def export_report(self, cr, uid, ids, context={}):
             data = self.read(cr,uid,ids,[])[0]
             context['from_date'] = data['from_date']
             context['to_date'] = data['to_date']
             context['product'] = data['product']
             date_str = '%s-%s' % (
                datetime.datetime.strptime(data['from_date'],'%Y-%m-%d').strftime('%Y.%m.%d'),
                datetime.datetime.strptime(data['to_date'],'%Y-%m-%d').strftime('%Y.%m.%d')
            )
             styledict = self.get_easyxf_styles()
             form = self.browse(cr, uid, ids[0], context=context)
             report_service = netsvc.LocalService('report.laons.export')#._service
             report_service.cr = cr
             report_service.uid = uid
             report_service.datas = data
             report_service.context = context
             report_service.pool = self.pool
             report_service.lang = context.get('lang', None)
             document_code = ''
             directory_name = False
             id = context.get('active_ids')
             ezxf = xlwt.easyxf
             debtor = ezxf('font: bold off, height 160; align: wrap on, vert centre, horiz left; borders: top thin, left thin, bottom thin, right thin;')
             heading_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
             text_xf = ezxf('font: bold off; align: wrap on, vert centre, horiz left; borders: top thin, left thin, bottom thin, right thin;')
             text_right_xf = ezxf('font: bold off; align: wrap on, vert centre, horiz right; borders: top thin, left thin, bottom thin, right thin;')
             text_bold_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz left; borders: top thin, left thin, bottom thin, right thin;')
             text_bold_right_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz right; borders: top thin, left thin, bottom thin, right thin;')
             text_center_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
             center_text_xf = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
             number_xf = ezxf('font: italic on; align: horz right; borders: top thin, left thin, bottom thin, right thin;', num_format_str='#,##0.00')
             number_bold_xf = ezxf('font: italic on, bold on; align: horz right; borders: top thin, left thin, bottom thin, right thin;', num_format_str='#,##0.00')
             number_green_xf = ezxf('font: italic on; align: horz right; borders: top thin, left thin, bottom thin, right thin;pattern: pattern solid, fore_colour gray25;', num_format_str='#,##0.00')
             text_green_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;pattern: pattern solid, fore_colour gray25;')
            
             book = xlwt.Workbook(encoding="utf8")
             sheet = book.add_sheet('Loans Report')
             sheet.write(1, 0, u'Байгууллагын нэр: %s'%data['company_id'][1], ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
                
             lines2 = self.pool.get('loan.order').browse(cr, uid, id)
             sheet.write_merge(3, 3, 0,7, u'%s зээлдэгчтэй %s дугаартай зээлийн гэрээний зээл, хүү төлөх хуваарь'%(lines2[0].partner_id.name,lines2[0].name), ezxf('font: bold on; align: wrap off, vert centre, horiz left;font: height 250'))
             sheet.row(3).height = 400
               
             sheet.write(5, 5, u'Тайлант үе:', ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
                 
             inch = 1000
             sheet.write(5, 6, '%s'%(date_str,), ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
             rowx = 7
             sheet.row(rowx).height = 400
             sheet.row(rowx+1).height = 500

    
             sheet.write_merge(rowx, rowx+1, 0, 0, u'Хуваарийн нэр', styledict['heading_xf'])
             sheet.write_merge(rowx, rowx+1, 1, 1, u'Огноо', styledict['heading_xf'])
             sheet.write_merge(rowx, rowx+1,  2, 2, u'Хүү бодогдсон хоног', styledict['heading_xf'])
             sheet.write_merge(rowx, rowx+1,  3, 3, u'Үндсэн зээл', styledict['heading_xf'])
             sheet.write_merge(rowx, rowx+1,  4, 4, u'Хүүгийн төлбөр', styledict['heading_xf'])
             sheet.write_merge(rowx, rowx+1,  5, 5, u'Нийт төлбөр', styledict['heading_xf'])
             sheet.write_merge(rowx, rowx+1,  6, 6, u'Үлдэгдэл', styledict['heading_xf'])
             sheet.write_merge(rowx, rowx+1,  7, 7, u'Илүү/дутуу(+/-)', styledict['heading_xf'])                  
             number = 1
             
             rowx += 1
             all_days = 0
             all_loan_amount = 0
             all_total_amount = 0
             all_repayment = 0
             all_total_interest = 0

             x = 8
             for lines in lines2:
                 
                  for li in lines['schedules']:                     
                      rowx += 1
                      sheet.write(rowx, 0, li.name, styledict['text_center_xf'])
                      sheet.write(rowx, 1, li.payment_date, debtor)
                      sheet.write(rowx, 2, li.days, styledict['text_center_xf'])
                      sheet.write(rowx, 3, li.loan_payment, styledict['text_center_xf'])
                      sheet.write(rowx, 4, li.interest_payment, styledict['text_center_xf'])
                      sheet.write(rowx, 5, li.total_payment, styledict['text_center_xf'])
                      sheet.write(rowx, 6, li.balance, styledict['text_center_xf'])
                      sheet.write(rowx, 7, li.remaining_payment, styledict['text_center_xf'])
                      all_days += li.days
                      all_loan_amount +=li.loan_payment
                      all_total_amount +=li.total_payment
                      all_total_interest +=li.interest_payment
                      all_repayment +=li.remaining_payment
                  number += 1
             rowx +=1
             sheet.write_merge(rowx, rowx, 0, 1, u'Нийт', styledict['text_center_xf'])
             sheet.write(rowx, 2, all_days, styledict['text_center_xf'])
             sheet.write(rowx, 3, all_loan_amount, styledict['text_center_xf'])
             sheet.write(rowx, 4, all_total_interest, debtor)
             sheet.write(rowx, 5, all_total_amount, styledict['text_center_xf'])
             sheet.write(rowx, 6, u'', styledict['text_center_xf'])
             sheet.write(rowx, 7, all_repayment, styledict['text_center_xf'])

                        
      
             sheet.col(0).width = 4*inch
             sheet.col(1).width = 4*inch
             sheet.col(2).width = 4*inch
             sheet.col(3).width = 3*inch
             sheet.col(4).width = 3*inch
             sheet.col(5).width = 3*inch
             sheet.col(6).width = 4*inch
             sheet.col(7).width = 4*inch
             sheet.col(8).width = 4*inch
             sheet.col(9).width = 4*inch
             sheet.col(10).width = 4*inch
             sheet.col(11).width = 4*inch
             sheet.col(12).width = 4*inch
             sheet.col(13).width = 4*inch
             sheet.col(14).width = 4*inch
             sheet.col(15).width = 4*inch
             sheet.col(16).width = 1*inch
     
         
             sheet.write_merge(rowx+3, rowx+3,0,3, u'Зээлдүүлэгчийг төлөөлж: ',ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
             sheet.write_merge(rowx+3, rowx+3,4,7, u'Зээлдэгчийг төлөөлж: ',ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
             sheet.write_merge(rowx+4, rowx+4, 0,3, u'Захирал:............................./                                 /' ,ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
             sheet.write_merge(rowx+4, rowx+4, 4,7, u'Зээлдэгч: %s/                                  /' % lines2[0].partner_id.name,ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))

             sheet.write_merge(rowx+5, rowx+5, 0,3, u'Эдийн засагч: %s /                              /' % lines2[0].current_economist.name,ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
#                 
        
    
             buffer = StringIO()
             book.save(buffer)
        
             buffer.seek(0)
       
             filename = "loan_report_%s.xls" % (time.strftime('%Y%m%d_%H%M'),)
             out = base64.encodestring(buffer.getvalue())
        
             buffer.close()
        
       
            
             excel_id = self.pool.get('report.excel.output').create(cr, uid, {
                                    'data':out,
                                    'name':filename
             }, context=context)
        
            
             mod_obj = self.pool.get('ir.model.data')
             form_res = mod_obj.get_object_reference(cr, uid, 'bbsb_loan', 'action_excel_output_view')
             form_id = form_res and form_res[1] or False
            
            # Тайлан боловсруулж дууссан тухай лог бэлтгэх хэсэг
             body = (u"Зээлийн тайлан")
             message = u"[Тайлан][PDF][PROCESSING] %s" % body
             tm = datetime.datetime.now()
             prefix = u"[Тайлан][XLS][COMPLETE (%s)]" % (tm,)
             message = u"%s %s" % (prefix, body)
             logging.info(message)
             
            
             return {
           'name': _('loans.info'),
           'view_type': 'form',
           'view_mode': 'form',
           'res_model': 'report.excel.output',
           'res_id': excel_id,
           'view_id': False,
           'views': [(form_id, 'form')],
           'context': context,
           'type': 'ir.actions.act_window',
           'target':'new'
       }
loan_report_wizard()
