# -*- coding: utf-8 -*-
import time
from datetime import datetime
from datetime import date
from dateutil.relativedelta import relativedelta
from osv import osv, fields
import netsvc
import calendar
import pooler
from tools.translate import _
import decimal_precision as dp
from osv.orm import browse_record, browse_null
from tools import DEFAULT_SERVER_DATE_FORMAT, DEFAULT_SERVER_DATETIME_FORMAT

class loan_schedule_graph(osv.osv_memory):
    _name = "loan.schedule.graph"
    
    def _payment_date(self, cr, uid, ids, context=None):
        if ids.has_key('active_id'):
            loan_data = self.pool.get('loan.schedule').browse(cr, uid, ids['active_id'])
            return loan_data.payment_date

    def _loan_payment(self, cr, uid, ids, context=None):
        if ids.has_key('active_id'):
            loan_data = self.pool.get('loan.schedule').browse(cr, uid, ids['active_id'])
            return loan_data.loan_payment

    _columns = {        
        'loan_payment':fields.float(u'Loan', digits=(16, 2), required=True),
        'payment_date': fields.date(u'Date', required=True),     
        'schedule_id': fields.many2one('loan.schedule', 'Schedule'),
    }
    
    _defaults = {
        'loan_payment':_loan_payment,
        'payment_date': _payment_date,
    }
    
    def edit_graphics(self, cr, uid, ids, context=None):
        loan_obj = self.pool.get('loan.schedule')
        print context
        load_id=False
        if context.has_key('active_id'):
          load_id = context.get('active_id')
        if load_id:
            loan_obj.write(cr, uid, [load_id], {'loan_payment':self.browse(cr, uid, ids)[0].loan_payment})
            loan_obj.edit_graphics(cr, uid, [load_id], context=context)
            contract_id= loan_obj.browse(cr, uid, load_id).contract_id.id
            print "Contract id: ",contract_id
            order_id = self.pool.get('loan.schedule').search(cr, uid, [('contract_id','=',contract_id)])
            print "Order id: ",order_id
            for line in self.pool.get('loan.schedule').browse(cr, uid, order_id):
                print "Line schedule: ",line.edit_schedule
                if line.edit_schedule:                    
                    self.pool.get('loan.schedule').write(cr, uid, line.id, {'edit_schedule': False}, context)
                    print "Edit schedule1::::::::::::::: ",line.edit_schedule
                else:
                    self.pool.get('loan.schedule').write(cr, uid, line.id, {'edit_schedule': True}, context)
                    print "Edit schedule2::::::::::::::: ",line.edit_schedule
        return True
#     def edit_graphics(self, cr, uid, ids, context=None):
#         self_data = self.browse(cr, uid, ids[0])
#         now = self.pool.get('loan.schedule').browse(cr, uid, context['active_ids'])[0]
#         now.write({'payment_date': self_data.payment_date, 'loan_payment': self_data.loan_payment})
#         con = now.contract_id
#         print '--writed------', con.interest, ids[0]
#         gtype = con.schedule_type
#         rate = con.interest
#         print 'GTYPE-', gtype
#         
#         if 0 <= now.loan_payment:
#             pre_balance = con.loan_balance 
#             if now.prior_id != 0:
#                 pre = self.pool.get('loan.schedule').browse(cr, uid, now.prior_id)
#                 pre_balance = pre.balance
# 
#             balance = pre_balance - now.loan_payment
#             niit = now.loan_payment     + now.interest_payment
#             print "NOW: ID: ",now.id
#             print 'writed self', self.pool.get('loan.schedule').write(cr, uid, now.id,
#                                                                     {'loan_payment':now.loan_payment,
#                                                                      'total_payment':niit,
#                                                                      'balance':balance}, context)
#             print 'gacha....', now.loan_payment, niit, balance
#             
#             nextid = self.pool.get('loan.schedule').search(cr, uid, [('prior_id', '=', now.id)])
#             print 'next', nextid
#             
#             last = 0
#             niit = 0.0
#             
#             while nextid != []:
#                 vz = 0.0
#                 balance = 0.0
#                 now = self.pool.get('loan.schedule').browse(cr, uid, nextid[0])
#                 pre = self.pool.get('loan.schedule').browse(cr, uid, now.prior_id)
#                 if last == 1:
#                     print 'deleted other', self.pool.get('loan.schedule').unlink(cr, uid, now.id, context) 
#                     break   
#                 else:
#                     c = rate / 100
#                     xvv = pre.balance * c / 30 * now.days    
#                     if gtype == 'type1':
#                         vz = now.total_payment - xvv
#                         balance = pre.balance - vz
#                         if balance <= 0 :
#                             niit = xvv + pre.balance
#                             vz = pre.balance
#                             balance = 0
#                             print gtype, '1vz', vz, 'xvv', xvv, 'niit', now.total_payment, 'balance', balance
#                             print gtype, '1writed  - Balance', self.pool.get('loan.schedule').write(cr, uid, now.id,
#                                             {'loan_payment':vz,
#                                              'interest_payment':xvv,
#                                              'total_payment':niit,
#                                              'balance':balance}, context)    
#                             last = 1
#                         
#                         nextid = self.pool.get('loan.schedule').search(cr, uid, [('prior_id', '=', now.id)])
#                         if nextid == [] and balance > 0:
#                             vz += balance
#                             balance = 0
#                             niit = xvv + vz
#                             print gtype, '1writed other', self.pool.get('loan.schedule').write(cr, uid, now.id,
#                                                         {'loan_payment':vz,
#                                                          'interest_payment':xvv,
#                                                          'total_payment':niit,
#                                                          'balance':balance}, context)
#                                                          
#                         print gtype, '1vz', vz, 'xvv', xvv, 'niit', now.total_payment, 'balance', balance
#                         print gtype, '1writed other', self.pool.get('loan.schedule').write(cr, uid, now.id,
#                                                         {'loan_payment':vz,
#                                                          'interest_payment':xvv,
#                                                          'balance':balance}, context)
# 
#                     if gtype == 'type3' or gtype == 'type5':                    
#                         niit = now.loan_payment + xvv
#                         balance = pre.balance - now.loan_payment
#                         if balance <= 0 :
#                             niit = xvv + pre.balance
#                             vz = pre.balance
#                             balance = 0
#                             print gtype, '2vz', now.loan_payment, 'xvv', xvv, 'niit', niit, 'balance', balance, "aaaaaaaaaaaaaaaaaaaaaadd"
#                             print gtype, '2writed  - Balance', self.pool.get('loan.schedule').write(cr, uid, now.id,
#                                             {'loan_payment':vz,
#                                              'interest_payment':xvv,
#                                              'total_payment':niit,
#                                              'balance':balance}, context)    
#                             last = 1
#                 nextid = self.pool.get('loan.schedule').search(cr, uid, [('prior_id', '=', now.id)])
#                 if nextid == [] and balance > 0:
#                         niit = xvv + pre.balance
#                         vz = pre.balance
#                         balance = 0
#                         print now.total_payment, '2vz', vz, 'xvv', xvv, 'niit', now.total_payment, 'balance', balance, "last", last
#                         print gtype, '2writed other', self.pool.get('loan.schedule').write(cr, uid, now.id,
#                                                     {'total_payment':niit,
#                                                      'loan_payment':vz,
#                                                      'interest_payment':xvv,
#                                                      'balance':balance}, context)
#                 else:
#                         print now.total_payment, '2vz', vz, 'xvv', xvv, 'niit', now.total_payment, 'balance', balance, "last", last
#                         print gtype, '2writed other', self.pool.get('loan.schedule').write(cr, uid, now.id,
#                             {'total_payment':niit,
#                              'interest_payment':xvv,
#                              'balance':balance}, context)
#                 # bichilt
#                 nextid = self.pool.get('loan.schedule').search(cr, uid, [('prior_id', '=', now.id)])