# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields
from dateutil import parser

from lxml import etree
import time, datetime
from openerp.tools.translate import _
import openerp.netsvc
import xlwt
from xlwt import *
import base64
from StringIO import StringIO
from operator import itemgetter
import logging


class loan_report_wizard(osv.osv_memory):
 	_inherit = 'abstract.report.excel'
	_name = 'loan.report.wizard'
	_description = 'Loan Report Wizard'
	
	_columns = {
		'company_id': fields.many2one('res.company', 'Company', required=True),		
		'note':fields.char(u'Тайлангийн нэр',size=64,readonly=True),
		'from_date': fields.date(u'Эхлэх огноо',required=True),
		'to_date': fields.date(u'Дуусах огноо',required=True),
		'product':fields.many2one('loan.product',u'Зээлийн бүтээгдэхүүн',domain="[('loan_product_type','in',['loan_product'])]"),
	}
	
	_defaults = {
		'company_id': lambda self, cr, uid, ctx: self.pool.get('res.company')._company_default_get(cr, uid, 'res.user', context=ctx),
        'note': u'Идэвхитэй байгаа зээлийн гэрээний тайлан',
        'from_date': lambda * a: time.strftime('%Y-01-01'),
        'to_date': fields.date.context_today,
    }

	def print_report(self, cr, uid, ids, context=None):
		data = self.read(cr,uid,ids,[])[0]
		context['from_date'] = data['from_date']
		context['to_date'] = data['to_date']
		context['product'] = data['product']
		
		return {
            'type'         : 'ir.actions.report.xml',
            'context':context,
            'report_name'   : 'loans.info',
            'datas': {
                    'model':'loan.order',
                    'id': context.get('active_ids') and context.get('active_ids')[0] or False,
                    'ids': context.get('active_ids') and context.get('active_ids') or [],
                    'report_type': 'pdf',
                    'form':data,
                },
            'nodestroy': False
        }
	def export_report(self, cr, uid, ids, context={}):
 			data = self.read(cr,uid,ids,[])[0]
		 	context['from_date'] = data['from_date']
		 	context['to_date'] = data['to_date']
		 	context['product'] = data['product']
		 	date_str = '%s-%s' % (
                datetime.datetime.strptime(data['from_date'],'%Y-%m-%d').strftime('%Y.%m.%d'),
                datetime.datetime.strptime(data['to_date'],'%Y-%m-%d').strftime('%Y.%m.%d')
            )
		 	
  			styledict = self.get_easyxf_styles()
		        
		        form = self.browse(cr, uid, ids[0], context=context)
	        	report_service = netsvc.LocalService('report.laons.export')#._service
	       	 	report_service.cr = cr
	        	report_service.uid = uid
  	          	report_service.datas = data
	          	report_service.context = context
	          	report_service.pool = self.pool
	          	report_service.lang = context.get('lang', None)
	          	document_code = ''
	          	directory_name = False
	            
	        	ezxf = xlwt.easyxf
	        	debtor = ezxf('font: bold off, height 160; align: wrap on, vert centre, horiz left; borders: top thin, left thin, bottom thin, right thin;')
	    		heading_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
	       		text_xf = ezxf('font: bold off; align: wrap on, vert centre, horiz left; borders: top thin, left thin, bottom thin, right thin;')
	         	text_right_xf = ezxf('font: bold off; align: wrap on, vert centre, horiz right; borders: top thin, left thin, bottom thin, right thin;')
	          	text_bold_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz left; borders: top thin, left thin, bottom thin, right thin;')
	           	text_bold_right_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz right; borders: top thin, left thin, bottom thin, right thin;')
	        	text_center_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
	         	center_text_xf = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
	          	number_xf = ezxf('font: italic on; align: horz right; borders: top thin, left thin, bottom thin, right thin;', num_format_str='#,##0.00')
	           	number_bold_xf = ezxf('font: italic on, bold on; align: horz right; borders: top thin, left thin, bottom thin, right thin;', num_format_str='#,##0.00')
	        	number_green_xf = ezxf('font: italic on; align: horz right; borders: top thin, left thin, bottom thin, right thin;pattern: pattern solid, fore_colour gray25;', num_format_str='#,##0.00')
	         	text_green_xf = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;pattern: pattern solid, fore_colour gray25;')
	            
	        	book = xlwt.Workbook(encoding="utf8")
	         	sheet = book.add_sheet('Loans Report')
	            
	         
 	        	sheet.write(3, 6, u'Зээлийн тайлан', ezxf('font: bold on; align: wrap off, vert centre, horiz left;font: height 250'))
 	         	sheet.row(3).height = 400
 	            
 	            
 	        	sheet.write(5, 11, u'Тайлант үе:', ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
 	        	sheet.write(5, 1, u'Байгууллагын нэр: %s'%data['company_id'][1], ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))

 	         	inch = 1000
 	          	sheet.write_merge(5, 5, 12, 13, '%s'%(date_str,), ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
 	           	rowx = 7
 	           	sheet.row(rowx).height = 400
 	           	sheet.row(rowx+1).height = 500
 	           	
 	        	sheet.write_merge(rowx, rowx+1, 0, 0, u'Д/д', styledict['heading_xf'])
 	         	sheet.write_merge(rowx, rowx+1, 1, 1, u'Гэрээний дугаар', styledict['heading_xf'])
 	          	sheet.write_merge(rowx, rowx+1, 2, 2, u'Бүтээгдэхүүн', styledict['heading_xf'])
 	           	sheet.write_merge(rowx, rowx+1, 3, 3, u'Зээлдэгч', styledict['heading_xf'])
 	        	sheet.write_merge(rowx, rowx,  4, 5, u'Зээлийн огноо', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 4, u'Олгосон', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 5, u'Төлөгдөх', styledict['heading_xf'])
 	        	sheet.write_merge(rowx, rowx+1, 6, 6, u'Хүү%', styledict['heading_xf'])
 	        	sheet.write_merge(rowx, rowx, 7, 10, u'Зээл', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 7, u'Эхний үлдэгдэл', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 8, u'Дебит', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 9, u'Кридет', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 10, u'Эцсийн үлдэгдэл', styledict['heading_xf'])
 	        	sheet.write_merge(rowx, rowx, 11, 14, u'Хуримтлагдсан хүү', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 11, u'Эхний үлдэгдэл', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 12, u'Дебит', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 13, u'Кридет', styledict['heading_xf'])
 	        	sheet.write(rowx+1, 14, u'Эцсийн үлдэгдэл', styledict['heading_xf'])
 	        	sheet.write_merge(rowx, rowx+1, 15, 15, u'Тухайн хүү', styledict['heading_xf'])
 	        	sheet.write_merge(rowx, rowx+1, 16, 16, u'Э/з код', styledict['heading_xf'])
 	         	
 	         	number = 1
 	         	lines2 = report_service.export_report(cr, uid, data, context)
 	         	print "Lines2: ",lines2
  	         	user_name  = lines2[0]['user_name']
 	        	rowx += 1
 	        	all_f_balance = 0
 	        	all_l_balance = 0
 	        	all_debit = 0
 	        	all_credit = 0
 	        	all_hhf_balance = 0
 	        	all_hhl_balance = 0
 	        	all_hhdebit = 0
 	        	all_hhcredit = 0
 	        	all_t_xvv = 0
 	        	x = 8
  	         	for lines in lines2:
  	         		rowx += 1
	 	         	sheet.write(rowx, 0, str(number), styledict['text_center_xf'])
	 	         	sheet.write(rowx, 1, lines['contract'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 2, lines['product_name'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 3, lines['partner_name'], debtor)
	 	         	sheet.write(rowx, 4, lines['installment_date'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 5, lines['close_date'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 6, lines['interest'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 7, lines['f_balance'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 8, lines['debit'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 9, lines['credit'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 10, lines['l_balance'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 11, lines['hhf_balance'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 12, lines['hhdebit'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 13, lines['hhcredit'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 14, lines['hhl_balance'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 15, lines['t_xvv'], styledict['text_center_xf'])
	 	         	sheet.write(rowx, 16, lines['current_economist'], styledict['text_center_xf'])
	 	         	number += 1
	 	         	x +=1
	 	         	all_f_balance += lines['f_balance']
 	        		all_l_balance += lines['l_balance']
 	        	 	all_debit += lines['debit']
 	        	 	all_credit += lines['credit']
 	        	 	all_hhf_balance += lines['hhf_balance']
 	        		all_hhl_balance += lines['hhl_balance']
 	        	 	all_hhdebit += lines['hhdebit']
 	        	 	all_hhcredit += lines['hhcredit']
 	        	 	all_t_xvv += lines['t_xvv']
 	        	 	sheet.row(x).height = 600
 	         		
 	         	rowx += 1
 	         	sheet.write(rowx, 0, '', styledict['text_xf'])
 	         	sheet.write(rowx, 1, u'НИЙТ', styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 2, '', styledict['text_xf'])
 	         	sheet.write(rowx, 3, '', styledict['text_xf'])
 	         	sheet.write(rowx, 4, '', styledict['text_xf'])
 	         	sheet.write(rowx, 5, '', styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 6, '', styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 7, all_f_balance, styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 8, all_debit, styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 9, all_credit, styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 10, all_l_balance, styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 11, all_hhf_balance, styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 12, all_hhdebit, styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 13, all_hhcredit, styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 14, all_hhl_balance, styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 15, all_t_xvv, styledict['text_center_bold_xf'])
 	         	sheet.write(rowx, 16, '', styledict['text_center_bold_xf'])
 	         	 	         	
 	         	
 	         	sheet.col(0).width = 1*inch
 	         	sheet.col(1).width = 4*inch
 	         	sheet.col(2).width = 4*inch
 	         	sheet.col(3).width = 3*inch
 	         	sheet.col(4).width = 3*inch
 	         	sheet.col(5).width = 3*inch
 	         	sheet.col(6).width = 2*inch
 	         	sheet.col(7).width = 4*inch
 	         	sheet.col(8).width = 4*inch
 	         	sheet.col(9).width = 4*inch
 	         	sheet.col(10).width = 4*inch
 	         	sheet.col(11).width = 4*inch
 	         	sheet.col(12).width = 4*inch
 	         	sheet.col(13).width = 4*inch
 	         	sheet.col(14).width = 4*inch
 	         	sheet.col(15).width = 4*inch
 	         	sheet.col(16).width = 1*inch
 	            
 	            
 		        sheet.write(rowx+3, 2, u'Ерөнхий НЯБО: ',ezxf('font: bold off; align: wrap off, vert centre, horiz right;'))
 		        sheet.write_merge(rowx+3, rowx+3, 3,6, u'........................................./ %s/' % user_name ,ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
 		        sheet.write_merge(rowx+4, rowx+4, 2,6, u'Хэвлэсэн огноо: %s'	 % time.strftime('%Y-%m-%d %H:%M:%S') ,ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
# 		        
		        
		        
		        buffer = StringIO()
		        book.save(buffer)
		        
		        buffer.seek(0)
		       
		        filename = "loan_report_%s.xls" % (time.strftime('%Y%m%d_%H%M'),)
		        out = base64.encodestring(buffer.getvalue())
		        
		        buffer.close()
		        
		       
		            
		        excel_id = self.pool.get('report.excel.output').create(cr, uid, {
		                                    'data':out,
		                                    'name':filename
		            }, context=context)
		        
		            
 		        mod_obj = self.pool.get('ir.model.data')
  		        form_res = mod_obj.get_object_reference(cr, uid, 'bbsb_loan', 'action_excel_output_view')
  		        form_id = form_res and form_res[1] or False
		            
		            # Тайлан боловсруулж дууссан тухай лог бэлтгэх хэсэг
		        body = (u"Зээлийн тайлан")
		        message = u"[Тайлан][PDF][PROCESSING] %s" % body
		        tm = datetime.datetime.now()
 		        prefix = u"[Тайлан][XLS][COMPLETE (%s)]" % (tm,)
 		        message = u"%s %s" % (prefix, body)
 		        logging.info(message)
 		        
	        	
	        	return {
               'name': _('loans.info'),
               'view_type': 'form',
               'view_mode': 'form',
               'res_model': 'report.excel.output',
               'res_id': excel_id,
               'view_id': False,
               'views': [(form_id, 'form')],
               'context': context,
               'type': 'ir.actions.act_window',
               'target':'new'
           }
loan_report_wizard()
