# -*- coding: utf-8 -*-

from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp
import dateutil


class adv_type (osv.osv):
    _name = 'adv.type'
    _columns ={
            'name': fields.char('Type'),
            'type_abb':fields.char('Type Abbreviation', size=2),
            'sub_type_ids':fields.one2many('adv.sub.type','type_id','Sub Types')         
          }

class adv_sub_type (osv.osv):
    _name = 'adv.sub.type'
    _columns ={
            'name': fields.char('Sub type'),  
            'type_id': fields.many2one('adv.type','Type'),
          }

class advertisement_entry (osv.osv):
    _name = 'advertisement.entry'
    _description = 'Advertisement entry'

    def _get_line_compute(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        digit = 0
        for line in self.browse(cr, uid, ids):
            for li in line.marketing_adv_tree_id:
                digit += li.quantity
            res[line.id]=digit
        return res
    
    def _get_start_date(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        date = '2030-02-19'
        for line in self.browse(cr, uid, ids):
            for li in line.marketing_adv_tree_id:
                if date >= li.date:
                    date = li.date
            res[line.id] = date
        return res

    def _get_end_date(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        date = '2000-02-19'
        for line in self.browse(cr, uid, ids):
            for li in line.marketing_adv_tree_id:
                if date <= li.date:
                    date = li.date
            res[line.id] = date
        return res

    def _get_line_vat(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        vat = 0
        for line in self.browse(cr, uid, ids):
            vat = line.tax.amount*line.amount
            res[line.id] = vat
        return res
    
    def _get_line_amount(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        amount = 0
        for line in self.browse(cr, uid, ids):
            amount = line.quantity*line.price_unit*line.digit
            res[line.id] = amount
        return res
    
    def _get_line_percent(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        percent = 0.00
        for line in self.browse(cr, uid, ids):
            res[line.id] = 0
            if line.marketing_plan_id.id != False:
                plan = self.pool.get('marketing.business.plan')
                p=plan.browse(cr, uid, plan.search(cr, uid, [('id','=',line.marketing_plan_id.id)]))
                print'kkkkkkk',line.marketing_plan_id,p.digit,line.digit
                percent = float(line.digit)/(float(p.digit)/100)
                res[line.id] = percent
        return res
    
    _columns = {
             'name': fields.char('Name',required=True),
             'manager_id': fields.many2one('res.users','Manager'),
             'chanel': fields.many2one('adv.type', 'Chanel', required=True),
             'sub_chanel': fields.many2one('adv.sub.type', 'Sub chanel', required=True),
             'schedule_to': fields.float('Schedule to'),
             'schedule_from': fields.float('Schedule from'),
             'quantity': fields.integer('Quantity', required = True),
             'description':fields.char('Description'),
             'digit': fields.function(_get_line_compute,type="integer",string='Digit', readonly=True),
             'price_unit': fields.integer('Price unit', required = True),
             'amount': fields.function(_get_line_amount, type="integer", string='Amount', readonly=True),
             'vat': fields.function(_get_line_vat, type="integer", string='VAT', readonly=True),
             'start_date': fields.function(_get_start_date,type="date",string='Date start', readonly=True),
             'end_date': fields.function(_get_end_date,type="date",string='Date end', readonly=True),
             'tax': fields.many2one('account.tax', 'Tax'),
             'interpreter_id':fields.many2one('res.partner','Interpreter'),
             'marketing_adv_tree_id': fields.one2many('marketing.adv.tree','marketing_plan_id','Marketing plan'),
             'state': fields.selection([('draft','Draft'),
                                           ('confirmed','Confirmed'),
                                           ('canceled','Canceled')], 'State', readonly=True),
             'percent': fields.function(_get_line_percent, type='float', string='Performance percent', readonly=True),
             'marketing_plan_id': fields.many2one('marketing.business.plan', 'Marketing plan', readonly=True),
             
             }
    
class marketing_adv_tree(osv.osv):
    
     _name = 'marketing.adv.tree'
     _description = "Marketing adv tree"
    
     _columns = {
                'project_id': fields.many2one('project.project', 'Project'),
                'date': fields.date('Date'),
                'quantity_plan': fields.integer('Quantity plan'),
                'quantity': fields.integer('Quantity'),
                'marketing_plan_id': fields.many2one('advertisement.entry', 'Advertisement line'),
                'marketing_plan_tree_id': fields.many2one('marketing.plan.tree', readonly=True),
                }
     

    
    #===========================================================================
    # _columns = {
    #             'name':fields.char('Name',required=True),
    #             'type': fields.many2one('adv.type','Type',required=True),
    #             'start_date': fields.datetime('Start date'),
    #             'end_date':fields.datetime('End date'),
    #             'sub_type': fields.many2one('adv.sub.type','Sub type', required=True),
    #             'ferquency':fields.integer('Ferquency'),
    #             'performance_percent':fields.float('Performance percent'),
    #             'progress_percent':fields.float('Progress percent'),
    #             'company': fields.many2one('res.company','Company'),                
    #             'manager_id':fields.many2one('hr.employee', 'Sales manager'),
    #             'customer_id':fields.many2one('res.partner', 'Customer'), 
    #             'contract_id':fields.many2one('account.analytic.account','Contract'),
    #             'note': fields.text('Note'), 
    #             'state': fields.selection([('draft','Draft'),
    #                                        ('confirmed','Confirmed'),
    #                                        ('canceled','Canceled')], 'State', readonly=True),              
    #             }
    #===========================================================================
    #===========================================================================
    # _defaults = { 
    #             'date': lambda obj, cr, uid, context: time.strftime('%Y-%m-%d'),
    #             'manager_id': lambda obj, cr, uid, context: uid, 
    #             'state' : lambda *a: 'draft',
    #                 }
    #===========================================================================
    
    
    #===========================================================================
    # def on_change_progress_percent(self, cr, uid, ids, progress_percent, context=None):
    #     if 0 <= progress_percent <= 100:
    #     
    #          return {
    #         'value': {
    #             'performance_percent': progress_percent,
    #          } }
    #     else:
    #        raise osv.except_osv(('Warning'),('Not correct value. Please check value'))
    #===========================================================================
            
        
