from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp
from bsddb.dbtables import _columns


class marketing_business_plan(osv.osv):
    _name = 'marketing.business.plan'
    _description = "Marketing business plan"
    
    
    
    def _get_line_percent(self, cr, uid, ids,name, args, context = None):
        
        obj = self.browse(cr, uid,ids)[0]
        #task_id = self.pool.get('project.project.task').browse(cr, uid, obj.task_id.id)
        percent = 0.0
        perf = 0.00
        #cr.execute('select sum(material_sum_price) from task_bom where pro_task_id = '+str(task_id.id))
        for line in obj.marketing_plan_tree_id:
            perf += line.performance
            if perf == 0:
               percent = 0.0
            else:
                   
                percent = (float(perf) / float(obj.digit))*100
                 
            
        return {ids[0]:percent}
    
    def _get_line_compute(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        amount = 0
        for line in self.browse(cr, uid, ids):
            for li in line.marketing_plan_tree_id:
                amount += li.quantity
            res[line.id]=amount
        return res
    
    def _get_start_date(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        date = '2030-02-19'
        for line in self.browse(cr, uid, ids):
            for li in line.marketing_plan_tree_id:
                if date >= li.date:
                    date = li.date
            res[line.id] = date
        return res

    def _get_end_date(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        date = '2000-02-19'
        for line in self.browse(cr, uid, ids):
            for li in line.marketing_plan_tree_id:
                if date <= li.date:
                    date = li.date
            res[line.id] = date
        return res

    def _get_line_vat(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        vat = 0
        for line in self.browse(cr, uid, ids):
            vat = line.tax.amount*line.amount
            res[line.id] = vat
        return res
    
    def _get_line_amount(self, cr, uid, ids,  name, arg, context=None):
        res = {}
        amount = 0
        for line in self.browse(cr, uid, ids):
            amount = line.quantity*line.price_unit*line.digit
            res[line.id] = amount
        return res
    
    _columns = {
             'name': fields.char('Name',required=True),
             'manager_id': fields.many2one('res.users','Manager'),
             'chanel': fields.many2one('adv.type', 'Chanel', required=True),
             'sub_chanel': fields.many2one('adv.sub.type', 'Sub chanel', required=True),
             'schedule_to': fields.float('Schedule to'),
             'schedule_from': fields.float('Schedule from'),
             'quantity': fields.integer('Quantity', required = True),
             'description':fields.char('Description'),
             'digit': fields.function(_get_line_compute,type="integer",string='Digit', readonly=True),
             'price_unit': fields.integer('Price unit', required = True),
             'amount': fields.function(_get_line_amount, type="integer", string='Amount', readonly=True),
             'vat': fields.function(_get_line_vat, type="integer", string='VAT', readonly=True),
             'start_date': fields.date('Date start', readonly=True),
             'startdate': fields.function(_get_start_date,type="date",string='Date start', readonly=True),
             'end_date': fields.function(_get_end_date,type="date",string='Date end', readonly=True),
             'tax': fields.many2one('account.tax', 'Tax'),
             'interpreter_id':fields.many2one('res.partner','Interpreter'),
             'percent': fields.function(_get_line_percent, type='float', string='Performance percent', readonly=True, store=True),
             'marketing_plan_tree_id': fields.one2many('marketing.plan.tree','marketing_plan_id','Marketing plan'),
             'state': fields.selection([('draft','Draft'),
                                           ('confirmed','Confirmed'),
                                           ('canceled','Canceled')], 'State', readonly=True),
             
             
             }
    
    _defaults = {
                 'manager_id': lambda obj, cr, uid, context: uid,
                 'state': 'draft',
                }
    
    def action_cancel_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True
    
    def action_to_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'canceled'})
        return True
    
    def action_to_confirm(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid,ids)
        mark_plan_tree = self.pool.get('marketing.plan.tree')
        self.write(cr, uid, ids, {'start_date': obj.startdate,}, context=context)  
        plan_line=[]
        for line in obj.marketing_plan_tree_id:
        
            if obj.name:
                mark_plan_tree.write(cr, uid, line.id, {  
                                                                 'plan_name':obj.name,
                                                                 'manager_id':obj.manager_id.id,
                                                                 'chanel':obj.chanel.id,
                                                                 'sub_chanel':obj.sub_chanel.id,
                                                                 'schedule_to':obj.schedule_to,
                                                                 'schedule_from': obj.schedule_from,
                                                                 'plan_quantity':obj.quantity,
                                                                 'description': obj.description,
                                                                 'digit':obj.digit,
                                                                 'price_unit':obj.price_unit,
                                                                 'amount':obj.amount,
                                                                 'vat':obj.vat,
                                                                 'tax':obj.tax.id,
                                                                 'interpreter_id':obj.interpreter_id.id,
                                                                 #'marketing_adv_tree_id': plan_line,
                                                                 #'marketing_plan_id': obj.id,
                                                         })    
        self.write(cr, uid, ids, {'state':'confirmed'}, context)  
       
                   
                
            
        return True  
    def write(self, cr, uid, ids, vals, context=None):
        if isinstance(ids, (int, long)):
            ids = [ids]
        obj = self.browse(cr, uid,ids)
        change = {}
        # stage change: update date_last_stage_update
        
        if obj.startdate: 
            
            change.update({ 'start_date': obj.startdate})
            super(marketing_business_plan, self).write(cr, uid, ids, change, context=context)
        res = super(marketing_business_plan, self).write(cr, uid, ids, vals, context=context)
        
        return res
    
    
class marketing_business_plan_tree(osv.osv):
    
    _name = 'marketing.plan.tree'
    _description = "Marketing business plan tree"
    
    _columns = {
                 'plan_name': fields.char('Plan Name'),
                 'manager_id': fields.many2one('res.users','Manager'),
                 'chanel': fields.many2one('adv.type', 'Chanel'),
                 'sub_chanel': fields.many2one('adv.sub.type', 'Sub chanel'),
                 'schedule_to': fields.float('Schedule to'),
                 'schedule_from': fields.float('Schedule from'),
                 'plan_quantity': fields.integer('Quantity'),
                 'description':fields.char('Description'),
                 'digit': fields.integer('Digit'),
                 'price_unit': fields.integer('Price unit'),
                 'amount': fields.integer('Amount'),
                 'vat': fields.integer('VAT'),
                 'tax': fields.many2one('account.tax', 'Tax'),
                 'interpreter_id':fields.many2one('res.partner','Interpreter'),
                 'project_id': fields.many2one('project.project', 'Project'),
                 'date': fields.date('Date'),
                 'quantity': fields.integer('Quantity'),
                 'performance': fields.integer('Performance'),
                 'is_true': fields.boolean('Is true'),
                 'marketing_plan_id': fields.many2one('marketing.business.plan', 'Business plan')
                }
    _defaults = {
                 'is_true': False
                                }
    
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)
        plan = self.pool.get('marketing.business.plan')
        
        obj_plan = plan.browse(cr ,uid, plan.search(cr, uid, [('id', '=', obj.marketing_plan_id.id)]))
        digit = obj_plan.digit - obj.quantity
        plan.write(cr, uid , obj_plan.id,{
                                          'digit': digit,
                                          })
       
        return osv.osv.unlink(self, cr, uid, ids, context=context)
    
    #===========================================================================
    # def onchange_date(self, cr, uid, ids, vals, date, context=None):
    #     plan=self.pool.get('marketing.business.plan')
    #     if vals.get('marketing_pan_id'):
    #         print "ssssssssssssssssssssss", vals['marketing_pan_id']
    #     return True
    #===========================================================================
        
class marketing_chanel(osv.osv):
    
    _name = 'marketing.chanel'
    _description = "Marketing chanel"  
    
    _columns = {
                'name': fields.char('Chanel'),
                'Description':fields.char('Description'),
                
                }  
class marketing_sub_chanel(osv.osv):
    
    _name = 'marketing.sub.chanel'
    _description = "Marketing sub chanel"  
    
    _columns = {
                'name': fields.char('Sub chanel'),
                'Description':fields.char('Description'),
                
                }  
