# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import logging
import time
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _
from datetime import date, timedelta, datetime


class project_collection(osv.Model):
    _name = 'project.collection'
    _description = 'Project collection'
    _inherit = ['mail.thread']
    
    def lengthmonth(year, month):
        if month == 2 and ((year % 4 == 0) and ((year % 100 != 0) or (year % 400 == 0))):
            return 29
        return [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month]

    _columns = {
                'company_id':fields.many2one('res.company','Company',required=True),
                'date':fields.date('Date',required=True),
                'name': fields.char('Collection code', required=True), 
                'desc_name':fields.char('Desc name'),
                'state':fields.selection([('draft','Draft'),
                                          ('confirmed','Confirmed'),
                                          ('done','Done'),
                                          ('cancel','Cancel')],'State'), 
                'project_id':fields.many2one('project.project', 'Project name',required=True),
                'line_id':fields.one2many('collection.line','collection_id', 'Collection line'),  
    }
    
    _defaults = {  
                 'state' : lambda *a: 'draft',   
                 'company_id':lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'account.integrate', context=c),
                 }
    
    def do_something(self, cr, uid, ids, context=None):
        self.do_something_send_note(cr, uid, ids, context=context)
        return res
    
    def do_something_send_note(self, cr, uid, ids, context=None):
        self.message_post(
            cr, uid, ids, _('My subject'),
            _("has received a <b>notification</b> and is happy for it."),
            context=context)


    #------------------------ def write(self, cr, uid, ids, vals, context=None):
         #--- if alias_model has been changed, update alias_model_id accordingly
        #------------------------------------------- if vals.get('alias_model'):
            # model_ids = self.pool.get('ir.model').search(cr, uid, [('model', '=', vals.get('alias_model', 'project.collection'))])
            #-------------------------- vals.update(alias_model_id=model_ids[0])
        # return super(project_collection, self).write(cr, uid, ids, vals, context=context)

    #---------------------------- def create(self, cr, uid, vals, context=None):
        #--------------------------------------------------- if context is None:
            #------------------------------------------------------ context = {}
        # # Prevent double project creation when 'use_tasks' is checked + alias management
        #----- create_context = dict(context, project_creation_in_progress=True,
                              # alias_model_name=vals.get('alias_model', 'project.collection'),
                              #------------- alias_parent_model_name=self._name)
#------------------------------------------------------------------------------ 
#------------------------------------------------------------------------------ 
        # project_id = super(project_collection, self).create(cr, uid, vals, context=create_context)
        #------- project_rec = self.browse(cr, uid, project_id, context=context)
        # self.pool.get('mail.alias').write(cr, uid, [project_rec.alias_id.id], {'alias_parent_thread_id': project_id, 'alias_defaults': {'collection_id': project_id}}, context)
        #----------------------------------------------------- return project_id
    
    
    def action_draft(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'draft'})
        return True
    def action_confirmed(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)
        integrate_obj = self.pool.get('collection.integrate')
        integrate_line_obj = self.pool.get('collection.integrate.line')
        integ_id = integrate_obj.search(cr, uid, [('project_id','=',obj.project_id.id),('company_id','=',obj.company_id.id)])
        
        if integ_id ==[]:
           
            int_id = integrate_obj.create(cr, uid, {
                                                    'pro_col_id':obj.id,
                                                   'project_id':obj.project_id.id,
                                                   'company_id':obj.company_id.id,
                                                   'state':'draft',
                                                   })
        else:
            int_id = integ_id[0]
        cr.execute("""select sum(product_bom),product_id,pro_uom_id,is_foreign,company_id from collection_line 
                    where collection_id = %s  group by product_id,pro_uom_id,is_foreign,company_id"""%obj.id)
        integrate = cr.dictfetchall()
        

        if integrate !=[]:
            for lines in obj.line_id:
                cr.execute("""select li.id,li.product_id, li.pro_uom_id, li.product_count,li.integ_id from collection_integrate as int 
                            left join collection_integrate_line as li on
                            li.integ_id=int.id where int.pro_col_id = %s and  int.project_id = %s and li.product_id = %s"""%(obj.id,obj.project_id.id,lines.product_id.id))
                dict = cr.dictfetchall()
                if dict !=[]:
                    for li in dict:
                        integrate_line_obj.write(cr, uid, li['id'],{
                                                                   'product_count':lines.product_bom,
                                                                   })
                else:
            
                    if int_id==[]:
                        
                        int_id = int_id[0]
                    else:
                        int_id =int_id
                    
                    integrate_line_obj.create(cr, uid, {
                                    'product_id':lines.product_id.id,
                                    'pro_uom_id':lines.pro_uom_id.id,
                                    'product_count':lines.product_bom,
                                    'integ_id':int_id,
                                    'is_foreign':lines.is_foreign,
                                    'company_id':obj.company_id.id,
                                    })
        self.write(cr, uid, ids, {'state':'confirmed'}, context)
        return True
    
    def action_cancel(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)
        now_date = time.strftime('%Y-%m-%d')
        config_obj = self.pool.get('collection.configure')
        if obj.date != now_date:
            config_id = config_obj.search(cr, uid, [('company_id','=',obj.company_id.id)])
            if config_id !=[]:
                config = config_obj.browse(cr, uid, config_id)
                if obj.date[:7]==config.name:
                    self.write(cr,uid, ids,{
                                        'state':'cancel',
                                        })
                else:
                    raise osv.except_osv(_('Configuration Error!'), _(u'Түүвэр цуцлах хугацаа болоогүй байна!'))

            else:
                raise osv.except_osv(_('Configuration Error!'), _(u'Та түүвэр цуцлах тохиргоог үүсгээгүй байгаа тул үүсгэнэ үү!'))
        else:
            self.write(cr,uid, ids,{
                                    'state':'cancel',
                                        })

                

        return True
    def action_product_import(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)
        pro_task_obj = self.pool.get('project.task')
        collection_line_obj = self.pool.get('collection.line')
        bom_obj = self.pool.get('task.bom')
        task_id = pro_task_obj.search(cr, uid, [('project_id','=',obj.project_id.id)])
        pro_date = None
        datetime_format = "%Y-%m-%d"
        date_format = '%Y-%m-%d %H:%M:%S'
        
        if task_id !=[]:
           
            #task = pro_task_obj.browse(cr, uid, task_id)[0]
            for task in pro_task_obj.browse(cr, uid, task_id):
                
                bom_id = bom_obj.search(cr, uid, [('pro_task_id','=',task.task_id.id)])
                if task.date_start:
                   presence_date = datetime.strptime(task.date_start, date_format) + timedelta(days=7)
                   print'persence_______date',presence_date
                if bom_id !=[]:
                    bom = bom_obj.browse(cr, uid, bom_id)
                    
                    for lines in bom.line1_id:
                      
                        col_line_id = collection_line_obj.search(cr, uid, [('product_id','=',lines.product_id.id),('collection_id','=',obj.id)])
                        if col_line_id ==[]:
                            collection_line_obj.create(cr, uid, {
                                                                 'project_task_type_id':task.phase_id.id,
                                                                 'pro_uom_id':lines.pro_uom_id.id,
                                                                 'product_bom':lines.product_count*task.planned_hours,
                                                                 'product_id':lines.product_id.id,
                                                                 'collection_id':obj.id,
                                                                 'presence_date':presence_date,
                                                                 'project_id':obj.project_id.id,
                                                             })
                        else:
                            for line in collection_line_obj.browse(cr, uid, col_line_id):
                                collection_line_obj.write(cr, uid, line.id, {
                                         'project_task_type_id':task.phase_id.id,
                                         'pro_uom_id':lines.pro_uom_id.id,
                                         'product_bom':lines.product_count*task.planned_hours,
                                         'product_id':lines.product_id.id,
                                         'presence_date':presence_date,
                                          'collection_id':obj.id,
                                          'project_id':obj.project_id.id,
                                     })
            
        return True
    
class collection_line(osv.Model):
    _name = 'collection.line'
    
    def _write_material_sale_price(self, cr, uid, ids,name, args, context = None):
        
        obj = self.browse(cr, uid,ids)
        res = {}
        price = 0.0
        for line in obj:
            product_id = self.pool.get('product.product').browse(cr, uid, line.product_id.id)
            for li in product_id:
                price = li.lst_price         
                res[line.id] = price
        return res
    
    def _write_material_sum_price(self, cr, uid, ids,name, args, context = None):
        
        obj = self.browse(cr, uid,ids)
        res = {}
        sum_price = 0.0
        for line in obj:
             sum_price = line.material_price * line.product_count
             res[line.id] = sum_price
        return res

    
    _columns = {
        'collection_id':fields.many2one('project.collection','Project collection'),
        'project_id':fields.many2one('project.project','Project'),
        'product_id':fields.many2one('product.product', 'Product name'),
        'pro_uom_id':fields.many2one('product.uom', 'Unit'),
        'product_count':fields.float('Product count'),
        'is_foreign':fields.boolean('Is foreign'),
        'product_bom':fields.float('Product bom'),
        'material_count':fields.float('Material count'),
        'presence_date': fields.date('Presence date'),
        'material_price': fields.function(_write_material_sale_price, method=True, type ="float", string='Price'),
        'material_sum_price': fields.function(_write_material_sum_price, method=True, type ="float", string='Sum price'),
        'material_total_price': fields.float('Total price'),
        'task_bom_id':fields.many2one('task.bom','Task bom'),
        'project_task_type_id':fields.many2one('project.task.phase', 'Task stage'),
        'res_user_id': fields.many2one('res.users','User'),
        'company_id': fields.many2one('res.company','Company'),
        'pr_material_id':fields.many2one('performance.material','Material list'),
        'per_material_id':fields.many2one('task.performance','Material list'),
        'per1_material_id':fields.many2one('task.performance','Material list'),
        
    }
    _defaults = { 
        'presence_date': lambda obj, cr, uid, context: time.strftime('%Y-%m-%d'),
        'res_user_id': lambda obj, cr, uid, context: uid, 
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'collection.line', context=c),
        }
    def onchange_product_uom(self, cr, uid, ids, pro_id,context=None):
        res = {}
        
        temp_obj = self.pool.get('product.template')
        pro_obj = self.pool.get('product.product')
        if pro_id:
            
            pro = pro_obj.browse(cr, uid, pro_id)[0]
            #select * from product_product where id = prod_id
            temp = temp_obj.browse(cr, uid, pro.product_tmpl_id.id)[0]
            #select * from product_template where id = pro.tmpl_id.id
            
            res['pro_uom_id']=temp.uom_id.id
            res['material_price']=temp.lst_price
            return {'value':res}
    
       
    #===========================================================================
    # def action_view_per_material(self, cr, uid, ids, context=None):
    #     mod_obj = self.pool.get('ir.model.data')
    #     act_obj = self.pool.get('ir.actions.act_window')
    #     
    #     result = mod_obj.get_object_reference(cr, uid, 'ierp_project', 'action_performance_material_tree_view')
    #     id = result and result[1] or False
    #     result = act_obj.read(cr, uid, [id], context=context)[0]
    #     #compute the number of invoices to display
    #     inv_ids = []
    #     for so in self.browse(cr, uid, ids, context=context):
    #         inv_ids += [invoice.id for invoice in so.pr_material_id]
    #     #choose the view_mode accordingly
    #     if len(inv_ids)>1:
    #         result['domain'] = "[('id','in',["+','.join(map(str, inv_ids))+"])]"
    #     else:
    #         res = mod_obj.get_object_reference(cr, uid, 'ierp_project', 'performance_material_form_view')
    #         result['views'] = [(res and res[1] or False, 'form')]
    #         result['res_id'] = inv_ids and inv_ids[0] or False
    #     
    #     return result
    #===========================================================================
class task_bom_line(osv.Model):
    _name = 'task.bom.line' 
    
    def _write_material_sale_price(self, cr, uid, ids,name, args, context = None):
        
        obj = self.browse(cr, uid,ids)
        res = {}
        price = 0.0
        for line in obj:
            product_id = self.pool.get('product.product').browse(cr, uid, line.product_id.id)
            for li in product_id:
                price = li.lst_price         
                res[line.id] = price
        return res
    _columns = {
        'product_id':fields.many2one('product.product', 'Product name'),
        'pro_uom_id':fields.many2one('product.uom', 'Unit'),
        'material_count':fields.float('Material count'),
        'material_price': fields.function(_write_material_sale_price, method=True, type ="float", string='Price'),
        'material_total_price': fields.float('Total price'),
        'material_id':fields.many2one('project.task','Material list'),
        'company_id': fields.many2one('res.company','Company'),
        
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'task.bom.line', context=c),
        }
    
    def onchange_product_id(self, cr, uid, ids, product_id, context=None):
        res = {}
        temp_obj = self.pool.get('product.product')
        if product_id:
            #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
            temp = temp_obj.browse(cr, uid, temp_obj.search(cr, uid, [('id','=',product_id)]))
            res['pro_uom_id']=temp.uom_id.id
        return {'value':res}
    
class collection_integrate(osv.osv):
    _name = 'collection.integrate'
    
    _columns = {
                'name':fields.char('Collection code'),
                'create_date':fields.date('Create date'),
                'project_id':fields.many2one('project.project','Project'),
                'company_id':fields.many2one('res.company','Company'),
                'state':fields.selection([('draft','Draft'),
                                          ('confirm','Confirmed'),
                                          ('cancel','Cancel')],'State'),
                'line_id':fields.one2many('collection.integrate.line','integ_id','Line'),
                'pro_col_id':fields.many2one('project.collection','Project collection'),
                }
    _defaults = {
                'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'collection.integrate', context=c),    
                 'state':'draft',
                'create_date':time.strftime("%Y-%m-%d"),
                 }
    
    def action_confirmed(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)
        
        self.write(cr, uid, ids, {'state':'confirm'}, context)
        return True
    
    
class collection_integrate_line(osv.osv):
    _name = 'collection.integrate.line'
    
    def _get_diff(self, cr, uid, ids, field_name, arg, context=None):
        obj = self.browse(cr, uid, ids)
        res = {}
        diff = 0.0
        for line in obj:
            diff = line.product_count-line.income_quantity
            res[line.id] = diff
        return res
    _columns = {
                'company_id':fields.many2one('res.company','Company'),
                'product_id':fields.many2one('product.product','Product'),
                'pro_uom_id':fields.many2one('product.uom','Product uom'),
                'product_count':fields.float('Product count'),
                'presence_date':fields.date('Presence date'),
                'integ_id':fields.many2one('collection.integrate','Integrate'),
                'is_foreign':fields.boolean('Is foreign'),
                'income_quantity':fields.float('Income quantity'),
                'difference_quantity':fields.function(_get_diff,type='float',string='Difference quantity'),
                }
    _defaults = {  
                 'product_count':0.0,
                 'income_quantity':0.0,
                 'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'collection.integrate.line', context=c),    
                 }
    
    def onchange_product_id(self, cr, uid, ids, product_id, context=None):
        res = {}
        temp_obj = self.pool.get('product.product')
        if product_id:
            #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
            temp = temp_obj.browse(cr, uid, temp_obj.search(cr, uid, [('id','=',product_id)]))
            res['pro_uom_id']=temp.uom_id.id
        return {'value':res}
    
class collection_configure(osv.osv):
    _name = 'collection.configure'
    
    _columns = {
                'name':fields.integer('Config period'),
                'config_date':fields.date('Config date'),
                'company_id':fields.many2one('res.company','Company'),
                'user_id':fields.many2one('res.users','User'),
                }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'collection.configure', context=c),    
                 } 

class phase_per_report_line(osv.osv):
    _name = 'phase.per.report.line'
    _columns = {
         'task_id': fields.many2one('project.project.task','Task name'),
         'unit': fields.many2one('product.uom', 'Unit'),
         'performance_count':fields.float('Performance count'),
         'contract_price':fields.float('Contract price'),
         'contract_count':fields.float('Contract count'),
         'total_price':fields.float('Total price'),
         'company_id':fields.many2one('res.company','Company'),
         'phase_per_report_id':fields.many2one('phase.per.report','Phase per report'),  
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'performance.report.line', context=c),    
                 }
    
    def onchange_task_id(self, cr, uid, ids, task_id, context=None):
        res = {}
        temp_obj = self.pool.get('project.project.task')
        if task_id:
            #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
            temp = temp_obj.browse(cr, uid, temp_obj.search(cr, uid, [('id','=',task_id)]))
            res['unit']=temp.unit.id
        return {'value':res}

class phase_per_report_materials(osv.osv):
    _name = 'phase.per.report.materials'
    _columns = {
         'task_id': fields.many2one('project.project.task','Task name'),
         'product_id':fields.many2one('product.product', 'Product name'),
         'pro_uom_id':fields.many2one('product.uom', 'Unit'),
         'product_count':fields.float('Product count'),
         'bom_count':fields.float('Bom count'),
         'company_id':fields.many2one('res.company','Company'),
         'phase_per_report_mat_id':fields.many2one('phase.per.report','Phase performance report'),  
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'performance.report.line', context=c),    
                 }
    
    def onchange_product_id(self, cr, uid, ids, product_id, context=None):
        res = {}
        temp_obj = self.pool.get('product.product')
        if product_id:
            #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
            temp = temp_obj.browse(cr, uid, temp_obj.search(cr, uid, [('id','=',product_id)]))
            res['pro_uom_id']=temp.uom_id.id
        return {'value':res}

class phase_per_report_per_count(osv.osv):
    _name = 'phase.per.report.per.count'
    _columns = {
         'task_id': fields.many2one('project.project.task','Task name'),
         'per_product_id':fields.many2one('product.product', 'Performance product'),
         'product_id':fields.many2one('product.product', 'Product name'),
         'pro_uom_id':fields.many2one('product.uom', 'Unit'),
         'product_price':fields.float('Product price'),
         'total_price':fields.float('Total price'),
         'product_count':fields.float('Product count'),
         'company_id':fields.many2one('res.company','Company'),
         'phase_per_rep_id':fields.many2one('phase.per.report','Performance report'),  
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'performance.report.line', context=c),    
                 }
    
    def onchange_per_product_id(self, cr, uid, ids, per_product_id, context=None):
        res = {}
        temp_obj = self.pool.get('product.product')
        if per_product_id:
            #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
            temp = temp_obj.browse(cr, uid, temp_obj.search(cr, uid, [('id','=',per_product_id)]))
            res['pro_uom_id']=temp.uom_id.id
        return {'value':res}
    
    
    