# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import logging
import time
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _

    
class project_type(osv.Model):
    _name = 'project.type'
    _columns = {
        'name': fields.char('Type name', required=True),
        'company_id':fields.many2one('res.company','Company'),
        
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'project.type', context=c),    
                 }
class sub_phase(osv.Model):
    _name = 'sub.phase'
    _columns = {
        'name': fields.char('Project type', required=True),
        'company_id':fields.many2one('res.company','Company'),
        
    }  
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'sub.phase', context=c),    
                 } 
    
    
class project_project(osv.osv):
    _inherit = 'project.project'
    
    #===========================================================================
    # def _google_map_img(self, cr, uid, ids, name, args, context=None):
    #     employee = self.browse(cr, uid, ids[0], context=context)
    #     if employee.square_address:
    #         map_img_url = self.browse(cr, SUPERUSER_ID, ids[0], context=context).square_address
    #         return {ids[0]: map_img_url}
    #     return None
    #===========================================================================
    
    def _get_awards(self, cr, uid, ids, context=None):
        building_counts = []
        for building_count in self.browse(cr, uid, ids, context=None):
            building_counts += [x.id for x in building_count.building_count_ids]
        return building_counts
    
    def _get_act_window_dict(self, cr, uid, name, context=None):
        mod_obj = self.pool.get('ir.model.data')
        act_obj = self.pool.get('ir.actions.act_window')
        result = mod_obj.xmlid_to_res_id(cr, uid, name, raise_if_not_found=True)
        result = act_obj.read(cr, uid, [result], context=context)[0]
        return result
    
    def action_building_count(self, cr, uid, ids, context=None):
        boms = self._get_awards(cr, uid, ids, context=context)
        result = self._get_act_window_dict(cr, uid, 'ierp_project.action_project_project_inherit_for_building', context=context)

        result['domain'] = "[('id','in',[" + ','.join(map(str, boms)) + "]),('is_apartment','=',True)]"
        return result
    
    def _building_count(self, cr, uid, ids, field_name, arg, context=None):
        res={}
        task_bom = self.pool.get('project.project')
        for boms in ids:
            nb = task_bom.search_count(cr, uid, [('self_parent_id', '=', boms)], context=context)
            res[boms] = nb
        print '_building_count'
        return res
    
    
    _columns = {
                'pro_type':fields.many2one('project.type', 'Project type'),
                #'code': fields.char('Code'),
                'direction': fields.char('Direction'),
                'location': fields.char('Location'),
                'object_quantity': fields.char('Object quantity'),
                'total_finance': fields.char('Total finance'),
                'finance_type': fields.char('Finance type'),
                'prospective_sale': fields.char('Prospective sale'),
                'present_value': fields.char('PV'),
                'net_present_value': fields.char('NPV'),
                'profitability_index': fields.char('Profitability index'),
                'internal_rate_of_return': fields.char('IRR'),
                'discount_payback_period': fields.char('Discount payback period'),
                'is_apartment': fields.boolean('Is apartment'),
                'company_id':fields.many2one('res.company','Company'),
                'stage_line_id':fields.one2many('task.stage', 'stage_id','Project stage'),
                
                #WBS-tei holbootoi nemegdsen talbaruud
                'square_address': fields.char('Төслийн талбайн албан хаяг'),
                'capacity_ids':fields.one2many('project.capacity', 'project_id', 'Хүчин чадлууд'),
                'square_info_ids':fields.one2many('project.square.info', 'project_id', 'Талбайн мэдээллүүд'),
                'square_google_map': fields.text('Төслийн байршлын зураг'),
                #'square_google_map': fields.function(_google_map_img,'Төслийн байршлын зураг', type='text'),
                'building_infos': fields.text('Барилгын мэдээлэл'),
                'building_advantages': fields.text('Төслийн давуу талууд'),
                
                
                'have_household_size':fields.boolean('Айлын хүчин чадал байгаа эсэх'),
                'household_size':fields.integer('Айлын хүчин чадлын хэмжээ'),
                'have_parking':fields.boolean('Машины зогсоол байгаа эсэх'),
                'parking_size':fields.integer('Машины зогсоолын хэмжээ'),
                'have_service_square':fields.boolean('Үйлчилгээний талбай байгаа эсэх'),
                'service_square_size':fields.float('Үйлчилгээний талбайн хэмжээ'),
                 
                 
                'have_square_size':fields.boolean('Төслийн нийт талбай байгаа эсэх'),
                'square_size':fields.float('Төслийн нийт талбайн хэмжээ'),
                'have_buildings_size':fields.boolean('Барилгажих талбай байгаа эсэх'),
                'buildings_size':fields.float('Барилгажих талбайн хэмжээ'),
                'have_green_area_size':fields.boolean('Ногоон байгууламж байгаа эсэх'),
                'green_area_size':fields.float('Ногоон байгууламжийн талбайн хэмжээ'),
                'have_service_square2':fields.boolean('Үйлчилгээний талбай байгаа эсэх'),
                'service_square_size2':fields.float('Үйлчилгээний талбайн хэмжээ'),
                
                #'buildings': fields.one2many('project.project', 'building_id', "Buildings Activities"),
        
                'self_parent_id':fields.many2one('project.project','Барилгын толгой төсөл'),
                'building_count': fields.function(_building_count, type='integer', string="Барилгууд",),
                'building_count_ids': fields.one2many('project.project', 'self_parent_id', 'Buildings child', type='integer'),
                
                'is_performance':fields.boolean('Гүйцэтгэлд оруулах эсэх'),
                'percentile':fields.float('Хувийн жин'),
                
                
                }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'project.project', context=c),    
                 }
    
    def compute_task_dates(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid,ids)
        task_obj = self.pool.get('project.task')
        print 'ddddddddd', self, obj, len(obj.task_ids)
        
        
        list = []
        only_parents_id = task_obj.search(cr, uid, [('parent_ids','=',False),('child_ids','!=',False)], order="date_finish asc")
        only_parents = task_obj.browse(cr, uid, only_parents_id)
        print 'ooooo',only_parents_id, only_parents

        if only_parents:
            for line1 in only_parents:
                print 'mmmmmmmmm',line1
                par1_date_beg = line1.date_begin
                par1_date_fin = line1.date_finish
                etsgiin_zorvv_odor = line1.days_finish_dif
                if list != []:
                    print 'cccc3333',list,list[0]
                    print 'cccc4444',list[1]
                    line1 = list
                print 'mmmmmmmmm222',line1
                #if line1.child_ids:
                for line2 in line1.child_ids:
                    parents_id_of_line2_id = task_obj.search(cr, uid, [('child_ids','in',line2.id)], order="date_finish asc", limit = 1)
                    parents_id_of_line2 = task_obj.browse(cr, uid, parents_id_of_line2_id)
                    print 'eeeeee', parents_id_of_line2, parents_id_of_line2.id
                    
                    if line1.id == parents_id_of_line2.id:
                        print '111111111', line2,line2.id, line2.child_ids, line2.child_ids.name, line2.child_ids.id
                        par2_date_beg = line2.date_begin
                        par2_date_fin = line2.date_finish
                        etsgiin2_zorvv_odor = line2.days_finish_dif
                        print 'iiii', par1_date_fin, line2.date_begin
                        
                        if par1_date_fin > par2_date_beg:
                            print '1111111'
                            add_date1 = par1_date_fin
                            add_date2 = datetime.strptime(str(par1_date_fin), '%Y-%m-%d') + timedelta(days=(etsgiin2_zorvv_odor - 1))
                        else:
                            print '222222'
                            add_date1 = par2_date_beg
                            add_date2 = datetime.strptime(str(par2_date_beg), '%Y-%m-%d') + timedelta(days=(etsgiin2_zorvv_odor - 1))
                        print 'uuuuuu', add_date1, add_date2
                        def_date_days = (datetime.strptime(str(add_date2.date()), '%Y-%m-%d') - datetime.strptime(str(add_date1), '%Y-%m-%d')).days
                        line2.write({'date_begin':add_date1, 'date_finish':add_date2})
                    list.append(line2)
                    #===========================================================
                    # for line24 in line1.child_ids:
                    #     line1.child_ids = line24.child_ids
                    #===========================================================
                #===============================================================
                # while line1.child_ids:
                #     for line25 in line1.child_ids:
                #         line1 = line25
                #         print 'ooooooooooooooo', line1
                #===============================================================
                else:
                    print 'ooooooooooooooo222', line1, line1.parent_ids
                    for line3 in line1.parent_ids:
                        parents_id_of_line3_id = task_obj.search(cr, uid, [('child_ids','in',line3.id)], order="date_finish desc", limit = 1)
                        parents_id_of_line3 = task_obj.browse(cr, uid, parents_id_of_line3_id)
                        print 'eeeeee7777', parents_id_of_line3, parents_id_of_line3.id
                         
                        #if line1.id == parents_id_of_line3.id:
                            #etssiin hvvhdvvd
                        last_child_date_beg = line3.date_begin
                        last_child_date_fin = line3.date_finish
                        etsgiin3_zorvv_odor = line3.days_finish_dif
                        print 'ggggg7777', last_child_date_beg, last_child_date_fin
                        print 'oppppp77777', add_date2,add_date2.date(), last_child_date_beg, type(datetime.strptime(str(last_child_date_beg), '%Y-%m-%d')),type(datetime.strptime(str(add_date2.date()), '%Y-%m-%d'))
                         
                        if datetime.strptime(str(last_child_date_fin), '%Y-%m-%d') > datetime.strptime(str(line1.date_begin), '%Y-%m-%d'):
                            add_date3 = last_child_date_fin
                            add_date4 = datetime.strptime(str(last_child_date_fin), '%Y-%m-%d') + timedelta(days=(line1.days_finish_dif-1))
                        else:
                            add_date3 = line1.date_begin
                            add_date4 = datetime.strptime(str(line1.date_begin), '%Y-%m-%d') + timedelta(days=(line1.days_finish_dif-1))
                        
                        print 'hhhhhhhhhh888888', add_date3, add_date4
                        def_date_days2 = (datetime.strptime(str(add_date4.date()), '%Y-%m-%d') - datetime.strptime(str(add_date3), '%Y-%m-%d')).days
                        line1.write({'date_begin':add_date3, 'date_finish':add_date4})
                list = list
        #=======================================================================
        # 
        # for line_parents in only_parents:
        #     do1_function
        #     
        #     while line_parents.child_ids:
        #         p_ids = line_parents
        #         ch_ids = line_parents.child_ids
        #     if line_parents.child_ids:
        #         for line_chil in line_parents.child_ids:
        #             
        # if line_parents.child_ids:
        #     line_parents = for line in line_parents.child_ids:
        #     
        #=======================================================================
        #=======================================================================
        # for line1 in only_parents:
        #     #anhniii etsgvvd
        #     par1_date_beg = line1.date_begin
        #     par1_date_fin = line1.date_finish
        #     etsgiin_zorvv_odor = line1.days_finish_dif
        #     print 'daaaaaaaaaaaaaaateeeeeeeeee', par1_date_beg, par1_date_fin
        #     print 'sssss', line1
        #     if line1.child_ids:
        #         for line2 in line1.child_ids:
        #             parents_id_of_line2_id = task_obj.search(cr, uid, [('child_ids','in',line2.id)], order="date_finish desc", limit = 1)
        #             parents_id_of_line2 = task_obj.browse(cr, uid, parents_id_of_line2_id)
        #             print 'eeeeee', parents_id_of_line2, parents_id_of_line2.id
        #             
        #             if line1.id == parents_id_of_line2.id:
        #                 print '111111111', line2,line2.id, line2.child_ids, line2.child_ids.name, line2.child_ids.id
        #                 par2_date_beg = line2.date_begin
        #                 par2_date_fin = line2.date_finish
        #                 etsgiin2_zorvv_odor = line2.days_finish_dif
        #                 print 'iiii', par1_date_fin, line2.date_begin
        #                 
        #                 if par1_date_fin > par2_date_beg:
        #                     print '1111111'
        #                     add_date1 = par1_date_fin
        #                     add_date2 = datetime.strptime(str(par1_date_fin), '%Y-%m-%d') + timedelta(days=(etsgiin2_zorvv_odor - 1))
        #                 else:
        #                     print '222222'
        #                     add_date1 = par2_date_beg
        #                     add_date2 = datetime.strptime(str(par2_date_beg), '%Y-%m-%d') + timedelta(days=(etsgiin2_zorvv_odor - 1))
        #                 print 'uuuuuu', add_date1, add_date2
        #                 def_date_days = (datetime.strptime(str(add_date2.date()), '%Y-%m-%d') - datetime.strptime(str(add_date1), '%Y-%m-%d')).days
        #                 line2.write({'date_begin':add_date1, 'date_finish':add_date2})
        #                 
        #                 if line2.child_ids:
        #                     for line3 in line2.child_ids:
        #                         parents_id_of_line3_id = task_obj.search(cr, uid, [('child_ids','in',line3.id)], order="date_finish desc", limit = 1)
        #                         parents_id_of_line3 = task_obj.browse(cr, uid, parents_id_of_line3_id)
        #                         print 'eeeeee', parents_id_of_line3, parents_id_of_line3.id
        #                         
        #                         if line2.id == parents_id_of_line3.id:
        #                             #etssiin hvvhdvvd
        #                             last_child_date_beg = line3.date_begin
        #                             last_child_date_fin = line3.date_finish
        #                             etsgiin3_zorvv_odor = line3.days_finish_dif
        #                             print 'oppppp', add_date2,add_date2.date(), last_child_date_beg, type(datetime.strptime(str(last_child_date_beg), '%Y-%m-%d')),type(datetime.strptime(str(add_date2.date()), '%Y-%m-%d'))
        #                             
        #                             if datetime.strptime(str(add_date2.date()), '%Y-%m-%d') > datetime.strptime(str(last_child_date_beg), '%Y-%m-%d'):
        #                                 add_date3 = add_date2.date()
        #                                 add_date4 = datetime.strptime(str(add_date2.date()), '%Y-%m-%d') + timedelta(days=(etsgiin3_zorvv_odor-1))
        #                             else:
        #                                 add_date3 = last_child_date_beg
        #                                 add_date4 = datetime.strptime(str(last_child_date_beg), '%Y-%m-%d') + timedelta(days=(etsgiin3_zorvv_odor-1))
        #                                  
        #                             def_date_days2 = (datetime.strptime(str(add_date4.date()), '%Y-%m-%d') - datetime.strptime(str(add_date3), '%Y-%m-%d')).days
        #                             line3.write({'date_begin':add_date3, 'date_finish':add_date4})
        #=======================================================================
        #self.write(cr, uid, ids, {'state':'draft'}, context)   
        return True

    def create(self, cr, uid, vals, context=None):
        if context is None:
            context = {}
        # Prevent double project creation when 'use_tasks' is checked + alias management
        create_context = dict(context, project_creation_in_progress=True,
                              alias_model_name=vals.get('alias_model', 'project.task'),
                              alias_parent_model_name=self._name)

        if vals.get('type', False) not in ('template', 'contract'):
            vals['type'] = 'contract'

        project_id = super(project, self).create(cr, uid, vals, context=create_context)
        project_rec = self.browse(cr, uid, project_id, context=context)
        self.pool.get('mail.alias').write(cr, uid, [project_rec.alias_id.id], {'alias_parent_thread_id': project_id, 'alias_defaults': {'project_id': project_id}}, context)
        return project_id

    def write(self, cr, uid, ids, vals, context=None):
        # if alias_model has been changed, update alias_model_id accordingly
        if vals.get('alias_model'):
            model_ids = self.pool.get('ir.model').search(cr, uid, [('model', '=', vals.get('alias_model', 'project.task'))])
            vals.update(alias_model_id=model_ids[0])
        return super(project, self).write(cr, uid, ids, vals, context=context)

class project_capacity(osv.Model):
    _name = 'project.capacity'
    _columns = {
        
        'project_id': fields.many2one('project.project','Project'),
        'name': fields.char('Нэр'),
        'size': fields.char('Хэмжээ'),
        
    }

class project_square_info(osv.Model):
    _name = 'project.square.info'
    _columns = {
        
        'project_id': fields.many2one('project.project','Project'),
        'name': fields.char('Нэр'),
        'size': fields.char('Хэмжээ'),
        
    }

class product_product(osv.Model):
    _inherit = 'product.product'
    _columns = {
        'project_collection_id': fields.many2one('project.collection','Project collection'),
        
    }
    
class project_task_phase(osv.Model):
    _inherit = 'project.task.phase'
    _columns = {
        'code':fields.char('Код'),
        
    }
    
class project_task_phase2(osv.Model):
    _name = 'project.task.phase2'
    _columns = {
        'name':fields.char('Ажлын үе шат'),
        'code':fields.char('Код'),
        
    }
    
class project_task_phase3(osv.Model):
    _name = 'project.task.phase3'
    _columns = {
        'name':fields.char('Ажил'),
        'code':fields.char('Код'),
        
    }
    
    
class project_project_task(osv.Model):
    _name = 'project.project.task'

    def _call_bom(self, cr, uid, ids, field_name, arg, context=None):
        res={}
        task_bom = self.pool.get('task.bom')
        for boms in ids:
            nb = task_bom.search_count(cr, uid, [('pro_task_id', '=', boms)], context=context)
            res[boms] = nb
        return res
    
    _columns = {
        'name':fields.char('Name', required=True),
        'code':fields.char('Code'),
        'payroll_job':fields.float('Payroll job'),
        'unit':fields.many2one('product.uom', 'Unit'),
        'project_task_quantity': fields.float('Task quantity'),
        'call_bom': fields.function(_call_bom, type='integer',string="Bom",),
        'company_id':fields.many2one('res.company','Company'),
        'bom_ids':fields.one2many('task.bom', 'pro_task_id'),
        
        
        'project_task_phase_id':fields.many2one('project.task.phase', 'Төслийн үе шат'),
        'code1':fields.char('Төслийн үе шатны код'),
        
        'project_task_phase_id2':fields.many2one('project.task.phase2', 'Ажлын үе шат'),
        'code2':fields.char('Ажлын үе шатны код'),
        
        'project_task_phase_id3':fields.many2one('project.task.phase3', 'Ажил'),
        'code3':fields.char('Ажлын код'),
        
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'project.project.task', context=c),    
                 }
    def _get_tasks(self, cr, uid, ids, context=None):
        tasks = []
        for task in self.browse(cr, uid, ids, context=None):
            tasks += [x.id for x in task.bom_ids]
        return tasks
    def _get_act_window_dict(self, cr, uid, name, context=None):
        mod_obj = self.pool.get('ir.model.data')
        act_obj = self.pool.get('ir.actions.act_window')
        result = mod_obj.xmlid_to_res_id(cr, uid, name, raise_if_not_found=True)
        result = act_obj.read(cr, uid, [result], context=context)[0]
        return result
        
    def create(self, cr, uid, vals, context=None):
        task_per_obj = self.pool.get('project.project.task')
        if 'code3' in vals:
            code3 = vals['code3']
            filter = str(code3)
            cr.execute("select code from project_project_task where code like '"+filter+"%' order by code desc limit 1")
            employee_code_info  = cr.dictfetchall()
            if employee_code_info:
                for employee in employee_code_info:
                    empii = employee['code']
                    if empii == None:
                        i = 1
                    else:
                        i = int(empii[-3:]) + 1
            else:
                i = 1
            vals['code'] = str(code3) + '.' + u'%s'%str(i).zfill(3)
        return super(project_project_task, self).create(cr, uid, vals, context=context)
    
    def action_view_bom(self, cr, uid, ids, context=None):
        boms = self._get_tasks(cr, uid, ids, context=context)
        result = self._get_act_window_dict(cr, uid, 'ierp_project.action_task_bom_tree_view', context=context)

        result['domain'] = "[('id','in',[" + ','.join(map(str, boms)) + "])]"
        return result
    
    def onchange_project_task_phase_id(self, cr, uid, ids, project_task_phase_id, context=None):
        res = {}
        if project_task_phase_id != None:
            decr_obj = self.pool.get('project.task.phase')
            decr_id = decr_obj.search(cr, uid, [('id','=',project_task_phase_id)])
            decr = decr_obj.browse(cr, uid, decr_id)
            res['code1']=decr.code
            return {'value':res}
    
    def onchange_project_task_phase_id2(self, cr, uid, ids, project_task_phase_id2, context=None):
        res = {}
        if project_task_phase_id2 != None:
            decr_obj = self.pool.get('project.task.phase2')
            decr_id = decr_obj.search(cr, uid, [('id','=',project_task_phase_id2)])
            decr = decr_obj.browse(cr, uid, decr_id)
            res['code2']=decr.code
            return {'value':res}
    
    def onchange_project_task_phase_id3(self, cr, uid, ids, project_task_phase_id3, context=None):
        res = {}
        if project_task_phase_id3 != None:
            decr_obj = self.pool.get('project.task.phase3')
            decr_id = decr_obj.search(cr, uid, [('id','=',project_task_phase_id3)])
            decr = decr_obj.browse(cr, uid, decr_id)
            res['code3']=decr.code
            return {'value':res}

    
class task_material(osv.Model):
    _name = 'task.material'
    _columns = {
        'pro_task_id':fields.many2one('project.project.task','Task name'),
        'unit':fields.many2one('product.uom', 'Unit'),
        'project_task_quantity': fields.float('Task quantity'),
        'company_id':fields.many2one('res.company','Company'),
        
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'task.material', context=c),    
                 }
    
    
class task_bom(osv.Model):
    _name = 'task.bom'
    _columns = {
        'pro_task_id':fields.many2one('project.project.task','Task name'),
        'unit':fields.many2one('product.uom', 'Unit'),
        'state':fields.selection([('draft','Draft'),
                                  ('confirmed','Confirmed')],'State'),
        'company_id':fields.many2one('res.company','Company'),
        'line1_id':fields.one2many('collection.line','task_bom_id', 'Collection line')  
    }
    _defaults = {
        'state' : lambda *a: 'draft', 
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'task.bom', context=c)        
                 }
   
    def onchange_check_task(self, cr, uid, ids, pro_task_id,context=None):
            
            res = {}
            obj_id = self.search(cr, uid, [('pro_task_id','=',pro_task_id)])
            temp_obj = self.pool.get('project.project.task')
            if obj_id:
                raise osv.except_osv(_('Warning!'), _('Task bom matching !!!'))
            
            if pro_task_id:
                
                temp = temp_obj.browse(cr, uid, pro_task_id)[0]
                
                res['unit']=temp.unit.id
            

            return {'value':res}
                    
    
class project_budget(osv.Model):
    _name = 'project.budget'
    _columns = {
        'name':fields.char('Budget name'),
        'project_id':fields.many2one('project.project', 'Project name'),
        'project_task_type_id':fields.many2one('project.task.type', 'Task stage'),
        'start_date':fields.date('Start date'),
        'end_date':fields.date('End date'), 
        'company_id':fields.many2one('res.company','Company'), 
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'project.budget', context=c),    
                 }
    
class task_list(osv.Model):
    _name = 'task.list'
    _columns = {
        'task_id':fields.many2one('project.project.task', 'Task name'),
        'unit':fields.many2one('product.uom', 'Unit'),
        'code':fields.char('Code'),
        'start_date':fields.date('Start date'),
        'end_date':fields.date('End date'),  
        'approved_count':fields.float('Approved count'), 
        'company_id':fields.many2one('res.company','Company'),
        'task_line_id':fields.many2one('task.line','Task line'),
        
        'building_id':fields.many2one('building.building','Building'),
        'door_id':fields.many2one('product.product','Product', domain="[('building_id', '=', building_id),('is_asset', '=', True)]"),
        'entrance':fields.char('Entrance'),
        'floor':fields.char('Floor'),
        #'task_id':fields.many2one('project.project.task','Project task'),
        'user_id':fields.many2one('res.users','Assigned'),
        'description':fields.text('Description'),
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'task.list', context=c),    
                 }
    def onchange_task(self, cr, uid, ids, task_id,context=None):
            res = {}
            
            temp_obj = self.pool.get('project.project.task')
            if task_id:
                
                temp = temp_obj.browse(cr, uid, task_id)[0]
                
                res['unit']=temp.unit.id
                res['code']=temp.code
                
            
                return {'value':res}
    def onchange_door_id(self, cr, uid, ids, door_id,context=None):
            res = {}
            obj = self.browse(cr, uid,ids)
            door_obj = self.pool.get('product.product')
            door_obj_id = door_obj.browse(cr,uid,door_id)
            res['entrance']=door_obj_id.entrance
            res['floor']=door_obj_id.floor
                
            return {'value':res}
        
    def onchange_building_id(self, cr, uid, ids, building_id,context=None):
            res = {}
            obj = self.browse(cr, uid,ids)
            res['door_id']=False
            res['entrance']=False
            res['floor']=False
                
            return {'value':res}
    
class task_line(osv.Model):
    _name = 'task.line'
    _columns = {
        'company_id':fields.many2one('res.company','Company'),
        'project_id':fields.many2one('project.project', 'Project name'),
        'project_task_phase_id':fields.many2one('project.task.phase', 'Task phase'),
        'state':fields.selection([('draft','Draft'),
                                  ('confirmed','Confirmed'),
                                  ('cancel','Cancel')],'State'),
        'tsk_id':fields.one2many('task.list','task_line_id', 'Task'),
        'note':fields.text('Note'),
        
         } 
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'task.line', context=c), 
        'state':'draft',   
                 }
    def action_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'cancel'}, context)   
        return True
    def action_draft(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'draft'}, context)   
        return True
    def action_confirm(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid,ids)
        pro_task_obj = self.pool.get('project.task')
        task_obj = self.pool.get('project.project.task')
       
        for tasks in obj.tsk_id:
            temp = task_obj.browse(cr, uid, tasks.task_id.id)[0]
           
            if obj.project_task_phase_id.id !=tasks.task_id.project_task_phase_id.id:
                raise osv.except_osv(_('Warning!'), _('Үе шатны ажил буруу оруулсан байна !!!    Ажлын нэр: %s') % tasks.task_id.name)
            
            if obj.project_id.id !=tasks.building_id.project_id.id:
                raise osv.except_osv(_('Warning!'), _('Төслийн байрыг буруу оруулсан байна !!!    Байрны нэр: %s') % tasks.building_id.name)
                    
            else:
                pro_task_obj.create(cr, uid, {
                                             'task_list_id':tasks.id,
                                             'name':tasks.task_id.name,
                                             'project_id':obj.project_id.id,
                                             'phase_id':obj.project_task_phase_id.id,
                                             'building_id':tasks.building_id.id,
                                             'door_id':tasks.door_id.id,
                                             'entrance':tasks.entrance,
                                             'floor':tasks.floor,
                                             #'stage_id':obj.project_task_type_id.id,
                                             'task_id':tasks.task_id.id,
                                             'user_id':tasks.user_id.id,
                                             'planned_hours': tasks.approved_count,
                                             'unit':tasks.unit.id,
                                             'date_start': tasks.start_date,
                                             'date_end':tasks.end_date,
                                             'date_deadline':tasks.end_date,
                                             'description':tasks.description,
                                             'total_hours':tasks.approved_count,
                                             'remaining_hours':tasks.approved_count,
                                             'code':temp.code,
                                                         })    
            self.write(cr, uid, ids, {'state':'confirmed'}, context)   
        return True 

    
class task(osv.osv):
    _name ='project.task'
    _inherit = 'project.task'
 
    
    def _write_material_costs(self, cr, uid, ids,name, args, context = None):
        
        obj = self.browse(cr, uid,ids)[0]
        sum_price = 0.0
        
        live_people_obj = self.pool.get('task.performance')
        live_people_id = live_people_obj.search(cr, uid, [('task_id','=',obj.task_id.id),('state','=','confirmed')])
        task_p_id = live_people_obj.browse(cr, uid, live_people_id)
        
        for task_perf_id in task_p_id:
                for tpi in task_perf_id.line_id:
                    sum_price += tpi.product_id.lst_price*tpi.material_real_count
        
        self.write(cr, uid, obj.id, {'executed_material_cost_report': sum_price})
        
        return {ids[0]:sum_price}
    

    def _write_salary(self, cr, uid, ids,name, args, context = None):
       obj = self.browse(cr, uid,ids)[0]
       task_id = self.pool.get('project.project.task').browse(cr, uid, obj.task_id.id)
       executed_salary = 0.0
       
       if task_id.payroll_job != 0:
           executed_salary = task_id.payroll_job * obj.effective_hours
           self.write(cr, uid, obj.id, {'executed_payroll_job_report': executed_salary})
       return {ids[0]:executed_salary}


    
    def _write_total_costs(self, cr, uid, ids,name, args, context = None):
        obj = self.browse(cr, uid,ids)[0]
        total_executed_cost = 0.0
        if obj.executed_payroll_job or obj.executed_material_cost:
            total_executed_cost = obj.executed_payroll_job + obj.executed_material_cost
        else:
            total_executed_cost = 0.0
        self.write(cr, uid, obj.id, {'sum_executed_cost_report': total_executed_cost})
        return {ids[0]:total_executed_cost}
    
    def _effective_days(self, cr, uid, ids,name, args,vals, context = None):
        obj = self.browse(cr, uid,ids)[0]
        res  = {}
        summ = 0.0
        for line in obj.work_ids:
            summ += line.hours
        
        e_hours = 0.0
        pl_days = 0.0
        e_percent = 0.0
        e_days = 0.0
        if 'planned_days' in vals:
            pl_days = vals['planned_days']
        else:
            pl_days = obj.planned_days
        
        if 'work_ids' in vals and 'remaining_hours' not in vals:
            #for line in obj.work_ids:
            e_hours = summ
            e_percent = e_hours / (obj.remaining_hours + e_hours)
            e_days = pl_days * e_percent
            #vals['effective_days'] = e_days
        elif 'work_ids' in vals and 'remaining_hours' in vals:
            #for line in obj.work_ids:
            e_hours = summ
            e_percent = e_hours / (vals['remaining_hours'] + e_hours)
            e_days = pl_days * e_percent
            #vals['effective_days'] = e_days
            vals['remaining_hours'] = vals['remaining_hours']
        elif 'work_ids' not in vals and 'remaining_hours' in vals:
            e_hours = obj.effective_hours
            e_percent = e_hours / (vals['remaining_hours'] + e_hours)
            e_days = pl_days * e_percent
            #vals['effective_days'] = e_days
            vals['remaining_hours'] = vals['remaining_hours']
        elif 'work_ids' not in vals and 'remaining_hours' not in vals:
            e_hours = obj.effective_hours
            print 'k', e_percent, e_hours, obj.total_hours
            if obj.total_hours != 0.0:
                e_percent = e_hours / obj.total_hours
            else:
                e_percent = 0.0
            e_days = pl_days * e_percent
            #vals['effective_days'] = e_days
        if 'remaining_hours' in vals:
            res[obj.id] = e_days
            res[obj.id] = vals['remaining_hours']
        else:
            res[obj.id] = e_days
        
        self.write(cr, uid, obj.id, {'effective_days_report': e_days})
        return res
    

    def _progress_total_costs(self, cr, uid, ids,name, args, context = None):
        obj = self.browse(cr, uid,ids)[0]
        total_cost = 0.0
        if obj.sum_executed_cost > obj.sum_approved_cost:
            total_cost = 100.0
        else:
            if obj.sum_approved_cost > 0:
                total_cost = round(min(100.0 * obj.sum_executed_cost / obj.sum_approved_cost, 100.00),2)
            else:
                total_cost = 0.0
        return {ids[0]:total_cost}
    
    def _hours_get(self, cr, uid, ids, field_names, args, context=None):
        res = {}
        cr.execute("SELECT task_id, COALESCE(SUM(hours),0) FROM project_task_work WHERE task_id IN %s GROUP BY task_id",(tuple(ids),))
        hours = dict(cr.fetchall())
        for task in self.browse(cr, uid, ids, context=context):
            res[task.id] = {'effective_hours': hours.get(task.id, 0.0), 'total_hours': (task.remaining_hours or 0.0) + hours.get(task.id, 0.0)}
            res[task.id]['delay_hours'] = res[task.id]['total_hours'] - task.planned_hours
            res[task.id]['progress'] = 0.0
            if (task.remaining_hours + hours.get(task.id, 0.0)):
                print'kkkkkkkkkkkkkkk',round(min(100.0 * hours.get(task.id, 0.0) / res[task.id]['total_hours'], 100.00),2)
                res[task.id]['progress'] = round(min(100.0 * hours.get(task.id, 0.0) / res[task.id]['total_hours'], 100.00),2)
            # TDE CHECK: if task.state in ('done','cancelled'):
            if task.stage_id and task.stage_id.fold:
                res[task.id]['progress'] = 100.0
        return res
    def _get_task(self, cr, uid, ids, context=None):
        result = {}
        for work in self.pool.get('project.task.work').browse(cr, uid, ids, context=context):
            if work.task_id: result[work.task_id.id] = True
        return result.keys()
    _columns = {
        'name': fields.char('Task Summary'),
        ##### tb nemew ###
        'building_id':fields.many2one('building.building', 'Байр',
                    domain="[('project_id', '=', project_id)]"),
        'door_id':fields.many2one('product.product', 'Тоот',
                    domain="[('building_id', '=', building_id),('is_asset', '=', True)]"),
        'entrance': fields.char('Орц'),
        'floor': fields.char('Давхар'),
        'date_deadline_start': fields.date('Анхны төлөвлөсөн эхлэх хугацаа', required=True),
        'date_begin': fields.date('Date begin'),
        'date_finish': fields.date('Date finish'),
        'days_finish_dif': fields.integer('Ажилбарын дуусах хугацааг өөрчилсөн сүүлийн зөрүү /өдрөөр/'),
        'planned_days':fields.float('Төлөвлөсөн хоног'),
        #'effective_days':fields.float('Effective days'),
        'effective_days': fields.function(_effective_days, method=True, type ="float", string='Effective days'),
        'effective_days_report': fields.float('Гүйцэтгэлийн хоног'),
        #Effective days report
        #'effective_days':fields.function(_effective_days, method=True, store=True, type ="float", string='Effective days'),
        
        'project_phase_id':fields.many2one('project.task.type', 'Task stage',
                    domain="[('project_ids', '=', project_id)]"),
        'project_phase_id2':fields.many2one('project.task.phase2', 'Ажлын үе шат'),
        'project_phase_id3':fields.many2one('project.task.phase3', 'Ажил'),
        'task_id':fields.many2one('project.project.task', 'Task name'),
        'code': fields.char('Task code'),
        'unit':fields.many2one('product.uom', 'Unit'),
        'approved_payroll_job': fields.float('Анхны төлөвлөсөн цалин'),
        #Approved payroll job
        'approved_material_cost': fields.float('Анхны төлөвлөсөн материал'),
        #Approved material cost
        'approved_contract_payroll_job': fields.float('Гэрээний цалин'),
        'executed_payroll_job': fields.function(_write_salary, method=True, type ="float", string='Executed payroll job'),
        'executed_payroll_job_report': fields.float('Цалин.'),
        'executed_material_cost': fields.function(_write_material_costs, method=True, type ="float", string='Executed material cost'),
        'executed_material_cost_report': fields.float('Материал.'),
        'sum_approved_cost': fields.float('Нийт батлагдсан ажлын зардал'),
        #Sum approved job
        'sum_executed_cost': fields.function(_write_total_costs, method=True, type ="float", string='Нийт гүйцэтгэсэн ажлын зардал'),
        'sum_executed_cost_report': fields.float('Нийт гүйцэтгэсэн ажлын зардал.'),
        #Sum executed cost
        'progress_amount': fields.function(_progress_total_costs, method=True, type ="float", string='Progress amount (%)'),
        #'progress_amount_report': fields.float('Зардлаарх явц (%).'),
        
        'task_list_id':fields.many2one('task.list','Tasks'),
        #'partner_id':fields.many2one('res.partner', 'Partner'),
        'line_id':fields.one2many('task.bom.line','material_id', 'Collection line'),
        'planned_hours': fields.float('Approved count', help='Estimated quantity to do the task, usually set by the project manager when the task is in draft state.'),
        'remaining_hours': fields.float('Remaining quantity', digits=(16,2), help="Total remaining quantity, can be re-estimated periodically by the assignee of the task."),
        'progress': fields.function(_hours_get, string='Progress (%)', multi='hours', group_operator="avg", help="If the task has a progress of 99.99% you should close the task if it's finished or reevaluate the time",
            store = {
                'project.task': (lambda self, cr, uid, ids, c={}: ids, ['work_ids', 'remaining_hours', 'planned_hours', 'state', 'stage_id'], 10),
                'project.task.work': (_get_task, ['hours'], 10),
            }),        }
    _defaults = { 
            'date_deadline_start': lambda obj, cr, uid, context: time.strftime('%Y-%m-%d'),
            #'user_id': lambda obj, cr, uid, context: uid, 
            #'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'material.line', context=c), 
         }
    def onchange_date_finish(self, cr, uid, ids, date_begin, date_finish, context=None):
        res = {}
        obj = self.browse(cr, uid, ids)
        dif_real = 1
        if date_begin and date_finish:
            dif = (datetime.strptime(str(date_finish), '%Y-%m-%d') - datetime.strptime(str(date_begin), '%Y-%m-%d')).days
            dif_real = dif + 1
        else:
            pass
        res['days_finish_dif'] = dif_real
        return {'value':res}
    def onchange_deadline_start(self, cr, uid, ids, date_deadline_start,date_deadline,context=None):
            res = {}
            converted_date = str(date_deadline_start) + " 00:00:01"
            day = '%Y-%m-%d'
            total = 0
            delta_day = 0
            if date_deadline_start and date_deadline:
                a = datetime.strptime(date_deadline_start, day)
                b = datetime.strptime(date_deadline, day)
                total = b - a
                delta_day = total.days + 1
            res['planned_days'] = delta_day
            res['date_start'] = converted_date
            res['date_begin'] = converted_date
            return {'value':res}
    def onchange_deadline_end(self, cr, uid, ids, date_deadline,date_deadline_start, context=None):
            res = {}
            day = '%Y-%m-%d'
            total = 0
            delta_day = 0
            converted_date = ''
            if date_deadline:
                converted_date = str(date_deadline) + " 00:00:01"
                a = datetime.strptime(date_deadline_start, day)
                b = datetime.strptime(date_deadline, day)
                total = b - a
                delta_day = total.days + 1
            else:
                pass
            res['planned_days'] = delta_day
            res['date_end'] = converted_date
            res['date_finish'] = converted_date
            return {'value':res}
    
    def onchange_door_id(self, cr, uid, ids, door_id,context=None):
            res = {}
            obj = self.browse(cr, uid,ids)
            toot_obj = self.pool.get('product.product')
            toot = toot_obj.browse(cr, uid, door_id)
            if door_id:
                res['entrance']=toot.entrance
                res['floor']=toot.floor
            else:
                res['entrance']=""
                res['floor']=""
            return {'value':res}

    def onchange_task_uom_code(self, cr, uid, ids, task_id,context=None):
            res = {}
            obj = self.browse(cr, uid,ids)
            temp_obj = self.pool.get('project.project.task')
            material_obj = self.pool.get('task.bom')
            coll_obj = self.pool.get('collection.line')
            if task_id:
                temp = temp_obj.browse(cr, uid, task_id)[0]
                res['project_phase_id']=temp.project_task_phase_id.id
                res['project_phase_id2']=temp.project_task_phase_id2.id
                res['project_phase_id3']=temp.project_task_phase_id3.id
                res['unit']=temp.unit.id
                res['code']=temp.code
                res['name']=temp.name
            return {'value':res}
    
    def action_compute(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid,ids)
        temp_obj = self.pool.get('project.project.task')
        material_obj = self.pool.get('task.bom')
        task_bom_line_obj = self.pool.get('task.bom.line')
        if obj.task_id:
            mat_id = material_obj.search(cr, uid, [('pro_task_id','=',obj.task_id.id)])
            if mat_id:
                task = material_obj.browse(cr, uid, mat_id)[0]
           
                for pro in task.line1_id:
                    task_bom_line_id = task_bom_line_obj.search(cr, uid, [('material_id','=',obj.id),('product_id','=',pro.product_id.id),])
                    
                    if task_bom_line_id!= []:
                       
                           task_bom_line_obj.write(cr, uid, task_bom_line_id,{
                            'material_count': pro.product_count * obj.planned_hours,
                            'material_total_price': pro.material_sum_price * obj.planned_hours,
                            
                             }, context=context)
                    else:
                       task_bom_line_obj.create(cr, uid,{
                                                    'material_id':obj.id,
                        'product_id': pro.product_id.id,
                        'pro_uom_id': pro.pro_uom_id.id,
                        'company_id': obj.company_id.id,
                        'material_count': pro.product_count * obj.planned_hours,
                        'material_total_price': pro.material_sum_price * obj.planned_hours
                        } )
            else:
                raise osv.except_osv(_('Warning!'), _('Ажлын орц бүртгээгүй байна !!!    Ажлын нэр: %s') % (obj.project_id.name + " , " + (obj.task_id.name)))
      
        return True      
    
    
    def write(self, cr, uid, ids, vals, context=None):
        
        if isinstance(ids, (int, long)):
            ids = [ids]
        obj = self.browse(cr, uid,ids)
        if 'days_finish_dif' in vals:
            if vals['days_finish_dif'] < 0:
                 raise osv.except_osv(_('Warning!'), _('Төлөвлөсөн хоног Сөрөг утгатай байж болохгүй'))
      
        #=======================================================================
        # if 'days_finish_dif' in vals:
        #     print 'ovvvvvvvvdddd', vals['days_finish_dif']
        #     if 'child_ids' in vals:
        #         print 'wra1111111', vals['child_ids']
        #         for line1 in vals['child_ids']:
        #             sum = vals['days_finish_dif'] + line1.days_finish_dif
        #             line1.write({'days_finish_dif':sum})
        #     if obj.child_ids:
        #         print 'wra222222', obj.child_ids
        #         for line2 in obj.child_ids:
        #             sum2 = obj.days_finish_dif + line2.days_finish_dif
        #             line2.write({'days_finish_dif':sum2})
        #=======================================================================
                
        #=======================================================================
        # e_hours = 0
        # pl_days = 0
        # e_percent = 0
        # e_days = 0
        # if 'planned_days' in vals:
        #     pl_days = vals['planned_days']
        # else:
        #     pl_days = obj.planned_days
        # 
        # if 'work_ids' in vals and 'remaining_hours' not in vals:
        #     for line in obj.work_ids:
        #         e_hours += line['hours']
        #     e_percent = e_hours / (obj.remaining_hours + e_hours)
        #     e_days = pl_days * e_percent
        #     vals['effective_days'] = e_days
        #     print 'gaaaaaadadadadada', e_hours, e_percent, e_days, vals['effective_days']
        # elif 'work_ids' in vals and 'remaining_hours' in vals:
        #     for line in obj.work_ids:
        #         e_hours += line.hours
        #     e_percent = e_hours / (vals['remaining_hours'] + e_hours)
        #     e_days = pl_days * e_percent
        #     vals['effective_days'] = e_days
        #     vals['remaining_hours'] = vals['remaining_hours']
        # elif 'work_ids' not in vals and 'remaining_hours' in vals:
        #     e_hours = obj.effective_hours
        #     e_percent = e_hours / (vals['remaining_hours'] + e_hours)
        #     e_days = pl_days * e_percent
        #     vals['effective_days'] = e_days
        #     vals['remaining_hours'] = vals['remaining_hours']
        # elif 'work_ids' not in vals and 'remaining_hours' not in vals:
        #     e_hours = obj.effective_hours
        #     e_percent = e_hours / obj.total_hours
        #     e_days = pl_days * e_percent
        #     vals['effective_days'] = e_days
        #=======================================================================
        
        #=======================================================================
        # if 'remaining_hours' in vals:
        #     self.write(cr, uid, ids, {'effective_days': vals['effective_days'],
        #                               'remaining_hours':vals['remaining_hours']})
        # else:
        #     self.write(cr, uid, ids, {'effective_days': vals['effective_days']})
        #=======================================================================
        # stage change: update date_last_stage_update
        if 'stage_id' in vals:
            vals['date_last_stage_update'] = fields.datetime.now()
        # user_id change: update date_start
        if vals.get('user_id') and 'date_start' not in vals:
            vals['date_start'] = fields.datetime.now()

        #contract salary
        change = {}
        if obj.task_id:
            material_cost = 0
            total_approved_cost = 0
            total_executed_cost = 0
            task_id = self.pool.get('project.project.task').browse(cr, uid, obj.task_id.id)[0]
            
            if  obj.task_id.bom_ids != []:
                for bom_id in obj.task_id.bom_ids:
                     bom_id = self.pool.get('task.bom').browse(cr, uid, bom_id.id)
                     if  bom_id.line1_id != []:
                        for bom_line in bom_id.line1_id:
                            material_cost +=  bom_line.material_sum_price
            #===================================================================
            # if obj.work_ids !=[]:
            #     for li in obj.work_ids:
            #===================================================================
            if 'planned_hours' in vals:
                 approved_salary = task_id.payroll_job * vals['planned_hours']
                 approved_material_total_cost = material_cost * vals['planned_hours']
                 total_approved_cost = approved_salary + approved_material_total_cost
            else:
                 approved_salary = task_id.payroll_job * obj.planned_hours
                 approved_material_total_cost = material_cost * obj.planned_hours
                 total_approved_cost = approved_salary + approved_material_total_cost

            change.update({ 'approved_payroll_job': approved_salary
                            ,'approved_material_cost': approved_material_total_cost
                           ,'sum_approved_cost': total_approved_cost})
            super(task, self).write(cr, uid, ids, change, context=context)

        # Overridden to reset the kanban_state to normal whenever
        # the stage (stage_id) of the task changes.
        if vals and not 'kanban_state' in vals and 'stage_id' in vals:
            new_stage = vals.get('stage_id')
            vals_reset_kstate = dict(vals, kanban_state='normal')
            for t in self.browse(cr, uid, ids, context=context):
                 write_vals = vals_reset_kstate if t.stage_id.id != new_stage else vals
                 super(task, self).write(cr, uid, [t.id], write_vals, context=context)
            result = True
        else:
             result = super(task, self).write(cr, uid, ids, vals, context=context)

             if any(item in vals for item in ['stage_id', 'remaining_hours', 'user_id', 'kanban_state']):
                self._store_history(cr, uid, ids, context=context)
        
        return result, vals
    
    
class material_line(osv.Model):
    _name = 'material.line'
    _columns = {
        'per_product_id':fields.many2one('product.product', 'Product name'),
        'product_id':fields.many2one('product.product', 'Product name'),
        'pro_uom_id':fields.many2one('product.uom', 'Unit'),
        'product_bom':fields.float('Product bom'),
        'project_id':fields.many2one('project.project', 'Project', required=True),        
        'project_phase_id':fields.many2one('project.task.phase', 'Task stage', required=True),
        'task_id': fields.many2one('project.project.task','Task name'),
        'res_partner_id': fields.many2one('res.partner','Executive'),
        'sub_phase_id':fields.many2one('sub.phase', 'Sub phase'),  
        'per_date':fields.date('Date'), 
        'company_id':fields.many2one('res.company','Company'),
        'user_id':fields.many2one('res.users', 'User'),
        'pr_material_id':fields.many2one('performance.material','Material list'),  
    }
    _defaults = { 
            'per_date': lambda obj, cr, uid, context: time.strftime('%Y-%m-%d'),
            'user_id': lambda obj, cr, uid, context: uid, 
            'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'material.line', context=c), 
         }
   
    def onchange_product_uom(self, cr, uid, ids, pro_id,context=None):
        res = {}
        temp_obj = self.pool.get('product.template')
        pro_obj = self.pool.get('product.product')
        if pro_id:
            pro = pro_obj.browse(cr, uid, pro_id)[0]
            #select * from product_product where id = prod_id
            temp = temp_obj.browse(cr, uid, pro.product_tmpl_id.id)[0]
            #select * from product_template where id = pro.tmpl_id.id
            res['pro_uom_id']=temp.uom_id.id
            res['material_price']=temp.lst_price
            return {'value':res}
        
    def create(self, cr, uid, vals, context=None):
       
        per_mat_obj = self.pool.get('performance.material')
        per_obj = self.pool.get('per.line')
        task_per_obj = self.pool.get('task.performance')
        if 'pr_material_id' in vals:
            per_mat_id = per_mat_obj.search(cr, uid,[('id','=',vals['pr_material_id'])])
            per_mat = per_mat_obj.browse(cr, uid, per_mat_id)
            task_per_id = per_obj.search(cr, uid,[('id','=',per_mat.per_line_id.id)])
            task_per = per_obj.browse(cr, uid, task_per_id)
            task_id = task_per_obj.search(cr,uid, [('id','=',task_per.task_performance_id.id)])
            task = task_per_obj.browse(cr, uid, task_id)
            if task_per:
               for li in per_mat.line_id:
                   vals.update({
                                 'product_id':vals['product_id'],
                                 'pro_uom_id':vals['pro_uom_id'],
                                 'product_bom':vals['product_bom'],
                                 'pr_material_id':per_mat.id,
                                 'per_product_id':per_mat.per_product_id.id,
                                 'project_id':task.project_id.id,
                                 'project_phase_id':task.project_phase_id.id,
                                 'task_id':task.task_id.id,
                                 'res_partner_id':task.res_partner_id.id,
                                 'sub_phase_id':task.sub_phase_id.id,
                        }, context=context)
               #vals.update({'qty_balance':vals['qty_balance']})
        return super(material_line, self).create(cr, uid, vals, context=context)
    
class per_line(osv.Model):
    _name = 'per.line'
    _columns = {
        'product_id':fields.many2one('product.product', 'Product name'),
        'pro_uom_id':fields.many2one('product.uom', 'Unit'),
        'material_count':fields.float('Material count'),
        'material_real_count':fields.float('Material real count'),
        'company_id':fields.many2one('res.company','Company'),
        'task_performance_id':fields.many2one('task.performance','Performance bom material'),
        'line_id': fields.one2many('performance.material','per_line_id','line'),
        
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'per.line', context=c),    
                 }
    def onchange_product_uom(self, cr, uid, ids, pro_id,context=None):
        res = {}
        
        temp_obj = self.pool.get('product.template')
        pro_obj = self.pool.get('product.product')
        if pro_id:
            pro = pro_obj.browse(cr, uid, pro_id)[0]
            #select * from product_product where id = prod_id
            temp = temp_obj.browse(cr, uid, pro.product_tmpl_id.id)[0]
            #select * from product_template where id = pro.tmpl_id.id
            res['pro_uom_id']=temp.uom_id.id
            res['material_price']=temp.lst_price
            return {'value':res}
    
    def action_view_per_material(self, cr, uid, ids, context=None):
        mod_obj = self.pool.get('ir.model.data')
        act_obj = self.pool.get('ir.actions.act_window')
        
        result = mod_obj.get_object_reference(cr, uid, 'ierp_project', 'action_performance_material_tree_view')
        id = result and result[1] or False
        result = act_obj.read(cr, uid, [id], context=context)[0]
        
        #compute the number of invoices to display
        inv_ids = []
        for so in self.browse(cr, uid, ids, context=context):
            inv_ids += [invoice.id for invoice in so.line_id]
        
        #choose the view_mode accordingly
        if len(inv_ids)>1:
            result['domain'] = "[('id','in',["+','.join(map(str, inv_ids))+"])]"
        else:
            res = mod_obj.get_object_reference(cr, uid, 'ierp_project', 'performance_material_form_view')
            result['views'] = [(res and res[1] or False, 'form')]
            result['res_id'] = inv_ids and inv_ids[0] or False
        
        return result 
        
class task_performance(osv.osv):
    _name = 'task.performance'
    _columns = {
        'project_id':fields.many2one('project.project', 'Project', required=True),        
        'project_phase_id':fields.many2one('project.task.phase', 'Task phase', required=True),
        #'project_phase_id':fields.many2one('project.task.type', 'Task stage', required=True, domain="[('project_ids', '=', project_id)]"),
        'task_id': fields.many2one('project.project.task','Task name', domain="[('project_task_phase_id', '=', project_phase_id)]"),
        'unit': fields.many2one('product.uom', 'Unit'),
        'res_partner_id': fields.many2one('res.partner','Executive'),
        'sub_phase_id':fields.many2one('sub.phase', 'Sub phase'),  
        'performance_count':fields.float('Performance count'), 
        'per_date':fields.datetime('Date'), 
        'user_id':fields.many2one('res.users', 'User'), 
        'note':fields.text('Note'), 
        'status':fields.boolean('Status', help="Сонгогдсон байвал <<Үе шатны гүйцэтгэл тайлан>>-д энэхүү батлагдсан гүйцэтгэлийг татсан байна гэж үзнэ!"),
        'is_passed_performance_report':fields.boolean('Is passed performance report', help="Сонгогдсон байвал <<Гүйцэтгэл тайлан>>-д энэхүү батлагдсан гүйцэтгэлийг татсан байна гэж үзнэ!"),
        'per_product_id':fields.many2one('product.product', 'Product'),
        'state':fields.selection([('draft','Draft'),
                                  ('confirmed','Confirmed'),
                                  ('cancel','Cancel')],'State'),
        'company_id':fields.many2one('res.company','Company'),
        'line_id':fields.one2many('per.line','task_performance_id', 'Performance line'),
        'door_product_id':fields.many2one('product.product', 'Door product'),
        'entrance':fields.char('Entrance', required=True),
        'floor':fields.char('Floor', required=True),
        }   
    _defaults = { 
            'status' : False,
            'is_passed_performance_report' : False,
            'state' : lambda *a: 'draft',
            'per_date': lambda obj, cr, uid, context: time.strftime('%Y-%m-%d'),
            'user_id': lambda obj, cr, uid, context: uid, 
            'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'task.performance', context=c), 
         }
    
    def onchange_door_product_id(self, cr, uid, ids, door_product_id,context=None):
            res = {}
            toot_obj = self.pool.get('product.product')
            toot = toot_obj.browse(cr, uid, door_product_id)
            if door_product_id:
                res['entrance']=toot.entrance
                res['floor']=toot.floor
            else:
                res['entrance']=""
                res['floor']=""
            return {'value':res}
        
    def onchange_task_uom_code(self, cr, uid, ids, task_id,context=None):
            res = {}
            
            obj = self.browse(cr, uid,ids)
            temp_obj = self.pool.get('project.project.task')
            if task_id:
                #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
                temp = temp_obj.browse(cr, uid, temp_obj.search(cr, uid, [('id','=',task_id)]))[0]
                
                res['unit']=temp.unit.id
              
            return {'value':res}
        
        
    def action_compute_perf(self, cr, uid, ids, context=None):
        performance_obj = self.pool.get('performance.material')
        obj = self.browse(cr, uid,ids)
        temp_obj = self.pool.get('project.project.task')
        material_obj = self.pool.get('task.bom')
        per_obj = self.pool.get('per.line')
        mat_obj = self.pool.get('material.line')
        pro_task_work = self.pool.get('project.task.work')
        pro_task = self.pool.get('project.task')
        pro_task_work_id = pro_task_work.search(cr, uid,[('task_per_id','=',obj.id)])
        
        if obj.task_id:
            mat_id = material_obj.search(cr, uid, [('pro_task_id','=',obj.task_id.id)])
            task = material_obj.browse(cr, uid, mat_id)
            for pro in task.line1_id:

                per_mat_id = per_obj.search(cr, uid,[('task_performance_id','=',obj.id),('product_id','=',pro.product_id.id)])
                products = performance_obj.search(cr, uid, [('per_line_id', 'in', per_mat_id)])
                mat_line_id = mat_obj.search(cr, uid, [('pr_material_id', 'in', products)])
                
                if per_mat_id!=[]:
                   for per in  per_obj.browse(cr, uid, per_mat_id):
                       per_obj.write(cr, uid, per.id,{
                                                      'pro_uom_id':per.product_id.uom_id.id,
                                                      'material_count':pro.product_count * obj.performance_count,
                                                      }, context=context)
                else:
                    pr_id = per_obj.create(cr, uid, {
                                                    'task_performance_id':obj.id,
                                                    'product_id':pro.product_id.id,
                                                    'material_count': pro.product_count * obj.performance_count,
                                                    #'pro_uom_id': pro.product_id.id,
                                                    })
                    per_id= performance_obj.create(cr, uid, {
                                                         'per_line_id':pr_id,
                                                         'per_product_id':pro.product_id.id,
                                                         'performance_count': pro.product_count * obj.performance_count,
                                                         #'count':pro.product_count * obj.performance_count,
                                                         'project_id':obj.project_id.id,
                                                         'project_phase_id':obj.project_phase_id.id,
                                                         'task_id':obj.task_id.id,
                                                         'sub_phase_id':obj.sub_phase_id.id,
                                                         'res_partner_id':obj.res_partner_id.id,
                                                     })
                    mat_obj.create(cr, uid, {
                                                             'pr_material_id':per_id,
                                                             'per_product_id':pro.product_id.id,
                                                             'product_id':pro.product_id.id,
                                                             'pro_uom_id':pro.product_id.uom_id.id,
                                                             'product_bom':0.0,
                                                             'project_id':obj.project_id.id,
                                                             'project_phase_id':obj.project_phase_id.id,
                                                             'task_id':obj.task_id.id,
                                                             'res_partner_id':obj.res_partner_id.id,
                                                             'sub_phase_id':obj.sub_phase_id.id,
                                                     })
        return True
    # noorogloh vildel - to draft
    def action_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True
    # tsutslah vildel - to cancel
    def action_cancel_draft(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid, ids)[0]
        #    batlahdaa project_task ru shidsen ogogdlvvdiig heregsehgvi bolgoh
        if obj.status == True:
            raise osv.except_osv(_('Warning!'), _(u'Энэ гүйцэтгэлийг "Үе шатны гүйцэтгэл тайлан"-д татсан байна !!! \n Та эхлээд холбоотой Үе шатны тайлангаа цуцална уу!'))
        else:
            #    batlahdaa project_task ru shidsen ogogdlvvdiig heregsehgvi bolgoh
            pro_task_work = self.pool.get('project.task.work')
            pro_task = self.pool.get('project.task')
            pro_task_work_id = pro_task_work.search(cr, uid,[('task_per_id','=',obj.id)])
            if obj.door_product_id:
                project_task_id = pro_task.search(cr, uid,[
                        ('door_id','=',obj.door_product_id.id),
                        ('entrance','=',obj.entrance),
                        ('floor','=',obj.floor),
                        ('project_id','=',obj.project_id.id),
                        ('phase_id','=',obj.project_phase_id.id),
                        ('task_id','=',obj.task_id.id)])
            else:
                project_task_id = pro_task.search(cr, uid,[
                        ('entrance','=',obj.entrance),
                        ('floor','=',obj.floor),
                        ('project_id','=',obj.project_id.id),
                        ('phase_id','=',obj.project_phase_id.id),
                        ('task_id','=',obj.task_id.id)])
            if project_task_id!=[]:
               project_tsk_id = pro_task.browse(cr, uid, project_task_id)[0]
            #    batlahdaa project_task ru shidsen ogogdlvvdiig heregsehgvi bolgoh
               pro_task_work.unlink(cr, uid, pro_task_work_id)
            else:
                raise osv.except_osv(_('Warning!'), _(u'Ийм ажил бүртгэгдээгүй байна !!! \n Та эхлээд ажлаа бүртгэнэ үү! Ажлын нэр : %s')%obj.task_id.name)
            #    batlahdaa performance_material, per_line, material_line 3n class ru shidsen ogogdlvvdiig heregsehgvi bolgoh
            performance_obj = self.pool.get('performance.material')
            per_obj = self.pool.get('per.line')
            material_obj = self.pool.get('task.bom')
            mat_obj = self.pool.get('material.line')
            if obj.task_id:
                    mat_id = material_obj.search(cr, uid, [('pro_task_id','=',obj.task_id.id)])
                    task = material_obj.browse(cr, uid, mat_id)[0]
                    for pro in task.line1_id:
                        per_mat_id = per_obj.search(cr, uid,[('task_performance_id','=',obj.id),('product_id','=',pro.product_id.id)])
                        products = performance_obj.search(cr, uid, [('per_line_id', 'in', per_mat_id)])
                        mat_line_id = mat_obj.search(cr, uid, [('pr_material_id', 'in', products)])
                        for per in  per_obj.browse(cr, uid, per_mat_id):
            #    batlahdaa per_line ru shidsen ogogdlvvdiig heregsehgvi bolgoh
                            per_obj.unlink(cr, uid, per.id)
            #    batlahdaa performance_material ru shidsen ogogdlvvdiig heregsehgvi bolgoh
                            performance_obj.unlink(cr, uid, products)
            #    batlahdaa material_line ru shidsen ogogdlvvdiig heregsehgvi bolgoh
                            mat_obj.unlink(cr, uid, mat_line_id)
                    for new_pro in obj.line_id:
                        per_mat_id1 = per_obj.search(cr, uid,[('task_performance_id','=',obj.id),('product_id','=',new_pro.product_id.id)])
                        products1 = performance_obj.search(cr, uid, [('per_line_id', 'in', per_mat_id1)])
                        mat_line_id1 = mat_obj.search(cr, uid, [('pr_material_id', 'in', products1)])
                        for per1 in  per_obj.browse(cr, uid, per_mat_id1):
            #    batlahdaa per_line ru garaar nemsen ogogdlvvdiig heregsehgvi bolgoh
                            per_obj.unlink(cr, uid, per1.id)
            #    batlahdaa performance_material ru garaar nemsen ogogdloos shidseniig heregsehgvi bolgoh
                            performance_obj.unlink(cr, uid, products1)
            #    batlahdaa material_line ru garaar nemsen ogogdloos shidseniig heregsehgvi bolgoh
                            mat_obj.unlink(cr, uid, mat_line_id1)
        
        self.write(cr, uid, ids, {'state': 'cancel'}) 
        return True
    # batlah vildel - to confirmed
    def action_draft_confirm(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'confirmed'})
        performance_obj = self.pool.get('performance.material')
        obj = self.browse(cr, uid,ids)
        temp_obj = self.pool.get('project.project.task')
        material_obj = self.pool.get('task.bom')
        per_obj = self.pool.get('per.line')
        mat_obj = self.pool.get('material.line')
        pro_task_work = self.pool.get('project.task.work')
        pro_task = self.pool.get('project.task')
        pro_task_work_id = pro_task_work.search(cr, uid,[('task_per_id','=',obj.id)])
        #if obj.line_id:
        if obj.door_product_id:
            project_task_id = pro_task.search(cr, uid,[
                    ('door_id','=',obj.door_product_id.id),
                    ('entrance','=',obj.entrance),
                    ('floor','=',obj.floor),
                    ('project_id','=',obj.project_id.id),
                    ('phase_id','=',obj.project_phase_id.id),
                    ('task_id','=',obj.task_id.id)])
        else:
            project_task_id = pro_task.search(cr, uid,[
                    ('entrance','=',obj.entrance),
                    ('floor','=',obj.floor),
                    ('project_id','=',obj.project_id.id),
                    ('phase_id','=',obj.project_phase_id.id),
                    ('task_id','=',obj.task_id.id)])
        if project_task_id:
           project_tsk_id = pro_task.browse(cr, uid, project_task_id)[0]
           if pro_task_work_id!=[]:
              pro_task_work.write(cr, uid, pro_task_work_id[0], {
                                                             'name':obj.note,
                                                             'hours': obj.performance_count,
                                                             'res_partner_id':obj.res_partner_id.id,
                                                             'user_id': obj.user_id.id,
                                                             'date':obj.per_date,
                                                     })
                
           else:
                 pro_task_work.create(cr, uid, {  
                                                             'task_id':project_tsk_id.id,
                                                             'task_per_id':obj.id,
                                                             'name':obj.note,
                                                             'hours': obj.performance_count,
                                                             'res_partner_id':obj.res_partner_id.id,
                                                             'user_id': obj.user_id.id,
                                                             'date':obj.per_date,
                                                     })
        else:
            raise osv.except_osv(_('Warning!'), _(u'Энэ Төсөл, Төслийн үе шатанд харгалзах ажил бүртгэгдээгүй байна !!! \n Та эхлээд ажлаа бүртгэнэ үү! Ажлын нэр : %s')%obj.task_id.name)

        if obj.task_id:
            
            
            mat_id = material_obj.search(cr, uid, [('pro_task_id','=',obj.task_id.id)])
            task = material_obj.browse(cr, uid, mat_id)
            for pro in task.line1_id:
                per_mat_id = per_obj.search(cr, uid,[('task_performance_id','=',obj.id),('product_id','=',pro.product_id.id)])
                products = performance_obj.search(cr, uid, [('per_line_id', 'in', per_mat_id)])
                mat_line_id = mat_obj.search(cr, uid, [('pr_material_id', 'in', products)])
                
                for per in  per_obj.browse(cr, uid, per_mat_id):
                    
                    per_obj.write(cr, uid, per.id,{
                                                   'pro_uom_id':per.product_id.uom_id.id,
                                                   'material_count':pro.product_count * obj.performance_count,
                                                   })
                    
                    performance_obj.write(cr, uid, products,{
                                                     #'per_product_id':pro.product_id.id,
                                                     'per_product_id':pro.product_id.id,
                                                     'performance_count': per.material_count,
                                                     'count':per.material_real_count,
                                                     'project_id':obj.project_id.id,
                                                     'project_phase_id':obj.project_phase_id.id,
                                                     'task_id':obj.task_id.id,
                                                     'sub_phase_id':obj.sub_phase_id.id,
                                                     'res_partner_id':obj.res_partner_id.id,
                                            
                                                })
                    mat_obj.write(cr, uid, mat_line_id,{
                                  'product_bom':per.material_real_count,
                                  })
            if obj.line_id:
                for new_pro in obj.line_id:
                    per_mat_id1 = per_obj.search(cr, uid,[('task_performance_id','=',obj.id),('product_id','=',new_pro.product_id.id)])
                    products1 = performance_obj.search(cr, uid, [('per_line_id', 'in', per_mat_id1)])
                    mat_line_id1 = mat_obj.search(cr, uid, [('pr_material_id', 'in', products1)])
                    
                    if products1 == []:
                        
                        per_id1= performance_obj.create(cr, uid, {
                                                         'per_line_id':new_pro.id,
                                                         'per_product_id':new_pro.product_id.id,
                                                         'performance_count': new_pro.material_count,
                                                         'count':new_pro.material_real_count,
                                                         'project_id':obj.project_id.id,
                                                         'project_phase_id':obj.project_phase_id.id,
                                                         'task_id':obj.task_id.id,
                                                         'sub_phase_id':obj.sub_phase_id.id,
                                                         'res_partner_id':obj.res_partner_id.id,
                                                     })  
                        mat_obj.create(cr, uid, {
                                         'pr_material_id':per_id1,
                                         'per_product_id':new_pro.product_id.id,
                                         'product_id':new_pro.product_id.id,
                                         'pro_uom_id':new_pro.product_id.uom_id.id,
                                         'product_bom':new_pro.material_real_count,
                                         'project_id':obj.project_id.id,
                                         'project_phase_id':obj.project_phase_id.id,
                                         'task_id':obj.task_id.id,
                                         'res_partner_id':obj.res_partner_id.id,
                                         'sub_phase_id':obj.sub_phase_id.id,
                                     })
        #=======================================================================
        # else:
        #     raise osv.except_osv(_('Анхааруулга!'),_("Та Бүрэлдэхүүнүүд хэсгийн өгөгдлийг тооцоолсны дараа батлах үйлдлийг хийх боломжтой! <<Өгөгдлийг тооцоолох>> товчийг дарна уу"))
        #             
        #=======================================================================
        return True
    
    
class performance_material(osv.osv):
    _name = 'performance.material'
    
    _columns = {
        'project_id':fields.many2one('project.project', 'Project'),
        'project_phase_id':fields.many2one('project.task.phase', 'Task phase'),
        #'project_phase_id':fields.many2one('project.task.type', 'Task stage'),
        'task_id': fields.many2one('project.project.task','Task name'),
        'res_partner_id': fields.many2one('res.partner','Executive'),
        'sub_phase_id':fields.many2one('sub.phase', 'Sub phase'),
        'performance_count':fields.float('Bom count'),
        'count':fields.float('Count'),
        #'count':fields.function(_write_count, method=True, store=True, type ="float", string='Count'),
        'per_date':fields.date('Date'),
        'per_product_id':fields.many2one('product.product', 'Product'),
        'company_id':fields.many2one('res.company','Company'),
        'line_id':fields.one2many('material.line','pr_material_id', 'Material line'),
        'per_line_id':fields.many2one('per.line','Performance line'),
        }   
    _defaults = { 
            'per_date': lambda obj, cr, uid, context: time.strftime('%Y-%m-%d'),
            'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'performance.material', context=c),  
         } 
    
    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid,ids)
        mat_obj = self.pool.get('material.line')
        per_obj = self.pool.get('per.line')
        task_per_obj = self.pool.get('task.performance')
        task_per_id = per_obj.search(cr, uid,[('id','=',obj.per_line_id.id)])
        
        task_per = per_obj.browse(cr, uid, task_per_id)
        
        task_id = task_per_obj.search(cr,uid, [('id','=',task_per.task_performance_id.id)])
        task = task_per_obj.browse(cr, uid, task_id)
        
        if task_per:
           for li in obj.line_id:
               mat_obj.write(cr, uid, li.id,{
                                             'pr_material_id':obj.id,
                                             'project_id':task.project_id.id,
                                             'project_phase_id':task.project_phase_id.id,
                                             'task_id':task.task_id.id,
                                             'res_partner_id':task.res_partner_id.id,
                                             'sub_phase_id':task.sub_phase_id.id,
                    }, context=context)
               #vals.update({'qty_balance':vals['qty_balance']})
        return super(performance_material, self).write(cr, uid, ids, vals, context=context)

class task_stage(osv.osv):
    _name = 'task.stage'
    _columns = {
        'project_id':fields.many2one('project.project', 'Project', required=True),        
        'project_phase_id':fields.many2one('project.task.phase', 'Task stage', required=True),
        'carriage': fields.float('Carriage'),
        'mechanic_cost': fields.float('Mechanic cost'),
        'stage_id':fields.many2one('project.project', 'Stage'),  
        'company_id':fields.many2one('res.company','Company'),
        }  
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'task.stage', context=c),    
                 }      
       
class project_work(osv.osv):
    _inherit = "project.task.work"  
    _columns = {
    'res_partner_id': fields.many2one('res.partner', 'Executive'),
    'task_per_id':fields.many2one('task.performance','Task performance'),
    'date': fields.date('Date', select="1"),
    'date_end':fields.date('Дууссан огноо')
    
    }

    _defaults = {
        'date': date.today()
    }
    
class phase_costs(osv.osv):
    _name = 'phase.costs'
    _columns = {
         #'phase_id':fields.many2one('project.task.type','Phase name'),
         'task_phase_id':fields.many2one('project.task.phase','Phase name'),
         'carriage':fields.float('Carriage'),
         'machine_cost':fields.float('Machine cost'),
         'partner_id':fields.many2one('res.partner','Contractor'),
         'comment':fields.text('Comment'),
         'cont_date':fields.date('Contract date'),
         'company_id':fields.many2one('res.company','Company'),
         'carriage_machine_id':fields.many2one('carriage.machine','Carriage machine')       
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'phase.costs', context=c),    
                 } 
    
class carriage_machine(osv.osv):
    _name = 'carriage.machine'
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    
    def _total_carriage(self, cr, uid, ids, field_name, arg, context = None):
        sums = 0
        obj = self.browse(cr, uid, ids)[0]
        for line in obj.line_id:
            if line.id:
                sums = sums + line.carriage
        return {ids[0]:sums}
    
    def _total_machine_cost(self, cr, uid, ids, field_name, arg, context = None):
        sums = 0
        obj = self.browse(cr, uid, ids)[0]
        for line in obj.line_id:
            if line.id:
                sums = sums + line.machine_cost
        return {ids[0]:sums}
    
    _columns = {
        'name':fields.char('Carriage name', required=True, select=True, copy=False,),
        'project_id':fields.many2one('project.project','Project name'),
        'company_id':fields.many2one('res.company','Company'),
        'line_id':fields.one2many('phase.costs','carriage_machine_id', 'Phase costs'),
        'total_carriage': fields.function(_total_carriage, type='integer',string='Total carriage', store=True, help="Зөвхөн Тээврийн зардлын нийлбэр дүн"),
        'total_machine_cost': fields.function(_total_machine_cost, type='integer',string='Total machine cost', store=True, help="Зөвхөн Механизмын зардлын нийлбэр дүн"),
        
        }
    _defaults = {  
        'name': lambda obj, cr, uid, context: '/',
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'carriage.machine', context=c),    
                 } 
    def create(self, cr, uid, vals, context=None):
        if vals.get('name','/')=='/':
            vals['name'] = self.pool.get('ir.sequence').get(cr, uid, 'carriage.machine') or '/'
        context = dict(context or {}, mail_create_nolog=True)
        order =  super(carriage_machine, self).create(cr, uid, vals, context=context)
        self.message_post(cr, uid, [order], body=_("RFQ created"), context=context)
        return order
    
class performance_report(osv.osv):
    _name = 'performance.report'
    _columns = {
         'name':fields.char('Name', required=True, select=True, copy=False,), 
         'project_id':fields.many2one('project.project','Project name'),
         'res_partner_id': fields.many2one('res.partner','Executive'),
         'per_report_date':fields.date('Date'),
         'state':fields.selection([('draft','Draft'),
                                  ('confirmed','Confirmed'),
                                  ('cancel','Cancel')],'State'),
         'carriage':fields.float('Carriage'),
         'machine_cost':fields.float('Machine cost'),
         'payroll_cost':fields.float('Payroll cost',readonly=True),
         'material_cost':fields.float('Material cost',readonly=True),
         'material_cost_bom':fields.float('Material cost(Bom)',readonly=True),
         'total_cost':fields.float('Total cost'),
         'executive_cost':fields.float('Executive cost'),
         'our_cost':fields.float('Our cost'),
         'difference_cost':fields.float('Difference cost'),
         'company_id':fields.many2one('res.company','Company'),
         'line_id':fields.one2many('performance.report.line','per_report_id', 'Performance report line'),
         'per_line_id':fields.one2many('performance.report.per.count','per_rep_id', 'Performance report per count'),
         'material_line_id':fields.one2many('performance.report.materials','performance_report_id', 'Performance report material'),
         
    }
    _defaults = {  
        'per_report_date': lambda self, cr, uid, context: time.strftime('%Y-%m-%d'),
        'state' : lambda *a: 'draft',
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'performance.report', context=c),    
                 } 
    def onchange_executive_cost(self, cr, uid, ids, executive_cost, our_cost, context=None):
        obj = self.browse(cr, uid,ids)
       
        if executive_cost ==0:
           return {
                'value': {
                'total_cost': obj.carriage + obj.machine_cost + obj.payroll_cost + obj.material_cost,}
                   }
        else:
            return {
            'value': {
                'total_cost': obj.carriage + obj.machine_cost + obj.payroll_cost + obj.material_cost - executive_cost,
                'our_cost': obj.difference_cost - executive_cost}
                    }
    def onchange_our_cost(self, cr, uid, ids, our_cost, executive_cost, context=None):
        obj = self.browse(cr, uid,ids)
       
        if our_cost ==0:
           return {
                'value': {
                'total_cost': obj.carriage + obj.machine_cost + obj.payroll_cost + obj.material_cost,}
                   }
        else:
            return {
            'value': {
                'total_cost': obj.carriage + obj.machine_cost + obj.payroll_cost + obj.material_cost - (obj.difference_cost - our_cost),
                'executive_cost': obj.difference_cost - our_cost} 
                    }
    
    def onchange_executive_count(self, cr, uid, ids, executive_count, diff_count, context=None):
        res = {}
        obj = self.browse(cr, uid,ids)
        diff = diff_count - executive_count
        res['ncd_count']=diff
        return {'value':res}
    def onchange_ncd_count(self, cr, uid, ids, ncd_count, diff_count, context=None):
        res = {}
        obj = self.browse(cr, uid,ids)
        diff = diff_count - ncd_count
        res['executive_count']=diff
        return {'value':res}
    def action_to_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True
    def action_to_cancel(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid,ids)
        #Ajluud moriig unlink hiih
        per_rep_obj = self.pool.get('performance.report.line')
        for line1 in obj.line_id:
            if line1:
                per_rep_obj.unlink(cr, uid, line1.id)
        #Baraanuud orts bolon gvitsetgeleer moriig unlink hiih
        per_rep_mat_obj = self.pool.get('performance.report.materials')
        for line2 in obj.material_line_id:
            if line2:
                per_rep_mat_obj.unlink(cr, uid, line2.id)
        #Gvitsetgeleerh baraanuud moriig unlink hiih
        per_rep_per_count_obj = self.pool.get('performance.report.per.count')
        for line3 in obj.per_line_id:
            if line3:
                per_rep_per_count_obj.unlink(cr, uid, line3.id)
        self.write(cr, uid, ids, {'material_cost': 0.0,
                                  'material_cost_bom': 0.0,
                                  'difference_cost': 0.0,
                                  'carriage': 0.0,
                                  'machine_cost': 0.0,
                                  'executive_cost': 0.0,
                                  'payroll_cost': 0.0,
                                  'total_cost': 0.0,
                                  'our_cost': 0.0,
                                  'state': 'cancel'
                                  })
        return True
    def action_to_confirm(self, cr, uid, ids, *args):
        #self.write(cr, uid, ids, {'state': 'confirmed'})
        obj = self.browse(cr, uid,ids)
        if obj.line_id and obj.material_line_id and obj.per_line_id:
            self.write(cr, uid, ids, {'state': 'confirmed'})
            cr.execute(""" UPDATE task_performance as task
                    SET  is_passed_performance_report=TRUE where task.project_id = %s and 
                    task.res_partner_id = %s and 
                    task.project_phase_id = %s """%(obj.project_id.id,obj.res_partner_id.id,obj.task_phase_id.id))
        
        else:
            raise osv.except_osv(_('Анхааруулга!'),_("Та гүйцэтгэлийн мөрүүдийг татсаны дараа батлах үйлдлийг хийх боломжтой! \n <<Гүйцэтгэл татах>> товчийг дарна уу"))
        
        return True

    def action_pull_report(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid,ids)
        phase_per_report_obj = self.pool.get('phase.per.report')
        per_report_line = self.pool.get('performance.report.line')
        material_obj = self.pool.get('task.bom')
        per_rep_per_obj = self.pool.get('performance.report.per.count')
        material_line_obj = self.pool.get('material.line')
        report_materials = self.pool.get('performance.report.materials')
        product_obj = self.pool.get('product.product')
        
        #Ajluud moriig unlink hiih
        per_rep_obj11 = self.pool.get('performance.report.line')
        for line1 in obj.line_id:
            if line1:
                per_rep_obj11.unlink(cr, uid, line1.id)
        #Baraanuud orts bolon gvitsetgeleer moriig unlink hiih
        per_rep_mat_obj11 = self.pool.get('performance.report.materials')
        for line2 in obj.material_line_id:
            if line2:
                per_rep_mat_obj11.unlink(cr, uid, line2.id)
        #Gvitsetgeleerh baraanuud moriig unlink hiih
        per_rep_per_count_obj11 = self.pool.get('performance.report.per.count')
        for line3 in obj.per_line_id:
            if line3:
                per_rep_per_count_obj11.unlink(cr, uid, line3.id)
        self.write(cr, uid, ids, {
                                  'material_cost': 0.0,
                                  'material_cost_bom': 0.0,
                                  'difference_cost': 0.0,
                                  'carriage': 0.0,
                                  'machine_cost': 0.0,
                                  'executive_cost': 0.0,
                                  'payroll_cost': 0.0,
                                  'total_cost': 0.0,
                                  'our_cost': 0.0,
                                  })
        
        total_machine_cost = 0.00
        total_carriage = 0.00
        #doorhi vildliig task_obj dotor shiljvvlsen
        
        #=======================================================================
        # phase_per_id = phase_per_report_obj.search(cr, uid, [('project_id','=',obj.project_id.id),('res_partner_id','=',obj.res_partner_id.id)])
        # if phase_per_id:
        #    for phase_per in phase_per_report_obj.browse(cr, uid, phase_per_id):
        #        total_machine_cost += phase_per.machine_cost
        #        total_carriage += phase_per.carriage
        #    self.write(cr, uid, ids,{
        #                     'machine_cost': total_machine_cost,
        #                     'carriage': total_carriage,
        #                     
        #                      })
        #=======================================================================
               
        #Гүйцэтгэл оруулахаас авч байгаа(batlagdsan, status true, tosol bolon gvitsetgegcheer shvvsen)
        cr.execute("""select task.task_id, sum(task.performance_count), task.unit, task.project_phase_id from 
                    task_performance as task where task.project_id = %s and 
                    task.res_partner_id = %s  and task.state='confirmed' and task.status=TRUE group by task.project_phase_id, task.task_id, task.unit"""%(obj.project_id.id,obj.res_partner_id.id))
        task_obj  = cr.dictfetchall()
        
        #Гүйцэтгэлийн материалаас(deerh gvitsetgel oruulah-s awsan nohtsold taarah gvitsetgeliin materialuudiig tatah)
        cr.execute("""select task.per_product_id,sum(task.performance_count), sum(task.count) as sum1, task.project_phase_id from 
                    performance_material as task 
                    left join per_line as b on b.id=task.per_line_id
                    left join task_performance as task_per on task_per.id=b.task_performance_id
                    where  task_per.status=TRUE and task_per.state='confirmed' and task.project_id = %s and
                    task.res_partner_id = %s  group by task.project_phase_id, task.per_product_id"""%(obj.project_id.id,obj.res_partner_id.id))
        material_line_obj  = cr.dictfetchall()
        
        #Материалын мөрөөс(deerh 2 query-ees awsan nohtsold taarah materialiin moroos tatah)
        cr.execute("""select task.per_product_id, task.product_id, task.pro_uom_id, sum(task.product_bom), task.project_phase_id from 
                    material_line as task
                    left join performance_material as per_mat on per_mat.id=task.pr_material_id
                    left join per_line as b on b.id=per_mat.per_line_id
                    left join task_performance as task_per on task_per.id=b.task_performance_id
                    where  task_per.status=TRUE and task_per.state='confirmed' and task.project_id = %s and 
                    task.res_partner_id = %s  group by task.per_product_id, task.product_id, task.pro_uom_id, task.project_phase_id"""%(obj.project_id.id,obj.res_partner_id.id))
        mat_line_obj  = cr.dictfetchall()
        
        #material_line obj-toi haritsah
        mat_cost = 0.00
        if mat_line_obj!=[]:
           for per in  mat_line_obj:
               product_id = product_obj.search(cr, uid, [('id','=',per['product_id'])])
               product = product_obj.browse(cr, uid, product_id)[0]
               mat_cost += product.lst_price * per['sum']
               pr_id = per_rep_per_obj.create(cr, uid, {
                                            'per_rep_id':obj.id,
                                            'project_task_phase_id':per['project_phase_id'],
                                            'product_id':per['product_id'],
                                            'per_product_id':per['per_product_id'],
                                            'pro_uom_id':per['pro_uom_id'],
                                            'product_count':per['sum'],
                                            'material_price':product.lst_price,
                                            #'company_id': obj.company_id.id,
                                            'material_total_price':product.lst_price * per['sum'],
                                            })
           
        else:
            mat_cost = 0.00
        #performance_material obj-toi haritsah 
        diff_cost = 0.00
        material_bom_cost = 0.00
        
        if material_line_obj!=[]:
           for per1 in  material_line_obj:
               #per_mat_id = per_mat.search(cr, uid, [('project_id','=',obj.project_id.id),('res_partner_id','=',obj.res_partner_id.id), ('project_phase_id','=',obj.project_task_type_id.id)])
               #per_material_id = per_mat.browse(cr, uid, per)[0] 
               product_id = product_obj.search(cr, uid, [('id','=',per1['per_product_id'])])
               product = product_obj.browse(cr, uid, product_id)[0]
               diff_cost += (per1['sum1'] - per1['sum'])*product.lst_price
               material_bom_cost += per1['sum'] * product.lst_price
              
               pr_id = report_materials.create(cr, uid, {
                                            'performance_report_id':obj.id,
                                            'project_task_phase_id':per1['project_phase_id'],
                                            'product_id':per1['per_product_id'],
                                            'pro_uom_id':product.uom_id.id,
                                            'bom_count':per1['sum'],
                                            'product_count':per1['sum1'],
                                            'diff_count':per1['sum1'] - per1['sum'],
                                            })
        else:
            diff_cost = 0.00
            material_bom_cost = 0.00
            
        #task_performance obj-toi haritsah
        sal_cost = 0.00 
        if task_obj!=[]: 
           project_task_id = per_report_line.search(cr, uid,[('per_report_id','=',obj.id)])
           if project_task_id==[]:
      
              for pro in task_obj:  
                  cr.execute("""select a.work_count, a.contract_price from 
                      contract_work_line as a
                      left join account_analytic_account as b on b.id=a.account_analytic_account_id
                     where b.contract_project_id = %s and b.partner_id = %s and a.task_id = %s"""%(obj.project_id.id,obj.res_partner_id.id,pro['task_id']))
                  contract_obj  = cr.dictfetchone()
                  
                  if contract_obj !=None:
                     sal_cost += pro['sum'] * contract_obj['contract_price']  
                  
                     per_report_line.create(cr, uid, {  
                                                            'per_report_id':obj.id,
                                                            #'task_performance_id':pro['id'],
                                                            'phase_id':pro['project_phase_id'],
                                                            'task_id':pro['task_id'],
                                                            'unit':pro['unit'],
                                                            'performance_count':pro['sum'],
                                                            'company_id': obj.company_id.id,
                                                            'contract_price':contract_obj['contract_price'],
                                                            'contract_count':contract_obj['work_count'],
                                                            'total_price':pro['sum'] * contract_obj['contract_price'],
                                                    })
                     
                     phase_per_id = phase_per_report_obj.search(cr, uid, [('project_id','=',obj.project_id.id),('res_partner_id','=',obj.res_partner_id.id)])
                     if phase_per_id:
                       for phase_per in phase_per_report_obj.browse(cr, uid, phase_per_id):
                           total_machine_cost += phase_per.machine_cost
                           total_carriage += phase_per.carriage
                       
                     else:
                        total_machine_cost = 0.0
                        total_carriage = 0.0
                  else:
                     raise osv.except_osv(_('Warning!'), _('Гүйцэтгэгч дээр энэ ажлын гэрээ бүртгэлгүй байна !!!    Ажлын нэр: %s') % pro['task_id'])
              
        else:
            sal_cost = 0.00
                    
        total_cost11 = 0.0    
        total_cost11 = mat_cost + sal_cost + total_machine_cost + total_carriage
        #=======================================================================
        # if executive_cost ==0:
        #     total_cost11 = mat_cost + sal_cost + total_machine_cost + total_carriage
        # elif executive_cost !=0:
        #     total_cost11 = mat_cost + sal_cost + total_machine_cost + total_carriage - executive_cost
        #     our_cost = diff_cost - executive_cost
        #=======================================================================
        
        self.write(cr, uid, ids,{
                                'material_cost': mat_cost,
                                'material_cost_bom': material_bom_cost,
                                'difference_cost': mat_cost - material_bom_cost,
                                'carriage': total_carriage,
                                'machine_cost': total_machine_cost,
                                'payroll_cost': sal_cost,
                                'total_cost': total_cost11,
                                
                                 })
                
        return True  
               
class phase_per_report(osv.osv):
    _name = 'phase.per.report'
    _columns = {
         'name':fields.char('Name', required=True, select=True,), 
         'project_id':fields.many2one('project.project','Project name'),
         'task_phase_id':fields.many2one('project.task.phase','Task phase'),
         #'project_task_type_id':fields.many2one('project.task.type', 'Task stage',
         #                   domain="[('project_ids', '=', project_id)]"),
         'res_partner_id': fields.many2one('res.partner','Executive'),
         'per_report_date':fields.date('Date'),
         'state':fields.selection([('draft','Draft'),
                                  ('confirmed','Confirmed'),
                                  ('cancel','Cancel')],'State'),
         'carriage':fields.float('Carriage'),
         'machine_cost':fields.float('Machine cost'),
         'payroll_cost':fields.float('Payroll cost',readonly=True),
         'material_cost':fields.float('Material cost',readonly=True),
         'total_cost':fields.float('Total cost'),
         'company_id':fields.many2one('res.company','Company'),
         'line_id':fields.one2many('phase.per.report.line','phase_per_report_id', 'Phase performance tasks'),
         'per_line_id':fields.one2many('phase.per.report.per.count','phase_per_rep_id', 'Phase performance materials'),
         'material_line_id':fields.one2many('phase.per.report.materials','phase_per_report_mat_id', 'Phase bom materials'),
                
    }
    _defaults = {  
        'per_report_date': lambda self, cr, uid, context: time.strftime('%Y-%m-%d'),
        'state' : lambda *a: 'draft',
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'performance.report', context=c), 
                }
    def onchange_carriage(self, cr, uid, ids, carriage, machine_cost, context=None):
        obj = self.browse(cr, uid,ids)
       
        if carriage ==0:
           return {
                'value': {
                'total_cost': machine_cost + obj.payroll_cost + obj.material_cost,}
                   }
        else:
            return {
            'value': {
                'total_cost': carriage + machine_cost + obj.payroll_cost + obj.material_cost,}
                    }
               
               
    def onchange_machine_cost(self, cr, uid, ids, machine_cost, carriage, context=None):
        obj = self.browse(cr, uid,ids)
        if machine_cost==0:
           return {
            'value': {
                'total_cost': obj.material_cost + carriage + obj.payroll_cost,
                  }
              }
        else:
            return {
            'value': {
                'total_cost': machine_cost + obj.material_cost + carriage + obj.payroll_cost,
                  }
              }
            
    
    def action_pull_phase_performance(self, cr, uid, ids, context=None, *args):
        obj = self.browse(cr, uid,ids)
        project_task_obj = self.pool.get('project.project.task')
        product_obj = self.pool.get('product.product')
        per_report_line = self.pool.get('phase.per.report.line')
        per_mat = self.pool.get('performance.material')
        material_obj = self.pool.get('task.bom')
        per_rep_per_obj = self.pool.get('phase.per.report.per.count')
        material_line_obj = self.pool.get('material.line')
        report_materials = self.pool.get('phase.per.report.materials')
        sal_cost = 0.0
        mat_cost = 0.0
        carr_cost = 0.0
        mach_cost = 0.0
        
        #omnoh line-uudiig tsewerleh vildel
        #Ajluud moriig unlink hiih
        per_rep_obj = self.pool.get('phase.per.report.line')
        for line1 in obj.line_id:
            if line1:
                per_rep_obj.unlink(cr, uid, line1.id)
        #Baraanuud orts bolon gvitsetgeleer moriig unlink hiih
        per_rep_mat_obj = self.pool.get('phase.per.report.materials')
        for line2 in obj.material_line_id:
            if line2:
                per_rep_mat_obj.unlink(cr, uid, line2.id)
        #Gvitsetgeleerh baraanuud moriig unlink hiih
        per_rep_per_count_obj = self.pool.get('phase.per.report.per.count')
        for line3 in obj.per_line_id:
            if line3:
                per_rep_per_count_obj.unlink(cr, uid, line3.id)
        self.write(cr, uid, ids, {'payroll_cost': 0.0,
                                  'material_cost': 0.0,
                                  'carriage': 0.0,
                                  'machine_cost': 0.0,
                                  'total_cost': 0.0,
                                  })
        
        #ajliin gvitsetgelees ajliin torol, gvitsetgeliin too hemjeeg tosliin id, 
        #hariltsagchiin id, ve shatnii id, batlagdsan tolowtei, status n false-r tentsvvlj awch bn
        cr.execute("""select task.task_id, sum(task.performance_count) from 
                    task_performance as task where task.project_id = %s and 
                    task.res_partner_id = %s and 
                    task.project_phase_id = %s and task.state='confirmed' and task.status=FALSE group by task.task_id"""%(obj.project_id.id,obj.res_partner_id.id,obj.task_phase_id.id))
        task_obj  = cr.dictfetchall()
        
        #gvitsetgeliin material-s baraa, ortsoor too hemjeenii niilber, gvitsetgeliin too hemjeenii niilber zergiig
        #gvitsetgeliin moriig tulgaj, ajliin gvitsetgeliig tulgaj status n false, batlagdsan, tosol, partner, ve shataar n shvvj awch bn
        cr.execute("""select task.task_id, task.per_product_id,sum(task.performance_count), sum(task.count) as sum1 from 
                    performance_material as task 
                    left join per_line as b on b.id=task.per_line_id
                    left join task_performance as task_per on task_per.id=b.task_performance_id
                    where  task_per.status=FALSE and task_per.state='confirmed' and task.project_id = %s and
                    task.res_partner_id = %s and
                    task.project_phase_id = %s group by task.task_id, task.per_product_id"""%(obj.project_id.id,obj.res_partner_id.id,obj.task_phase_id.id))
        mat_line_obj  = cr.dictfetchall()
        
        #material_line-s deerhitei ijil shvvlteer awsan bn
        cr.execute("""select task.task_id, task.per_product_id, task.product_id, task.pro_uom_id, sum(task.product_bom) from 
                    material_line as task
                    left join performance_material as per_mat on per_mat.id=task.pr_material_id
                    left join per_line as b on b.id=per_mat.per_line_id
                    left join task_performance as task_per on task_per.id=b.task_performance_id
                    where  task_per.status=FALSE and task_per.state='confirmed' and task.project_id = %s and 
                    task.res_partner_id = %s and 
                    task.project_phase_id = %s group by task.task_id,task.per_product_id, task.product_id, task.pro_uom_id"""%(obj.project_id.id,obj.res_partner_id.id,obj.task_phase_id.id))
        pro_obj  = cr.dictfetchall()
        
        
        
        #doorhi update-g batlah vildel rvv shiljvvlsen bolno
        
        #ajliin gvitsetgeliig tosliin id, partner_id, ve shatnii id-gaar shvvj status-g update hiij bn
        #=======================================================================
        # cr.execute(""" UPDATE task_performance as task
        #             SET  status=TRUE where task.project_id = %s and 
        #             task.res_partner_id = %s and 
        #             task.project_phase_id = %s """%(obj.project_id.id,obj.res_partner_id.id,obj.task_phase_id.id))
        # 
        #=======================================================================
        
        #morvvdiig shineer tatah vildlvvd
        if mat_line_obj!=[]:
           for per in  mat_line_obj:
               per_mat_id = per_mat.search(cr, uid, [('project_id','=',obj.project_id.id),('res_partner_id','=',obj.res_partner_id.id), ('project_phase_id','=',obj.task_phase_id.id)])
               per_material_id = per_mat.browse(cr, uid, per)[0] 
               product_id = product_obj.search(cr, uid, [('id','=',per['per_product_id'])])
               product = product_obj.browse(cr, uid, product_id)[0]
               #Бараанууд орц болон гүйцэтгэлээр rvv utga shidej bga n
               pr_id = report_materials.create(cr, uid, {
                                            'phase_per_report_mat_id':obj.id,
                                            'task_id':per['task_id'],
                                            'product_id':per['per_product_id'],
                                            'pro_uom_id':product.uom_id.id,
                                            'bom_count':per['sum'],
                                            'product_count':per['sum1'],
                                            })
               
                   
           
        if task_obj!=[]: 
           project_task_id = per_report_line.search(cr, uid,[('phase_per_report_id','=',obj.id)])
           if project_task_id==[]:       
      
              for pro in task_obj:    
                  pr_task_id = project_task_obj.search(cr, uid, [('id','=',pro['task_id'])])
                  task = project_task_obj.browse(cr, uid, pr_task_id)[0]
                  cr.execute("""select a.work_count, a.contract_price from 
                      contract_work_line as a
                      left join account_analytic_account as b on b.id=a.account_analytic_account_id
                     where b.contract_project_id = %s and b.partner_id = %s and a.task_id = %s"""%(obj.project_id.id,obj.res_partner_id.id,pro['task_id']))
                  contract_obj  = cr.dictfetchone()
                  
                  if contract_obj !=None:
                     sal_cost += pro['sum'] * contract_obj['contract_price']
                     
                     #Ажлууд
                     per_report_line.create(cr, uid, {  
                                                            'phase_per_report_id':obj.id,
                                                            'task_id':pro['task_id'],
                                                            'unit':task.unit.id,
                                                            'contract_price':contract_obj['contract_price'],
                                                            'contract_count':contract_obj['work_count'],
                                                            'performance_count':pro['sum'],
                                                            'total_price':pro['sum'] * contract_obj['contract_price'],
                                                            'company_id': obj.company_id.id,
                                                    })
                     
                     
                     #carriage_machine-s tosol bolon ve shataar shvvj awah
                     cr.execute("""select sum(pcs.carriage) as sumc, sum(pcs.machine_cost) as summ, pcs.task_phase_id from 
                                phase_costs as pcs
                                left join carriage_machine as cm on cm.id=pcs.carriage_machine_id
                                where cm.project_id = %s and 
                                pcs.partner_id = %s and 
                                pcs.task_phase_id = %s group by pcs.task_phase_id"""%(obj.project_id.id,obj.res_partner_id.id,obj.task_phase_id.id))
                     carriage_machine_obj  = cr.dictfetchall()
                     if carriage_machine_obj!=[]:
                        for cmo in carriage_machine_obj:
                            carr_cost = cmo['sumc']
                            mach_cost = cmo['summ']
                     else:
                         carr_cost = 0.0
                         mach_cost = 0.0
                  else:
                      raise osv.except_osv(_('Warning!'), _('Гүйцэтгэгч дээр энэ ажлын гэрээ бүртгэлгүй байна !!!'))
                      
        if pro_obj!=[]:
           for prod in  pro_obj:
               product_id = product_obj.search(cr, uid, [('id','=',prod['product_id'])])
               product = product_obj.browse(cr, uid, product_id)[0]
               mat_cost += product.standard_price * prod['sum']
               #Гүйцэтгэлээрх бараанууд
               per_rep_per_obj.create(cr, uid, {  
                                                            'phase_per_rep_id':obj.id,
                                                            'task_id':prod['task_id'],
                                                            'per_product_id':prod['per_product_id'],
                                                            'product_id':prod['product_id'],
                                                            'pro_uom_id':prod['pro_uom_id'],
                                                            'product_price':product.standard_price,
                                                            'product_count':prod['sum'],
                                                            'company_id': obj.company_id.id,
                                                            'total_price':product.standard_price * prod['sum'],
                                                    })
        if sal_cost and mat_cost:
                  
           self.write(cr, uid, ids,{
                            'payroll_cost': sal_cost,
                            'material_cost': mat_cost,
                            
                             })
                  #=============================================================
                  # mat_id = material_obj.search(cr, uid, [('pro_task_id','=',pro['task_id'])])
                  # task = material_obj.browse(cr, uid, mat_id)[0]
                  # 
                  # for tsk in task.line1_id: 
                  #     per_rep_per_obj.create(cr, uid, {
                  #                                   'performance_report_id':obj.id,
                  #                                   'project_task_type_id':pro['project_phase_id'],
                  #                                   'product_id':tsk.product_id.id,
                  #                                   'pro_uom_id':tsk.pro_uom_id.id,
                  #                                   'material_price':tsk.material_price,
                  #                                   'material_total_price':tsk.material_price * pro['sum'] * tsk.product_count,
                  #                                   'product_count': tsk.product_count * pro['sum'],
                  #                                   'company_id': obj.company_id.id,
                  #                                   
                  #                                   })
                  #=============================================================
        total1_cost = 0.0
        total1_cost = sal_cost + mat_cost + carr_cost + mach_cost
        self.write(cr, uid, ids,{
                                'carriage': carr_cost,
                                'machine_cost': mach_cost,
                                'total_cost': total1_cost})
        
        return True 
    def action_draft_confirm(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid,ids)
        if obj.line_id and obj.material_line_id and obj.per_line_id:
            self.write(cr, uid, ids, {'state': 'confirmed'})
            cr.execute(""" UPDATE task_performance as task
                    SET  status=TRUE where task.project_id = %s and 
                    task.res_partner_id = %s and 
                    task.project_phase_id = %s """%(obj.project_id.id,obj.res_partner_id.id,obj.task_phase_id.id))
        
        else:
            raise osv.except_osv(_('Анхааруулга!'),_("Та гүйцэтгэлийн мөрүүдийг татсаны дараа батлах үйлдлийг хийх боломжтой! \n <<Үе шатны гүйцэтгэл татах>> товчийг дарна уу"))
        
        return True
    def action_confirm_cancel(self, cr, uid, ids, *args):
        obj = self.browse(cr, uid,ids)
        #Ajluud moriig unlink hiih
        per_rep_obj = self.pool.get('phase.per.report.line')
        for line1 in obj.line_id:
            per_rep_obj.unlink(cr, uid, line1.id)
        #Baraanuud orts bolon gvitsetgeleer moriig unlink hiih
        per_rep_mat_obj = self.pool.get('phase.per.report.materials')
        for line2 in obj.material_line_id:
            per_rep_mat_obj.unlink(cr, uid, line2.id)
        #Gvitsetgeleerh baraanuud moriig unlink hiih
        per_rep_per_count_obj = self.pool.get('phase.per.report.per.count')
        for line3 in obj.per_line_id:
            per_rep_per_count_obj.unlink(cr, uid, line3.id)
        
        
        #ajliin gvitsetgeliig tosliin id, partner_id, ve shatnii id-gaar shvvj status-g update hiij false bolgoh
        task_perf_obj = self.pool.get('task.performance').search(cr, uid,[('project_id','=',obj.project_id.id),
                                                                          ('res_partner_id','=',obj.res_partner_id.id),
                                                                          ('project_phase_id','=',obj.task_phase_id.id)])
        for status in task_perf_obj:
            cr.execute(""" UPDATE task_performance as task
                        SET  status=False where task.project_id = %s and 
                        task.res_partner_id = %s and 
                        task.project_phase_id = %s """%(obj.project_id.id,obj.res_partner_id.id,obj.task_phase_id.id))
        self.write(cr, uid, ids, {'state': 'cancel',
                                  'payroll_cost': 0.0,
                                  'material_cost': 0.0,
                                  'carriage': 0.0,
                                  'machine_cost': 0.0,
                                  'total_cost': 0.0,
                                  })
        return True
    def action_to_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True
    
class performance_report_line(osv.osv):
    _name = 'performance.report.line'
    
#===============================================================================
#     def _write_contract_price(self, cr, uid, ids,name, args, context = None):
# 
#        obj = self.browse(cr, uid,ids)
#        per_rep_obj = self.pool.get('performance.report')
#        res ={}
#        for line in obj:
#            
#            per_report_id = per_rep_obj.search(cr, uid,[('id','=',line.per_report_id.id)])
#            per = per_rep_obj.browse(cr, uid, per_report_id)
#            
#            
#        
#            
#            cr.execute("""select a.contract_price from 
#                       contract_work_line as a
#                       left join account_analytic_account as b on b.id=a.account_analytic_account_id
#                      where b.contract_project_id = %s and b.partner_id = %s and a.task_id = %s"""%(per.project_id.id,per.res_partner_id.id,line.task_id.id))
#            mat_line_obj  = cr.dictfetchone()
#            
#            contract_price = 0.0
#            if mat_line_obj !=None:
#               
#               if mat_line_obj['contract_price'] != None:
#                  
#                  contract_price = mat_line_obj['contract_price']
#                  
#            res[line.id] = contract_price
# 
#        return res
#    
#     def _write_contract_count(self, cr, uid, ids,name, args, context = None):
# 
#        obj = self.browse(cr, uid,ids)
#        per_rep_obj = self.pool.get('performance.report')
#        res ={}
#        for line in obj:
#            
#            per_report_id = per_rep_obj.search(cr, uid,[('id','=',line.per_report_id.id)])
#            per = per_rep_obj.browse(cr, uid, per_report_id)
#            
#            
#        
#            
#            cr.execute("""select a.work_count from 
#                       contract_work_line as a
#                       left join account_analytic_account as b on b.id=a.account_analytic_account_id
#                      where b.contract_project_id = %s and b.partner_id = %s and a.task_id = %s"""%(per.project_id.id,per.res_partner_id.id,line.task_id.id))
#            mat_line_obj  = cr.dictfetchone()
#            
#            contract_count = 0.0
#            if mat_line_obj !=None:
#               
#               if mat_line_obj['work_count'] != None:
#                  
#                  contract_count = mat_line_obj['work_count']
#                  
#            res[line.id] = contract_count
# 
#        return res
#===============================================================================
   
   
    _columns = {
         #'phase_id':fields.many2one('project.task.type','Phase name'),
         'phase_id':fields.many2one('project.task.phase','Phase name'),
         'task_id': fields.many2one('project.project.task','Task name'),
         'unit': fields.many2one('product.uom', 'Unit'),
         'performance_count':fields.float('Performance count'),
         'contract_count': fields.float('Contract count'), 
         'contract_price': fields.float('Contract price'), 
         'total_price':fields.float('Total price'),
         'company_id':fields.many2one('res.company','Company'),
         'per_report_id':fields.many2one('performance.report','Performance report'),     
         'task_performance_id':fields.many2one('task.performance','Task performance')  
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'performance.report.line', context=c),    
                 }
    
    def onchange_task_id(self, cr, uid, ids, task_id, context=None):
        res = {}
        temp_obj = self.pool.get('project.project.task')
        if task_id:
            #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
            temp = temp_obj.browse(cr, uid, temp_obj.search(cr, uid, [('id','=',task_id)]))
            res['unit']=temp.unit.id
        return {'value':res}
    

class performance_report_materials(osv.osv):
    _name = 'performance.report.materials'
    _columns = {
         'project_task_phase_id':fields.many2one('project.task.phase','Phase name'),
         'product_id':fields.many2one('product.product', 'Product name'),
         'pro_uom_id':fields.many2one('product.uom', 'Unit'),
         'product_count':fields.float('Product count'),
         'bom_count':fields.float('Bom count'),
         'diff_count':fields.float('Diffrence count'),
         'ncd_count':fields.float('NCD count'),
         'executive_count':fields.float('Executive count'),
         'material_price': fields.float('Price'),
         'material_total_price': fields.float('Total price'),
         'company_id':fields.many2one('res.company','Company'),
         'performance_report_id':fields.many2one('performance.report','Performance report'),  
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'performance.report.line', context=c),    
                 }
    #@api.onchange
    def onchange_executive_count(self, cr, uid, ids, executive_count, diff_count, context=None):
        res = {}
        obj = self.browse(cr, uid,ids)
        diff = diff_count - executive_count
        res['ncd_count']=diff
        return {'value':res}
    #@api.onchange
    def onchange_ncd_count(self, cr, uid, ids, ncd_count, diff_count, context=None):
        res = {}
        obj = self.browse(cr, uid,ids)
        diff = diff_count - ncd_count
        res['executive_count']=diff
        return {'value':res}
    
    def onchange_product_id(self, cr, uid, ids, product_id, context=None):
        res = {}
        temp_obj = self.pool.get('product.product')
        if product_id:
            #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
            temp = temp_obj.browse(cr, uid, temp_obj.search(cr, uid, [('id','=',product_id)]))
            res['pro_uom_id']=temp.uom_id.id
        return {'value':res}
    
class performance_report_per_count(osv.osv):
    _name = 'performance.report.per.count'
    
    #===========================================================================
    # def _write_material_price(self, cr, uid, ids,name, args, context = None):
    #     
    #     obj = self.browse(cr, uid,ids)
    #     res = {}
    #     price = 0.0
    #     for line in obj:
    #         product_id = self.pool.get('product.product').browse(cr, uid, line.product_id.id)
    #         for li in product_id:
    #             price = li.standard_price
    #             #cr.execute('select lst_price from product_product where id = %s'%obj.product_id.id)
    #             
    #             
    #             res[line.id] = price
    #     return res
    # 
    # def _write_material_sum_price(self, cr, uid, ids,name, args, context = None):
    #     
    #     obj = self.browse(cr, uid,ids)
    #     res = {}
    #     sum_price = 0.0
    #     for line in obj:
    #          sum_price = line.material_price * line.product_count
    #          res[line.id] = sum_price
    #          
    #     return res
    #===========================================================================
    _columns = {
         'project_task_phase_id':fields.many2one('project.task.phase','Phase name'),
         'product_id':fields.many2one('product.product', 'Product name'),
         'per_product_id':fields.many2one('product.product', 'Performance product'),
         'pro_uom_id':fields.many2one('product.uom', 'Unit'),
         'product_count':fields.float('Product count'),
         'material_price': fields.float('Price'),
         'material_total_price': fields.float('Sum price'),
         'company_id':fields.many2one('res.company','Company'),
         'per_rep_id':fields.many2one('performance.report','Performance report'),  
    }
    _defaults = {  
        'company_id': lambda self, cr, uid, c: self.pool.get('res.company')._company_default_get(cr, uid, 'performance.report.line', context=c),    
                 }
    
    def onchange_per_product_id(self, cr, uid, ids, per_product_id, context=None):
        res = {}
        temp_obj = self.pool.get('product.product')
        if per_product_id:
            #task = material_obj.browse(cr, uid, material_obj.search(cr, uid, [('pro_task_id','=',task_id)]))[0]
            temp = temp_obj.browse(cr, uid, temp_obj.search(cr, uid, [('id','=',per_product_id)]))
            res['pro_uom_id']=temp.uom_id.id
        return {'value':res}

