# -*- coding: utf-8 -*-
##############################################################################
#
#                       tbab - ERP
#
##############################################################################

from openerp import tools
from openerp.osv import fields, osv

from openerp.tools.sql import drop_view_if_exists

class carriage_machine_report(osv.osv):
    _name = "carriage.machine.report"
    _description = "Carriage machine report analysis"
    _auto = False
    #_rec_name = 'date'
    
    _columns = {
        'name': fields.char('Carriage name'),
        'project_id': fields.many2one('project.project', 'Project name'),        
        'task_phase_id':fields.many2one('project.task.phase','Task phase'),
        'carriage':fields.float('Carriage'),
        'machine_cost':fields.float('Machine cost'),
        'partner_id':fields.many2one('res.partner','Partner'),
        'comment':fields.text('Comment'),
        'cont_date':fields.date('Contract date'),
        'company_id':fields.many2one('res.company','Company'),
    }
    _order = 'cont_date desc'

    def init(self, cr):
        drop_view_if_exists(cr, 'carriage_machine_report')
        cr.execute("""
            create or replace view carriage_machine_report as (
                SELECT
                    ptp.id as id,
                    ptp.id as task_phase_id,
                    pc.carriage as carriage,
                    pc.machine_cost as machine_cost,
                    pc.partner_id as partner_id,
                    pc.comment as comment,
                    pc.cont_date as cont_date,
                    c.name as name,
                    c.project_id as project_id,
                    c.company_id as company_id,
                    sum(pc.carriage)
                FROM 
                    carriage_machine c
                    LEFT JOIN phase_costs pc ON (pc.carriage_machine_id = c.id)
                    LEFT JOIN project_task_phase ptp ON (ptp.id = pc.task_phase_id)
                    LEFT JOIN res_partner rp ON (rp.id = pc.partner_id)
                    LEFT JOIN res_company rc ON (rc.id = c.company_id)
                GROUP BY
                    ptp.id,
                    pc.partner_id,
                    pc.carriage,
                    pc.machine_cost,
                    pc.comment,
                    pc.cont_date,
                    c.name,
                    c.project_id,
                    c.company_id
            )""")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: