# -*- coding: utf-8 -*-
##############################################################################
#
#                       tbab - ERP
#
##############################################################################

from openerp import tools
from openerp.osv import fields, osv

from openerp.tools.sql import drop_view_if_exists


class progress_amount_report_tb(osv.osv):
    _name = "progress.amount.report.tb"
    _description = "Tasks by progress_amount and project"
    _auto = False
    _columns = {
        'name': fields.char('Ажлууд', readonly=True),
        'user_id': fields.many2one('res.users', 'Оноогдсон', readonly=True),
        'reviewer_id': fields.many2one('res.users', 'Хянагч', readonly=True),
        'project_id': fields.many2one('project.project', 'Төсөл', readonly=True),
        'progress': fields.float('Тоо хэмээгээрх явц (%)', readonly=True, group_operator='avg'),
        'progress_amount': fields.float('Зардлаарх явц (%)', readonly=True, group_operator='avg'),
        'nbr': fields.integer('# Ажлын тоо', readonly=True),  # TDE FIXME master: rename into nbr_tasks
        'state': fields.selection([('normal', 'In Progress'),('blocked', 'Blocked'),('done', 'Ready for next stage')],'Status', readonly=True),
        'partner_id': fields.many2one('res.partner', 'Захиалагч', readonly=True),
        'stage_id': fields.many2one('project.task.type', 'Төлөв'),
        'phase_id': fields.many2one('project.task.phase', 'Төслийн үе шат'),
    }
    _order = 'name desc, project_id'

    def init(self, cr):
        tools.sql.drop_view_if_exists(cr, 'progress_amount_report_tb')
        cr.execute("""
            CREATE view progress_amount_report_tb as
              SELECT
                    (select 1 ) AS nbr,
                    t.id as id,
                    t.user_id,
                    t.reviewer_id,
                    progress as progress,
                    progress_amount_report as progress_amount,
                    t.project_id,
                    t.name as name,
                    t.partner_id,
                    t.stage_id as stage_id,
                    t.phase_id as phase_id,
                    t.kanban_state as state
              FROM project_task t
                WHERE t.active = 'true'
                GROUP BY
                    t.id,
                    progress,
                    progress_amount_report,
                    t.user_id,
                    t.reviewer_id,
                    t.project_id,
                    name,
                    t.partner_id,
                    t.phase_id,
                    stage_id
        """)
