# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import logging

from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _
from datetime import date, datetime
from dateutil import relativedelta
import json
import time


AVAILABLE_PRIORITIES = [
    ('1', 'Bad'),
    ('2', 'Below Average'),
    ('3', 'Average'),
    ('4', 'Good'),
    ('5', 'Excellent'),
]

class res_partner(osv.osv):
    _inherit = 'res.partner'
    
    def name_get(self, cr, uid, ids, context=None):
        if isinstance(ids, (list, tuple)) and not len(ids):
            return []
        if isinstance(ids, (long, int)):
            ids = [ids]
        reads = self.read(cr, uid, ids, ['name','code'], context=context)
        res = []
        for record in reads:
            name = record['name']
            if record['code']:
                name = name +'/'+ record['code']
            res.append((record['id'], name))
        return res
    
    def name_search(self, cr, uid, name, args=None, operator='ilike', context=None, limit=100):
        if args is None:
            args = []
        if context is None:
            context = {}
        ids = []
        if name:
            ids = self.search(cr, uid, [('name', 'ilike', name)] + args, limit=limit)
        if not ids:
            ids = self.search(cr, uid, [('code', 'ilike', name)] + args, limit=limit)
        return self.name_get(cr, uid, ids, context=context)

    _columns = {
                'assessment':fields.selection(AVAILABLE_PRIORITIES,'Assessment'),
                'assessment_note':fields.text('Assessment Note'),
                'history_id':fields.one2many('assessment.history','partner_id'),
                'code':fields.char('Partner code'),
                'regiment':fields.char('Regiment'),
                'section':fields.char('Section'),
                'town':fields.char('Town'),
                'building':fields.char('Building'),
                'door':fields.char('Door'),
                }
    _sql_constraints = [
        ('code', 'unique (code)', u' Харилцагч код давхцаж болохгүй тул та өөр код өгнө үү!')
    ]
    
    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid, ids)
        if ids:
            asses = ''
            note = ''
            if 'assessment' in vals:
                asses = vals['assessment']
                
            if 'assessment_note' in vals:
                note = vals['assessment_note']
                self.pool.get('assessment.history').create(cr, uid, {
                                                                         'user_id':uid,
                                                                         'partner_id':obj.id,
                                                                         'change_date':time.strftime('%Y-%m-%d'),
                                                                         'renew_assessment':obj.assessment,
                                                                         'change_assessment':asses,
                                                                         'description':note,
                                                                      })
            if asses != '':
              if 'assessment_note' in vals:
                print'llll',
              else:
                  raise osv.except_osv( _('error!'),
                        _(u"Үнэлгээний тайлбарыг заавал оруулна уу"))
         
            #if obj.assessment_note == False:
            #    raise osv.except_osv( _('error!'),
             #           _(u"Үнэлгээний тайлбарыг заавал оруулна уу"))
        return super(res_partner, self).write(cr, uid, ids, vals,context=context)

class assessment_history(osv.osv):
    _name = 'assessment.history'

    _columns = {
                'user_id':fields.many2one('res.users','Change user name'),
                'change_date':fields.date('Change date'),
                'renew_assessment':fields.selection(AVAILABLE_PRIORITIES,'Renew assessment'),
                'change_assessment':fields.selection(AVAILABLE_PRIORITIES,'Change assessment'),
                'description':fields.char('Assessment Note'),
                'partner_id':fields.many2one('res.partner','Partner id'),
                }