# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import logging

from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _

class purchase_date_config(osv.osv):
    _name = 'purchase.date.config'
    
    _columns = {
                'name':fields.char('Name'),
                'line_id':fields.one2many('purchase.date.config.line','config_id','Purchase day configure'),
                'company_id':fields.many2one('res.company','Company'),
                }
    _defaults = {
                  'company_id': lambda self, cr, uid, context: self.pool.get('res.company')._company_default_get(cr, uid, 'purchase.date.config', context=context)
                 }

class purchase_date_config_line(osv.osv):
    _name='purchase.date.config.line'
    
    _columns = {
                'created_date':fields.date('Created date'),
                'day':fields.integer('Purchase config day'),
                'company_id':fields.many2one('res.company','Company'),
                'user_id':fields.many2one('res.users','Created user'),
                'config_id':fields.many2one('purchase.date.config','purchase.date.config')
                }
    _defaults = {
                  'user_id': lambda self, cr, uid, context: uid,      
                  'company_id': lambda self, cr, uid, context: self.pool.get('res.company')._company_default_get(cr, uid, 'purchase.date.config', context=context)
                 }