
openerp.ierp_purchase_comparison = function(instance) {
    var QWeb = instance.web.qweb;
    var _t = instance.web._t;
    var supps = [];
    var supp_ids = {};
    var group_name = [];

    instance.ierp_purchase_comparison.Comparison = instance.web.form.FormWidget.extend(instance.web.form.ReinitializeWidgetMixin, {
        events: {
            "click .oe_timesheet_weekly_account a": "go_to",
            "change .calc_price": "calculate_price",
            "change .risk_eval": "calculate_risk",
            "change .operational_cost": "calculate_cost",
            "change .buyer_check": "on_buyer_check",
            "change .select_budget": "on_buyer_check",
            "change .product_budget": "on_product_budget",
            
            "change .buyer": "on_buyer",
            "change .ceo": "on_ceo",
            "change .buyer_ceo": "on_buyer_ceo",
            "change .budget_ceo": "on_budget_ceo",
            "change .holder": "on_holder",
        },
        init: function() {
            this._super.apply(this, arguments);
            var self = this;
            self.suppliers = [];

            this.set({
                sheets: [],
                date_to: false,
                date_from: false,
            });
            this.updating = false;
            this.defs = [];
            this.field_manager.on("field_changed:order_ids", this, this.query_sheets);
            this.on("change:sheets", this, this.update_sheets);
            this.res_o2m_drop = new instance.web.DropMisordered();
            this.render_drop = new instance.web.DropMisordered();
            this.get_group_drop = new instance.web.DropMisordered();
            this.description_line = _t("/");
            // Original save function is overwritten in order to wait all running deferreds to be done before actually applying the save.
            this.view.original_save = _.bind(this.view.save, this.view);
            this.view.save = function(prepend_on_create) {
                self.prepend_on_create = prepend_on_create;
                return $.when.apply($, self.defs).then(function() {
                    return self.view.original_save(self.prepend_on_create);
                });
            };

			this.get_group();
        },
        on_buyer:function(e){
            this.check_one('buyer', e.target);
        },
        on_ceo:function(e){
            this.check_one('ceo', e.target);
        },
        on_buyer_check:function(e){
            this.check_one('buyer_check', e.target);
        },
        on_buyer_ceo:function(e){
            this.check_one('buyer_ceo', e.target);
        },
        on_budget_ceo:function(e){
            this.check_one('budget_ceo', e.target);
        },
        on_holder:function(e){
            this.check_one('holder', e.target);
        },
        check_one:function(classes, target){
            var group = "input." + classes + "";
            $(group).attr("checked",false);
            $(target).attr("checked",true);
            this.on_buyer_check();
        },
        get_group: function() {
            self = this;
            self.get_group_drop.add(new instance.web.Model('purchase.comparison').call("get_groups", [], {context: new instance.web.CompoundContext()}))
                    .done(function(result) {
                        self.querying = true;
		            	self.group_name = result;
		            	// console.log("RESULTS", result);
                        self.querying = false;
                    });
        },
        has_role: function(role, state){
            var current_state = this.field_manager.get_field_value("state");
            // console.log("GROUP", this.group_name);
            if(this.group_name.length == 0){
                return true;
            }
        	for(i = 0; i < this.group_name.length; i++){
        		group = this.group_name[i];
        		// console.log(group);
        		if(group['name'] == role && current_state == state){
        			return true;
        		}
        	}
        	return false;
        },
        update_total_eval: function() {
            var total_sum = 0;
            _.each(supps, function(supplier) {
                total_sum = parseInt(this.$('[data-calc-price="' + supplier + '_calc_price"]').html()) +
                        parseInt(this.$('[data-risk-eval="' + supplier + '_risk_eval"]').html()) +
                        parseInt(this.$('[data-oper-cost="' + supplier + '_oper_cost"]').html())
                return this.$('[data-total-eval="' + supplier + '_total_eval"]').html(total_sum);
            });
        },
	get_formatted_amount:function(amount){
        	var amount1=Math.round(amount);
        	return amount1.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
        
        },
        calculate_price: function(event) {
            var po_amount = 0;
            var po_tax = 0;
            var transport_cost = 0;
            var sum = 0;
            
            _.each(supps, function(supplier) {
                po_amount = this.$('[data-calc-price-item="' + supplier + '_calc_price_item1"]').html();
                po_tax = this.$('[data-calc-price-item="' + supplier + '_calc_price_item2"]').html();
                transport_cost = this.$('[data-calc-price-item="' + supplier + '_calc_price_item3"]').val();
                sum = parseInt(po_amount) + parseInt(po_tax) + parseInt(transport_cost);
                return this.$('[data-calc-price="' + supplier + '_calc_price"]').html(sum);
            });
            this.update_total_eval();
            self.querying = false;
            // console.log("-----------------");
            // console.log("query:", self.querying);
            this.update_sheets();
        },
        on_product_budget:function(event){
            self.querying = false;
            // console.log("-----------------");
            // console.log("query:", self.querying);
            this.update_sheets();
        },
        calculate_risk: function(event) {
            var val = $(event.target).val();
            var experience = 0;
            var quarantee = 0;
            var supply_dur = 0;
            var sum = 0;

            _.each(supps, function(supplier) {
                experience = this.$('[data-risk-eval-item="' + supplier + '_risk_eval_item1"]').val();
                quarantee = this.$('[data-risk-eval-item="' + supplier + '_risk_eval_item2"]').val();
                supply_dur = this.$('[data-risk-eval-item="' + supplier + '_risk_eval_item3"]').val();
                sum = parseInt(experience) + parseInt(quarantee) + parseInt(supply_dur)
                return this.$('[data-risk-eval="' + supplier + '_risk_eval"]').html(sum);
            });
            this.update_total_eval();
            self.querying = false;
            this.update_sheets();
        },
        calculate_cost: function(event) {
            _.each(supps, function(supplier) {
                var maintenance_cost = this.$('[data-oper-cost-item="' + supplier + '_oper_cost_item1"]').val();
                var parts_cost = this.$('[data-oper-cost-item="' + supplier + '_oper_cost_item2"]').val();
                var quality_cost = this.$('[data-oper-cost-item="' + supplier + '_oper_cost_item3"]').val();
                var sum = parseInt(maintenance_cost) + parseInt(parts_cost) + parseInt(quality_cost);
                return this.$('[data-oper-cost="' + supplier + '_oper_cost"]').html(sum);
            });
            this.update_total_eval();
            self.querying = false;
            this.update_sheets();
        },
        on_buyer_check: function(event) {
            /*
             _.each(supps, function(supplier) {
             var buyer_check = this.$('[data-buyer-check="' + supplier + '_buyer_check"]').val();
             });
             */


            // console.log("buyer_check");
            self.querying = false;
            this.update_sheets();
        },
        query_sheets: function() {
            // console.log('query_sheets');
            var self = this;
            if (self.updating)
                return;
            var commands = this.field_manager.get_field_value("order_ids");
            this.res_o2m_drop.add(new instance.web.Model(this.view.model).call("resolve_2many_commands", ["order_ids", commands, [],
                new instance.web.CompoundContext()]))
                    .done(function(result) {
                        self.querying = true;
                        // console.log('result: ', result);
                        self.set({sheets: result});
                        self.querying = false;
                    });
        },
        update_sheets: function() {
            // console.log('update_sheets');
            var self = this;
            // console.log('self.querying: ', self.querying);
            if (self.querying) {
                return;
            }
            self.updating = true;
            // console.log('self.get(sheets): ', self.get("sheets"));
            var sheet = self.get("sheets");

            var ops = [];
            _.each(self.get("sheets"), function(order) {
                var tmp = _.clone(order);
                _.each(order, function(v, k) {
                    if (v instanceof Array) {
                        tmp[k] = v[0];
                    }
                });
                ops.push(tmp);
            });

            var orders = [];
            _.each(supps, function(supplier) {
                var order_data = {};
                order_data['transport_cost'] = this.$('[data-calc-price-item="' + supplier + '_calc_price_item3"]').val();
                order_data['calculated_price'] = parseInt(this.$('[data-calc-price-item="' + supplier + '_calc_price_item1"]').html()) +
                        parseInt(this.$('[data-calc-price-item="' + supplier + '_calc_price_item2"]').html()) +
                        parseInt(this.$('[data-calc-price-item="' + supplier + '_calc_price_item3"]').html())

                order_data['experience_real'] = this.$('[data-risk-real-item="' + supplier + '_risk_real_item1"]').val();
                order_data['experience_amount'] = this.$('[data-risk-eval-item="' + supplier + '_risk_eval_item1"]').val();
                order_data['guarantee_real'] = this.$('[data-risk-real-item="' + supplier + '_risk_real_item2"]').val();
                order_data['guarantee_amount'] = this.$('[data-risk-eval-item="' + supplier + '_risk_eval_item2"]').val();
                order_data['supply_dur_real'] = this.$('[data-risk-real-item="' + supplier + '_risk_real_item3"]').val();
                order_data['supply_dur_amount'] = this.$('[data-risk-eval-item="' + supplier + '_risk_eval_item3"]').val();
                order_data['risk_aval_amount'] = parseInt(order_data['experience_amount']) + parseInt(order_data['guarantee_amount']) + parseInt(order_data['supply_dur_amount'])

                order_data['maintenance_cost'] = this.$('[data-oper-cost-item="' + supplier + '_oper_cost_item1"]').val();
                order_data['spare_parts_cost'] = this.$('[data-oper-cost-item="' + supplier + '_oper_cost_item2"]').val();
                order_data['quality_cost'] = this.$('[data-oper-cost-item="' + supplier + '_oper_cost_item3"]').val();
                order_data['operational_cost'] = parseInt(order_data['maintenance_cost']) + parseInt(order_data['spare_parts_cost']) + parseInt(order_data['quality_cost']);

                order_data['total_evaluation'] = parseInt(order_data['calculated_price']);

                if(this.$('[data-in-budget="' + supplier + '_in_budget"]').is(':enabled')){
                	order_data['in_budget'] = (this.$('[data-in-budget="' + supplier + '_in_budget"]').val() == 'Yes') ? 'yes' : 'no';
                }
                if(this.$('[data-buyer-check="' + supplier + '_buyer_check"]').is(':enabled')){
                	order_data['is_selected_by_employee'] = this.$('[data-buyer-check="' + supplier + '_buyer_check"]').is(":checked");
                }
                if(this.$('[data-director-check="' + supplier + '_director_check"]').is(':enabled')){
                	order_data['is_selected_by_director'] = this.$('[data-director-check="' + supplier + '_director_check"]').is(":checked");
                }
                if(this.$('[data-proc-director="' + supplier + '_proc_director"]').is(':enabled')){
                	order_data['is_selected_by_proc_director'] = this.$('[data-proc-director="' + supplier + '_proc_director"]').is(":checked");
                }
                if(this.$('[data-ceo="' + supplier + '_ceo"]').is(':enabled')){
                	order_data['is_selected_by_ceo'] = this.$('[data-ceo="' + supplier + '_ceo"]').is(":checked");
                }
                if(this.$('[data-board="' + supplier + '_board"]').is(':enabled')){
                	order_data['is_selected_by_board'] = this.$('[data-board="' + supplier + '_board"]').is(":checked");
                }


                if(this.$('.product_budget').length > 0){
	                order_data['order_line'] = [];
	                for(index in self.product_objs){
	                	obj = self.product_objs[index];
	                	budget = this.$('[data-budget="' + obj['name'] + '_budget"]').val();
	                	order_data['order_line'].push([1, obj['id'], {'budget': budget}]);
	                }
                }

                console.log("LINE", order_data['order_line']);

                orders.push([1, supp_ids[supplier], order_data]);

                console.log("ORDER", orders);
            });
            self.field_manager.set_values({order_ids: orders}).done(function() {
                self.updating = false;
            });
        },
        go_to: function(event) {
            var id = JSON.parse($(event.target).data("id"));
            this.do_action({
                type: 'ir.actions.act_window',
                res_model: "account.analytic.account",
                res_id: id,
                views: [[false, 'form']],
                target: 'current'
            });
        },
        initialize_field: function() {
            instance.web.form.ReinitializeWidgetMixin.initialize_field.call(this);
            var self = this;
            self.on("change:user_id", self, self.initialize_content);
            self.on("change:sheets", self, self.initialize_content);
        },
        fetch: function(model, fields, domain, ctx) {
            return new instance.web.Model(model).query(fields).filter(domain).context(ctx).all()
        },
        initialize_content: function() {

            var self = this;
            self.dates = ['2014-06-09', '2014-06-10'];
            self.accounts = ['account1', 'account2'];
            self.suppliers = [];
            self.order_ids = [];
            self.products = [];
            self.product_objs = [];
            self.product_names = {};
            self.supplier_names = {};
            self.payment_term = {};
            self.contact = {};
            self.incoterm = {};
            self.orders = this.field_manager.get_field_value("order_ids");
            _.each(self.orders, function(order) {
                self.order_ids.push(order[1]);
            });
            var loaded = self.fetch('purchase.order',
                    ['id', 'name', 'partner_id', 'amount_total', 'amount_tax', 'order_line', 'calculated_price', 'transport_cost', 'experience_amount',
                        'guarantee_amount', 'shipment_day', 'maintenance_cost', 'spare_parts_cost', 'quality_cost','payment_term_id','incoterm_id',
                        'risk_aval_amount', 'operational_cost', 'total_evaluation', 'is_selected_by_employee', 'is_selected_by_director', 'in_budget',
                        'is_selected_by_proc_director', 'is_selected_by_ceo', 'is_selected_by_board', 'state', 'experience_real', 'guarantee_real', 'warranty_years',
                        'supply_dur_real','currency_rate'],
                    [['id', 'in', self.order_ids]])
                    .then(function(order_objs) {
                        self.suppliers = [];
                        self.order_names = [];
                        self.quotation_price = {};
                        self.product_price = {};
                        self.product_budget = {};
                        self.calculated_price = {};
                        self.product_qty = {};
                        self.product_unit = {};
                        self.taxes = {};
                        self.products = [];
                        self.product_objs = [];
                        self.product_names = {};
                        self.supplier_names = {};
                        self.payment_term = {};
                        self.incoterm = {};
                        self.contact = {};
                        self.currency_rate = {};
                        self.transport_cost = {};

                        self.risk_aval_amount = {};
                        self.experience_amount = {};
                        self.guarantee_amount = {};
                        self.supply_dur_amount = {};

                        self.experience_real = {};
                        self.guarantee_real = {};
                        self.supply_dur_real = {};

                        self.operational_cost = {};
                        self.maintenance_cost = {};
                        self.spare_parts_cost = {};
                        self.quality_cost = {};

                        self.total_evaluation = {};
                        self.is_selected_by_employee = {};
                        self.is_selected_by_director = {};
                        self.is_selected_by_proc_director = {};
                       

                        self.in_budget = {};
                        self.states = {};
                        self.attachments = {};

                        var order_lines = {};
                        self.choices = ['Yes', ' No'];
                        _.each(order_objs, function(order_obj) {
                            self.suppliers.push(order_obj.name);
                            self.attachments[order_obj.name] = []
                            
                            var attch = self.fetch('ir.attachment', ['id', 'datas_fname'], [['res_model', '=', 'purchase.order'],['res_id','=',order_obj.id]]).then(function(attachs) {
                            	console.log('attachs: ', attachs);
                        		_.each(attachs, function(attach) {
	                            	console.log('attach.id: ', attach.id);
	                            	var found = 0;
	                            	for (i in self.attachments[order_obj.name]){
	                            		console.log('i: ', i);
	                            		console.log('self.attachments[order_obj.name][i][id]: ', self.attachments[order_obj.name][i]['id']);
	                            		console.log('attach.id: ', attach.id);
	                            		if (self.attachments[order_obj.name][i]['id'] == attach.id){
	                            			found = 1;
	                            			console.log('found');
	                            		}
	                            	}
	                            	if (found == 0){
	                            		self.attachments[order_obj.name].push({'id':attach.id, 'filename' : attach.datas_fname});
	                            	}
                            	});
                            });
                            
                            supp_ids[order_obj.name] = order_obj.id;
                            if (order_obj.amount_total == false) {
                                self.quotation_price[order_obj.name] = 0
                                self.calculated_price[order_obj.name] = 0
                            } else {
                                if (order_obj.amount_tax == false) {
                                    self.quotation_price[order_obj.name] = order_obj.amount_total;
                                } else {
                                    self.quotation_price[order_obj.name] = (order_obj.amount_total - order_obj.amount_tax);
                                }
                            }
                            self.calculated_price[order_obj.name] = self.quotation_price[order_obj.name]+order_obj.amount_tax;
                            self.taxes[order_obj.name] = order_obj.amount_tax;
                            self.supplier_names[order_obj.name] = order_obj.partner_id[1];
                            self.payment_term[order_obj.name] = order_obj.payment_term_id[1];
                            self.incoterm[order_obj.name] = order_obj.incoterm_id[1];
                            self.contact[order_obj.name] = order_obj.partner_id[2]+order_obj.partner_id[10];
                            order_lines[order_obj.name] = order_obj.order_line;

                            self.transport_cost[order_obj.name] = order_obj.transport_cost;

                            self.risk_aval_amount[order_obj.name] = order_obj.risk_aval_amount;
                            self.experience_amount[order_obj.name] = order_obj.experience_amount;
                            self.guarantee_amount[order_obj.name] = order_obj.guarantee_amount;
                            self.supply_dur_amount[order_obj.name] = order_obj.shipment_day;

                            self.experience_real[order_obj.name] = order_obj.experience_real;
                            self.guarantee_real[order_obj.name] = order_obj.warranty_years;
                            self.supply_dur_real[order_obj.name] = order_obj.supply_dur_real;

                            self.operational_cost[order_obj.name] = order_obj.operational_cost;
                            self.maintenance_cost[order_obj.name] = order_obj.maintenance_cost;
                            self.spare_parts_cost[order_obj.name] = order_obj.spare_parts_cost;
                            self.quality_cost[order_obj.name] = order_obj.quality_cost;
 			                self.currency_rate[order_obj.name] = order_obj.currency_rate
                            self.total_evaluation[order_obj.name] = order_obj.total_evaluation;

                            self.is_selected_by_employee[order_obj.name] = Boolean(order_obj.is_selected_by_employee);
                            self.is_selected_by_director[order_obj.name] = Boolean(order_obj.is_selected_by_director);
                            self.is_selected_by_proc_director[order_obj.name] = Boolean(order_obj.is_selected_by_proc_director);
                            self.in_budget[order_obj.name] = order_obj.in_budget;
                           
                            self.states[order_obj.name] = order_obj.state;
                            
                        });
                        supps = self.suppliers;
                        return order_lines;
                    }).then(function(order_lines) {
                        _.each(order_lines, function(line) {
                            _.each(self.suppliers, function(supplier) {
                                self.product_price[supplier] = {}
                                self.product_qty[supplier] = {}
                                self.product_unit[supplier] = {}
                                var products = self.fetch('purchase.order.line', ['id', 'product_id', 'price_unit', 'product_uom', 'product_qty', 'budget'], [['id', 'in', order_lines[supplier]]]).then(function(lines) {
                                    _.each(lines, function(line) {
                                        if (self.products.indexOf(line.product_id[1]) < 0) {
                                            self.products.push(line.product_id[1]);
                                        }
                                        if (!self.has_product(line.product_id[0])) {
                                            self.product_objs.push({'id':line.product_id[0],'name':line.product_id[1]});
                                        }
                                        
                                        self.product_price[supplier][line.product_id[1]] = line.price_unit;
                                        self.product_qty[supplier][line.product_id[1]] = line.product_qty;
                                        self.product_unit[supplier][line.product_id[1]] = line.product_uom[1];
                                        self.product_budget[line.product_id[1]] = line.budget;
                                    });
                                    self.display_data();
                                    return products;
                                }).then(function(products) {
                                    return self.products;
                                });
                            });
                            
                        });
                    });
        },
        has_product:function(id){
        	for(index in this.product_objs){
        		obj = this.product_objs[index];
        		console.log("index", index);

        		if(obj['id'] == id){
        			return true;
        		}
        	}
        	return false;
        },
       	get_price:function(supplier, product){
            self = this;
            for(field in self.product_price[supplier]){
                if(field == product){
                    return this.get_formatted_amount( self.product_price[supplier][product]);
                }
            }
            return 0;
        },
        get_product_unit:function(supplier, product){
            self = this;
            
            for(field in self.product_unit[supplier]){
                if(field == product){
                    return self.product_unit[supplier][product];
                }
            }
            return 0;
        },
        get_qty:function(supplier, product){
            self = this;
            
            for(field in self.product_qty[supplier]){
                if(field == product){
                    return this.get_formatted_amount(self.product_qty[supplier][product]);
                }
            }
            return 0;
        },
        is_valid_value: function(value) {
            var split_value = value.split(":");
            var valid_value = true;
            if (split_value.length > 2)
                return false;
            _.detect(split_value, function(num) {
                if (isNaN(num)) {
                    valid_value = false;
                }
            });
            return valid_value;
        },
        display_data: function() {
            var self = this;

            self.$el.html(QWeb.render("ierp_purchase_comparison.Comparison", {widget: self}));
        },
        get_box: function(account, day_count) {
            return this.$('[data-account="' + account.account + '"][data-day-count="' + day_count + '"]');
        },
        get_total: function(account) {
            return this.$('[data-account-total="' + account.account + '"]');
        },
        get_day_total: function(day_count) {
            return this.$('[data-day-total="' + day_count + '"]');
        },
        get_super_total: function() {
            return this.$('.oe_timesheet_weekly_supertotal');
        },
        sum_box: function(account, day_count, show_value_in_hour) {
            var line_total = 0;
            _.each(account.days[day_count].lines, function(line) {
                line_total += line.unit_amount;
            });
            return (show_value_in_hour && line_total != 0) ? this.format_client(line_total) : line_total;
        },
        generate_o2m_value: function() {
            var self = this;
            var ops = [];

            _.each(self.accounts, function(account) {
                var auth_keys = _.extend(_.clone(account.account_defaults), {
                    name: true, amount: true, unit_amount: true, date: true, account_id: true,
                });
                _.each(account.days, function(day) {
                    _.each(day.lines, function(line) {
                        if (line.unit_amount !== 0) {
                            var tmp = _.clone(line);
                            tmp.id = undefined;
                            _.each(line, function(v, k) {
                                if (v instanceof Array) {
                                    tmp[k] = v[0];
                                }
                            });
                            // we have to remove some keys, because analytic lines are shitty
                            _.each(_.keys(tmp), function(key) {
                                if (auth_keys[key] === undefined) {
                                    tmp[key] = undefined;
                                }
                            });
                            ops.push(tmp);
                        }
                    });
                });
            });
            return ops;
        },
        sync: function() {
            var self = this;
            self.setting = true;
            self.set({sheets: this.generate_o2m_value()});
            self.setting = false;
        },
        //converts hour value to float
        parse_client: function(value) {
            return instance.web.parse_value(value, {type: "float_time"});
        },
        //converts float value to hour
        format_client: function(value) {
            return instance.web.format_value(value, {type: "float_time"});
        },
    });
    instance.web.form.custom_widgets.add('comparison_widget', 'instance.ierp_purchase_comparison.Comparison');
};
