# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2014 iERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : iERP@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp

class building_building(osv.osv):
    _name = 'building.building'
    _description = "building number"
    _columns = {
                'name':fields.char('Building number'),
                'project_id':fields.many2one('project.project','Project'),
                'to_commission_season':fields.many2one('to.commission.season','To Commission season'),
                'door_ids':fields.one2many('product.product','building_id','Doors', readonly=True),
                'furniture':fields.many2one('building.furniture', 'Furniture'),
                'gear':fields.many2one('building.gear', 'Gear information'),
                'dedication_id': fields.many2many('building.dedication', 'building_dedication_rel', 'building_id', 'dedication_id', 'Dedication'),
                'choice_start_date': fields.date('Choice start date'),
                'choice_end_date': fields.date('Choice end date'),
                'apartment_square': fields.float('Apartment square'),
                'garage_square': fields.float('Garage square'),
                'object_square': fields.float('Object square'),
                
                'ois_length':fields.float('Ois length', help=u'Барилгын уртын ойсорх хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Урт ойсорх
                'inside_wall_length':fields.float('Inside wall length', help=u'Барилгын уртын дотор ханаас авсан хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Урт дотор ханаас
                'outside_wall_length':fields.float('Outside wall length', help=u'Барилгын уртын гадна хананаас авсан хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Урт гадна хананаас
                'ois_width':fields.float('Ois width', help=u'Барилгын өргөний ойсорх хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Өргөн ойсоорх
                'inside_wall_width':fields.float('Inside wall width', help=u'Барилгын өргөний дотор ханаас авсан хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Өргөн дотор ханаас
                'outside_wall_width':fields.float('Outside wall width', help=u'Барилгын өргөний гадна хананаас авсан хэмжээг бүхэл болон бутархай тоо ашиглаж оруулах боломжтой'), #Өргөн гадна ханаас
                'building_heigth':fields.float('Heigth', help=u'Барилгын нийт уртыг бүхэл болон бутархай тоо  ашиглан оруулах боломжтой'), #Барилгын хэмжээ - Өндөр          
                'building_floor_number':fields.integer('Floor number', help=u'Давхрын тоог оруулна'), #Давхрын тоо
                'building_door_number':fields.integer('Doors number', help=u'Тухайн барилгын хүчин чадлыг  харгалзах хэмжих нэгжинд нь тааруулж бүхэл болон бутархай тоогоор оруулах боломжтой'), #Айлын тоо, хүчин чадал
                
                
                }
    
class to_commission_season(osv.osv):
    _name = "to.commission.season"
    _columns = {
                'name':fields.char('To commission season')
                }
    
class building_furniture(osv.osv):
    _name = "building.furniture"
    _columns = {
                'name':fields.char('Furniture'),
                'description': fields.text('Description')
                }

class building_gear(osv.osv):
    _name = "building.gear"
    _columns = {
                'name':fields.char('Gear information'),
                'description': fields.text('Description')
                }
    
class town_location(osv.osv):
    _name = 'town.location'
    _description = "Town location"
    _columns = {
                'name':fields.char('Town location'),
                }
        
class building_dedication(osv.osv):
    _name = "building.dedication"
    _description = "Building dedication"
    
    _columns = {
                'name': fields.char('Location name'),
                'building_id':fields.many2one('building.building','Building', invisible=True, readonly = True),
                }  
        
