from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp

class change_entry(osv.osv):
    _name = 'change.entry'
    _description = "Change entry"
    _columns = {
                'name':fields.char('Name',required=True),
                'project_id':fields.many2one('project.project', 'Project'),
                'customer_id':fields.many2one('res.partner', 'Customer'),
                'building_id':fields.many2one('building.building', 'Building'),
                'door_id':fields.many2one('product.product', 'Door'),
                'floor':fields.char('Floor'),
                'request_type': fields.selection([
                                    ('mba', 'MBA'),
                                    ('ba', 'BA'),                                    
                                    ], 'Request type', select=True, required=True),
                'total_squaring':fields.float('Total Squar'),
                'designer_id':fields.many2one('hr.employee', 'Designer'),
                'start_date':fields.datetime('Start Date'),
                'respondent':fields.many2one('hr.employee', 'Respondent'),
                'end_date':fields.datetime('End Date'),
                'request':fields.text('Request'),
                'solution':fields.text('Solution'),
                'building_note':fields.text('Building note'),
                'state': fields.selection([
                                    ('new', 'New'),
                                    ('solution', 'Solution'),
                                    ('done','Done'),
                                    ('cancel','Cancel'),                                    
                                    ], 'State', select=True, readonly=True),                              
                }
    
    
    _defaults = {
                 'state': 'new',
                 'start_date': lambda obj, cr, uid, context: time.strftime('%Y-%m-%d'),
                'designer_id': lambda obj, cr, uid, context: uid, 
                }
    
    def action_cancel(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'cancel'})
        return True

    def action_to_done(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'done'})
        return True
    
    def action_to_new(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'new'})
        return True
    
    def action_to_solution(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'solution'})
        return True
    
    def onchange_floor_squar(self, cr, uid, ids, door_id,context=None):
        res = {}
        
        obj = self.browse(cr, uid,ids)
        pro_obj = self.pool.get('product.product')
        if door_id:
            task = pro_obj.browse(cr, uid, pro_obj.search(cr, uid, [('id','=',door_id)]))[0]
          
            
            res['floor']=task.floor
            res['total_squaring']=task.total_squaring
           
            
        return {'value':res}