# -*- coding: utf-8 -*-

from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp

class choice_entry(osv.osv):
    _name = 'choice.entry'
    _description = "Choice entry"
    _columns = {
                'name':fields.char('Name',required=True),
                'designer_id':fields.many2one('res.users', 'Designer'),
                'manager_id':fields.many2one('res.users', 'Sales manager'),
                'customer_id':fields.many2one('res.partner', 'Customer'),
                'project_id':fields.many2one('project.project', 'Project'),
                'building_id':fields.many2one('building.building', 'Building'),
                'door_id':fields.many2one('product.product', 'Door'),
                'counted_date':fields.date('Counted date'),
                'choice_date':fields.date('Choice to expiration date'),
                'choice_date_end':fields.date(''),
                'choiced_date':fields.date('Choiced date'),
                'choice_entry_line_id':fields.one2many('choice.entry.line','choice_entry_id','Choice entry line'),
                'change_choice_entry_line_id':fields.one2many('changed.choice.entry.line','choice_entry_id','Changed choice entry line'),
                'choice_block_id':fields.many2one('choice.block','Choice block'),
                'call_date':fields.datetime('Call date'),
                'sms_date':fields.datetime('SMS date'),
                'ceil_made':fields.many2one('ceil.made','Ceal made'),
                'reason_unchoiced':fields.text('Reason of unchoice'),
                'state': fields.selection([
                                    ('draft', 'Draft'),
                                    ('did_choice','Did choice'),
                                    ('confirm', 'Confirm'),
                                    ('cancel','Cancel'),
                                    ], 'State', select=True, readonly=True),
                }
    _defaults = {
                 'state': 'draft',
                 }
    
    def action_cancel_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True
    def onchange_choice_date(self, cr, uid, ids, building_id):
        buldate = self.pool.get('building.building').browse(cr, uid, building_id)
        return {'value':{'choice_date': buldate.choice_start_date,
                         'choice_date_end': buldate.choice_end_date}}

    def action_to_confirm(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        picking = self.pool.get('stock.picking')
        picking_type = self.pool.get('stock.picking.type')
        p_type = picking_type.browse(cr, uid, picking_type.search(cr, uid, [('code','=','internal')]))
        #print"asdasdasdadsasdasd", p_type[0].id, p_type[1].id
        loc = self.pool.get('stock.location') 
        move_lines = []
        if p_type[0].id:  
            for line in obj.choice_entry_line_id:
                if line.is_change == False:
                    move_lines.append((0, 0, {
                                        'product_id': line.product_id.id,
                                        'product_uom_qty': line.quantity,
                                        'product_uom': line.product_id.uom_id.id,
                                        'name': obj.name,
                                        'date': time.strftime('%Y-%m-%d %H:%M:%S'),
                                        'date_expected': time.strftime('%Y-%m-%d %H:%M:%S'),
                                        'invoice_state': 'none',
                                        'location_id': line.product_id.property_stock_inventory.id,
                                        'location_dest_id': line.product_id.property_stock_procurement.id,
                                        }))
     
            for line in obj.change_choice_entry_line_id:
                move_lines.append((0, 0, {
                                    'product_id': line.product_id.id,
                                    'product_uom_qty': line.quantity,
                                    'product_uom':line.product_id.uom_id.id,
                                    'name': obj.name,
                                    'date': time.strftime('%Y-%m-%d %H:%M:%S'),
                                    'date_expected': time.strftime('%Y-%m-%d %H:%M:%S'),
                                    'invoice_state': 'none',
                                    'location_id': line.product_id.property_stock_inventory.id,
                                    'location_dest_id': line.product_id.property_stock_procurement.id,
                                    }))            
     
            picking.create(cr, uid, {
                                    'partner_id': obj.customer_id.id,
                                    'date': time.strftime('%Y-%m-%d %H:%M:%S'),
                                    'min_date': time.strftime('%Y-%m-%d %H:%M:%S'),
                                    'origin': obj.name,
                                    'move_type': 'one',
                                    'invoice_state':'none',
                                    'priority': '1',
                                    'move_lines': move_lines,
                                    'picking_type_id': p_type[0].id,
                                    'state': 'draft',
                                     })
        
        self.write(cr, uid, ids, {'state': 'confirm',
                                  'counted_date': time.strftime('%Y-%m-%d')})
        return True
    
    def action_to_choice(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)
        ent_line = self.pool.get('choice.entry.line')
        block = self.pool.get('choice.block')
        ch_block = block.browse(cr, uid, block.search(cr, uid, [('id','=',obj.choice_block_id.id)]))
        for line in ch_block.line_id:
            ent_line.create(cr, uid, {
                                      'line_name': line.line_name.id,
                                      'room': line.room.id,
                                      'product_id': line.product_id.id,
                                      'choice_entry_id': obj.id,
                                      'quantity': line.quantity,
                                      })
        self.write(cr, uid, ids, {'state': 'did_choice'})
        return True
    
    def action_to_cancel(self, cr, uid, ids, context=None):
        
        self.write(cr, uid, ids, {'state': 'cancel'})
        return True
    
class choice_entry_line(osv.osv):
    _name = 'choice.entry.line'
    _description = "Choice entry"
    _columns = {
                'line_name':fields.many2one('choice.line.name','Line name', readonly=True),
                'room':fields.many2one('choice.room', 'Room'),               
                'product_id':fields.many2one('product.product','Product',readonly=True),
                'choice_entry_id':fields.many2one('choice.entry','Choice entry', readonly=True),
                'quantity':fields.float('Quantity'),
                'is_change':fields.boolean('Is Change'),
                'is_changed':fields.boolean('Is changed', readonly=True),
                }
    _defaults = {
                'is_change': False,
                'is_changed': False,
                 }
    
    def onchange_is_change(self, cr, uid, ids, is_change):
        obj = self.browse(cr, uid, ids)
        change = self.pool.get('changed.choice.entry.line')
        if is_change == True:
            change.create(cr, uid, {
                                'line_name': obj.line_name.id,
                                'room': obj.room.id,
                                'product_id': False,
                                'quantity': 0,
                                'choice_entry_id': obj.choice_entry_id.id,
                                })
            return {'value':{'is_changed': True}}
        
    
    
       
class changed_choice_entry_line(osv.osv):
    _name = 'changed.choice.entry.line'
    _description = "Changed choice entry"
    _columns = {
                'line_name':fields.many2one('choice.line.name','Line name', readonly=True),
                'room':fields.many2one('choice.room', 'Room'),               
                'product_id':fields.many2one('product.product','Product'),
                'choice_entry_id':fields.many2one('choice.entry','Choice entry', readonly=True),
                'quantity':fields.float('Quantity'),
                'reason_change':fields.text('Reason of change'),
                }
    
  
    
class choice_block(osv.osv):
    _name = 'choice.block'
    _description = "Choice block"
    _columns = {
                'name':fields.char('Name', required=True),
                'type':fields.many2one('door.type','Door type'),
                'project_id':fields.many2one('project.project', 'Project'),
                'line_id':fields.one2many('choice.block.line','choice_block_id','Choice line'),
                }
    
class choice_block_line(osv.osv):
    _name = 'choice.block.line'
    _description = "Choice block line"
    _columns = {
                'name':fields.char('Name'),
                'line_name':fields.many2one('choice.line.name','Line name'),
                'room':fields.many2one('choice.room', 'Room'),               
                'product_id':fields.many2one('product.product','Product'),             
                'quantity':fields.float('Quantity'),
                #'square_size':fields.char('Square size'),
                'choice_block_id':fields.many2one('choice.block','Choice block'),             
                }
    
class choice_line_name(osv.osv):
    _name = 'choice.line.name'
    _description = "Choice line name"
    _columns = {
                'name':fields.char('Line Name'),           
                }
    
class ceil_made(osv.osv):
    _name = 'ceil.made'
    _description = "Ceil made"
    _columns = {
                'name':fields.char('Name'),           
                }
    
class choice_room(osv.osv):
    _name = 'choice.room'
    _description = "Choice room"
    _columns = {
                'name':fields.char('Room name'),           
                }
