# -*- coding: utf-8 -*-







from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools.translate import _
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp




class crm_lead(osv.osv):
    _inherit='crm.lead'
    _columns = {
                'get_on_to_date':fields.date('Get on to date'),
                'how_contacted':fields.selection([('phone', 'Phone'),
                                                  ('office', 'Office'),
                                                  ('outside','Outside')], 'How contacted'), 
                'interest_project_id':fields.many2one('project.project','Interest project'),
                'interest_total_space':fields.float('Space'),
                'interest_object_type': fields.selection([
                    ('apartment', 'Apartment'),
                    ('garage', 'Garage'),
                    ('object', 'Object')
                    ], 'Interest object type'),                # Only used for type opportunity
                'building_id': fields.many2one('building.building','Building'),
                'door_id': fields.many2one('product.template', 'Door', domain="[('type', '=', 'apartment')]")
                }

    def create(self, cr, uid, vals, context=None):
        context = dict(context or {})
        if vals.get('type') and not context.get('default_type'):
            context['default_type'] = vals.get('type')
        if vals.get('section_id') and not context.get('default_section_id'):
            context['default_section_id'] = vals.get('section_id')
        if vals.get('user_id'):
            vals['date_open'] = fields.datetime.now()
        # context: no_log, because subtype already handle this
        create_context = dict(context, mail_create_nolog=True)
        if vals.get('type'):
            if vals['type'] == 'opportunity':
                if vals.get('interest_project_id') and vals.get('building_id') and vals.get('door_id'):
                    info=self.pool.get('sales.information')
                    information=info.browse(cr, uid, info.search(cr, uid, [('product_id','=',vals['door_id'])]))
                    #employee=self.pool.get('res.users')
                    #emp = employee.browse(cr, uid, employee.search(cr, uid, [('user_id', '=', vals['user_id'])]))
                    if information.state == 'speaking':
                        info.write(cr, uid, information.id,{
                                            'state': 'speaking',
                                            #'manager_id': [(4, vals['user_id'])],
                                            })
                    if information.state == 'unsold':
                        info.write(cr, uid, information.id,{
                                            'state': 'speaking',
                                            #'manager_id': [(6, 0, [vals['user_id']])],
                                            })                        
        return super(crm_lead, self).create(cr, uid, vals, context=create_context)

    def write(self, cr, uid, ids, vals, context=None):
        # stage change: update date_last_stage_update
        if 'stage_id' in vals:
            vals['date_last_stage_update'] = fields.datetime.now()
        if vals.get('user_id'):
            vals['date_open'] = fields.datetime.now()
        # stage change with new stage: update probability and date_closed
        if vals.get('stage_id') and not vals.get('probability'):
            onchange_stage_values = self.onchange_stage_id(cr, uid, ids, vals.get('stage_id'), context=context)['value']
            vals.update(onchange_stage_values)
        if vals.get('type'):
            if vals['type'] == 'opportunity':
                if vals.get('interest_project_id') and vals.get('building_id') and vals.get('door_id'):
                    info=self.pool.get('sales.information')
                    information=info.browse(cr, uid, info.search(cr, uid, [('product_id','=',vals['door_id'])]))
                    employee=self.pool.get('hr.employee')
                    emp = employee.browse(cr, uid, employee.search(cr, uid, [('user_id', '=', vals['user_id'])]))
                    if information.state == 'speaking':
                        info.write(cr, uid, information.id,{
                                            'state': 'speaking',
                                            'manager_id': [(4, vals['user_id'])],
                                            })
                    if information.state == 'unsold':
                        info.write(cr, uid, information.id,{
                                            'state': 'speaking',
                                            'manager_id': [(6, 0, [vals['user_id']])],
                                            })
        #obj = self.browse(cr, uid, ids[0])
        obj = self.browse(cr, uid,ids)
        if obj.type == 'opportunity':
            if vals.get('interest_project_id') and vals.get('building_id') and vals.get('door_id'):
                info=self.pool.get('sales.information')
                information=info.browse(cr, uid, info.search(cr, uid, [('product_id','=',vals['door_id'])]))
                #employee=self.pool.get('hr.employee')
                #emp = employee.browse(cr, uid, employee.search(cr, uid, [('user_id', '=', vals['user_id'])]))
                if information.state == 'speaking':
                    info.write(cr, uid, information.id,{
                                        'state': 'speaking',
                                        #'manager_id': [(4, vals['user_id'])],
                                        })
                if information.state == 'unsold':
                    info.write(cr, uid, information.id,{
                                        'state': 'speaking',
                                        #'manager_id': [(6, 0, [vals['user_id']])],
                                        })
                               
        return super(crm_lead, self).write(cr, uid, ids, vals, context=context)
    
    def case_mark_lost(self, cr, uid, ids, context=None):
        """ Mark the case as lost: state=cancel and probability=0
        """
        stages_leads = {}
        for lead in self.browse(cr, uid, ids, context=context):
          
            if lead.stage_id.id == 7:
                raise osv.except_osv(_('Анхааруулга!'),_("Энэ боломж ялагдсанаар тэмдэглэгдсэн байна!"))
                
            if lead.door_id:
                
                lead1=self.browse(cr, uid, self.search(cr, uid, [('door_id','=',lead.door_id.id)]))
                i = 0
                for lead_id in lead1:
                    if lead_id.stage_id.id != 7:
                        i += 1
                if i == 1:
                    info=self.pool.get('sales.information')
                    information=info.browse(cr, uid, info.search(cr, uid, [('product_id','=',lead.door_id.id)]))
                    info.write(cr, uid, information.id,{
                                        'state': 'unsold'
                                        })
            stage_id = self.stage_find(cr, uid, [lead], lead.section_id.id or False, [('probability', '=', 0.0), ('fold', '=', True), ('sequence', '>', 1)], context=context)
            if stage_id:
                if stages_leads.get(stage_id):
                    stages_leads[stage_id].append(lead.id)
                else:
                    stages_leads[stage_id] = [lead.id]
            else:
                raise osv.except_osv(_('Warning!'),
                    _('To relieve your sales pipe and group all Lost opportunities, configure one of your sales stage as follow:\n'
                        'probability = 0 %, select "Change Probability Automatically".\n'
                        'Create a specific stage or edit an existing one by editing columns of your opportunity pipe.'))
        for stage_id, lead_ids in stages_leads.items():
            self.write(cr, uid, lead_ids, {'stage_id': stage_id}, context=context)
        return True
    
    