# -*- coding: utf-8 -*-

from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp
from bsddb.dbtables import _columns

from dateutil.relativedelta import relativedelta
from xlwt import Workbook, Formula


class sale_business_plan(osv.osv):
    _name = 'sale.business.plan'
    _description = "Sales business plan"
    _inherit = ['mail.thread']
    
    _columns = {
                'name': fields.char('Name'),
                'project_id': fields.many2one('project.project','Project'),
                'start_date': fields.date('Start date'),
                'end_date': fields.date('End date'),
                'business_plan_tree_id': fields.one2many('sale.business.plan.line', 'business_plan_id', 'Business plan tree ids'),
                'state': fields.selection([('draft','Draft'),
                                           ('confirmed','Confirmed'),
                                           ('canceled','Canceled'),
                                           ('close', 'Close')], 'State', readonly=True),
                }
    
    _defaults = {
                 'start_date': lambda self, cr, uid, context={}: context.get('start_date', time.strftime("%Y-%m-%d")),
                 'state': 'draft',
                }
    
    def action_cancel_draft(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True
    
    def action_to_confirm(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'confirmed'})
        return True

    def action_to_cancel(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'canceled'})
        return True

    def action_to_close(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        tree = self.pool.get('sale.business.plan.tree')
        contract = self.pool.get('account.analytic.account')
        new_date_start = time.strftime('%Y-%m-%d')
        new_date_end = time.strftime('%Y-%m-%d')
        new_date_start[0:4] = new_date_start[0:4]

        new_plan = self.create(cr, uid, {
                                         'name': 'Засах',
                                         'project_id': obj.project_id.id,
                                         'start_date': new_date_start,
                                         'end_date': new_date_end,
                                         'state': 'draft',
                                         })
        for line in obj.business_plan_tree_id:
            con = contract.browse(cr, uid , contract.search(cr, uid, [('door_id', '=', line.door_id.id)]))
            if con.state == 'pending':
                print 'sssssssssss'
                #===============================================================
                # tree.create(cr, uid, {
                #                       'building_id': ,
                #                       'door_id':,
                #                       'entrance':,
                #                       'floor':,
                #                       'door_price':,
                #                       'average_discount':,
                #                       'planned_contract_amount':,
                #                       'total_square':,
                #                       'business_plan_id':,
                #                       })
                #===============================================================
        self.write(cr, uid, ids, {'state': 'canceled'})
        return True
    
    def create(self, cr, uid, vals, context=None):
        cont = self.pool.get('account.analytic.account')
        contract = cont.browse(cr, uid, cont.search(cr, uid, [('state', '=', 'pending'),('general_type', '=', 'sales'),('sale_contract_type','!=','lease')]))
        plan_line = []
        date = time.strftime("%Y-%m-%d")
        year = int(date[0:4])
        next_date = str(year+1)+'-'+str('01')+'-'+str('01')
        plan_line = vals['business_plan_tree_id']
        for line in contract:
            amount = 0
            for line1 in line.sale_payment_schedule_id:
                if line1.date > next_date:
                    amount = amount + line1.amount

            plan_line.append((0, 0, {
                                        'building_id': line.sale_building_id.id,
                                        'door_id': line.sale_door_id.id,
                                        'entrance': line.sale_door_id.entrance,
                                        'floor': line.sale_door_id.floor,
                                        'door_price': 0,
                                        'average_discount': 0,
                                        'planned_contract_amount': amount,
                                        'total_square': line.sale_door_id.total_squaring,
                                        'houseroom': line.sale_door_id.houseroom,
                                        'is_old': True,
                                        }))
        vals['business_plan_tree_id'] = plan_line
        print "ssssssss", vals['business_plan_tree_id']
        return super(sale_business_plan, self).create(cr, uid, vals, context=context)
    
    def write(self, cr, uid, ids, vals, context=None):
        return super(sale_business_plan,self).write(cr, uid, ids,vals, context=context)

class sale_business_plan_line(osv.osv):
    _name = 'sale.business.plan.line'
    _description = "Sales business plan tree"
    
    _columns = {
                'building_id': fields.many2one('building.building', 'Building', required=True),
                'door_id': fields.many2one('product.template', 'Door', required=True),
                'entrance': fields.integer('Entrance'),
                'floor': fields.integer('Floor'),
                'door_price': fields.integer('Door price'),
                'average_discount': fields.float('Average discount'),
                'planned_contract_amount': fields.integer('Planned contract amount'),
                'total_square': fields.float('Total square'),
                'houseroom': fields.float('Houseroom'),
                'business_plan_id': fields.many2one('sale.business.plan', 'Business plan'),
                'period_id': fields.many2one('account.period', 'Period'),
                'is_old': fields.boolean('Is old', readonly=True),
                }
        
    def write(self, cr, uid, ids, vals, context=None):
        amount = 0
        res = {}
        obj = self.browse(cr, uid, ids)[0]
        if 'average_discount' in vals:
            amount = obj.door_price - ((obj.door_price/100)*vals['average_discount'])
            vals.update({'planned_contract_amount':amount})
        return super(sale_business_plan_line,self).write(cr, uid, ids,vals, context=context)
    
    def onchange_door(self, cr, uid, ids, door_id, context=None):
        door=self.pool.get('product.template')
        building=self.pool.get('building.building')
        res = {}
        print door_id
        if door_id:
            door_obj=door.browse(cr, uid, door.search(cr, uid, [('id','=',door_id)]))[0]
            if door_obj:
                res = {'entrance': door_obj.entrance,
                       'floor': door_obj.floor,
                       'door_price': door_obj.list_price,
                       'total_square': door_obj.total_squaring,
                       'houseroom': door_obj.houseroom,
                          }
        return {'value': res}
    
    def onchange_discount(self, cr, uid, ids, average_discount, door_price, context=None):
        res = {}
        amount = door_price - door_price*average_discount/100
        res = {'planned_contract_amount': amount,}
        return {'value': res}
    
            
