# -*- coding: utf-8 -*-

from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp

class hr_employee_inherit(osv.osv):
    _inherit = 'hr.employee'
    _columns = {
                'sales_information_id': fields.many2one('sales.information','Sales information'),
                }
    
class sales_information(osv.osv):
    _name = 'sales.information'
    _description = "Sales information"
    _inherit = ['mail.thread']
    
    _columns = {
                'product_id': fields.many2one('product.template','Product', readonly = True),
                'manager_id': fields.many2many('res.users', 'sales_information_manager_rel', 'sales_information_id', 'manager_id', 'Sales Managers', readonly = True),
                'date': fields.date('Date', readonly = True),
                'to_commission_season':fields.many2one('to.commission.season','To Commission season', readonly = True),
                'windows_location':fields.many2many('windows.location', 'windows_location_information_rel','information_id','windows_location', 'Windows location', readonly = True),
                'floor':fields.integer('Floor', readonly = True),
                'entrance':fields.integer('Entrance', readonly = True),
                'building_id':fields.many2one('building.building','Building', readonly = True),
                'total_squar':fields.float('Total square', readonly = True),
                'houseroom':fields.float('Houseroom', readonly = True),
                'project_id':fields.many2one('project.project', 'Project', readonly = True),
                'state': fields.selection([
                                    ('unsold', 'Unsold'),
                                    ('not_sell','Not sell'),
                                    ('speaking','Speaking'),
                                    ('pignorate', 'Pignorated'),
                                    ('sold', 'Sold'),
                                    ], 'State', select=True, readonly = True),
                }
    _defaults = {
                 'date': lambda *a: time.strftime('%Y-%m-%d'),
                 }
    
    def onchange_product(self, cr, uid, ids, product_id, context=None):
        product=self.pool.get('product.template')
        res = {}
        if product_id:
            pro_obj=product.browse(cr, uid, product.search(cr, uid, [('id','=',product_id)]))[0]
            if pro_obj:
                bui_obj=building.browse(cr, uid,  pro_obj.building_id.id)
                res = {
                          'floor': pro_obj.floor,
                          'windows_location': pro_obj.windows_location,
                          'total_squar': pro_obj.total_squaring,
                          'houseroom': pro_obj.houseroom,
                       }
            
        return {'value': res}
    
    def onchange_building(self, cr, uid, ids, building_id, context=None):
        building=self.pool.get('building.building')
        res = {}
        if building_id:
            bui_obj=building.browse(cr, uid, building.search(cr, uid, [('id','=',building_id)]))[0]
            if bui_obj:
                res = {
                          'to_commission_season': bui_obj.to_commission_season,
                          }
            
        return {'value': res}

    
    def action_cancel_unsold(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'unsold'})
        return True
    
    def action_to_not_sell(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'not_sell'})
        return True
    
    def action_to_pignorate(self, cr, uid, ids, context=None):
        print "sssssssssssss", uid
        self.write(cr, uid, ids, {'state': 'pignorate',
                                  'manager_id': [(6, 0, [uid])],
                                  })
        return True
    
    def action_to_sold(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'sold'})
        return True
    
    def pignorate_to_unsold(self, cr, uid, ids, context=None):
        inf = self.pool.get('sales.information')
        date = time.strftime('%Y-%m-%d')
        now_year = date[0:4]
        now_day = time.strftime('%Y-%m-%d')[8:10]
        now_month = time.strftime('%Y-%m-%d')[5:7]
        current_month = now_month - 1
        current_day = now_day-7
        if current_day > 0:
            date[8:10]=current_day
        else:
            if current_month == 0:
                date[0:4]= now_year-1
                date[5:7]= 12
                date[8:10]= 31+current_day
            else:
                date[5:7] = current_month
                if current_month == 1 or 3 or 5 or 7 or 8 or 10 or 0:
                    date[8:10] = 31 + current_day
                if current_month == 4 or 6 or 9 or 11:
                    date[8:10] = 30 + current_day
                if current_month == 2:
                    if now_year%400 == 0:
                        date[8:10]= 29-current_day
                    else:
                        if now_year%100==0:
                            date[8:10]= 28 -current_day
                        else:
                            if now_year%4 == 0:
                                date[8:10]= 29-current_day
                            else:
                                date[8:10]= 28 -current_day
        information = inf.search(cr, uid, [('write_date','<=',date)])
        for line in information:
            info = inf.browse(cr, uid, line)
            inf.write(cr, uid, info, {
                                      'state': 'unsold',
                                      })
        return True
