# -*- coding: utf-8 -*-

from openerp import netsvc
from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
import openerp.addons.decimal_precision as dp
import time

class sales_week_report(osv.osv):
    _name = 'sales.week.report'
    _description = "Week report"
    _columns = {
                'name':fields.char('Name'),
                'project_id':fields.many2one('project.project','Project'),
                'designer_id':fields.many2one('res.users','Designer'),
                'start_date':fields.date('Start date'),
                'end_date':fields.date('End date'),
                'phoning_size':fields.integer('Phoning size', readonly=True),
                'messaging_id':fields.integer('Messaging size', readonly=True),
                'process_size':fields.integer('Process size', readonly=True),
                'measure':fields.integer('Measure', readonly=True),
                'obtrusion_size':fields.integer('Obtrusion size', readonly=True),
                'decided_partner_size':fields.integer('Decided partner size', readonly=True),
                'undecided_partner_size':fields.integer('Undecided partner size', readonly=True),
                }
    _defaults = {
                 }
    
    def create(self, cr, uid, vals, context=None):
        if vals.get('project_id') and vals.get('designer_id') and vals.get('start_date') and vals.get('end_date'):
            phone = self.pool.get('crm.phonecall')
            phonecall = phone.browse(cr, uid, phone.search(cr, uid, [('categ_id','=', 10),('user_id','=',vals['designer_id']),('project_id','=',vals['project_id'])]))
            count_phone = 0
            count_message = 0
            for line in phonecall:
                #===============================================================
                # cr.execute("select substring(to_char(date, 'YYYY-MM-DD'), 1, 10) as date from crm_phonecall where id = %s" %(line.id))
                # calls = cr.fetchall()
                #===============================================================
                date = time.strftime('%Y-%m-%d', time.strptime(line.date,'%Y-%m-%d %H:%M:%S'))
                #print "datedatedate", date
                if vals['start_date'] <= date and date <=vals['end_date']:
                    if line.phone_type == 'phone':
                        count_phone = count_phone +1
                    if line.phone_type == 'message':
                        count_message = count_message + 1
            count_choiced = 0
            choice = self.pool.get('choice.entry')
            #print 'ssssssssssss', vals['start_date'], vals['end_date']
            ch_entry_id = choice.search(cr, uid, [('choiced_date','>=',vals['start_date']),('choiced_date','<=',vals['end_date'])])
            
            count_unchoiced = 0
            if ch_entry_id !=[]:
                ch_entry = choice.browse(cr, uid, ch_entry_id)
                for line in ch_entry:
                    count_choiced = count_choiced + 1
                co = self.pool.get('account.analytic.account')
                
                contract = co.browse(cr, uid, co.search(cr, uid, [('state','=','pending'),('general_type','=','sales')]))
                for line in contract:
                    entry = choice.browse(cr, uid, choice.search(cr, uid, [('door_id','=', line.door_id.id)]))
                    if entry.state != 'counted':
                        count_unchoiced = count_unchoiced + 1
            
                        #Барилга орсон тэмдэглэл
            
            note = self.pool.get('building.note')
            bui_note = note.browse(cr, uid, note.search(cr, uid, [('designer_id','=',vals['designer_id']),('project_id','=',vals['project_id'])]))
            count_process = 0
            count_obtrusion = 0
            count_measure = 0
            for line in bui_note:
                date1 = time.strftime('%Y-%m-%d', time.strptime(line.date,'%Y-%m-%d %H:%M:%S'))
                if vals['start_date'] <= date1 and date1 <=vals['end_date']:
                    if line.note_type == 'process':
                        count_process = count_process + 1
                    if line.note_type == 'obtrusion':
                        count_obtrusion = count_obtrusion + 1
                    if line.note_type == 'measure':
                        count_measure = count_measure + 1
            vals['phoning_size'] = count_phone
            vals['messaging_id'] = count_message
            vals['decided_partner_size'] = count_choiced
            vals['undecided_partner_size'] = count_unchoiced
            vals['process_size'] = count_process
            vals['measure'] = count_obtrusion
            vals['obtrusion_size'] = count_measure
        week_report = super(sales_week_report, self).create(cr, uid, vals, context=context)
        return week_report
    
    


    
    
    
    