# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class building_info(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "building.info"
    _description = "Building info"
    
    _columns = {
       'project_id': fields.many2one('account.analytic.account', 'Project', required=True),
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        
        cr.execute("""select t.name, t.id from account_analytic_account as t 
                             left join project_project as p on p.analytic_account_id = t.id
                             where t.id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
        
      
      
 
        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['id']
        
        
       
        sheet.write_merge(1, 1, 0, 3, u'Байрны мэдээлэл:', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(3, 3, 0, 2, u'Төслийн нэр:',style_noborder)
        sheet.write_merge(3, 3, 3, 3, u'%s' %project_info['name'],style_noborder)
        sheet.write_merge(5, 6, 0, 0, u'№',stylebr1) 
        sheet.write_merge(5, 6, 1, 1, u'Байрны дугаар',stylebr1)
        sheet.write_merge(5, 6, 2, 2, u'Давхар',stylebr1)
        sheet.write_merge(5, 6, 3, 3, u'Төрөл',stylebr1)
        sheet.write_merge(5, 6, 4, 4, u'Орцны дугаар',stylebr1)
        sheet.write_merge(5, 6, 5, 5, u'Хаалганы дугаар',stylebr1)
        sheet.write_merge(5, 6, 6, 6, u'Загварын дугаар',stylebr1)
        sheet.write_merge(5, 6, 7, 7, u'Талбайн хэмжээ',stylebr1)
        sheet.write_merge(5, 6, 8, 8, u'Өрөөний тоо',stylebr1)
        sheet.write_merge(5, 6, 9, 9, u'АЦӨ-ний тоо',stylebr1)
        sheet.write_merge(5, 6, 10, 10, u'Цонхны байршил',stylebr1)
        sheet.write_merge(5, 6, 11, 11, u'Тавилга',stylebr1)
        sheet.write_merge(5, 6, 12, 12, u'Тоноглолын мэдээлэл',stylebr1)
        sheet.write_merge(5, 6, 13, 13, u'Зарагдсан эсэх',stylebr1)
        
        i = 7
        cr.execute("""SELECT 
                      account_analytic_account.id
                      FROM 
                      account_analytic_account 
                      WHERE 
                      account_analytic_account.parent_id = %s"""%(data['project_id'][0]))
       
        lg_parent  = cr.dictfetchall()
        #print 'looog', lg_parent
        for idss in lg_parent:
            #print 'looooooog123' , idss
            project_obj = self.pool.get('project.project')
            project_parent = project_obj.search(cr,uid,[('analytic_account_id','=',idss['id'])])
            parent_id = project_obj.browse(cr,uid,project_parent)
            #print 'parent_idddddddddd',parent_id.id,project_parent
            if parent_id.id != False:
                cr.execute("""select b.name as bname, pt.floor as floor, pt.entrance as orts, pt.room_size as room,
                                     pt.name as toot,pt.asset_type as asset,pt.door_type as zagvar,pt.total_squaring as talbai,
                                     pt.atso as atso, wl.name as tsonh,bf.name as tavilga, bg.name as tonoglol, si.state as state
                                         from 
                                            building_building as b,
                                            product_template as pt,
                                            project_project as p,
                                            building_furniture as bf,
                                            building_gear as bg,
                                            sales_information as si,
                                            windows_location as wl,
                                            windows_location_rel as wlr
                                          where pt.project_id = %s
                                            and b.id = pt.building_id 
                                            and p.id = b.project_id 
                                            and bf.id = b.furniture 
                                            and bg.id = b.gear 
                                            and si.product_id = pt.id
                                            and pt.id = wlr.door_id
                                            and wl.id = wlr.windows_location
                                            order by b.id ASC"""%parent_id.id)
                                               
                project_info  = cr.dictfetchall()
                
                k = 1
                if project_info != []:
                    for line1 in project_info:
                        #------------------------------- print 'tttttttteeeeeeeb', line1
                            sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                            
                            if line1['bname'] == None:
                                sheet.write(i, 1, u'', style_table)
                            else:
                                sheet.write(i, 1, u'%s' %line1['bname'], stylebr)
                                
                            if line1['floor'] == None:
                                sheet.write(i, 2, u'', style_table)
                            else:
                                sheet.write(i, 2, u'%s' %line1['floor'], stylebr)
                            if line1['toot'] == None:
                                sheet.write(i, 5, u'', style_table)
                            else:
                                sheet.write(i, 5, u'%s' %line1['toot'], stylebr)
                            if line1['orts'] == None:
                                sheet.write(i, 4, u'', style_table)
                            else:
                                sheet.write(i, 4, u'%s' %line1['orts'], stylebr)
                            if line1['room'] == None:
                                sheet.write(i, 8, u'', style_table)
                            else:
                                sheet.write(i, 8, u'%s' %line1['room'], stylebr)
                            if line1['atso'] == None:
                                sheet.write(i, 9, u'', style_table)
                            else:
                                sheet.write(i, 9, u'%s' %line1['atso'], stylebr)
                            if line1['asset'] == None:
                                sheet.write(i, 3, u'', style_table)
                            else:
                                sheet.write(i, 3, u'%s' %line1['asset'], stylebr)
                            if line1['talbai'] == None:
                                sheet.write(i, 7, u'', style_table)
                            else:
                                sheet.write(i, 7, u'%s' %line1['talbai'], stylebr)
                            if line1['zagvar'] == None:
                                sheet.write(i, 6, u'', style_table)
                            else:
                                sheet.write(i, 6, u'%s' %line1['zagvar'], stylebr)
                            if line1['tavilga'] == None:
                                sheet.write(i, 11, u'', style_table)
                            else:
                                sheet.write(i, 11, u'%s' %line1['tavilga'], stylebr)
                            if line1['tonoglol'] == None:
                                sheet.write(i, 12,u'', style_table)
                            else:
                                sheet.write(i, 12, u'%s' %line1['tonoglol'], stylebr)
                            if line1['tsonh'] == None:
                                sheet.write(i, 10,u'', style_table)
                            else:
                                 sheet.write(i, 10, u'%s' %line1['tsonh'], stylebr)
                            if line1['state'] == None:
                                sheet.write(i, 13,u'', style_table)
                            else:
                                sheet.write(i, 13, u'%s' %line1['state'], stylebr)
                    
                            i = i + 1
                            k = k + 1
                       
              
               
                 
              
                inch = 1000
                sheet.col(0).width = 500
                sheet.col(1).width = 2*inch
                sheet.col(2).width = 2*inch #shirheg
                sheet.col(3).width = 3*inch
                sheet.col(4).width = 3*inch
                sheet.col(5).width = 3*inch
                sheet.col(6).width = 3*inch
                sheet.col(7).width = 2*inch
                sheet.col(8).width = 3*inch
                sheet.col(9).width = 2*inch
                sheet.col(10).width = 3*inch
                sheet.col(11).width = 2*inch
                sheet.col(12).width = 3*inch
                sheet.col(13).width = 3*inch
                
         
        
    
        return {'data':book}

building_info()