# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from datetime import date, timedelta, datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class cash_flow_detailed_plan(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "cash.flow.detailed.plan"
    _description = "Cash flow detailed plan"
    
    _columns = {
        'project_id': fields.many2one('account.analytic.account', 'Project', required=True),
        'year': fields.integer('Year', size = 4)
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        
        cr.execute("""select a.name, a.id from account_analytic_account as a 
                             left join project_project as p on p.analytic_account_id = a.id
                             where a.id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
          
        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['id']
        today = date.today()
        
        sheet.write_merge(1, 1, 1, 10, u'Төслийн борлуулалтын гэрээнээс орох мөнгөн урсгалын дэлгэрэнгүй төлөвлөгөө, гүйцэтгэл, хоцрогдол', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(3, 3, 1, 1, u'Төслийн нэр:',style_noborder)
        sheet.write_merge(3, 3, 4, 5, u'%s' %project_info['name'],style_noborder)
        sheet.write_merge(3, 3, 11, 11, u'Огноо:',style_noborder)
        sheet.write_merge(3, 3, 12, 12, u'%s' %data['year'], style_noborder)
        sheet.write_merge(3, 3, 21, 22, u'Огноо:',style_noborder)
        sheet.write_merge(3, 3, 23, 24, u'%s' %today, style_noborder)
        sheet.write_merge(5, 8, 0, 0, u'№',stylebr1) 
        sheet.write_merge(5, 8, 1, 1, u'Байрны дугаар',stylebr1)
        sheet.write_merge(5, 8, 2, 2, u'Давхар',stylebr1)
        sheet.write_merge(5, 8, 3, 3, u'Төрөл',stylebr1)
        sheet.write_merge(5, 8, 4, 4, u'Хаалганы дугаар',stylebr1)
        sheet.write_merge(5, 8, 5, 5, u'Талбайн хэмжээ',stylebr1)
        sheet.write_merge(5, 8, 6, 6, u'Гэрээний дугаар',stylebr1)
        sheet.write_merge(5, 8, 7, 7, u'Менежер',stylebr1)
        sheet.write_merge(5, 8, 8, 8, u'Түрээслэх сар',stylebr1)
        sheet.write_merge(5, 8, 9, 9, u'Гэрээний үнэ (Төг)',stylebr1)
        sheet.write_merge(5, 8, 10, 10, u'Нийт төлөгдсөн төлбөр (Төг)',stylebr1)
        sheet.write_merge(5, 8, 11, 11, u'Нийт төлөгдсөн төлбөр (Хувиар)',stylebr1)
        sheet.write_merge(5, 8, 12, 12, u'Үлдэгдэл төлбөр (Төг)',stylebr1)
        
        sheet.write_merge(5, 5, 13, 15, u'1-р сар',stylebr1)
        sheet.write_merge(5, 5, 16, 18, u'2-р сар',stylebr1)
        sheet.write_merge(5, 5, 19, 21, u'3-р сар',stylebr1)
        sheet.write_merge(5, 5, 22, 24, u'4-р сар',stylebr1)
        sheet.write_merge(5, 5, 25, 27, u'5-р сар',stylebr1)
        sheet.write_merge(5, 5, 28, 30, u'6-р сар',stylebr1)
        sheet.write_merge(5, 5, 31, 33, u'7-р сар',stylebr1)
        sheet.write_merge(5, 5, 34, 36, u'8-р сар',stylebr1)
        sheet.write_merge(5, 5, 37, 39, u'9-р сар',stylebr1)
        sheet.write_merge(5, 5, 40, 42, u'10-р сар',stylebr1)
        sheet.write_merge(5, 5, 43, 45, u'11-р сар',stylebr1)
        sheet.write_merge(5, 5, 46, 48, u'12-р сар',stylebr1)
        sheet.write_merge(6, 8, 13, 13, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 14, 14, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 15, 15, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 16, 16, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 17, 17, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 18, 18, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 19, 19, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 20, 20, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 21, 21, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 22, 22, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 23, 23, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 24, 24, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 25, 25, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 26, 26, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 27, 27, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 28, 28, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 29, 29, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 30, 30, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 31, 31, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 32, 32, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 33, 33, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 34, 34, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 35, 35, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 36, 36, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 37, 37, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 38, 38, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 39, 39, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 40, 40, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 41, 41, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 42, 42, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 43, 43, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 44, 44, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 45, 45, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(6, 8, 46, 46, u'Хуваарь',stylebr1)
        sheet.write_merge(6, 8, 47, 47, u'Төлөлт',stylebr1)
        sheet.write_merge(6, 8, 48, 48, u'Хоцорсон төлөлт',stylebr1)
        sheet.write_merge(5, 5, 49, 50, u'Алданги',stylebr1)
        sheet.write_merge(6, 8, 49, 49, u'Захиалагчийн төлөх алданги',stylebr1)
        sheet.write_merge(6, 8, 50, 50, u'Компанийн төлөх алданги',stylebr1)
        i = 9
        j = 10
        r = 10
     
        cr.execute("""select a.id as aid, b.id as bid, a.name as tbair, a.code as code, b.name as bbair, a.sale_floor as davhar, 
                           pt.name as toot, pt.asset_type as asset, pt.total_squaring as talbai, ru.login as manager,
                           a.sale_door_amount as dun,a.sale_discount_type as distype,a.sale_discount,a.sale_lease_month as sar, sum(sps.amount) as amount, sps.state,sps.date as ydate,
                           a.sale_discounted_amount as discount
                          from
                            account_analytic_account as a,
                            building_building as b,
                            product_template as pt,
                            res_users as ru,
                            sales_payment_schedule as sps
                           where a.parent_id = %s
                               and a.general_type_2 = 'sales'
                               and a.sale_building_id = b.id
                               and a.sale_door_id = pt.id
                               and a.manager_id = ru.id
                               and b.id = pt.building_id
                               and a.id = sps.contract_id
                               
                           group by a.id, b.id, a.name, a.code, b.name, a.sale_floor, 
                           pt.name, pt.asset_type, pt.total_squaring, ru.login,
                           a.sale_door_amount,a.sale_discount_type,a.sale_discount,a.sale_lease_month,sps.state,sps.date,
                           a.sale_discounted_amount
                           order by b.id ASC"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
        k = 1
        if project_info != []:
            for line1 in project_info:
                
                numb = line1['ydate'][0:4]
                if data['year'] == int(numb):
                    
                    sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                    
                    if line1['bbair'] == None:
                        sheet.write(i, 1, u'', style_table)
                    else:
                        sheet.write(i, 1, u'%s' %line1['bbair'], stylebr)
                    if line1['davhar'] == None:
                        sheet.write(i, 2, u'', style_table)
                    else:
                        sheet.write(i, 2, u'%s' %line1['davhar'], stylebr)
                    if line1['asset'] == None:
                        sheet.write(i, 3, u'', style_table)
                    else:
                        sheet.write(i, 3, u'%s' %line1['asset'], stylebr)
                    if line1['toot'] == None:
                        sheet.write(i, 4, u'', style_table)
                    else:
                        sheet.write(i, 4, u'%s' %line1['toot'], stylebr)
                    if line1['talbai'] == None:
                        sheet.write(i, 5, u'', style_table)
                    else:
                        sheet.write(i, 5, u'%s' %line1['talbai'], stylebr)
                    if line1['code'] == None:
                        sheet.write(i, 6, u'', style_table)
                    else:
                        sheet.write(i, 6, u'%s' %line1['code'], stylebr)
                    if line1['manager'] == None:
                        sheet.write(i, 7, u'', style_table)
                    else:
                        sheet.write(i, 7, u'%s' %line1['manager'], stylebr)
                    if line1['sar'] == None:
                        sheet.write(i, 8, u'', style_table)
                    else:
                        sheet.write(i, 8, u'%s' %line1['sar'], stylebr)
                    if line1['dun'] == 0:
                        sheet.write(i, 9, 0, stylebr)
                        sheet.write(i, 10, 0, stylebr)
                        sheet.write(i, 11, 0, stylebr)
                        sheet.write(i, 12, 0, stylebr)
                        
                    else:
                        sheet.write(i, 9, line1['discount'], stylebr)
                        sheet.write(i, 10, line1['amount'], stylebr)
                        sheet.write(i, 11, Formula('$K$%d*100/$J$%d' % (r, r)), stylebr)
                        sheet.write(i, 12, Formula('$J$%d-$K$%d' % (j, j)), stylebr)
                       
                        r = r + 1
                        j = j + 1 
                
                    i = i + 1
                    k = k + 1
       
         
      
        inch = 1000
        sheet.col(0).width = 1000
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 2*inch #shirheg
        sheet.col(3).width = 2*inch
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 2*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 3*inch
        sheet.col(13).width = 3*inch
        sheet.col(14).width = 3*inch
        sheet.col(15).width = 3*inch
        sheet.col(16).width = 3*inch
        sheet.col(17).width = 3*inch
        sheet.col(18).width = 3*inch
        sheet.col(19).width = 3*inch
        sheet.col(20).width = 3*inch
        sheet.col(21).width = 3*inch
        sheet.col(22).width = 3*inch
        sheet.col(23).width = 3*inch
        sheet.col(24).width = 3*inch
        sheet.col(25).width = 3*inch
        sheet.col(26).width = 3*inch
        sheet.col(27).width = 3*inch
        sheet.col(28).width = 3*inch
        sheet.col(29).width = 3*inch
        sheet.col(30).width = 3*inch
        sheet.col(31).width = 3*inch
        sheet.col(32).width = 3*inch
        sheet.col(33).width = 3*inch
        sheet.col(34).width = 3*inch
        sheet.col(35).width = 3*inch
        sheet.col(36).width = 3*inch
        sheet.col(37).width = 3*inch
        sheet.col(38).width = 3*inch
        sheet.col(39).width = 3*inch
        sheet.col(40).width = 3*inch
        sheet.col(41).width = 3*inch
        sheet.col(42).width = 3*inch
        sheet.col(43).width = 3*inch
        sheet.col(44).width = 3*inch
        sheet.col(45).width = 3*inch
        sheet.col(46).width = 3*inch
        sheet.col(47).width = 3*inch
        sheet.col(48).width = 3*inch
        sheet.col(49).width = 3*inch
        sheet.col(50).width = 3*inch
        sheet.col(51).width = 4*inch
        sheet.col(52).width = 4*inch
        return {'data':book}

cash_flow_detailed_plan()