# -*- coding: utf-8 -*-
from datetime import date, timedelta, datetime
import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _

import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class cash_flow_sale_plan(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "cash.flow.sale.plan"
    _description = "Cash flow sale plan"
    
    _columns = {
        'project_id': fields.many2one('account.analytic.account', 'Project', required=True),
        'year': fields.integer('Year', size = 4)
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        style_noborder1 = ezxf('font: bold off, name Times New Roman, height 200; align: wrap off;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        
        cr.execute("""select a.name, a.id from account_analytic_account as a 
                             left join project_project as p on p.analytic_account_id = a.id
                             where a.id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
        
        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['id']
        today = date.today()
        
        sheet.write_merge(2, 2, 1, 8, u'Борлуулалтын төлөвлөгөөнөөс орох мөнгөн урсгалын төлөвлөгөө', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(4, 4, 1, 1, u'Төслийн нэр:',style_noborder)
        sheet.write_merge(4, 4, 3, 3, u'%s' %project_info['name'],style_noborder)
        sheet.write_merge(4, 4, 11, 11, u'Огноо:',style_noborder)
        sheet.write_merge(4, 4, 12, 13, u'%s' %today, style_noborder)
        sheet.write_merge(6, 7, 0, 0, u'№',stylebr1) 
        sheet.write_merge(4, 4, 15, 16, u'Тайланг харах он:',style_noborder)
        sheet.write_merge(4, 4, 17, 17, u'%s' %data['year'], style_noborder)
        sheet.write_merge(6, 7, 1, 1, u'Байрны дугаар',stylebr1)
        sheet.write_merge(6, 7, 2, 2, u'Давхар',stylebr1)
        sheet.write_merge(6, 7, 3, 3, u'Төрөл',stylebr1)
        sheet.write_merge(6, 7, 4, 4, u'Хаалганы дугаар',stylebr1)
        sheet.write_merge(6, 7, 5, 5, u'Талбайн хэмжээ',stylebr1)
        sheet.write_merge(6, 7, 6, 6, u'Түрээслэх сар',stylebr1)
        sheet.write_merge(6, 7, 7, 7, u'Гэрээний үнэ (Төг)',stylebr1)
        sheet.write_merge(6, 7, 8, 8, u'Урьдчилгаа хувь',stylebr1)
        sheet.write_merge(6, 7, 9, 9, u'Урьдчилгаа төлбөр',stylebr1)
        sheet.write_merge(6, 7, 10, 10, u'Үлдэгдэл төлбөр (Төг)',stylebr1)
        sheet.write_merge(6, 7, 11, 11, u'1-р сар',stylebr1)
        sheet.write_merge(6, 7, 12, 12, u'2-р сар',stylebr1)
        sheet.write_merge(6, 7, 13, 13, u'3-р сар',stylebr1)
        sheet.write_merge(6, 7, 14, 14, u'4-р сар',stylebr1)
        sheet.write_merge(6, 7, 15, 15, u'5-р сар',stylebr1)
        sheet.write_merge(6, 7, 16, 16, u'6-р сар',stylebr1)
        sheet.write_merge(6, 7, 17, 17, u'7-р сар',stylebr1)
        sheet.write_merge(6, 7, 18, 18, u'8-р сар',stylebr1)
        sheet.write_merge(6, 7, 19, 19, u'9-р сар',stylebr1)
        sheet.write_merge(6, 7, 20, 20, u'10-р сар',stylebr1)
        sheet.write_merge(6, 7, 21, 21, u'11-р сар',stylebr1)
        sheet.write_merge(6, 7, 22, 22, u'12-р сар',stylebr1)
        
        i = 8
        t = 9
        t1 = 9
        cr.execute("""select b.id,b.name as bname, pt.floor as floor,a.sale_door_amount as dun, a.sale_valid_contract_percent as sale_valid,
                                   pt.name as toot,pt.asset_type as asset,pt.total_squaring as talbai,a.sale_lease_month as sar,sl.planned_contract_amount as planned,ap.code as code1
                                from 
                                building_building as b,
                                product_template as pt,
                                project_project as p,
                                account_analytic_account as a,
                                sale_business_plan as s,
                                    sale_business_plan_line as sl,
                                    account_period as ap
                                   
                                  where a.parent_id = %s
                                and a.sale_door_id = pt.id
                                and a.general_type_2 ='sales'
                                and b.id = a.sale_building_id
                                and p.id = s.project_id
                                and s.id = sl.business_plan_id
                                and sl.period_id = ap.id
                                and  pt.id = sl.door_id
                                group by b.id, b.name, pt.floor,a.sale_door_amount,
                                       pt.name,pt.asset_type,pt.total_squaring,
                                       a.sale_contract_type, a.sale_lease_type, a.sale_lease_month,a.sale_valid_contract_percent,sl.planned_contract_amount,ap.code
                            order by b.id ASC"""%(data['project_id'][0]))
                   
        project_info  = cr.dictfetchall()
       
        k = 1
        
        if project_info != []:
            for line1 in project_info:
                numb = line1['code1'][3:7]
                if data['year'] == int(numb):
                    #===========================================================
                    # print 'pppppppppp',line1['code1'][3:7]
                    #===========================================================
                    sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                    
                    if line1['bname'] == None:
                        sheet.write(i, 1, u'', style_table)
                    else:
                        sheet.write(i, 1, u'%s' %line1['bname'], stylebr)
                    if line1['floor'] == None:
                        sheet.write(i, 2, u'', style_table)
                    else:
                        sheet.write(i, 2, u'%s' %line1['floor'], stylebr)
                    if line1['asset'] == None:
                        sheet.write(i, 3, u'', style_table)
                    else:
                        sheet.write(i, 3, u'%s' %line1['asset'], stylebr)
                    if line1['toot'] == None:
                        sheet.write(i, 4, u'', style_table)
                    else:
                        sheet.write(i, 4, u'%s' %line1['toot'], stylebr)
                    if line1['talbai'] == None:
                        sheet.write(i, 5, u'', style_table)
                    else:
                        sheet.write(i, 5, u'%s' %line1['talbai'], stylebr)
                    if line1['sar'] == None:
                        sheet.write(i, 6, u'', style_table)
                    else:
                        sheet.write(i, 6, u'%s' %line1['sar'], stylebr)
                    if line1['dun'] == None:
                        sheet.write(i, 7, u'', style_table)
                    else:
                        sheet.write(i, 7, u'%s' %line1['dun'], stylebr)
                        sheet.write(i, 8, Formula('$J$%d*100/$H$%d' % (t1, t1)), stylebr)
                    if line1['sale_valid'] == None:
                        sheet.write(i, 9, u'', style_table)
                    else:
                        sheet.write(i, 9, u'%s' %line1['sale_valid'], stylebr)
                        sheet.write(i, 10, Formula('$H$%d-$J$%d' % (t, t)), stylebr)
                        
               
                     
                    numa = line1['code1'][0:2]
                    print 'tttttttttttt',line1['code1'][0:2],numa
                    if  numa == '01':
                        sheet.write(i, 11, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '02':
                        sheet.write(i, 12, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '03':
                        sheet.write(i, 13, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '04':
                        sheet.write(i, 14, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '05':
                        sheet.write(i, 15, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '06':
                        sheet.write(i, 16, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '07':
                        sheet.write(i, 17, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '08':
                        sheet.write(i, 18, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '09':
                        sheet.write(i, 19, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '10':
                        sheet.write(i, 20, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '11':
                        sheet.write(i, 21, u'%s' %line1['planned'], style_noborder1)
                    elif numa == '12':
                        sheet.write(i, 22, u'%s' %line1['planned'], style_noborder1)
                    else:
                        pass
                    
                    i = i + 1
                    k = k + 1
                    t = t + 1
                    t1 = t1 + 1
       
        inch = 1000
        sheet.col(0).width = 1000
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 2*inch #shirheg
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 2*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 3*inch
       
     
     
        
    
        return {'data':book}

cash_flow_sale_plan()