# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class cash_flow_total_project(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "cash.flow.total.project"
    _description = "Cash flow total project"
    
    _columns = {
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        
        
       
        sheet.write_merge(1, 1, 1, 4, u'Нийт төслүүдийн борлуулалтаас орох мөнгөн орлого', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(3, 3, 1, 1, u'Төслийн нэр:',style_noborder)
        sheet.write_merge(3, 3, 4, 4, u'Огноо:',style_noborder)
        sheet.write_merge(5, 5, 0, 0, u'№',stylebr1) 
        sheet.write_merge(5, 5, 1, 1, u'Төсөл',stylebr1)
        sheet.write_merge(5, 5, 2, 2, u'Төрөл',stylebr1)
        sheet.write_merge(5, 5, 3, 3, u'Гэрээний байдал',stylebr1)
        sheet.write_merge(5, 5, 4, 4, u'2014-1',stylebr1)
        sheet.write_merge(5, 5, 5, 5, u'2014-2',stylebr1)
        sheet.write_merge(5, 5, 6, 6, u'2014-3',stylebr1)
        sheet.write_merge(5, 5, 7, 7, u'2014-4',stylebr1)
        sheet.write_merge(5, 5, 8, 8, u'2014-5',stylebr1)
        sheet.write_merge(5, 5, 9, 9, u'2014-6',stylebr1)
        sheet.write_merge(5, 5, 10, 10, u'2014-7',stylebr1)
        sheet.write_merge(5, 5, 11, 11, u'2014-8',stylebr1)
        sheet.write_merge(5, 5, 12, 12, u'2014-9',stylebr1)
        sheet.write_merge(5, 5, 13, 13, u'2014-10',stylebr1)
        sheet.write_merge(5, 5, 14, 14, u'2014-11',stylebr1)
        sheet.write_merge(5, 5, 15, 15, u'2014-12',stylebr1)
        
        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['code']
        i = 6
        
        cr.execute("""select s.contract_id, s.date, s.amount, s.loss,s.percent,
                        s.state, a.id as accid from sales_payment_schedule as s, 
                        account_analytic_account as a
                        where contract_id = a.id and
                        a.id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
        
        k = 1
        sum = 0
        for line1 in project_info:
            if line1['accid'] != None:
                sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                if line1['date'] == None:
                    sheet.write(i, 1, u'', style_table)
                else:
                    sheet.write(i, 1, u'%s' %line1['date'], stylebr)
                if line1['amount'] == None:
                    sheet.write(i, 2, u'', stylebr)
                else:
                    sheet.write(i, 2, u'%s' %line1['amount'], stylebr)
                    sum = sum + line1['amount']
                sheet.write(i, 3, u'', style_nodatatable)
                sheet.write(i, 4, u'', style_nodatatable)
              
                i = i + 1
                k = k + 1
            else:
                pass
      
       
         
      
        inch = 1000
        sheet.col(0).width = 1000
        sheet.col(1).width = 4*inch
        sheet.col(2).width = 4*inch #shirheg
        sheet.col(3).width = 4*inch
        sheet.col(4).width = 2*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 2*inch
        sheet.col(8).width = 2*inch
        sheet.col(9).width = 2*inch
        sheet.col(10).width = 2*inch
        sheet.col(11).width = 2*inch
        sheet.col(12).width = 2*inch
        sheet.col(13).width = 2*inch
        sheet.col(14).width = 2*inch
        sheet.col(15).width = 2*inch
       
     
        return {'data':book}

cash_flow_total_project()