# -*- coding: utf-8 -*-


import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class choice_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "choice.report"
    _description = "Choice report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'project_id': fields.many2one('project.project', 'Project', required=True),
        
    }
     
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        data = datas['form']
        
        
               
        #=======================================================================
        # cr.execute("select * from crm_lead as l where l.get_on_to_date >= '" +data['start_date']+"'and l.get_on_to_date <='" + data['end_date']+"'")
        # task_obj  = cr.dictfetchall()
        #=======================================================================
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz left; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('choice report')
       
        #=======================================================================
        # sheet.write(4, 1, u'Огноо:', ezxf('font: bold off;align:wrap off,vert centre;'))
        # sheet.write(4, 2, time.strftime('%Y-%m-%d'))
        #=======================================================================
        sheet.write_merge(4, 5, 0, 0, u'№', style_table_header)
        sheet.write_merge(4, 4, 1, 6, u'Барилгын тухай мэдээлэл', style_table_header)
        sheet.write_merge(4, 4, 7, 11, u'Захиалагчтай холбоотой мэдээлэл', style_table_header)
        sheet.write_merge(4, 4, 12, 13, u'Холбогдсон байдал', style_table_header)
        sheet.write(5, 1, u'Гэрээ хийсэн', style_table_header)
        sheet.write(5, 2, u'Барилга', style_table_header)
        sheet.write(5, 3, u'Давхар', style_table_header)
        sheet.write(5, 4, u'Тоот', style_table_header)
        sheet.write(5, 5, u'м2', style_table_header)
        sheet.write(5, 6, u'Өрөө', style_table_header)
        sheet.write(5, 7, u'Г/Дугаар', style_table_header)
        sheet.write(5, 8, u'Менежер', style_table_header)
        sheet.write(5, 9, u'Захиалагч', style_table_header)
        sheet.write(5, 10, u'Холбогдох утас', style_table_header)
        sheet.write(5, 11, u'И-мэйл', style_table_header)
        sheet.write(5, 12, u'Утсаар ярьсан', style_table_header)
        sheet.write(5, 13, u'SMS бичсэн', style_table_header)
        sheet.write_merge(4, 5, 14, 14, u'Сонгосон багц', style_table_header)
        sheet.write_merge(4, 5, 15, 15, u'Санал хүсэлт', style_table_header)
        
        rowx = 6
        co_ent_obj = self.pool.get('choice.entry')
        cont_obj = self.pool.get('account.analytic.account')
        claim_obj = self.pool.get('crm.claim')
        
        co_ent_ob = co_ent_obj.search(cr, uid,[('project_id','=',data['project_id'][0]) , ('state','=','confirm')])
        
        i=1
        for entry in co_ent_obj.browse(cr, uid, co_ent_ob):
            
            contract = cont_obj.search(cr, uid,[('partner_id','=',entry.customer_id.id) , ('sale_door_id','=',entry.door_id.id),('state','=','pending')])
            claim_ent_ob = claim_obj.search(cr, uid,[('claim_door_id','=',entry.door_id.id) , ('partner_id','=',entry.customer_id.id)])
            #geree id
            contract_id = cont_obj.browse(cr, uid, contract)
            #sanal huselt
            
            
           
      
             
            sheet.write(rowx, 0, u'%s' %i, style_table)
            i=i+1
             
            #sheet.write(2, 3, u'%s' %user_list.name, ezxf('font: bold on;align:wrap off,vert centre;'))
            if contract_id.date_start == False:
                sheet.write(rowx, 1, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 1, u'%s' %contract_id.date_start, style_table)
           
            if entry.building_id.name == False:
                sheet.write(rowx, 2, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 2, u'%s' %entry.building_id.name, style_table)
            if entry.door_id.floor == False:
                sheet.write(rowx, 3, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 3, u'%s' %entry.door_id.floor, style_table)
            if entry.door_id.name == False:    
                sheet.write(rowx, 4, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 4, u'%s' %entry.door_id.name, style_table)
            if entry.door_id.houseroom == False:    
                sheet.write(rowx, 5, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 5, u'%s' %entry.door_id.houseroom, style_table)
            
            if entry.door_id.room_size == False:
                sheet.write(rowx, 6, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 6, u'%s' %entry.door_id.room_size, style_table)
            if contract_id.code == False:
                sheet.write(rowx, 7, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 7, u'%s' %contract_id.code, style_table)   
            if entry.manager_id.name == False:
                sheet.write(rowx, 8, u'%s' %'', style_table)
            else: 
                sheet.write(rowx, 8, u'%s' %entry.manager_id.name, style_table)
            if entry.customer_id.name == False:
                sheet.write(rowx, 9, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 9, u'%s' %entry.customer_id.name, style_table)    
            if entry.customer_id.mobile == False:
                sheet.write(rowx, 10, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 10, u'%s' %entry.customer_id.mobile, style_table)
            if entry.customer_id.email == False:
                sheet.write(rowx, 11, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 11, u'%s' %entry.customer_id.email, style_table)    
            if entry.call_date == False:
                sheet.write(rowx, 12, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 12, u'%s' %entry.call_date, style_table)
            if entry.sms_date == False:
                sheet.write(rowx, 13, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 13, u'%s' %entry.sms_date, style_table)
            if entry.choice_block_id.name == False:    
                sheet.write(rowx, 14, u'%s' %'', style_table)
            else:
                sheet.write(rowx, 14, u'%s' %entry.choice_block_id.name, style_table)
            note = ''
            for claim_id in claim_obj.browse(cr, uid, claim_ent_ob):
                if note == '':
                   note = claim_id.name
                else:
                 note = note + ',' + claim_id.name
            sheet.write(rowx, 15, u'%s' %note, style_table)
            rowx = rowx + 1    
        
        inch = 1000
        inch1 = 900
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 5*inch1
        sheet.col(2).width = 3*inch
        sheet.col(3).width = 2*inch
        sheet.col(4).width = 4*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 4*inch
        sheet.col(8).width = 6*inch1
        sheet.col(9).width = 5*inch
        sheet.col(10).width = 4*inch
        sheet.col(11).width = 5*inch
        sheet.col(12).width = 5*inch
        sheet.col(13).width = 5*inch
        sheet.col(14).width = 4*inch
        #sheet.col(15).width = 4*inch
        
       # sheet.write(rowx, 5, u'Гүйцэтгэх захирал:', ezxf('font: bold off;align:wrap off,vert centre;'))
        #k=k+1
        #sheet.write(rowx, 5, u'Нягтлан бодогч:', ezxf('font: bold off;align:wrap off,vert centre;'))
        
        return {'data':book}

choice_report()