# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class contract_reg_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "contract.reg.report"
    _description = "Contract reg report"
    
    _columns = {
    'project_id': fields.many2one('account.analytic.account', 'Project', required=True),
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
       
        cr.execute("""select t.name, t.id from account_analytic_account as t 
                             left join project_project as p on p.analytic_account_id = t.id
                             where t.id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
        
        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['id']
        sheet.write_merge(1, 1, 1, 3, u'Гэрээний бүртгэлийн тайлан', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(3, 6, 0, 0, u'№',stylebr1) 
        sheet.write_merge(3, 6, 1, 1, u'Гэрээний дугаар',stylebr1)
        sheet.write_merge(3, 6, 2, 2, u'Гэрээ байгуулсан огноо',stylebr1)
        sheet.write_merge(3, 3, 3, 13, u'Бүтээгдэхүүний мэдээлэл',stylebr1)
        sheet.write_merge(3, 3, 14, 20, u'Захиалагчийн мэдээлэл',stylebr1)
        sheet.write_merge(3, 3, 21, 29, u'Төлбөрийн мэдээлэл',stylebr1)
        sheet.write_merge(4, 6, 3, 3, u'Төсөл',stylebr1)
        sheet.write_merge(4, 6, 4, 4, u'Байр',stylebr1)
        sheet.write_merge(4, 6, 5, 5, u'Давхар',stylebr1)
        sheet.write_merge(4, 6, 6, 6, u'Орц',stylebr1)
        sheet.write_merge(4, 6, 7, 7, u'Тоот',stylebr1)
        sheet.write_merge(4, 6, 8, 8, u'Нийт талбай',stylebr1)
        sheet.write_merge(4, 6, 9, 9, u'Байршил',stylebr1)
        sheet.write_merge(4, 6, 10, 10, u'Цонхны байршил',stylebr1)
        sheet.write_merge(4, 6, 11, 11, u'Цэвэр талбай',stylebr1)
        sheet.write_merge(4, 6, 12, 12, u'Гаражтай эсэх',stylebr1)
        sheet.write_merge(4, 6, 13, 13, u'Нэмэлт тавилга',stylebr1)
        sheet.write_merge(4, 6, 14, 14, u'Ургийн овог',stylebr1)
        sheet.write_merge(4, 6, 15, 15, u'Овог',stylebr1)
        sheet.write_merge(4, 6, 16, 16, u'Нэр',stylebr1)
        sheet.write_merge(4, 6, 17, 17, u'Рег|дугаар',stylebr1)
        sheet.write_merge(4, 6, 18, 18, u'Утас',stylebr1)
        sheet.write_merge(4, 6, 19, 19, u'Гэрийн хаяг',stylebr1)
        sheet.write_merge(4, 6, 20, 20, u'И-мaйл хаяг',stylebr1)
        sheet.write_merge(4, 6, 21, 21, u'Орон сууцны үнэ',stylebr1)
        sheet.write_merge(4, 6, 22, 22, u'Шууд хөнгөлөлтийн үнэ',stylebr1)
        sheet.write_merge(4, 6, 23, 23, u'Нөхцөлт хөнгөлөлт',stylebr1)
        sheet.write_merge(4, 6, 24, 24, u'Гэрээний үнэ',stylebr1)
        sheet.write_merge(4, 6, 25, 25, u'Урьдчилгаа дүн',stylebr1)
        sheet.write_merge(4, 6, 26, 26, u'Төлбөрийн график',stylebr1)
        sheet.write_merge(4, 6, 27, 27, u'Хугацаандаа төлсөн хөнгөлөлтийн хувь',stylebr1)
        sheet.write_merge(4, 6, 28, 28, u'Захиалагчийн хоног тутмын алдангийн хувь',stylebr1)
        sheet.write_merge(4, 6, 29, 29, u'Компанийн хоног тутамд төлөх алдангийн хувь',stylebr1)
        sheet.write_merge(3, 6, 30, 30, u'Барилга ашиглалтанд орох хугацаа',stylebr1)
        sheet.write_merge(3, 6, 31, 31, u'Хариуцсан менежер',stylebr1)
        sheet.write_merge(3, 6, 32, 32, u'Цуцлагдсан гэрээ',stylebr1)
        sheet.write_merge(3, 6, 33, 33, u'Гэрээ цуцалсан торгууль',stylebr1)
        sheet.write_merge(3, 3, 34, 35, u'Төлсөн алданги',stylebr1)
        sheet.write_merge(3, 3, 36, 39, u'Нэмэлт мэдээлэл',stylebr1)
        sheet.write_merge(4, 6, 34, 34, u'Захиалагчийн төлсөн алданги',stylebr1)
        sheet.write_merge(4, 6, 35, 35, u'Компанийн төлсөн алданги',stylebr1)
        sheet.write_merge(4, 6, 36, 36, u'Төлбөр тооцоо дууссан эсэх',stylebr1)
        sheet.write_merge(4, 6, 37, 37, u'Түлхүүр хүлээж авсан огноо',stylebr1)
        sheet.write_merge(4, 6, 38, 38, u'ҮХХ-н гэрчилгээ авсан эсэх',stylebr1)
        sheet.write_merge(4, 6, 39, 39, u'Тайлбар',stylebr1)
        
        i = 7
        m = 5
        cr.execute("""select a.id as aid, a.code as code,a.date1 as ognoo, a.name as tbair, b.name as bbair, a.sale_floor as davhar, 
                                a.sale_entrance as orts, pt.name as toot, a.total_square as ntalbai, a.houseroom_size as tstalbai,
                                wl.name as tsonh,bf.name as tavilga, rp.name as ner,rp.lastname as ovog, rp.surename as uovog, rp.register_number as regdug, rp.phone as phone, rp.street as hayag, rp.email as mail
                                   from
                                    account_analytic_account as a,
                                    building_building as b,
                                    product_template as pt,
                                    windows_location as wl,
                                    windows_location_rel as wlr,
                                    building_furniture as bf,
                                    res_partner as rp
                               where a.parent_id = %s
                                       and a.general_type_2 = 'sales'
                                       and a.sale_building_id = b.id
                                       and a.sale_door_id = pt.id
                                       and pt.id = wlr.door_id
                                       and wl.id = wlr.windows_location
                                       and b.id = pt.building_id 
                                       and b.furniture = bf.id
                                       and a.partner_id = rp.id  
                       order by a.id ASC"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
   
        k = 1
        if project_info != []:
            for line1 in project_info:
                aidd = line1['aid']
                cr.execute("""select a.id as aid,a.name as tbair, b.name as bbair,pt.name as toot,a.sale_door_amount as dun, a.sale_discounted_amount as hdun, a.sale_amount as hongololt, a.sale_valid_contract_percent as valid
                               from
                                    account_analytic_account as a,
                                    building_building as b,
                                    product_template as pt
                               where a.id = %s
                                       and a.general_type_2 = 'sales'
                                       and a.sale_building_id = b.id
                                       and a.sale_door_id = pt.id
                               order by a.id ASC"""%aidd)

                project_info2  = cr.dictfetchall()
               
                for line2 in project_info2:
                   
                    if line2['dun'] == None:
                        sheet.write(i, 24, u'', style_table)
                    else:
                        sheet.write(i, 24, u'%s' %line2['dun'], stylebr)
                    if line2['hdun'] == None:
                        sheet.write(i, 22, u'', style_table)
                    else:
                        sheet.write(i, 22, u'%s' %line2['hdun'], stylebr)
                    if line2['hongololt'] == None:
                        sheet.write(i, 23, u'', style_table)
                    else:
                        sheet.write(i, 23, u'%s' %line2['hongololt'], stylebr)
                    if line2['valid'] == None:
                        sheet.write(i, 25, u'', style_table)
                    else:
                        sheet.write(i, 25, u'%s' %line2['valid'], stylebr)
                
                sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                    
                if line1['code'] == None:
                    sheet.write(i, 1, u'', style_table)
                else:
                    sheet.write(i, 1, u'%s' %line1['code'], stylebr)
                if line1['ognoo'] == None:
                    sheet.write(i, 2, u'', style_table)
                else:
                    sheet.write(i, 2, u'%s' %line1['ognoo'], stylebr)
                if line1['bbair'] == None:
                    sheet.write(i, 4, u'', style_table)
                else:
                    sheet.write(i, 4, u'%s' %line1['bbair'], stylebr)
                if line1['davhar'] == None:
                    sheet.write(i, 5, u'', style_table)
                else:
                    sheet.write(i, 5, u'%s' %line1['davhar'], stylebr)
                if line1['orts'] == None:
                    sheet.write(i, 6, u'', style_table)
                else:
                    sheet.write(i, 6, u'%s' %line1['orts'], stylebr)
                if line1['toot'] == None:
                    sheet.write(i, 7, u'', style_table)
                else:
                    sheet.write(i, 7, u'%s' %line1['toot'], stylebr)
                if line1['ntalbai'] == None:
                    sheet.write(i, 8, u'', style_table)
                else:
                    sheet.write(i, 8, u'%s' %line1['ntalbai'], stylebr)
                if line1['tsonh'] == None:
                    sheet.write(i, 10, u'', style_table)
                else:
                    sheet.write(i, 10, u'%s' %line1['tsonh'], stylebr)
                if line1['tstalbai'] == None:
                    sheet.write(i, 11, u'', style_table)
                else:
                    sheet.write(i, 11, u'%s' %line1['tstalbai'], stylebr)
                if line1['tavilga'] == None:
                    sheet.write(i, 13, u'', style_table)
                else:
                    sheet.write(i, 13, u'%s' %line1['tavilga'], stylebr)
                if line1['ner'] == None:
                    sheet.write(i, 14, u'', style_table)
                else:
                    sheet.write(i, 14, u'%s' %line1['ner'], stylebr)
                if line1['ovog'] == None:
                    sheet.write(i, 15, u'', style_table)
                else:
                    sheet.write(i, 15, u'%s' %line1['ovog'], stylebr)
                if line1['uovog'] == None:
                    sheet.write(i, 16, u'', style_table)
                else:
                    sheet.write(i, 16, u'%s' %line1['uovog'], stylebr)
                if line1['regdug'] == None:
                    sheet.write(i, 17, u'', style_table)
                else:
                    sheet.write(i, 17, u'%s' %line1['regdug'], stylebr)
                if line1['phone'] == None:
                    sheet.write(i, 18, u'', style_table)
                else:
                    sheet.write(i, 18, u'%s' %line1['phone'], stylebr)
                if line1['hayag'] == None:
                    sheet.write(i, 19, u'', style_table)
                else:
                    sheet.write(i, 19, u'%s' %line1['hayag'], stylebr)
                if line1['mail'] == None:
                    sheet.write(i, 20, u'', style_table)
                else:
                    sheet.write(i, 20, u'%s' %line1['mail'], stylebr)
                i = i + 1
                k = k + 1
      
        inch = 1000
        sheet.col(0).width = 1000
        sheet.col(1).width = 3*inch
        sheet.col(2).width = 3*inch #shirheg
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 2*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 2*inch
        sheet.col(8).width = 2*inch
        sheet.col(9).width = 4*inch
        sheet.col(10).width = 4*inch
        sheet.col(11).width = 2*inch
        sheet.col(12).width = 2*inch
        sheet.col(13).width = 3*inch
        sheet.col(14).width = 3*inch
        sheet.col(15).width = 3*inch
        sheet.col(16).width = 3*inch
        sheet.col(17).width = 4*inch
        sheet.col(18).width = 3*inch
        sheet.col(19).width = 5*inch
        sheet.col(20).width = 3*inch
        sheet.col(21).width = 3*inch
        sheet.col(22).width = 3*inch
        sheet.col(23).width = 3*inch
        sheet.col(24).width = 3*inch
        sheet.col(25).width = 3*inch
        sheet.col(26).width = 3*inch
        sheet.col(27).width = 4*inch
        sheet.col(28).width = 4*inch
        sheet.col(29).width = 4*inch
        sheet.col(30).width = 3*inch
        sheet.col(31).width = 3*inch
        sheet.col(32).width = 3*inch
        sheet.col(33).width = 3*inch
        sheet.col(34).width = 3*inch
        sheet.col(35).width = 3*inch
        sheet.col(36).width = 4*inch
        sheet.col(37).width = 4*inch
        sheet.col(38).width = 4*inch
        sheet.col(39).width = 3*inch
     
       
     
        return {'data':book}

contract_reg_report()