# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class inner_design_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "inner.design.report"
    _description = "Inner design report"
    
    _columns = {
        'project_id': fields.many2one('account.analytic.account', 'Project', required=True),
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        cr.execute("""select a.name, a.id from account_analytic_account as a 
                             left join project_project as p on p.analytic_account_id = a.id
                             where a.id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
          
        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['id']
        
        sheet.write_merge(1, 1, 1, 5, u'Дотор заслын сонголтын товч тайлан төслөөр', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(1, 1, 8, 9, u'Төслийн нэр:',style_noborder)
        sheet.write_merge(1, 1, 10, 11, u'%s' %project_info['name'],style_noborder)
        sheet.write_merge(3, 5, 0, 0, u'№',stylebr1)
        sheet.write_merge(3, 5, 1, 1, u'Байрны дугаар',stylebr1)
        sheet.write_merge(3, 5, 2, 2, u'Айлын тоо',stylebr1)
        sheet.write_merge(3, 5, 3, 3, u'Захиалагчтай айл',stylebr1)
        sheet.write_merge(3, 3, 4, 12, u'Сонголт хийсэн айлын тоо',stylebr1)
        sheet.write_merge(4, 5, 4, 4, u'Галын өрөөний плита',stylebr1)
        sheet.write_merge(4, 5, 5, 5, u'АЦӨ плита',stylebr1)
        sheet.write_merge(4, 5, 6, 6, u'Обой',stylebr1)
        sheet.write_merge(4, 5, 7, 7, u'Шал',stylebr1)
        sheet.write_merge(4, 5, 8, 8, u'Хивс',stylebr1)
        sheet.write_merge(4, 5, 9, 9, u'Хаалга',stylebr1)
        sheet.write_merge(4, 5, 10, 10, u'ТВ чулуу',stylebr1)
        sheet.write_merge(4, 5, 11, 11, u'Задгай шкаф',stylebr1)
        sheet.write_merge(4, 5, 12, 12, u'Хаалгатай шкаф',stylebr1)
        sheet.write_merge(3, 5, 13, 13, u'Бүх сонголтоо хийсэн айлын тоо',stylebr1)
        sheet.write_merge(3, 5, 14, 14, u'Дутуу сонголт хийсэн айлын тоо',stylebr1)
        i = 6
     
        cr.execute("""select a.id,a.name as tbair, b.id as bid,b.name as bbair,count(ptt.project_id = p.id) as count
                                
                            from
                                project_project as p,
                                account_analytic_account as a,
                                product_template as ptt,
                                building_building as b
                            where a.parent_id = %s
                               and a.id = p.analytic_account_id
                               and ptt.asset_type = 'apartment'
                               and b.id = ptt.building_id
                               and p.id = ptt.project_id
                            group by a.id,a.name,b.name,b.id
                               order by a.id ASC"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
     
        k = 1
        if project_info != []:
            for line1 in project_info:
                    sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                    
                    if line1['bbair'] == None:
                        sheet.write(i, 1, u'', style_table)
                    else:
                        sheet.write(i, 1, u'%s' %line1['bbair'], stylebr)
                    if line1['count'] == None:
                        sheet.write(i, 2, u'', style_table)
                    else:
                        sheet.write(i, 2, u'%s' %line1['count'], stylebr)
                    
                     
                    i = i + 1
                    k = k + 1
        
      
        inch = 1000
        sheet.col(0).width = 1000
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 2*inch #shirheg
        sheet.col(3).width = 2*inch
        sheet.col(4).width = 4*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 2*inch
        sheet.col(8).width = 2*inch
        sheet.col(9).width = 2*inch
        sheet.col(10).width = 2*inch
        sheet.col(11).width = 2*inch
        sheet.col(12).width = 2*inch
        sheet.col(13).width = 4*inch
        sheet.col(14).width = 4*inch
        sheet.col(15).width = 4*inch
        sheet.col(16).width = 4*inch
     
        
    
        return {'data':book}

inner_design_report()