# -*- coding: utf-8 -*-


import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta


class lead_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "lead.report"
    _description = "Lead report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'start_date':fields.date('Start date', required=True),
        'end_date':fields.date('End date', required=True),
        #'crm_lead_id': fields.many2one('crm.lead', 'Lead', required=True),
    }
     
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        data = datas['form']
        
        
      
        
        cr.execute("select * from crm_lead as l where l.get_on_to_date >= '" +data['start_date']+"'and l.get_on_to_date <='" + data['end_date']+"'")
        task_obj  = cr.dictfetchall()
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin; pattern: pattern solid, fore_colour gray25;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('lead report')
        sheet.write(0, 1, u'Долоо хоногийн хандалтын тайлан', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(2, 1, u'Менежерийн нэр:', ezxf('font: bold on;align:wrap off,vert centre;'))
        
        sheet.write(4, 1, u'Огноо:', ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(4, 2, time.strftime('%Y-%m-%d'))
        sheet.write_merge(6, 7, 0, 0, u'№', style_table_header)
        sheet.write_merge(6, 6, 1, 3, u'Хувийн мэдээлэл', style_table_header)
        sheet.write(7, 1, u'Нэр', style_table_header)
        sheet.write(7, 2, u'Утас', style_table_header)
        sheet.write(7, 3, u'И-мэйл', style_table_header)
        sheet.write_merge(6, 7, 4, 4, u'Холбоо барьсан огноо', style_table_header)
        sheet.write_merge(6, 7, 5, 5, u'Мэдээллийн эх сурвалж', style_table_header)
        sheet.write_merge(6, 7, 6, 6, u'Хэрхэн холбогдсон', style_table_header)
        sheet.write_merge(6, 7, 7, 7, u'Сонирхож буй төсөл', style_table_header)
        sheet.write_merge(6, 7, 8, 8, u'Нэмэлт тайлбар', style_table_header)
       
        rowx = 8
        i=1
        for line in task_obj:
            user1_obj = self.pool.get('res.users')
            medium_obj = self.pool.get('crm.tracking.medium')
            project1_obj = self.pool.get('project.project')
            user_id = user1_obj.search(cr, uid,[('id','=',line['user_id'])])
            medium_id = medium_obj.search(cr, uid,[('id','=',line['medium_id'])])
            project1_id = project1_obj.search(cr, uid,[('id','=',line['interest_project_id'])])
        
            user_list = user1_obj.browse(cr, uid, user_id)[0]
            medium_list = medium_obj.browse(cr, uid, medium_id)
            porject_list = project1_obj.browse(cr, uid, project1_id)
            
            sheet.write(rowx, 0, u'%s' %i, style_table)
            i=i+1
            
        
            sheet.write(2, 2, u'%s' %user_list.name, ezxf('font: bold on;align:wrap off,vert centre;'))
            if line['name'] != None:    
                 sheet.write(rowx, 1, u'%s' %line['name'], style_table)
            else: 
                sheet.write(rowx, 1, u'', style_table) 
            if line['mobile'] != None: 
                 sheet.write(rowx, 2, u'%s' %line['mobile'], style_table)
            else:
                 sheet.write(rowx, 2, u'', style_table)
            if  line['email_from'] != None:        
                sheet.write(rowx, 3, u'%s' %line['email_from'], style_table)
            else:
                sheet.write(rowx, 3, u'', style_table) 
            if line['get_on_to_date'] !=None:      
                sheet.write(rowx, 4, u'%s' %line['get_on_to_date'], style_table)
            else:
                sheet.write(rowx, 4, u'', style_table)
            if medium_list.name !=False:    
                sheet.write(rowx, 5, u'%s' %medium_list.name, style_table)
            else:
                sheet.write(rowx, 5, u'', style_table)    
            if line['how_contacted'] != None:    
                sheet.write(rowx, 6, u'%s' %line['how_contacted'], style_table)
            else:
                sheet.write(rowx, 6, u'', style_table) 
            if porject_list.name != False:       
                sheet.write(rowx, 7, u'%s' %porject_list.name, style_table)
            else:  
                sheet.write(rowx, 7, u'', style_table)
            if  line['description'] != None:     
                sheet.write(rowx, 8, u'%s' %line['description'], style_table)
            else:
                sheet.write(rowx, 8, u'', style_table)    
     
            rowx = rowx + 1    
        
        inch = 1000
        inch1 = 900
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 5*inch1
        sheet.col(2).width = 3*inch
        sheet.col(3).width = 5*inch
        sheet.col(4).width = 4*inch
        sheet.col(5).width = 6*inch
        sheet.col(6).width = 5*inch
        sheet.col(7).width = 4*inch
        sheet.col(8).width = 5*inch1
        sheet.col(9).width = 4*inch
        
       # sheet.write(rowx, 5, u'Гүйцэтгэх захирал:', ezxf('font: bold off;align:wrap off,vert centre;'))
        #k=k+1
        #sheet.write(rowx, 5, u'Нягтлан бодогч:', ezxf('font: bold off;align:wrap off,vert centre;'))
        
        return {'data':book}

lead_report()
    
 


 