# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class payment_definition(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "payment.definition"
    _description = "Payment definition"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'project_id': fields.many2one('account.analytic.account', 'Project', required=True),
        'code': fields.char('Code')
      
      
    }
     
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
    }
    #===========================================================================
    #  
    # def onchange_code(self, cr, uid, ids, id, context=None):
    #     res = {}
    #     if id:
    #         account_obj = self.pool.get('account.analytic.account')
    #         acc = account_obj.browse(cr, uid, id)[0]
    #         #print "fffff",u'%s'%empl.last_name
    #         res['code']=acc.code
    #         return {'value':res} 
    #===========================================================================
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold off, name Times New Roman, height 120; align: wrap on;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        
        cr.execute("""select * from account_analytic_account
                        where id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()

        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['code']
       
        sheet.write_merge(0, 2, 1, 2, u'', style_table_header)
        sheet.write(1, 5, u'ТӨЛБӨР ТӨЛӨЛТИЙН ТОДОРХОЙЛОЛТ', ezxf('font: bold on;align:wrap off,vert centre;'))
        #sheet.write(1, 2, u'%s' %val, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(3, 3, 1, 3, u'Гэрээний дугаар:',style_noborder)
        sheet.write(3, 5, u'%s' %val,style_noborder)
        
        sheet.write_merge(4, 4, 1, 3, u'Захиалагчийн овог, нэр:',style_noborder)
        #id torliin talbariin neriig awah
        if project_info['partner_id'] == None:
            sheet.write(6, 5, u'',style_noborder)
        else:
            contr_obj = self.pool.get('res.partner')
            contrs = contr_obj.search(cr, uid, [('id','=',project_info['partner_id'])])
            contrs_id = contr_obj.browse(cr, uid, contrs)
            sheet.write(4, 5, u'%s' %contrs_id.name,style_noborder)
        
        sheet.write_merge(5, 5, 1, 3, u'Байрны дугаар:',style_noborder)
        if project_info['sale_building_id'] == None:
            sheet.write(7, 5, u'',style_noborder)
        else:
            contr1_obj = self.pool.get('building.building')
            contrs1 = contr1_obj.search(cr, uid, [('id','=',project_info['sale_building_id'])])
            contrs1_id = contr1_obj.browse(cr, uid, contrs1)
            sheet.write(5, 5, u'%s' %contrs1_id.name,style_noborder)
        
        sheet.write_merge(6, 6, 1, 3, u'Орц:', style_noborder)
        sheet.write(6, 5, u'%s' %project_info['sale_entrance'], style_noborder)
        
        sheet.write_merge(7, 7, 1, 3, u'Давхар:',style_noborder)
        sheet.write(7, 5, u'%s' %project_info['sale_floor'],style_noborder)
        sheet.write_merge(8, 8, 1, 3, u'Хаалганы дугаар:',style_noborder)
        sheet.write(8, 5, u'%s' %project_info['sale_door_id'],style_noborder)
        sheet.write_merge(9, 9, 1, 3, u'Захиалгын гэрээний үндсэн үнэ:',style_noborder)
        sheet.write(9, 5, u'%s' %project_info['sale_door_amount'],style_noborder)
        sheet.write_merge(10, 10, 1, 3, u'Тооцсон урамшуулал, хөнгөлөлт:',style_noborder)
        
        if project_info['sale_discount_type'] == 'amount':
            sheet.write(10, 5, u'%s' %project_info['sale_amount'],style_noborder)
        elif project_info['sale_discount_type'] == 'discount':
            sheet.write(10, 5, u'%s' %project_info['sale_discount'],style_noborder)
        else:
            sheet.write(10, 5, u'',style_noborder)
        
        sheet.write_merge(11, 11, 1, 3, u'Тооцоо хийх үнийн дүн:',style_noborder)
        sheet.write(11, 5, u'%s' %project_info['sale_discounted_amount'],style_noborder)
        
        sheet.write_merge(10, 10, 8, 11, u'Орон сууц ашиглалтад орох хугацаа:',style_noborder)
        sheet.write(10, 15, u'%s' %project_info['sale_valid_contract_date'],style_noborder)
        sheet.write_merge(11, 12, 8, 13,  u'Гэрээнд заасан ашиглалтад орох хугацаанд барилгын гүйцэтгэлийн хувь:', style_noborder)
        #sheet.write(1, 4, u'%s' %val, ezxf('font: bold on;align:wrap off,vert centre;'))
        i = 17
        
        cr.execute("""select s.contract_id, s.date, s.amount, s.loss,s.percent,
                        s.state, a.id as accid from sales_payment_schedule as s, 
                        account_analytic_account as a
                        where contract_id = a.id and
                        a.id = %s"""%(data['project_id'][0]))
        project_info1  = cr.dictfetchall()
        
        k = 1
        sum = 0
        for line1 in project_info1:
            if line1['accid'] != None:
                sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                if line1['date'] == None:
                    sheet.write(i, 1, u'', style_table)
                else:
                    sheet.write(i, 1, u'%s' %line1['date'], stylebr)
                if line1['amount'] == None:
                    sheet.write(i, 2, u'', stylebr)
                else:
                    sheet.write(i, 2, u'%s' %line1['amount'], stylebr)
                    sum = sum + line1['amount']
                sheet.write(i, 3, u'', style_nodatatable)
                sheet.write(i, 4, u'', style_nodatatable)
                
                sheet.write(i, 6, u'', style_nodatatable)
                sheet.write(i, 7, u'', style_nodatatable)
                sheet.write(i, 8, u'', style_nodatatable)
                sheet.write(i, 9, u'', style_nodatatable)
               
               
                
          
               
            
                i = i + 1
                k = k + 1
            else:
                pass
            
        l = i - 1      
        j = l + 1
        
        sheet.write_merge(17, l, 5, 5, u'', style_nodatatable)
        sheet.write_merge(17, l, 10, 10, u'', style_nodatatable)
        sheet.write_merge(17, l, 11, 11, u'', style_nodatatable)
        sheet.write_merge(17, l, 12, 12, u'', style_nodatatable)
        sheet.write_merge(17, l, 13, 13, u'', style_nodatatable)
        sheet.write_merge(17, l, 14, 14, u'', style_nodatatable)
        sheet.write_merge(17, l, 15, 15, u'', style_nodatatable)
       
        
        sheet.write(j, 0, u'',style_nodatatable)
        sheet.write(j, 1, u'Нийт төлбөр', stylebr1)
        sheet.write(j, 2, sum, stylebr1)
        sheet.write(j, 3, u'',style_nodatatable)
        sheet.write(j, 4, u'',style_nodatatable)
        sheet.write(j, 5, u'',style_nodatatable)
        sheet.write(j, 6, u'',style_nodatatable)
        sheet.write(j, 7, u'',style_nodatatable)
        sheet.write(j, 8, u'',style_nodatatable)
        sheet.write(j, 9, u'',style_nodatatable)
        sheet.write(j, 10, u'',style_nodatatable)
        sheet.write(j, 11, u'',style_nodatatable)
        sheet.write(j, 12, u'',style_nodatatable)
        sheet.write(j, 13, u'',style_nodatatable)
        sheet.write(j, 14, u'',style_nodatatable)
        sheet.write(j, 15, u'',style_nodatatable)
        
       
     
            
    
        inch = 1000
        sheet.col(0).width = 1*inch
 
       
        sheet.write_merge(13,16,0,0, u'№', stylebr)
        sheet.write_merge(13,14,1,2, u'Гэрээнд заасан төлбөр төлөх хуваарь', stylebr)
        sheet.write_merge(13,14,3,4, u'Захиалагчийн төлбөр төлсөн байдал', stylebr)
        sheet.write_merge(13,16,5,5, u'Хугацаандаа төлбөрөө төлсний хөнгөлөлт хасаж тооцох', stylebr)
        sheet.write_merge(13,14,6,7, u'Захиалагчийн төлбөрөө төлөх хугацаа хэтэрсэн', stylebr)
        sheet.write_merge(13,14,8,9, u'Алданги', stylebr)
        sheet.write_merge(13,14,10,14, u'Гүйцэтгэгчийн ашиглалтанд орох хугацаа хэтэрсэн', stylebr)
        sheet.write_merge(13,16,15,15, u'Зөвшөөрсөн', stylebr)
        sheet.write_merge(15,16,1,1, u'Төлбөр төлөх огноо', stylebr)
        #sheet.write(1, 19, u'%s' %project_info['date'], ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(15,16,2,2, u'Төлөх дүн', stylebr)
        sheet.write_merge(15,16,3,3, u'Төлбөр төлсөн огноо', stylebr)
        #----------------------------- sheet.write(17,3, u'', style_nodatatable)
        sheet.write_merge(15,16,4,4, u'Төлсөн дүн', stylebr)
        sheet.write_merge(15,16,6,6, u'Зөрүү төлбөр', stylebr)
        sheet.write_merge(15,16,7,7, u'Хоног', stylebr)
        sheet.write_merge(15,16,8,8, u'Хувь', stylebr)
        sheet.write_merge(15,16,9,9, u'Дүн', stylebr)
        sheet.write_merge(15,16,10,10, u'Гүйцэтгэлийн дутуу хувь', stylebr)
        sheet.write_merge(15,16,11,11, u'Төлбөрийн дүн', stylebr)
        sheet.write_merge(15,16,12,12, u'Хоног', stylebr)
        sheet.write_merge(15,16,13,13, u'Хувь', stylebr)
        sheet.write_merge(15,16,14,14, u'Алданги', stylebr)
        
        m = j + 2
        sheet.write_merge(m, m, 2, 4, u'Захиалагчийн төлөх дутуу төлбөр:',style_noborder)
        # sheet.write(25, 4, u'%s' %val, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(m, m, 6, 9, u'Захиалагчийн төлөх алданги:',style_noborder)
        # sheet.write(25, 4, u'%s' %val, ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(m, m, 11, 14, u'Гүйцэтгэгчийн төлөх алданги:',style_noborder)
        # sheet.write(25, 4, u'%s' %val, ezxf('font: bold on;align:wrap off,vert centre;'))
        
       
        m1 = m + 2
        sheet.write_merge(m1, m1, 2, 4,u'ТӨЛБӨР ТООЦООГ ЗӨВШӨӨРСӨН:',style_noborder)
        #sheet.write(5, 5, u'%s' %val, ezxf('font: bold on;align:wrap off,vert centre;'))
        m2 = m1 + 2
        m21 = m2 + 1
        sheet.write_merge(m2, m21, 2, 4, u'"НОМИН КОНСТРАКШН" ХХК-ийн Маркетинг,Борлуулалт хариуцсан захирал:',style_noborder)
        #sheet.write(5, 5, u'%s' %val, ezxf('font: bold on;align:wrap off,vert centre;'))
        
        m3 = m21 + 2
        
        sheet.write_merge(m3, m3, 2, 4, u'Маркетинг,Борлуулалтын албаны ахлах менежер:',style_noborder)
        #sheet.write(5, 5, u'%s' %val, ezxf('font: bold on;align:wrap off,vert centre;'))
        m4 = m3 + 2
        sheet.write_merge(m4, m4, 2, 4, u'Нягтлан бодогч:',style_noborder)
        #sheet.write(5, 5, u'%s' %val, ezxf('font: bold on;align:wrap off,vert centre;'))
        m5 = m4 + 2
    
        sheet.write_merge(m5, m5, 1, 4, u'Захиалагчийн үлдэгдэл төлбөрөө төлөх хуваарь:',style_noborder)
        m6 = m5 + 1
        m7 = m6 + 1
        sheet.write_merge(m6,m7,0,0, u'№', stylebr1)
        sheet.write_merge(m6,m7,1,1, u'Тал', stylebr)
        sheet.write_merge(m6,m7,2,2, u'Үлдэгдэл төлбөрийн дүн', stylebr)
        sheet.write_merge(m6,m7,3,3, u'Бодогдсон алдангийн дүн', stylebr)
        sheet.write_merge(m6,m7,4,4, u'Нийт төлөгдөх төлбөр', stylebr)
        sheet.write_merge(m6,m7,5,5, u'Төлбөр төлөх хугацаа', stylebr)
        sheet.write_merge(m6,m7,6,6, u'Зөвшөөрсөн', stylebr)
        rowp=35
        rowp1= rowp+1
        sheet.row(rowp1).height = 300
        #------------------------- sheet.write_merge(rowp,rowp1,4,4).width = 200
        
        h = 37
        
        cr.execute("""select s.contract_id, s.date, s.amount, s.loss,s.percent,
                        s.state, a.id as accid from sales_payment_schedule as s, 
                        account_analytic_account as a
                        where contract_id = a.id and
                        a.id = %s"""%(data['project_id'][0]))
        project_info1a  = cr.dictfetchall()
        
        d = 1
        for line1 in project_info1a:
            if line1['accid'] != None:
                sheet.write(h, 0, u'%s' %d, stylebr)#des dugaar hewlelt
                
                sheet.write(h, 1, u'', style_nodatatable)
                sheet.write(h, 2, u'', style_nodatatable)
                sheet.write(h, 3, u'', style_nodatatable)
                sheet.write(h, 4, u'', style_nodatatable)
                sheet.write(h, 5, u'', style_nodatatable)
                sheet.write(h, 6, u'', style_nodatatable)
              
                h = h + 1
                d = d + 1
            else:
                pass
        o = h + 2
        g = o - 1
        g1 = g + 1
        
        sheet.write_merge(g, g, 2, 5, u'Үлдэгдэл төлбөр төлсөн болохыг баталсан:',style_noborder)
        sheet.write_merge(g1, g1, 2, 3, u'Нягтлан бодогч:',style_noborder)
       
          
        inch = 900
        sheet.col(0).width = 500
        sheet.col(1).width = 3*inch
        sheet.col(2).width = 3*inch #shirheg
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 4*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 1*inch
        sheet.col(8).width = 1*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 1*inch
        sheet.col(13).width = 1*inch
        sheet.col(14).width = 3*inch
        sheet.col(15).width = 4*inch
        
        rowu=11
        rowu2= rowu + 1
        sheet.row(rowu2).height = 80
         
        rowx=15
        sheet.row(rowx).height = 400
        rowm=23
        sheet.row(rowm).height = 200
        rowf=27
        rowf1= rowf+1
        sheet.row(rowf1).height = 100
        rowb=30
        sheet.row(rowb).height = 200
        rowd=26
        sheet.row(rowd).height = 200
        rowa=29
        sheet.row(rowa).height = 200
        rowr=24
        sheet.row(rowr).height = 200
        rowr1=31
        sheet.row(rowr1).height = 200
        rowr2=33
        sheet.row(rowr2).height = 200
        rowo=13
        rowo1= rowo+1
        sheet.row(rowo1).height = 300
        rowk1=15
        rowk2= rowk1+1
        sheet.row(rowk2).height = 50
      
        
        


        return {'data':book}

payment_definition()