# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class project_performance(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "project.performance"
    _description = "Project performance"
    
    _columns = {
        'project_id': fields.many2one('account.analytic.account', 'Project', required=True),
        
      
      
    }
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap off, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold off, name Times New Roman, height 120; align: wrap on;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        
        
        cr.execute("""select t.name, t.id from account_analytic_account as t 
                             left join project_project as p on p.analytic_account_id = t.id
                             where t.id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
        
      
      
 
        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['id']
        
        sheet.write_merge(1, 1, 2, 5, u'Төслийн борлуулалтын гүйцэтгэлийн мэдээ |Товч|:', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(3, 1, u'Төслийн нэр:',style_noborder)
        sheet.write_merge(3, 3, 2, 3, u'%s' %project_info['name'],style_noborder)
        sheet.write_merge(5, 6, 0, 0, u'',style_nodatatable)
        sheet.write_merge(5, 6, 1, 1, u'Обьектууд ',stylebr1)
        sheet.write_merge(5, 6, 2, 2, u'Зориулалт',stylebr1)
         
        sheet.write_merge(5, 5, 3, 5, u'Байр',stylebr1)
        sheet.write(6, 3, u'борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write(6, 4, u'борлуулалтын гүйцэтгэл',stylebr1)
        sheet.write(6, 5, u'Гүйцэтгэлийн хувь',stylebr1)
        sheet.write_merge(5, 5, 6, 8, u'Гараж',stylebr1)
        sheet.write(6, 6, u'борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write(6, 7, u'борлуулалтын гүйцэтгэл',stylebr1)
        sheet.write(6, 8, u'Гүйцэтгэлийн хувь',stylebr1)
        sheet.write_merge(5, 5, 9, 11, u'Үйлчилгээ',stylebr1)
        sheet.write(6, 9, u'борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write(6, 10, u'борлуулалтын гүйцэтгэл',stylebr1)
        sheet.write(6, 11, u'Гүйцэтгэлийн хувь',stylebr1)
        sheet.write_merge(5, 6, 12, 12, u'Нийт борлуулалт',stylebr1)
         
        i = 7
        
         
        cr.execute("""select a.id,a.name as aname,sum(sl.planned_contract_amount) as sum, pt.name as pname
                            from account_analytic_account as a,
                                 project_project as p,
                                 sale_business_plan as s,
                                 sale_business_plan_line as sl,
                                 project_type as pt
                            where a.id = p.analytic_account_id and sl.business_plan_id = s.id and a.parent_id = %s
                            group by a.name,a.id,pt.name
                                 order by  a.id ASC"""%(data['project_id'][0]))
       
        project_info1  = cr.dictfetchall()
      
        cr.execute("""select b.id, sum(a.sale_door_amount) as sum1
                         from account_analytic_account as a,
                              product_template as ptt,
                              building_building as b
                       where a.sale_door_id = ptt.id and ptt.asset_type = 'apartment' and a.parent_id = %s and a.sale_building_id = b.id
                       group by b.id
                       order by b.id ASC"""%(data['project_id'][0]))
        
        project_info2  = cr.dictfetchall()
        
        cr.execute("""select a.id,a.name as aname,a.sale_contract_type,ptt.asset_type as asset,sum(sl.planned_contract_amount) as sum2
                            from account_analytic_account as a,
                                 project_project as p,
                                 building_building as b,
                                 sale_business_plan as s,
                                 sale_business_plan_line as sl,
                                 product_template as ptt
                            where a.id = p.analytic_account_id and p.id = b.project_id and sl.building_id = b.id and sl.door_id = ptt.id and sl.business_plan_id = s.id and ptt.asset_type = 'garage' and a.parent_id = %s
                                 group by a.name,a.id,a.sale_contract_type,ptt.asset_type
                                 order by  a.id ASC"""%(data['project_id'][0]))
       
        project_info3  = cr.dictfetchall()
        
        cr.execute("""select a.name,sum(a.sale_door_amount) as sum3
                         from account_analytic_account as a,
                              product_template as ptt
                       where a.sale_door_id = ptt.id and ptt.asset_type = 'garage' and a.parent_id = %s
                       group by a.id,a.name
                       order by a.id ASC"""%(data['project_id'][0]))
        
        project_info4  = cr.dictfetchall()
        cr.execute("""select a.id,a.name as aname,a.sale_contract_type,ptt.asset_type,sum(sl.planned_contract_amount) as sum5
                            from account_analytic_account as a,
                                 project_project as p,
                                 building_building as b,
                                 sale_business_plan as s,
                                 sale_business_plan_line as sl,
                                 product_template as ptt
                            where a.id = p.analytic_account_id and p.id = b.project_id and sl.building_id = b.id and sl.door_id = ptt.id and sl.business_plan_id = s.id and ptt.asset_type = 'object' and a.parent_id = %s
                                 group by a.name,a.id,a.sale_contract_type,ptt.asset_type
                                 order by  a.id ASC"""%(data['project_id'][0]))
       
        project_info5  = cr.dictfetchall()
      
        cr.execute("""select a.name,sum(a.sale_door_amount) as sum6
                         from account_analytic_account as a,
                              product_template as ptt
                       where a.sale_door_id = ptt.id and ptt.asset_type = 'object' and a.parent_id = %s
                       group by a.id,a.name
                       order by a.id ASC"""%(data['project_id'][0]))
        
        project_info6  = cr.dictfetchall()
         
        k = 1
        if project_info1 != []:
            for line1 in project_info1:   
                    sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                   
                    if line1['aname'] == None:
                        sheet.write(i, 1, u'', style_table)
                    else:
                        sheet.write(i, 1, u'%s' %line1['aname'], stylebr)
                    if line1['pname'] == None:
                        sheet.write(i, 2, u'', style_table)
                    else:
                        sheet.write(i, 2, u'%s' %line1['pname'], stylebr)
                    
                    if line1['sum'] == None:
                        sheet.write(i, 3, u'', style_table)
                    else:
                        sheet.write(i, 3, u'%s' %line1['sum'], stylebr)
                    
                     
                    i = i + 1
        if project_info2 != []:
            i=7
            j = 8
            for line2 in project_info2:
                if line2['sum1'] == None:
                    sheet.write(i, 4, u'', style_table)
                else:
                    sheet.write(i, 4, u'%s' %line2['sum1'], stylebr)
                
                    sheet.write(i, 5, Formula('$E$%d*100/$D$%d' % (j, j)), stylebr)
                i = i + 1
                j = j + 1
        if project_info3 != []:
            i=7
            for line3 in project_info3:
                if line3['sum2'] == None:
                    sheet.write(i, 6, u'', style_table)
                else:
                    sheet.write(i, 6, u'%s' %line3['sum2'], stylebr)
               
                i = i + 1
        if project_info4 != []:
            i=7
            t = 8
            for line4 in project_info4:
                if line4['sum3'] == None:
                    sheet.write(i, 7, u'', style_table)
                else:
                    sheet.write(i, 7, u'%s' %line4['sum3'], stylebr)
                    sheet.write(i, 8, Formula('$H$%d*100/$G$%d' % (t, t)), stylebr)
                i = i + 1
                t = t + 1
        if project_info5 != []:
            i=7
            for line5 in project_info5:
                if line5['sum5'] == None:
                    sheet.write(i, 9, u'', style_table)
                else:
                    sheet.write(i, 9, u'%s' %line5['sum5'], stylebr)
                
                i = i + 1
        if project_info6 != []:
            i=7
            t=8
            for line6 in project_info6:
                if line6['sum6'] == None:
                    sheet.write(i, 10, u'', style_table)
                else:
                    sheet.write(i, 10, u'%s' %line6['sum6'], stylebr)
                    sheet.write(i, 11, Formula('$K$%d*100/$J$%d' % (t, t)), stylebr)
                    sheet.write(i, 12, Formula('$E$%d+$H$%d+$K$%d' % (t, t, t)), stylebr)
                    
                i = i + 1
                t = t + 1
        inch = 1000
        sheet.col(0).width = 500
        sheet.col(1).width = 3*inch
        sheet.col(2).width = 3*inch #shirheg
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 3*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 3*inch
        sheet.col(13).width = 3*inch
        sheet.col(14).width = 3*inch
        sheet.col(15).width = 3*inch
        
        

        return {'data':book}

project_performance()