# -*- coding: utf-8 -*-
from datetime import date, timedelta, datetime
import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class project_sale_plan(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "project.sale.plan"
    _description = "Project sale plan"
    
    _columns = {
       'project_id': fields.many2one('account.analytic.account', 'Project', required=True),
    }
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        building = self.pool.get('building.building')
        buil = building.search(cr, uid, [('project_id','=',data['project_id'][0])])
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        
        cr.execute("""select t.name, t.id from account_analytic_account as t 
                             left join project_project as p on p.analytic_account_id = t.id
                             where t.id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
        
        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['id']
        
        today = date.today()
        sheet.write(1, 1, u'Төслийн борлуулалтын төлөвлөгөө /товч/', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write(3, 1, u'Төслийн нэр:', ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(3, 2, u'%s' %project_info['name'],style_noborder)
        sheet.write(3, 11, u'Огноо:', ezxf('font: bold off;align:wrap off,vert centre;'))
        sheet.write(3, 12, u'%s' %today, style_noborder)
        sheet.write_merge(5, 6, 0, 0, u' ', style_table_header)
        sheet.write_merge(5, 6, 1, 1, u'Обьектууд', stylebr1)
        sheet.write_merge(5, 6, 2, 2, u'Зориулалт', stylebr1)
        sheet.write_merge(5, 5, 3, 5, u'Байр', stylebr1)
        sheet.write(6, 3, u'талбай(м2)', stylebr1)
        sheet.write(6, 4, u'хаалга тоо', stylebr1)
        sheet.write(6, 5, u'борлуулалт', stylebr1)
        sheet.write_merge(5, 5, 6, 8, u'Гараж', stylebr1)
        sheet.write(6, 6, u'талбай(м2)', stylebr1)
        sheet.write(6, 7, u'хаалга тоо', stylebr1)
        sheet.write(6, 8, u'борлуулалт', stylebr1)
        sheet.write_merge(5, 5, 9, 11, u'Үйлчилгээ', stylebr1)
        sheet.write(6, 9, u'талбай(м2)', stylebr1)
        sheet.write(6, 10, u'хаалга тоо', stylebr1)
        sheet.write(6, 11, u'борлуулалт', stylebr1)
        sheet.write_merge(5, 6, 12, 12, u'Нийт борлуулалт', stylebr1)
       
        i = 7
        m = 5
         
        cr.execute("""select a.id,a.name as tbair, b.id as bid,b.name as bbair, pt.name as torol, sum(ptt.total_squaring) as sum1,
                                count(ptt.project_id = p.id) as count,(select sum(a.sale_door_amount) 
                                from product_template as ptt, account_analytic_account as a
                                where a.sale_door_id = ptt.id and ptt.asset_type = 'apartment') as sum3
                                
                            from
                                project_project as p,
                                account_analytic_account as a,
                                project_type as pt,
                                product_template as ptt,
                                building_building as b
                            where a.parent_id = %s
                               and a.id = p.analytic_account_id
                               and pt.id = p.pro_type
                               and ptt.asset_type = 'apartment'
                               and b.id = ptt.building_id
                               and p.id = ptt.project_id
                            group by a.id,a.name, pt.name, b.name,b.id
                               order by a.id ASC"""%(data['project_id'][0]))
                   
        project_info1  = cr.dictfetchall()
        
        cr.execute("""select a.id,a.name as tbair, b.id as bid,b.name as bbair,b.garage_square as sum2, pt.name as torol,
                                count(ptt.project_id = p.id) as count1,(select sum(a.sale_door_amount) 
                                from product_template as ptt, account_analytic_account as a
                                where a.sale_door_id = ptt.id and ptt.asset_type = 'garage') as sum4
                                
                            from
                                project_project as p,
                                account_analytic_account as a,
                                project_type as pt,
                                product_template as ptt,
                                building_building as b
                            where a.parent_id =%s
                               and a.id = p.analytic_account_id
                               and pt.id = p.pro_type
                               and ptt.asset_type = 'garage'
                                and b.id = ptt.building_id
                                and p.id = ptt.project_id
                                
                            group by a.id,a.name, pt.name, b.name,b.id,b.garage_square
                               order by a.id ASC"""%(data['project_id'][0]))
        
        project_info2  = cr.dictfetchall()
        cr.execute("""select a.id,a.name as tbair, b.id as bid,b.name as bbair, pt.name as torol, sum(ptt.total_squaring) as sum5,
                                count(ptt.project_id = p.id) as count2,(select sum(a.sale_door_amount) 
                                from product_template as ptt, account_analytic_account as a
                                where a.sale_door_id = ptt.id and ptt.asset_type = 'object') as sum6
                                
                            from
                                project_project as p,
                                account_analytic_account as a,
                                project_type as pt,
                                product_template as ptt,
                                building_building as b
                            where a.parent_id = %s
                               and a.id = p.analytic_account_id
                               and pt.id = p.pro_type
                               and ptt.asset_type = 'object'
                                and b.id = ptt.building_id
                                and p.id = ptt.project_id
                                
                            group by a.id,a.name, pt.name, b.name,b.id
                               order by a.id ASC"""%(data['project_id'][0]))
        
        project_info3  = cr.dictfetchall()
        
        k = 1
        if project_info1 != []:
            for line1 in project_info1:
                bidd = line1['bid']
                cr.execute("""select sum(a.sale_door_amount) as sum7 
                                    from product_template as ptt,
                                     account_analytic_account as a,
                                     building_building as b
                                    where a.sale_door_id = ptt.id 
                                        and ptt.asset_type = 'apartment' 
                                        and b.id = a.sale_building_id 
                                        and b.id = %s"""%bidd)
                
                project_info4  = cr.dictfetchall()
                
                if len(project_info4) > 0:
                    project_info4 = project_info4[0]
                    suum = project_info4['sum7']
                    sheet.write(i, 3, u'%s' %line1['sum1'], stylebr)
                    sheet.write(i, 4, u'%s' %line1['count'], stylebr)
                    sheet.write(i, 5, u'%s' %suum, stylebr)
                     
                else:
                     
                    sheet.write(i, 3, u'', style_table)
                    sheet.write(i, 4, u'', style_table)
                    sheet.write(i, 5, u'', style_table)
            
                sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                
                if line1['bbair'] == None:
                    sheet.write(i, 1, u'', style_table)
                else:
                    sheet.write(i, 1, u'%s' %line1['bbair'], stylebr)
                if line1['torol'] == None:
                    sheet.write(i, 2, u'', style_table)
                else:
                    sheet.write(i, 2, u'%s' %line1['torol'], stylebr)
                    
                    
                
            
                i = i + 1
                k = k + 1
        if project_info2 != []:
            i=7
            for line2 in project_info2:
                bidd = line2['bid']
                cr.execute("""select sum(a.sale_door_amount) as sum8
                                    from product_template as ptt,
                                     account_analytic_account as a,
                                     building_building as b
                                    where a.sale_door_id = ptt.id 
                                        and ptt.asset_type = 'garage' 
                                        and b.id = a.sale_building_id 
                                        and b.id = %s"""%bidd)
                
                project_info5  = cr.dictfetchall()
                print 'dadada',project_info5
                
                if len(project_info5) > 0:
                    print 'len_if'
                    project_info5 = project_info5[0]
                    suum1 = project_info5['sum8']
                    
                    sheet.write(i, 6, u'%s' %line2['sum2'], stylebr)
                    sheet.write(i, 7, u'%s' %line2['count1'], stylebr)
                    sheet.write(i, 8, u'%s' %suum1, stylebr)
                else:
                    print 'len_else'
                    sheet.write(i, 6, u'', style_table) 
                    sheet.write(i, 7, u'', style_table)
                    sheet.write(i, 8, u'', style_table)
                   
                i = i + 1
        if project_info3 != []:
            i=7
            t=8
            
            for line3 in project_info3:
                bidd = line3['bid']
                cr.execute("""select sum(a.sale_door_amount) as sum9 
                                    from product_template as ptt,
                                     account_analytic_account as a,
                                     building_building as b
                                    where a.sale_door_id = ptt.id 
                                        and ptt.asset_type = 'object' 
                                        and b.id = a.sale_building_id 
                                        and b.id = %s"""%bidd)
                
                project_info6  = cr.dictfetchall()
                if len(project_info6) > 0:
                    project_info6 = project_info6[0]
                    suum2 = project_info6['sum9']
                    sheet.write(i, 9, u'%s' %line3['sum5'], stylebr)
                    sheet.write(i, 10, u'%s' %line3['count2'], stylebr)
                    sheet.write(i, 11, u'%s' %suum2, stylebr)
                    sheet.write(i, 12, Formula('$F$%d+$I$%d+$L$%d' % (t, t, t)), stylebr)
                else:
                    sheet.write(i, 9, u'', style_table)
                    sheet.write(i, 10, u'', style_table)
                    sheet.write(i, 11, u'', style_table)
                    sheet.write(i, 12, Formula('$F$%d+$I$%d+$L$%d' % (t, t, t)), stylebr)
                i = i + 1
                t = t + 1
            
        inch = 1000
        sheet.col(0).width = 1000
        sheet.col(1).width = 4*inch
        sheet.col(2).width = 5*inch
        sheet.col(3).width = 3*inch #shirheg
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 3*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 5*inch


        return {'data':book}

project_sale_plan()