# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class sale_plan_detailed_performance(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "sale.plan.detailed.performance"
    _description = "Sale plan detailed performance"
    
    _columns = {
       'project_id': fields.many2one('account.analytic.account', 'Project', required=True),
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        
        cr.execute("""select t.name, t.id from account_analytic_account as t 
                             left join project_project as p on p.analytic_account_id = t.id
                             where t.id = %s"""%(data['project_id'][0]))
        project_info  = cr.dictfetchall()
        
        if len(project_info) > 0:
                project_info = project_info[0]
                val = project_info['id']
        
       
        sheet.write_merge(1, 1, 1, 7, u'Төслийн борлуулалтын төлөвлөгөөний дэлгэрэнгүй гүйцэтгэл (Хугацаатай)', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(3, 3, 1, 1, u'Төслийн нэр:',style_noborder)
        sheet.write_merge(3, 3, 3, 3, u'%s' %project_info['name'],style_noborder)
        sheet.write_merge(5, 6, 0, 0, u'№',stylebr1) 
        sheet.write_merge(5, 6, 1, 1, u'Байрны дугаар',stylebr1)
        sheet.write_merge(5, 6, 2, 2, u'Давхар',stylebr1)
        sheet.write_merge(5, 6, 3, 3, u'Төрөл',stylebr1)
        sheet.write_merge(5, 6, 4, 4, u'Тоот',stylebr1)
        sheet.write_merge(5, 6, 5, 5, u'Талбайн хэмжээ',stylebr1)
        sheet.write_merge(5, 6, 6, 6, u'Байрны код',stylebr1)
        sheet.write_merge(5, 6, 7, 7, u'Үйлчилгээний төрөл',stylebr1)
        sheet.write_merge(5, 6, 8, 8, u'Түрээсийн сар',stylebr1)
        sheet.write_merge(5, 6, 9, 9, u'Төлөвлөгөөний үнэ (Төг)',stylebr1)
        sheet.write_merge(5, 6, 10, 10, u'Гэрээний үнэ (Төг)',stylebr1)
        sheet.write_merge(5, 6, 11, 11, u'Гэрээний дугаар',stylebr1)
        sheet.write_merge(5, 6, 12, 12, u'Менежер',stylebr1)
        sheet.write_merge(5, 6, 13, 13, u'Захиалагч',stylebr1)
        sheet.write_merge(5, 6, 14, 15, u'Зарахаар төлөвлөсөн огноо',stylebr1)
       
        
        i = 7
        m = 5
        n = 6
        
        cr.execute("""select b.name as bname, pt.floor as floor, pt.entrance as orts,a.sale_door_amount as dun,a.code as code,sl.planned_contract_amount as planned,
                               pt.name as toot,pt.asset_type as asset,p.code as bkod,pt.total_squaring as talbai,
                               rp.name as zahialagch, ru.login as manager,ap.code as code1, 
                               a.sale_contract_type, a.sale_lease_type, a.sale_lease_month
                               
                             from 
                                building_building as b,
                                product_template as pt,
                                project_project as p,
                                account_analytic_account as a,
                                res_users as ru,
                                res_partner as rp,
                                sale_business_plan as s,
                                sale_business_plan_line as sl,
                                account_period as ap
                              where a.parent_id = %s
                                and a.sale_door_id = pt.id
                                and ru.id = a.manager_id
                                and rp.id = a.partner_id
                                and p.id = s.project_id
                                and s.id = sl.business_plan_id
                                and sl.period_id = ap.id
                                and a.general_type_2 ='sales'
                                and b.id = a.sale_building_id
                                and  pt.id = sl.door_id
                order by b.id ASC"""%(data['project_id'][0]))
                   
        project_info  = cr.dictfetchall()
        print 'pppppppppp',project_info
        k = 1
        if project_info != []:
            for line1 in project_info:
                #------------------------------- print 'tttttttteeeeeeeb', line1
                    sheet.write(i, 0, u'%s' %k, stylebr)#des dugaar hewlelt
                    
                    if line1['bname'] == None:
                        sheet.write(i, 1, u'', style_table)
                    else:
                        sheet.write(i, 1, u'%s' %line1['bname'], stylebr)
                        
                    if line1['floor'] == None:
                        sheet.write(i, 2, u'', style_table)
                    else:
                        sheet.write(i, 2, u'%s' %line1['floor'], stylebr)
                    if line1['toot'] == None:
                        sheet.write(i, 4, u'', style_table)
                    else:
                        sheet.write(i, 4, u'%s' %line1['toot'], stylebr)
                    if line1['asset'] == None:
                        sheet.write(i, 3, u'', style_table)
                    else:
                        sheet.write(i, 3, u'%s' %line1['asset'], stylebr)
                    if line1['talbai'] == None:
                        sheet.write(i, 5, u'', style_table)
                    else:
                        sheet.write(i, 5, u'%s' %line1['talbai'], stylebr)
                    if line1['bkod'] == None:
                        sheet.write(i, 6, u'', style_table)
                    else:
                        sheet.write(i, 6, u'%s' %line1['bkod'], stylebr)
                    if line1['sale_contract_type'] == 'lease':
                        if line1['sale_lease_type'] == '':
                            sheet.write(i, 7, u'', style_table)
                        else:
                            sheet.write(i, 7, u'%s' %line1['sale_lease_type'], style_table)
                        if line1['sale_lease_month'] == '':
                            sheet.write(i, 8, u'', style_table)
                        else:
                            sheet.write(i, 8, u'%s' %line1['sale_lease_month'], style_table)
                    else:
                        sheet.write(i, 7, u'', style_table)
                        sheet.write(i, 8, u'', style_table)
                        
                    if line1['planned'] == None:
                        sheet.write(i, 9, u'', style_table)
                    else:
                        sheet.write(i, 9, u'%s' %line1['planned'], stylebr)
                    if line1['dun'] == None:
                        sheet.write(i, 10, u'', style_table)
                    else:
                        sheet.write(i, 10, u'%s' %line1['dun'], stylebr)
                    if line1['code'] == None:
                        sheet.write(i, 11, u'', style_table)
                    else:
                        sheet.write(i, 11, u'%s' %line1['code'], stylebr)
                    if line1['manager'] == None:
                        sheet.write(i, 12, u'', style_table)
                    else:
                        sheet.write(i, 12, u'%s' %line1['manager'], stylebr)
                    if line1['zahialagch'] == None:
                        sheet.write(i, 13, u'', style_table)
                    else:
                        sheet.write(i, 13, u'%s' %line1['zahialagch'], stylebr)
                    if line1['code1'] == None:
                        sheet.write_merge(i, i, 14, 15, u'', style_table)
                    else:
                        sheet.write_merge(i, i, 14, 15, u'%s' %line1['code1'], stylebr)
                   
                    
                    i = i + 1
                    k = k + 1
      
        inch = 1000
        sheet.col(0).width = 700
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 2*inch #shirheg
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 2*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 5*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 4*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 3*inch
        sheet.col(13).width = 3*inch
        sheet.col(14).width = 2*inch
        sheet.col(15).width = 2*inch
        sheet.col(16).width = 2*inch
        sheet.col(17).width = 2*inch
        sheet.col(18).width = 2*inch
        sheet.col(19).width = 2*inch
        sheet.col(20).width = 2*inch
        sheet.col(21).width = 2*inch
        sheet.col(22).width = 2*inch
        sheet.col(23).width = 2*inch
        sheet.col(24).width = 2*inch
        sheet.col(25).width = 2*inch
     
        
    
        return {'data':book}

sale_plan_detailed_performance()