# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2014 iERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : iERP@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp
from openerp.tools.translate import _
import StringIO
import csv
from tempfile import TemporaryFile
import base64


class stock_inventory(osv.osv):
    _name = "stock.inventory"
    _inherit = 'stock.inventory'

    _columns = {
                'state': fields.selection([('draft', 'Draft'),
                                            ('cancel', 'Cancelled'),
                                            ('compute','Diffrerence Compute'),
                                            ('confirm', 'In Progress'),
                                            ('done', 'Validated'),], 'Status', readonly=True, select=True, copy=False),
                'other_id': fields.one2many('stock.other.line', 'inventory_id', 'Other Inventories'),
                'data': fields.binary('File'),
                }
    def write(self, cr, uid, ids, vals, context=None):
        if 'product_qty' in vals:
            vals.update({'theoretical_qty':vals['product_qty']})
        return super(stock_inventory, self).write(cr, uid, ids, vals, context=context)
    def action_difference(self, cr, uid, ids,context=None):
        obj = self.browse(cr, uid, ids)[0]
        line_obj = self.pool.get('stock.inventory.line')
        diff = 0
        if obj.line_ids:
            for line in obj.line_ids:
                diff = line.theoretical_qty-line.product_qty
                line_obj.write(cr, uid, line.id,{
                                              'difference':diff,
                                              })

        self.write(cr, uid, ids,{'state':'compute'}, context)
        return True
    
    def action_import_inventory(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]

        if obj.data:
            f = StringIO.StringIO(base64.decodestring(obj.data))
            reader = csv.reader(f, delimiter=',')
            product_lines = self.pool.get('stock.inventory.line')
            product_other_lines = self.pool.get('stock.other.line')
            
            reader1 = {}
            for i, line in enumerate(reader):
                if not (len(line) == 2 and int(line[1]) > 0):
                    raise osv.except_osv(_('Анхааруулга!'), _('Буруу файл оруулсан байна !!!'))
                    return False;
                if line[0] in reader1:
                    reader1[line[0]] = reader1[line[0]] + int(line[1])
                else:
                    reader1[line[0]] = int(line[1])
                
            for line_barcode, line_value in reader1.iteritems():
                line_read = False
                for product in obj.line_ids:
                    if line_barcode == product.product_id.ean13:
                        if product.is_read == 'yes':
                            line_value_plus = line_value + product.product_qty
                            product_lines.write(cr, uid, product.id, {'product_qty': line_value_plus , 'is_read': 'yes'}, context=context)
                        else:
                            product_lines.write(cr, uid, product.id, {'product_qty': line_value , 'is_read': 'yes'}, context=context)
                        line_read = True
                        break
                        
                if line_read == False:
                    line_exists = product_other_lines.search(cr, uid, [('bar_code','=', line_barcode), ('inventory_id', '=', obj.id)])
                    existed_line = product_other_lines.browse(cr, uid, line_exists)
                    if len(line_exists) > 0:
                        line_value_plus = line_value + existed_line.read_qty
                        product_other_lines.write(cr, uid, line_exists[0], {'read_qty': line_value_plus}, context=context)
                    else:
                        product_other_lines.create(cr, uid, {'inventory_id': obj.id, 'read_qty': line_value, 'bar_code': line_barcode}, context=context)
                    
            self.write(cr, uid, obj.id, {'data': ''}, context=context)
        return True

class stock_inventory_line(osv.osv):
    _inherit = 'stock.inventory.line'
    
    _columns = {
                'difference':fields.float('Difference'),
                'is_read': fields.selection([('yes', 'Yes'),
                                            ('no', 'No'),], 'Is read', select=True),
                }
    _defaults = {
        'is_read': 'no',
    }
    
class stock_other_line(osv.osv):
    _name = 'stock.other.line'
    
    _columns = {
                'inventory_id': fields.many2one('stock.inventory', 'Inventory', ondelete='cascade', select=True),
                'product_id': fields.many2one('product.product', 'Product'),
                'bar_code':fields.char('Bar code'),
                'read_qty':fields.float('Read qty'),
                }    
