# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2013 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
from StringIO import StringIO
#import xlrd, base64, time, datetime, xlwt, netsvc
import datetime
import openerp.netsvc
import xlwt
import time
#logger = netsvc.Logger()

class brief_journal_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "brief.journal.report"
    _description = "Brief Journal Report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'start_date': fields.date("Start Date", required=True),
        'end_date': fields.date("End Date", required=True),
    }
    
    
    
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
        'start_date': lambda *a: time.strftime('%Y-01-01'),
        'end_date': lambda *a: time.strftime('%Y-%m-%d'),
    }
    

    # Override
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['model'] = 'account.invoice'
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
       
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Receivables Detailed Ledger')
        styles = self.get_easyxf_styles()
        report_title = u"Санхүү, эдийн засгийн сайдын 2002 оны  191  тоот тушаалаар батлав"
        report_name = u'ЖУРНАЛЫН ТОВЧОО'
        sheet.portrait=True
        
        ezxf = xlwt.easyxf
        sheet.row(4).height = 500
        sheet.write_merge(0, 1,3, 4,  report_title, ezxf('font: bold off;align:wrap on,vert centre,horiz right;'))
        sheet.write_merge(5,5,3,4, u'Журналын төрөл: ЖТ №  ¹', ezxf('font: bold off;align:wrap on,vert centre,horiz centre;'))
        
        
        sheet.write(5, 0, u'Байгууллагын нэр: %s' %(data['company_id'][1]), ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write_merge(3, 3,0,4, report_name, ezxf('font: bold on; align: wrap off, vert centre, horiz centre;font: height 200'))
        
        date_str = '%s-%s' % (
                datetime.datetime.strptime(data['start_date'],'%Y-%m-%d').strftime('%Y.%m.%d'),
                datetime.datetime.strptime(data['end_date'],'%Y-%m-%d').strftime('%Y.%m.%d')
            )
        
        sheet.write(8, 1, u'Тайлант хугацаа: %s'% (date_str,)
                 ,ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
        today = fields.date.context_today(self,cr,uid,context=context)         
        sheet.write(8, 3, u'Бэлтгэсэн : %s өдөр '% (today,)
                 ,ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
        rowx = 10
        sheet.row(10).height = 500
        sheet.write_merge(rowx, rowx, 0, 0, u'Д/д', styles['heading_xf'])
        sheet.write_merge(rowx, rowx, 1, 1, u'Тайлбар', styles['heading_xf'])
        sheet.write_merge(rowx, rowx, 2, 2, u'Дүн', styles['heading_xf'])
        sheet.write_merge(rowx, rowx, 3, 3, u'Дансны дебет', styles['heading_xf'])
        sheet.write_merge(rowx, rowx, 4, 4, u'Дансны кридет', styles['heading_xf'])
        sellers =15
        rowx += 3

        sheet.write_merge(rowx, rowx, 0, 0, u' ', styles['text_center_xf'])
        sheet.write_merge(rowx, rowx, 1, 1, u' ', styles['text_center_xf'])
        sheet.write_merge(rowx, rowx, 2, 2, u'Дүн', styles['text_center_xf'])
        sheet.write_merge(rowx, rowx, 3, 3, u' ', styles['text_center_xf'])
        sheet.write_merge(rowx, rowx, 4, 4, u' ', styles['text_center_xf'])
        

        inch = 1000
        sheet.col(0).width = 1.5*inch
        sheet.col(1).width = 10*inch
        sheet.col(2).width = 4*inch
        sheet.col(3).width = 5*inch 
        sheet.col(4).width = 5*inch
        rowx += 5
        sheet.write(rowx+3, 1, u'Хөтөлсөн нягтлан бодогч.........................................../\
                                                 /',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))
        sheet.write(rowx+5, 1, u'Хянасан ерөнхий (ахлах) нягтлан бодогч....................................../\
                                                 /', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))
        
        return {'data':book}
brief_journal_report()