# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2013 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
from StringIO import StringIO
#import xlrd, base64, time, datetime, xlwt, netsvc
import datetime
import openerp.netsvc
import xlwt
import time
#logger = netsvc.Logger()

class cash_payment_journal_currency_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "cash.payment.journal.currency.report"
    _description = "Cash payment Journal Report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'partner_id': fields.many2one('res.partner', 'Partner', required=True), 
        'date': fields.date("Date", required=True),
    }
    
    
    
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
        'date': lambda *a: time.strftime('%Y-%m-%d'),
    }
    

    # Override
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['model'] = 'account.invoice'
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
       
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Receivables Detailed Ledger')
        styles = self.get_easyxf_styles()
        report_title = u"Санхүү, эдийн засгийн сайдын 2002 оны  191  тоот тушаалаар батлав"
        report_name = u'МӨНГӨНИЙ ЗАРЛАГЫН ЖУРНАЛ'
        sheet.portrait=True
        
        ezxf = xlwt.easyxf
        sheet.row(4).height = 500
        sheet.write_merge(0, 1,4, 8,  report_title, ezxf('font: bold off;align:wrap on,vert centre,horiz right;'))
        sheet.write_merge(5,5,4,6, u'Журналын төрөл: МЗ-1  ¹', ezxf('font: bold off;align:wrap on,vert centre,horiz centre;'))
        
        
        sheet.write(5, 0, u'Байгууллагын нэр: %s' %(data['company_id'][1]), ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(6,0, u'Дансны нэр: ________________________', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(7,0, u'Дансны дугаар: _____________________', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write_merge(3, 3,0,6, report_name, ezxf('font: bold on; align: wrap off, vert centre, horiz centre;font: height 200'))
        sheet.write(8, 3, u'Тайлант хугацаа: %s '%
                (datetime.datetime.strptime(data['date'],'%Y-%m-%d').strftime('%Y.%m.%d'),
                 ),ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
        sheet.write(8, 7, u'Бэлтгэсэн ……. сар %s өдөр '%
                (datetime.datetime.strptime(data['date'],'%Y-%m-%d').strftime('%Y.%m.%d'),
                 ),ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
        rowx = 10
        sheet.row(10).height = 500
        sheet.write_merge(rowx, rowx+2, 0, 0, u'Д/д', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+2, 1, 1, u'Он,сар өдөр', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+2, 2, 2, u'Баримтын дугаар', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+2, 3, 3, u'Гүйлгээний утга', styles['heading_xf'])
        sheet.write_merge(rowx, rowx, 4, 10, u'Дебетлэгдсэн дансны нэр, код', styles['heading_xf'])
        sheet.write_merge(rowx+1, rowx+1, 4, 7, u'Валютын касс, харилцах', styles['heading_xf'])
        sheet.write(rowx+2, 4, u'Валютын нэр', styles['heading_xf'])
        sheet.write(rowx+2, 5, u'Ханш', styles['heading_xf'])
        sheet.write(rowx+2, 6, u'Хэмжээ', styles['heading_xf'])
        sheet.write(rowx+2, 7, u'Төгрөгийн дүн', styles['heading_xf'])
        sheet.write_merge(rowx+1, rowx+2, 8, 8, u'Ханшийн зөрүүгийн алдагдал', styles['heading_xf'])
        sheet.write_merge(rowx, rowx, 11, 14, u'Кредитлэгдсэн дансны нэр, код', styles['heading_xf'])
        sheet.write_merge(rowx+1, rowx+2, 11, 11, u'Өглөгийн данс', styles['heading_xf'])
        sheet.write_merge(rowx, rowx, 15, 17, u'Бусад', styles['heading_xf'])
        sheet.write_merge(rowx+1, rowx+2, 15, 15, u'Дүн', styles['heading_xf'])
        sheet.write_merge(rowx+1, rowx+1, 16, 17, u'Дансны нэр, код', styles['heading_xf'])
        sheet.write(rowx+2, 16, u'Дебет', styles['heading_xf'])
        sheet.write(rowx+2, 17, u'Кредит', styles['heading_xf'])
        sellers =15
        rowx += 3



        inch = 1000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 3*inch
        sheet.col(3).width = 5*inch 
        sheet.col(4).width = 2*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 2*inch
        sheet.col(8).width = 2*inch
        sheet.col(9).width = 2*inch
        sheet.col(10).width = 2*inch
        sheet.col(11).width = 2*inch
        sheet.col(12).width = 2*inch
        sheet.col(13).width = 2*inch
        rowx += 5
        sheet.write(rowx+3, 2, u'Хөтөлсөн нягтлан бодогч.........................................../\
                                                 /',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))
        sheet.write(rowx+5, 2, u'Хянасан ерөнхий (ахлах) нягтлан бодогч....................................../\
                                                 /', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))
        
        return {'data':book}
cash_payment_journal_currency_report()