# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2013 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
from StringIO import StringIO
#import xlrd, base64, time, datetime, xlwt, netsvc
import datetime
import openerp.netsvc
import xlwt
import time
#logger = netsvc.Logger()

class cash_receipt_journal_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "cash.receipt.journal.report"
    _description = "Cash receipt Journal Report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'account_id': fields.many2one('account.account', 'Account',required=True),
        'start_date': fields.date("Start date", required=True),
        'end_date':fields.date('End date',required=True),
    }
        
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
        'start_date': lambda *a: time.strftime("%Y-%m-01"),
        'end_date': lambda *a: time.strftime('%Y-%m-%d'),
    }
    

    # Override
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['model'] = 'account.invoice'
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
       
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Receivables Detailed Ledger')
        styles = self.get_easyxf_styles()
        report_title = u"Санхүү, эдийн засгийн сайдын 2002 оны  191  тоот тушаалаар батлав"
        report_name = u'МӨНГӨНИЙ ОРЛОГЫН ЖУРНАЛ'
        sheet.portrait=True
        
        ezxf = xlwt.easyxf
        data_style = ezxf('font: bold off; align: wrap on, vert centre, horiz centre; font: height 200;borders: left thin, right thin, top thin, bottom thin;')

        sheet.row(4).height = 500
        sheet.write_merge(0, 1, 8, 12,  report_title, ezxf('font: bold off;align:wrap on,vert centre,horiz right;font: height 200'))
        sheet.write_merge(5, 5, 10, 12, u'Журналын төрөл: МО-1 ¹', ezxf('font: bold off;align:wrap on,vert centre,horiz centre;font: height 200'))
        
        sheet.write_merge(3, 3, 0, 12, report_name, ezxf('font: bold on; align: wrap off, vert centre, horiz centre;font: height 220'))
        sheet.write(7, 1, u'Тайлант хугацаа: %s '%
                (datetime.datetime.strptime(data['start_date'],'%Y-%m-%d').strftime('%Y.%m.%d'),
                 ),ezxf('font:bold off;align:wrap off,vert centre,horiz left;font: height 200'))
        sheet.write(7, 5, u'Бэлтгэсэн ……. сар %s өдөр '%
                (datetime.datetime.strptime(data['end_date'],'%Y-%m-%d').strftime('%Y.%m.%d'),
                 ),ezxf('font:bold off;align:wrap off,vert centre,horiz left;font: height 200'))
        rowx = 10
        sheet.row(10).height = 500
        sheet.write_merge(rowx, rowx+2, 0, 0, u'№', data_style)
        sheet.write_merge(rowx, rowx+2, 1, 1, u'Сар өдөр', data_style)
        sheet.write_merge(rowx, rowx+2, 2, 2, u'Баримтын дугаар', data_style)
        sheet.write_merge(rowx, rowx+2, 3, 3, u'Гүйлгээний утга', data_style)
        sheet.write_merge(rowx, rowx+1, 4, 5, u'Дебетлэгдсэн дансны нэр, код', data_style)
        sheet.write_merge(rowx, rowx+1, 6, 9, u'Кредитлэгдсэн дансны нэр, код',data_style)
        sheet.write_merge(rowx, rowx, 10, 12, u'Бусад', data_style)
        sheet.write_merge(rowx+1, rowx+2, 10, 10, u'Дүн', data_style)
        sheet.write_merge(rowx+1, rowx+1, 11, 12, u'Дансны нэр, код', data_style)
        sheet.write(rowx+2, 4, u'', data_style)
        sheet.write(rowx+2, 5, u'', data_style)
        sheet.write(rowx+2, 6, u'', data_style)
        sheet.write(rowx+2, 7, u'', data_style)
        sheet.write(rowx+2, 8, u'', data_style)
        sheet.write(rowx+2, 9, u'', data_style)
        sheet.write(rowx+2, 11, u'', data_style)
        sheet.write(rowx+2, 12, u'', data_style)
        rowx = 13
        row = 0
        for row in range(0,13):
            sheet.write(rowx, row, u'%s'%row, data_style)
            row +=1
        rowx = 14
        statement_obj = self.pool.get('account.bank.statement')
        statement_line = self.pool.get('account.bank.statement.line')
        move_line_obj = self.pool.get('account.move.line')
        move_obj = self.pool.get('account.move')
        
        statement_id = statement_obj.search(cr, uid, [('company_id','=',data['company_id'][0]),('date','>=',data['start_date']),('date','<=',data['end_date']),('state','=','confirm')])
        start_balance = 0
        end_balance = 0
        for balance in statement_obj.browse(cr, uid, statement_id):
            start_balance +=balance.balance_start 
        sheet.write(rowx, 0, u'', data_style)
        sheet.write(rowx, 1, u'', data_style)
        sheet.write(rowx, 2, u'', data_style)
        sheet.write(rowx, 3, u'Эхний үлдэгдэл', data_style)
        sheet.write(rowx, 4, u'', data_style)
        sheet.write(rowx, 5, u'', data_style)
        sheet.write(rowx, 6, u'', data_style)
        sheet.write(rowx, 7, u'', data_style)
        sheet.write(rowx, 8, u'', data_style)
        sheet.write(rowx, 9, u'', data_style)
        sheet.write(rowx, 10, u'%s'%start_balance, data_style)
        sheet.write(rowx, 11, u'', data_style)
        sheet.write(rowx, 12, u'', data_style)
        rowx +=1
        sum = 0
        num = 0
        comp = self.pool.get('res.company')
        res = comp.browse(cr, uid, comp.search(cr, uid, [('id','=',data['company_id'][0])]))[0]
        line_ids = move_line_obj.browse(cr, uid, move_line_obj.search(cr, uid, [('account_id','=',data['account_id'][0]),('debit','>',0.0)]))
        for lines in line_ids:
            move_id = move_obj.search(cr, uid, [('id','=',lines.move_id.id),('date','>=',data['start_date']),('date','<=',data['end_date']),('state','=','posted')])
            for move in move_obj.browse(cr, uid, move_id):
                    num +=1
                    sum +=lines.debit
                    sheet.write(rowx, 0, u'%s'%num, data_style)
                    sheet.write(rowx, 1, u'%s'%move.date, data_style)
                    sheet.write(rowx, 2, u'%s'%move.name, data_style)
                    sheet.write(rowx, 3, u'%s'%lines.name, data_style)
                    sheet.write(rowx, 4, u'%s'%move.journal_id.default_debit_account_id.name, data_style)
                    sheet.write(rowx, 5, u'%s'%move.journal_id.default_debit_account_id.code, data_style)
                    sheet.write(rowx, 10, u'%s'%lines.debit, data_style)
                    sheet.write(rowx, 8, u'%s'%lines.account_id.name, data_style)
                    sheet.write(rowx, 9, u'%s'%lines.account_id.code, data_style)
                    sheet.write(rowx, 6, u'', data_style)
                    sheet.write(rowx, 7, u'', data_style)
                    sheet.write(rowx, 12, u'', data_style)
                    sheet.write(rowx, 11, u'', data_style)
                    rowx +=1
        end_balance = start_balance + sum
        sheet.write_merge(rowx, rowx , 0, 3, u'Дүн', data_style)
        sheet.write(rowx, 4, u'', data_style)
        sheet.write(rowx, 5, u'', data_style)
        sheet.write(rowx, 6, u'', data_style)
        sheet.write(rowx, 7, u'', data_style)
        sheet.write(rowx, 8, u'', data_style)
        sheet.write(rowx, 9, u'', data_style)
        sheet.write(rowx, 10, u'%s'%sum, data_style)
        sheet.write(rowx, 11, u'', data_style)
        sheet.write(rowx, 12, u'', data_style)
        sheet.write_merge(rowx+1, rowx+1, 0, 3, u'Эцсийн үлдэгдэл', data_style)
        sheet.write(rowx+1, 4, u'', data_style)
        sheet.write(rowx+1, 5, u'', data_style)
        sheet.write(rowx+1, 6, u'', data_style)
        sheet.write(rowx+1, 7, u'', data_style)
        sheet.write(rowx+1, 8, u'', data_style)
        sheet.write(rowx+1, 9, u'', data_style)
        sheet.write(rowx+1, 10, u'%s'%end_balance, data_style)
        sheet.write(rowx+1, 11, u'', data_style)
        sheet.write(rowx+1, 12, u'', data_style)
                
        

        inch = 1000
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 3*inch
        sheet.col(2).width = 4*inch
        sheet.col(3).width = 4*inch 
        sheet.col(4).width = 4*inch
        sheet.col(5).width = 3*inch
        sheet.col(6).width = 4*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 4*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.col(12).width = 2*inch
        sheet.col(13).width = 2*inch
        rowx += 5
        sheet.write(rowx+3, 0, u'Хөтөлсөн нягтлан бодогч_______________________________(_______________________)',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 200'))
              
        return {'data':book,}
cash_receipt_journal_report()