# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
from StringIO import StringIO
#import xlrd, base64, time, datetime, xlwt, netsvc
import datetime
import openerp.netsvc
import xlwt
import time
#logger = netsvc.Logger()

class entity_income_tax_report(osv.osv_memory):
    """
        Нэмэгдсэн өртгийн албан татвар
        Increased cost ministerial tax
    """
    _inherit = "abstract.report.excel"
    _name = "entity.income.tax.report"
    _description = "Entity income tax"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'fiscalyear_id': fields.many2one('account.fiscalyear', 'Fiscal Year', required=True),
        'date_from': fields.date('Start Date', required=True),
        'date_to': fields.date('End Date', required=True),
        'target_move': fields.selection([('posted', 'All Posted Entries'),
                                         ('all', 'All Entries'),
                                        ], 'Target Moves', required=True)
    }
    
    def _get_account(self, cr, uid, context=None):
        accounts = self.pool.get('account.account').search(cr, uid, [('parent_id', '=', False)], limit=1)
        return accounts and accounts[0] or False
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c=None:obj.pool.get('res.company')._company_default_get(cr,uid,'account.stockholders.equity.report',context=c),
        'date_from': lambda *a: time.strftime('%Y-01-01'),
        'date_to': lambda *a: time.strftime("%Y-%m-%d"),
        'target_move': 'posted',
        'fiscalyear_id': lambda obj,cr,uid,c=None:obj.pool.get('account.fiscalyear').find(cr, uid, context=c)
    }
    
    def onchange_fiscalyear(self, cr, uid, ids, fiscalyear, context=None):
        fy = self.pool.get('account.fiscalyear').browse(cr, uid, fiscalyear, context=context)
        date_from = fy.date_start
        date_to = fy.date_stop
        now_day = time.strftime('%Y-%m-%d')
        if now_day > date_from and now_day < date_to:
            date_to = now_day
        return {'value':{'date_from':date_from,'date_to':date_to}}
    
    def prepare_data(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids[0], context=context)
        
        data = {
            'ids': ids,
            'model': 'bbsb.account.stockholders.equity.report',
            'form': {
                'company_id': obj.company_id.id,
                'date_from': obj.date_from,
                'date_to': obj.date_to,
                'target_move': obj.target_move,
                'fiscalyear_id': obj.fiscalyear_id.id,
                'save': obj.save
            },
            'report_name':'bbsb.account.stockholders.equity.report'
        }
        
#        if obj.date_from < obj.fiscalyear_id.date_start or \
#           obj.date_from > obj.fiscalyear_id.date_stop or \
#           obj.date_to < obj.fiscalyear_id.date_start or \
#           obj.date_to > obj.fiscalyear_id.date_stop:
#            raise osv.except_osv(_('Integrity Error!'), _('The report duration does not correct for this fiscalyear: %s') % form.fiscalyear_id.name)
#        
#        company = obj.company_id
#        if not company.property_statutory_fund_account or\
#           not company.property_treasury_stock_account or\
#           not company.property_additional_capital_account or\
#           not company.property_revaluation_addition_account or\
#           not company.property_foreign_currency_conversion_account or\
#           not company.property_stockholders_equity_remainder_account or\
#           not company.property_previous_retained_earnings_account or\
#           not company.property_period_retained_earnings_account or\
#           not company.property_dividend_expense_account or\
#           not company.property_adjustment_journal or\
#           not company.property_equity_changes_journal :
#            raise osv.except_osv(_('Integrity Error!'), _('There is no completely necessary data in your company configuration for Statement of stockholders equity report.'))
#        
        return data
    
    def get_log_message(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids[0], context=context)
        
        body = u"Өмчийн өөрчлөлтийн тайлан (Эхлэх='%s', Дуусах='%s')" % (obj.date_from, obj.date_to)
        return body
    
    def get_export_data(self, cr, uid, ids, context=None):
        ''' Тайлангийн загварыг боловсруулж өгөгдлүүдийг
            тооцоолж байрлуулна.
        '''
        if context is None:
            context = {}
        datas = self.prepare_data(cr, uid, ids, context=context)
        data = datas['form']
        
        company = self.pool.get('res.company').browse(cr, uid, data['company_id'])
        
        date_str = '%s-%s' % (
            datetime.strptime(data['date_from'],'%Y-%m-%d').strftime('%Y.%m.%d'),
            datetime.strptime(data['date_to'],'%Y-%m-%d').strftime('%Y.%m.%d')
        )
        
        document_code = ''
        directory_name = False
        if data['save']:
            generate_barcode = report_service.get_report_barcode(cr, context=context)
            document_code = report_service.code
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        data_styless = ezxf('font: bold off; align: wrap on, vert centre, horiz left;font: height 180;borders: left thick, right thick, top thick, bottom thick;')
        header = ezxf('font:bold on;align:wrap off,vert centre,horiz left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet(u'Entity incoming tax')
        date_to_obj = datetime.strptime(data['date_to'],'%Y-%m-%d')
        sheet.write_merge(0, 0, 0, 5, u'   Татварын Ерөнхий Газрын даргын 2012 оны 05 сарын 10-ны ºдрийí 492 дугаар тушаалын 2 дугаар хавсралт', header )
        sheet.write(1, 0, u'Маягт ТT-03а', header )
        sheet.write(1, 1, u'ҮНДЭСНИЙ ТАТВАРЫН АЛБА', header )
        sheet.write(2, 3, u'', ezxf('font:bold off;align:wrap off,vert centre,horiz right;'))
        
        sheet.write(2, 1, u'Аж ахуй нэгжийн орлогын албан татварын тайлан', ezxf('font: bold on; align: wrap off, vert centre, horiz left;font: height 250'))
        sheet.row(2).height = 400
        
        sheet.write(4, 0, u'ТТД: |__|__|__|__|__|__|__|   2. Нэр:  _____________________________________   3. Хариуцлагын хэлбэр: ______________', header)
        sheet.write(5, 0, u'4. Тайлант хугацаа: он |__|__|__|__| улирал |__|     (   ) Тухайн тайлант хугацаанд їйл ажиллагаа эрхлээгїй бол (х)-ээр тэмдэглэнэ.',header)
        sheet.write(6, 0, u'5. Татвар төлөгчийн одоогийн хаяг : ', header )
        sheet.write(7, 0, u'|__|__|         Аймаг, хот: ______________________________  |__|__|         Сум, дүүрэг: ______________________________________ ', header )
        sheet.write(8, 0, u'|__|__|         Баг, хороо: ______________________________   |__|__|__|    Гудамж, хороолол: ________________________________   ', header )
        sheet.write(9, 0, u'|__|__|__|    Байр:   __________________________________   |__|__|__|    Хашаа, хаалга: ____________________________________', header )
        sheet.write(10, 0, u'Утас 1: ______________________________ Утас 2: ______________________________ Факс : ______________________________', header )
        sheet.write(11, 0, u'Ш/хайрцаг No: ____________________________________    И-мэйл хаяг: _______________________________________________', header )
        sheet.write(12, 0, u'6. Эрхлэх үйл ажиллагаа:  Їндсэн: код |__|__|__|__|__|__| ____________________________________________________________', header )
        sheet.write(13, 0, u'Туслах: код |__|__|__|__|__|__| ____________________________________________________________', header )
        sheet.write(14, 0, u'Туслах: код |__|__|__|__|__|__| ____________________________________________________________', header )
        sheet.write(15, 0, u'7. Толгой компанийн регистр, нэр |__|__|__|__|__|__|__|   ____________________________________________________________', header )
        sheet.write(16, 0, u'8. Салбар компанийн тоо |__|__|__|,  нэрс _________________________________________________________________________', header )
        sheet.write(17, 0, u'______________________________________________________________________________________________________________', header )
        sheet.write(18, 0, u'9. Гадаадын хөрөнгө оруулалтын эзлэх хувь |__|__|, хэмжээ ________________________________________________________', header )

        rowx = 19

        sheet.write(rowx+2, 0, u'А. Нийтлэг хувь хэмжээгээр ногдуулах татварын тооцоолол:           (мянган төгрөгєєр)', ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
        sheet.write_merge(rowx+4, rowx+4, 0, 19, u'Үзүүлэлтүүд', data_styless)
        sheet.write_merge(rowx+4, rowx+4, 20,21, u'Мөр', data_styless)
        sheet.write_merge(rowx+4, rowx+4, 22, 23, u'Татвар төлөгчийн тодорхойлсон', data_styless)
        sheet.write_merge(rowx+4, rowx+4, 24, 25, u'Татварын алба хүлээн авсан', data_styless)

        sheet.write_merge(rowx+5, rowx+5, 0, 19, u'1. Нийт орлогын дүн (мөр 2+3+4+5+6)', data_styless)
        sheet.write_merge(rowx+5, rowx+5, 20,21, u'1', data_styless)
        sheet.write_merge(rowx+5, rowx+5, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+5, rowx+5, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+6, rowx+6, 0,0, u'Үүнээс:', data_styless)
        sheet.write_merge(rowx+6, rowx+6, 1, 19, u'1.1. Татвараас чөлөөлөгдөх орлогын дүн (Маягт ТТ-02(б), А хэсгийн дүн)', data_styless)
        sheet.write_merge(rowx+6, rowx+6, 20, 21, u'2', data_styless)
        sheet.write_merge(rowx+6, rowx+6, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+6, rowx+6, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+7, rowx+7, 1, 19, u'1.2. Тусгай хувь хэмжээгээр татвар ногдох орлогын дүн (Хїснэгт Б,  мөр 32+34+39+41+43)', data_styless)
        sheet.write_merge(rowx+7, rowx+7, 20, 21, u'3', data_styless)
        sheet.write_merge(rowx+7, rowx+7, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+7, rowx+7, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+8, rowx+8, 1, 19, u'1.3. Хуулийн дагуу бусдад татвар суутгуулсан орлогын дүн (Хїснэгт В, мөр 46+48+50+52)', data_styless)
        sheet.write_merge(rowx+8, rowx+8, 20,21, u'4', data_styless)
        sheet.write_merge(rowx+8, rowx+8, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+8, rowx+8, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+9, rowx+9, 1, 19, u'1.4. Бусад орлогын дүн', data_styless)
        sheet.write_merge(rowx+9, rowx+9, 20,21, u'5', data_styless)
        sheet.write_merge(rowx+9, rowx+9, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+9, rowx+9, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+10, rowx+10, 1, 19, u'1.5. Нийтлэг хувь хэмжээгээр татвар ногдох орлогын дүн (мөр 7+8+…+17)', data_styless)
        sheet.write_merge(rowx+10, rowx+10, 20,21, u'6', data_styless)
        sheet.write_merge(rowx+10, rowx+10, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+10, rowx+10, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+11, rowx+11, 1, 1, u'Үүнээс:', data_styless)
        sheet.write_merge(rowx+11, rowx+11, 2, 19, u'Үндсэн үйлдвэрлэл, ажил үйлчилгээний борлуулалтын орлого', data_styless)
        sheet.write_merge(rowx+11, rowx+11, 20,21, u'7', data_styless)
        sheet.write_merge(rowx+11, rowx+11, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+11, rowx+11, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+12, rowx+12, 2, 19, u'Туслах үйлдвэрлэл, ажил үйлчилгээний борлуулалтын орлого', data_styless)
        sheet.write_merge(rowx+12, rowx+12, 20,21, u'8', data_styless)
        sheet.write_merge(rowx+12, rowx+12, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+12, rowx+12, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+13, rowx+13, 2, 19, u'Хувьцаа, үнэт цаас борлуулсны орлого', data_styless)
        sheet.write_merge(rowx+13, rowx+13, 20,21, u'9', data_styless)
        sheet.write_merge(rowx+13, rowx+13, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+13, rowx+13, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+14, rowx+14, 2, 19, u'Үнэ төлбөргүйгээр бусдаас авсан бараа, ажил, үйлчилгээ', data_styless)
        sheet.write_merge(rowx+14, rowx+14, 20,21, u'10', data_styless)
        sheet.write_merge(rowx+14, rowx+14, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+14, rowx+14, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+15, rowx+15, 2, 19, u'Биет бус хөрөнгө борлуулсны орлого', data_styless)
        sheet.write_merge(rowx+15, rowx+15, 20,21, u'11', data_styless)
        sheet.write_merge(rowx+15, rowx+15, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+15, rowx+15, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+16, rowx+16, 2, 19, u'Техникийн, удирдлагын зөвлөх болон бусад үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+16, rowx+16, 20,21, u'12', data_styless)
        sheet.write_merge(rowx+16, rowx+16, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+16, rowx+16, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+17, rowx+17, 2, 19, u'Гэрээгээр хүлээсэн үүргээ биелүүлээгүй этгээдээс авсан хүү, анз /торгууль, алданги/, хохирлын нөхөн төлбөрийн орлого', data_styless)
        sheet.write_merge(rowx+17, rowx+17, 20,21, u'13', data_styless)
        sheet.write_merge(rowx+17, rowx+17, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+17, rowx+17, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+18, rowx+18, 2, 19, u'Гадаад валютын ханшийн зөрүүгийн бодит орлого', data_styless)
        sheet.write_merge(rowx+18, rowx+18, 20,21, u'14', data_styless)
        sheet.write_merge(rowx+18, rowx+18, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+18, rowx+18, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+19, rowx+19, 2, 19, u'Хөдлөх болон үл хөдлөх эд хөрөнгийн түрээсийн орлого', data_styless)
        sheet.write_merge(rowx+19, rowx+19, 20,21, u'15', data_styless)
        sheet.write_merge(rowx+19, rowx+19, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+19, rowx+19, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+20, rowx+20, 2, 19, u'Хөдлөх эд хөрөнгө борлуулсны орлого', data_styless)
        sheet.write_merge(rowx+20, rowx+20, 20,21, u'16', data_styless)
        sheet.write_merge(rowx+20, rowx+20, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+20, rowx+20, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+21, rowx+21, 2, 19, u'Албан татвар ногдох бусад орлого', data_styless)
        sheet.write_merge(rowx+21, rowx+21, 20,21, u'17', data_styless)
        sheet.write_merge(rowx+21, rowx+21, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+21, rowx+21, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+22, rowx+22, 0, 19, u'2. Борлуулсан бүтээгдэхүүний өртөг', data_styless)
        sheet.write_merge(rowx+22, rowx+22, 20,21, u'18', data_styless)
        sheet.write_merge(rowx+22, rowx+22, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+22, rowx+22, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+23, rowx+23, 0, 19, u'3. Удирдлагын болон борлуулалтын үйл ажиллагааны зардал ', data_styless)
        sheet.write_merge(rowx+23, rowx+23, 20,21, u'19', data_styless)
        sheet.write_merge(rowx+23, rowx+23, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+23, rowx+23, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+24, rowx+24, 0, 19, u'4. Үндсэн бус үйл ажиллагааны зардал', data_styless)
        sheet.write_merge(rowx+24, rowx+24, 20,21, u'20', data_styless)
        sheet.write_merge(rowx+24, rowx+24, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+24, rowx+24, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+25, rowx+25, 2, 19, u'5. Татварын өмнөх ашиг +, алдагдал - (мөр 1-18-19-20)', data_styless)
        sheet.write_merge(rowx+25, rowx+25, 20,21, u'21', data_styless)
        sheet.write_merge(rowx+25, rowx+25, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+25, rowx+25, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+26, rowx+26, 2, 19, u'6. Хуульд заасан татвар ногдох орлогоос хасагдахгүй зардлын дүн буюу “Санхүүгийн болон орлогын албан татварын тайлангийн үзүүлэлт хоорондын зөрүүг зохицуулах тайлан”-гийн А1, В3 мөрийн нийлбэр дүн /татварын өмнөх ашгийг нэмэгдүүлэх дүн/', data_styless)
        sheet.write_merge(rowx+26, rowx+26, 20,21, u'22', data_styless)
        sheet.write_merge(rowx+26, rowx+26, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+26, rowx+26, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+27, rowx+27, 2, 19, u'7. “Санхүүгийн болон орлогын албан татварын тайлангийн үзүүлэлт хоорондын зөрүүг зохицуулах тайлан”-гийн A2, В4 мөрийн дүн буюу татвар ногдуулах орлогыг бууруулах дүн', data_styless)
        sheet.write_merge(rowx+27, rowx+27, 20,21, u'23', data_styless)
        sheet.write_merge(rowx+27, rowx+27, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+27, rowx+27, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+28, rowx+28, 2, 19, u'8. Татвар ногдуулах орлогын дүн (мөр 21+22-23)', data_styless)
        sheet.write_merge(rowx+28, rowx+28, 20,21, u'24', data_styless)
        sheet.write_merge(rowx+28, rowx+28, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+28, rowx+28, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+29, rowx+29, 2, 19, u'9. Сайн дурын даатгалын хураамжийн хэтрэлт (“Санхүүгийн болон орлогын албан татварын тайлангийн үзүүлэлт хоорондын зөрүүг зохицуулах тайлан”-гийн 5.1 дэх мөрийн дүн)', data_styless)
        sheet.write_merge(rowx+29, rowx+29, 20,21, u'25', data_styless)
        sheet.write_merge(rowx+29, rowx+29, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+29, rowx+29, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+30, rowx+30, 2, 19, u'10. Зохицуулагдсан татвар ногдуулах орлогын дүн (мөр 24+25)', data_styless)
        sheet.write_merge(rowx+30, rowx+30, 20,21, u'26', data_styless)
        sheet.write_merge(rowx+30, rowx+30, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+30, rowx+30, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+31, rowx+31, 2, 19, u'11. Өмнөх жилүүдийн татварын тайлангаар гарсан татварын албаар баталгаажуулсан алдагдлаас тайлант хугацаанд шилжүүлсэн дүн (Маягт ТТ-02(в), А хїснэгтийн 3 дахь хэсгийн дїн)', data_styless)
        sheet.write_merge(rowx+31, rowx+31, 20,21, u'27', data_styless)
        sheet.write_merge(rowx+31, rowx+31, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+31, rowx+31, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+32, rowx+32, 2, 19, u'12. Нийтлэг хувь хэмжээгээр татвар ногдуулах орлогын дүн (мөр 26-27)', data_styless)
        sheet.write_merge(rowx+32, rowx+32, 20,21, u'28', data_styless)
        sheet.write_merge(rowx+32, rowx+32, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+32, rowx+32, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+33, rowx+33, 2, 19, u'13. Ногдуулсан татвар (мєр 28 x хуулийн 17.1-д заасан хувиар)', data_styless)
        sheet.write_merge(rowx+33, rowx+33, 20,21, u'29', data_styless)
        sheet.write_merge(rowx+33, rowx+33, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+33, rowx+33, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+34, rowx+34, 2, 19, u'14. Хөнгөлөгдөх татварын дүн  (Маягт ТТ-02(б), Б хїснэгтийн дүн)', data_styless)
        sheet.write_merge(rowx+34, rowx+34, 20,21, u'30', data_styless)
        sheet.write_merge(rowx+34, rowx+34, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+34, rowx+34, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+35, rowx+35, 2, 19, u'15. НИЙТЛЭГ ХУВЬ ХЭМЖЭЭГЭЭР ТӨЛБӨЛ ЗОХИХ АЛБАН ТАТВАР (мөр 29-30)', data_styless)
        sheet.write_merge(rowx+35, rowx+35, 20,21, u'31', data_styless)
        sheet.write_merge(rowx+35, rowx+35, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+35, rowx+35, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+36, rowx+36, 0, 19, u'Б. Тусгай хувь хэмжээгээр ногдуулах татварын тооцоолол:', data_styless)
        sheet.write_merge(rowx+37, rowx+37, 0, 19, u'16. Эротик хэвлэл, ном зохиол, дүрс бичлэг худалдсан буюу төлбөртэй ашиглуулсан, эротик тоглолт явуулсан үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+37, rowx+37, 20,21, u'32', data_styless)
        sheet.write_merge(rowx+37, rowx+37, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+37, rowx+37, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+38, rowx+38, 1, 19, u'Эротик хэвлэл, ном зохиол, дүрс бичлэг худалдсан буюу төлбөртэй ашиглуулсан, эротик тоглолт явуулсан үйлчилгээний орлогод ногдуулсан татвар (32 х 40 хувь)', data_styless)
        sheet.write_merge(rowx+38, rowx+38, 20,21, u'33', data_styless)
        sheet.write_merge(rowx+38, rowx+38, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+38, rowx+38, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+39, rowx+39, 0, 19, u'17.Төлбөрт таавар, бооцоот тоглоом, эд мөнгөний хонжворт сугалааны орлого', data_styless)
        sheet.write_merge(rowx+39, rowx+39, 20, 21, u'34', data_styless)
        sheet.write_merge(rowx+39, rowx+39, 22,23, u'', data_styless)
        sheet.write_merge(rowx+39, rowx+39, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+40, rowx+40, 1, 19, u'Баримтаар нотлогдох зардал', data_styless)
        sheet.write_merge(rowx+40, rowx+40, 20,21, u'35', data_styless)
        sheet.write_merge(rowx+40, rowx+40, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+40, rowx+40, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+41, rowx+41, 1, 19, u'Хонжворт олгосон мөнгө болон барааны үнэ', data_styless)
        sheet.write_merge(rowx+41, rowx+41, 20,21, u'36', data_styless)
        sheet.write_merge(rowx+41, rowx+41, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+41, rowx+41, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+42, rowx+42, 1, 19, u'Татвар ногдуулах орлого (мөр 34-35-36)', data_styless)
        sheet.write_merge(rowx+42, rowx+42, 20,21, u'37', data_styless)
        sheet.write_merge(rowx+42, rowx+42, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+42, rowx+42, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+43, rowx+43, 1, 19, u'Ногдуулсан татвар (37 x 40 хувь)', data_styless)
        sheet.write_merge(rowx+43, rowx+43, 20,21, u'38', data_styless)
        sheet.write_merge(rowx+43, rowx+43, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+43, rowx+43, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+44, rowx+44, 0, 19, u'18.Хүүгийн орлого', data_styless)
        sheet.write_merge(rowx+44, rowx+44, 20,21, u'39', data_styless)
        sheet.write_merge(rowx+44, rowx+44, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+44, rowx+44, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+45, rowx+45, 1, 19, u'Хүүгийн орлогод ногдуулсан татвар (39 x 10 хувь)', data_styless)
        sheet.write_merge(rowx+45, rowx+45, 20,21, u'40', data_styless)
        sheet.write_merge(rowx+45, rowx+45, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+45, rowx+45, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+46, rowx+46, 0, 19, u'19. Давхар татварын гэрээтэй гадаад улсад олсон тухайн гэрээнд заасны дагуу Монгол Улсад татвар ногдуулах ногдол ашиг, хүүгийн орлого', data_styless)
        sheet.write_merge(rowx+46, rowx+46, 20,21, u'41', data_styless)
        sheet.write_merge(rowx+46, rowx+46, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+46, rowx+46, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+47, rowx+47, 1, 19, u'Давхар татварын гэрээний заалтын дагуу Монгол Улсад татвар төлөх ногдол ашиг, хүүгийн орлогод ногдох татвар (мөр 41 x  гэрээнд заасан хувиар)', data_styless)
        sheet.write_merge(rowx+47, rowx+47, 20,21, u'42', data_styless)
        sheet.write_merge(rowx+47, rowx+47, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+47, rowx+47, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+48, rowx+48, 0, 19, u'20. Гадаад улсад олсон ААНОАТ-ын хуульд заасан тусгайлсан хувь хэмжээгээр албан татвар ногдуулах орлого /суутгагч нь оршин суугч бус этгээд бол/', data_styless)
        sheet.write_merge(rowx+48, rowx+48, 20,21, u'43', data_styless)
        sheet.write_merge(rowx+48, rowx+48, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+48, rowx+48, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+49, rowx+49, 1, 19, u' Гадаад улсад олсон ААНОАТ-ын хуульд заасан тусгайлсан хувь хэмжээгээр албан татвар ногдуулах орлогод суутгасан татвар (мөр 43 x  хуульд заасан хувиар)', data_styless)
        sheet.write_merge(rowx+49, rowx+49, 20,21, u'44', data_styless)
        sheet.write_merge(rowx+49, rowx+49, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+49, rowx+49, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+50, rowx+50, 0, 19, u'21. ТУСГАЙ ХУВЬ ХЭМЖЭЭГЭЭР ТӨЛБӨЛ ЗОХИХ АЛБАН ТАТВАРЫН ДҮН (мөр 33+38+40+42+44) ', data_styless)
        sheet.write_merge(rowx+50, rowx+50, 20,21, u'45', data_styless)
        sheet.write_merge(rowx+50, rowx+50, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+50, rowx+50, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+52, rowx+52, 0, 0, u'В. Хуулийн дагуу бусдад суутгуулсан татварын тооцоолол:', data_styless)
        sheet.write_merge(rowx+54, rowx+54, 0, 19, u'22. Ногдол ашгийн орлого', data_styless)
        sheet.write_merge(rowx+54, rowx+54, 20,21, u'46', data_styless)
        sheet.write_merge(rowx+54, rowx+54, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+54, rowx+54, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+55, rowx+55, 1, 19, u'Ногдол ашгийн орлогод суутгуулсан татвар (мєр 46 х 10 хувь)', data_styless)
        sheet.write_merge(rowx+55, rowx+55, 20,21, u'47', data_styless)
        sheet.write_merge(rowx+55, rowx+55, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+55, rowx+55, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+56, rowx+56, 0, 19, u'23. Эрхийн шимтгэлийн орлого', data_styless)
        sheet.write_merge(rowx+56, rowx+56, 20,21, u'48', data_styless)
        sheet.write_merge(rowx+56, rowx+56, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+56, rowx+56, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+57, rowx+57, 0, 19, u'Эрхийн шимтгэлийн орлогод суутгуулсан татвар (мєр 48 х 10 хувь)', data_styless)
        sheet.write_merge(rowx+57, rowx+57, 20,21, u'49', data_styless)
        sheet.write_merge(rowx+57, rowx+57, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+57, rowx+57, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+58, rowx+58, 0, 19, u'24. Эрх борлуулсны орлого', data_styless)
        sheet.write_merge(rowx+58, rowx+58, 20,21, u'50', data_styless)
        sheet.write_merge(rowx+58, rowx+58, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+58, rowx+58, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+59, rowx+59, 1, 19, u'Эрх борлуулсны орлогод суутгуулсан татвар (50 х 30 хувь)', data_styless)
        sheet.write_merge(rowx+59, rowx+59, 20,21, u'51', data_styless)
        sheet.write_merge(rowx+59, rowx+59, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+59, rowx+59, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+60, rowx+60, 0, 19, u'25. Їл хєдлєх эд хєрєнгє борлуулсны орлого', data_styless)
        sheet.write_merge(rowx+60, rowx+60, 20,21, u'52', data_styless)
        sheet.write_merge(rowx+60, rowx+60, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+60, rowx+60, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+61, rowx+61, 1, 19, u'Їл хєдлєх эд хєрєнгє борлуулсны орлогод суутгуулсан татвар (52 х 2 хувь)', data_styless)
        sheet.write_merge(rowx+61, rowx+61, 20,21, u'53', data_styless)
        sheet.write_merge(rowx+61, rowx+61, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+61, rowx+61, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+62, rowx+62, 1, 19, u'26. ХУУЛИЙН ДАГУУ БУСДАД СУУТГУУЛСАН АЛБАН ТАТВАРЫН ДҮН (мөр 47+49+51+53)', data_styless)
        sheet.write_merge(rowx+62, rowx+62, 20,21, u'54', data_styless)
        sheet.write_merge(rowx+62, rowx+62, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+62, rowx+62, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+63, rowx+63, 0, 19, u'23. НИЙТ ТӨЛБӨЛ ЗОХИХ ТАТВАРЫН ДҮН (Хїснэгт А, мөр 31+Хїснэгт Б, мєр 45+Маягт ТТ-13, мєр 24)', data_styless)
        sheet.write_merge(rowx+63, rowx+63, 20,21, u'55', data_styless)
        sheet.write_merge(rowx+63, rowx+63, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+63, rowx+63, 24, 25, u'', data_styless)

        sheet.write_merge(rowx+65, rowx+65, 0, 19, u'Г. Татварын тооцоолол:              ', data_styless)
        sheet.write_merge(rowx+65, rowx+65, 20,21, u'', data_styless)
        sheet.write_merge(rowx+65, rowx+65, 22, 23, u'Дебет', data_styless)
        sheet.write_merge(rowx+65, rowx+65, 24, 25, u'Кредит', data_styless)
        
        sheet.write_merge(rowx+67, rowx+68, 0, 2, u'Тайлангийн эхний үлдэгдэл', data_styless)
        sheet.write_merge(rowx+67, rowx+67, 3, 19, u'Илүү', data_styless)
        sheet.write_merge(rowx+67, rowx+67, 20,21, u'56', data_styless)
        sheet.write_merge(rowx+67, rowx+67, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+67, rowx+67, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+68, rowx+68, 3, 19, u'Дутуу', data_styless)
        sheet.write_merge(rowx+68, rowx+68, 20,21, u'57', data_styless)
        sheet.write_merge(rowx+68, rowx+68, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+68, rowx+68, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+69, rowx+69, 0, 19, u'Тайлант хугацаанд ногдуулсан татвар (мөр 55)', data_styless)
        sheet.write_merge(rowx+69, rowx+69, 20,21, u'58', data_styless)
        sheet.write_merge(rowx+69, rowx+69, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+69, rowx+69, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+70, rowx+71, 0, 2, u'Тайлант хугацаанд дансаар төлсөн', data_styless)
        sheet.write_merge(rowx+70, rowx+70, 3, 19, u'Гүйцэтгэл', data_styless)
        sheet.write_merge(rowx+70, rowx+70, 20,21, u'59', data_styless)
        sheet.write_merge(rowx+70, rowx+70, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+70, rowx+70, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+71, rowx+71, 3, 19, u'Өөрчлөлт /+,-/', data_styless)
        sheet.write_merge(rowx+71, rowx+71, 20,21, u'60', data_styless)
        sheet.write_merge(rowx+71, rowx+71, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+71, rowx+71, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+72, rowx+72, 0, 19, u'Татварын алба болон татвар төлөгч хоорондын тооцоогоор төлсөн', data_styless)
        sheet.write_merge(rowx+72, rowx+72, 20,21, u'61', data_styless)
        sheet.write_merge(rowx+72, rowx+72, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+72, rowx+72, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+73, rowx+73, 0, 19, u'Бусад татварын илүү төлөлтөөс суутган тооцсон', data_styless)
        sheet.write_merge(rowx+73, rowx+73, 20,21, u'62', data_styless)
        sheet.write_merge(rowx+73, rowx+73, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+73, rowx+73, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+74, rowx+74, 0, 19, u'Буцаан олгосон болон хүчингүй болгосон татвар', data_styless)
        sheet.write_merge(rowx+74, rowx+74, 20,21, u'63', data_styless)
        sheet.write_merge(rowx+74, rowx+74, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+74, rowx+74, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+75, rowx+75, 0, 19, u'Илүү төлөлтөөс бусад татварын өрөнд суутган тооцсон', data_styless)
        sheet.write_merge(rowx+75, rowx+75, 20,21, u'64', data_styless)
        sheet.write_merge(rowx+75, rowx+75, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+75, rowx+75, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+76, rowx+77, 0, 2, u'Тайлангийн эцсийн үлдэгдэл', data_styless)
        sheet.write_merge(rowx+76, rowx+76, 3, 19, u'Илүү', data_styless)
        sheet.write_merge(rowx+76, rowx+76, 20,21, u'65', data_styless)
        sheet.write_merge(rowx+76, rowx+76, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+76, rowx+76, 24, 25, u'', data_styless)
        sheet.write_merge(rowx+77, rowx+77, 3, 19, u'Дутуу', data_styless)
        sheet.write_merge(rowx+77, rowx+77, 20,21, u'66', data_styless)
        sheet.write_merge(rowx+77, rowx+77, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+77, rowx+77, 24, 25, u'', data_styless)

        
        rowx += 1
        inch = 500
        sheet.col(0).width = 2*inch
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 14*inch
        sheet.col(3).width = 2*inch
        sheet.col(4).width = 2*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 2*inch
        sheet.col(8).width = 2*inch
        sheet.col(9).width = 2*inch
        sheet.col(10).width = 2*inch
        sheet.col(11).width = 2*inch
        sheet.col(12).width = 2*inch
        sheet.col(13).width = 2*inch
        sheet.col(14).width = 2*inch
        sheet.col(15).width = 2*inch
        sheet.col(16).width = 2*inch
        sheet.col(17).width = 2*inch
        sheet.col(18).width = 2*inch
        sheet.col(19).width = 2*inch
        sheet.col(20).width = 2*inch
        sheet.col(21).width = 2*inch
        sheet.col(22).width = 2*inch
        sheet.col(23).width = 2*inch
        sheet.row(6).height = 500
        sheet.row(0).height = 600
        rowx += 112
         
        sheet.write(rowx, 1, u'Тайлангийн хугацаанд борлуулсан болон худалдан авсан бараа, ажил, үйлчилгээнд ногдуулсан НӨАТ-ыг бүрэн тусгаж, энэхүү тайланд үнэн зөв тайлагнаснаа баталж байна.',ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
        sheet.write(rowx+2, 2, u'/Тэмдэг/ :',ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
        sheet.write(rowx+2, 3, u'Татвар төлөгчийн гарын үсэг ................... /                           / .............. он ....сар....өдөр',ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
        sheet.write(rowx+3, 3, u'Татварын итгэмжлэгдсэн нягтлан бодогч....................... /                /',ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))

        sheet.write(rowx+4, 2, u'Тэмдэг:', ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
        sheet.write(rowx+4, 3, u'Тайланг хүлээн авсан Татварын улсын байцаагч............................../               /......он.....сар.....өдөр', ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))
        sheet.write(rowx+6, 0, u'Албан татвар төлөгч нь улирлын тайланг дараа улирлын эхний сарын 20-ны дотор,  жилийн эцсийн тайланг дараа оны  2 сарын 10-ны дотор харъяалах татварын албанд тушаана.', ezxf('font: bold off; align: wrap off, vert centre, horiz left;'))

        return {'data':book}
    
entity_income_tax_report()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: