# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2013 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
from StringIO import StringIO
#import xlrd, base64, time, datetime, xlwt, netsvc
import datetime
import openerp.netsvc
import xlwt
import time
#logger = netsvc.Logger()

class general_journal_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "general.journal.report"
    _description = "General Journal Report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        #'partner_id': fields.many2one('accoun.journal', 'Partner', required=True),
        'journal_id': fields.many2one('account.journal', 'Journal', required=True),
        'date': fields.date("Date", required=True),
    }
    _defaults = {
        
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
        'date': lambda *a: time.strftime('%Y-%m-%d'),
        
    }
    

    # Override
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['model'] = 'account.invoice'
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        journal_object = self.pool.get('account.journal')
        account_line = self.pool.get('account.move.line')
        account_object = self.pool.get('account.move')
        account_id = account_object.search(cr, uid, [('journal_id','=',data['journal_id'][0])])
        
        
        
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Receivables Detailed Ledger')
        styles = self.get_easyxf_styles()
        report_title = u"Санхүү, эдийн засгийн сайдын 2002 оны 191 тоот тушаалаар батлав."
        report_name = u'ЕРӨНХИЙ ЖУРНАЛ'
        sheet.portrait=True
        
        ezxf = xlwt.easyxf
        sheet_style = ezxf('font: bold off; align: wrap on, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet.row(4).height = 500
        sheet.write_merge(0, 1,4, 6,  report_title, ezxf('font: bold off;align:wrap on,vert centre,horiz right;font: height 200'))
        sheet.write_merge(5,5,4,6, u'Журналын төрөл ЕЖ ¹', ezxf('font: bold off;align:wrap on,vert centre,horiz centre;font: height 200'))
        
        
        sheet.write(5, 0, u'Байгууллагын нэр: %s' %(data['company_id'][1]), ezxf('font:bold on;align:wrap off,vert centre,horiz left;font: height 200'))
        sheet.write_merge(3, 3,0,6, report_name, ezxf('font: bold on; align: wrap off, vert centre, horiz centre;font: height 220'))
        sheet.write(7, 4, u'Тайлант хугацаа: %s '%
                (datetime.datetime.strptime(data['date'],'%Y-%m-%d').strftime('%Y.%m.%d'),
                 ),ezxf('font:bold off;align:wrap off,vert centre,horiz left;font: height 200'))
        
        rowx = 9
        sheet.row(13).height = 500
        sheet.write_merge(rowx, rowx+1, 0, 0, u'Д/д', sheet_style)
        sheet.write_merge(rowx, rowx, 1, 2, u'Баримтын', sheet_style)
        sheet.write(rowx+1, 1, u'Cар өдөр', sheet_style)
        sheet.write(rowx+1, 2, u'дугаар', sheet_style)
        sheet.write_merge(rowx, rowx+1,3, 3, u'Гүйлгээний утга', sheet_style)
        sheet.write_merge(rowx, rowx+1, 4, 4, u'Дүн', sheet_style)
        sheet.write_merge(rowx, rowx, 5, 6, u'Дансны нэр, код', sheet_style)
        sheet.write(rowx+1, 5, u'Дебет', sheet_style)
        sheet.write(rowx+1, 6, u'Кридет', sheet_style)
        rowx = 11
        number = 1
        sum_debit = 0
        sum_credit = 0
        if account_id != []:
            for line in account_object.browse(cr, uid, account_id):
                account_lineid = account_line.search(cr, uid, [('move_id','=',line.id)])
                
                for lin in account_line.browse(cr, uid, account_lineid):
                    if lin.debit !=0:
                        sheet.write(rowx, 0, u'%d'%number, sheet_style)
                        sheet.write(rowx, 1, u'%s'%line.date, sheet_style)
                        sheet.write(rowx, 2, u'%s'%line.name, sheet_style)
                        sheet.write(rowx, 3, u'%s'%lin.name, sheet_style)
                        sheet.write(rowx, 4, u'%d'%line.amount, sheet_style) 
                        sheet.write(rowx, 5, u'%d'%lin.debit, sheet_style)
                        sum_debit += lin.debit
                    else:
                        sheet.write(rowx, 6, u'%d'%lin.credit, sheet_style)
                        sum_credit += lin.credit
                number+=1
                rowx +=1
                
        sheet.write_merge(rowx, rowx, 0, 4, u'Дүн', sheet_style)
        sheet.write(rowx, 5, u'%d'%sum_debit, sheet_style)
        sheet.write(rowx, 6, u'%d'%sum_credit, sheet_style)
        
        sellers =15
        
        inch = 1500
        sheet.col(0).width = 2*inch
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 5*inch
        sheet.col(3).width = 2*inch #shirheg
        sheet.col(4).width = 2*inch
        #sheet.col(5).width = 2*inch
        #sheet.col(6).width = 2*inch
        #sheet.col(14).width = 2*inch
        
        rowx += 2
        sheet.write(rowx, 2, u'Хөтөлсөн нягтлан бодогч___________________________________(___________________)',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 200'))
        sheet.write(rowx+2, 2, u'Хянасан ерөнхий (ахлах) нягтлан бодогч_____________________________________(___________________)', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 200'))
        
        return {'data':book}

general_journal_report()