# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
from StringIO import StringIO
#import xlrd, base64, time, datetime, xlwt, netsvc
import datetime
import openerp.netsvc
import xlwt
import time
#logger = netsvc.Logger()

class increased_cost_ministerial_tax_report(osv.osv_memory):
    """
        Нэмэгдсэн өртгийн албан татвар
        Increased cost ministerial tax
    """
    _inherit = "abstract.report.excel"
    _name = "increased.cost.ministerial.tax.report"
    _description = "Increased cost ministerial tax"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'fiscalyear_id': fields.many2one('account.fiscalyear', 'Fiscal Year', required=True),
        'date_from': fields.date('Start Date', required=True),
        'date_to': fields.date('End Date', required=True),
        'target_move': fields.selection([('posted', 'All Posted Entries'),
                                         ('all', 'All Entries'),
                                        ], 'Target Moves', required=True)
    }
    
    def _get_account(self, cr, uid, context=None):
        accounts = self.pool.get('account.account').search(cr, uid, [('parent_id', '=', False)], limit=1)
        return accounts and accounts[0] or False
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c=None:obj.pool.get('res.company')._company_default_get(cr,uid,'account.stockholders.equity.report',context=c),
        'date_from': lambda *a: time.strftime('%Y-01-01'),
        'date_to': lambda *a: time.strftime("%Y-%m-%d"),
        'target_move': 'posted',
        'fiscalyear_id': lambda obj,cr,uid,c=None:obj.pool.get('account.fiscalyear').find(cr, uid, context=c)
    }
    
    def onchange_fiscalyear(self, cr, uid, ids, fiscalyear, context=None):
        fy = self.pool.get('account.fiscalyear').browse(cr, uid, fiscalyear, context=context)
        date_from = fy.date_start
        date_to = fy.date_stop
        now_day = time.strftime('%Y-%m-%d')
        if now_day > date_from and now_day < date_to:
            date_to = now_day
        return {'value':{'date_from':date_from,'date_to':date_to}}
    
    def prepare_data(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids[0], context=context)
        
        data = {
            'ids': ids,
            'model': 'bbsb.account.stockholders.equity.report',
            'form': {
                'company_id': obj.company_id.id,
                'date_from': obj.date_from,
                'date_to': obj.date_to,
                'target_move': obj.target_move,
                'fiscalyear_id': obj.fiscalyear_id.id,
                'save': obj.save
            },
            'report_name':'bbsb.account.stockholders.equity.report'
        }
        

        return data
    
    def get_log_message(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids[0], context=context)
        
        body = u"НӨАТ (Эхлэх='%s', Дуусах='%s')" % (obj.date_from, obj.date_to)
        return body
    
    def get_export_data(self, cr, uid, ids, context=None):
        ''' Тайлангийн загварыг боловсруулж өгөгдлүүдийг
            тооцоолж байрлуулна.
        '''
        if context is None:
            context = {}
        datas = self.prepare_data(cr, uid, ids, context=context)
        
        data = datas['form']
        
        company = self.pool.get('res.company').browse(cr, uid, data['company_id'])
        
        date_str = '%s-%s' % (
            datetime.strptime(data['date_from'],'%Y-%m-%d').strftime('%Y.%m.%d'),
            datetime.strptime(data['date_to'],'%Y-%m-%d').strftime('%Y.%m.%d')
        )
               
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        data_styless = ezxf('font: bold off; align: wrap on, vert centre, horiz left;font: height 150;borders: left thin, right thin, top thin, bottom thin;')
        data_styless1 = ezxf('font: bold off; align: wrap on, vert centre, horiz left;font: height 150;borders: left thin, right thin, top thin, bottom thin;')

        header = ezxf('font:bold on; align: wrap off, vert centre, horiz left; font:height 200;')
        header1 = ezxf('font:bold on; align: wrap off, vert centre, horiz left; font:height 200;borders: left thin, right thin, top thin, bottom thin;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet(u'НӨАТ')
        date_to_obj = datetime.strptime(data['date_to'],'%Y-%m-%d')
        sheet.write_merge(0, 0, 0, 23, u'''                                                        ТЕГ-ын даргын 2012 оны 04-р сарын \n
                                                                18-ны өдрийн 326 тоот тушаалын1 дүгээр хавсралт''', header )
        sheet.write(1, 0, u'Маягт ТT-03а                                ҮНДЭСНИЙ ТАТВАРЫН АЛБА', header )
        sheet.write(2, 3, u'', ezxf('font:bold off;align:wrap off,vert centre,horiz right;'))
        
        sheet.write(2, 4, u'Нэмэгдсэн өртгийн албан татварын тайлан', ezxf('font: bold on; align: wrap off, vert centre, horiz left;font: height 250'))
        sheet.row(2).height = 400
        
        sheet.write_merge(4, 4, 3, 9, u'Тайлангийн хугацаа', header1)
        sheet.write_merge(5, 6, 3, 3, u'1', header1)
        sheet.write_merge(5, 5, 4, 7, u'Огноо', header1)
        sheet.write_merge(5, 5, 8, 9, u'Сар', header1)
        sheet.write_merge(6, 6, 4, 7, u'', header1)
        sheet.write_merge(6, 6, 8, 9, u'', header1)
        sheet.write_merge(4, 4, 11, 21, u'Зөвхөн татварын албан ажлын хэрэгцээнд',header1)
        sheet.write_merge(6, 6, 11, 21, u'Татварын алба',header1)
        sheet.write_merge(7, 7, 11, 21, u'Хүлээн авсан он, сар, өдөр          ,        ,         ',header1)
        rowx = 9
        sheet.write_merge(rowx, rowx+1, 0, 0, u'2', data_styless)
        sheet.write_merge(rowx, rowx+1, 1, 8, u'Татвар төлөгчийн нэр:', data_styless)
        sheet.write_merge(rowx, rowx+1, 9, 15, u'', data_styless)
        sheet.write_merge(rowx, rowx+1, 16,16, u'3', data_styless)
        sheet.write_merge(rowx, rowx, 17, 23, u'Татвар төлөгчийн дугаар:', data_styless)
        sheet.write_merge(rowx+2, rowx+3, 0, 0, u'4', data_styless)
        sheet.write_merge(rowx+2, rowx+3, 1, 8, u'Хаяг:', data_styless)
        sheet.write_merge(rowx+2, rowx+3, 9, 15, u'', data_styless)
        sheet.write_merge(rowx+2, rowx+5, 16, 16, u'5', data_styless)
        sheet.write_merge(rowx+2, rowx+2, 17,23, u'Утасны дугаар:', data_styless)
        sheet.write_merge(rowx+4, rowx+5, 0, 0, u'6', data_styless)
        sheet.write_merge(rowx+4, rowx+4, 1, 8, u'Эрхлэх үйл ажиллагааны чиглэл:', data_styless)
        sheet.write_merge(rowx+4, rowx+4, 9, 15, u'Код', data_styless)
        sheet.write_merge(rowx+4, rowx+4, 17,23, u'Факc', data_styless)
        sheet.write_merge(rowx+6, rowx+6, 0, 0, u'7', data_styless)
        sheet.write_merge(rowx+6, rowx+6, 1, 15, u'Толгой компани нэр:', data_styless)
        sheet.write_merge(rowx+6, rowx+6, 16,16, u'8', data_styless)
        sheet.write_merge(rowx+6, rowx+6, 17,23, u'E-mail хаяг:', data_styless)
        sheet.write(rowx+7, 0, u'А.ТУХАЙН САРЫН БОРЛУУЛСАН БАРАА, ГҮЙЦЭТГЭСЭН АЖИЛ ҮЙЛЧИЛГЭЭНИЙ НЭМЭГДСЭН ', ezxf('font: bold on; align: wrap off, vert centre, horiz left;'))
        sheet.write(rowx+8, 0, u'ӨРТГИЙН АЛБАН ТАТВАРЫН ТООЦОО', ezxf('font: bold on; align: wrap off, vert centre, horiz left;'))
        sheet.write_merge(rowx+9, rowx+9, 0, 19, u'* Тухайн сарын нийт борлуулалтын орлого', data_styless)
        sheet.write_merge(rowx+9, rowx+9, 20,21, u'', data_styless)
        sheet.write_merge(rowx+9, rowx+9, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+10, rowx+10, 0, 19, u'* Нэмэгдсэн өртгийн албан татвар ногдох бараа, ажил, үйлчилгээний нийт борлуулалтын орлого', data_styless)
        sheet.write_merge(rowx+10, rowx+10, 20,21, u'', data_styless)
        sheet.write_merge(rowx+10, rowx+10, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+11, rowx+42, 0, 0, u'', data_styless)
        sheet.write_merge(rowx+11, rowx+11, 1,19, u'Бараа борлуулсны орлого:', data_styless)
        sheet.write_merge(rowx+11, rowx+11, 20,21, u'', data_styless)
        sheet.write_merge(rowx+11, rowx+11, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+12, rowx+17, 1, 1, u'Үүнээс', data_styless1)
        sheet.write_merge(rowx+12, rowx+12, 2, 19, u'Дотоодын зах зээлд борлуулсан барааны борлуулалтын орлого', data_styless)
        sheet.write_merge(rowx+12, rowx+12, 20,21, u'', data_styless)
        sheet.write_merge(rowx+12, rowx+12, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+13, rowx+13, 2, 19, u'Аж ахуй болон бизнес эрхлэх эрх худалдсаны орлого', data_styless)
        sheet.write_merge(rowx+13, rowx+13, 20,21, u'', data_styless)
        sheet.write_merge(rowx+13, rowx+13, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+14, rowx+14, 2, 19, u'Татан буугдах үед өөрт үлдээсэн барааны орлого', data_styless)
        sheet.write_merge(rowx+14, rowx+14, 20,21, u'', data_styless)
        sheet.write_merge(rowx+14, rowx+14, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+15, rowx+15, 2, 19, u'Бусад этгээдэд өрийн төлбөр болон өгсөн барааны орлого', data_styless)
        sheet.write_merge(rowx+15, rowx+15, 20,21, u'', data_styless)
        sheet.write_merge(rowx+15, rowx+15, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+16, rowx+16, 2, 19, u'Экспортолсон барааны борлуулалтын орлого', data_styless)
        sheet.write_merge(rowx+16, rowx+16, 20,21, u'', data_styless)
        sheet.write_merge(rowx+16, rowx+16, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+17, rowx+17, 2, 19, u'Бусад барааны борлуулалт', data_styless)
        sheet.write_merge(rowx+17, rowx+17, 20,21, u'', data_styless)
        sheet.write_merge(rowx+17, rowx+17, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+18, rowx+18, 1, 19, u'Борлуулалтын буцаалт, хөнгөлөлт (өмнөх сарын)', data_styless)
        sheet.write_merge(rowx+18, rowx+18, 20,21, u'', data_styless)
        sheet.write_merge(rowx+18, rowx+18, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+19, rowx+19, 1, 19, u'Ажил үйлчилгээ үзүүлсний орлого', data_styless)
        sheet.write_merge(rowx+19, rowx+19, 20,21, u'', data_styless)
        sheet.write_merge(rowx+19, rowx+19, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+20, rowx+41, 1,1, u'Үүнээс', data_styless)
        sheet.write_merge(rowx+20, rowx+20, 2, 19, u'Цахилгаан борлуулсны орлого', data_styless)
        sheet.write_merge(rowx+20, rowx+20, 20,21, u'', data_styless)
        sheet.write_merge(rowx+20, rowx+20, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+21, rowx+21, 2, 19, u'Дулааны эрчим хүч борлуулсны орлого', data_styless)
        sheet.write_merge(rowx+21, rowx+21, 20,21, u'', data_styless)
        sheet.write_merge(rowx+21, rowx+21, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+22, rowx+22, 2, 19, u'Хий /уур/ борлуулсны орлого', data_styless)
        sheet.write_merge(rowx+22, rowx+22, 20,21, u'', data_styless)
        sheet.write_merge(rowx+22, rowx+22, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+23, rowx+23, 2, 19, u'Ус хангамж, ариутгах татуургын борлуулалт', data_styless)
        sheet.write_merge(rowx+23, rowx+23, 20,21, u'', data_styless)
        sheet.write_merge(rowx+23, rowx+23, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+24, rowx+24, 2, 19, u'Шуудагийн үйлчлгээний орлого', data_styless)
        sheet.write_merge(rowx+24, rowx+24, 20,21, u'', data_styless)
        sheet.write_merge(rowx+24, rowx+24, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+25, rowx+25, 2, 19, u'Харилцаа холбоо үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+25, rowx+25, 20,21, u'', data_styless)
        sheet.write_merge(rowx+25, rowx+25, 22, 23, u'', data_styless)
        
        sheet.write_merge(rowx+26, rowx+26, 2, 19, u'Зочид буудлын үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+26, rowx+26, 20,21, u'', data_styless)
        sheet.write_merge(rowx+26, rowx+26, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+27, rowx+27, 2, 19, u'Нийтийн хоол, бар, зоогийн газрын үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+27, rowx+27, 20,21, u'', data_styless)
        sheet.write_merge(rowx+27, rowx+27, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+28, rowx+28, 2, 19, u'Зуучлагчийн үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+28, rowx+28, 20,21, u'', data_styless)
        sheet.write_merge(rowx+28, rowx+28, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+29, rowx+29, 2, 19, u'Бараа түрээслүүлэх, бусад хэлбэрээр эзэмшүүлэх, ашиглуулах үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+29, rowx+29, 20,21, u'', data_styless)
        sheet.write_merge(rowx+29, rowx+29, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+30, rowx+30, 2, 19, u'Байшин барилгад байр түрээслүүлэх буюу бусад хэлбэрээр ашиглуулах үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+30, rowx+30, 20,21, u'', data_styless)
        sheet.write_merge(rowx+30, rowx+30, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+31, rowx+31, 2, 19, u'Байшин барилгаас бусад үл хөдлөх, хөдлөх эд хөрөнгө түрээслүүлэх буюу бусад хэлбэрээр эзэмшүүлэх ашиглуулах үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+31, rowx+31, 20,21, u'', data_styless)
        sheet.write_merge(rowx+31, rowx+31, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+32, rowx+32, 2, 19, u'Шинэ бүтээл, бүтээгдэхүүний загвар, ашигтай загвар, зохиогчийн эрхэд хамаарах бүтээл, барааны тэмдэг, ноу-хау, хөрөнгийн мэдээллийг шилжүүлсэн, түрээсэлсэн,худалдсаны орлого', data_styless)
        sheet.write_merge(rowx+32, rowx+32, 20,21, u'', data_styless)
        sheet.write_merge(rowx+32, rowx+32, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+33, rowx+33, 2, 19, u'Эд мөнгөний хонжворт сугалааны орлого', data_styless)
        sheet.write_merge(rowx+33, rowx+33, 20,21, u'', data_styless)
        sheet.write_merge(rowx+33, rowx+33, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+34, rowx+34, 2, 19, u'Төлбөрт таавар бооцоот тоглоомын үйл ажиллагааны орлого (Оролцогчдын нийт төлсөн мөнгөн дүнгээс хожлын төлбөрт төлсөн мөнгөн дүнг хасч тооцно)', data_styless)
        sheet.write_merge(rowx+34, rowx+34, 20,21, u'', data_styless)
        sheet.write_merge(rowx+34, rowx+34, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+35, rowx+35, 2, 19, u'Бусад этгээдэд өрийн төлбөр болгон гүйцэтгэсэн ажил, үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+35, rowx+35, 20,21, u'', data_styless)
        sheet.write_merge(rowx+35, rowx+35, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+36, rowx+36, 2, 19, u'Бусдаас авсан хүү торгуулийн орлого', data_styless)
        sheet.write_merge(rowx+36, rowx+36, 20,21, u'', data_styless)
        sheet.write_merge(rowx+36, rowx+36, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+37, rowx+37, 2, 19, u'Телевиз, радиогийн үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+37, rowx+37, 20,21, u'', data_styless)
        sheet.write_merge(rowx+37, rowx+37, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+38, rowx+38, 2, 19, u'Интернетийн үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+38, rowx+38, 20,21, u'', data_styless)
        sheet.write_merge(rowx+38, rowx+38, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+39, rowx+39, 2, 19, u'Зар сурталчилгааны үйлчилгээний орлого', data_styless)
        sheet.write_merge(rowx+39, rowx+39, 20,21, u'', data_styless)
        sheet.write_merge(rowx+39, rowx+39, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+40, rowx+40, 2, 19, u'Экспортолсон үйлчилгээний борлуулалтын орлого', data_styless)
        sheet.write_merge(rowx+40, rowx+40, 20,21, u'', data_styless)
        sheet.write_merge(rowx+40, rowx+40, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+41, rowx+41, 2, 19, u'Бусад үйлчилгээний борлуулалт', data_styless)
        sheet.write_merge(rowx+41, rowx+41, 20,21, u'', data_styless)
        sheet.write_merge(rowx+41, rowx+41, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+42, rowx+42, 2, 19, u'Борлуулалтын буцаалт, хөнгөлөлт(өмнөх сарын)', data_styless)
        sheet.write_merge(rowx+42, rowx+42, 20,21, u'', data_styless)
        sheet.write_merge(rowx+42, rowx+42, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+43, rowx+43, 0, 19, u'* Тухайн сарын НӨАТ-аас чөлөөлөгдөх борлуулалт /өөрт хамаарах чөлөөлөгдөх орлогыг гараар бөглөнө/', data_styless)
        sheet.write_merge(rowx+43, rowx+43, 20,21, u'', data_styless)
        sheet.write_merge(rowx+43, rowx+43, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+44, rowx+47, 0, 0, u'Үүнээс', data_styless)
        sheet.write_merge(rowx+44, rowx+44, 1, 19, u'', data_styless)
        sheet.write_merge(rowx+44, rowx+44, 20,21, u'', data_styless)
        sheet.write_merge(rowx+44, rowx+44, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+45, rowx+45, 1, 19, u'', data_styless)
        sheet.write_merge(rowx+45, rowx+45, 20,21, u'', data_styless)
        sheet.write_merge(rowx+45, rowx+45, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+46, rowx+46, 1, 19, u'', data_styless)
        sheet.write_merge(rowx+46, rowx+46, 20,21, u'', data_styless)
        sheet.write_merge(rowx+46, rowx+46, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+47, rowx+47, 1, 19, u'', data_styless)
        sheet.write_merge(rowx+47, rowx+47, 20,21, u'', data_styless)
        sheet.write_merge(rowx+47, rowx+47, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+48, rowx+48, 0, 19, u'* Тухайн сарын нийт борлуулалтаас НӨАТ ногдох бараа ажил, үйлчилгээний борлуулалт', data_styless)
        sheet.write_merge(rowx+48, rowx+48, 20,21, u'', data_styless)
        sheet.write_merge(rowx+48, rowx+48, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+49, rowx+52, 0, 0, u'Үүнээс', data_styless)
        sheet.write_merge(rowx+49, rowx+49, 1, 19, u'Тухайн сарын НӨАТ ногдох экспортын борлуулалт', data_styless)
        sheet.write_merge(rowx+49, rowx+49, 20,21, u'', data_styless)
        sheet.write_merge(rowx+49, rowx+49, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+50, rowx+50, 1, 19, u'Ноогдуулсан татвар', data_styless)
        sheet.write_merge(rowx+50, rowx+50, 20,21, u'', data_styless)
        sheet.write_merge(rowx+50, rowx+50, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+51, rowx+51, 1, 19, u'Тухайн сарын НӨАТ ногдох дотоодын борлуулалт', data_styless)
        sheet.write_merge(rowx+51, rowx+51, 20,21, u'', data_styless)
        sheet.write_merge(rowx+51, rowx+51, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+52, rowx+52, 1, 19, u'Ноогдуулсан татвар', data_styless)
        sheet.write_merge(rowx+52, rowx+52, 20,21, u'', data_styless)
        sheet.write_merge(rowx+52, rowx+52, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+53, rowx+53, 0, 19, u'* Тухайн сард ногдуулсан НӨАТ-ын нийт дүн', data_styless)
        sheet.write_merge(rowx+53, rowx+53, 20,21, u'', data_styless)
        sheet.write_merge(rowx+53, rowx+53, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+54, rowx+54, 0, 19, u'* Тухайн сард худалдан авсан бараа ажил үйлчилгээ (БАҮ)', data_styless)
        sheet.write_merge(rowx+54, rowx+54, 20,21, u'', data_styless)
        sheet.write_merge(rowx+54, rowx+54, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+55, rowx+55, 0, 19, u'* Тухайн сард худалдан авсан БАҮ-нээс НӨАТ-тай худалдан авсан бараа, ажил, үйлчилгээ', data_styless)
        sheet.write_merge(rowx+55, rowx+55, 20,21, u'', data_styless)
        sheet.write_merge(rowx+55, rowx+55, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+56, rowx+58, 0, 0, u'Үүнээс', data_styless)
        sheet.write_merge(rowx+56, rowx+56, 1, 19, u'Импортын бараа, ажил үйлчилгээ (гаалийн байгууллагад төлсөн НӨАТ-ыг оруулахгүй)', data_styless)
        sheet.write_merge(rowx+56, rowx+56, 20,21, u'', data_styless)
        sheet.write_merge(rowx+56, rowx+56, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+57, rowx+57, 1, 19, u'НӨАТ-тай үнээр дотоодын зах зээлээс худалдан авсан бараа, ажил, үйлчилгээ (төлсөн НӨАТ-ыг оруулахгүй)', data_styless)
        sheet.write_merge(rowx+57, rowx+57, 20,21, u'', data_styless)
        sheet.write_merge(rowx+57, rowx+57, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+58, rowx+58, 1, 19, u'Мал аж ахуй, газар тариалангийн үйлдвэрлэл эрхлэгчээс худалдан авсан мах, сүү, өндөг, арьс шир, төмс,хүнсний ногоо, жимс жимсгэнэ, дотооддоо үйлдвэрлэсэн гурил, /үнэнд шингэсэн НӨАТ-ыг оруулахгүй/', data_styless)
        sheet.write_merge(rowx+58, rowx+58, 20,21, u'', data_styless)
        sheet.write_merge(rowx+58, rowx+58, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+59, rowx+59, 0, 19, u'Худалдан авсан бараа бүтээгдэхүүний буцаал, хөнгөлөлт (өмнөх сарын)', data_styless)
        sheet.write_merge(rowx+59, rowx+59, 20,21, u'', data_styless)
        sheet.write_merge(rowx+59, rowx+59, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+60, rowx+60, 0, 19, u'* Худалдаж авсан бараа, ажил, үйлчилгээнд төлсөн НӨАТ-ын нийт дүн', data_styless)
        sheet.write_merge(rowx+60, rowx+60, 20,21, u'', data_styless)
        sheet.write_merge(rowx+60, rowx+60, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+61, rowx+61, 0, 19, u'* Худалдан авсан бараа, ажил, үйлчилгээнд төлсөн хасагдахгүй НӨАТ-ын дүн', data_styless)
        sheet.write_merge(rowx+61, rowx+61, 20,21, u'', data_styless)
        sheet.write_merge(rowx+61, rowx+61, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+62, rowx+64, 0, 0, u'Үүнээс', data_styless)
        sheet.write_merge(rowx+62, rowx+62, 1, 19, u'Суудлын автомашин, түүний эд анги сэлбэгт төлсөн НӨАТ', data_styless)
        sheet.write_merge(rowx+62, rowx+62, 20,21, u'', data_styless)
        sheet.write_merge(rowx+62, rowx+62, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+63, rowx+63, 1, 19, u'Хувьцаа болон ажиллагсдын хэрэгцээнд зориулж худалдан авсан бараа, ажил, үйлчилгээнд төлсөн НӨАТ', data_styless)
        sheet.write_merge(rowx+63, rowx+63, 20,21, u'', data_styless)
        sheet.write_merge(rowx+63, rowx+63, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+64, rowx+64, 1, 19, u'Хуулийн 13 дугаар зүйл заасан чөлөөлөгдөх үйлдвэрлэл, үйлчилгээнд зориулж импортлосон болон худалдаж авсан бараа, ажил, үйлчилгээнд төлсөн НӨАТ', data_styless)
        sheet.write_merge(rowx+64, rowx+64, 20,21, u'', data_styless)
        sheet.write_merge(rowx+64, rowx+64, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+65, rowx+65, 0, 19, u'* Тухайн сард хасагдах НӨАТ-ын дүн', data_styless)
        sheet.write_merge(rowx+65, rowx+65, 20,21, u'', data_styless)
        sheet.write_merge(rowx+65, rowx+65, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+66, rowx+66, 0, 19, u'* ТУХАЙН САРД ТӨЛБӨЛ ЗОХИХ НӨАТ', data_styless)
        sheet.write_merge(rowx+66, rowx+66, 20,21, u'', data_styless)
        sheet.write_merge(rowx+66, rowx+66, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+67, rowx+67, 0, 19, u'* ТУХАЙН САРД БУЦААН АВАХ НӨАТ', data_styless)
        sheet.write_merge(rowx+67, rowx+67, 20,21, u'', data_styless)
        sheet.write_merge(rowx+67, rowx+67, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+69, rowx+69, 0, 19, u'Б. САНХҮҮГИЙН ТҮРЭЭСИЙН ЗҮЙЛИЙН НЭМЭГДСЭН ӨРТГИЙН АЛБАН ТАТВАРЫН ТООЦОО', ezxf('font: bold on; align: wrap off, vert centre, horiz left;'))     
        sheet.write_merge(rowx+71, rowx+71, 0, 19, u'Санхүүгийн түрээсийн зүйлийг санхүүгийн түрээсээр импортлогчийн тухайн сард төлсөн түрээсийн төлбөрийн дүн', data_styless)
        sheet.write_merge(rowx+71, rowx+71, 20,21, u'', data_styless)
        sheet.write_merge(rowx+71, rowx+71, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+72, rowx+72, 0, 19, u'Ногдуулсан НӨАТ', data_styless)
        sheet.write_merge(rowx+72, rowx+72, 20,21, u'', data_styless)
        sheet.write_merge(rowx+72, rowx+72, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+73, rowx+73, 0, 19, u'Санхүүгийн түрээсийн зүйлийг санхүүгийн түрээсээр дотоодын зах зээлд борлуулсны орлого', data_styless)
        sheet.write_merge(rowx+73, rowx+73, 20,21, u'', data_styless)
        sheet.write_merge(rowx+73, rowx+73, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+74, rowx+74, 0, 19, u'Ногдуулсан НӨАТ', data_styless)
        sheet.write_merge(rowx+74, rowx+74, 20,21, u'', data_styless)
        sheet.write_merge(rowx+74, rowx+74, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+75, rowx+75, 0, 19, u'Санхүүгийн түрээсийн зүйлийг санхүүгийн түрээсээр дотоодын зах зээлээс худалдан авахад төлсөн түрээсийн төлбөр', data_styless)
        sheet.write_merge(rowx+75, rowx+75, 20,21, u'', data_styless)
        sheet.write_merge(rowx+75, rowx+75, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+76, rowx+76, 0, 19, u'Хасагдах НӨАТ', data_styless)
        sheet.write_merge(rowx+76, rowx+76, 20,21, u'', data_styless)
        sheet.write_merge(rowx+76, rowx+76, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+77, rowx+77, 0, 19, u'* ТУХАЙН САРД ТӨЛБӨЛ ЗОХИХ НӨАТ', data_styless)
        sheet.write_merge(rowx+77, rowx+77, 20,21, u'', data_styless)
        sheet.write_merge(rowx+77, rowx+77, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+78, rowx+78, 0, 19, u'* ТУХАЙН САРД БУЦААН АВАХ НӨАТ', data_styless)
        sheet.write_merge(rowx+78, rowx+78, 20,21, u'', data_styless)
        sheet.write_merge(rowx+78, rowx+78, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+79, rowx+79, 0, 19, u'В.СУУТГАСАН НЭМЭГДСЭН ӨРТГИЙН АЛБАН ТАТВАРЫН ТООЦОО', data_styless)
        sheet.write_merge(rowx+79, rowx+79, 20,21, u'', data_styless)
        sheet.write_merge(rowx+79, rowx+79, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+80, rowx+80, 0, 19, u'Оршин суугч бус иргэн, хуулийн этгээдээс худалдаж авсан бараа, ажил, үйлчилгээний дүн', data_styless)
        sheet.write_merge(rowx+80, rowx+80, 20,21, u'', data_styless)
        sheet.write_merge(rowx+80, rowx+80, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+81, rowx+81, 0, 19, u'Ногдуулсан НӨАТ буюу ТУХАЙН САРД СУУТГАН ТӨЛБӨЛ ЗОХИХ НӨАТ', data_styless)
        sheet.write_merge(rowx+81, rowx+81, 20,21, u'', data_styless)
        sheet.write_merge(rowx+81, rowx+81, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+82, rowx+82, 0, 19, u'Г.ТУХАЙН САРД НОГДУУЛСАН НЭМЭГДСЭН ӨРТГИЙН АЛБАН ТАТВАРЫН ТООЦОО', ezxf('font: bold on; align: wrap off, vert centre, horiz left;'))
        sheet.write_merge(rowx+84, rowx+87, 0, 2, u'ҮҮНД:', data_styless)
        sheet.write_merge(rowx+84, rowx+84, 3, 19, u'НИЙТ ТӨЛБӨЛ ЗОХИХ НӨАТ', data_styless)
        sheet.write_merge(rowx+84, rowx+84, 20,21, u'', data_styless)
        sheet.write_merge(rowx+84, rowx+84, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+85, rowx+85, 3, 19, u'НИЙТ БУЦААН АВАХ НӨАТ', data_styless)
        sheet.write_merge(rowx+85, rowx+85, 20,21, u'', data_styless)
        sheet.write_merge(rowx+85, rowx+85, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+86, rowx+86, 3, 19, u'ЭЦСИЙН ТООЦООГООР ТӨЛБӨЛ ЗОХИХ НӨАТ', data_styless)
        sheet.write_merge(rowx+86, rowx+86, 20,21, u'', data_styless)
        sheet.write_merge(rowx+86, rowx+86, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+87, rowx+87, 3, 19, u'ЭЦСИЙН ТООЦООГООР БУЦААН АВАХ НӨАТ', data_styless)
        sheet.write_merge(rowx+87, rowx+87, 20,21, u'', data_styless)
        sheet.write_merge(rowx+87, rowx+87, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+89, rowx+89, 0, 19, u'Д.ТАТВАРЫН ТООЦООЛОЛ', ezxf('font: bold on; align: wrap off, vert centre, horiz left;'))        
        sheet.write_merge(rowx+90, rowx+91, 0, 3, u'Тайлангийн эхний үлдэгдэл', data_styless)
        sheet.write_merge(rowx+90, rowx+90, 4, 19, u'Илүү', data_styless)
        sheet.write_merge(rowx+90, rowx+90, 20,21, u'', data_styless)
        sheet.write_merge(rowx+90, rowx+90, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+91, rowx+91, 4, 19, u'Дутуу', data_styless)
        sheet.write_merge(rowx+91, rowx+91, 20,21, u'', data_styless)
        sheet.write_merge(rowx+91, rowx+91, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+92, rowx+93, 0, 3, u'Тайлант хугацаанд ногдуулсан', data_styless)
        sheet.write_merge(rowx+92, rowx+92, 4, 19, u'Илүү /мөр 78/', data_styless)
        sheet.write_merge(rowx+92, rowx+92, 20,21, u'', data_styless)
        sheet.write_merge(rowx+92, rowx+92, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+93, rowx+93, 4, 19, u'Дутуу /мөр 76/', data_styless)
        sheet.write_merge(rowx+93, rowx+93, 20,21, u'', data_styless)
        sheet.write_merge(rowx+93, rowx+93, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+94, rowx+95, 0, 3, u'Тухайн тайлангийн хугацаанд төлсөн татвар', data_styless)
        sheet.write_merge(rowx+94, rowx+94, 4, 19, u'Татвар төлөгчийн тайлагнаснаар ', data_styless)
        sheet.write_merge(rowx+94, rowx+94, 20,21, u'', data_styless)
        sheet.write_merge(rowx+94, rowx+94, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+95, rowx+95, 4, 19, u'Татварын албаны мэдээгээр', data_styless)
        sheet.write_merge(rowx+95, rowx+95, 20,21, u'', data_styless)
        sheet.write_merge(rowx+95, rowx+95, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+96, rowx+96, 0, 19, u'Тухайн тайлангийн хугацаанд төсвөөс буцаан авсан татвар', data_styless)
        sheet.write_merge(rowx+96, rowx+96, 20,21, u'', data_styless)
        sheet.write_merge(rowx+96, rowx+96, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+97, rowx+98, 0, 3, u'Суутган тооцсон', data_styless)
        sheet.write_merge(rowx+97, rowx+97, 4, 19, u'Илүүг', data_styless)
        sheet.write_merge(rowx+97, rowx+97, 20,21, u'', data_styless)
        sheet.write_merge(rowx+97, rowx+97, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+98, rowx+98, 4, 19, u'Дутууг', data_styless)
        sheet.write_merge(rowx+98, rowx+98, 20,21, u'', data_styless)
        sheet.write_merge(rowx+98, rowx+98, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+99, rowx+100, 0, 3, u'Тайлангийн эцсийн үлдэгдэл', data_styless)
        sheet.write_merge(rowx+99, rowx+99, 4, 19, u'Илүү', data_styless)
        sheet.write_merge(rowx+99, rowx+99, 20,21, u'', data_styless)
        sheet.write_merge(rowx+99, rowx+99, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+100, rowx+100, 4, 19, u'Дутуу', data_styless)
        sheet.write_merge(rowx+100, rowx+100, 20,21, u'', data_styless)
        sheet.write_merge(rowx+100, rowx+100, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+102, rowx+102, 0, 19, u'Е.НЭМЭГДСЭН ӨРТГИЙН АЛБАН ТАТВАРЫН ПАДААНЫ ТООЦООЛОЛ', ezxf('font: bold on; align: wrap off, vert centre, horiz left;'))
        sheet.write_merge(rowx+104, rowx+105, 0, 3, u'Тайлангийн эхний үлдэгдэл', data_styless)
        sheet.write_merge(rowx+104, rowx+104, 4, 19, u'Тоо, хэмжээ', data_styless)
        sheet.write_merge(rowx+104, rowx+104, 20,21, u'', data_styless)
        sheet.write_merge(rowx+104, rowx+104, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+105, rowx+105, 4, 19, u'Падааны эхний, эцсийн дугаар', data_styless)
        sheet.write_merge(rowx+105, rowx+105, 20,21, u'', data_styless)
        sheet.write_merge(rowx+105, rowx+105, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+106, rowx+107, 0, 3, u'Тайлант хугацаанд авсан', data_styless)
        sheet.write_merge(rowx+106, rowx+106, 4, 19, u'Тоо, хэмжээ', data_styless)
        sheet.write_merge(rowx+106, rowx+106, 20,21, u'', data_styless)
        sheet.write_merge(rowx+106, rowx+106, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+107, rowx+107, 4, 19, u'Падааны эхний, эцсийн дугаар', data_styless)
        sheet.write_merge(rowx+107, rowx+107, 20,21, u'', data_styless)
        sheet.write_merge(rowx+107, rowx+107, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+108, rowx+109, 0, 3, u'Тайлант хугацаанд зарцуулсан', data_styless)
        sheet.write_merge(rowx+108, rowx+108, 4, 19, u'Тоо, хэмжээ', data_styless)
        sheet.write_merge(rowx+108, rowx+108, 20,21, u'', data_styless)
        sheet.write_merge(rowx+108, rowx+108, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+109, rowx+109, 4, 19, u'Падааны эхний, эцсийн дугаар', data_styless)
        sheet.write_merge(rowx+109, rowx+109, 20,21, u'', data_styless)
        sheet.write_merge(rowx+109, rowx+109, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+110, rowx+111, 0, 3, u'Тайлангийн эцсийн үлдэгдэл', data_styless)
        sheet.write_merge(rowx+110, rowx+110, 4, 19, u'Тоо, хэмжээ', data_styless)
        sheet.write_merge(rowx+110, rowx+110, 20, 21, u'', data_styless)
        sheet.write_merge(rowx+110, rowx+110, 22, 23, u'', data_styless)
        sheet.write_merge(rowx+111, rowx+111, 4, 19, u'Падааны эхний, эцсийн дугаар', data_styless)
        sheet.write_merge(rowx+111, rowx+111, 20,21, u'', data_styless)
        sheet.write_merge(rowx+111, rowx+111, 22, 23, u'', data_styless)
        
        rowx += 1
        inch = 500
        sheet.col(0).width = 2*inch
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 2*inch
        sheet.col(3).width = 2*inch
        sheet.col(4).width = 2*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 2*inch
        sheet.col(8).width = 2*inch
        sheet.col(9).width = 2*inch
        sheet.col(10).width = 2*inch
        sheet.col(11).width = 2*inch
        sheet.col(12).width = 2*inch
        sheet.col(13).width = 2*inch
        sheet.col(14).width = 2*inch
        sheet.col(15).width = 2*inch
        sheet.col(16).width = 2*inch
        sheet.col(17).width = 2*inch
        sheet.col(18).width = 2*inch
        sheet.col(19).width = 2*inch
        sheet.col(20).width = 2*inch
        sheet.col(21).width = 2*inch
        sheet.col(22).width = 2*inch
        sheet.col(23).width = 2*inch
        sheet.row(0).height = 600
        sheet.row(39).height = 600
        sheet.row(40).height = 600
        sheet.row(41).height = 600
        sheet.row(43).height = 600
        sheet.row(52).height = 600
        sheet.row(66).height = 600
        sheet.row(67).height = 700
        sheet.row(72).height = 600
        sheet.row(73).height = 600
        sheet.row(80).height = 600
        sheet.row(84).height = 600
        rowx += 112
         
        sheet.write(rowx, 1, u'Тайлангийн хугацаанд борлуулсан болон худалдан авсан бараа, ажил, үйлчилгээнд ногдуулсан',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 150;'))
        sheet.write(rowx+1, 1, u'НӨАТ-ыг бүрэн тусгаж, энэхүү тайланд үнэн зөв тайлагнаснаа баталж байна.',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 150;'))
        sheet.write(rowx+3, 3, u'Тэмдэг:',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 150;'))
        sheet.write(rowx+3, 5, u'Татвар төлөгчийн гарын үсэг ................... /                           / .............. он ....сар....өдөр',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 150;'))
        sheet.write(rowx+4, 5, u'Татварын итгэмжлэгдсэн нягтлан бодогч....................... /                /',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 150;'))

        sheet.write(rowx+6, 3, u'Тэмдэг:', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 150;'))
        sheet.write(rowx+6, 5, u'Тайланг хүлээн авсан Татварын улсын байцаагч............................../               /......он.....сар.....өдөр', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 150;'))
         
        return {'data':book,}
    
increased_cost_ministerial_tax_report()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: