# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2013 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from lxml import etree
from openerp.osv import fields, osv

from openerp.tools.translate import _
from operator import itemgetter
from StringIO import StringIO
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta
#import xlrd, base64, time, datetime, xlwt, netsvc
import openerp.netsvc
import xlwt
from datetime import timedelta, datetime, date
import time

#logger = netsvc.Logger()

class payable_detail_register(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "payable.detail.register"
    _description = "payable Detail Register"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'partner_id': fields.many2one('res.partner', 'Partner', required=True), 
        'account_id': fields.many2one('account.account','Account',required=False),
        'date_start': fields.date("Start Date", required=True),
        'date_end': fields.date("End Date", required=True),
    }
     
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
        'date_end': lambda *a: time.strftime('%Y-%m-%d'),
    }
    

    # Override
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['model'] = 'account.invoice'
        datas['form'] = self.read(cr, uid, ids)[0]
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;', '#,##0.00;#,##0.00')
        
        
        if not data['account_id']:
            self.context = context
            ctx = self.context.copy()
            ctx1 = self.context.copy()
            ctx['date_from'] = data['date_start']
            ctx['date_to'] = data['date_end']
            ctx1['date_from'] = time.strftime("%Y-01-01")
            ctx1['date_to'] = data['date_start']
            
            today1 = ctx1['date_to']
            yesterday = datetime.strptime(today1,'%Y-%m-%d') - timedelta(days = 1)
            kk = datetime.strftime(yesterday,'%Y-%m-%d')
            ctx2 = ctx1
            ctx2['date_to'] = kk
            
            acc_move = self.pool.get('account.move')
            partner = self.pool.get('res.partner')
            acc_move_line = self.pool.get('account.move.line')      #account move line-ii object
            aml = acc_move_line.search(cr, uid, [('partner_id', '=', data['partner_id'][0])], order = "date")       #харилцагчаар шүүж авах
            
            #am = acc_move.browse(cr, uid, acc_move.search(cr, uid, [('partner_id', '=', data['partner_id'][0]),('date','>=',data['date_start']),('date','<=',data['date_end'])],order="date"))
            am_start = acc_move.browse(cr, uid, acc_move.search(cr, uid, [('partner_id', '=', data['partner_id'][0]),('date','<',data['date_start'])],order="date"))
            part = partner.browse(cr, uid, partner.search(cr, uid, [('id','=',data['partner_id'][0])]))
            
            bank = ' '
            for bank_id in part[0].bank_ids:
                if bank == ' ':
                    bank = bank_id.bank_name + ', ' + bank_id.acc_number
                else:
                    bank= bank + ', ' + bank_id.bank_name + ' ' + bank_id.acc_number
                    
            street = part[0].street
            city = part[0].city
            phone = part[0].phone
            fax = part[0].fax
            debit=0
            credit=0
            total_debit=0
            total_credit=0
            
            book = xlwt.Workbook(encoding='utf8')
            sheet = book.add_sheet('Payables Detailed Ledger')
            report_title = u"Санхүү, эдийн засгийн сайдын 2002 оны 191 тоот тушаалаар батлав"
            report_name = u'Өглөгийн дансны дэлгэрэнгүй бүртгэл'
            sheet.portrait=False
            
            today = date.today()
            
            ezxf = xlwt.easyxf
            sheet.write(0, 7, u'Санхүү эдийн засгийн сайдын', ezxf('font: bold off;align:wrap off,vert centre;'))
            sheet.write(1, 7, u'2002 оны 191 тоот тушаалаар батлав', ezxf('font: bold off;align:wrap off,vert centre;'))
            sheet.write(4, 4, u'Дэлгэрэнгүй бүртгэл АВ-1 №', ezxf('font: bold off;align:wrap off,vert centre,;'))
            sheet.write_merge(4, 4, 7, 9, u'Тайлангийн хугацаа:        ' + u'%s' %(data['date_start'] + '  -  ' + data['date_end']), ezxf('font: bold off;align:wrap off,vert centre,horiz right;'))
                      
            sheet.write(4, 1, u'Байгууллагын нэр: %s' %(data['company_id'][1]), ezxf('align:wrap off,vert centre,horiz left;'))
            sheet.write_merge(2, 2, 3, 6, report_name, ezxf('font: bold on; align: wrap off, vert centre;font: height 200'))
            
            sheet.write_merge(6, 6, 1, 2, u'ТТД (регистр)', style1)
            sheet.write_merge(6, 6, 3, 5, u'Бэлтгэн нийлүүлэгчийн нэр', style1)
            sheet.write_merge(6, 6, 6, 7, u'Хаяг: утас, факс, шуудан', style1)
            sheet.write_merge(6, 6, 8, 9, u'Харилцах дансны нэр, дугаар', style1)
            
            sheet.write_merge(7, 8, 1, 2, u'%s' %(part[0].ref or ''), style1)
            sheet.write_merge(7, 8, 3, 5, u'%s'% data['partner_id'][1], style1)
            sheet.write_merge(7, 8, 6, 7, u'%s, %s, %s, %s' %(street or '', city or '', phone or '', fax or '') ,style1)
            sheet.write_merge(7, 8, 8, 9, u'%s' %(bank or ''), style1)
            rowx = 10
            sheet.row(9).height = 500
            sheet.row(7).height = 500
    
            
            sheet.write_merge(rowx, rowx+1, 1, 1, u'Cар өдөр', style1)
            sheet.write_merge(rowx, rowx+1, 2, 2, u'Журналын төрөл', style1)
            sheet.write_merge(rowx, rowx+1, 3, 5, u'Гүйлгээний утга', style1)
            sheet.write_merge(rowx, rowx, 6, 7, u'Гүйлгээний дүн', style1)
            sheet.write_merge(rowx+1, rowx+1, 6, 6, u'Дебет', style1)
            sheet.write_merge(rowx+1, rowx+1, 7, 7, u'Кредит', style1)
            sheet.write_merge(rowx, rowx, 8, 9, u'Үлдэгдэл', style1)
            sheet.write_merge(rowx+1, rowx+1, 8, 8, u'Дебет', style1)
            sheet.write_merge(rowx+1, rowx+1, 9, 9, u'Кредит', style1)
            
            sheet.write_merge(rowx+2, rowx+2, 1, 1, u'1', style1)
            sheet.write_merge(rowx+2, rowx+2, 2, 2, u'2', style1)
            sheet.write_merge(rowx+2, rowx+2, 3, 5, u'3', style1)
            sheet.write_merge(rowx+2, rowx+2, 6, 6, u'4', style1)
            sheet.write_merge(rowx+2, rowx+2, 7, 7, u'5', style1)
            sheet.write_merge(rowx+2, rowx+2, 8, 8, u'6', style1)
            sheet.write_merge(rowx+2, rowx+2, 9, 9, u'7', style1)
            
            debit = am_start.amount
            credit = 0
            cons_debit = debit      #Эхний үлдэгдэл, Гүйлгээний дүн, Дебит
            cons_credit = credit    #Эхний үлдэгдэл, Гүйлгээний дүн, Кредит
            #--------------------------- print 'debit11', cons_debit,cons_credit
            if credit > debit:
                    credit = credit-debit
                    debit=0
            else:
                    debit=debit-credit
                    credit=0
            
            sheet.write_merge(rowx+3, rowx+3, 1, 1, u' ', style1)
            sheet.write_merge(rowx+3, rowx+3, 2, 2, u' ', style1)
            sheet.write_merge(rowx+3, rowx+3, 3, 5, u'Эхний үлдэгдэл', style1)
            sheet.write_merge(rowx+3, rowx+3, 6, 6, '', style1)
            sheet.write_merge(rowx+3, rowx+3, 7, 7, '', style1)
            sheet.write_merge(rowx+3, rowx+3, 8, 8, debit, style1)
            sheet.write_merge(rowx+3, rowx+3, 9, 9, credit, style1)
            rowx+=3
            
            for movess in acc_move_line.browse(cr, uid, aml):
                acc_move = self.pool.get('account.move')
                #acc_move_id =  acc_move.browse(cr, uid, [('id', '=', movess.move_id.id),('date','>=', data['date_start']), 'date', '<=', data['date_end']])
                acc_move_id =  acc_move.browse(cr, uid, movess.move_id.id)
                #print 'amamam', acc_move_id.date,movess.name
                if acc_move_id.date >= data['date_start'] and acc_move_id.date <= data['date_end']:
                    if movess.account_id.type == 'payable':
                        if movess.partner_id == acc_move_id.partner_id:
                            debit=movess.debit
                            credit=movess.credit
                            
                            cr.execute("select jour.type from account_journal as jour where id='%d'"%movess.journal_id)
                            jour=cr.fetchone()
                            rowx=rowx+1
                            sheet.write_merge(rowx, rowx, 1, 1, u'%s' %acc_move_id.date, style1)
                            sheet.write_merge(rowx, rowx, 2, 2, u'%s' %jour, style1)
                            sheet.write_merge(rowx, rowx, 3, 5, u'%s' %(in_name or ''), style1)
                            sheet.write_merge(rowx, rowx, 6, 6, debit, style1)
                            sheet.write_merge(rowx, rowx, 7, 7, credit, style1)
                            
                            #Авлагын данстай холбоотой тул дебит дансдуудад л өгөгдөл орно, кредит нь 0 байна
                            debit=debit+movess.debit   
                            credit=credit+movess.credit
                            total_debit=total_debit+movess.debit    #Дүн, гүйлгээний дүн, дебит
                            total_credit=total_credit+movess.credit #Дүн, гүйлгээний дүн, кредит
                            
                            if credit > debit:
                                credit = credit-debit
                                debit=0
                                sheet.write_merge(rowx, rowx, 8, 8, total_debit, style1)
                                sheet.write_merge(rowx, rowx, 9, 9, total_credit, style1)
                            else:
                                debit=debit-credit
                                credit=0
                                sheet.write_merge(rowx, rowx, 8, 8, total_debit, style1)
                                sheet.write_merge(rowx, rowx, 9, 9, total_credit, style1)
            
                in_name = ''
                if in_name != '':
                    if movess.name != "/":
                        in_name=movess.name
                else:
                    if movess.name != "/":
                        in_name = in_name +', '+ movess.name
            rowx = rowx
            
            cons_debit=cons_debit+total_debit
            cons_credit=cons_credit+total_credit
                     
            sheet.write_merge(rowx+1, rowx+1, 1, 1, u' ', style1)
            sheet.write_merge(rowx+1, rowx+1, 2, 2, u' ', style1)
            sheet.write_merge(rowx+1, rowx+1, 3, 5, u'Дүн', style1)
            sheet.write_merge(rowx+1, rowx+1, 6, 6, total_debit, style1)
            sheet.write_merge(rowx+1, rowx+1, 7, 7, total_credit, style1)
            sheet.write_merge(rowx+1, rowx+1, 8, 8, u' ', style1)
            sheet.write_merge(rowx+1, rowx+1, 9, 9, u' ', style1)
            
            sheet.write_merge(rowx+2, rowx+2, 1, 1, u' ', style1)
            sheet.write_merge(rowx+2, rowx+2, 2, 2, u' ', style1)
            sheet.write_merge(rowx+2, rowx+2, 3, 5, u'Эцсийн үлдэгдэл', style1)
            sheet.write_merge(rowx+2, rowx+2, 6, 6, u'', style1)
            sheet.write_merge(rowx+2, rowx+2, 7, 7, u'', style1)
            #sheet.write_merge(rowx+2, rowx+2, 6, 6, u'%s'%(cons_debit or''), style1)
            #sheet.write_merge(rowx+2, rowx+2, 7, 7, u'%s'%(cons_credit or ''), style1)
            sheet.write_merge(rowx+2, rowx+2, 8, 8, cons_debit, style1)
            sheet.write_merge(rowx+2, rowx+2, 9, 9, cons_credit, style1)
    
    
            inch = 1500
            inch1 = 2200
            inch2 = 3750
            sheet.col(0).width = 2*inch
            sheet.col(1).width = 2*inch
            sheet.col(2).width = 2*inch
            sheet.col(3).width = inch1 #shirheg
            sheet.col(4).width = inch1
            sheet.col(5).width = inch1
            sheet.col(6).width = inch2
            sheet.col(7).width = inch2
            sheet.col(8).width = inch2
            sheet.col(9).width = inch2
            
            sheet.write(rowx+4, 3, u'Хөтөлсөн нягтлан бодогч.........................................../\
                                                     /',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))
            sheet.write(rowx+5, 3, u'Хянасан ерөнхий (ахлах) нягтлан бодогч....................................../\
                                                     /', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))
            sheet.write_merge(rowx+7, rowx+7, 1, 2, u'Хэвлэсэн огноо:', ezxf('font: bold off, italic on, height 200;align:wrap off,vert centre, horiz left;'))
            sheet.write_merge(rowx+7, rowx+7, 3, 6, u'%s -ны өдөр' %today, ezxf('font: bold off, italic on, height 200;align:wrap off,vert centre, horiz left;'))
        # Данс дээр данс сонгосон үед хийх тооцоолол
        else:
            self.context = context
            ctx = self.context.copy()
            ctx1 = self.context.copy()
            ctx['date_from'] = data['date_start']
            ctx['date_to'] = data['date_end']
            ctx1['date_from'] = time.strftime("%Y-01-01")
            ctx1['date_to'] = data['date_start']
        
            today1 = ctx1['date_to']
            yesterday = datetime.strptime(today1,'%Y-%m-%d') - timedelta(days = 1)
            kk = datetime.strftime(yesterday,'%Y-%m-%d')
            ctx2 = ctx1
            ctx2['date_to'] = kk
            
            account = self.pool.get('account.account')
            partner = self.pool.get('res.partner')
            acc_move = self.pool.get('account.move')
            am = acc_move.browse(cr, uid, acc_move.search(cr, uid, [('partner_id', '=', data['partner_id'][0]),('date','>=',data['date_start']),('date','<=',data['date_end'])],order="date"))            
            
            part = partner.browse(cr, uid, partner.search(cr, uid, [('id','=',data['partner_id'][0])]))
            acc_ctx= account.browse(cr, uid, account.search(cr, uid, [('id','=',data['account_id'][0])]),ctx)
            acc_ctx1 = account.browse(cr, uid, account.search(cr, uid, [('id','=',data['account_id'][0])]),ctx2)
            acc = account.browse(cr, uid, account.search(cr, uid, [('id','=',data['account_id'][0])]))
            
            street = part[0].street
            city = part[0].city
            phone = part[0].phone
            fax = part[0].fax
            
            bank = ' '
            for bank_id in part[0].bank_ids:
                if bank == ' ':
                    bank = str(bank_id.bank_name) + ', ' + str(bank_id.acc_number)
                else:
                    bank= bank + ', ' + bank_id.bank_name + ', ' + bank_id.acc_number
            
            debit = acc_ctx1[0].debit
            credit = acc_ctx1[0].credit
            
            if debit == credit:
                debit = 0
                credit = 0
            elif debit > credit:
                debit = debit-credit
                credit = 0
            elif debit < credit:
                credit = credit-debit
                debit = 0
            
            book = xlwt.Workbook(encoding='utf8')
            sheet = book.add_sheet('Payables Detailed Ledger')
            styles = self.get_easyxf_styles()
            report_title = u"Санхүү, эдийн засгийн сайдын 2002 оны 191 тоот тушаалаар батлав"
            report_name = u'Өглөгийн дансны дэлгэрэнгүй бүртгэл'
            sheet.portrait=False
            
            today = date.today()
            
            ezxf = xlwt.easyxf
            sheet.write(0, 7, u'Санхүү эдийн засгийн сайдын', ezxf('font: bold off;align:wrap off,vert centre;'))
            sheet.write(1, 7, u'2002 оны 191 тоот тушаалаар батлав', ezxf('font: bold off;align:wrap off,vert centre;'))
            sheet.write(4, 4, u'Дэлгэрэнгүй бүртгэл АВ-1 №', ezxf('font: bold off;align:wrap off,vert centre,;'))
            sheet.write_merge(4, 4, 7, 9, u'Тайлангийн хугацаа:        ' + u'%s' %(data['date_start'] + '  -  ' + data['date_end']), ezxf('font: bold off;align:wrap off,vert centre,horiz right;'))
            
            
            sheet.write(4, 1, u'Байгууллагын нэр: %s' %(data['company_id'][1]), ezxf('align:wrap off,vert centre,horiz left;'))
            sheet.write_merge(2, 2, 3, 6, report_name, ezxf('font: bold on; align: wrap off, vert centre;font: height 200'))
            
            sheet.write_merge(6, 6, 1, 2, u'ТТД (регистр)', style1)
            sheet.write_merge(6, 6, 3, 5, u'Бэлтгэн нийлүүлэгчийн нэр', style1)
            sheet.write_merge(6, 6, 6, 7, u'Хаяг: утас, факс, шуудан', style1)
            sheet.write_merge(6, 6, 8, 9, u'Харилцах дансны нэр, дугаар', style1)
            
            sheet.write_merge(7, 8, 1, 2, u'%s'%(part[0].ref or ''), style1)
            sheet.write_merge(7, 8, 3, 5, u'%s'% data['partner_id'][1], style1)
            
            if street == False and city != False and phone != False and fax != False:
                sheet.write_merge(7, 8, 6, 7, u'%s %s, %s, %s' %('',city, phone, fax) ,style1)
            elif city == False and street != False and phone != False and fax != False:
                sheet.write_merge(7, 8, 6, 7, u'%s, %s %s, %s' %(street ,'', phone, fax) ,style1)
            elif phone == False and city != False and street != False and fax != False:
                sheet.write_merge(7, 8, 6, 7, u'%s, %s, %s %s' %(street ,city, '', fax) ,style1)
            elif fax == False and city != False and phone != False and street != False:
                sheet.write_merge(7, 8, 6, 7, u'%s, %s, %s, %s' %(street ,city, phone, '') ,style1)
            elif fax == False and city == False and phone == False and street == False:
                sheet.write_merge(7, 8, 6, 7, u'%s %s %s %s' %('' ,'', '', '') ,style1)
            elif fax == False and city == False and phone == False and street != False:
                sheet.write_merge(7, 8, 6, 7, u'%s %s %s %s' %(street ,'', '', '') ,style1)
            elif fax == False and city == False and phone != False and street == False:
                sheet.write_merge(7, 8, 6, 7, u'%s %s %s %s' %('' ,'', phone, '') ,style1)
            elif fax == False and city != False and phone == False and street == False:
                sheet.write_merge(7, 8, 6, 7, u'%s %s %s %s' %('',city, '', '') ,style1)
            elif fax != False and city == False and phone == False and street == False:
                sheet.write_merge(7, 8, 6, 7, u'%s %s %s %s' %('','', '', fax) ,style1)
            elif fax != False and city != False and phone == False and street == False:
                sheet.write_merge(7, 8, 6, 7, u'%s %s, %s %s' %('',city, '', fax) ,style1)
            elif fax != False and city == False and phone != False and street == False:
                sheet.write_merge(7, 8, 6, 7, u'%s %s %s, %s' %('','', phone, fax) ,style1)
            elif fax != False and city == False and phone == False and street != False:
                sheet.write_merge(7, 8, 6, 7, u'%s, %s %s %s' %(street,'', '', fax) ,style1)
            elif fax == False and city == False and phone != False and street != False:
                sheet.write_merge(7, 8, 6, 7, u'%s, %s %s %s' %(street,'', phone, '') ,style1)
            elif fax == False and city != False and phone == False and street != False:
                sheet.write_merge(7, 8, 6, 7, u'%s, %s %s %s' %(street,city, '', '') ,style1)
            elif fax == False and city != False and phone != False and street == False:
                sheet.write_merge(7, 8, 6, 7, u'%s %s, %s %s' %('',city, phone, '') ,style1)
            else:
                sheet.write_merge(7, 8, 6, 7, u'%s, %s, %s, %s' %(street,city, phone, fax) ,style1)
            #sheet.write_merge(7, 7, 6, 7, u'%s, %s, %s, %s' %(street or '',city or '', phone or '', fax or '') ,style1)
            sheet.write_merge(7, 8, 8, 9, u'%s'%(bank or ''), style1)
            
            rowx = 10
            sheet.row(9).height = 500
            sheet.row(7).height = 500
    
            
            sheet.write_merge(rowx, rowx+1, 1, 1, u'Cар өдөр', style1)
            sheet.write_merge(rowx, rowx+1, 2, 2, u'Журналын төрөл', style1)
            sheet.write_merge(rowx, rowx+1, 3, 5, u'Гүйлгээний утга', style1)
            sheet.write_merge(rowx, rowx, 6, 7, u'Гүйлгээний дүн', style1)
            sheet.write_merge(rowx+1, rowx+1, 6, 6, u'Дебет', style1)
            sheet.write_merge(rowx+1, rowx+1, 7, 7, u'Кредит', style1)
            sheet.write_merge(rowx, rowx, 8, 9, u'Үлдэгдэл', style1)
            sheet.write_merge(rowx+1, rowx+1, 8, 8, u'Дебет', style1)
            sheet.write_merge(rowx+1, rowx+1, 9, 9, u'Кредит', style1)
            
            sheet.write_merge(rowx+2, rowx+2, 1, 1, u'1', style1)
            sheet.write_merge(rowx+2, rowx+2, 2, 2, u'2', style1)
            sheet.write_merge(rowx+2, rowx+2, 3, 5, u'3', style1)
            sheet.write_merge(rowx+2, rowx+2, 6, 6, u'4', style1)
            sheet.write_merge(rowx+2, rowx+2, 7, 7, u'5', style1)
            sheet.write_merge(rowx+2, rowx+2, 8, 8, u'6', style1)
            sheet.write_merge(rowx+2, rowx+2, 9, 9, u'7', style1)
            
            sheet.write_merge(rowx+3, rowx+3, 1, 1, u' ', style1)
            sheet.write_merge(rowx+3, rowx+3, 2, 2, u' ', style1)
            sheet.write_merge(rowx+3, rowx+3, 3, 5, u'Эхний үлдэгдэл', styles['text_center_xf'])
            sheet.write_merge(rowx+3, rowx+3, 6, 6, u' ', style1)
            sheet.write_merge(rowx+3, rowx+3, 7, 7, u' ', style1)
            sheet.write_merge(rowx+3, rowx+3, 8, 8, debit, style1)
            sheet.write_merge(rowx+3, rowx+3, 9, 9, credit, style1)
            
            rowx+=3
            
            for acc_moves in am:
                in_name = ''
                for movess in acc_moves.line_id:
                    if in_name == '':
                        if movess.name != "/":
                            in_name=movess.name           
                    else:
                        if movess.name != "/":
                            in_name = in_name +', '+ movess.name
                for movess in acc_moves.line_id:
                    if movess.account_id.id==data['account_id'][0]:
                        cr.execute("select jour.type from account_journal as jour where id='%d'"%acc_moves.journal_id)
                        jour=cr.fetchone()
                        rowx=rowx+1
                        sheet.write_merge(rowx, rowx, 1, 1, u'%s' %acc_moves.date, style1)
                        sheet.write_merge(rowx, rowx, 2, 2, u'%s' %jour, style1)
                        sheet.write_merge(rowx, rowx, 3, 5, u'%s' %(movess.name or ''), style1)
                        sheet.write_merge(rowx, rowx, 6, 6, movess.debit, style1)
                        sheet.write_merge(rowx, rowx, 7, 7, movess.credit, style1)
                        
                        debit=debit+movess.debit
                        credit=credit+movess.credit
                        if credit > debit:
                            credit = credit-debit
                            debit=0
                            sheet.write_merge(rowx, rowx, 8, 8, u'%d'%(debit or ''), style1)
                            sheet.write_merge(rowx, rowx, 9, 9, u'%d'%(credit or ''), style1)
                        else:
                            debit=debit-credit
                            credit=0
                            sheet.write_merge(rowx, rowx, 8, 8, u'%d'%(debit or ''), style1)
                            sheet.write_merge(rowx, rowx, 9, 9, u'%d'%(credit or 0), style1)
                     
            sheet.write_merge(rowx+1, rowx+1, 1, 1, u' ', style1)
            sheet.write_merge(rowx+1, rowx+1, 2, 2, u' ', style1)
            sheet.write_merge(rowx+1, rowx+1, 3, 5, u'Дүн', style1)
            sheet.write_merge(rowx+1, rowx+1, 6, 6, acc_ctx[0].debit, style1)
            sheet.write_merge(rowx+1, rowx+1, 7, 7, acc_ctx[0].credit, style1)
            sheet.write_merge(rowx+1, rowx+1, 8, 8, u' ', style1)
            sheet.write_merge(rowx+1, rowx+1, 9, 9, u' ', style1)
            
            sheet.write_merge(rowx+2, rowx+2, 1, 1, u' ', style1)
            sheet.write_merge(rowx+2, rowx+2, 2, 2, u' ', style1)
            sheet.write_merge(rowx+2, rowx+2, 3, 5, u'Эцсийн үлдэгдэл', style1)
            sheet.write_merge(rowx+2, rowx+2, 6, 6, u'', style1)
            sheet.write_merge(rowx+2, rowx+2, 7, 7, u'', style1)
            #sheet.write_merge(rowx+2, rowx+2, 6, 6, u'%s'%(acc[0].debit or ''), style1)
            #sheet.write_merge(rowx+2, rowx+2, 7, 7, u'%s'%(acc[0].credit or ''), style1)
            sheet.write_merge(rowx+2, rowx+2, 8, 8, debit, style1)
            sheet.write_merge(rowx+2, rowx+2, 9, 9, credit, style1)
    
    
            inch = 1500
            inch1 = 2200
            inch2 = 3700
            sheet.col(0).width = 2*inch
            sheet.col(1).width = 2*inch
            sheet.col(2).width = 2*inch
            sheet.col(3).width = inch1 #shirheg
            sheet.col(4).width = inch1
            sheet.col(5).width = inch1
            sheet.col(6).width = inch2
            sheet.col(7).width = inch2
            sheet.col(8).width = inch2
            sheet.col(9).width = inch2
            
            sheet.write(rowx+4, 3, u'Хөтөлсөн нягтлан бодогч.........................................../\
                                                     /',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 200'))
            sheet.write(rowx+5, 3, u'Хянасан ерөнхий (ахлах) нягтлан бодогч....................................../\
                                                     /', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 200'))
            sheet.write_merge(rowx+7, rowx+7, 1, 2, u'Хэвлэсэн огноо:', ezxf('font: bold off, italic on, height 200;align:wrap off,vert centre, horiz left;'))
            sheet.write_merge(rowx+7, rowx+7, 3, 6, u'%s -ны өдөр' %today, ezxf('font: bold off, italic on, height 200;align:wrap off,vert centre, horiz left;'))
            
            
        return {'data':book}

payable_detail_register()