# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2013 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
from StringIO import StringIO
#import xlrd, base64, time, datetime, xlwt, netsvc
import datetime
import openerp.netsvc
import xlwt
import time
#logger = netsvc.Logger()

class salary_tax_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "salary.tax.report"
    _description = "Salary Tax Report"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'partner_id': fields.many2one('res.partner', 'Partner', required=True), 
        'date': fields.date("Date", required=True),
    }
    
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
        'date': lambda *a: time.strftime('%Y-%m-%d'),
    }
    

    # Override
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['model'] = 'account.invoice'
        datas['form'] = self.read(cr, uid, ids)[0]
 
        
        data = datas['form']
       
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Receivables Detailed Ledger')
        styles = self.get_easyxf_styles()
        report_title = u"ТЕГ-ын даргын 2011 оны 10 дугаар сарын 12-ны өдрийн  584 дүгээр  тушаалын 1-р хавсралт "
        report_name = u'Маягт ТТ- 11(1)                                      Үндэсний татварын алба'
        sheet.portrait=True
        
        ezxf = xlwt.easyxf
        sheet.row(4).height = 500
        sheet.write_merge(0, 1,4, 11,  report_title, ezxf('font: bold off;align:wrap on,vert centre,horiz right;'))
        sheet.write_merge(5,5,0,11, u'Үндсэн цалин, хөдөлмөрийн хөлс болон түүнтэй адилтгах ', ezxf('font: bold on;align:wrap on,vert centre,horiz centre;font: height 250'))
        sheet.write_merge(6,6,0,11, u'орлогоос суутган тооцсон татварын мэдээ ', ezxf('font: bold on;align:wrap on,vert centre,horiz centre;font: height 250'))

        
        sheet.write(8, 0, u'1. ТТД: |__|__|__|__|__|__|__|                    ' , ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(10, 0, u'2. Байгууллагын нэр: %s'%(data['company_id'][1]), ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(12,0, u'3. Тайлант хугацаа: он |__|__|__|__|  улирал |__|__|', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write_merge(3, 3,0,11, report_name, ezxf('font: bold on; align: wrap off, vert centre, horiz left;font: height 300'))
        sheet.write(8,7, u'Зєвхєн татварын албан ажлын хэрэгцээнд', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(9,7, u'БТД  |__|__|__|__|__|__|__|__|__|__|__|__|__|', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(10,7, u'Татварын байцаагч: |__|__|__|__|__| ', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(11,9, u'                                 Тэмдэг  ', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(12,7, u'Хүлээн авсан ', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(13,8, u'он.сар.өдөр: __ __ . __ __ . __ __', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))
        sheet.write(15,0, u'(өссөн дүнгээр)                                                                                                                              (мянган төгрөгөөр)', ezxf('font:bold on;align:wrap off,vert centre,horiz left;'))

        rowx = 16
        sheet.write_merge(rowx, rowx+1, 0, 0, u'1', styles['heading_xf'])
        sheet.write_merge(rowx, rowx, 1, 3, u'Суутгуулагчийн', styles['heading_xf'])
        sheet.write(rowx+1, 1, u'Регистрийн дугаар', styles['heading_xf'])
        sheet.write(rowx+1, 2, u'Овог', styles['heading_xf'])
        sheet.write(rowx+1, 3, u'Нэр', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+1, 4, 4, u'Үндсэн болон нэмэгдэл цалин (ХХОАТТХ-ийн 11.1.1 дэх заалт)', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+1, 5, 5, u'ЭМД болон НДШ-ийн дүн(4*10%)', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+1, 6, 6, u'ЭМД болон НДШ-ийг хассан дүн(4-5)', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+1, 7, 7, u'Шууд бус орлого болон ХХОАТТХ-ийн 11.1.2-11.1.5 дах заалтад хамраах орлого', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+1, 8, 8, u'Татвар ногдуулах  нийт орлогын дүн ( 6+7 )', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+1, 9, 9, u'Ногдуулсан татвар (8*10%)', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+1, 10, 10, u'Хөнгөлөгдөх татварын дүн', styles['heading_xf'])
        sheet.write_merge(rowx, rowx+1, 11, 11, u'Төлөх татварын дүн (9-10)', styles['heading_xf'])
        sellers =15
        rowx += 3



        inch = 1000
        inch2= 500
        sheet.col(0).width = 1*inch
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 3*inch
        sheet.col(3).width = 5*inch 
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 3*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
        sheet.col(9).width = 3*inch
        sheet.col(10).width = 3*inch
        sheet.col(11).width = 3*inch
        sheet.row(16).height = 1*inch
        sheet.row(17).height = 1*inch
        sheet.row(3).height = 1*inch2
        sheet.row(5).height = 1*inch2
        sheet.row(6).height = 1*inch2
        rowx += 5
        sheet.write(rowx+3, 2, u'Тайланг үнэн зөв гаргасан:',ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))
        sheet.write(rowx+4, 2, u'Дарга /Захирал/............./                                              /   Тайланг хянаж хїлээн авсан: ', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))
        sheet.write(rowx+5, 2, u'Ерєнхий нягтлан бодогч   . . . . . . . . . . . /                                           /          Татварын улсын байцаагч  . . . . . . . . . . . . . /                                     /', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))
        sheet.write(rowx+6, 2, u'20. . . оны . . . сарын  . . . єдєр', ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 180'))

        return {'data':book }
salary_tax_report()