# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2014 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import datetime
from openerp.osv import fields, osv
from openerp.tools.translate import _

class account_cashflow_report_config(osv.osv):
    """
        МӨНГӨН ГҮЙЛГЭЭНИЙ ТАЙЛАНГИЙН ТОХИРГОО
    """
    _name = "account.cashflow.report.configure"
    _description = "Cashflows statement report configure"
    
    _columns = {
        'name': fields.char('Name'),
        'filter': fields.selection([('period', 'Period'),
                                         ('year', 'Year'),
                                        ], 'Filter by', required=True),
        'year_id': fields.many2one('account.fiscalyear', 'Year'),
        'period_id': fields.many2one('account.period', 'Period'),
        'line_config':fields.one2many('account.cashflow.report.configure.line', 'line')
    }

account_cashflow_report_config()

class account_cashflow_report_config_line(osv.osv):

    _name = "account.cashflow.report.configure.line"
    _description = 'Information on a configure line'
    
    def _get_default_cash_move_type(self, cr, uid, context=None):
        res=[]
        company_id = self.pool.get('res.users').browse(cr,uid,uid,context=None).company_id.id
        type_obj = self.pool.get('account.cash.move.type')
        ids = type_obj.search(cr,uid,[('company_id','=',company_id)], context=None)
        model = type_obj.browse(cr, uid,ids,context=None)

        for model_id in model :
            res.append(model_id.id)
        return res[0]
    
    _columns = {
        'cash_move_type': fields.many2one('account.cash.move.type', 'Type', required=True),
        'amount': fields.integer('Amount'),
        'sequence': fields.integer('Sequence'),
        'line': fields.many2one('account.cashflow.report.configure'),
        }
        
    def on_change_type(self, cr, uid, ids, type_id, context=None):
        if not type_id :
            return  False
        model = self.pool.get('account.cash.move.type').browse(cr, uid, type_id, context=context)
        return {
            'value': {
                'sequence': model.sequence,
            }
        }