# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################


from datetime import datetime
from dateutil.relativedelta import relativedelta
from operator import itemgetter
import time
from xlwt import Workbook, Formula
from openerp.osv import fields, osv
class account_invoice_report(osv.osv):
    _inherit = "account.invoice"
    
    def invoice_print(self, cr, uid, ids, context=None):
        '''
        This function prints the invoice and mark it as sent, so that we can see more easily the next step of the workflow
        '''
        assert len(ids) == 1, 'This option should only be used for a single id at a time.'
        self.write(cr, uid, ids, {'sent': True}, context=context)
        obj = self.browse(cr, uid, ids)[0]
        context['partner_id'] = obj.partner_id.id
        context['date'] = obj.date_invoice
        context['id'] = obj.id
        context['line_id'] = obj.invoice_line[0].id
        context['company_id'] = obj.company_id.id
        datas = {
             'ids': ids,
             'model': 'account.invoice',
             'form': self.read(cr, uid, ids[0], context=context)
        }
 
        return {
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'account.invoice.sheet.report',
            'type': 'ir.actions.act_window',
            'target': 'new',
            'datas': datas,
            'context': context,
            'nodestroy': True,
        }


account_invoice_report()

    
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: