# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2014 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import datetime
from openerp.osv import fields, osv
from openerp.tools.translate import _

class account_prepayment_report_config(osv.osv):
    """
        МӨНГӨН УРЬДЧИЛГААНЫ ТАЙЛАНГИЙН ТОХИРГОО
    """
    _name = "account.prepayment.report.configure"
    _description = "Account prepayment report configure"
    
    _columns = {
        'name':fields.char('Name', required=True),
        'line_config':fields.one2many('account.prepayment.report.configure.line', 'line'),
        'line_config2':fields.one2many('account.prepayment.report.configure.line2', 'line')
    }

account_prepayment_report_config()

class account_prepayment_report_config_line(osv.osv):

    _name = "account.prepayment.report.configure.line"
    _description = 'Information on a configure line'
    
    def _get_default_account_move_type(self, cr, uid, context=None):
        res=[]
        company_id = self.pool.get('res.users').browse(cr,uid,uid,context=None).company_id.id
        type_obj = self.pool.get('account.account')
        ids = type_obj.search(cr,uid,[('company_id','=',company_id)], context=None)
        model = type_obj.browse(cr, uid,ids,context=None)

        for model_id in model :
            res.append(model_id.id)
        return res[0]
    
    _columns = {
        'account_move_type': fields.many2one('account.account', 'Account', required=True),
        'sequence': fields.integer('Sequence'),
        'line': fields.many2one('account.prepayment.report.configure'),
        }
        
    def on_change_type(self, cr, uid, ids, type_id, context=None):
        if not type_id :
            return  False
        model = self.pool.get('account.account').browse(cr, uid, type_id, context=context)
        return {
            'value': {
                'sequence': model.sequence,
            }
        }
class account_prepayment_report_config_line2(osv.osv):

    _name = "account.prepayment.report.configure.line2"
    _description = 'Information on a configure line2'
    
    def _get_default_account_move_type2(self, cr, uid, context=None):
        res=[]
        company_id = self.pool.get('res.users').browse(cr,uid,uid,context=None).company_id.id
        type_obj = self.pool.get('account.account')
        ids = type_obj.search(cr,uid,[('company_id','=',company_id)], context=None)
        model = type_obj.browse(cr, uid,ids,context=None)

        for model_id in model :
            res.append(model_id.id)
        return res[0]
    
    _columns = {
        'account_move_type2': fields.many2one('account.account', 'Performance account', required=True),
        'sequence': fields.integer('Sequence'),
        'line': fields.many2one('account.prepayment.report.configure'),
        }
        
    def on_change_type2(self, cr, uid, ids, type_id, context=None):
        if not type_id :
            return  False
        model = self.pool.get('account.account').browse(cr, uid, type_id, context=context)
        return {
            'value': {
                'sequence': model.sequence,
            }
        }