# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2014 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################
from datetime import datetime
from datetime import timedelta
from openerp.osv import fields, osv
from openerp.tools.translate import _
import re
from lxml import etree
import simplejson
#import xlrd, base64, time, datetime, xlwt, netsvc
import datetime
import openerp.netsvc
import xlwt
import time

class account_stockholders_equity_report_config(osv.osv):
    """
        ӨМЧИЙН ӨӨРЧЛӨЛТИЙН ТАЙЛАНГИЙН ТОХИРГОО
    """
    _name = "account.stockholders.equity.report.config"
    _description = "Stockholders equity report configure"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'year_id': fields.many2one('account.fiscalyear', 'Year'),
        'report_id':fields.one2many('account.stockholders.equity.config','report_id','Report ids'),
        'property_adjustment_journal': fields.many2one('account.journal',"Adjustment Journal", # Залруулгын журнал
            domain="[('type','=','general')]",
            help='This journal will be used in Stockholders Equity Report computation.'),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c=None:obj.pool.get('res.company')._company_default_get(cr,uid,'account.stockholders.equity.report',context=c),
    }
    
    def onchange_year_id(self,cr,uid,ids,year_id,context=None):
        if year_id !=[]:
            obj = self.pool.get('account.fiscalyear').browse(cr, uid, year_id, context=context)
            year_name = obj.name
        else:
            obj_id = self.pool.get('account.fiscalyear').search(cr, uid, [('name','=',datetime.strftime('%Y'))])
            obj = obj = self.pool.get('account.fiscalyear').browse(cr, uid, obj_id)
            year_name = obj.name
        return year_name
   
account_stockholders_equity_report_config()


class account_stockholders_equity_config(osv.osv):
    _name = 'account.stockholders.equity.config'
    _columns = {
                'name':fields.char('Name'),
                'account_id': fields.many2one('account.account','Account', 
                                domain="[('type','in',('other','consolidation'))]"),
                'init_balance1':fields.float('Init Balance'),
                'init_balance2':fields.float('Init Balance'),
                'report_id':fields.many2one('account.stockholders.equity.report.config','Report'),
                'type':fields.selection([('statutory_fund_account','Statutory fund account'),
                                         ('treasury_stock_account','Treasury stock account'),
                                         ('additional_capital_account','Additional capital account'),
                                         ('revaluation_addition_account','Revaluation addition account'),
                                         ('foreign_currency_conversion_account','Foreign currency conversion account'),
                                         ('stockholders_equity_remainder_account','Stockholders equity remainder account'),
                                         ('previous_retained_earnings_account','Previous retained earnings account')],'Type'),
                }

    # def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False, submenu=False):
        #--------------------------------------------------- if context is None:
            #------------------------------------------------------ context = {}
        #- conf_obj = self.pool.get('account.stockholders.equity.report.config')
#------------------------------------------------------------------------------ 
        #---------- year_id = conf_obj.search(cr, uid, [('create_uid','=',uid)])
        #----------------------------------------------------- if year_id != []:
            #--------------------------- year_id = conf_obj.browse(cr, uid, uid)
            #-------------------------------------- if year_id.year_id.id != []:
                #-------------------- print "lllllllllllllog",year_id['year_id']
                # obj = self.pool.get('account.fiscalyear').browse(cr, uid, year_id.year_id.id, context=context)
                #------------------------------------------ year_name = obj.name
                #---------------------------------- print "llllllllll",year_name
            #------------------------------------------------------------- else:
                #--------------------------- year_name = datetime.strftime("%Y")
#------------------------------------------------------------------------------ 
                #------------------------------------------- print "a",year_name
        #----------------------------------------------------------------- else:
            #------------------------------- year_name = datetime.strftime("%Y")
        #--------------------------------------------- print "aaaaaaa",year_name
        # res = super(account_stockholders_equity_config,self).fields_view_get(cr, uid, view_id, view_type, context, toolbar=toolbar, submenu=submenu)
        #------------------------------------------ doc = etree.XML(res['arch'])
        #------------------- nodes = doc.xpath("//field[@name='init_balance1']")
        #---------------------------------------------------- for node in nodes:
            #----- node.set('string', _('%s Init Balance'%(int(year_name) - 2)))
        #------------------- nodes = doc.xpath("//field[@name='init_balance2']")
        #---------------------------------------------------- for node in nodes:
            #----- node.set('string', _('%s Init Balance'%(int(year_name) - 1)))
        #------------------------------------- res['arch'] = etree.tostring(doc)
        #------------------------------------------------------------ return res