# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from c2c_reporting_tools.reports.standard_report import *
from c2c_reporting_tools.flowables.simple_row_table import *
from c2c_reporting_tools.c2c_helper import *
from c2c_reporting_tools.translation import _
from reportlab.platypus import *
from reportlab.lib.colors import red, black, navy, white, green
from reportlab.lib.enums import TA_LEFT, TA_RIGHT, TA_CENTER, TA_JUSTIFY

from datetime import datetime
from dateutil.relativedelta import relativedelta
from operator import itemgetter
import time
from xlwt import Workbook, Formula
class balance_sheet_report(StandardReport):
    ''' Санхүүгийн байдлын тайлан
    '''
    def get_template_title(self, cr, context):
        """ return the title of the report """
        return u"Санхүүгийн байдлын тайлан"
    
    def get_report_barcode(self, cr, context=None):
        ''' Баримтын кодыг зураасан код болгож зурах '''
        if context is None:
            context = {}
        uid = 1
        if not self.datas['form']['save']:
            self.code = '-----'
            return False
        
        tmp, sequence_id = self.pool.get('ir.model.data').get_object_reference(cr, uid, 'l10n_mn_base','seq_account_report')
        sequence = self.pool.get('ir.sequence').get_id(cr, uid, sequence_id, code_or_id='id', context=context)
        if not sequence :
            self.code = '-----'
            return False
        self.code = sequence
        self.attache_name = sequence
        self.force_save = True
        return sequence
    
    
    def create_pdf_report_data(self, cr, uid, data, context=None):
        ''' Гүйлгээ баланс тайлангийн мэдээллийг боловсруулж
            тайлангийн форматад тохируулан python [{},{},{}...]
            загвараар хүснэгтийн мөр багануудын өгөгдлийг боловсруулна.
            
        '''
        def get_initial_journal(fy):
            initial_bal_journal = False
            prev_fy_ids = fiscalyear_obj.search(cr, uid, [('date_stop', '<', fy.date_start)], order="date_start desc")
            if prev_fy_ids :
                prev_fy = fiscalyear_obj.browse(cr, uid, prev_fy_ids[0])
                if prev_fy.end_journal_period_id :
                    initial_bal_journal = prev_fy.end_journal_period_id.journal_id.id
            return initial_bal_journal, (prev_fy_ids and prev_fy_ids[0]) or False
        
        def _get_amount_by_type(account_report_type):
            ''' Тухайн санхүүгийн байдлын тайлангийн дансны төрөлд хийгдсэн тайлант хугацааны
             болон өнгөрсөн жилийн мөн үеийн гүйлгээний дүнг харуулна.
            '''
            bef_init_balance=0
            type_ids = conf_obj.search(cr, uid, [('name','=','balance'),('company_id','=',data['company_id'])])
            conf_id  = account_config_report_obj.search(cr, uid, [('report_id','=',type_ids),('type','=',account_report_type)])
            res = {}
            start_amount = 0
            end_amount = 0
            self.context = context
            ctx = self.context.copy()
            ctx1 = self.context.copy()
            ctx['fiscalyear'] = data['fiscalyear_id']
            ctx['company_id'] = data['company_id']
            ctx1['period_from'] = data['date_from']
            ctx1['period_to'] = data['date_from']
            ctx['date_from'] = data['date_from']
            ctx['date_to'] =  data['date_to']
            ctx['state'] = data['target_move']
            if type_ids:
                for x in account_config_report_obj.browse(cr, uid, conf_id, context=context):
                    sum = 0
                    sum1 = 0
                    for acc in x.account_id:
                        
                        config_start_line = account_obj.browse(cr, uid,[acc.id],ctx1)
                        if config_start_line:
                            for s_line in config_start_line:
                                start_amount = s_line['balance']
                                sum += start_amount
                        else:
                             sum = 0
                        config_end_line = account_obj.browse(cr, uid,[acc.id],ctx)
                        if config_end_line:
                            for e_line in config_end_line:
                                end_amount = e_line['balance']
                                sum1 +=end_amount
                        else:
                            sum1 = 0
                    res[x.id] = {
                        'id': x.id,
                        'name': x.name,
                        'start_amount':sum,
                        'end_amount':sum1,
                        'sequence': x.sequence or 1
                    }
                        
            return sorted(res.values(), key=itemgetter("sequence"))
        
        if not context:
            context = {}
        account_obj = self.pool.get('account.account')
        account_rel = self.pool.get('account.config.rel')
        currency_obj = self.pool.get('res.currency')
        company_obj = self.pool.get('res.company')
        fiscalyear_obj = self.pool.get('account.fiscalyear')
        account_move_line_obj = self.pool.get('account.move.line')
        account_config_report_obj = self.pool.get('account.config')
        
        conf_line_obj = self.pool.get('account.cashflow.report.configure.line')
        conf_obj = self.pool.get('account.report.configure')
        
        
        move_state = 'all'
        if data['target_move'] == 'posted':
            move_state = 'posted'
                
        grid = []
        grid.append(['1', u'<b>ХӨРӨНГӨ</b>', '', '', ''])
        grid.append(['1.1', u'<b>Эргэлтийн хөрөнгө</b>', '', '', ''])
        sublines = []
        current_asset_total = 0
        current_asset_total1 = 0
        for line in _get_amount_by_type('current_asset') :
            sublines.append([line['sequence'], line['name'], line['start_amount'], line['end_amount'], '<font color="white">_______</font>'])
            current_asset_total += line['start_amount']
            current_asset_total1 += line['end_amount']
        grid.extend(sublines)
        grid.append(['1.1.10', u'','', '', ''])
        grid.append(['1.1.11', u'<b>Эргэлтийн хөрөнгийн дүн</b>', current_asset_total, current_asset_total1, '<font color="white">___</font>'])
        grid.append(['1.2', u'<b>Эргэлтийн бус хөрөнгө</b>', '', '', ''])
        
        noncurrent_asset_total = 0
        noncurrent_asset_total1 = 0
        total_asset = 0
        total_asset1 = 0
        sublines = []
        for line in _get_amount_by_type('noncurrent_asset'):
            sublines.append([line['sequence'], line['name'],line['start_amount'], line['end_amount'], '<font color="white">_______</font>'])
            noncurrent_asset_total += line['start_amount']
            noncurrent_asset_total1 += line['end_amount']
        grid.extend(sublines)
        grid.append(['1.2.9', u'','', '', ''])
        grid.append(['1.2.10', u'Эргэлтийн бус хөрөнгийн дүн', noncurrent_asset_total,noncurrent_asset_total1, '<font color="white">___</font>'])
        
        total_asset = current_asset_total+noncurrent_asset_total
        total_asset1 = current_asset_total1+noncurrent_asset_total1
        grid.append(['1.3', u'<b>НИЙТ ХӨРӨНГИЙН ДҮН</b>', total_asset,total_asset1, ''])
        grid.append(['2', u'<b>ӨР ТӨЛБӨР БА ЭЗДИЙН ӨМЧ</b>', '','', ''])
        grid.append(['2.1', u'<b>Өр төлбөр</b>', '','', ''])
        grid.append(['2.1.1', u'<b>Богино хугацаат өр төлбөр</b>', '','', ''])
        
        short_term_liability_total = 0
        short_term_liability_total1 = 0
        sublines = []
        for line in _get_amount_by_type('short_term_liability'):
            sublines.append([line['sequence'], line['name'],line['start_amount'], line['end_amount'], '<font color="white">_______</font>'])
            short_term_liability_total += line['start_amount']
            short_term_liability_total1 += line['end_amount'] 
        grid.extend(sublines)
        grid.append(['2.1.1.12', u'','', '', ''])
        grid.append(['2.1.1.13', u'<b>Богино хугацаат өр төлбөрийн дүн</b>', short_term_liability_total,short_term_liability_total1, '<font color="white">___</font>'])
        grid.append(['2.1.2', u'<b>Урт хугацаат өр төлбөр</b>', '','', '<font color="white">___</font>'])
            
        long_term_liability_total = 0
        long_term_liability_total1 = 0
        total_liability = 0
        total_liability1 = 0 
        sublines = []
        for line in _get_amount_by_type('long_term_liability'):
            sublines.append([line['sequence'], line['name'],line['start_amount'], line['end_amount'], '<font color="white">_______</font>'])
            long_term_liability_total += line['start_amount']
            long_term_liability_total1 += line['end_amount'] 
        grid.extend(sublines)
        total_liability = short_term_liability_total+long_term_liability_total
        total_liability1 = short_term_liability_total1+long_term_liability_total1
        grid.append(['2.1.2.5', u'','', '', ''])
        grid.append(['2.1.1.13', u'<b>Урт хугацаат өр төлбөрийн дүн</b>', long_term_liability_total,long_term_liability_total1, '<font color="white">___</font>'])
        grid.append(['2.2', u'<b>Өр төлбөрийн нийт дүн</b>', total_liability,total_liability1, '<font color="white">___</font>'])
        grid.append(['2.3', u'<b>Эздийн өмч</b>', '','', '<font color="white">___</font>'])
        
        owner_property_total = 0
        owner_property_total1 = 0
        total_owner_property = 0
        total_owner_property1 = 0
        total = 0
        total1 = 0
        sublines = []
        for line in _get_amount_by_type('owner_property'):
            sublines.append([line['sequence'], line['name'],line['start_amount'], line['end_amount'], '<font color="white">_______</font>'])
            owner_property_total += line['start_amount']
            owner_property_total1 += line['end_amount'] 
        grid.extend(sublines)
        grid.append(['2.3.10', u'','', '', ''])
        total_owner_property = owner_property_total +total_liability
        total_owner_property1 = owner_property_total1 +total_liability1
        grid.append(['2.3.11', u'<b>Эздийн өмчийн дүн</b>', owner_property_total,owner_property_total1, '<font color="white">___</font>'])
        grid.append(['2.4', u'<b>ӨР ТӨЛБӨР БА ЭЗДИЙН ӨМЧИЙН ДҮН</b>', total_owner_property,total_owner_property1, '<font color="white">___</font>'])
        return grid
    
    
    def get_story(self):
        ''' Тайлангийн өгөгдлүүдийг боловсруулж, PDF -г зурна.
            A4 цаасний стандарт хэмжээ 210x297 үүний тайлангийн бие нь
            Хэвтээ хэлбэрээр 280x200 байхаар тогтоолоо.
            
        '''
        story = []
        cr = self.cr
        uid = self.uid 
        context = self.context
        
        data = self.datas['form']
        period_obj = self.pool.get('account.period')
        account_obj = self.pool.get('account.account')
        company = self.pool.get('res.company').browse(cr, uid, data['company_id'])
        
        date_str = '%s-%s' % (
            datetime.strptime(data['date_from'],'%Y-%m-%d').strftime('%Y.%m.%d'),
            datetime.strptime(data['date_to'],'%Y-%m-%d').strftime('%Y.%m.%d')
        )
        
        styNormal = ParagraphStyle('normal', fontName='Helvetica', fontSize=8, leading=13,
                   textColor=navy, alignment=TA_LEFT, leftIndent=8, spaceAfter=10)
        styNormalR = ParagraphStyle('normal', fontName='Helvetica', fontSize=8, leading=13,
                   textColor=navy, alignment=TA_RIGHT, leftIndent=8, spaceAfter=10)
        title_style = ParagraphStyle('tabledataleft', fontName='Helvetica-Bold', fontSize=12, leading=17, 
                    alignment=TA_CENTER, leftIndent=1, rightIndent=1, spaceAfter=10, spaceBefore=10)
        nullpara = Paragraph('', styNormal)
        
        grid = [[
            Paragraph(u"", styNormal),
            Paragraph(u"Байгууллагын нэр: %s" % company.name, styNormalR)
        ],[
            Paragraph(u"САНХҮҮГИЙН БАЙДЛЫН ТАЙЛАН", title_style),
            nullpara
        ],[
            Paragraph(u"Дугаар: %s" % self.code, styNormal),
            Paragraph(u"Тайлант хугацаа: %s" % date_str, styNormalR),
        ]]
        
        tsGrid = TableStyle([
                ('GRID', (0,0), (-1,-1), 0.25, colors.white),
                ('SPAN', (0,1), (1,1))
        ])
        
        story.append(Table(grid, style=tsGrid, colWidths=[90*mm,90*mm]))
        story.append(Spacer(20,20))
        
        table = SimpleRowsTableBuilder(u'Санхүүгийн байдлын тайлан')
        
        table.add_text_column(u'Мөрийн дугаар', 15 * mm, extra={'font_size':7,'header_font_size':8})
        table.add_text_column(u'Үзүүлэлт', 100 * mm, extra={'font_size':7,'header_font_size':8})
        table.add_num_column(u'01 сарын 01', 25*mm, 2, extra={'font_size':7,'header_font_size':8})
        table.add_num_column(u'%s сарын %s'%(datetime.strptime(data['date_to'],'%Y-%m-%d').strftime('%m'),datetime.strptime(data['date_to'],'%Y-%m-%d').strftime('%d')), 25*mm, 2, extra={'font_size':7,'header_font_size':8})
        
        grid = self.create_pdf_report_data(cr, uid, data, context)
        
        for row in grid:
            table.add_text_cell(row[0])
            table.add_text_cell(row[4]+row[1])
            table.add_num_cell(row[2])
            table.add_num_cell(row[3])
        
        # Ингээд л болоо
        story.append(table.get_table())
        
        # Тайлангийн доод хэсэгт гарын үсэг зурах жижиг хүснэгт бэлдэнэ.
        tsGrid = TableStyle([
                ('GRID', (0,0), (-1,-1), 0.25, colors.white),
                ('FONT', (0,0),(-1,-1),'Helvetica', 8)
        ])
        #spacer
        story.append(Spacer(30,30))
        
        td_right_style = ParagraphStyle('tabledataright', fontName='Helvetica', fontSize=6, leading=11, 
                    alignment=TA_RIGHT, leftIndent=3, rightIndent=1, spaceAfter=1, spaceBefore=2)
        td_left_style = ParagraphStyle('tabledataleft', fontName='Helvetica', fontSize=6, leading=11, 
                    alignment=TA_LEFT, leftIndent=1, rightIndent=3, spaceAfter=1, spaceBefore=2)
        nullpara = Paragraph('', td_right_style)
        grid = [
            [Paragraph(u'', td_right_style), Paragraph(u'Захирал..................................................../<font color="white">____________________________________</font>/', td_left_style)],
            [nullpara,Paragraph(u'Ерөнхий нягтлан бодогч...................................................../<font color="white">____________________________________</font>/', td_left_style)]
        ]
        story.append(Table(grid, style=tsGrid, colWidths=[80*mm,160*mm]))
        
        return story

balance_sheet_report('report.account.balance.sheet.report', "Account balance sheet", 'account.balance.sheet.report', StandardReport.A4_PORTRAIT)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: