# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from c2c_reporting_tools.reports.standard_report import *
from c2c_reporting_tools.flowables.simple_row_table import *
from c2c_reporting_tools.c2c_helper import *
from c2c_reporting_tools.translation import _
from reportlab.platypus import *
from reportlab.lib.colors import red, black, navy, white, green
from reportlab.lib.enums import TA_LEFT, TA_RIGHT, TA_CENTER, TA_JUSTIFY

from datetime import datetime
from dateutil.relativedelta import relativedelta
from operator import itemgetter
import time
from xlwt import Workbook, Formula
class cashflow_statement_report(StandardReport):
    ''' Мөнгөн гүйлгээний тайлан
    '''
    def get_template_title(self, cr, context):
        """ return the title of the report """
        return u"Мөнгөн гүйлгээний тайлан"
    
    def get_report_barcode(self, cr, context=None):
        ''' Баримтын кодыг зураасан код болгож зурах '''
        if context is None:
            context = {}
        uid = 1
        if not self.datas['form']['save']:
            self.code = '-----'
            return False
        
        tmp, sequence_id = self.pool.get('ir.model.data').get_object_reference(cr, uid, 'l10n_mn_base','seq_account_report')
        sequence = self.pool.get('ir.sequence').get_id(cr, uid, sequence_id, code_or_id='id', context=context)
        if not sequence :
            self.code = '-----'
            return False
        self.code = sequence
        self.attache_name = sequence
        self.force_save = True
        return sequence
    
    def create_report_xls_data(self, cr, uid, data, context=None):
        ''' Гүйлгээ баланс тайлангийн мэдээллийг боловсруулж
            тайлангийн форматад тохируулан python [{},{},{}...]
            загвараар хүснэгтийн мөр багануудын өгөгдлийг боловсруулна.
            
        '''
        def get_initial_journal(fy):
            initial_bal_journal = False
            prev_fy_ids = fiscalyear_obj.search(cr, uid, [('date_stop', '<', fy.date_start)], order="date_start desc")
            if prev_fy_ids :
                prev_fy = fiscalyear_obj.browse(cr, uid, prev_fy_ids[0])
                if prev_fy.end_journal_period_id :
                    initial_bal_journal = prev_fy.end_journal_period_id.journal_id.id
            return initial_bal_journal, (prev_fy_ids and prev_fy_ids[0]) or False
        
        def _get_amount_by_type(move_type_group):
            ''' Тухайн мөнгөн гүйлгээний төрөлд хийгдсэн тайлант хугацааны
             болон өнгөрсөн жилийн мөн үеийн гүйлгээний дүнг харуулна.
            '''
            bef_init_balance=0
            type_ids = cash_move_type_obj.search(cr, uid, [('group','=',move_type_group)], order='sequence')
            res = {}
            if type_ids:
                for x in cash_move_type_obj.browse(cr, uid, type_ids, context=context):
                    config_year_ids = conf_obj.search(cr,uid,[('filter','=','year'),('year_id', '=', data['fiscalyear_id'])], context=None)
                    year_amount = 0
                    period_amount = 0
                    if config_year_ids !=[]:
                        config_year_line_ids = conf_line_obj.search(cr,uid,[('line','=',config_year_ids[0])], context=None)
                        config_year_line = conf_line_obj.browse(cr, uid,config_year_line_ids,context=None)
                        
                        
                        if config_year_line:
                            for line in config_year_line:
                                if line['cash_move_type'].group == move_type_group and line['cash_move_type'].sequence ==x.sequence:
                                    if line:
                                        year_amount = line['amount']
                                    else:
                                        year_amount = 0
                                config_period_ids = conf_obj.search(cr,uid,[('filter','=','period')], context=None)
                                if config_period_ids !=[]:
                                    config_period = conf_obj.browse(cr, uid,config_period_ids,context=None)
                                    config_period_line_ids = conf_line_obj.search(cr,uid,[('line','=',config_period_ids[0])], context=None)
                                    config_period_line = conf_line_obj.browse(cr, uid,config_period_line_ids,context=None)
                                    
                                    if config_period[0]['period_id'].fiscalyear_id.id== data['fiscalyear_id']:
                                        for line1 in config_period_line:
                                            if line1['cash_move_type'].group == move_type_group and line1['cash_move_type'].sequence ==x.sequence:
                                                if line1:
                                                    period_amount = line1['amount']
                                                else:
                                                    period_amount = 0
                            
                    res[x.id] = {
                        'id': x.id,
                        'name': x.name,
                        'initail_amount':year_amount,
                        'amount':period_amount,
                        'sequence': x.sequence or 1
                    }
                        
                cr.execute("select l.cash_move_type, coalesce(SUM(l.amount),0) "
                           "from account_bank_statement_line l "
                           "where " + query + " "
                           "and l.account_id in %s "
                           "and l.cash_move_type is not null "
                           "and l.cash_move_type in %s "
                           "group by l.cash_move_type ",
                           (account_tuple,tuple(type_ids)))
                fetched = cr.fetchall()
                period_amount = 0
                
                if fetched:
                    for type_id, amount in fetched:
                        res[type_id]['amount'] +=  amount
            return sorted(res.values(), key=itemgetter("sequence"))
        
        if not context:
            context = {}
        account_obj = self.pool.get('account.account')
        journal_obj = self.pool.get('account.journal')
        currency_obj = self.pool.get('res.currency')
        company_obj = self.pool.get('res.company')
        fiscalyear_obj = self.pool.get('account.fiscalyear')
        account_move_line_obj = self.pool.get('account.move.line')
        cash_move_type_obj = self.pool.get('account.cash.move.type')
        
        conf_line_obj = self.pool.get('account.cashflow.report.configure.line')
        conf_obj = self.pool.get('account.cashflow.report.configure')
        
        # Тухайн санхүүгийн жилд эхний үлдэгдэл бичсэн санхүүгийн журналыг тодорхойлно.
        fiscalyear = fiscalyear_obj.browse(cr, uid, data['fiscalyear_id'], context=context)
        current_initial_journal, previous_year_id = get_initial_journal(fiscalyear)
        
        move_state = 'all'
        if data['target_move'] == 'posted':
            move_state = 'posted'
            
        query = "date >= \'" +data['date_from']+ "\' AND date <= \'"+data['date_to']+"\' "
        account_ids = account_obj.search(cr, uid, [('type','<>','liquidity'),('parent_id','child_of',[data['chart_account_id']])], context=context)
        account_tuple = tuple(account_ids)
        
        grid = []
        total = grand = 0.0
        total1 = grand1 = 0.0
        grid.append(['1', u'<b>Үндсэн үйл ажиллагааны мөнгөн гүйлгээ</b>', '', '', ''])
        sublines = []
        for line in _get_amount_by_type('activities_income') :
            sublines.append(['', line['name'], line['initail_amount'], line['amount'], '<font color="white">_______</font>'])
        grid.append(['1.1', u'Үндсэн үйл ажиллагааны мөнгөн орлогын дүн', Formula('SUM(C10:C15)'),Formula('SUM(D10:D15)'), '<font color="white">___</font>'])
        grid.extend(sublines)
        
        sublines = []
        subtotal = 0
        subtotal1 = 0
        for line in _get_amount_by_type('activities_expense') :
            sublines.append(['', line['name'],-line['initail_amount'], -line['amount'], '<font color="white">_______</font>'])
            subtotal += line['amount']
            subtotal1 += line['initail_amount']
        grid.append(['1.2', u'Үндсэн үйл ажиллагааны мөнгөн зарлагын дүн',Formula('SUM(C17:C25)'), Formula('SUM(D17:D25)'), '<font color="white">___</font>'])
        grid.extend(sublines)
         
        grid.append(['1.3', u'<b>Үндсэн үйл ажиллагааны цэвэр мөнгөн гүйлгээний дүн</b>', Formula('C9-C16'),Formula('D9-D16'), ''])
         
        total = 0
        subtotal = 0
        subtotal1 = 0
        sublines = []
        grid.append(['2', u'<b>Хөрөнгө оруулалтын үйл ажиллагааны мөнгөн гүйлгээ</b>', '', '',''])
        for line in _get_amount_by_type('investing_income') :
            sublines.append(['', line['name'], line['initail_amount'],line['amount'], '<font color="white">_______</font>'])
        grid.append(['2.1', u'Хөрөнгө оруулалтын үйл ажиллагааны мөнгөн орлогын дүн', Formula('SUM(C29:C35)'), Formula('SUM(D29:D35)'), '<font color="white">___</font>'])
        grid.extend(sublines)
         
        subtotal = 0
        subtotal1 = 0
        total = 0
        total1 = 0
        sublines = []
        for line in _get_amount_by_type('investing_expense'):
            sublines.append(['', line['name'],-line['initail_amount'], -line['amount'], '<font color="white">_______</font>'])
            subtotal += line['amount']
            subtotal1 += line['initail_amount']
        grid.append(['2.2', u'Хөрөнгө оруулалтын үйл ажиллагааны мөнгөн зарлагын дүн', Formula('SUM(C37:C41)'),Formula('SUM(C37:C41)'), '<font color="white">___</font>'])
        grid.extend(sublines)
        total += subtotal
        total1 += subtotal1
         
        grid.append(['2.3', u'<b>Хөрөнгө оруулалтын үйл ажиллагааны цэвэр мөнгөн гүйлгээний дүн</b>', Formula('C28-C36'),Formula('D28-D36'), ''])
        grand += total
        grand1 += total1
        total = 0
        total1 = 0
         
        sublines = []
        subtotal = 0
        subtotal1 = 0
        grid.append(['3', u'<b>Санхүүгийн үйл ажиллагааны мөнгөн гүйлгээ</b>', '', '',''])
        for line in _get_amount_by_type('financing_income'):
            sublines.append(['', line['name'],line['initail_amount'], line['amount'], '<font color="white">_______</font>'])
        grid.append(['3.1', u'Санхүүгийн үйл ажиллагааны мөнгөн орлогын дүн', Formula('SUM(C45:C47)'), Formula('SUM(D45:D47)'), '<font color="white">___</font>'])
        grid.extend(sublines)
         
        subtotal = 0
        subtotal1 = 0
        sublines = []
        for line in _get_amount_by_type('financing_expense'):
            sublines.append(['', line['name'],-line['initail_amount'], -line['amount'], '<font color="white">_______</font>'])
        grid.append(['3.2', u'Санхүүгийн үйл ажиллагааны мөнгөн зарлагын дүн', Formula('SUM(C49:C52)'), Formula('SUM(D49:D52)'), '<font color="white">___</font>'])
        grid.extend(sublines)
         
        grid.append(['3.20', u'<b>Санхүүгийн үйл ажиллагааны цэвэр мөнгөн гүйлгээний дүн</b>', Formula('C44-C48'), Formula('D44-D48'), ''])
        grid.append(['4', u'<b>Бүх цэвэр мөнгөн гүйлгээ</b>', Formula('C26+C42+C53'), Formula('D26+D42+D53'), ''])
        
#        Эхний эцсийн үлдэгдлийг харин санхүүгийн бичилтээс тооцоно.
        account_ids = account_obj.search(cr, uid, [('type','=','liquidity'),('parent_id','child_of',[data['chart_account_id']])], context=context)
        account_tuple = tuple(account_ids)
 
        initial_bal = account_obj.get_initial_balance(cr, uid, account_ids, context=context)
        context.update({'date_from': fiscalyear.date_start})
        bal = dict((a['id'], a) for a in account_obj.read(cr, uid, account_ids, ['debit','credit'], context=context))
        
        bef_init_balance=0
        for line in _get_amount_by_type('dummy'):
            bef_init_balance = line['initail_amount']
        print 'grand1 = ', grand1
        bef_balance = grand1+bef_init_balance
        now_balance = grand + bef_balance
        grid.append(['5.1', u'<b>Мөнгө, түүнтэй адилтгах хөрөнгийн эхний үлдэгдэл</b>', bef_init_balance, bef_balance, ''])
        grid.append(['5.2', u'<b>Мөнгө, түүнтэй адилтгах хөрөнгийн эцсийн үлдэгдэл</b>',Formula('C54+C55'), Formula('D54+D55'), ''])
         
        return grid
    
    def create_report_pdf_data(self, cr, uid, data, context=None):
        ''' Гүйлгээ баланс тайлангийн мэдээллийг боловсруулж
            тайлангийн форматад тохируулан python [{},{},{}...]
            загвараар хүснэгтийн мөр багануудын өгөгдлийг боловсруулна.
            
        '''
        def get_initial_journal(fy):
            initial_bal_journal = False
            prev_fy_ids = fiscalyear_obj.search(cr, uid, [('date_stop', '<', fy.date_start)], order="date_start desc")
            if prev_fy_ids :
                prev_fy = fiscalyear_obj.browse(cr, uid, prev_fy_ids[0])
                if prev_fy.end_journal_period_id :
                    initial_bal_journal = prev_fy.end_journal_period_id.journal_id.id
            return initial_bal_journal, (prev_fy_ids and prev_fy_ids[0]) or False
        
        def _get_amount_by_type(move_type_group):
            ''' Тухайн мөнгөн гүйлгээний төрөлд хийгдсэн тайлант хугацааны
             болон өнгөрсөн жилийн мөн үеийн гүйлгээний дүнг харуулна.
            '''
            type_ids = cash_move_type_obj.search(cr, uid, [('group','=',move_type_group)], order='sequence')
            res = {}
            year_amount = 0
            period_amount = 0
            if type_ids:
                for x in cash_move_type_obj.browse(cr, uid, type_ids, context=context):
                    config_year_ids = conf_obj.search(cr,uid,[('filter','=','year'),('year_id', '=', data['fiscalyear_id'])], context=None)
                    if config_year_ids !=[]:
                        config_year_line_ids = conf_line_obj.search(cr,uid,[('line','=',config_year_ids[0])], context=None)
                        config_year_line = conf_line_obj.browse(cr, uid,config_year_line_ids,context=None)
                        for line in config_year_line:
                            if line['cash_move_type'].group == move_type_group and line['cash_move_type'].sequence ==x.sequence:
                                
                                year_amount = line['amount']
                            config_period_ids = conf_obj.search(cr,uid,[('filter','=','period')], context=None)
                            if config_period_ids !=[]:
                                config_period = conf_obj.browse(cr, uid,config_period_ids,context=None)
                                config_period_line_ids = conf_line_obj.search(cr,uid,[('line','=',config_period_ids[0])], context=None)
                                config_period_line = conf_line_obj.browse(cr, uid,config_period_line_ids,context=None)
                                if config_period[0]['period_id'].fiscalyear_id.id== data['fiscalyear_id']:
                                    for line1 in config_period_line:
                                        if line1['cash_move_type'].group == move_type_group and line1['cash_move_type'].sequence ==x.sequence:
                                            period_amount = line1['amount']
                    res[x.id] = {
                        'id': x.id,
                        'name': x.name,
                        'initail_amount':year_amount,
                        'amount':period_amount,
                        'sequence': x.sequence or 1
                    }
                        
                cr.execute("select l.cash_move_type, coalesce(SUM(l.amount),0) "
                           "from account_bank_statement_line l "
                           "where " + query + " "
                           "and l.account_id in %s "
                           "and l.cash_move_type is not null "
                           "and l.cash_move_type in %s "
                           "group by l.cash_move_type ",
                           (account_tuple,tuple(type_ids)))
                fetched = cr.fetchall()
                period_amount = 0
                
                if fetched:
                    for type_id, amount in fetched:
                        res[type_id]['amount'] +=  amount
                        print 'dsd' ,res.values()
            return sorted(res.values(), key=itemgetter("sequence"))
        
        if not context:
            context = {}
        account_obj = self.pool.get('account.account')
        journal_obj = self.pool.get('account.journal')
        currency_obj = self.pool.get('res.currency')
        company_obj = self.pool.get('res.company')
        fiscalyear_obj = self.pool.get('account.fiscalyear')
        account_move_line_obj = self.pool.get('account.move.line')
        cash_move_type_obj = self.pool.get('account.cash.move.type')
        
        conf_line_obj = self.pool.get('account.cashflow.report.configure.line')
        conf_obj = self.pool.get('account.cashflow.report.configure')
        
        # Тухайн санхүүгийн жилд эхний үлдэгдэл бичсэн санхүүгийн журналыг тодорхойлно.
        fiscalyear = fiscalyear_obj.browse(cr, uid, data['fiscalyear_id'], context=context)
        current_initial_journal, previous_year_id = get_initial_journal(fiscalyear)
        
        move_state = 'all'
        if data['target_move'] == 'posted':
            move_state = 'posted'
            
        query = "date >= \'" +data['date_from']+ "\' AND date <= \'"+data['date_to']+"\' "
        account_ids = account_obj.search(cr, uid, [('type','<>','liquidity'),('parent_id','child_of',[data['chart_account_id']])], context=context)
        account_tuple = tuple(account_ids)
        
        grid = []
        total = grand = 0.0
        total1 = grand1 = 0.0
        grid.append(['1', u'<b>Үндсэн үйл ажиллагааны мөнгөн гүйлгээ</b>', '', '', ''])
        sublines = []
        subtotal = 0
        subtotal1 = 0
        for line in _get_amount_by_type('activities_income') :
            sublines.append(['', line['name'], line['initail_amount'], line['amount'], '<font color="white">_______</font>'])
            subtotal += line['amount']
            subtotal1 += line['initail_amount']
        grid.append(['1.1', u'Үндсэн үйл ажиллагааны мөнгөн орлогын дүн', subtotal1, subtotal, '<font color="white">___</font>'])
        grid.extend(sublines)
        total += subtotal
        total1 += subtotal1
        
        sublines = []
        subtotal = 0
        subtotal1 = 0
        for line in _get_amount_by_type('activities_expense') :
            sublines.append(['', line['name'],-line['initail_amount'], line['amount'], '<font color="white">_______</font>'])
            subtotal += line['amount']
            subtotal1-= line['initail_amount']
        grid.append(['1.2', u'Үндсэн үйл ажиллагааны мөнгөн зарлагын дүн',subtotal1, subtotal, '<font color="white">___</font>'])
        grid.extend(sublines)
        total += subtotal
        total1-= subtotal1
         
        grid.append(['1.3', u'<b>Үндсэн үйл ажиллагааны цэвэр мөнгөн гүйлгээний дүн</b>', total1,total, ''])
        grand += total
        grand1 += total1
         
        total = 0
        subtotal = 0
        subtotal1 = 0
        sublines = []
        grid.append(['2', u'<b>Хөрөнгө оруулалтын үйл ажиллагааны мөнгөн гүйлгээ</b>', '', '',''])
        for line in _get_amount_by_type('investing_income') :
            sublines.append(['', line['name'], line['initail_amount'],line['amount'], '<font color="white">_______</font>'])
            subtotal += line['amount']
            subtotal1 += line['initail_amount']
        grid.append(['2.1', u'Хөрөнгө оруулалтын үйл ажиллагааны мөнгөн орлогын дүн', subtotal1, subtotal, '<font color="white">___</font>'])
        grid.extend(sublines)
        total += subtotal
        total1 += subtotal1
         
        subtotal = 0
        subtotal1 = 0
        total = 0
        total1 = 0
        sublines = []
        for line in _get_amount_by_type('investing_expense'):
            sublines.append(['', line['name'],-line['initail_amount'], -line['amount'], '<font color="white">_______</font>'])
            subtotal += line['amount']
            subtotal1 += line['initail_amount']
        grid.append(['2.2', u'Хөрөнгө оруулалтын үйл ажиллагааны мөнгөн зарлагын дүн', -subtotal1,-subtotal, '<font color="white">___</font>'])
        grid.extend(sublines)
        total += subtotal
        total1 += subtotal1
         
        grid.append(['2.3', u'<b>Хөрөнгө оруулалтын үйл ажиллагааны цэвэр мөнгөн гүйлгээний дүн</b>', total1,total, ''])
        grand += total
        grand1 += total1
        total = 0
        total1 = 0
         
        sublines = []
        subtotal = 0
        subtotal1 = 0
        grid.append(['3', u'<b>Санхүүгийн үйл ажиллагааны мөнгөн гүйлгээ</b>', '', '',''])
        for line in _get_amount_by_type('financing_income'):
            sublines.append(['', line['name'],line['initail_amount'], line['amount'], '<font color="white">_______</font>'])
            subtotal += line['amount']
            subtotal1 += line['initail_amount']
        grid.append(['3.1', u'Санхүүгийн үйл ажиллагааны мөнгөн орлогын дүн', subtotal1, subtotal, '<font color="white">___</font>'])
        grid.extend(sublines)
        total += subtotal
        total1 += subtotal1
         
        subtotal = 0
        subtotal1 = 0
        sublines = []
        for line in _get_amount_by_type('financing_expense'):
            sublines.append(['', line['name'],-line['initail_amount'], -line['amount'], '<font color="white">_______</font>'])
            subtotal += line['amount']
            subtotal1 += line['initail_amount']
        grid.append(['3.2', u'Санхүүгийн үйл ажиллагааны мөнгөн зарлагын дүн', -subtotal1, -subtotal, '<font color="white">___</font>'])
        grid.extend(sublines)
        total -= subtotal
        total1 -= subtotal1
         
        grid.append(['3.20', u'<b>Санхүүгийн үйл ажиллагааны цэвэр мөнгөн гүйлгээний дүн</b>', total1, total, ''])
        grand += total
        grand1 += total1
        grid.append(['4', u'<b>Бүх цэвэр мөнгөн гүйлгээ</b>', grand1, grand, ''])
         
        now_balance = 0.0
        now_init_balance = 0.0
#        Эхний эцсийн үлдэгдлийг харин санхүүгийн бичилтээс тооцоно.
        account_ids = account_obj.search(cr, uid, [('type','=','liquidity'),('parent_id','child_of',[data['chart_account_id']])], context=context)
        account_tuple = tuple(account_ids)
 
        initial_bal = account_obj.get_initial_balance(cr, uid, account_ids, context=context)
        context.update({'date_from': fiscalyear.date_start})
        bal = dict((a['id'], a) for a in account_obj.read(cr, uid, account_ids, ['debit','credit'], context=context))
        
        bef_init_balance=0
        for line in _get_amount_by_type('dummy'):
            bef_init_balance = line['initail_amount']
        bef_balance = grand1+bef_init_balance
        now_balance = grand + bef_balance
        grid.append(['5.1', u'<b>Мөнгө, түүнтэй адилтгах хөрөнгийн эхний үлдэгдэл</b>', bef_init_balance, bef_balance, ''])
        grid.append(['5.2', u'<b>Мөнгө, түүнтэй адилтгах хөрөнгийн эцсийн үлдэгдэл</b>',bef_balance, now_balance, ''])
         
        return grid
    def get_story(self):
        ''' Тайлангийн өгөгдлүүдийг боловсруулж, PDF -г зурна.
            A4 цаасний стандарт хэмжээ 210x297 үүний тайлангийн бие нь
            Хэвтээ хэлбэрээр 280x200 байхаар тогтоолоо.
            
        '''
        story = []
        cr = self.cr
        uid = self.uid 
        context = self.context
        
        data = self.datas['form']
        period_obj = self.pool.get('account.period')
        account_obj = self.pool.get('account.account')
        company = self.pool.get('res.company').browse(cr, uid, data['company_id'])
        
        date_str = '%s-%s' % (
            datetime.strptime(data['date_from'],'%Y-%m-%d').strftime('%Y.%m.%d'),
            datetime.strptime(data['date_to'],'%Y-%m-%d').strftime('%Y.%m.%d')
        )
        
        styNormal = ParagraphStyle('normal', fontName='Helvetica', fontSize=8, leading=13,
                   textColor=navy, alignment=TA_LEFT, leftIndent=8, spaceAfter=10)
        styNormalR = ParagraphStyle('normal', fontName='Helvetica', fontSize=8, leading=13,
                   textColor=navy, alignment=TA_RIGHT, leftIndent=8, spaceAfter=10)
        title_style = ParagraphStyle('tabledataleft', fontName='Helvetica-Bold', fontSize=12, leading=17, 
                    alignment=TA_CENTER, leftIndent=1, rightIndent=1, spaceAfter=10, spaceBefore=10)
        nullpara = Paragraph('', styNormal)
        
        grid = [[
            Paragraph(u"Маягт CT-4-1", styNormal),
            Paragraph(u"Байгууллагын нэр: %s" % company.name, styNormalR)
        ],[
            Paragraph(u"МӨНГӨН ГҮЙЛГЭЭНИЙ ТАЙЛАН", title_style),
            nullpara
        ],[
            Paragraph(u"Дугаар: %s" % self.code, styNormal),
            Paragraph(u"Тайлант хугацаа: %s" % date_str, styNormalR),
        ]]
        
        tsGrid = TableStyle([
                ('GRID', (0,0), (-1,-1), 0.25, colors.white),
                ('SPAN', (0,1), (1,1))
        ])
        
        story.append(Table(grid, style=tsGrid, colWidths=[90*mm,90*mm]))
        story.append(Spacer(20,20))
        
        table = SimpleRowsTableBuilder(u'Мөнгөн гүйлгээний тайлан')
        
        table.add_text_column(u'Мөрийн дугаар', 15 * mm, extra={'font_size':7,'header_font_size':8})
        table.add_text_column(u'Үзүүлэлт', 100 * mm, extra={'font_size':7,'header_font_size':8})
        table.add_num_column(u'12 сарын 31', 25*mm, 2, extra={'font_size':7,'header_font_size':8})
        table.add_num_column(u'Тайлант үеийн дүн', 25*mm, 2, extra={'font_size':7,'header_font_size':8})
        
        grid1 = self.create_report_pdf_data(cr, uid, data, context)
        
        for row in grid1:
            table.add_text_cell(row[0])
            table.add_text_cell(row[4]+row[1])
            table.add_num_cell(row[2])
            table.add_num_cell(row[3])
        
        # Ингээд л болоо
        story.append(table.get_table())
        
        # Тайлангийн доод хэсэгт гарын үсэг зурах жижиг хүснэгт бэлдэнэ.
        tsGrid = TableStyle([
                ('GRID', (0,0), (-1,-1), 0.25, colors.white),
                ('FONT', (0,0),(-1,-1),'Helvetica', 8)
        ])
        #spacer
        story.append(Spacer(30,30))
        
        td_right_style = ParagraphStyle('tabledataright', fontName='Helvetica', fontSize=6, leading=11, 
                    alignment=TA_RIGHT, leftIndent=3, rightIndent=1, spaceAfter=1, spaceBefore=2)
        td_left_style = ParagraphStyle('tabledataleft', fontName='Helvetica', fontSize=6, leading=11, 
                    alignment=TA_LEFT, leftIndent=1, rightIndent=3, spaceAfter=1, spaceBefore=2)
        nullpara = Paragraph('', td_right_style)
        grid = [
            [Paragraph(u'Боловсруулсан :', td_right_style), Paragraph(u'Гүйцэтгэх захирал.........................................../<font color="white">____________________________________</font>/', td_left_style)],
            [nullpara,Paragraph(u'Ерөнхий нягтлан бодогч............................................./<font color="white">____________________________________</font>/', td_left_style)]
        ]
        story.append(Table(grid, style=tsGrid, colWidths=[80*mm,160*mm]))
        
        return story

cashflow_statement_report('report.account.cashflow.statement.report', "Cashflows statement", 'account.cashflow.statement.report', StandardReport.A4_PORTRAIT)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: