# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from c2c_reporting_tools.reports.standard_report import *
from c2c_reporting_tools.flowables.simple_row_table import *
from c2c_reporting_tools.c2c_helper import *
from c2c_reporting_tools.translation import _
from reportlab.platypus import *
from reportlab.lib.colors import red, black, navy, white, green
from reportlab.lib.enums import TA_LEFT, TA_RIGHT, TA_CENTER, TA_JUSTIFY

import time
from datetime import datetime
from dateutil.relativedelta import relativedelta
from xlwt import Workbook, Formula

class equity_changes(StandardReport):
    ''' Өмчийн өөрчлөлтийн тайлан
        (хуримтлагдсан ашгийн тайлан)
    '''
    def get_template_title(self, cr, context):
        """ return the title of the report """
        return u"ӨМЧИЙН ӨӨРЧЛӨЛТИЙН ТАЙЛАН"

    def get_report_barcode(self, cr, context=None):
        ''' Баримтын кодыг зураасан код болгож зурах '''
        if context is None:
            context = {}
        uid = 1
        if not self.datas['form']['save']:
            self.code = '-----'
            return False
        
        tmp, sequence_id = self.pool.get('ir.model.data').get_object_reference(cr, uid, 'l10n_mn_base','seq_account_report')
        #self.directory_name = 'B10101'
        sequence = self.pool.get('ir.sequence').get_id(cr, uid, sequence_id, code_or_id='id', context=context)
        if not sequence :
            self.code = '-----'
            return False
        self.code = sequence
        self.attache_name = sequence
        self.force_save = True
        return sequence
    
    def create_report_data(self, cr, uid, data, context=None):
        ''' Өмчийн өөрчлөлтийн тайлангийн мэдээллийг боловсруулж
            тайлангийн форматад тохируулан python [{},{},{}...]
            загвараар хүснэгтийн мөр багануудын өгөгдлийг боловсруулна.
            
            @return: cols - Хүснэгтийн толгойн өгөгдлүүд 
                     rows - Хүснэгтийн биеийн өгөгдлүүд
        '''
        def _get_initial_balance(dicte, a):
            if a.user_type.report_type not in ('expense','asset') :
                balance = dicte[a.id]['credit'] - dicte[a.id]['debit']
            else:
                balance = dicte[a.id]['debit'] - dicte[a.id]['credit']
            return balance
        
        if not context:
            context = {}
        account_obj = self.pool.get('account.account')
        journal_obj = self.pool.get('account.journal')
        currency_obj = self.pool.get('res.currency')
        fiscalyear_obj = self.pool.get('account.fiscalyear')
        if not context:
            context = {}
        fiscalyear = fiscalyear_obj.browse(cr, uid, data['form']['fiscalyear_id'], context=context)
        
        config_obj = self.pool.get('account.stockholders.equity.report.config') 
        config_id = config_obj.search(cr, uid, [('company_id', '=', data['form']['fiscalyear_id']),('year_id','=',data['form']['fiscalyear_id'])]) 
        config = config_obj.browse(cr, uid, config_id, context=context)
        config_line_obj = self.pool.get('account.stockholders.equity.config')
        conf_line_id = config_line_obj.search(cr, uid, [('report_id','=',config[0].id)])
        initial_account_ids = []
        res = []
        ress = []
        resss = []
        for res1 in config[0].report_id:
            initial_account_ids.append(res1['account_id'].id)
            res.append(res1['account_id'])
            ress.append(res1['init_balance1'])
            resss.append(res1['init_balance2'])
        number = 1
        rows = []
        context.update({
            'fiscalyear': fiscalyear.id,
            'date_from': data['form']['date_from'],
            'date_to':  data['form']['date_to'],
            'company_id': data['form']['company_id']
        })
        
        ### Эхний үлдэгдэл
        date_from_obj = datetime.strptime(data['form']['date_from'],'%Y-%m-%d')
        row = [str(number), u'<b>%s оны 12 сарын 31-ний үлдэгдэл</b>' % (int(date_from_obj.strftime('%Y'))-2)]
        initial_bal = account_obj.get_initial_balance(cr, uid, initial_account_ids, context=context)
        row.append(ress[0])
        row.append(ress[1])
        row.append(ress[2])
        row.append(ress[3])
        row.append(ress[4])
        row.append(ress[5])
        row.append(ress[6])
        row.append(Formula('sum(C8:I8)'))
        rows.append(row)
        
        ### Бүртгэлийн бодлогын өөрчлөлт
        number += 1 # line number
        ctx = context.copy()
        start_years = ''
        start_end_years = ''
        start = time.strftime("%Y-%m-%d")
        start_year = int(start[:4])
        start_years = str(start_year-2)+'-'+str(01)+'-'+str(01)
        start_end_years = str(start_year-2)+'-'+str(12)+'-'+str(31)
        ctx['date_from'] = start_years
        ctx['date_to'] = start_end_years
        
        acc_move = self.pool.get('account.move')
        acc_mv_line = self.pool.get('account.move.line')
        total = 0
        move_id = acc_move.search(cr, uid, [('id','=',config[0].property_adjustment_journal.id),('date','<=',start_years),('date','>=',start_end_years)])
        if move_id !=[]:
            line_id = acc_mv_line.search(cr, uid, [('move_id','=',move_id),('account_id','=',initial_account_ids)])
            if line_id !=[]:
                for lines in acc_mv_line.browse(cr, uid, line_id):
                 total = lines.debit - lines.credit   
        row = [str(number), u'Нягтлан бодох бүртгэлийн бодлогын өөрчлөлтийн нөлөө, алдааны залруулга','0', '0', '0', '0', '0', '0']
        row.append(total)
        row.append(Formula('SUM(C9:I9)'))
        rows.append(row)
        
        ### Залруулсан үлдэгдэл
        number += 1
        row = [str(number), u'Залруулсан үлдэгдэл']
        row.append(Formula('SUM(C8:C9)'))
        row.append(Formula('SUM(D8:D9)'))
        row.append(Formula('SUM(E8:E9)'))
        row.append(Formula('SUM(F8:F9)'))
        row.append(Formula('SUM(G8:G9)'))
        row.append(Formula('SUM(H8:H9)'))
        row.append(Formula('SUM(I8:I9)'))
        row.append(Formula('SUM(C10:I10)'))
        rows.append(row)
        
        ### Тайлант үеийн цэвэр ашиг
        number += 1
        row = [str(number), u'Тайлант үеийн цэвэр ашиг', '0', '0', '0', '0', '0', '0']
        a = account_obj.browse(cr, uid, res[0].id, ctx)
        row.append(a.debit-a.credit)
        row.append(Formula('SUM(C11:I11)'))
        rows.append(row)
        
        ### Бусад дэлгэрэнгүй орлого
        number += 1
        row = [str(number), u'Бусад дэлгэрэнгүй орлого','0','0','0',]
        revaluation_account_id = config_line_obj.browse(cr, uid, config_line_obj.search(cr, uid, [('type','=','revaluation_addition_account')]))[0]
        foreign_account_id = config_line_obj.browse(cr, uid, config_line_obj.search(cr, uid, [('type','=','foreign_currency_conversion_account')]))[0]
        remainder_account_id = config_line_obj.browse(cr, uid, config_line_obj.search(cr, uid, [('type','=','stockholders_equity_remainder_account')]))[0]
        aobjs = account_obj.browse(cr, uid, [revaluation_account_id.account_id.id,foreign_account_id.account_id.id,remainder_account_id.account_id.id],
                                   ctx)
        row.append(aobjs[0].debit - aobjs[0].credit)
        row.append(aobjs[1].debit - aobjs[1].credit)
        row.append(aobjs[2].debit - aobjs[2].credit)
        row.extend(['0'])
        row.append(Formula('SUM(C12:I12)'))
        rows.append(row)
        
        ### Өмчид гарсан өөрчлөлт
        number += 1
        row = [str(number), u'Өмчид гарсан өөрчлөлт']
        context5 = context.copy()
        journal_id = config[0].property_adjustment_journal.id
        expense_account_id = config_line_obj.browse(cr, uid, config_line_obj.search(cr, uid, [('type','=','statutory_fund_account')]))[0]
        context5.update({'journal_ids':[journal_id]})
        a = account_obj.browse(cr, uid, expense_account_id.account_id.id, context=context5)
        row.append(a.debit - a.credit)
        row.extend(['0','0', '0','0','0','0'])
        row.append(Formula('SUM(C13:I13)'))
        rows.append(row)
        
        ### Зарласан ногдол ашиг
        number += 1
        row = [str(number), u'Зарласан ногдол ашиг', '0','0','0','0','0','0']
        a = account_obj.browse(cr, uid, expense_account_id.account_id.id, ctx)
        row.append(a.debit - a.credit)
        row.append(Formula('SUM(C14:I14)'))
        rows.append(row)
        
        ### Дахин үнэлгээний нэмэгдлийн хэрэгжсэн дүн
        number += 1
        row = [str(number), u'Дахин үнэлгээний нэмэгдлийн хэрэгжсэн дүн', '0', '0', '0']
        a = account_obj.browse(cr, uid, expense_account_id.account_id.id, ctx)
        row.append(a.debit - a.credit)
        row.extend(['0','0','0'])
        row.append(Formula('SUM(C15:I15)'))
        rows.append(row)
        
        # Хөлийн дүн
        number += 1
        row = [str(number), u'<b>%s оны 12 сарын 31-ний үлдэгдэл</b>' % (int(date_from_obj.strftime('%Y'))-1)]
        initial_bal = account_obj.get_initial_balance(cr, uid, initial_account_ids, context=context)
        row.append(resss[0])
        row.append(resss[1])
        row.append(resss[2])
        row.append(resss[3])
        row.append(resss[4])
        row.append(resss[5])
        row.append(resss[6])
        row.append(Formula('SUM(C16:I16)'))
        rows.append(row)
        
        ### Бүртгэлийн бодлогын өөрчлөлт
        number += 1 # line number
        ctx2 = context.copy()
        date = time.strftime("%Y-%m-%d")
        year = int(date[:4])
        new_year = year-1
        month1 = 1
        day1 = 1
        month2 = 12
        day2 = 31
        new_date1 = ''
        new_date2 = ''
        new_date1 = str(new_year)+'-'+str(month1)+'-'+str(day1)
        new_date2 = str(new_year)+'-'+str(month2)+'-'+str(day2)
        ctx2['date_from'] = new_date1
        ctx2['date_to'] = new_date2
        total2 = 0
        move_ids = acc_move.search(cr, uid, [('id','=',config[0].property_adjustment_journal.id),('date','<=',new_date1),('date','>=',new_date2)])
        if move_ids !=[]:
            line_ids = acc_mv_line.search(cr, uid, [('move_id','=',move_ids),('account_id','=',initial_account_ids)])
            if line_ids !=[]:
                for liness in acc_mv_line.browse(cr, uid, line_ids):
                 total2 = liness.debit - liness.credit
        row = [str(number), u'Нягтлан бодох бүртгэлийн бодлогын өөрчлөлтийн нөлөө, алдааны залруулга']
        row.extend(['0','0','0','0','0','0'])
        row.append(total2)
        row.append(Formula('SUM(C17:I17)'))
        rows.append(row)
        
        ### Залруулсан үлдэгдэл
        number += 1
        row = [str(number), u'Залруулсан үлдэгдэл']
        row.append(Formula('SUM(C16:C17)'))
        row.append(Formula('SUM(D16:D17)'))
        row.append(Formula('SUM(E16:E17)'))
        row.append(Formula('SUM(F16:F17)'))
        row.append(Formula('SUM(G16:G17)'))
        row.append(Formula('SUM(H16:H17)'))
        row.append(Formula('SUM(I16:I17)'))
        row.append(Formula('SUM(C18:I18)'))
        rows.append(row)
        
        ### Тайлант үеийн цэвэр ашиг
        number += 1
        row = [str(number), u'Тайлант үеийн цэвэр ашиг', '0', '0', '0', '0', '0', '0']
        a = account_obj.browse(cr, uid, res[6].id, ctx2)
        row.append(a.debit-a.credit)
        row.append(a.debit-a.credit)
        rows.append(row)
        
        ### Бусад дэлгэрэнгүй орлого
        number += 1
        row = [str(number), u'Бусад дэлгэрэнгүй орлого', '0', '0', '0',]
        revaluation_account_id = config_line_obj.browse(cr, uid, config_line_obj.search(cr, uid, [('type','=','revaluation_addition_account')]))[0]
        foreign_account_id = config_line_obj.browse(cr, uid, config_line_obj.search(cr, uid, [('type','=','foreign_currency_conversion_account')]))[0]
        remainder_account_id = config_line_obj.browse(cr, uid, config_line_obj.search(cr, uid, [('type','=','stockholders_equity_remainder_account')]))[0]
        aobjs = account_obj.browse(cr, uid, [revaluation_account_id.account_id.id,foreign_account_id.account_id.id,remainder_account_id.account_id.id],
                                   ctx2)
        row.append(aobjs[0].debit - aobjs[0].credit)
        row.append(aobjs[1].debit - aobjs[1].credit)
        row.append(aobjs[2].debit - aobjs[2].credit)
        row.extend(['0'])
        row.append(Formula('SUM(C20:I20)'))
        rows.append(row)
        
        ### Өмчид гарсан өөрчлөлт
        number += 1
        row = [str(number), u'Өмчид гарсан өөрчлөлт']
        expense_account_id = config_line_obj.browse(cr, uid, config_line_obj.search(cr, uid, [('type','=','statutory_fund_account')]))[0]
        a = account_obj.browse(cr, uid, expense_account_id.account_id.id, ctx2)
        row.append(a.debit - a.credit)
        row.extend(['0','0','0','0','0','0'])
        row.append(Formula('SUM(C21:I21)'))
        rows.append(row)
        
        ### Зарласан ногдол ашиг
        number += 1
        row = [str(number), u'Зарласан ногдол ашиг', '0']
        a = account_obj.browse(cr, uid, expense_account_id.account_id.id, ctx2)
        row.append(a.debit - a.credit)
        row.extend(['0', '0', '0', '0', '0'])
        row.append(Formula('SUM(C22:I22)'))
        rows.append(row)
        
        ### Дахин үнэлгээний нэмэгдлийн хэрэгжсэн дүн
        number += 1
        row = [str(number), u'Дахин үнэлгээний нэмэгдлийн хэрэгжсэн дүн', '0', '0', '0']
        a = account_obj.browse(cr, uid, expense_account_id.account_id.id, ctx2)
        row.append(a.debit - a.credit)
        row.extend(['0','0','0'])
        row.append(Formula('SUM(C23:I23)'))
        rows.append(row)
        
        # Хөлийн дүн
        number += 1
        date_to_obj = datetime.strptime(data['form']['date_to'],'%Y-%m-%d')
        row = [str(number), u'<b>%s оны %s сарын %s-ний үлдэгдэл</b>' % (date_to_obj.strftime('%Y'),
                                                                         date_to_obj.strftime('%m'),
                                                                         date_to_obj.strftime('%d'))]
        row.append(Formula('SUM(C17:C23)'))
        row.append(Formula('SUM(D17:D23)'))
        row.append(Formula('SUM(E17:E23)'))
        row.append(Formula('SUM(F17:F23)'))
        row.append(Formula('SUM(G17:H23)'))
        row.append(Formula('SUM(H17:H23)'))
        row.append(Formula('SUM(I17:I23)'))
        row.append(Formula('SUM(C24:I24)'))
        rows.append(row)
        return rows
    
    def get_story(self):
        ''' Тайлангийн өгөгдлүүдийг боловсруулж, PDF -г зурна.
            A4 цаасний стандарт хэмжээ 210x297 үүний тайлангийн бие нь
            Хэвтээ хэлбэрээр 280x200 байхаар тогтоолоо.
            
        '''
        story = []
        cr = self.cr
        uid = self.uid 
        context = self.context
        
        data = self.datas['form']
        company = self.pool.get('res.company').browse(cr, uid, data['company_id'], context=context)
        
        date_str = '%s-%s' % (
            datetime.strptime(data['date_from'],'%Y-%m-%d').strftime('%Y.%m.%d'),
            datetime.strptime(data['date_to'],'%Y-%m-%d').strftime('%Y.%m.%d')
        )
        
        styNormal = ParagraphStyle('normal', fontName='Helvetica', fontSize=8, leading=13,
                   textColor=navy, alignment=TA_LEFT, leftIndent=8, spaceAfter=10)
        title_style = ParagraphStyle('tabledataleft', fontName='Helvetica-Bold', fontSize=12, leading=17, 
                    alignment=TA_CENTER, leftIndent=1, rightIndent=1, spaceAfter=10, spaceBefore=10)
        nullpara = Paragraph('', styNormal)
        
        grid = [[
            Paragraph(u"Маягт CT-3", styNormal),
            Paragraph(u"Байгууллагын нэр: %s" % company.name, styNormal)
        ],[
            Paragraph(u"ӨМЧИЙН ӨӨРЧЛӨЛТИЙН ТАЙЛАН", title_style),
            nullpara
        ],[
            Paragraph(u"Дугаар: %s" % self.code, styNormal),
            Paragraph(u"Тайлант хугацаа: %s" % date_str, styNormal),
        ]]
        
        tsGrid = TableStyle([
                ('GRID', (0,0), (-1,-1), 0.25, colors.white),
        ])
        
        story.append(Table(grid, style=tsGrid, colWidths=[140*mm,140*mm]))
        story.append(Spacer(10,10))
        
        table = SimpleRowsTableBuilder(u'ӨМЧИЙН ӨӨРЧЛӨЛТИЙН ТАЙЛАН')
        
        table.add_text_column(u'Д/д', 10 * mm, extra={'font_size':6,'header_font_size':7})
        table.add_text_column(u'ҮЗҮҮЛЭЛТ', 70 * mm, extra={'font_size':6,'header_font_size':7})
        table.add_num_column(u'Өмч', 25*mm, 2, extra={'font_size':5,'header_font_size':6})
        table.add_num_column(u'Халаасны хувьцаа', 25*mm, 2, extra={'font_size':5,'header_font_size':6})
        table.add_num_column(u'Нэмж төлөгдсөн капитал', 25*mm, 2, extra={'font_size':5,'header_font_size':6})
        table.add_num_column(u'Дахин үнэлгээний нэмэгдэл', 25*mm, 2, extra={'font_size':5,'header_font_size':6})
        table.add_num_column(u'Гадаад валютын хөрвүүлэлтийн нөөц', 25*mm, 2, extra={'font_size':5,'header_font_size':6})
        table.add_num_column(u'Эздийн өмчийн бусад хэсэг', 25*mm, 2, extra={'font_size':5,'header_font_size':6})
        table.add_num_column(u'Хуримтлагдсан ашиг', 25*mm, 2, extra={'font_size':5,'header_font_size':6})
        table.add_num_column(u'Нийт дүн', 25*mm, 2, extra={'font_size':5,'header_font_size':6})
        
        rows = self.create_report_data(cr, uid, self.datas, context)
        
        for row in rows :
            table.add_text_cell(row[0])
            table.add_text_cell(row[1])
            for td in row[2:]:
                table.add_num_cell(td)
        
        # Ингээд л болоо
        story.append(table.get_table())
        
        # Тайлангийн доод хэсэгт гарын үсэг зурах жижиг хүснэгт бэлдэнэ.
        tsGrid = TableStyle([
                ('GRID', (0,0), (-1,-1), 0.25, colors.white),
                ('FONT', (0,0),(-1,-1),'Helvetica', 8)
        ])
        #spacer
        story.append(Spacer(10,10))
        
        td_right_style = ParagraphStyle('tabledataright', fontName='Helvetica', fontSize=6, leading=11, 
                    alignment=TA_RIGHT, leftIndent=3, rightIndent=1, spaceAfter=1, spaceBefore=2)
        td_left_style = ParagraphStyle('tabledataleft', fontName='Helvetica', fontSize=6, leading=11, 
                    alignment=TA_LEFT, leftIndent=1, rightIndent=3, spaceAfter=1, spaceBefore=2)
        nullpara = Paragraph('', td_right_style)
        grid = [
            [Paragraph(u'Боловсруулсан :', td_right_style), Paragraph(u'Гүйцэтгэх захирал.........................................../<font color="white">____________________________________</font>/', td_left_style)],
            [nullpara,Paragraph(u'Ерөнхий нягтлан бодогч............................................./<font color="white">____________________________________</font>/', td_left_style)]
        ]
        story.append(Table(grid, style=tsGrid, colWidths=[40*mm,160*mm]))
        
        return story
    
equity_changes('report.account.stockholders.equity.report', "Statement of stockholder's equity", 'account.stockholders.equity.report', StandardReport.A4_LANDSCAPE)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: