# -*- encoding: utf-8 -*-
##############################################################################
#
#    Shine-ERP, Enterprise Management Solution    
#
##############################################################################

from c2c_reporting_tools.reports.standard_report import *
from c2c_reporting_tools.flowables.simple_row_table import *
from c2c_reporting_tools.c2c_helper import *
from c2c_reporting_tools.translation import _
from reportlab.platypus import *
from reportlab.lib.colors import red, black, navy, white, green
from reportlab.lib.enums import TA_LEFT, TA_RIGHT, TA_CENTER, TA_JUSTIFY
from operator import itemgetter
import time, itertools, operator

class asset_detail_register_keeper_owner(StandardReport):

    # TABLE HEADER
    th_style = ParagraphStyle('tableheaderbold', fontName='Helvetica', fontSize=7, leading=9, 
                    alignment=TA_CENTER, leftIndent=3, rightIndent=3, spaceAfter=2, spaceBefore=2)
    td_right_style = ParagraphStyle('tabledataright', fontName='Helvetica', fontSize=6, leading=8, 
                    alignment=TA_RIGHT, leftIndent=3, rightIndent=1, spaceAfter=1, spaceBefore=2)
    td_left_style = ParagraphStyle('tabledataleft', fontName='Helvetica', fontSize=6, leading=8, 
                    alignment=TA_LEFT, leftIndent=1, rightIndent=3, spaceAfter=1, spaceBefore=2)
    td_center_style = ParagraphStyle('tabledataleft', fontName='Helvetica', fontSize=6, leading=8, 
                    alignment=TA_CENTER, leftIndent=1, rightIndent=3, spaceAfter=1, spaceBefore=2)

    def deprecated_amount(self, cr, uid, asset_id,use_list,start_list,end_list, context={}):
        ''' Тухайн хөрөнгийн хуримтлагдсан элэгдлийн дүнг тодорхойлно.
        '''
        query ="""SELECT 
                l.asset_id, SUM(l.debit) AS dt,SUM(l.credit) AS cr
            FROM
                account_move_line l
            LEFT JOIN
                account_move m on (l.move_id=m.id)
            WHERE
                m.state <> 'draft' 
            AND
                m.date <= '%s'
            and l.asset_id = %s GROUP BY l.asset_id""" %(str(start_list),str(asset_id))
            
        cr.execute(query)
        res2=cr.fetchall()

        cr.execute("""SELECT 
                l.asset_id, SUM(l.debit) AS dt,SUM(l.credit) AS cr
            FROM
                account_move_line l 
            LEFT JOIN
                account_move m on (l.move_id=m.id)
            WHERE
                m.state <> 'draft' 
            and
                m.date > '%s'
            and
                m.date <= '%s'
            and
                l.asset_id = %s GROUP BY l.asset_id """ %(str(start_list),str(end_list),str(asset_id)))
        res3=cr.fetchall()
        if len(res2)==0:
            
            res2.append((0,0.00,0.00))
        if len(res3)==0:
            res3.append((0,0.00,0.00))

        return res2,res3
    def compute_data(self,cr,uid,asset_ids,data,group_datas,asset_obj,context):
        pretty = c2c_helper.comma_me # Тоог мянгатын нарийвчлалтай болгодог method
        nullpara = Paragraph('', self.td_right_style)
        P = Paragraph
        val_total_sum=0
        val_income_sum=0
        val_expense_sum=0
        val_last_t_sum=0
        val_depreciation_sum=0
        val_capital_sum=0
        depr_start_sum=0
        val_dpr_mon_sum=0
        depr_start = 0
        depr_mon = 0
        val_dpr_ex_sum=0
        val_dpr_last_sum=0
        val_dpr_total_sum=0
        count_first=0
        count_income=0
        count_ex=0
        count_last=0
        res_dpr_total = 0
        res_total = 0

        sum_count_first=0
        sum_count_income=0
        sum_count_ex=0
        sum_count_last=0
        use_list = {}
        start_list = {}
        end_list = {}

        seq=0
        asset_ht_obj = self.pool.get('account.asset.history')
        rows=[]

        asset_ht = asset_ht_obj.browse(cr,uid,
                    asset_ht_obj.search(cr,uid,[
                                                ('asset_id','in',asset_ids),
                                                   ('date','<=',data['s_date']),
                                                   '|',('date','>=',data['e_date']),
                                                   ('type','=','closed'),
                                           ]))
        closed_asset_ids=[]
        for i in asset_ht:
            closed_asset_ids.append(i.asset_id.id)
            for j in asset_ids:
                if j==i.asset_id.id:
                    asset_ids.remove(i.asset_id.id)
                
        for asset in asset_obj.browse(cr,uid,asset_ids):

            if data['type']=='keeper':
                year = str(asset.method_progress_factor)[:6]
                val_sell=0
                val_e=0
                type=''
                location_code=''
                date_use=''

                val_tot=0
                val_buy=0

                asset_ht = asset_ht_obj.browse(cr,uid,
                                               asset_ht_obj.search(cr,uid,[('asset_id','=',asset.id)]))

                val_order=asset.value_total
                capitalization=0

                if asset.template_id.category_id.code:
                    type=asset.template_id.category_id.code
                else:
                    type=asset.template_id.category_id.name
                location_code =asset.owner_id.name
                if asset.date:
                    date_use = asset.date
                else:
                    raise osv.except_osv(_('Warning !'), _('date in use is not define asset %s-%s')%(asset.code,asset.template_id.name))

                use_list = date_use
                start_list = data['s_date']
                end_list = data['e_date']
                if date_use <= data['s_date'] and asset.state!='close':
                    count_first = asset.quantity
                    val_tot=val_order
                    val_buy=0
                    res2,res3=self.deprecated_amount(cr,uid,asset.id,use_list,start_list,end_list,context)
                    depr_start = res2[0][2]
                    depr_mon = res3[0][2]
                    res2 = 0.00

                elif date_use > data['s_date'] and asset.state!='close':
                    count_income = asset.quantity
                    val_tot=0
                    val_buy=val_order
                    res2,res3=self.deprecated_amount(cr,uid,asset.id,use_list,start_list,end_list,context)
                    depr_start = res2[0][2]
                    depr_mon = res3[0][2]
                    res2 = 0.00

                if date_use <= data['s_date'] and date_use <= data['e_date'] and (asset.state=='close' or asset.state=='half_close'):
                    res={}
                    res2={}
                    cr.execute("""
                        SELECT l.asset_id, SUM(l.debit) inc, SUM(l.credit) AS ex
                        FROM
                            account_move_line l LEFT JOIN
                            account_move m on (l.move_id=m.id)
                        WHERE 
                            m.state <> 'draft' AND 
                            l.asset_id = ("""+str(asset.id)+") GROUP BY l.asset_id ")
                    res=cr.fetchall()
                    
                    count_first = asset.quantity
                    val_tot=res[0][1]
                    val_buy=0

                    count_ex = asset.quantity
                    val_sell=res[0][2]
                    if data['keeper_type'] == 'owner_dep' or data['keeper_type'] == 'item_dep'\
                     or data['keeper_type'] == 'short_item_dep' or data['keeper_type'] == 'short_owner_dep':					
                        res2,res3=self.deprecated_amount(cr,uid,asset.id,use_list,start_list,end_list,context)
                        val_e = res2[0][1]
                        depr_start = res2[0][2]
                        depr_mon = res3[0][2]
                        res2 = 0.00

                elif date_use > data['s_date'] and date_use <= data['e_date'] and (asset.state=='close' or asset.state=='half_close'):
                    res={}
                    res2={}
                    cr.execute("""
                        SELECT l.asset_id, SUM(l.debit) inc, SUM(l.credit) AS ex
                        FROM 
                            account_move_line l LEFT JOIN
                            account_move m on (l.move_id=m.id)
                        WHERE 
                            m.state <> 'draft' AND 
                            l.asset_id = ("""+str(asset.id)+") GROUP BY l.asset_id ")
                    res=cr.fetchall()
                    count_income = asset.quantity
                    val_tot=0
                    val_buy=res[0][1]

                    count_ex = asset.quantity
                    val_sell=res[0][2]
                    if data['keeper_type'] == 'owner_dep' or data['keeper_type'] == 'item_dep'\
                     or data['keeper_type'] == 'short_item_dep' or data['keeper_type'] == 'short_owner_dep':
                        res2,res3 = self.deprecated_amount(cr,uid,asset.id,use_list,start_list,end_list,context)
                        val_e = res2[0][1]
                        depr_start = res2[0][2]
                        depr_mon = res3[0][2]

                if asset_ht and asset_ht[0].type=='capitalization':
                    capitalization=asset.value_write_up
                        
                res_val_total = val_tot+val_buy-val_sell+capitalization
                count_last = count_first + count_income - count_ex

                res_dpr_total = depr_mon-val_e+depr_start
                res_total=res_val_total-res_dpr_total
                if data['keeper_type'] == 'owner_ending' or data['keeper_type'] == 'item_ending':
                    rows.append([
                               P(type,self.td_center_style),
                               P(asset.template_id.name,self.td_left_style),
                               P(asset.code,self.td_center_style),
                               P('',self.td_center_style),
                               P(date_use,self.td_center_style),
                               P(str(year),self.td_right_style),
                               P(str(int(count_first)),self.td_right_style),
                               P(pretty(val_tot,separator=","), self.td_right_style),
                               P(str(int(count_income)),self.td_right_style),
                               P(pretty(val_buy,separator=","), self.td_right_style),
                               P(str(int(count_ex)),self.td_right_style),
                               P(pretty(val_sell,separator=","), self.td_right_style),
                               P(str(int(count_last)),self.td_right_style),
                               P(pretty(res_val_total,separator=","), self.td_right_style),
                               P(pretty(asset.value_write_up,separator=","), self.td_right_style),
                    ])
                elif data['keeper_type'] == 'owner_dep' or data['keeper_type'] == 'item_dep':

                    rows.append([
                               P(type,self.td_center_style),
                               P(asset.template_id.name,self.td_left_style),
                               P(asset.code,self.td_center_style),
                               P(location_code,self.td_center_style),
                               P(str(year),self.td_right_style),
                               P(pretty(val_tot,separator=","), self.td_right_style),
                               P(pretty(val_buy,separator=","), self.td_right_style),
                               P(pretty(val_sell,separator=","), self.td_right_style),
                               P(pretty(depr_start,separator=","), self.td_right_style),
                               P(pretty(depr_mon,separator=","), self.td_right_style),
                               P(pretty(val_e,separator=","), self.td_right_style),
                               P(pretty(res_dpr_total,separator=","), self.td_right_style),

                               P(pretty(res_total,separator=","), self.td_right_style),
                    ])

                val_capital_sum+=asset.value_write_up
                val_total_sum+=val_tot
                val_income_sum+=val_buy
                val_expense_sum+=val_sell
                val_last_t_sum+=res_val_total
                depr_start_sum+=depr_start
                val_dpr_mon_sum+=depr_mon
                val_dpr_ex_sum+=val_e
                val_dpr_last_sum+=res_dpr_total
                val_dpr_total_sum+=res_total
                
                sum_count_first+=count_first
                sum_count_income+=count_income
                sum_count_ex+=count_ex
                sum_count_last+=count_last

                count_first=0
                count_income=0
                count_ex=0
                count_last=0
                depr_start = 0
                depr_mon = 0
                res_dpr_total = 0
                res_total = 0

        if data['keeper_type'] == 'owner_ending' or data['keeper_type'] == 'item_ending':
            t3=[[nullpara,
                 nullpara,
                 nullpara,
                 nullpara,
               P(u'Дүн',self.td_center_style),
                 nullpara,
               P(str(sum_count_first),self.td_right_style),
               P(pretty(val_total_sum,separator=","), self.td_right_style),
               P(str(sum_count_income),self.td_right_style),
               P(pretty(val_income_sum,separator=","), self.td_right_style),
               P(str(sum_count_ex),self.td_right_style),
               P(pretty(val_expense_sum,separator=","), self.td_right_style),
               P(str(sum_count_last),self.td_right_style),
               P(pretty(val_last_t_sum,separator=","), self.td_right_style),
               P(pretty(val_capital_sum,separator=","), self.td_right_style),
               ]]
        elif data['keeper_type'] == 'owner_dep' or data['keeper_type'] == 'item_dep':
            t3=[[nullpara,
                 nullpara,
                 nullpara,
               P(u'Дүн',self.td_center_style),
                 nullpara,
               P(pretty(val_total_sum,separator=","), self.td_right_style),
               P(pretty(val_income_sum,separator=","), self.td_right_style),
               P(pretty(val_expense_sum,separator=","), self.td_right_style),
               P(pretty(depr_start_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_mon_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_ex_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_last_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_total_sum,separator=","), self.td_right_style),
               ]]
        elif data['keeper_type']=='short_item_ending':
            t3=[[
               P(group_datas[0]['cat_code'],self.td_center_style),
               P(group_datas[0]['cat_name'],self.td_left_style),
               P(str(sum_count_first),self.td_right_style),
               P(pretty(val_total_sum,separator=","), self.td_right_style),
               P(str(sum_count_income),self.td_right_style),
               P(pretty(val_income_sum,separator=","), self.td_right_style),
               P(str(sum_count_ex),self.td_right_style),
               P(pretty(val_expense_sum,separator=","), self.td_right_style),
               P(str(sum_count_last),self.td_right_style),
               P(pretty(val_last_t_sum,separator=","), self.td_right_style),
               P(pretty(val_capital_sum,separator=","), self.td_right_style),
               ]]
        elif data['keeper_type'] == 'short_item_dep':
            t3=[[
               P(group_datas[0]['cat_code'],self.td_center_style),
               P(group_datas[0]['cat_name'],self.td_left_style),
               P(pretty(val_total_sum,separator=","), self.td_right_style),
               P(pretty(val_income_sum,separator=","), self.td_right_style),
               P(pretty(val_expense_sum,separator=","), self.td_right_style),
               P(pretty(depr_start_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_mon_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_ex_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_last_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_total_sum,separator=","), self.td_right_style),]]

        elif data['keeper_type'] == 'short_owner_ending':
            t3=[[
               P(group_datas[0]['account_code'],self.td_center_style),
               P(group_datas[0]['account_name'],self.td_left_style),
               P(str(sum_count_first),self.td_right_style),
               P(pretty(val_total_sum,separator=","), self.td_right_style),
               P(str(sum_count_income),self.td_right_style),
               P(pretty(val_income_sum,separator=","), self.td_right_style),
               P(str(sum_count_ex),self.td_right_style),
               P(pretty(val_expense_sum,separator=","), self.td_right_style),
               P(str(sum_count_last),self.td_right_style),
               P(pretty(val_last_t_sum,separator=","), self.td_right_style),
               P(pretty(val_capital_sum,separator=","), self.td_right_style),
               ]]
        elif data['keeper_type'] == 'short_owner_dep':
            t3=[[
               P(group_datas[0]['account_code'],self.td_center_style),
               P(group_datas[0]['account_name'],self.td_left_style),
               P(pretty(val_total_sum,separator=","), self.td_right_style),
               P(pretty(val_income_sum,separator=","), self.td_right_style),
               P(pretty(val_expense_sum,separator=","), self.td_right_style),
               P(pretty(depr_start_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_mon_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_ex_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_last_sum,separator=","), self.td_right_style),
               P(pretty(val_dpr_total_sum,separator=","), self.td_right_style),]]

        total_dic = {}
        if data['keeper_type']=='short_item_ending' or data['keeper_type'] == 'short_owner_ending':
            total_dic ={
               'sum_count_first':sum_count_first,
               'val_total_sum':val_total_sum,
               'sum_count_income':sum_count_income,
               'val_income_sum':val_income_sum,
               'sum_count_ex':sum_count_ex,
               'val_expense_sum':val_expense_sum,
               'sum_count_last':sum_count_last,
               'val_last_t_sum':val_last_t_sum,
               'val_capital_sum':val_capital_sum,
               }

            rows.extend(t3)
            return rows,total_dic
        elif data['keeper_type'] == 'short_item_dep' or data['keeper_type'] == 'short_owner_dep':
            total_dic ={
               'val_total_sum':val_total_sum,
               'val_income_sum':val_income_sum,
               'val_expense_sum':val_expense_sum,
               'sum_count_last':sum_count_last,
               'val_last_t_sum':val_last_t_sum,
               'val_capital_sum':val_capital_sum,
               'depr_start_sum':depr_start_sum,
               'val_dpr_mon_sum':val_dpr_mon_sum,
               'val_dpr_ex_sum':val_dpr_ex_sum,
               'val_dpr_last_sum':val_dpr_last_sum,
               'val_dpr_total_sum':val_dpr_total_sum
               }

            rows.extend(t3)
            return rows,total_dic
        else:
            rows.extend(t3)
            return rows
    def get_story(self):
        data = self.datas['form']
        story = []
        cr = self.cr
        uid = self.uid 
        context = self.context
        asset_obj = self.pool.get('account.asset.asset')
        account_obj = self.pool.get('account.account')
        dep_obj = self.pool.get('hr.department')
        styBody = ParagraphStyle('normal',
                                 fontName='Helvetica',
                                 fontSize=6,
                                 alignment=TA_RIGHT)
        sch=()
        label1=''
        label1_size=0
        nullpara = Paragraph('', self.td_right_style)
        pretty = c2c_helper.comma_me # Тоог мянгатын нарийвчлалтай болгодог method
        P = Paragraph

        t1=[]
        t1_style = TableStyle([
                ('TEXTCOLOR', (0,0),(-1,-1), colors.black),
                ('ALIGN',(0,0),(-1,-1),'LEFT'),
                ('FONT', (0,0),(-1,-1), 'DejaVu Sans', 7),
        ])
        if data['company_id'] :
            company = self.pool.get('res.company').browse(cr, uid, data['company_id'][0], context=context)
        else :
            company_ids = self.pool.get('res.company').search(cr, uid, [], context=context)
            if company_ids :
                company = self.pool.get('res.company').browse(cr, uid, company_ids[0], context=context)
            else :
                company = False

        label1_size=15*mm
        t1 = [[
            Paragraph(u"Байгууллагын нэр: <b>%s</b>" %((company and company.name) or '..................'),
                ParagraphStyle('normal', fontName='Helvetica', fontSize=7, leading=14, 
                        alignment=TA_LEFT, leftIndent=20, spaceAfter=5)),
            nullpara,
            Paragraph(u"Тайлант хугацаа: <b>%s</b>-ээс <b>%s</b>-ны хооронд" %(data['s_date'],data['e_date']),
                ParagraphStyle('normal', fontName='Helvetica', fontSize=7, leading=14, 
                        alignment=TA_RIGHT, leftIndent=20, spaceAfter=5)),]]

        if data['type']=='keeper':
            if data['keeper_id']:
                print data['keeper_id']
                department = dep_obj.browse(cr, uid, data['keeper_id'][0], context=context)
            elif data['all']:
                try:
                    departments=[]
                    for asset in asset_obj.browse(cr,uid,asset_obj.search(cr,uid,[])):
                        if asset.template_id.account_asset_id.id:
                            if asset.owner_id and asset.owner_id.id:
                                departments.append(asset.owner_id.department_id.id)
                    print 'Departments: ' + str(departments)
                except osv.except_osv,e:
                    print ok
                    self.fail(e.name + e.value)
            else:
                raise osv.except_osv(_('Error !'),
                        _('Select account, or keeper'))
            if data['keeper_type'] == 'owner_ending' or data['keeper_type'] == 'item_ending':
                t2 = [[
                       Paragraph(u'Төрөл',self.th_style),
                       Paragraph(u'Хөрөнгийн нэр',self.th_style),
                       Paragraph(u'Хөрөнгийн дугаар',self.th_style),
                       Paragraph(u'Байршил',self.th_style),
                       Paragraph(u'Ашиглалтанд орсон огноо',self.th_style),
                       Paragraph(u'Сарын элэгдлийн хувь',self.th_style),
                       Paragraph(u'Анхны өртөг',self.th_style),
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       Paragraph(u'Капитал жуулалт',self.th_style)],[
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       Paragraph(u'Эхний',self.th_style),
                       nullpara,
                       Paragraph(u'Орлого',self.th_style),
                       nullpara,
                       Paragraph(u'Зарлага',self.th_style),
                       nullpara,
                       Paragraph(u'Эцсийн',self.th_style),
                       nullpara,
                       nullpara],
                      [
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       Paragraph(u'Тоо',self.th_style),
                       Paragraph(u'Үнэ',self.th_style),
                       Paragraph(u'Тоо',self.th_style),
                       Paragraph(u'Үнэ',self.th_style),
                       Paragraph(u'Тоо',self.th_style),
                       Paragraph(u'Үнэ',self.th_style),
                       Paragraph(u'Тоо',self.th_style),
                       Paragraph(u'Үнэ',self.th_style),
                       nullpara]
                      ]

                t2_style = TableStyle([
                        ('ALIGN',(0,0),(-1,1),'CENTER'),
                        ('ALIGN',(2,1),(-2,-1),'RIGHT'),
                        ('ALIGN',(1,1),(1,-1),'LEFT'),
                        ('FONT', (0,0),(-1,1), 'DejaVu Sans Bold', 7),
                        ('FONT', (0,2),(-1,-1), 'DejaVu Sans', 7),
                        ('GRID',(0,0),(-1,-1), 0.5, colors.black),
                        ('VALIGN',(0,0),(-1,-1),'MIDDLE'),
                        ('SPAN',(0,0),(0,2)),
                        ('SPAN',(1,0),(1,2)),
                        ('SPAN',(2,0),(2,2)),
                        ('SPAN',(3,0),(3,2)),
                        ('SPAN',(4,0),(4,2)),
                        ('SPAN',(5,0),(5,2)),
                        ('SPAN',(6,0),(13,0)),
                        ('SPAN',(6,1),(7,1)),
                        ('SPAN',(8,1),(9,1)),
                        ('SPAN',(10,1),(11,1)),
                        ('SPAN',(12,1),(13,1)),
                        ('SPAN',(14,0),(14,2)),
                ],)
                col_w=[label1_size,45*mm,20*mm,15*mm,20*mm,15*mm,10*mm,20*mm,10*mm,20*mm,10*mm,20*mm,10*mm,20*mm,20*mm]
                title=u"Үндсэн хөрөнгийн дэлгэрэнгүй бүртгэл (эд хариуцагчаар) үлдэгдэл"
            elif data['keeper_type'] == 'owner_dep' or data['keeper_type'] == 'item_dep':
                t2 = [[
                       Paragraph(u'Төрөл',self.th_style),
                       Paragraph(u'Хөрөнгийн нэр',self.th_style),
                       Paragraph(u'Хөрөнгийн дугаар',self.th_style),
                       Paragraph(u'Байршил',self.th_style),
                       Paragraph(u'Сарын элэгдлийн хувь',self.th_style),
                       Paragraph(u'Анхны өртөг',self.th_style),
                       nullpara,
                       nullpara,
                       Paragraph(u'Элэгдэл',self.th_style),
                       nullpara,
                       nullpara,
                       nullpara,
                       Paragraph(u'Үлдэгдэл өртөг',self.th_style),
                       ],[
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       Paragraph(u'Эхний',self.th_style),
                       Paragraph(u'Орлого',self.th_style),
                       Paragraph(u'Зарлага',self.th_style),
                       Paragraph(u'Хуримт лагдсан',self.th_style),
                       Paragraph(u'Сарын',self.th_style),
                       Paragraph(u'Хасагдсанд ноогдох',self.th_style),
                       Paragraph(u'Үлдэгдэл',self.th_style),
                       nullpara],
                      ]
                t2_style = TableStyle([
                        ('ALIGN',(0,0),(-1,1),'CENTER'),
                        ('ALIGN',(2,1),(-2,-1),'RIGHT'),
                        ('ALIGN',(1,1),(1,-1),'LEFT'),
                        ('FONT', (0,0),(-1,1), 'DejaVu Sans Bold', 7),
                        ('FONT', (0,2),(-1,-1), 'DejaVu Sans', 7),
                        ('GRID',(0,0),(-1,-1), 0.5, colors.black),
                        ('VALIGN',(0,0),(-1,-1),'MIDDLE'),
                        ('SPAN',(0,0),(0,1)),
                        ('SPAN',(1,0),(1,1)),
                        ('SPAN',(2,0),(2,1)),
                        ('SPAN',(3,0),(3,1)),
                        ('SPAN',(4,0),(4,1)),
                        ('SPAN',(5,0),(7,0)),
                        ('SPAN',(8,0),(11,0)),
                        ('SPAN',(12,0),(12,1)), 
                ],)
                col_w=[label1_size,45*mm,20*mm,20*mm,15*mm,20*mm,20*mm,20*mm,20*mm,18*mm,18*mm,23*mm,23*mm,]
                title=u"Үндсэн хөрөнгийн дэлгэрэнгүй бүртгэл (эд хариуцагчаар) элэгдэл"
            if data['keeper_type'] == 'short_item_ending' or data['keeper_type'] == 'short_owner_ending':
                t2 = [[
                       Paragraph(u'Код',self.th_style),
                       Paragraph(u'Хөрөнгийн нэр',self.th_style),
                       Paragraph(u'Анхны өртөг',self.th_style),
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       nullpara,
                       Paragraph(u'Капитал жуулалт',self.th_style)],[
                       nullpara,
                       nullpara,
                       Paragraph(u'Эхний',self.th_style),
                       nullpara,
                       Paragraph(u'Орлого',self.th_style),
                       nullpara,
                       Paragraph(u'Зарлага',self.th_style),
                       nullpara,
                       Paragraph(u'Эцсийн',self.th_style),
                       nullpara,
                       nullpara],
                      [
                       nullpara,
                       nullpara,
                       Paragraph(u'Тоо',self.th_style),
                       Paragraph(u'Үнэ',self.th_style),
                       Paragraph(u'Тоо',self.th_style),
                       Paragraph(u'Үнэ',self.th_style),
                       Paragraph(u'Тоо',self.th_style),
                       Paragraph(u'Үнэ',self.th_style),
                       Paragraph(u'Тоо',self.th_style),
                       Paragraph(u'Үнэ',self.th_style),
                       nullpara]
                      ]

                t2_style = TableStyle([
                        ('ALIGN',(0,0),(-1,1),'CENTER'),
                        ('ALIGN',(2,1),(-2,-1),'RIGHT'),
                        ('ALIGN',(1,1),(1,-1),'LEFT'),
                        ('FONT', (0,0),(-1,1), 'DejaVu Sans Bold', 7),
                        ('FONT', (0,2),(-1,-1), 'DejaVu Sans', 7),
                        ('GRID',(0,0),(-1,-1), 0.5, colors.black),
                        ('VALIGN',(0,0),(-1,-1),'MIDDLE'),
                        ('SPAN',(0,0),(0,2)),
                        ('SPAN',(1,0),(1,2)),
                        ('SPAN',(2,0),(9,0)),
                        ('SPAN',(2,1),(5,1)),
                        ('SPAN',(4,1),(5,1)),
                        ('SPAN',(6,1),(7,1)),
                        ('SPAN',(8,1),(9,1)),
                        ('SPAN',(10 ,0),(10,2)),
                ],)
                col_w=[label1_size,55*mm,15*mm,30*mm,15*mm,30*mm,15*mm,30*mm,15*mm,30*mm,30*mm]
                if data['keeper_type'] == 'short_item_ending':
                    title=u"Үндсэн хөрөнгийн дэлгэрэнгүй бүртгэлийн товчоо (эд хариуцагчаар) төрлөөр үлдэгдэл"
                if data['keeper_type'] == 'short_owner_ending':
                    title=u"Үндсэн хөрөнгийн дэлгэрэнгүй бүртгэлийн товчоо (эд хариуцагчаар) эд хариуцагчаар үлдэгдэл"
            if data['keeper_type'] == 'short_item_dep' or data['keeper_type'] == 'short_owner_dep':
                t2 = [[
                       Paragraph(u'Төрөл',self.th_style),
                       Paragraph(u'Хөрөнгийн нэр',self.th_style),
                       Paragraph(u'Анхны өртөг',self.th_style),
                       nullpara,
                       nullpara,
                       Paragraph(u'Элэгдэл',self.th_style),
                       nullpara,
                       nullpara,
                       nullpara,
                       Paragraph(u'Үлдэгдэл өртөг',self.th_style),
                       ],[
                       nullpara,
                       nullpara,
                       Paragraph(u'Эхний',self.th_style),
                       Paragraph(u'Орлого',self.th_style),
                       Paragraph(u'Зарлага',self.th_style),
                       Paragraph(u'Хуримт лагдсан',self.th_style),
                       Paragraph(u'Сарын',self.th_style),
                       Paragraph(u'Хасагдсанд ноогдох',self.th_style),
                       Paragraph(u'Үлдэгдэл',self.th_style),
                       nullpara],
                      ]
                t2_style = TableStyle([
                        ('ALIGN',(0,0),(-1,1),'CENTER'),
                        ('ALIGN',(2,1),(-2,-1),'RIGHT'),
                        ('ALIGN',(1,1),(1,-1),'LEFT'),
                        ('FONT', (0,0),(-1,1), 'DejaVu Sans Bold', 7),
                        ('FONT', (0,2),(-1,-1), 'DejaVu Sans', 7),
                        ('GRID',(0,0),(-1,-1), 0.5, colors.black),
                        ('VALIGN',(0,0),(-1,-1),'MIDDLE'),
                        ('SPAN',(0,0),(0,1)),
                        ('SPAN',(1,0),(1,1)),
                        ('SPAN',(2,0),(4,0)),
                        ('SPAN',(5,0),(8,0)),
                        ('SPAN',(9,0),(9,1)), 
                ],)
                col_w=[label1_size,55*mm,25*mm,25*mm,25*mm,25*mm,20*mm,20*mm,23*mm,23*mm,]
                title=u"Үндсэн хөрөнгийн дэлгэрэнгүй бүртгэлийн товчоо (эд хариуцагчаар) элэгдэл"

        story.append(Paragraph(u"Санхүү эдийн засгийн сайдын 2002 оны 191 тоот тушаалаар батлав.", styBody))
        styNormal = ParagraphStyle('normal',fontName='Helvetica-Bold',fontSize=10,leading=15,textColor=black,alignment=TA_CENTER,rightIndent=10,spaceAfter=5)
        story.append(Paragraph(title, styNormal))
        story.append(Spacer(10,10))

        story.append(Table(t1, style=t1_style, colWidths=[90*mm,90*mm,90*mm]))
        
        tstyle = TableStyle([
            ('LINEBELOW', (0,-1), (-1,-1), 0.40, colors.black),
        ])
        story.append(Table(t2, style=t2_style, colWidths=col_w))
        if data['keeper_id']:
            grid = [[
                Paragraph(u"<b>Эд хариуцагч : %s</b>" %department.name,self.td_right_style),
                Paragraph(u"",self.td_left_style),
            ]]
            width = [70*mm, 130*mm] # 200
            story.append(Table(grid, colWidths=width))
            if data['keeper_type'] == 'owner_ending' or data['keeper_type'] == 'owner_dep'\
             or data['keeper_type'] == 'short_owner_ending' or data['keeper_type'] == 'short_owner_dep':
                asset_groups=[]
                for asset in asset_obj.browse(cr,uid,asset_obj.search(cr,uid,[('state','<>','draft'),('owner_id','=',department.id)])):
                    asset_groups.append({'asset_id':asset.id,
                                         'account_id':asset.account_asset_id.id,
                                         'account_name':asset.account_asset_id.name,
                                         'account_code':asset.account_asset_id.code,
                                         })
                group_datas = []
                sorted_datas = sorted(asset_groups, key=itemgetter('account_id'))
                for key, items in itertools.groupby(sorted_datas, operator.itemgetter('account_id')):
                    group_datas.append(list(items))
                if data['keeper_type'] == 'short_owner_ending':
                   sum_count_first=0.00
                   val_total_sum=0.00
                   sum_count_income=0.00
                   val_income_sum=0.00
                   sum_count_ex=0.00
                   val_expense_sum=0.00
                   sum_count_last=0.00
                   val_last_t_sum=0.00
                   val_capital_sum=0.00
                   
                   for d in group_datas:
                       asset_ids=[]
                       for h in d: asset_ids.append(h['asset_id'])
                       data_report,total_dict = self.compute_data(cr, uid, asset_ids, data,d, asset_obj,context=context)
                       grid.extend(data_report)
                       grid.pop(0)
                       if len(grid)>0:
                            story.append(Table(grid, style=tstyle2, colWidths=col_w))
                       sum_count_first+=total_dict['sum_count_first']
                       val_total_sum+=total_dict['val_total_sum']
                       sum_count_income+=total_dict['sum_count_income']
                       val_income_sum+=total_dict['val_income_sum']
                       sum_count_ex+=total_dict['sum_count_ex']
                       val_expense_sum+=total_dict['val_expense_sum']
                       sum_count_last+=total_dict['sum_count_last']
                       val_last_t_sum+=total_dict['val_last_t_sum']
                       val_capital_sum+=total_dict['val_capital_sum']

                   t4=[[
                       nullpara,
                       P(u"Дүн",self.td_center_style),
                       P(str(sum_count_first),self.td_right_style),
                       P(pretty(val_total_sum,separator=","), self.td_right_style),
                       P(str(sum_count_income),self.td_right_style),
                       P(pretty(val_income_sum,separator=","), self.td_right_style),
                       P(str(sum_count_ex),self.td_right_style),
                       P(pretty(val_expense_sum,separator=","), self.td_right_style),
                       P(str(sum_count_last),self.td_right_style),
                       P(pretty(val_last_t_sum,separator=","), self.td_right_style),
                       P(pretty(val_capital_sum,separator=","), self.td_right_style),
                       ]]
                   grid.extend(t4)
                   grid.pop(0)
                   if len(grid)>0:
                        story.append(Table(grid, style=tstyle, colWidths=col_w))
                elif data['keeper_type'] == 'short_owner_dep':
                   val_total_sum=0.00
                   val_income_sum=0.00
                   val_expense_sum=0.00
                   depr_start_sum=0.00
                   val_dpr_mon_sum=0.00
                   val_dpr_ex_sum=0.00
                   val_dpr_last_sum=0.00
                   val_dpr_total_sum=0.00

                   for d in group_datas:
                       asset_ids=[]
                       for h in d: asset_ids.append(h['asset_id'])
                       data_report,total_dict = self.compute_data(cr, uid, asset_ids, data,d, asset_obj,context=context)
                       grid.extend(data_report)
                       grid.pop(0)
                       if len(grid)>0:
                            story.append(Table(grid, style=tstyle2, colWidths=col_w))

                       val_total_sum+=total_dict['val_total_sum']
                       val_income_sum+=total_dict['val_income_sum']
                       val_expense_sum+=total_dict['val_expense_sum']
                       depr_start_sum+=total_dict['depr_start_sum']
                       val_dpr_mon_sum+=total_dict['val_dpr_mon_sum']
                       val_dpr_ex_sum+=total_dict['val_dpr_ex_sum']
                       val_dpr_last_sum+=total_dict['val_dpr_last_sum']
                       val_dpr_total_sum+=total_dict['val_dpr_total_sum']

                   t4=[[
                       nullpara,
                       P(u"Дүн",self.td_center_style),
                       P(pretty(val_total_sum,separator=","), self.td_right_style),
                       P(pretty(val_income_sum,separator=","), self.td_right_style),
                       P(pretty(val_expense_sum,separator=","), self.td_right_style),
                       P(pretty(depr_start_sum,separator=","), self.td_right_style),
                       P(pretty(val_dpr_mon_sum,separator=","), self.td_right_style),
                       P(pretty(val_dpr_ex_sum,separator=","), self.td_right_style),
                       P(pretty(val_dpr_last_sum,separator=","), self.td_right_style),
                       P(pretty(val_dpr_total_sum,separator=","), self.td_right_style),
                       ]]
                   grid.extend(t4)
                   grid.pop(0)
                   if len(grid)>0:
                        story.append(Table(grid, style=tstyle, colWidths=col_w))
                else:
                    for d in group_datas:
                        grid = [[
                            Paragraph(u"<b>Хөрөнгийн данс : %s</b>" %d[0]['account_code'],self.td_right_style),
                            Paragraph(u"<b>%s</b>" %d[0]['account_name'],self.td_left_style),
                        ]]
                        width = [50*mm, 150*mm] # 200
                        story.append(Table(grid, colWidths=width))
        
                        asset_ids=[]
                        for h in d: asset_ids.append(h['asset_id'])
                        grid.extend(self.compute_data(cr, uid, asset_ids, data,group_datas, asset_obj,context=context))
                        grid.pop(0)
                        if len(grid)>0:                
                            story.append(Table(grid, style=tstyle, colWidths=col_w))
            elif data['keeper_type'] == 'item_ending' or data['keeper_type'] == 'item_dep'\
             or data['keeper_type'] == 'short_item_ending' or data['keeper_type'] == 'short_item_dep':
                asset_groups=[]
                for asset in asset_obj.browse(cr,uid,asset_obj.search(cr,uid,[('state','<>','draft'),('owner_id','=',department.id)])):
                    asset_groups.append({'asset_id':asset.id,
                                         'cat_id':asset.template_id.category_id.id,
                                         'cat_name':asset.template_id.category_id.name,
                                         'cat_code':asset.template_id.category_id.code,
                                         })
                group_datas = []
                sorted_datas = sorted(asset_groups, key=itemgetter('cat_id'))
                for key, items in itertools.groupby(sorted_datas, operator.itemgetter('cat_id')):
                    group_datas.append(list(items))
                if data['keeper_type'] == 'short_item_ending':
                   sum_count_first=0.00
                   val_total_sum=0.00
                   sum_count_income=0.00
                   val_income_sum=0.00
                   sum_count_ex=0.00
                   val_expense_sum=0.00
                   sum_count_last=0.00
                   val_last_t_sum=0.00
                   val_capital_sum=0.00

                   for d in group_datas:
                       asset_ids=[]
                       for h in d: asset_ids.append(h['asset_id'])
                       data_report,total_dict = self.compute_data(cr, uid, asset_ids, data,d, asset_obj,context=context)
                       grid.extend(data_report)
                       grid.pop(0)
                       if len(grid)>0:
                            story.append(Table(grid, style=tstyle2, colWidths=col_w))
                       sum_count_first+=total_dict['sum_count_first']
                       val_total_sum+=total_dict['val_total_sum']
                       sum_count_income+=total_dict['sum_count_income']
                       val_income_sum+=total_dict['val_income_sum']
                       sum_count_ex+=total_dict['sum_count_ex']
                       val_expense_sum+=total_dict['val_expense_sum']
                       sum_count_last+=total_dict['sum_count_last']
                       val_last_t_sum+=total_dict['val_last_t_sum']
                       val_capital_sum+=total_dict['val_capital_sum']

                   t4=[[
                       nullpara,
                       P(u"Дүн",self.td_center_style),
                       P(str(sum_count_first),self.td_right_style),
                       P(pretty(val_total_sum,separator=","), self.td_right_style),
                       P(str(sum_count_income),self.td_right_style),
                       P(pretty(val_income_sum,separator=","), self.td_right_style),
                       P(str(sum_count_ex),self.td_right_style),
                       P(pretty(val_expense_sum,separator=","), self.td_right_style),
                       P(str(sum_count_last),self.td_right_style),
                       P(pretty(val_last_t_sum,separator=","), self.td_right_style),
                       P(pretty(val_capital_sum,separator=","), self.td_right_style),
                       ]]
                   grid.extend(t4)
                   grid.pop(0)
                   if len(grid)>0:
                        story.append(Table(grid, style=tstyle, colWidths=col_w))
                elif data['keeper_type'] == 'short_item_dep':
                   val_total_sum=0.00
                   val_income_sum=0.00
                   val_expense_sum=0.00
                   depr_start_sum=0.00
                   val_dpr_mon_sum=0.00
                   val_dpr_ex_sum=0.00
                   val_dpr_last_sum=0.00
                   val_dpr_total_sum=0.00

                   for d in group_datas:
                       asset_ids=[]
                       for h in d: asset_ids.append(h['asset_id'])
                       data_report,total_dict = self.compute_data(cr, uid, asset_ids, data,d, asset_obj,context=context)
                       grid.extend(data_report)
                       grid.pop(0)
                       if len(grid)>0:
                            story.append(Table(grid, style=tstyle2, colWidths=col_w))

                       val_total_sum+=total_dict['val_total_sum']
                       val_income_sum+=total_dict['val_income_sum']
                       val_expense_sum+=total_dict['val_expense_sum']
                       depr_start_sum+=total_dict['depr_start_sum']
                       val_dpr_mon_sum+=total_dict['val_dpr_mon_sum']
                       val_dpr_ex_sum+=total_dict['val_dpr_ex_sum']
                       val_dpr_last_sum+=total_dict['val_dpr_last_sum']
                       val_dpr_total_sum+=total_dict['val_dpr_total_sum']

                   t4=[[
                       nullpara,
                       P(u"Дүн",self.td_center_style),
                       P(pretty(val_total_sum,separator=","), self.td_right_style),
                       P(pretty(val_income_sum,separator=","), self.td_right_style),
                       P(pretty(val_expense_sum,separator=","), self.td_right_style),
                       P(pretty(depr_start_sum,separator=","), self.td_right_style),
                       P(pretty(val_dpr_mon_sum,separator=","), self.td_right_style),
                       P(pretty(val_dpr_ex_sum,separator=","), self.td_right_style),
                       P(pretty(val_dpr_last_sum,separator=","), self.td_right_style),
                       P(pretty(val_dpr_total_sum,separator=","), self.td_right_style),
                       ]]
                   grid.extend(t4)
                   grid.pop(0)
                   if len(grid)>0:
                        story.append(Table(grid, style=tstyle, colWidths=col_w))
                else:
		            for d in group_datas:
		                grid = [[
		                    Paragraph(u"<b>Төрөл : %s </b>" %d[0]['cat_code'],self.td_right_style),
		                    Paragraph(u"<b> - %s</b>" %d[0]['cat_name'],self.td_left_style),
		                ]]
		                width = [30*mm, 170*mm] # 200
		                story.append(Table(grid, colWidths=width))

		                asset_ids=[]
		                for h in d: asset_ids.append(h['asset_id'])
		                grid.extend(self.compute_data(cr, uid, asset_ids, data,d, asset_obj,context=context))

		                grid.pop(0)
		                if len(grid)>0:
		                    story.append(Table(grid, style=tstyle, colWidths=col_w))
        else:
            departments=list(set(departments))
            for department in dep_obj.browse(cr,uid,departments):
                print 'Department: ' + department.name
                grid = [[
                    Paragraph(u"<b>Эд хариуцагч : </b>",self.td_right_style),
                    Paragraph(u"<b>%s</b>" %department.name,self.td_left_style),
                ]]
                width = [70*mm, 130*mm] # 200
                story.append(Table(grid, colWidths=width))
                if data['keeper_type'] == 'owner_ending' or data['keeper_type'] == 'owner_dep'\
                  or data['keeper_type'] == 'short_owner_ending' or data['keeper_type'] == 'short_owner_dep':
                    asset_groups=[]
                    for asset in asset_obj.browse(cr,uid,asset_obj.search(cr,uid,[('state','<>','draft'),('owner_id','=',department.id)])):
                        asset_groups.append({'asset_id':asset.id,
                                             'account_id':asset.account_asset_id.id,
                                             'account_name':asset.account_asset_id.name,
                                             'account_code':asset.account_asset_id.code,
                                             })
                    group_datas = []
                    sorted_datas = sorted(asset_groups, key=itemgetter('account_id'))
                    for key, items in itertools.groupby(sorted_datas, operator.itemgetter('account_id')):
                        group_datas.append(list(items))
                    if data['keeper_type'] == 'short_owner_ending':
                       sum_count_first=0.00
                       val_total_sum=0.00
                       sum_count_income=0.00
                       val_income_sum=0.00
                       sum_count_ex=0.00
                       val_expense_sum=0.00
                       sum_count_last=0.00
                       val_last_t_sum=0.00
                       val_capital_sum=0.00
    
                       for d in group_datas:
                           asset_ids=[]
                           for h in d: asset_ids.append(h['asset_id'])
                           data_report,total_dict = self.compute_data(cr, uid, asset_ids, data,d, asset_obj,context=context)
                           grid.extend(data_report)
                           grid.pop(0)
                           if len(grid)>0:
                                story.append(Table(grid, style=tstyle2, colWidths=col_w))
                           sum_count_first+=total_dict['sum_count_first']
                           val_total_sum+=total_dict['val_total_sum']
                           sum_count_income+=total_dict['sum_count_income']
                           val_income_sum+=total_dict['val_income_sum']
                           sum_count_ex+=total_dict['sum_count_ex']
                           val_expense_sum+=total_dict['val_expense_sum']
                           sum_count_last+=total_dict['sum_count_last']
                           val_last_t_sum+=total_dict['val_last_t_sum']
                           val_capital_sum+=total_dict['val_capital_sum']
    
                       t4=[[
                           nullpara,
                           P(u"Дүн",self.td_center_style),
                           P(str(sum_count_first),self.td_right_style),
                           P(pretty(val_total_sum,separator=","), self.td_right_style),
                           P(str(sum_count_income),self.td_right_style),
                           P(pretty(val_income_sum,separator=","), self.td_right_style),
                           P(str(sum_count_ex),self.td_right_style),
                           P(pretty(val_expense_sum,separator=","), self.td_right_style),
                           P(str(sum_count_last),self.td_right_style),
                           P(pretty(val_last_t_sum,separator=","), self.td_right_style),
                           P(pretty(val_capital_sum,separator=","), self.td_right_style),
                           ]]
                       grid.extend(t4)
                       grid.pop(0)
                       if len(grid)>0:
                            story.append(Table(grid, style=tstyle, colWidths=col_w))
                    elif data['keeper_type'] == 'short_owner_dep':
                       val_total_sum=0.00
                       val_income_sum=0.00
                       val_expense_sum=0.00
                       depr_start_sum=0.00
                       val_dpr_mon_sum=0.00
                       val_dpr_ex_sum=0.00
                       val_dpr_last_sum=0.00
                       val_dpr_total_sum=0.00
    
                       for d in group_datas:
                           asset_ids=[]
                           for h in d: asset_ids.append(h['asset_id'])
                           data_report,total_dict = self.compute_data(cr, uid, asset_ids, data,d, asset_obj,context=context)
                           grid.extend(data_report)
                           grid.pop(0)
                           if len(grid)>0:
                                story.append(Table(grid, style=tstyle2, colWidths=col_w))
    
                           val_total_sum+=total_dict['val_total_sum']
                           val_income_sum+=total_dict['val_income_sum']
                           val_expense_sum+=total_dict['val_expense_sum']
                           depr_start_sum+=total_dict['depr_start_sum']
                           val_dpr_mon_sum+=total_dict['val_dpr_mon_sum']
                           val_dpr_ex_sum+=total_dict['val_dpr_ex_sum']
                           val_dpr_last_sum+=total_dict['val_dpr_last_sum']
                           val_dpr_total_sum+=total_dict['val_dpr_total_sum']
    
                       t4=[[
                           nullpara,
                           P(u"Дүн",self.td_center_style),
                           P(pretty(val_total_sum,separator=","), self.td_right_style),
                           P(pretty(val_income_sum,separator=","), self.td_right_style),
                           P(pretty(val_expense_sum,separator=","), self.td_right_style),
                           P(pretty(depr_start_sum,separator=","), self.td_right_style),
                           P(pretty(val_dpr_mon_sum,separator=","), self.td_right_style),
                           P(pretty(val_dpr_ex_sum,separator=","), self.td_right_style),
                           P(pretty(val_dpr_last_sum,separator=","), self.td_right_style),
                           P(pretty(val_dpr_total_sum,separator=","), self.td_right_style),
                           ]]
                       grid.extend(t4)
                       grid.pop(0)
                       if len(grid)>0:
                            story.append(Table(grid, style=tstyle, colWidths=col_w))
                    else:
                        for d in group_datas:
                            grid = [[
                                Paragraph(u"<b>Хөрөнгийн данс : %s</b>" %d[0]['account_code'],self.td_right_style),
                                Paragraph(u"<b>%s</b>" %d[0]['account_name'],self.td_left_style),
                            ]]
                            width = [50*mm, 150*mm] # 200
                            story.append(Table(grid, colWidths=width))
            
                            asset_ids=[]
                            for h in d: asset_ids.append(h['asset_id'])
                            grid.extend(self.compute_data(cr, uid, asset_ids, data,group_datas, asset_obj,context=context))
                            grid.pop(0)
                            if len(grid)>0:
                                story.append(Table(grid, style=tstyle, colWidths=col_w))
                elif data['keeper_type'] == 'item_ending' or data['keeper_type'] == 'item_dep'\
				 or data['keeper_type'] == 'short_item_ending' or data['keeper_type'] == 'short_item_dep':
                    asset_groups=[]
                    for asset in asset_obj.browse(cr,uid,asset_obj.search(cr,uid,[('state','<>','draft'),('owner_id','=',department.id)])):
                        asset_groups.append({'asset_id':asset.id,
                                             'cat_id':asset.template_id.category_id.id,
                                             'cat_name':asset.template_id.category_id.name,
                                             'cat_code':asset.template_id.category_id.code,
                                             })
                    group_datas = []
                    sorted_datas = sorted(asset_groups, key=itemgetter('cat_id'))
                    for key, items in itertools.groupby(sorted_datas, operator.itemgetter('cat_id')):
                        group_datas.append(list(items))
                    if data['keeper_type'] == 'short_item_ending':
                       sum_count_first=0.00
                       val_total_sum=0.00
                       sum_count_income=0.00
                       val_income_sum=0.00
                       sum_count_ex=0.00
                       val_expense_sum=0.00
                       sum_count_last=0.00
                       val_last_t_sum=0.00
                       val_capital_sum=0.00

                       for d in group_datas:
                           asset_ids=[]
                           for h in d: asset_ids.append(h['asset_id'])
                           data_report,total_dict = self.compute_data(cr, uid, asset_ids, data,d, asset_obj,context=context)
                           grid.extend(data_report)
                           grid.pop(0)
                           if len(grid)>0:
                                story.append(Table(grid, style=tstyle2, colWidths=col_w))

                           sum_count_first+=total_dict['sum_count_first']
                           val_total_sum+=total_dict['val_total_sum']
                           sum_count_income+=total_dict['sum_count_income']
                           val_income_sum+=total_dict['val_income_sum']
                           sum_count_ex+=total_dict['sum_count_ex']
                           val_expense_sum+=total_dict['val_expense_sum']
                           sum_count_last+=total_dict['sum_count_last']
                           val_last_t_sum+=total_dict['val_last_t_sum']
                           val_capital_sum+=total_dict['val_capital_sum']

                       t4=[[
                           nullpara,
                           P(u"Дүн",self.td_center_style),
                           P(str(sum_count_first),self.td_right_style),
                           P(pretty(val_total_sum,separator=","), self.td_right_style),
                           P(str(sum_count_income),self.td_right_style),
                           P(pretty(val_income_sum,separator=","), self.td_right_style),
                           P(str(sum_count_ex),self.td_right_style),
                           P(pretty(val_expense_sum,separator=","), self.td_right_style),
                           P(str(sum_count_last),self.td_right_style),
                           P(pretty(val_last_t_sum,separator=","), self.td_right_style),
                           P(pretty(val_capital_sum,separator=","), self.td_right_style),
                           ]]
                       grid.extend(t4)
                       grid.pop(0)
                       if len(grid)>0:
                            story.append(Table(grid, style=tstyle, colWidths=col_w))
                    elif data['keeper_type'] == 'short_item_dep':
                       val_total_sum=0.00
                       val_income_sum=0.00
                       val_expense_sum=0.00
                       depr_start_sum=0.00
                       val_dpr_mon_sum=0.00
                       val_dpr_ex_sum=0.00
                       val_dpr_last_sum=0.00
                       val_dpr_total_sum=0.00

                       for d in group_datas:
                           asset_ids=[]
                           for h in d: asset_ids.append(h['asset_id'])
                           data_report,total_dict = self.compute_data(cr, uid, asset_ids, data,d, asset_obj,context=context)
                           grid.extend(data_report)
                           grid.pop(0)
                           if len(grid)>0:
                                story.append(Table(grid, style=tstyle2, colWidths=col_w))

                           val_total_sum+=total_dict['val_total_sum']
                           val_income_sum+=total_dict['val_income_sum']
                           val_expense_sum+=total_dict['val_expense_sum']
                           depr_start_sum+=total_dict['depr_start_sum']
                           val_dpr_mon_sum+=total_dict['val_dpr_mon_sum']
                           val_dpr_ex_sum+=total_dict['val_dpr_ex_sum']
                           val_dpr_last_sum+=total_dict['val_dpr_last_sum']
                           val_dpr_total_sum+=total_dict['val_dpr_total_sum']

                       t4=[[
                           nullpara,
                           P(u"Дүн",self.td_center_style),
                           P(pretty(val_total_sum,separator=","), self.td_right_style),
                           P(pretty(val_income_sum,separator=","), self.td_right_style),
                           P(pretty(val_expense_sum,separator=","), self.td_right_style),
                           P(pretty(depr_start_sum,separator=","), self.td_right_style),
                           P(pretty(val_dpr_mon_sum,separator=","), self.td_right_style),
                           P(pretty(val_dpr_ex_sum,separator=","), self.td_right_style),
                           P(pretty(val_dpr_last_sum,separator=","), self.td_right_style),
                           P(pretty(val_dpr_total_sum,separator=","), self.td_right_style),
                           ]]
                       grid.extend(t4)
                       grid.pop(0)
                       if len(grid)>0:
                            story.append(Table(grid, style=tstyle, colWidths=col_w))
                    else:
                        for d in group_datas:
                            grid = [[
                                Paragraph(u"<b>Төрөл : %s </b>" %d[0]['cat_code'],self.td_right_style),
                                Paragraph(u"<b> - %s</b>" %d[0]['cat_name'],self.td_left_style),
                            ]]
                            width = [30*mm, 170*mm] # 200
                            story.append(Table(grid, colWidths=width))
        
                            asset_ids=[]
                            for h in d: asset_ids.append(h['asset_id'])
                            grid.extend(self.compute_data(cr, uid, asset_ids, data,group_datas, asset_obj,context=context))
        
                            grid.pop(0)
                            if len(grid)>0:
                                story.append(Table(grid, style=tstyle, colWidths=col_w))
        t1_style = TableStyle([
                ('ALIGN',(0,0),(-1,-1),'CENTER'),
                ('FONT', (0,0),(-1,-1), 'DejaVu Sans', 7),
        ])
        t3 = [[u'Хөтөлсөн нягтлан бодогч : ....................................'],
              [u'Хянасан ерөнхий нягтлан бодогч : ....................................']]
        story.append(Table(t3, style=t1_style, colWidths=[270*mm]))
        return story
    
asset_detail_register_keeper_owner('report.asset.detail.register.keeper.owner', "Assets detail", 'account.asset.asset', StandardReport.A4_LANDSCAPE)