# -*- encoding: utf-8 -*-
##############################################################################
#
#    Shine-ERP, Enterprise Management Solution    
#
##############################################################################

from c2c_reporting_tools.reports.standard_report import *
from c2c_reporting_tools.flowables.simple_row_table import *
from c2c_reporting_tools.c2c_helper import *
from c2c_reporting_tools.translation import _
from reportlab.platypus import *
from reportlab.lib.pagesizes import letter,A4,inch,cm
from reportlab.lib.colors import red, black, navy, white, green
from reportlab.lib.enums import TA_LEFT, TA_RIGHT, TA_CENTER, TA_JUSTIFY
from reportlab.platypus.flowables import PageBreak

import locale
import time, calendar
from operator import itemgetter
from openerp.osv import fields, osv
from openerp.tools.translate import _
import decimal_precision as dp
import time, netsvc
from lxml import etree
from datetime import datetime, timedelta
from dateutil.relativedelta import relativedelta

class asset_move(StandardReport):

    def get_datas(self, cr, uid, data, context=None):
        res = []
        where = ''
        if data['owner_ids']:
            if len(data['owner_ids']) == 1:
                where += ' AND h.to_owner_id = '+str(tuple(data['owner_ids']))
            else:
                where += ' AND h.to_owner_id in '+str(tuple(data['owner_ids']))
        if data['asset_asset_ids']:
            if len(data['asset_asset_ids']) == 1:
                where += ' AND a.id = '+str(tuple(data['asset_asset_ids']))
            else:
                where += ' AND a.id in '+str(tuple(data['asset_asset_ids']))
        
        cr.execute("select e.login as to_owner, e1.login as from_owner, \
        a.name as asset_name, a.code as asset_code, h.create_date as create_date, \
        h.note as text , h.date as date, a.id as id, a.company_id as company_id \
        from account_asset_history as h \
        left join account_asset_asset as a on (a.id = h.asset_id) \
        left join res_users as e on (e.id = h.user_id) \
        left join res_users as e1 on (e1.id = h.user_id) \
        WHERE h.date >= %s AND \
        h.date <=%s and a.company_id = %s"+where,(data['from_date'], data['to_date'], data['company_id'][0]))
        fetch = cr.dictfetchall()
        for i in fetch:
            
            cr.execute("SELECT SUM(ml.debit - ml.credit) AS amount \
                                FROM account_move_line AS ml \
                                LEFT JOIN account_move AS m ON ml.move_id = m.id \
                                WHERE ml.asset_id = %s  \
                                AND ml.date <= %s AND m.state IN('posted') \
                                AND m.company_id = %s \
                                ",(i['id'], data['from_date'],i['company_id']))
            price = cr.dictfetchone()
            
            res.append({
                        'name':i['asset_name'] or '',
                        'code':i['asset_code'] or '',
                        'owner':i['from_owner'] or '',
                        'in_date':str(i['date']).split(' ')[0] or '',
                        'price_unit':price and price['amount'] or '',
                        'to_date':str(i['create_date']).split(' ')[0] or '',
                        'origin_name':'shalgah' or '',
                        'text':i['text'] or '',
                        })
        return res
    
asset_move('report.asset.move', "Asset Move", 'account.asset.asset', StandardReport.A4_LANDSCAPE)