# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from datetime import datetime
from openerp import netsvc
import xlwt
from xlwt import Workbook, Formula

class account_detail_register_report(osv.osv_memory):
    """
        Дансны дэлгэрэнгүй бүртгэл
    """
    _inherit = "abstract.report.excel"
    _name = "account.detail.register"
    _description = "Account Detail Register"
    _columns = {
                'company_id':fields.many2one('res.company', 'Company',required=True),
                'account_id':fields.many2one('account.account', 'Account',required=True),
                'start_date':fields.date('Start date',required=True),
                'end_date':fields.date('End date',required=True),
                }
    _defaults = {
                 'company_id': lambda obj,cr,uid,c=None:obj.pool.get('res.company')._company_default_get(cr,uid,'account.balance.sheet',context=c),
                'start_date':time.strftime('%Y-%m-01'),
                'end_date':time.strftime('%Y-%m-%d'),
               }
    
    def prepare_data(self, cr, uid, ids, context=None):
        fy_obj = self.pool.get('account.fiscalyear')
        period_obj = self.pool.get('account.period')
        obj = self.browse(cr, uid, ids[0], context=context)
        
        data = {
            'ids': ids,
            'model': 'account.detail.register',
            'form': {
                'company_id': obj.company_id.id,
                'account_id': obj.account_id.id,
                'start_date': obj.start_date,
                'end_date': obj.end_date,
                'save': obj.save
            },
            'report_name': 'account.detail.register'
        }
        return data
    
    def get_export_data(self, cr, uid, ids, context=None):
        ''' Тайлангийн загварыг боловсруулж өгөгдлүүдийг
            тооцоолж байрлуулна.
        '''
        def name_padding(param):
            l = param['level'] - 2
            return ('  ' * l) + param['name']
        
        if context is None:
            context = {}
        
        datas = self.prepare_data(cr, uid, ids, context=context)
        data = datas['form']
        self.context = context
        ctx = self.context.copy()
                    
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        
        self.context = context
        ctx = self.context.copy()
        ctx1 = self.context.copy()
        ctx['date_from'] = data['start_date']
        ctx['date_to'] = data['end_date']
        ctx1['date_from'] = time.strftime("%Y-01-01")
        ctx1['date_to'] = data['start_date']
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Balance')
        header = ezxf('font: bold on; align: wrap off, vert centre, horiz centre;font: height 220')
        header1 = ezxf('font: bold on; align: wrap on, vert centre, horiz left;font: height 200')
        sheet_style = ezxf('font: bold off; align: wrap on, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        
        company = self.pool.get('res.company')
        company_id = company.search(cr, uid, [('id','=',data['company_id'])])
        company_name = company.browse(cr, uid, company_id)[0]
        account_object = self.pool.get('account.account')
        account_id  = account_object.search(cr, uid, [('id','=',data['account_id'])])
        account_data = account_object.browse(cr, uid, account_id, ctx1)[0]
        
        
        sheet.write_merge(0, 0, 0, 2, u'Байгууллагын нэр: %s'%company_name.name, header1)
        sheet.write_merge(2, 2, 4, 5, u'ДАНСНЫ ДЭЛГЭРЭНГҮЙ БҮРТГЭЛ', header)
        sheet.write_merge(4, 4, 0, 2, u'Дансны нэр: %s'%account_data.name, header1)
        sheet.write_merge(5, 5, 0, 1, u'Код: %s'%account_data.code, header1)
        sheet.write_merge(7, 8, 0, 0, u'Д/д', sheet_style)
        sheet.write_merge(7, 7, 1, 2, u'Баримтын', sheet_style)
        sheet.write(8, 1, u'Огноо', sheet_style)
        sheet.write(8, 2, u'Дугаар', sheet_style)
        sheet.write_merge(7, 8, 3, 3, u'Гүйлгээний утга', sheet_style)
        sheet.write_merge(7, 7, 4, 5, u'Гүйлгээний дүн(төгрөгөөр)', sheet_style)
        sheet.write(8, 4, u'Дебет', sheet_style)
        sheet.write(8, 5, u'Кредит', sheet_style)
        sheet.write_merge(7, 8, 6, 6, u'Үлдэгдэл', sheet_style)
        sheet.write(9, 0, u'', sheet_style)
        sheet.write(9, 1, u'', sheet_style)
        sheet.write(9, 2, u'', sheet_style)
        sheet.write(9, 3, u'Эхний үлдэгдэл', sheet_style)
        sheet.write(9, 4, u'', sheet_style)
        sheet.write(9, 5, u'', sheet_style)
        sheet.write(9, 6, u'%s'%account_data.balance, sheet_style)
        
        
        account_move_object  = self.pool.get('account.move.line')
        account_id = account_move_object.search(cr, uid, [('account_id','=',data['account_id'])])
            
        row = 10
        num = 1
        sum_debit = 0
        sum_credit = 0
        sum_subtotal = account_data.balance
        for line in account_move_object.browse(cr, uid, account_id):
            sheet.write(row, 0, u'%d'%num,sheet_style)
            sheet.write(row, 3, u'%s'%line.name,sheet_style)
            sheet.write(row, 4, u'%s'%line.debit,sheet_style)
            sheet.write(row, 5, u'%s'%line.credit,sheet_style)
            sum_debit += line.debit
            sum_credit += line.credit
            if line.debit != 0:
                sum_subtotal += line.debit
                sheet.write(row, 6, u'%s'%sum_subtotal, sheet_style)
            if line.credit != 0:
                sum_subtotal -=line.credit
                sheet.write(row, 6, u'%s'%sum_subtotal, sheet_style)
            account_obj=self.pool.get('account.move')
            account_moveid = account_obj.search(cr, uid, [('ref','=',line.ref)])
            for lin in account_obj.browse(cr, uid, account_moveid):
                sheet.write(row, 2, u'%s'%lin.name, sheet_style)
                sheet.write(row, 1, u'%s'%lin.date, sheet_style)
            row += 1
            num += 1
        
        sheet.write(row, 0, u'', sheet_style)
        sheet.write(row, 1, u'', sheet_style)
        sheet.write(row, 2, u'', sheet_style)
        sheet.write(row, 3, u'Нийт дүн', sheet_style)
        sheet.write(row, 4, u'%s'%sum_debit, sheet_style)
        sheet.write(row, 5, u'%s'%sum_credit, sheet_style)
        sheet.write(row, 6, u'', sheet_style)
        nowdate = time.strftime("%Y %m %d")
        sheet.write_merge(row+1, row+1, 0, 2, u'Хэвлэсэн огноо: %s' %nowdate, ezxf('font:bold off;align:wrap off,vert centre,horiz left;'))
        
        sheet.write_merge(row+2, row+2, 2, 4, u'Боловсруулсан нягтлан бодогч____________________________(______________________________)', header1)
        sheet.write_merge(row+4, row+4, 2, 4, u'Хянасан ерөнхий нягтлан бодогч______________________________(___________________________)', header1)
        sheet.write_merge(row+6, row+6, 2, 4, u'Зөвшөөрсөн_________________________________(_________________________)', header1)
        
        inch = 2000
        sheet.col(0).width = 2 * inch
        sheet.col(1).width = 2 * inch
        sheet.col(2).width = 2 * inch
        sheet.col(3).width = 2 * inch 
        sheet.col(4).width = 3 * inch
        sheet.col(5).width = 3 * inch
        sheet.col(6).width = 3 * inch
        sheet.col(7).width = 2 * inch
        sheet.col(8).width = 2 * inch
        sheet.col(9).width = 2 * inch
        sheet.row(row+2).height = 600
        sheet.row(row+4).height = 600
        sheet.row(row+6).height = 600        
        return {'data':book}

account_detail_register_report()