# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from datetime import datetime
from openerp import netsvc
import xlwt
from xlwt import Workbook, Formula
class account_invoice_sheet_report(osv.osv_memory):
    """
        Нэхэмжлэл
    """
    _inherit = "abstract.report.excel"
    _name = "account.invoice.sheet.report"
    
    
    
    def get_export_data(self, cr, uid, ids, context=None):
        ''' Тайлангийн загварыг боловсруулж өгөгдлүүдийг
            тооцоолж байрлуулна.
        '''
        def name_padding(param):
            l = param['level'] - 2
            return ('  ' * l) + param['name']
        
        if context is None:
            context = {}
        

        self.context = context
        ctx = self.context.copy()
        company = self.pool.get('res.company').browse(cr, uid, context['company_id'])
        inv_obj = self.pool.get('account.invoice')
        invoice_object = self.pool.get('account.invoice.line')
        
        invoice_id = inv_obj.search(cr, uid, [('partner_id','=',context['partner_id']),('date_invoice','>=',context['date'])])
        inv_id = invoice_object.search(cr, uid, [('id','=',context['line_id'])])
        invoiceid = invoice_object.browse(cr, uid, inv_id)[0]
        account = self.pool.get('res.partner')
        invoices = inv_obj.browse(cr, uid, context['id'])
        
        account_partner = account._find_accounting_partner(invoices.partner_id)
        
        partner_bank = self.pool.get('res.partner.bank')
        
        bnk_id = partner_bank.search(cr, uid, [('partner_id','=',invoiceid.partner_id.id)])
        if bnk_id != []:
            partner_bank = partner_bank.browse(cr, uid, bnk_id)[0]
        else:
            raise osv.except_osv(_('Error'),_(u'Харилцагчийн банкны дансыг оруулаагүй байна'))

        
        
        moneyprice = c2c_helper.verbose_numeric(abs(invoices.amount_untaxed))
        
        obj = self.browse(cr, uid, ids[0], context=context)
            
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        
        self.context = context
        ctx = self.context.copy()
    
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Balance')
        header = ezxf('font: bold on; align: wrap off, vert centre, horiz centre;font: height 200')
        header1 = ezxf('font: bold off; align: wrap on, vert centre, horiz left;font: height 200')
        header2 = ezxf('font: bold on; align: wrap off, vert centre, horiz centre;font: height 220')
        boldoff = ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 200')
        boldoff2 = ezxf('font: bold off; align: wrap off, vert centre, horiz centre;font: height 200')
        sheet_style = ezxf('font: bold off; align: wrap on, vert centre, horiz left;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet_styles = ezxf('font: bold on; align: wrap on, vert centre, horiz left;font: height 200;','#,##0.00_);(#,##0.00)')
        
        
        sheet.write_merge(0, 0, 0, 1, u'НХМаягт Т-1', header1)
        sheet.write_merge(0, 0, 2, 4, u'Санхүү, эдийн засгийн сайд, Үндэсний статистикийн газрын даргын 2002 оны тоот тушаалын хавсралт', header1)
        sheet.write_merge(1, 1, 0, 5, u'НЭХЭМЖЛЭХ №', header2)
        sheet.write_merge(3, 3, 0, 1, u'Нэхэмжлэгч:', header)
        sheet.write_merge(3, 3, 2, 5, u'Төлөгч:', header)
        sheet.write_merge(4, 4, 0, 1, u'Байгуулгын нэр: ' + account_partner.name, boldoff)
        sheet.write_merge(4, 4, 2, 5, u'Байгуулгын нэр: ' + company.name, boldoff)
        sheet.write_merge(5, 5, 0, 1, u'Хаяг: %s' %(account_partner.street or ''), boldoff)
        sheet.write_merge(5, 5, 2, 5, u'Хаяг: %s' %(company.street or ''), boldoff)
        sheet.write_merge(6, 6, 0, 1, u'Утас, Факс: %s'%(account_partner.phone or ''), boldoff)
        sheet.write_merge(6, 6, 2, 5, u'Гэрээний №:', boldoff)
        sheet.write_merge(7, 7, 0, 1, u'Э-Шуудан: %s' %(account_partner.website or ''), boldoff)
        sheet.write_merge(8, 8, 0, 1, u'Банкны нэр: %s' %partner_bank.bank_name, boldoff)
        sheet.write_merge(8, 8, 2, 5, u'Нэхэмжилсэн огноо: %s' %invoices.date_invoice, boldoff)
        sheet.write_merge(9, 9, 0, 1, u'Банкны дансны дугаар: %s' %partner_bank.acc_number, boldoff)
        sheet.write_merge(9, 9, 2, 5, u'Төлбөр хийх хугацаа: %s' %invoices.date_due, boldoff)
        sheet.write(11, 0, u'№', sheet_styles)
        sheet.write(11, 1, u'Гүйлгээний утга', sheet_styles)
        sheet.write(11, 2, u'Тоо хэмжээ', sheet_styles)
        sheet.write(11, 3, u'Нэгжийн үнэ', sheet_styles)
        sheet.write(11, 4, u'Нийт үнэ', sheet_styles)
        row = 12
        number = 1
        untaxed = 0
        total = 0
        for invoice in inv_obj.browse(cr, uid, invoice_id):
            for invoiceid in invoice.invoice_line:
                sheet.write(row, 0, u'%d'%number, sheet_style)
                sheet.write(row, 1, invoiceid.name, sheet_style)
                sheet.write(row, 2, invoiceid.quantity, sheet_style)
                sheet.write(row, 3, invoiceid.price_unit, sheet_style)
                sheet.write(row, 4, invoiceid.quantity * invoiceid.price_unit, sheet_style)
                row +=1
                number +=1
                untaxed += invoiceid.price_subtotal
                total += invoiceid.quantity * invoiceid.price_unit
        sheet.write(row, 3, u'Дүн', sheet_styles)
        sheet.write(row+1, 3, u'НӨАТ', sheet_styles)
        sheet.write(row+2, 3, u'Нийт дүн', sheet_styles)
        sheet.write(row, 4, untaxed, sheet_styles)
        sheet.write(row+1, 4, invoice.amount_tax, sheet_styles)
        sheet.write(row+2, 4, total, sheet_styles)
         
        row +=1
        sheet.write_merge(row+4, row+4, 1, 5, u'Мөнгөний дүн: ' + moneyprice, boldoff)
        sheet.write_merge(row+5, row+5, 1, 5, u'(үсгээр)', boldoff)
        sheet.write_merge(row+6, row+6, 1, 5, u'__________________________________________________________________болно.', boldoff)
        sheet.write_merge(row+7, row+7, 1, 1, u'(Тамга)', boldoff)
        sheet.write_merge(row+8, row+8, 1, 4, u'Дарга:___________________________________/                 /', boldoff2)
        sheet.write_merge(row+9, row+9, 1, 4, u'Нягтлан бодогч: _____________________________________/                  /', boldoff2)
        
        
        
        rowx = 7
  
        rowx = 69
        inch = 1000
        sheet.col(0).width = 2*inch
        sheet.col(1).width = 13*inch
        sheet.col(2).width = 3.5*inch
        sheet.col(3).width = 3.5*inch
        sheet.row(0).height = 800
        sheet.row(37).height = 600
        sheet.row(6).height = 200
        
        
        return {'data':book}

account_invoice_sheet_report()
