# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2013 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import timedelta
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from operator import itemgetter
from StringIO import StringIO
import time
import datetime
import xlwt


from openerp import netsvc



class account_prepayment_report(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "account.prepayment.report"
    _description = "Account prepayment"
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'partner_id': fields.many2one('res.partner', 'Partner', required=True),
        'account_id': fields.many2one('account.account', 'Account', required=False),
        'date_start': fields.date("Start Date", required=True),
        'date_stop': fields.date("End Date", required=True),
    }
    
    _defaults = {
        'company_id': lambda obj,cr,uid,c={}:obj.pool.get('res.users').browse(cr,uid,uid,context=c).company_id.id,
        'date_start': lambda *a: time.strftime('%Y-%m-01'),
        'date_stop': lambda *a: time.strftime('%Y-%m-%d'),
    
    }

    # Override
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['model'] = 'sale.order'
        datas['form'] = self.read(cr, uid, ids)[0]
        #=======================================================================
        # report_service = netsvc.LocalService('report.product.detail.register')
        # report_service.cr = cr
        # report_service.uid = uid
        # report_service.datas = datas
        # report_service.context = context
        # report_service.pool = self.pool
        # report_service.lang = context.get('lang', None)
        # 
        #=======================================================================
        data = datas['form']        
        
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Product Detailed Ledger')
        styles = self.get_easyxf_styles()
        sheet.portrait=False
        ezxf = xlwt.easyxf
        sheet_style = ezxf('font: bold off; align: wrap on, vert centre, horiz centre;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        partner_obj = self.pool.get('res.partner')
        partner_data = partner_obj.browse(cr, uid, data['partner_id'][0])
        row = 0
        sum1, sum2, sum3, sum4 = 0, 0, 0, 0
        line_id = []
        line_id2 = []
        account_obj = self.pool.get('account.move.line')
        prepayment_config_line = self.pool.get('account.prepayment.report.configure.line')
        prepayment_config_line2 = self.pool.get('account.prepayment.report.configure.line2')
        if(data['account_id'] != False):
            line_id = prepayment_config_line.search(cr, uid, [('account_move_type','=',data['account_id'][0])])
            line_id2 = prepayment_config_line2.search(cr, uid, [('account_move_type2','=',data['account_id'][0])])
            if(line_id == [] and line_id2 == []):
                raise osv.except_osv(_('Error'),_(u'Мөнгөн урьдчилгааны тохиргоонд энэ данс байхгүй байна.'))
            else:
                account_id = account_obj.search(cr, uid, [('account_id','=',data['account_id'][0]),('partner_id','=',data['partner_id'][0])])
                if account_id == []:
                    raise osv.except_osv(_('Error'),_(u'Тухайн харилцагчийн дансанд ямар нэгэн гүйлгээ алга.'))
                row = 8
                num = 1
                for line in account_obj.browse(cr, uid, account_id):
                    
                    sheet.write(row, 0, u'%d'%num, sheet_style)
                    sheet.write(row, 1, u'%s'%line.name, sheet_style)
                    sheet.write(row, 2, u'%s'%line.debit, sheet_style)
                    sum1 += line.debit
                    if(line.state == 'valid'):
                        sheet.write(row, 3, u'%s'%line.credit, sheet_style)
                        if(line.credit > 0):
                            sheet.write(row, 5, u'%s'%(line.credit - line.debit), sheet_style)
                            sum2 += line.credit
                            sum3 += (line.credit - line.debit)
                        else:
                            sheet.write(row, 5, u'0.00', sheet_style)
                            sheet.write(row, 6, u'%s'%(line.debit - line.credit), sheet_style)
                            sum4 += (line.debit - line.credit)
                    else:
                        sheet.write(row, 3, u'0.00', sheet_style)
                    sheet.write(row, 4, u'%s'%line.debit, sheet_style)
                    sheet.write(row, 7, u'%s'%line.ref, sheet_style)
                    row +=1
                    num +=1
        else:
            row = 8
            num = 1
            account_id = account_obj.search(cr, uid, [('partner_id','=',data['partner_id'][0])])
            for line in account_obj.browse(cr, uid, account_id):
                line_id = prepayment_config_line.search(cr, uid, [('account_move_type','=',line.account_id.id)])
                line_id2 = prepayment_config_line2.search(cr, uid, [('account_move_type2','=',line.account_id.id)])
            for line in prepayment_config_line.browse(cr, uid, line_id):
                account_id = account_obj.search(cr, uid, [('partner_id','=',data['partner_id'][0]),('account_id','=',line.account_move_type.id)])
            if(line_id == [] and line_id2 == []):
                raise osv.except_osv(_('Error'),_(u'Мөнгөн урьдчилгааны тохиргоонд тухайн харилцагчийн данс байхгүй байна.'))
            else:
                for line in account_obj.browse(cr, uid, account_id):
                    sheet.write(row, 0, u'%d'%num, sheet_style)
                    sheet.write(row, 1, u'%s'%line.name, sheet_style)
                    sheet.write(row, 2, u'%s'%line.debit, sheet_style)
                    sum1 += line.debit
                    if(line.state == 'valid'):
                        sheet.write(row, 3, u'%s'%line.credit, sheet_style)
                        if(line.credit > 0):
                            sheet.write(row, 5, u'%s'%(line.credit - line.debit), sheet_style)
                            sum2 += line.credit
                            sum3 += (line.credit - line.debit)
                        else:
                            sheet.write(row, 5, u'0.00', sheet_style)
                            sheet.write(row, 6, u'%s'%(line.debit - line.credit), sheet_style)
                            sum4 += (line.debit - line.credit)
                    else:
                        sheet.write(row, 3, u'0.00', sheet_style)
                    sheet.write(row, 4, u'%s'%line.debit, sheet_style)
                    sheet.write(row, 7, u'%s'%line.ref, sheet_style)
                    row +=1
                    num +=1
                    
            
        sheet.write_merge(0, 0, 0, 1, u'НХМаягт TМ-2', ezxf('font: bold off;align:wrap on,vert bottom,horiz left;font: height 200'))
        sheet.write_merge(0, 0, 4, 7, u'Санхүү эдийн засгийн сайд, Үндэсний статистикийн газрын даргын 2002 оны 6 сарын 18-ны 171/111 тоот тушаалын хавсралт', ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(1, 1, 2, 6, u'Мөнгөн урьдчилгааны тайлан', ezxf('font: bold on;align:wrap on,vert centre,horiz centre;font: height 220;'))
        
        sheet.write_merge(2, 2, 0, 3, u'Байгуулгын нэр: %s'%data['company_id'][1], ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write(2, 4, u'%s оны'%time.strftime("%Y"), ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write(2, 5, u'%s сарын'%time.strftime("%m"), ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write(2, 6, u'%s өдөр'%time.strftime("%d"), ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(3, 3, 0, 1, u'Урьдчилгаа авагч: %s'%data['partner_id'][1], ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(3, 3, 2, 4, u'Овог нэр: %s'%data['partner_id'][1], ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(4, 4, 2, 4, u'Албан тушаал: %s'%partner_data.function, ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
                        
        sheet.write_merge(6, 7, 0, 0, u'Д/д', sheet_style)
        sheet.write_merge(6, 7, 1, 1, u'Урьдчилгааны зориулалт', sheet_style)
        sheet.write_merge(6, 7, 2, 2, u'Олгосон урьдчилгаа', sheet_style)
        sheet.write_merge(6, 7, 3, 3, u'Гүйцэтгэл', sheet_style)
        sheet.write_merge(6, 6, 4, 6, u'Хянасан', sheet_style)
        sheet.write(7, 4, u'Дүн', sheet_style)
        sheet.write(7, 5, u'Илүү', sheet_style)
        sheet.write(7, 6, u'Дутуу', sheet_style)
        sheet.write_merge(6, 7, 7, 7, u'Хавсаргасан баримтын №', sheet_style)
        sheet.write(row, 0, u'', sheet_style)
        sheet.write(row, 1, u'Нийт', sheet_style)
        sheet.write(row, 2, u'%s'%sum1, sheet_style)
        sheet.write(row, 3, u'%s'%sum2, sheet_style)
        sheet.write(row, 4, u'%s'%sum1, sheet_style)
        sheet.write(row, 5, u'%s'%sum3, sheet_style)
        sheet.write(row, 6, u'%s'%sum4, sheet_style)
        sheet.write(row, 7, u'', sheet_style)
        sheet.write_merge(row + 2, row + 2, 1, 4, u'Тайлан гаргасан:________________________(____________________________)', ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(row + 3, row + 3, 1, 3, u'Үлдэгдэл буюу илүү  зарцуулсан дүнгийн талаар гаргасан шийдвэр:', ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(row + 4, row + 4, 1, 4, u'________________________________________________________________________', ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(row + 5, row + 5, 1, 4, u'________________________________________________________________________', ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        
        sheet.write(row + 6, 1, u'тэмдэг', ezxf('font: bold off;align:wrap on,vert centre,horiz centre;font: height 200'))
        sheet.write_merge(row + 7, row + 7, 2, 5, u'Дарга__________________________________________(_________________________)', ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(row + 8, row + 8, 2, 5, u'Нягтлан бодогч___________________________________(___________________________)', ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        sheet.write_merge(row + 9, row + 9, 4, 6, u'_______________.оны_______________сарын_______________өдөр.', ezxf('font: bold off;align:wrap on,vert centre,horiz left;font: height 200'))
        
        inch = 2000
        
        sheet.col(0).width = 1 * inch
        sheet.col(1).width = 3 * inch
        sheet.col(2).width = 3 * inch
        sheet.col(3).width = 3 * inch
        sheet.col(4).width = 3 * inch
        sheet.col(5).width = 3 * inch
        sheet.col(6).width = 3 * inch
        sheet.col(7).width = 2 * inch
        sheet.col(8).width = 2 * inch
        sheet.col(9).width = 2 * inch
        
        row_inch = 200
        sheet.row(0).height = 4 * row_inch
        sheet.row(1).height = 2 * 200
        sheet.row(10).height = 2 * row_inch
        sheet.row(11).height = 2 * 250
        sheet.row(12).height = 2 * row_inch
        sheet.row(13).height = 2 * row_inch
        sheet.row(15).height = 2 * row_inch
        sheet.row(16).height = 2 * row_inch
        
        
        return {'data':book,}

account_prepayment_report()