# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
from datetime import datetime
from openerp import netsvc
import xlwt
from xlwt import Workbook, Formula

class currency_balance_report(osv.osv_memory):
    """
        Дансны дэлгэрэнгүй бүртгэл
    """
    _inherit = "abstract.report.excel"
    _name = "currency.balance.report"
    
    _columns = {
                'company_id':fields.many2one('res.company', 'Company',required=True),
                'start_date':fields.date('Start date',required=True),
                'end_date':fields.date('End date',required=True),
                }
    _defaults = {
                 'company_id': lambda obj,cr,uid,c=None:obj.pool.get('res.company')._company_default_get(cr,uid,'account.balance.sheet',context=c),
                'start_date':time.strftime('%Y-%m-01'),
                'end_date':time.strftime('%Y-%m-%d'),
               }
    
    
    def get_export_data(self, cr, uid, ids, context=None):
        ''' Тайлангийн загварыг боловсруулж өгөгдлүүдийг
            тооцоолж байрлуулна.
        '''
        def name_padding(param):
            l = param['level'] - 2
            return ('  ' * l) + param['name']
        
        if context is None:
            context = {}
        data = self.browse(cr, uid, ids)[0]
        self.context = context
        ctx = self.context.copy()
        ctx1 = self.context.copy()
        ctx['date_from'] = data.start_date
        ctx['date_to'] = data.end_date
        ctx1['date_from'] = time.strftime("%Y-01-01")        
        ctx1['date_to'] = data.start_date
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        
        
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Balance')
        header = ezxf('font: bold on; align: wrap off, vert centre, horiz centre;font: height 220')
        header1 = ezxf('font: bold on; align: wrap off, vert centre, horiz left;font: height 220')
        header2 = ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 200')
        boldoff = ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 220')
        boldoff2 = ezxf('font: bold off; align: wrap off, vert centre, horiz left;font: height 220')
        sheet_style = ezxf('font: bold on; align: wrap on, vert centre, horiz left;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        sheet_styles = ezxf('font: bold off; align: wrap on, vert centre, horiz left;font: height 200;borders: left thin, right thin, top thin, bottom thin;','#,##0.00_);(#,##0.00)')
        
        
        sheet.write(0, 0, u'Байгууллагын нэр: %s'%data.company_id.name, header1)
        sheet.write(0, 8, u'Маягт БГ', header1)
        sheet.write(2, 3, u'Гүйлгээ баланс', header1)
        sheet.write(3, 0, u'Дугаар:', header2) 
        sheet.write(4, 6, u'Тайлант хугацаа: %s - %s'%(data.start_date,data.end_date), header2)
        sheet.write_merge(5, 6, 0, 0,  u'Дансны зориулалт', sheet_style)
        sheet.write_merge(5, 6, 1, 1, u'Дансны дугаар', sheet_style)
        sheet.write_merge(5, 6, 2, 2, u'Валютын төрөл', sheet_style)
        sheet.write_merge(5, 5, 3, 4, u'Эхний үлдэгдэл', sheet_style)
        sheet.write(6, 3, u'Дебит', sheet_style)
        sheet.write(6, 4, u'Кредит', sheet_style)
        sheet.write_merge(5, 5, 5, 6, u'Гүйлгээ', sheet_style)
        sheet.write(6, 5, u'Дебит', sheet_style)
        sheet.write(6, 6, u'Кредит', sheet_style)
        sheet.write_merge(5, 5, 7, 8, u'Эцсийн үлдэгдэл', sheet_style)
        sheet.write(6, 7, u'Дебит', sheet_style)
        sheet.write(6, 8, u'Кредит',sheet_style)   
        row = 7
        total1 = 0
        total1_1 = 0
        total1_2 = 0
        total1_3 = 0
        total1_4 = 0 
        total1_5 = 0
        total2 = 0
        total2_1 = 0
        total2_2 = 0
        total2_3 = 0
        total2_4 = 0
        total2_5 = 0
        total3_1 = 0
        total3_2 = 0
        total3_3 = 0
        total3_4 = 0
        total3_5 = 0
        total4 = 0
        total4_1 = 0
        total4_2 = 0
        total4_3 = 0
        total4_4 = 0
        total4_5 = 0
        total5 = 0
        total6 = 0
        total7 = 0
        total8 = 0
        total9 = 0
        total10 = 0
        account_obj = self.pool.get('account.account')
        line = account_obj.search(cr, uid, [('company_id','=',data.company_id.id),('type','=','view'),('parent_id','=',False)])
        total3 = 0
        for one in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',line[0])]),ctx):
            print 'oneeeeee', one.name, one.code
            for two in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',one.id)]),ctx):
                print 'twooooo', two.name, two.code
                for three in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',two.id)]),ctx):
                    print '3333333333', three.code,three.name
                    four_s_debit = 0
                    four_s_credit = 0
                    for fours in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',three.id)]),ctx1):
                       #print 'zzzzzzzzzzzzzzz',fours.id,fours.code,fours.name, fours.debit, fours.credit
                       d1=0
                       d2=0
                       #if fours.type != 'view':
                       four_s_debit = fours.debit
                       four_s_credit = fours.credit
                    f_cr_de = 0
                    f_cr = 0.0
                    f_de = 0.0
                    #niit niilbervvdiig tootsooloh 'four' huwisagch
                    for four in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',three.id)]),ctx):
                         print 'foureeeeeeeeee', four.name, four.code
                         eh_v_de4 = 0.0
                         eh_v_cr4 = 0.0
                         eh_v_de4_1 = 0.0
                         eh_v_cr4_1 = 0.0
                         eh_v_total4 = 0.0
                         diff4_de = 0.0
                         diff4_cr = 0.0
                         for four_2 in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',four.id)]),ctx):
                             #ilvv shatlaltai dansnii ehnii vldegdliin niilberiig endees awna
                             for four_3 in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',four_2.id)]),ctx):
                                 if four_3.type == 'view':
                                     for four_4 in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',four_3.id)]),ctx):
                                         move_obj = self.pool.get('account.move.line')
                                         for eh_v_104 in move_obj.browse(cr, uid, move_obj.search(cr, uid, [('account_id','=',four_4.id),('date','<',data.start_date)])):
                                             eh_v_de4 = eh_v_de4 + eh_v_104.debit
                                             eh_v_cr4 = eh_v_cr4 + eh_v_104.credit
                                 else:
                                     move_obj = self.pool.get('account.move.line')
                                     for eh_v_104 in move_obj.browse(cr, uid, move_obj.search(cr, uid, [('account_id','=',four_3.id),('date','<',data.start_date)])):
                                             eh_v_de4 = eh_v_de4 + eh_v_104.debit
                                             eh_v_cr4 = eh_v_cr4 + eh_v_104.credit
                             #dutuu shatlaltai dansnii ehnii vldegdliin niilberiig endees awna
                             if four_2.type == 'view':
                                 for four_4_1 in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',four_2.id)]),ctx):
                                     move_obj = self.pool.get('account.move.line')
                                     for eh_v_104_1 in move_obj.browse(cr, uid, move_obj.search(cr, uid, [('account_id','=',four_4_1.id),('date','<',data.start_date)])):
                                         eh_v_de4_1 = eh_v_de4_1 + eh_v_104_1.debit
                                         eh_v_cr4_1 = eh_v_cr4_1 + eh_v_104_1.credit
                             else:
                                 for eh_v_104_1 in move_obj.browse(cr, uid, move_obj.search(cr, uid, [('account_id','=',four_2.id),('date','<',data.start_date)])):
                                         eh_v_de4_1 = eh_v_de4_1 + eh_v_104_1.debit
                                         eh_v_cr4_1 = eh_v_cr4_1 + eh_v_104_1.credit
                         #diff4 = eh_v_de4 - eh_v_cr4
                         
                         #ilvv shatlaltai bol niilber
                         if four.type != 'view' or len(four.code) == 2:
                             sheet.write(row, 0, four.name, sheet_style)
                             sheet.write(row, 1, four.code, sheet_style)
                             sheet.write(row, 2, four.currency_id.name, sheet_style)                                  
                             sheet.write(row, 5, four.debit, sheet_style)
                             sheet.write(row, 6, four.credit, sheet_style)
                             #f_cr = eh_v_de4+four.debit
                             #f_de = eh_v_cr4+four.credit
                             if three.user_type.report_type == 'asset':
                                 print '22222222222', three.user_type.report_type
                                 diff4_de = eh_v_de4 - eh_v_cr4
                                 diff4_cr = 0.0
                                 f_de = eh_v_de4+four.debit-four.credit
                                 f_cr = 0.0
                                 #sheet.write(row, 3, diff4, sheet_style)
                                 #sheet.write(row, 4, 0.0, sheet_style)
                             elif three.user_type.report_type == 'liability':
                                 print '33333333333333', three.user_type.report_type
                                 diff4_de = 0.0
                                 diff4_cr = eh_v_cr4 - eh_v_de4
                                 f_de = 0.0
                                 f_cr = eh_v_cr4+four.credit-four.debit
                                 #sheet.write(row, 3, 0.0, sheet_style)
                                 #sheet.write(row, 4, diff4, sheet_style)  
                             else:
                                 diff4_de = eh_v_de4
                                 diff4_cr = eh_v_cr4
                                 f_de = eh_v_de4+four.debit
                                 f_cr = eh_v_cr4+four.credit
                                 #sheet.write(row, 3, eh_v_de4, sheet_style)
                                 #sheet.write(row, 4, eh_v_cr4, sheet_style)  
                             sheet.write(row, 3, diff4_de, sheet_style)
                             sheet.write(row, 4, diff4_cr, sheet_style)   
                             sheet.write(row, 7, f_de, sheet_style)
                             sheet.write(row, 8, f_cr, sheet_style)
                             row +=1
                         #dutuu shatlaltai bol niilber
                         else:
                             print 'jjjjjjjjjjjjjjjjjjj', diff4_de,diff4_cr,f_de,f_cr
                             diff4_de = eh_v_de4_1
                             diff4_cr = eh_v_cr4_1
                             f_de = eh_v_de4_1+four_2.debit
                             f_cr = eh_v_cr4_1+four_2.credit
                         total1 += diff4_de
                         total1_1 += diff4_cr       #total1, total1_1 niilber ololt bolson
                         total1_2 += four.debit
                         total1_3 += four.credit
                         total1_4 += f_de
                         total1_5 += f_cr
                         print 'niiiiiiiiiiiiiiiiiiiilber', f_de, f_cr
                         five_s_debit = 0
                         five_s_credit = 0 
                         for fives in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',four.id)]),ctx1):
                            if fives.type != 'view':
                                five_s_debit = fives.debit
                                five_s_credit = fives.credit
                         fe_cr_de = 0
                         fe_cr = 0.0
                         fe_de = 0.0
                         for five in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',four.id)]),ctx):
                             eh_v_de5 = 0.0
                             eh_v_cr5 = 0.0
                             eh_v_total5 = 0.0
                             diff5 = 0.0
                             if five.type == 'view':
                                 for five_2 in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',five.id)]),ctx):
                                     move_obj = self.pool.get('account.move.line')
                                     for eh_v_105 in move_obj.browse(cr, uid, move_obj.search(cr, uid, [('account_id','=',five_2.id),('date','<',data.start_date)])):
                                        eh_v_de5 = eh_v_de5 + eh_v_105.debit
                                        eh_v_cr5 = eh_v_cr5 + eh_v_105.credit
                             else:
                                 for eh_v_105 in move_obj.browse(cr, uid, move_obj.search(cr, uid, [('account_id','=',five.id),('date','<',data.start_date)])):
                                        eh_v_de5 = eh_v_de5 + eh_v_105.debit
                                        eh_v_cr5 = eh_v_cr5 + eh_v_105.credit
                             diff5 = eh_v_de5 - eh_v_cr5
                             
                             if five.type != 'view' or len(five.code) == 2:
                                 sheet.write(row, 0, five.name, sheet_styles)
                                 sheet.write(row, 1, five.code, sheet_styles)
                                 sheet.write(row, 2, five.currency_id.name, sheet_styles)
                                 #------------------------------ if diff5 > 0.0:
                                     #- sheet.write(row, 3, diff5, sheet_styles)
                                     #--- sheet.write(row, 4, 0.0, sheet_styles)
                                 #---------------------------------------- else:
                                     #--- sheet.write(row, 3, 0.0, sheet_styles)
                                     # sheet.write(row, 4, -(diff5), sheet_styles)
                                 #sheet.write(row, 3, eh_v_de5, sheet_styles)
                                 #sheet.write(row, 4, eh_v_cr5, sheet_styles)
                                 sheet.write(row, 5, five.debit, sheet_styles)
                                 sheet.write(row, 6, five.credit, sheet_styles)
                                 fe_cr_de = five_s_debit+five.debit-five_s_credit-five.credit
                                 if three.user_type.report_type == 'asset':
                                     print 'baaaaaaaaaaaaa5', three.user_type.report_type
                                     fe_de = eh_v_de5+five.debit-five.credit
                                     fe_cr = 0.0
                                     sheet.write(row, 3, diff5, sheet_styles)
                                     sheet.write(row, 4, 0.0, sheet_styles)
                                 elif three.user_type.report_type == 'liability':
                                     print 'beeeeeeeeeeeee5', three.user_type.report_type
                                     fe_de = 0.0
                                     fe_cr = eh_v_cr5+five.credit-five.debit
                                     sheet.write(row, 3, 0.0, sheet_styles)
                                     sheet.write(row, 4, -diff5, sheet_styles)
                                 else:
                                     fe_de = eh_v_de5+five.debit
                                     fe_cr = eh_v_cr5+five.credit
                                     sheet.write(row, 3, eh_v_de5, sheet_styles)
                                     sheet.write(row, 4, eh_v_cr5, sheet_styles)
                                     
                                 sheet.write(row, 7, fe_de, sheet_styles)
                                 sheet.write(row, 8, fe_cr, sheet_styles)
                                 
                                 
                                 #==============================================
                                 # if fe_cr_de > 0.0:
                                 #     fe_cr = fe_cr_de
                                 #     sheet.write(row, 7, fe_cr, sheet_styles)
                                 #     sheet.write(row, 8, 0.0, sheet_styles)
                                 # else:
                                 #     fe_de = -(fe_cr_de)
                                 #     sheet.write(row, 7, 0.0, sheet_styles)
                                 #     sheet.write(row, 8, fe_de, sheet_styles)
                                 #==============================================
                                 row +=1
                             total2 += five_s_debit
                             total2_1 += five_s_credit
                             total2_2 += five.debit
                             total2_3 += five.credit
                             total2_4 += fe_cr
                             total2_5 += fe_de
                             
                             
                             six_s_debit = 0
                             six_s_credit = 0
                             for sixs in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',five.id)]),ctx1):
                                 if sixs.type != 'view':
                                     six_s_debit = sixs.debit
                                     six_s_credit = sixs.credit
                             s_cr_de = 0.0
                             s_cr = 0.0
                             s_de = 0.0

                             for six in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',five.id)]),ctx):
                                 eh_v_de6 = 0.0
                                 eh_v_cr6 = 0.0
                                 eh_v_total6 = 0.0
                                 diff6 = 0.0
                                 move_obj = self.pool.get('account.move.line')
                                 if six.type == 'view':
                                     for six_2 in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',six.id)]),ctx):
                                         for eh_v_106 in move_obj.browse(cr, uid, move_obj.search(cr, uid, [('account_id','=',six_2.id),('date','<',data.start_date)])):
                                             eh_v_de6 = eh_v_de6 + eh_v_106.debit
                                             eh_v_cr6 = eh_v_cr6 + eh_v_106.credit
                                 else:
                                     for eh_v_106 in move_obj.browse(cr, uid, move_obj.search(cr, uid, [('account_id','=',six.id),('date','<',data.start_date)])):
                                             eh_v_de6 = eh_v_de6 + eh_v_106.debit
                                             eh_v_cr6 = eh_v_cr6 + eh_v_106.credit
                                 diff6 = eh_v_de6 - eh_v_cr6
                                 if six.type != 'view' or len(six.code) == 2:
                                     #-------------------------- if diff6 > 0.0:
                                         # sheet.write(row, 3, diff6, sheet_styles)
                                         # sheet.write(row, 4, 0.0, sheet_styles)
                                     #------------------------------------ else:
                                         # sheet.write(row, 3, 0.0, sheet_styles)
                                         # sheet.write(row, 4, -(diff6), sheet_styles)
                                     sheet.write(row, 0, six.name, sheet_styles)
                                     sheet.write(row, 1, six.code, sheet_styles)
                                     sheet.write(row, 2, six.currency_id.name, sheet_styles)                                                                         
                                     #sheet.write(row, 3, eh_v_de6, sheet_styles)
                                     #sheet.write(row, 4, eh_v_cr6, sheet_styles)
                                     sheet.write(row, 5, six.debit, sheet_styles)
                                     sheet.write(row, 6, six.credit, sheet_styles)
                                     if three.user_type.report_type == 'asset':
                                         print 'baaaaaaaaaaaaa6', three.user_type.report_type
                                         s_de = eh_v_de6+six.debit-six.credit
                                         s_cr = 0.0                                                                         
                                         sheet.write(row, 3, diff6, sheet_styles)
                                         sheet.write(row, 4, 0.0, sheet_styles)
                                     elif three.user_type.report_type == 'liability':
                                         print 'beeeeeeeeeeeee6', three.user_type.report_type
                                         s_de = 0.0
                                         s_cr = eh_v_cr6+six.credit-six.debit                                                                         
                                         sheet.write(row, 3, 0.0, sheet_styles)
                                         sheet.write(row, 4, -diff6, sheet_styles)
                                     else:
                                         s_de = eh_v_de6+six.debit
                                         s_cr = eh_v_cr6+six.credit                                                                         
                                         sheet.write(row, 3, eh_v_de6, sheet_styles)
                                         sheet.write(row, 4, eh_v_cr6, sheet_styles)
                                         
                                     sheet.write(row, 7, s_de, sheet_styles)
                                     sheet.write(row, 8, s_cr, sheet_styles)
                                     
                                     s_cr_de = six_s_debit+six.debit-six.credit-six_s_credit
                                     #==========================================
                                     # if s_cr_de > 0.0:
                                     #     s_cr = s_cr_de                                                                                          
                                     #     sheet.write(row, 7, s_cr, sheet_styles)
                                     #     sheet.write(row, 8, 0.0, sheet_styles)
                                     # else:
                                     #     s_de = -(s_cr_de)
                                     #     sheet.write(row, 7, 0.0, sheet_styles)
                                     #     sheet.write(row, 8, s_de, sheet_styles)
                                     #==========================================
                                     row +=1
                                 total3 += six_s_debit
                                 total3_1 += six_s_credit
                                 total3_2 += six.debit
                                 total3_3 += six.credit
                                 total3_4 += s_cr
                                 total3_5 += s_de
                                 seven_s_debit = 0
                                 seven_s_credit = 0
                                 #move_obj = self.pool.get('account.move.line')
                                 for sevens in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',six.id)]),ctx1):
                                     if sevens:
                                         seven_s_debit = sevens.debit
                                         seven_s_credit = sevens.credit
                                 se_cr_de = 0.0
                                 se_cr = 0.0 
                                 se_de = 0.0
                                 for seven in account_obj.browse(cr, uid, account_obj.search(cr, uid, [('parent_id','=',six.id)]),ctx):
                                     #if seven.type != 'view':
                                     eh_v_de7 = 0.0
                                     eh_v_cr7 = 0.0
                                     eh_v_total_de7 = 0.0
                                     eh_v_total_cr7 = 0.0
                                     diff7 = 0.0
                                     move_obj = self.pool.get('account.move.line')
                                     for eh_v_107 in move_obj.browse(cr, uid, move_obj.search(cr, uid, [('account_id','=',seven.id),('date','<',data.start_date)])):
                                         eh_v_de7 = eh_v_de7 + eh_v_107.debit
                                         eh_v_cr7 = eh_v_cr7 + eh_v_107.credit
                                         eh_v_total_de7 = eh_v_total_de7 + eh_v_107.debit
                                         eh_v_total_cr7 = eh_v_total_cr7 + eh_v_107.credit
                                         
                                     #d1 += eh_v_107.debit
                                     #d2 += eh_v_107.credit
                                     
                                     
                                     diff7 = eh_v_de7 - eh_v_cr7
                                     # print '1dansnii niit gvilgeenii niilber', diff7, d1, d2
                                     #-------------------------- if diff7 > 0.0:
                                         # sheet.write(row, 3, diff7, sheet_styles)
                                         # sheet.write(row, 4, 0.0, sheet_styles)
                                     #------------------------------------ else:
                                         # sheet.write(row, 3, 0.0, sheet_styles)
                                         # sheet.write(row, 4, -(diff7), sheet_styles)
                                     
                                     sheet.write(row, 0, seven.name, sheet_styles)   
                                     sheet.write(row, 1, seven.code, sheet_styles)
                                     sheet.write(row, 2, seven.currency_id.name, sheet_styles)
                                     #sheet.write(row, 3, eh_v_de7, sheet_styles)
                                     #sheet.write(row, 4, eh_v_cr7, sheet_styles)                                        
                                     sheet.write(row, 5, seven.debit, sheet_styles)
                                     sheet.write(row, 6, seven.credit, sheet_styles)
                                     se_cr_de = seven_s_debit+seven.debit-seven_s_credit-seven.credit
                                     if three.user_type.report_type == 'asset':
                                         print 'baaaaaaaaaaaaa7', three.user_type.report_type
                                         se_de = eh_v_de7+seven.debit-seven.credit
                                         se_cr = 0.0
                                         sheet.write(row, 3, diff7, sheet_styles)
                                         sheet.write(row, 4, 0.0, sheet_styles)
                                     elif three.user_type.report_type == 'liability':
                                         print 'beeeeeeeeeeeee7', three.user_type.report_type
                                         se_de = 0.0
                                         se_cr = eh_v_cr7+seven.credit-seven.debit
                                         sheet.write(row, 3, 0.0, sheet_styles)
                                         sheet.write(row, 4, -diff7, sheet_styles)
                                     else:
                                         se_de = eh_v_de7+seven.debit
                                         se_cr = eh_v_cr7+seven.credit
                                         sheet.write(row, 3, eh_v_de7, sheet_styles)
                                         sheet.write(row, 4, eh_v_cr7, sheet_styles)    
                                         
                                     sheet.write(row, 7, se_de, sheet_styles)
                                     sheet.write(row, 8, se_cr, sheet_styles)
                                         
                                         
                                     #==========================================
                                     # if se_cr_de > 0.0:
                                     #     se_cr = se_cr_de
                                     #     sheet.write(row, 7, se_cr, sheet_styles)
                                     #     sheet.write(row, 8, 0.0, sheet_styles)
                                     # else:
                                     #     se_de = -(se_cr_de)
                                     #     sheet.write(row, 7, 0.0, sheet_styles)
                                     #     sheet.write(row, 8, se_de, sheet_styles)
                                     #==========================================
                                     row +=1
                                     total4 += seven_s_debit
                                     total4_1 += seven_s_credit
                                     total4_2 += seven.debit
                                     total4_3 += seven.credit
                                     total4_4 += se_cr
                                     total4_5 += se_de
        total5 = total1 
        total6 = total1_1 
        total7 = total1_2
        total8 = total1_3
        total9 = total1_4
        total10 = total1_5          
        sheet.write_merge(row, row, 0, 2, u'Нийт:', sheet_styles)   
        sheet.write(row, 3, total5, sheet_styles)
        sheet.write(row, 4, total6, sheet_styles)                                        
        sheet.write(row, 5, total7, sheet_styles)
        sheet.write(row, 6, total8, sheet_styles)
        sheet.write(row, 7, total9, sheet_styles)
        sheet.write(row, 8, total10, sheet_styles)
             
            
        sheet.write_merge(row+8, row+8, 1, 6, u'Дарга:____________________________________/......................./', boldoff2)
        sheet.write_merge(row+9, row+9, 1, 6, u'Нягтлан бодогч: __________________________________/...................../', boldoff2)
        
        inch = 1000
        sheet.col(0).width = 15*inch
        sheet.col(1).width = 3*inch
        sheet.col(2).width = 3*inch
        sheet.col(3).width = 4*inch
        sheet.col(4).width = 4*inch
        sheet.col(5).width = 4*inch
        sheet.col(6).width = 4*inch
        sheet.col(7).width = 4*inch
        sheet.col(8).width = 4*inch
        sheet.row(5).height = 300
        sheet.row(6).height = 300
        
        return {'data':book}

currency_balance_report()