# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from openerp.osv import osv,fields
import time
from openerp.tools.translate import _

class res_currency(osv.osv):
    _inherit = 'res.currency'

    def _get_current_rate(self, cr, uid, ids, raise_on_no_rate=True, context=None):
        if context is None:
            context = {}
        res = {}

        date = context.get('date') or time.strftime('%Y-%m-%d')
        for id in ids:
            cr.execute('SELECT rate FROM res_currency_rate '
                       'WHERE currency_id = %s '
                         'AND name <= %s '
                       'ORDER BY name desc LIMIT 1',
                       (id, date))
            if cr.rowcount:
                res[id] = cr.fetchone()[0]
            elif not raise_on_no_rate:
                res[id] = 0
            else:
                currency = self.browse(cr, uid, id, context=context)
                raise osv.except_osv(_('Error!'),_("No currency rate associated for currency '%s' for the given period" % (currency.name)))
        return res

    
    def _get_conversion_rate(self, cr, uid, from_currency, to_currency, context=None):
        if context is None:
            context = {}
        ctx = context.copy()
        ctx.update({'currency_rate_type_id': ctx.get('currency_rate_type_from')})
        from_currency = self.browse(cr, uid, from_currency.id, context=ctx)

        ctx.update({'currency_rate_type_id': ctx.get('currency_rate_type_to')})
        to_currency = self.browse(cr, uid, to_currency.id, context=ctx)

        if from_currency.rate == 0 or to_currency.rate == 0:
            date = context.get('date', time.strftime('%Y-%m-%d'))
            if from_currency.rate == 0:
                currency_symbol = from_currency.symbol
            else:
                currency_symbol = to_currency.symbol
            raise osv.except_osv(_('Error'), _('No rate found \n' \
                    'for the currency: %s \n' \
                    'at the date: %s') % (currency_symbol, date))
            
            
            print "llllllllllllllllllll",from_currency.rate,to_currency.rate
        return from_currency.rate/to_currency.rate
    
res_currency()


class old_float(fields.float):
    
    def digits_change(self, cr):
        from openerp.tools import float_round, float_repr
        import __builtin__
        
        if self.digits_compute:
            self.digits = self.digits_compute(cr)
        if self.digits:
            precision, scale = self.digits
            self._symbol_set = ('%s', lambda x: __builtin__.float(x or 0.0))

class res_currency_rate(osv.osv):
    _inherit = 'res.currency.rate'
    
    def name_get(self, cr, uid, ids, context={}):
        if not len(ids):
            return []
        res = []
        for r in self.browse(cr, uid, ids, context=context) :
            res.append( (r.id, u'%s (%s)' % (r.name, r.alter_rate)) )
        return res
    
    def _alter_rate_inv(self, cursor, user, ids, name, arg, context=None):
        ''' Тухайн валютын хамгийн сүүлчийн байдлаарх ханшны мэдээллийг
            хүнд ойлгомжтой хэлбэрт хөрвүүлэн харуулна.
        '''
        res = {}
        for r in self.browse(cursor, user, ids, context=context):
            rate = 0
            if r.rate:
                rate = r.rate
            res[r.id] = rate
        return res

    def _alter_rate_inv_write(self, cursor, user, id, name, value, arg, context=None):
        return self.write(cursor, user, id, {'rate': (value) or 0.0}, context=context)
    
    _columns = {
        #'alter_rate': fields.float('Rate', digits=(16,2), help='The rate of the currency to the currency of rate 1'),
        'rate': old_float('Rate', digits=(12,6), help='The rate of the currency to the currency of rate 1'),
        'alter_rate': fields.function(_alter_rate_inv, digits=(16,2),
            fnct_inv=_alter_rate_inv_write, string='Rate',
            help='The rate of the currency to the currency of rate 1', required=True),
    }
    
    _defaults = {
        'currency_id': lambda obj, cr, uid, c={}: c.get('currency_id', False),
    }
    
#     _sql_constraints = [
#         ('unique_rate_for_currency', 'UNIQUE(currency_id,name)', 'You can define only one rate on a day !'),
#     ]

res_currency_rate()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: