# -*- coding: utf-8 -*-
##############################################################################
#
#                       iERP Consulting
#
##############################################################################

from openerp import tools
from openerp.osv import fields, osv

from openerp.tools.sql import drop_view_if_exists

class tc_report(osv.osv):
    _name = "tc.report"
    _description = "Tbab checklist report"
    _auto = False
    #_rec_name = 'date'
    
    # Хяналтаар илэрсэн зөрчил
    
    _columns = {
	'id': fields.char('ID',copy=False),#ID
	'tc_number': fields.char('TC number',copy=False),#Хяналтын хуудас №.....
	'code': fields.char('Code'),#Баримтын дугаар
	'partner_id': fields.many2one('res.partner','Partner'),#Харилцагч
	'date_start': fields.date('Date start'),#Зөрчлийг шийдэж эхлэх огноо
	'date_end': fields.date('Date end', track_visibility='onchange'),#Зөрчлийг шийдэж дуусах огноо
	'project_id': fields.many2one('project.project','Project'),#Төсөл
	'building_id': fields.many2one('project.building','Building'),#Байр
	'date_completed': fields.date('Date completed', track_visibility='onchange'),#Биелсэн огноо
	#'assessment_line_id': fields.one2many('risk.assessment.line','line_id', 'Risk assessments line', track_visibility='onchange'),#Зөрчлүүд
	'tc_respondent': fields.char('TC Respondent'),#Хариуцагч
	'control_engineer': fields.many2one('res.users','Control engineer'),#Хяналтын инженер
	'hsm_engineer': fields.many2one('res.users','HSM engineer'),#ХЭМАБ-н инженер
	'description': fields.text('Description'),#Тайлбар
    	'state':fields.selection([('new','New'),
                            ('closed','Closed')],'State', track_visibility='onchange'),
	#'res_users_id':fields.many2many('res.users','tc_users_id','tc_users_rel','users_tc_id','Employees'),#Хамааралтай ажилчид


	
	'activity_id': fields.many2one('risk.activity','Activity'),#Үйл ажиллагаа
	'step_id': fields.many2one('risk.step','Step'),#Алхам
	'mistakes_id': fields.many2one('risk.mistakes','Mistakes'),#Бодит болон боломжит аюул, алдаа
	'type':fields.selection([('quality','Quality'),
                                    ('hsm','HSM')],'Type'),#Боломжит алдааны төрөл
	'reason': fields.char('Reason'),#Эрсдэл үүсэх шалтгаан
	'probability': fields.integer('Probability'),#Магадлал
	'damages': fields.integer('Damages'),#Хохирол
	'risk_level': fields.integer('Risk level'),#Эрсдлийн зэрэг
	'solution': fields.text('Solution'),#Авч хэрэгжүүлэх  арга хэмжээ
	'current_monitoring': fields.text('Current monitoring'),#Одоогийн хяналт хийж байгаа байдал
	'date': fields.date('Date'),#Эрсдэл үүссэн хугацаа
	'reduction_of_damages': fields.char('Reduction of damages'),#Хохирлыг бууруулах хэмжээ
	'ral_respondent': fields.many2one('res.users','RAL Respondent'),#Хариуцах албан тушаалтан
	'assessment': fields.integer('Assessment'),#Эрсдлийн үнэлгээ
	'note': fields.text('Note'),#Тэмдэглэл
	#'line_id': fields.many2one('tbab.checklist','line_id', 'Tbab checklist'),#Хяналтын хуудас
	'assessment_changed': fields.boolean('Assessment changed'),#Үнэлгээ өөрчлөгдсөн эсэх
    }

    def init(self, cr):
        drop_view_if_exists(cr, 'tc_report')
        cr.execute("""
            create or replace view tc_report as (
                SELECT 
	          ral.id as id, tc.tc_number as tc_number, tc.code as code, tc.partner_id as partner_id, tc.date_start as date_start, tc.date_end as date_end, tc.project_id as project_id, tc.building_id as building_id, tc.date_completed as date_completed, tc.respondent as tc_respondent, tc.control_engineer as control_engineer, tc.hsm_engineer as hsm_engineer, tc.description as description, tc.state as state, 
ral.activity_id as activity_id, ral.step_id as step_id, ral.mistakes_id as mistakes_id, ral.type as type, ral.reason as reason, ral.probability as probability, ral.damages as damages, ral.risk_level as risk_level, ral.solution as solution, ral.current_monitoring as current_monitoring, ral.date as date, ral.reduction_of_damages as reduction_of_damages, ral.respondent as ral_respondent, ral.assessment as assessment, ral.note as note, ral.assessment_changed as assessment_changed
	        FROM 
	          public.tbab_checklist as tc, 
	          public.risk_assessment_line as ral, 
	          public.risk_mistakes as rm, 
	          public.risk_step as rs, 
	          public.risk_activity as ra, 
	          public.res_partner as rp, 
	          public.project_project as pp, 
	          public.project_building as pb, 
	          public.res_users as ru
	        WHERE 
	          ral.line_id = tc.id AND
	          ra.id = rs.activity_id AND
	          ra.id = rm.activity_id AND
	          rs.id = rm.step_id AND
	          ra.id = ral.activity_id AND
	          rs.id = ral.step_id AND
	          rm.id = ral.mistakes_id AND
	          rp.id = tc.partner_id AND
	          pp.id = tc.project_id AND
	          pb.id = tc.building_id
		group by
		  ral.id,
		  tc.tc_number,
		  tc.partner_id,
		  tc.project_id,
		  tc.building_id,
		  tc.control_engineer,
		  tc.hsm_engineer,
		  ral.probability,
		  ral.damages,
		  ral.risk_level,
		  ral.assessment,
		  ral.activity_id,
		  ral.step_id,
		  ral.mistakes_id,
		  ral.respondent,
		  ral.type,
		  ral.reason,
		  ral.solution,
		  ral.current_monitoring,
		  ral.date,
		  ral.reduction_of_damages,
		  ral.note,
		  ral.assessment_changed,
		  tc.code,
		  tc.date_start,
		  tc.date_end,
		  tc.date_completed,
		  tc.respondent,
		  tc.description,
		  tc.state
		)""")



