# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    
#
##############################################################################

import logging
import time
import datetime
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv, orm
from openerp.tools import float_is_zero
from openerp.tools.translate import _
from calendar import month, day_abbr, day_name
from dateutil import rrule
import math
from dateutil.relativedelta import relativedelta
from openerp.exceptions import except_orm
from openerp.exceptions import Warning
#import pymsgbox

from openerp import tools
from openerp.osv import fields, osv

from openerp.tools.sql import drop_view_if_exists

class risk_activity(osv.osv):
    _name = 'risk.activity'
    
    _columns = {
		'name': fields.char('Name'),#Үйл ажиллагааны нэр
    }


class risk_step(osv.osv):
    _name = 'risk.step'
    
    _columns = {
		'name': fields.char('Name'),#Алхам
		'activity_id': fields.many2one('risk.activity','Activity'),#Үйл ажиллагаа
    }

class risk_mistakes(osv.osv):
    _name = 'risk.mistakes'
    
    _columns = {
		'name': fields.char('Name'),#Бодит болон боломжит аюул, алдаа
		'activity_id': fields.many2one('risk.activity','Activity'),#Үйл ажиллагаа
		'step_id': fields.many2one('risk.step','Step'),#Алхам
    }


class risk_assessment(osv.osv):
    _name = 'risk.assessment'
    
    _columns = {
		'activity_id': fields.many2one('risk.activity','Activity'),#Үйл ажиллагаа
		'step_id': fields.many2one('risk.step','Step'),#Алхам
		'mistakes_id': fields.many2one('risk.mistakes','Mistakes'),#Бодит болон боломжит аюул, алдаа
		'type':fields.selection([('quality','Quality'),
                                            ('hsm','HSM')],'Type'),#Боломжит алдааны төрөл
		
		'reason': fields.text('Reason'),#Эрсдэл үүсэх шалтгаан
		'probability': fields.integer('Probability'),#Магадлал
		'damages': fields.integer('Damages'),#Хохирол
		'risk_level': fields.integer('Risk level'),#Эрсдлийн зэрэг
		
		'solution': fields.text('Solution'),#Авч хэрэгжүүлэх арга хэмжээ
		'current_monitoring': fields.text('Current monitoring'),#Одоогийн хяналт хийж байгаа байдал
		'date': fields.date('Date'),#Хугацаа
		'reduction_of_damages': fields.char('Reduction of damages'),#Хохирлыг бууруулах хэмжээ
		'respondent': fields.many2one('res.users','Respondent'),#Хариуцагч
		'res_users_id':fields.many2many('res.users','ra_users_id','ra_users_rel','users_ra_id','Employees'),#Хамааралтай ажилчид
		
		#'assessment': fields.integer('Assessment'),#Эрсдлийн үнэлгээ
		#'note': fields.text('Note'),#Хариуцагч
	
    }
    _defaults = {
                 'probability': 1,
                 'damages': 1,
                 }
    _sql_constraints = [
         ('assessment_uniq', 'unique (activity_id,step_id,mistakes_id,type)', u' Давхцаж байна. Энэ төрлийн эрсдлийн үнэлгээ бүртгэгдсэн байна! Та <<Үйл ажиллагаа, Алхам, Бодит болон боломжит аюул алдаа, Боломжит алдааны төрөл>> талбарууд бүгд нийлээд цор ганц бүртгэгдсэн байгааг шалгана уу!')
    ]

    
    def create(self, cr, uid, vals, context=None):
        #alias_context = dict(context, alias_model_name='hr.applicant', alias_parent_model_name=self._name)
        
	probability_check = vals['probability']
	damages_check = vals['damages']
	
	if 1 > probability_check or probability_check > 5:
		raise osv.except_osv(_('Өгөгдөл бөглөлтийн алдаа!'),_("Та Магадлал талбарын утганд зөвхөн 1-с 5-н хооронд тоо оруулах боломжтой !!!"))
	
	if 1 > damages_check or damages_check > 5:
		raise osv.except_osv(_('Өгөгдөл бөглөлтийн алдаа!'),_("Та Хохирол талбарын утганд зөвхөн 1-с 5-н хооронд тоо оруулах боломжтой !!!"))
	vals['risk_level'] = probability_check * damages_check
	#vals['assessment'] = probability_check * damages_check
	
	job_id = super(risk_assessment, self).create(cr, uid, vals, context=None)
        
        return job_id


    def write(self, cr, uid, ids, vals, context=None):
	obj = self.browse(cr, uid,ids)
	probability_check = 1
	damages_check = 1
	if 'probability' in vals:
		probability_check = vals['probability']
	else:
		probability_check = obj.probability
	if 'damages' in vals:
		damages_check = vals['damages']
	else:
		damages_check = obj.damages
	
	if 1 > probability_check or probability_check > 5:
		raise osv.except_osv(_('Өгөгдөл бөглөлтийн алдаа!'),_("Та Магадлал талбарын утганд зөвхөн 1-с 5-н хооронд тоо оруулах боломжтой !!!"))
	
	if 1 > damages_check or damages_check > 5:
		raise osv.except_osv(_('Өгөгдөл бөглөлтийн алдаа!'),_("Та Хохирол талбарын утганд зөвхөн 1-с 5-н хооронд тоо оруулах боломжтой !!!"))
	
	vals['risk_level'] = probability_check * damages_check
	#vals['assessment'] = probability_check * damages_check


	return super(risk_assessment, self).write(cr, uid, ids, vals, context=context)


class tbab_checklist(osv.osv):
    _name = 'tbab.checklist'
    _description = 'Tbab checklist'
    
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    _columns = {
	'tc_number': fields.char('TC number',copy=False),#Хяналтын хуудас №.....
	'code': fields.char('Code'),#Баримтын дугаар
	'partner_id': fields.many2one('res.partner','Partner'),#Харилцагч
	'date_start': fields.date('Date start'),#Эхлэх огноо
	'date_end': fields.date('Date end', track_visibility='onchange'),#Дуусах огноо
	'project_id': fields.many2one('project.project','Project'),#Төсөл
	'building_id': fields.many2one('project.building','Building'),#Байр
	
	'date_completed': fields.date('Date completed', track_visibility='onchange'),#Биелсэн огноо
	
	
	'assessment_line_id': fields.one2many('risk.assessment.line','line_id', 'Risk assessments line', track_visibility='onchange'),#Зөрчлүүд
	#'risk_assessment_ids': fields.many2many('risk.assessment', 'tc_id', 'tc_ra_rel', 'tbab_checklist_id', 'Risk assessments'),#Зөрчлүүд
	
	'respondent': fields.char('Respondent'),#Хариуцагч
	#'site_engineer': fields.many2one('res.users','Site engineer'),#Талбайн инженер
	'control_engineer': fields.many2one('res.users','Control engineer'),#Хяналтын инженер
	'hsm_engineer': fields.many2one('res.users','HSM engineer'),#ХЭМАБ-н инженер
	
	'description': fields.text('Description'),#Тайлбар
    			
	'state':fields.selection([('new','New'),
                            ('closed','Closed')],'State', track_visibility='onchange'),
	'res_users_id':fields.many2many('res.users','tc_users_id','tc_users_rel','users_tc_id','Employees'),#Хамааралтай ажилчид
	

	'user_mail_created':fields.boolean('User mail created'),#Хамааралтай ажилчдад мэйл илгээсэн эсэх
	'ce_mail_created':fields.boolean('CE mail created'),#Хяналтын инженерт мэйл илгээсэн эсэх
	'hsme_mail_created':fields.boolean('HSME mail created'),#ХАБ-н инженерт мэйл илгээсэн эсэх
	'state_mail_created':fields.boolean('State mail created'),#Төлвийн өөрчлөлтөд мэйл илгээсэн эсэх
	'line_mail_created':fields.boolean('Line mail created'),#Мөрийн өөрлөлтөд мэйл илгээсэн эсэх

    }
    _defaults = {
                 'tc_number': lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'tbab.checklist'),
                 'state': 'new',

		 'user_mail_created':False,
		 'ce_mail_created':False,
		 'hsme_mail_created':False,
		 'state_mail_created':False,
		 'line_mail_created':False,
                 }

    def to_new(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'new', 'date_completed':False})
        return True

    def to_closed(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'closed', 'date_completed':date.today()})
        return True


    def write(self, cr, uid, ids, vals, context=None):
	obj = self.browse(cr, uid,ids)
	
	if 'res_users_id' in vals:
		vals['user_mail_created'] = False
	
	if 'state' in vals:
		vals['state_mail_created'] = False
	
	if 'assessment_line_id' in vals:
		vals['line_mail_created'] = False
	
	if 'control_engineer' in vals:
		vals['ce_mail_created'] = False
	
	if 'hsm_engineer' in vals:
		vals['hsme_mail_created'] = False
		
	return super(tbab_checklist, self).write(cr, uid, ids, vals, context=context)



class risk_assessment_line(osv.osv):
    _name = 'risk.assessment.line'
    _description = 'Risk assessment line'
    
    _columns = {
		'activity_id': fields.many2one('risk.activity','Activity'),#Үйл ажиллагаа
		'step_id': fields.many2one('risk.step','Step'),#Алхам
		'mistakes_id': fields.many2one('risk.mistakes','Mistakes'),#Бодит болон боломжит аюул, алдаа
		'type':fields.selection([('quality','Quality'),
                                            ('hsm','HSM')],'Type'),#Боломжит алдааны төрөл
		
		'reason': fields.text('Reason'),#Эрсдэл үүсэх шалтгаан
		'probability': fields.integer('Probability'),#Магадлал
		'damages': fields.integer('Damages'),#Хохирол
		'risk_level': fields.integer('Risk level'),#Эрсдлийн зэрэг
		
		'solution': fields.text('Solution'),#Авч хэрэгжүүлэх  арга хэмжээ
		'current_monitoring': fields.text('Current monitoring'),#Одоогийн хяналт хийж байгаа байдал
		'date': fields.date('Date'),#Хугацаа
		'reduction_of_damages': fields.char('Reduction of damages'),#Хохирлыг бууруулах хэмжээ
		'respondent': fields.many2one('res.users','Respondent'),#Хариуцагч
		
		'assessment': fields.integer('Assessment'),#Эрсдлийн үнэлгээ
		'note': fields.text('Note'),#Тэмдэглэл
		'line_id': fields.many2one('tbab.checklist','line_id', 'Tbab checklist'),#Хяналтын хуудас

		'assessment_changed': fields.boolean('Assessment changed'),#Үнэлгээ өөрчлөгдсөн эсэх
    }
    _defaults = {
                 'probability': 1,
                 'damages': 1,
                 'assessment_changed': False,
                 }
    
    
    def onchange_probability_damages(self, cr, uid, ids, probability, damages, type, activity_id, step_id, mistakes_id, context=None):
        value = {}
	if 1 > probability:
		probability = 1
	elif 5 < probability:
		probability = 5
	else:
		probability = probability
	if 1 > damages:
		damages = 1
	elif 5 < damages:
		damages = 5
	else:
		damages = damages
	if 0 < probability < 6 and 0 < damages < 6:
		value['probability'] = probability
		value['damages'] = damages
		value['assessment'] = probability * damages
	ra_obj = self.pool.get('risk.assessment').search(cr,uid,[('activity_id','=',activity_id),('step_id','=',step_id),('mistakes_id','=',mistakes_id),('type','=',type)])
	if ra_obj:
        	ra_id = self.pool.get('risk.assessment').browse(cr,uid,ra_obj)
		if ra_id.probability == probability and ra_id.damages == damages:
			value['assessment_changed'] = False
		else:
			value['assessment_changed'] = True
        return {'value': value}
    
    
    def onchange_mistakes_id(self, cr, uid, ids, type, activity_id, step_id, mistakes_id, context=None):
        value = {}
	print 'ddddddddsssssss', type, activity_id, step_id, mistakes_id
        if mistakes_id:
	    ra_obj = self.pool.get('risk.assessment').search(cr,uid,[('activity_id','=',activity_id),('step_id','=',step_id),('mistakes_id','=',mistakes_id),('type','=',type)])
	    print 'ggggnnnnnn', ra_obj
	    if ra_obj:
        	ra_id = self.pool.get('risk.assessment').browse(cr,uid,ra_obj)
		value['reason'] = ra_id.reason
		value['probability'] = ra_id.probability
		value['damages'] = ra_id.damages
		value['risk_level'] = ra_id.probability * ra_id.damages
		value['reduction_of_damages'] = ra_id.reduction_of_damages
		value['assessment'] = ra_id.probability * ra_id.damages
            #job = self.pool.get('hr.job').browse(cr, uid, job_id)
            #value['job_code'] = job.job_code
        return {'value': value}
    
    def create(self, cr, uid, vals, context=None):
	
        ra_obj = self.pool.get('risk.assessment').search(cr,uid,[('activity_id','=',vals['activity_id']),('step_id','=',vals['step_id']),('mistakes_id','=',vals['mistakes_id']),('type','=',vals['type'])])
	if ra_obj:
        	ra_id = self.pool.get('risk.assessment').browse(cr,uid,ra_obj)
		vals['reason'] = ra_id.reason
		#vals['probability'] = ra_id.probability
		#vals['damages'] = ra_id.damages
		vals['risk_level'] = ra_id.probability * ra_id.damages
		vals['reduction_of_damages'] = ra_id.reduction_of_damages
		vals['assessment'] = ra_id.probability * ra_id.damages
		#vals['assessment'] = vals['assessment']
	else:
        	raise osv.except_osv(_('Алдаа!'),_("Эрсдлийн үнэлгээний маягтад бүртгэлгүй байна. Та энэхүү мөрийг устгана уу!"))
	#vals['assessment'] = vals['assessment']
	job_id = super(risk_assessment_line, self).create(cr, uid, vals, context=None)
        
        return job_id


    def write(self, cr, uid, ids, vals, context=None):
	obj = self.browse(cr, uid,ids)
	
	w_type = ''
	w_ad = 0
	w_sd = 0
	w_md = 0
	if 'type' in vals or 'activity_id' in vals or 'step_id' in vals or 'mistakes_id' in vals:
		if 'type' in vals:
			w_type = vals['type']
		else:
			w_type = obj.type
		if 'activity_id' in vals:
			w_ad = vals['activity_id']
		else:
			w_ad = obj.activity_id.id
		if 'step_id' in vals:
			w_sd = vals['step_id']
		else:
			w_sd = obj.step_id.id
		if 'mistakes_id' in vals:
			w_md = vals['mistakes_id']
		else:
			w_md = obj.mistakes_id.id
		ra_obj = self.pool.get('risk.assessment').search(cr,uid,[('activity_id','=',w_ad),('step_id','=',w_sd),('mistakes_id','=',w_md),('type','=',w_type)])
	
		if ra_obj:
			ra_id = self.pool.get('risk.assessment').browse(cr,uid,ra_obj)
			print 'bbbbbbbbbbbbb', ra_id.reason
			vals['reason'] = ra_id.reason
			vals['probability'] = ra_id.probability
			vals['damages'] = ra_id.damages
			vals['risk_level'] = ra_id.probability * ra_id.damages
			vals['reduction_of_damages'] = ra_id.reduction_of_damages
			vals['assessment'] = ra_id.probability * ra_id.damages
			#vals['assessment'] = vals['assessment']
		else:
			raise osv.except_osv(_('Алдаа!'),_("Эрсдлийн үнэлгээний маягтад бүртгэлгүй байна. Та энэхүү мөрийг устгана уу!"))
	#if 'assessment' in vals:
		#vals['assessment'] = vals['assessment']
	return super(risk_assessment_line, self).write(cr, uid, ids, vals, context=context)

	







