# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    
#
##############################################################################

#from openerp import models
import logging
import time
import datetime
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv, orm
from openerp.tools import float_is_zero
from openerp.tools.translate import _
from calendar import month, day_abbr, day_name
from dateutil import rrule
import math
from dateutil.relativedelta import relativedelta
import sys
#from mock.mock import self
reload(sys)
sys.setdefaultencoding('utf-8')
#from openerp.exceptions import except_orm
#from openerp.exceptions import Warning
#import pymsgbox

class feedback_act(osv.osv):
    _name = 'feedback.act'
    _description = 'Feedback act'
    
    _inherit = ['mail.thread', 'ir.needaction_mixin']

    def _progress_function(self, cr, uid, ids,field_names, args, context = {}):
        res = {}
        for lines in self.browse(cr, uid, ids):
            i = 0
            count_yes = 0
            count_no = 0
            proc = 0
            if lines.solution_ids:
            	for line in lines.solution_ids:
                    i += 1
                    if line.is_done == True:
                        count_yes = count_yes + 1
                    else:
                        count_no = count_no + 1
                proc = (count_yes * 100)/i
            else:
                proc=0
            
            res[lines.id] = proc
        return res

    _columns = {
    			'fa_number': fields.char('FA number',copy=False),
				'project_id': fields.many2one('project.project', 'Project', track_visibility='onchange'),#Төсөл
				'project_building_id': fields.many2one('project.building', 'Building', track_visibility='onchange'),#Байрны дугаар
				'project_door_id': fields.many2one('project.door', 'Door', track_visibility='onchange', copy=False),#Хаалганы тоот
    			'self_number': fields.char('Self number'),#Баримтын дугаар
                'size_of_field': fields.float('Size of field'),#Талбайн хэмжээ
    			'number_of_rooms': fields.integer('Number of rooms'),#Өрөөний тоо
    			'have_payment': fields.boolean('Have payment'),#Төлбөр тооцоотой эсэх
                
                'fa_type':fields.selection([('feedback','Санал хүсэлт барагдуулах акт'),
                                            ('complaint','Гомдол, санал')],'Төрөл', track_visibility='onchange'),
    			
    			#'progress': fields.integer('Progress', related='progress_function'),#Ажлын явц (%)
    			'progress': fields.related('progress_function',string='Progress',type='integer',store=True, group_operator="avg"), 
        		'progress_function': fields.function(_progress_function, method=True, type ="integer", string='Progress function'),

    			'owner_surname': fields.char('Owner surname'),#Эзэмшигчийн овог
    			'owner_name': fields.char('Owner name'),#Эзэмшигчийн нэр
    			'contract_number': fields.char('Contract number'),#Гэрээний дугаар
    			'phone': fields.integer('Phone'),#Утасны дугаар
    			'accepted_date': fields.date('Accepted date'),#Түлхүүр хүлээн авсан хугацаа
    			
    			'aoa_payment_date': fields.date('AOA payment date'),#СӨХ-ны төлбөр бодогдох хугацаа
    			'assigned_to':fields.many2one('res.users','Assigned to', track_visibility='onchange'),#Гүйцэтгэх ажилчин
               		'res_users_id':fields.many2many('res.users','fa_users_id','fa_users_rel','users_fa_id','Employees', track_visibility='onchange'),#Хамааралтай ажилчид
               
    			'solution_ids': fields.one2many('feedback.solution','fa_id','Solutions'),#Санал хүсэлт барагдуулалт

    			#Гүйцэтгэгчийг төлөөлж
    			'sales_manager': fields.many2one('res.users','Sales manager'),#Борлуулалтын менежер
    			'crm_manager': fields.many2one('res.users','CRM manager'),#Харилцагчийн үйлчилгээний менежер
    			'author_manager': fields.many2one('res.users','Author manager'),#Хяналтын менежер
    			#Захиалагчийг төлөөлж
    			'subscriber': fields.char('Subscriber'),#Захиалагч
    			#СӨХ-г төлөөлж
    			'aoa_worker': fields.char('AOA worker'),#СӨХ-н ажилтан
    			#УЭХ-г төлөөлж
    			'ueh_worker': fields.char('UEH worker'),#УЭХ-н ажилтан
    			
    			'state':fields.selection([('draft','Draft'),
                                            ('process','Process'),
                                            ('closed','Closed')],'State', track_visibility='onchange'),
    			
    			'assigner_mail_created': fields.boolean('Assigner mail created'),#Гүйцэтгэх ажилчинд мэйл илгээсэн эсэх
    			'user_mail_created': fields.boolean('User mail created'),#Хамааралтай ажилчдад мэйл илгээсэн эсэх
    			'state_mail_created': fields.boolean('State mail created'),#Төлвийн өөрчлөлтөд мэйл илгээсэн эсэх
    			#'sm_mail_created': fields.boolean('SM mail created'),#Борлуулалтын менежерт мэйл илгээсэн эсэх
    			#'crmm_mail_created': fields.boolean('CRMM created'),#Харилцагчийн үйлчилгээний менежерт мэйл илгээсэн эсэх
    			#'am_mail_created': fields.boolean('AM mail created'),#Хяналтын менежерт мэйл илгээсэн эсэх
                #'all_mail_created': fields.boolean('All mail created'),#Төлвийн өөрчлөлтөд мэйл илгээсэн эсэх
    			
    }
    _defaults = {
                 'fa_number': lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'feedback.act'),
                 'state': 'draft',
                 'user_mail_created': False,
                 'state_mail_created': False,
                 'assigner_mail_created': False,
                 'fa_type': False,
                 #'all_mail_created': False,
                 #'sm_mail_created': False,
                 #'crmm_mail_created': False,
                 #'am_mail_created': False,
                 }


    def change_state_true(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'assigner_mail_created': True,
                           'user_mail_created': True,
                           'state_mail_created': True,})
        return True
    
    def to_draft(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'draft'})
        return True

    def to_process(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'process'})
        return True

    def to_close(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'closed'})
        return True
    
    def create(self, cr, uid, vals, context=None):
        
        # action_id = self.pool.get('ir.actions.actions').search(cr, uid, [('id','=',context['params']['action'])])
        #------------------------------------------ print '333333333', action_id
        # action_obj =  self.pool.get('ir.actions.actions').browse(cr,uid,action_id[0])
        #----------------------------------- print '444444444444444', action_obj
        #-------------------------- if action_obj.name == 'feedback.act.action':
            #-------------------------------------- vals['fa_type'] = 'feedback'
        #----------------------- elif action_obj.name == 'feedback.act.action2':
            #------------------------------------- vals['fa_type'] = 'complaint'
        
        if 'solution_ids' in vals:
            line_users_id = []
            for line in vals['solution_ids']:
                #print 'yyyyyyy', line, line[2], line[2]['user_id'], '------', vals['res_users_id'][0][2]
                if line[2]['user_id']:
                    line_users_id.append(line[2]['user_id'])
                #print 'wwwww', line_users_id
            mergedlist = vals['res_users_id'][0][2] + line_users_id
            #print 'uuuu', mergedlist
            if mergedlist:
                vals['res_users_id'][0][2] = [mergedlist]
            else:
                vals['res_users_id'][0][2] = []
            #vals['res_users_id'][2].update({'user_id': mergedlist})
        #print 'bbbb', vals
        job_id = super(feedback_act, self).create(cr, uid, vals, context=None)
        return job_id
    
    def write(self, cr, uid, ids, vals, context=None):
    	#obj = self.browse(cr, uid,ids)
    	if vals.get('assigned_to'):
    		vals['assigner_mail_created'] = False
     
    	if vals.get('state'):
    		vals['state_mail_created'] = False
     
    	if vals.get('res_users_id'):
    		vals['user_mail_created'] = False
        return super(feedback_act, self).write(cr, uid, ids, vals, context=context)


class project_building(osv.osv):
    _name = 'project.building'
    
    _columns = {
				'name': fields.char('Name'),#Байрны нэр
    			'project_id': fields.many2one('project.project','Project'),#Төсөл
    }


class project_door(osv.osv):
    _name = 'project.door'
    
    _columns = {
				'name': fields.char('Name'),#Тоотын нэр
    			#'project_id': fields.many2one('project.project','Project'),#Төсөл
    			#'building_id': fields.many2one('project.building','Building'),#Байр
    }


class feedback_solution(osv.osv):
    _name = 'feedback.solution'
    
    _columns = {
				'feedback_name': fields.char('Feedback name'),#Гарсан санал хүсэлт
				'date_to_solve': fields.date('Date to solve'),#Гүйцэтгэх хугацаа
				'date_solved': fields.date('Date solved'),#Гүйцэтгэсэн хугацаа
				'is_done': fields.boolean('Is done'),#Хийгдсэн эсэх
				'note': fields.text('Note'),#Тайлбар
    				'user_id': fields.many2one('res.users','User'),#Хариуцагч

                'fa_id':fields.many2one('feedback.act','FA'),
                #'attachment_ids':fields.one2many('fs.attachment', 'attachment_id', 'FS attachments'),#Хавсралтууд
                #'image_main':fields.many2many('ir.attachment','fsa_im_rel', 'fsa_id', 'fsa_im_id','Image main', attachment=True),
                'attachment':fields.binary('Attachment'),#Хавсралт
    }
    
    def create(self, cr, uid, vals, context=None):
        job_id = super(feedback_solution, self).create(cr, uid, vals, context=None)
        
    	if 'user_id' in vals and vals['user_id'] != False:
            vals['assigner_mail_created'] = False
            fa_obj = self.pool.get('feedback.act').search(cr,uid,{('solution_ids', '=', job_id)})
            print 'vvvvvvvvvvvvv', job_id, fa_obj
            fa_browse = self.pool.get('feedback.act').browse(cr,uid,fa_obj)
            print 'faaaaaaaaa', fa_browse
            before_users_id = []
            for line in fa_browse.res_users_id:
    	        before_users_id.append(line.id)
    		mergedlist = before_users_id + [vals['user_id']]
    		fa_browse.write({'res_users_id':[(6,0,[mergedlist])]})
    	
    	#job_id = super(feedback_solution, self).create(cr, uid, vals, context=None)
        
        return job_id

    def write(self, cr, uid, ids, vals, context=None):
    	obj = self.browse(cr, uid,ids)
    
    	if 'user_id' in vals and vals['user_id'] != False:
            vals['assigner_mail_created'] = False
            fa_obj = self.pool.get('feedback.act').search(cr,uid,{('id', '=', obj.fa_id.id)})
            fa_browse = self.pool.get('feedback.act').browse(cr,uid,fa_obj)
            before_users_id = []
            for line in fa_browse.res_users_id:
                before_users_id.append(line.id)
    		mergedlist = before_users_id + [vals['user_id']]
    		fa_browse.write({'res_users_id':[(6,0,[mergedlist])]})
            #project.write({'user_ids': [(6,0,[mergedlist])]})
        return super(feedback_solution, self).write(cr, uid, ids, vals, context=context)



class fs_attachment(osv.osv):
    _name = 'fs.attachment'
    #FS - feedback solution
    _description = "FS attachment"
    _columns = {
                'image_main':fields.many2many('ir.attachment','fs_im_rel', 'fs_id', 'fs_im_id','Image main', attachment=True),
                #'attachment_id':fields.many2one('feedback.solution', 'FS'),
    }


