# -*- coding: utf-8 -*-
##############################################################################
#
#                       iERP Consulting
#
##############################################################################

from openerp import tools
from openerp.osv import fields, osv

from openerp.tools.sql import drop_view_if_exists

class fa_report(osv.osv):
    _name = "fa.report"
    _description = "Feedback act report"
    _auto = False
    #_rec_name = 'date'
    
    # Санал хүсэлт барагдуулах акт
    
    _columns = {
    			'fa_number': fields.char('FA number',copy=False),
				'project_id': fields.many2one('project.project', 'Project', track_visibility='onchange'),#Төсөл
				'project_building_id': fields.many2one('project.building', 'Building', track_visibility='onchange'),#Байрны дугаар
				'project_door_id': fields.many2one('project.door', 'Door', track_visibility='onchange'),#Хаалганы тоот
    			'size_of_field': fields.integer('Size of field'),#Талбайн хэмжээ
    			'number_of_rooms': fields.integer('Number of rooms'),#Өрөөний тоо
    			'have_payment': fields.boolean('Have payment'),#Төлбөр тооцоотой эсэх
    			
    			#'progress': fields.integer('Progress', related='progress_function'),#Ажлын явц (%)
    			'progress': fields.related('progress_function',string='Progress',type='integer',store=True), 
        		'progress_function': fields.function(_progress_function, method=True, type ="integer", string='Progress function'),

    			'owner_surname': fields.char('Owner surname'),#Эзэмшигчийн овог
    			'owner_name': fields.char('Owner name'),#Эзэмшигчийн нэр
    			'contract_number': fields.char('Contract number'),#Гэрээний дугаар
    			'phone': fields.integer('Phone'),#Утасны дугаар
    			'accepted_date': fields.date('Accepted date'),#Түлхүүр хүлээн авсан хугацаа
    			
    			'aoa_payment_date': fields.date('AOA payment date'),#СӨХ-ны төлбөр бодогдох хугацаа
    			'assigned_to':fields.many2one('res.users','Assigned to', track_visibility='onchange'),#Гүйцэтгэх ажилчин
               		'res_users_id':fields.many2many('res.users','fa_users_id','fa_users_rel','users_fa_id','Employees', track_visibility='onchange'),#Хамааралтай ажилчид
               
    			'solution_ids': fields.one2many('feedback.solution','fa_id','Solutions'),#Санал хүсэлт барагдуулалт

    			#Гүйцэтгэгчийг төлөөлж
    			'sales_manager': fields.many2one('res.users','Sales manager'),#Борлуулалтын менежер
    			'crm_manager': fields.many2one('res.users','CRM manager'),#Харилцагчийн үйлчилгээний менежер
    			'author_manager': fields.many2one('res.users','Author manager'),#Хяналтын менежер
    			#Захиалагчийг төлөөлж
    			'subscriber': fields.char('Subscriber'),#Захиалагч
    			#СӨХ-г төлөөлж
    			'aoa_worker': fields.char('AOA worker'),#СӨХ-н ажилтан
    			#УЭХ-г төлөөлж
    			'ueh_worker': fields.char('UEH worker'),#УЭХ-н ажилтан
    			
    			'state':fields.selection([('draft','Draft'),
                                            ('process','Process'),
                                            ('closed','Closed')],'State', track_visibility='onchange'),
    			
    			'assigner_mail_created': fields.boolean('Assigner mail created'),#Гүйцэтгэх ажилчинд мэйл илгээсэн эсэх
    			'user_mail_created': fields.boolean('User mail created'),#Хамааралтай ажилчдад мэйл илгээсэн эсэх
    			'state_mail_created': fields.boolean('State mail created'),#Төлвийн өөрчлөлтөд мэйл илгээсэн эсэх
    			'sm_mail_created': fields.boolean('SM mail created'),#Борлуулалтын менежерт мэйл илгээсэн эсэх
    			'crmm_mail_created': fields.boolean('CRMM created'),#Харилцагчийн үйлчилгээний менежерт мэйл илгээсэн эсэх
    			'am_mail_created': fields.boolean('AM mail created'),#Хяналтын менежерт мэйл илгээсэн эсэх
    }

    def init(self, cr):
        drop_view_if_exists(cr, 'fa_report')
        cr.execute("""
            create or replace view fa_report as (
                SELECT
                  income_line.id as id,
                  income_line.income_type_id as type,
                  income_line.date_income as date,
                  mdei.name as month_date_exp_inc,
                  res_partner.id as res_partner,
                  res_partner.adp_id as adp,  
                  sum(income_line.income_amount) as income_amount
                FROM 
                  public.month_date_exp_inc as mdei, 
                  public.livelihood_plan as lp, 
                  public.income_line, 
                  public.income_type, 
                  public.income_expense,
                  public.res_partner
                WHERE 
                  res_partner.id = income_expense.partner_id and
                  res_partner.id = lp.partner_id and
                  lp.first_approved_date < income_line.date_income and
                  income_line.income_type_id = income_type.id AND
                  income_line.month_date_exp_inc = mdei.id AND
                  income_expense.id = income_line.income_expense_id AND
                  income_type.income_parent = 'business'
                group by 
                 income_line.id,
                 income_line.income_type_id,
                 mdei.name,
                 income_line.date_income,
                 res_partner.id,
                 res_partner.adp_id,
                 income_line.income_amount
            )""")
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
