# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    
#
##############################################################################

import logging
import time
import datetime
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools import float_is_zero
from openerp.tools.translate import _
from calendar import month, day_abbr, day_name
from dateutil import rrule
import math
from dateutil.relativedelta import relativedelta

class tbab_finger_request(osv.osv):
    _name = 'tbab.finger.request'
    _description = 'Tbab finger request'
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    #_order = 'sequence'
    
    def _employee_get(self, cr, uid, context=None):        
        emp_id = context.get('default_employee_id', False)
        if emp_id:
            return emp_id
        ids = self.pool.get('hr.employee').search(cr, uid, [('user_id', '=', uid)], context=context)
        if ids:
            return ids[0]
        return False
    
    _columns = {
        'name': fields.datetime('Огноо', required=True),
        'employee_id': fields.many2one('hr.employee', 'Ажилтан', required=True, track_visibility='onchange'),
        'action': fields.selection([('sign_in', 'Ирсэн'),('sign_out', 'Явсан'),('action', 'Үйлдэл')], 'Үйлдэл'),
        'state': fields.selection([('draft', 'Зөвшөөрөх'),('approved', 'Батлагдсан'),('cancelled', 'Цуцлагдсан')], 'Төлөв', track_visibility='onchange'),
        
    }

    _defaults = {
        'state': 'draft',
        'employee_id': _employee_get,
        
    }
    
    def action_confirm(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        to_create_obj = self.pool.get('hr.attendance').search(cr, uid, [('employee_id', '=', obj.employee_id.id), ('name', '=', obj.name)], context=None)
        if to_create_obj:
            raise osv.except_osv(_('Анхааруулга'),_("Энэ цагт ирсэн хурууны бүртгэл Ирцүүд-д бүртгэгдсэн байна!!! Давхар үүсгэж болохгүй!"))
        else:
            for obj in self.browse(cr, uid, ids, context=context):
                self.pool.get('hr.attendance').create(cr, uid, {
                    'employee_id': obj.employee_id.id,
                    'name': obj.name,
                    'action': obj.action
    
                }, context=None)
            
        self.write(cr, uid, ids, {'state': 'approved'})
        return True
    
    def action_cancel(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        obj_hr_attendance = self.pool.get('hr.attendance').search(cr, uid, [('employee_id', '=', obj.employee_id.id), ('name', '=', obj.name)], context=None)
        to_del_obj = self.pool.get('hr.attendance')
        if obj_hr_attendance:
            to_del_obj.unlink(cr, uid, obj_hr_attendance)
        #raise osv.except_osv(_('Мэдэгдэл'),_("Ирцүүд дээр үүсгэгдсэн холбогдох ирцийг устгасан!"))
        self.write(cr, uid, ids, {'state': 'cancelled'})
        return True
    
    def action_draft(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'draft'})
        return True
    
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        if obj.state == 'approved':
            raise osv.except_osv(_('Анхааруулга'),_("Батлагдсан хуруу бүртгэлийг устгаж болохгүй!!! Та эхлээд цуцална уу!"))
        
        return super(tbab_finger_request, self).unlink(cr, uid, ids, context=context)
    
    
    
    
