#-*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    
#
##############################################################################
import sys
reload(sys)
sys.setdefaultencoding('utf-8')

import logging
import time
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools import float_is_zero
from openerp.tools.translate import _
from calendar import month, day_abbr, day_name
from dateutil import rrule
import math
from dateutil.relativedelta import relativedelta

#===============================================================================
# class tbab_mail_alias_inherit(osv.osv):
#     _inherit = 'mail.alias'
#     _description = 'Tbab alias inherit'
#     _columns = {
#                 'tbab_project_id': fields.one2many('tbab.project', 'Projects'),
#                 
#     }
#===============================================================================


class tbab_project_task_type(osv.osv):
    _name = 'tbab.project.task.type'
    _description = 'Tbab Task Stage'
    _order = 'sequence'
    _columns = {
        'name': fields.char('Stage Name', required=True, translate=True),
        'description': fields.text('Description'),
        'sequence': fields.integer('Sequence'),
        'case_default': fields.boolean('Default for New Projects',
                        help="Сонгосноор шинэ ажил бүртгэхэд үе шат болж харагдана. Бас ажлын канбан харагдацад энэ үе шат нь ажлууд-гүй байсан ч харагдана."),
        'project_ids': fields.many2many('tbab.project', 'tbab_project_task_type_rel', 'type_id', 'project_id', 'Projects'),
        'fold': fields.boolean('Folded in Kanban View',
                               help='Канбан харагдацад харуулахдаа эвхэх бол сонгоно уу!'),
    }

    def _get_default_project_ids(self, cr, uid, ctx={}):
        project_id = self.pool['tbab.task']._get_default_project_id(cr, uid, context=ctx)
        if project_id:
            return [project_id]
        return None

    _defaults = {
        'sequence': 1,
        'project_ids': _get_default_project_ids,
        'case_default': True,
    }
    _order = 'sequence'
    
    

class tbab_project(osv.osv):
    _name = 'tbab.project'
    _description = "Tbab project"
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    #_inherits = {"mail.alias": "alias_id"}
    #_inherit = ['mail.thread', 'ir.needaction_mixin']
    

    #===========================================================================
    # def _get_default_user_id(self, cr, uid, ids, field_name, arg, context=None):
    #     #=======================================================================
    #     # project_id = self.pool['tbab.task']._get_default_project_id(cr, uid, context=ctx)
    #     # if project_id:
    #     #     return [project_id]
    #     #=======================================================================
    #     obj = self.browse(cr, uid, ids)[0]
    #     own_id = 0
    #     for have_own_user_id in obj.user_ids:
    #         print 'aaaaa', have_own_user_id
    #         if have_own_user_id.id == uid:
    #             own_id = 1
    #         else:
    #             own_id = 0
    #     
    #     return {ids[0]:own_id}
    #===========================================================================
    
    def name_get(self, cr, uid, ids, context=None):
        if isinstance(ids, (list, tuple)) and not len(ids):
            return []
        if isinstance(ids, (long, int)):
            ids = [ids]
        reads = self.read(cr, uid, ids, ['name','code'], context=context)
        res = []
        for record in reads:
            name = record['name']
            if record['code']:
                name = name +' / '+ record['code']
            res.append((record['id'], name))
        return res
    
    def name_search(self, cr, uid, name, args=None, operator='ilike', context=None, limit=100):
        if args is None:
            args = []
        if context is None:
            context = {}
        ids = []
        if name:
            ids = self.search(cr, uid, [('name', 'ilike', name)] + args, limit=limit)
        if not ids:
            ids = self.search(cr, uid, [('code', 'ilike', name)] + args, limit=limit)
        return self.name_get(cr, uid, ids, context=context)
    
    def unlink(self, cr, uid, ids, context=None):
        #alias_ids = []
        #mail_alias = self.pool.get('mail.alias')
        for proj in self.browse(cr, uid, ids, context=context):
            if proj.tasks:
                raise osv.except_osv(_('Invalid Action!'),
                                     _('You cannot delete a project containing tasks. You can either delete all the project\'s tasks and then delete the project or simply deactivate the project.'))
            #===================================================================
            # elif proj.alias_id:
            #     alias_ids.append(proj.alias_id.id)
            #===================================================================
        res = super(tbab_project, self).unlink(cr, uid, ids, context=context)
        #mail_alias.unlink(cr, uid, alias_ids, context=context)
        return res
    
    def _task_count(self, cr, uid, ids, field_name, arg, context=None):
        res={}
        for tasks in self.browse(cr, uid, ids, dict(context, active_test=False)):
            res[tasks.id] = len(tasks.task_ids)
        return res
    
    #===========================================================================
    # def _get_alias_models(self, cr, uid, context=None):
    #     """ Overriden in project_issue to offer more options """
    #     return [('tbab.task', "Tasks")]
    #===========================================================================
    
    #_alias_models = lambda self, *args, **kwargs: self._get_alias_models(*args, **kwargs)
    
    _columns = {
                'name': fields.char('Name', required=True),
                'code': fields.char('Code'),
                'user_ids': fields.many2many('res.users','tbab_project_users_rel','tbab_project_ids','uid','Users'),
                'members': fields.many2many('res.users', 'project_user_rel', 'project_id', 'uid', 'Project Members',
                        help="Project's members are users who can have an access to the tasks related to this project.", 
                        states={'close':[('readonly',True)], 'cancelled':[('readonly',True)]}),
                'active': fields.boolean('Active', help="If the active field is set to False, it will allow you to hide the project without removing it."),
                'sequence': fields.integer('Sequence', help="Gives the sequence order when displaying a list of Projects."),
                'tasks': fields.one2many('tbab.task', 'project_id', "Task Activities"),
                'task_count': fields.function(_task_count, type='integer', string="Tasks",),
                #'default_user_id': fields.function(_get_default_user_id, type='integer', string="User ID",),
                'task_ids': fields.one2many('tbab.task', 'project_id', 'Tasks',
                                    domain=[('stage_id.fold', '=', False)]),
                #'use_tasks': fields.boolean('Use tasks', help="Сонгосноор Ажлууд харагдана"),
                #'partner_id': fields.many2one('res.partner', 'Customer'),
                'state': fields.selection([('template', 'Template'),
                                   ('draft','New'),
                                   ('open','In Progress'),
                                   ('cancelled', 'Cancelled'),
                                   ('pending','Pending'),
                                   ('close','Closed')],
                                  'Status', required=True, copy=False),
                #'alias_model': fields.selection(_alias_models, "Alias Model", select=True, help="The kind of document created when an email is received on this project's email alias"),
                #'type_ids': fields.many2many('tbab.project.task.type', 'tbab_project_task_type_rel', 'project_id', 'type_id', 'Tasks Stages', states={'close':[('readonly',True)], 'cancelled':[('readonly',True)]}),
                #'alias_id': fields.many2one('mail.alias', 'Alias', ondelete="restrict"),
        
                }
    
    #===========================================================================
    # def _get_type_common(self, cr, uid, context):
    #     ids = self.pool.get('tbab.project.task.type').search(cr, uid, [('case_default','=',1)], context=context)
    #     return ids
    #===========================================================================
    
    _order = "sequence, id"
    _defaults = {
        'active': True,
        'state': 'open',
        'sequence': 10,
        #'user_ids': (4, 0, [uid]),
        
        #'use_tasks': True,
        #'type_ids': _get_type_common,
        #'alias_model': 'tbab.task',
        #'alias_id': 1145,
        #'privacy_visibility': 'employees',
    }
    
    def create(self, cr, uid, vals, context=None):
        if context is None:
            context = {}
        # Prevent double project creation when 'use_tasks' is checked + alias management
        #=======================================================================
        # create_context = dict(context, project_creation_in_progress=True,
        #                       alias_model_name=vals.get('alias_model', 'tbab.task'),
        #                       alias_parent_model_name=self._name)
        #=======================================================================
        vals['user_ids'] =  [(4, uid),(4, 1)]
        #=======================================================================
        # if vals.get('type', False) not in ('template', 'contract'):
        #     vals['type'] = 'contract'
        #=======================================================================

        project_id = super(tbab_project, self).create(cr, uid, vals, context=context)
        #project_rec = self.browse(cr, uid, project_id, context=context)
        #self.pool.get('mail.alias').write(cr, uid, [project_rec.alias_id.id], {'alias_parent_thread_id': project_id, 'alias_defaults': {'project_id': project_id}}, context)
        return project_id

    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid, ids, context=None)
        # if alias_model has been changed, update alias_model_id accordingly
        if context is None:
            context = {}
        if 'user_ids' in vals:
            vals['user_ids'] = vals['user_ids'] + [(4, uid),(4, 1)]
        else:
            vals['user_ids'] = obj.user_ids + [(4, uid),(4, 1)]
        #=======================================================================
        # for num in mergedlist1:#list-n dawhardliig arilgah funkts
        #     if num not in mergedlist:
        #         mergedlist.append(num)
        #=======================================================================
        #=======================================================================
        # if vals.get('alias_model'):
        #     model_ids = self.pool.get('ir.model').search(cr, uid, [('model', '=', vals.get('alias_model', 'tbab.task'))])
        #     vals.update(alias_model_id=model_ids[0])
        #=======================================================================
        return super(tbab_project, self).write(cr, uid, ids, vals, context=context)




class tbab_task(osv.osv):
    _name = "tbab.task"
    _description = "Tbab task"
    _inherit = ['mail.thread', 'ir.needaction_mixin']

    def name_get(self, cr, uid, ids, context=None):
        if isinstance(ids, (list, tuple)) and not len(ids):
            return []
        if isinstance(ids, (long, int)):
            ids = [ids]
        reads = self.read(cr, uid, ids, ['name'], context=context)
        res = []
        for record in reads:
            name = record['name']
            if record['name']:
                name = name
            res.append((record['id'], name))
        return res
    
    def name_search(self, cr, uid, name, args=None, operator='ilike', context=None, limit=100):
        if args is None:
            args = []
        if context is None:
            context = {}
        ids = []
        if name:
            ids = self.search(cr, uid, [('name', 'ilike', name)] + args, limit=limit)
        #=======================================================================
        # if not ids:
        #     ids = self.search(cr, uid, [('code', 'ilike', name)] + args, limit=limit)
        #=======================================================================
        return self.name_get(cr, uid, ids, context=context)
    
    def _is_template(self, cr, uid, ids, field_name, arg, context=None):
        res = {}
        for task in self.browse(cr, uid, ids, context=context):
            res[task.id] = True
            if task.project_id:
                if task.project_id.active == False or task.project_id.state == 'template':
                    res[task.id] = False
        return res

    # Compute: effective_hours, total_hours, progress
    def _hours_get(self, cr, uid, ids, field_names, args, context=None):
        res = {}
        cr.execute("SELECT task_id, COALESCE(SUM(hours),0) FROM tbab_project_task_work WHERE task_id IN %s GROUP BY task_id",(tuple(ids),))
        hours = dict(cr.fetchall())
        for task in self.browse(cr, uid, ids, context=context):
            res[task.id] = {'effective_hours': hours.get(task.id, 0.0), 'total_hours': (task.remaining_hours or 0.0) + hours.get(task.id, 0.0)}
            res[task.id]['delay_hours'] = res[task.id]['total_hours'] - task.planned_hours
            res[task.id]['progress'] = 0.0
            if not float_is_zero(res[task.id]['total_hours'], precision_digits=2):
                res[task.id]['progress'] = round(min(100.0 * hours.get(task.id, 0.0) / res[task.id]['total_hours'], 99.99),2)
            if task.stage_id and task.stage_id.fold:
                res[task.id]['progress'] = 100.0
        return res
    
    def _get_task(self, cr, uid, ids, context=None):
        result = {}
        for work in self.pool.get('tbab.project.task.work').browse(cr, uid, ids, context=context):
            if work.task_id: result[work.task_id.id] = True
        return result.keys()
    
    def onchange_remaining(self, cr, uid, ids, remaining=0.0, planned=0.0):
        if remaining and not planned:
            return {'value': {'planned_hours': remaining}}
        return {}

    def onchange_planned(self, cr, uid, ids, planned=0.0, effective=0.0):
        return {'value': {'remaining_hours': planned - effective}}
    
    
    def onchange_project(self, cr, uid, id, project_id, context=None):
        if project_id:
            project = self.pool.get('tbab.project').browse(cr, uid, project_id, context=context)
            #phase = self.pool.get('tbab.project.phases').browse(cr, uid, project_id, context=context)
            decr_obj = self.pool.get('tbab.project.phases')
            decr_id = decr_obj.search(cr, uid, [('project_id','=',project_id)])
            decr = decr_obj.browse(cr, uid, decr_id)
            if decr:
                return {'value': {'phase_id': decr.id}}
            else:
                return {'value': {'phase_id': False}}
            if project:
                return {'value': {'project_id': project.id}}
        return {}
    
    def onchange_user_id(self, cr, uid, ids, user_id, context=None):
        vals = {}
        hr_obj = self.pool.get('hr.employee')
        emp_id = hr_obj.search(cr, uid, [('user_id','=',user_id)])
        emp = hr_obj.browse(cr, uid, emp_id)
        if user_id:
            vals['user_id_hr'] = emp.id
        else:
            vals['user_id_hr'] = False
        return {'value': vals}
    
    def onchange_reviewer_id(self, cr, uid, ids, reviewer_id, context=None):
        vals = {}
        hr_obj = self.pool.get('hr.employee')
        emp_id = hr_obj.search(cr, uid, [('user_id','=',reviewer_id)])
        emp = hr_obj.browse(cr, uid, emp_id)
        if reviewer_id:
            vals['reviewer_id_hr'] = emp.id
        else:
            vals['reviewer_id_hr'] = False
        return {'value': vals}
    
    def onchange_message_follower_ids(self, cr, uid, ids, message_follower_ids, context=None):
        self.write(cr, uid, ids, {'partner_mail_created': False}, context=context)
        return True
    
    def duplicate_task(self, cr, uid, map_ids, context=None):
        mapper = lambda t: map_ids.get(t.id, t.id)
        for task in self.browse(cr, uid, map_ids.values(), context):
            new_child_ids = set(map(mapper, task.child_ids))
            new_parent_ids = set(map(mapper, task.parent_ids))
            if new_child_ids or new_parent_ids:
                task.write({'parent_ids': [(6,0,list(new_parent_ids))],
                            'child_ids':  [(6,0,list(new_child_ids))]})
    
    def copy_data(self, cr, uid, id, default=None, context=None):
        if default is None:
            default = {}
        current = self.browse(cr, uid, id, context=context)
        if not default.get('name'):
            default['name'] = _("%s (copy)") % current.name
        if 'remaining_hours' not in default:
            default['remaining_hours'] = current.planned_hours

        return super(tbab_task, self).copy_data(cr, uid, id, default, context)

    #-------------------- def _get_default_partner(self, cr, uid, context=None):
        #----------- project_id = self._get_default_project_id(cr, uid, context)
        #-------------------------------------------------------- if project_id:
            # project = self.pool.get('tbab.project').browse(cr, uid, project_id, context=context)
            #-------------------------------- if project and project.partner_id:
                #---------------------------------- return project.partner_id.id
        #---------------------------------------------------------- return False
    
        
    def _get_default_project_id(self, cr, uid, context=None):
        """ Gives default section by checking if present in the context """
        return (self._resolve_project_id_from_context(cr, uid, context=context) or False)

    def _get_default_stage_id(self, cr, uid, context=None):
        """ Gives default stage_id """
        project_id = self._get_default_project_id(cr, uid, context=context)
        return self.stage_find(cr, uid, [], project_id, [('fold', '=', False)], context=context)

    def _resolve_project_id_from_context(self, cr, uid, context=None):
        """ Returns ID of project based on the value of 'default_project_id'
            context key, or None if it cannot be resolved to a single
            project.
        """
        if context is None:
            context = {}
        if type(context.get('default_project_id')) in (int, long):
            return context['default_project_id']
        if isinstance(context.get('default_project_id'), basestring):
            project_name = context['default_project_id']
            project_ids = self.pool.get('tbab.project').name_search(cr, uid, name=project_name, context=context)
            if len(project_ids) == 1:
                return project_ids[0][0]
        return None

    def _read_group_stage_ids(self, cr, uid, ids, domain, read_group_order=None, access_rights_uid=None, context=None):
        stage_obj = self.pool.get('tbab.project.task.type')
        order = stage_obj._order
        access_rights_uid = access_rights_uid or uid
        if read_group_order == 'stage_id desc':
            order = '%s desc' % order
        search_domain = []
        project_id = self._resolve_project_id_from_context(cr, uid, context=context)
        if project_id:
            search_domain += ['|', ('project_ids', '=', project_id)]
        search_domain += ['|',('id', 'in', ids), ('case_default', '=', True)]   #'0'- tasktai bsan ch stage-vvdiig n kanban deer harargdaj baihaar vzvvlne
        stage_ids = stage_obj._search(cr, uid, search_domain, order=order, access_rights_uid=access_rights_uid, context=context)
        result = stage_obj.name_get(cr, access_rights_uid, stage_ids, context=context)
        # restore order of the search
        result.sort(lambda x,y: cmp(stage_ids.index(x[0]), stage_ids.index(y[0])))

        fold = {}
        for stage in stage_obj.browse(cr, access_rights_uid, stage_ids, context=context):
            fold[stage.id] = stage.fold or False
        return result, fold

    def _read_group_user_id(self, cr, uid, ids, domain, read_group_order=None, access_rights_uid=None, context=None):
        res_users = self.pool.get('res.users')
        project_id = self._resolve_project_id_from_context(cr, uid, context=context)
        access_rights_uid = access_rights_uid or uid
        if project_id:
            ids += self.pool.get('tbab.project').read(cr, access_rights_uid, project_id, ['members'], context=context)['members']
            order = res_users._order
            # lame way to allow reverting search, should just work in the trivial case
            if read_group_order == 'user_id desc':
                order = '%s desc' % order
            # de-duplicate and apply search order
            ids = res_users._search(cr, uid, [('id','in',ids)], order=order, access_rights_uid=access_rights_uid, context=context)
        result = res_users.name_get(cr, access_rights_uid, ids, context=context)
        # restore order of the search
        result.sort(lambda x,y: cmp(ids.index(x[0]), ids.index(y[0])))
        return result, {}
    
    #===========================================================================
    # def _get_alias_models(self, cr, uid, context=None):
    #     """ Overriden in project_issue to offer more options """
    #     return [('tbab.task', "Tasks")]
    #===========================================================================
    
    
    _group_by_full = {
        'stage_id': _read_group_stage_ids,
        'user_id': _read_group_user_id,
    }

    #_alias_models = lambda self, *args, **kwargs: self._get_alias_models(*args, **kwargs)
    
    
    _columns = {
        'active': fields.function(_is_template, store=True, string='Not a Template Task', type='boolean', help="This field is computed automatically and have the same behavior than the boolean 'active' field: if the task is linked to a template or unactivated project, it will be hidden unless specifically asked."),
        'name': fields.text('Task Name', track_visibility='onchange', required=True, select=True),
        'to': fields.char('TO number',copy=False),#Task order number
        'description': fields.text('Description'),
        'project_id': fields.many2one('tbab.project', 'Project', ondelete='set null', select=True, change_default=True),
        'phase_id': fields.many2one('tbab.project.phases', 'Phases', ondelete='set null', select=True, change_default=True),
        'user_id': fields.many2one('res.users', 'Assigned to', select=True, track_visibility='onchange'),
        #'partner_id': fields.many2one('res.partner', 'Customer'),
        'reviewer_id': fields.many2one('res.users', 'Reviewer', select=True, track_visibility='onchange', tracking_disable='True'),
        'user_id_hr': fields.many2one('hr.employee', 'User HR'),
        'reviewer_id_hr': fields.many2one('hr.employee', 'Reviewer HR'),
        'planned_hours': fields.float('Initially Planned Hours'),
        'effective_hours': fields.function(_hours_get, string='Hours Spent', multi='hours', help="Computed using the sum of the task work done.",
            store = {
                'tbab.task': (lambda self, cr, uid, ids, c={}: ids, ['work_ids', 'remaining_hours', 'planned_hours'], 10),
                'tbab.project.task.work': (_get_task, ['hours'], 10),
            }),
        'remaining_hours': fields.float('Remaining Hours', digits=(16,2), track_visibility='onchange', help="Total remaining time, can be re-estimated periodically by the assignee of the task."),
        'total_hours': fields.function(_hours_get, string='Total', multi='hours', help="Computed as: Time Spent + Remaining Time.",
            store = {
                'tbab.task': (lambda self, cr, uid, ids, c={}: ids, ['work_ids', 'remaining_hours', 'planned_hours'], 10),
                'tbab.project.task.work': (_get_task, ['hours'], 10),
            }),
        'progress': fields.function(_hours_get, string='Working Time Progress (%)', multi='hours', group_operator="avg", help="If the task has a progress of 99.99% you should close the task if it's finished or reevaluate the time",
            store = {
                'tbab.task': (lambda self, cr, uid, ids, c={}: ids, ['work_ids', 'remaining_hours', 'planned_hours', 'state', 'stage_id'], 10),
                'tbab.project.task.work': (_get_task, ['hours'], 10),
            }),
        'delay_hours': fields.function(_hours_get, string='Delay Hours', multi='hours', help="Computed as difference between planned hours by the project manager and the total hours of the task.",
            store = {
                'tbab.task': (lambda self, cr, uid, ids, c={}: ids, ['work_ids', 'remaining_hours', 'planned_hours'], 10),
                'tbab.project.task.work': (_get_task, ['hours'], 10),
            }),
        'date_start': fields.datetime('Starting Date', select=True, copy=False),
        'date_end': fields.datetime('Ending Date', select=True, copy=False, required=True),
        'date_last_stage_update': fields.datetime('Last Stage Update', select=True, copy=False),
        'categ_ids': fields.many2many('tbab.project.category', string='Tags'),
        'sequence': fields.integer('Sequence', select=True, help="Gives the sequence order when displaying a list of tasks."),
        'priority': fields.selection([('0','Low'), ('1','Normal'), ('2','High')], 'Priority'),
        'work_ids': fields.one2many('tbab.project.task.work', 'task_id', 'Work done', track_visibility='onchange'),
        'stage_id': fields.many2one('tbab.project.task.type', 'Stage', track_visibility='onchange', select=True, copy=False),
        'stage_id_before': fields.many2one('tbab.project.task.type', 'Stage before', copy=False),
        #                domain="[('project_ids', '=', project_id)]", copy=False),
        'kanban_state': fields.selection([('normal', 'In Progress'),('blocked', 'Blocked'),('done', 'Ready for next stage')], 'Kanban State',
                                         track_visibility='onchange',
                                         help="A task's kanban state indicates special situations affecting it:\n"
                                              " * Normal is the default situation\n"
                                              " * Blocked indicates something is preventing the progress of this task\n"
                                              " * Ready for next stage indicates the task is ready to be pulled to the next stage",
                                         required=False, copy=False),
        #'user_email': fields.related('user_id', 'email', type='char', string='User Email', readonly=True),
        'parent_ids': fields.many2many('tbab.task', 'tbab_task_parent_rel', 'task_id', 'parent_id', 'Parent Tasks'),
        'child_ids': fields.many2many('tbab.task', 'tbab_task_parent_rel', 'parent_id', 'task_id', 'Delegated Tasks'),
        'color': fields.integer('Өнгө'),
        
        'is_finished_in_time': fields.boolean('Is finished in time'),
        'is_have_auto_task': fields.boolean('Is have auto task', readonly=True),
        'date_closed': fields.datetime('Date closed', select=True, copy=False),
        'date_approved': fields.datetime('Date approved', select=True, copy=False),
        
        'planned_hours_first': fields.float('Planned hours first', groups='tbab_project_task.group_tbab_task_manager,tbab_project_task.group_tbab_task_headmans'),
        'date_start_first': fields.datetime('Date start first', groups='tbab_project_task.group_tbab_task_manager,tbab_project_task.group_tbab_task_headmans'),
        'date_end_first': fields.datetime('Date end first', groups='tbab_project_task.group_tbab_task_manager,tbab_project_task.group_tbab_task_headmans'),
        'user_mail_created': fields.boolean('User mail created'),
        'reviewer_mail_created': fields.boolean('Reviewer mail created'),
        'partner_mail_created': fields.boolean('Partner mail created'),
        'state_mail_created': fields.boolean('State mail created'),
        #'mail_id': fields.many2one('mail.mail','Send mail'),
        #'alias_id': fields.many2one('mail.alias', 'Alias', ondelete="restrict", required=True),
        #=======================================================================
        # 'alias_model': fields.selection(_alias_models, "Alias Model", select=True, required=True,
        #                                 help="The kind of document created when an email is received on this project's email alias"),
        # 
        #=======================================================================
        'stage_str': fields.char('Stage STRING'),
    }
    _defaults = {
        'to': lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'tbab.task'),
        'stage_id': _get_default_stage_id,
        'project_id': _get_default_project_id,
        'date_last_stage_update': fields.datetime.now,
        'date_start': fields.datetime.now,
        'kanban_state': 'normal',
        'priority': '0',
        'progress': 0,
        'sequence': 10,
        'active': True,
        'is_have_auto_task': False,
        'reviewer_id': lambda obj, cr, uid, ctx=None: uid,
        'user_id': lambda obj, cr, uid, ctx=None: uid,
        'user_mail_created': False,
        'reviewer_mail_created': False,
        'partner_mail_created': False,
        'state_mail_created': False,
        'stage_id_before': _get_default_stage_id,
        'stage_str': 'Шинэ',
        #'company_id': lambda self, cr, uid, ctx=None: self.pool.get('res.company')._company_default_get(cr, uid, 'project.task', context=ctx),
        #'partner_id': lambda self, cr, uid, ctx=None: self._get_default_partner(cr, uid, context=ctx),
    }
    _order = "priority desc, sequence, date_start, name"

    
    def _check_recursion(self, cr, uid, ids, context=None):
        for id in ids:
            visited_branch = set()
            visited_node = set()
            res = self._check_cycle(cr, uid, id, visited_branch, visited_node, context=context)
            if not res:
                return False

        return True
    
    def _check_cycle(self, cr, uid, id, visited_branch, visited_node, context=None):
        if id in visited_branch: #Cycle
            return False

        if id in visited_node: #Already tested don't work one more time for nothing
            return True

        visited_branch.add(id)
        visited_node.add(id)

        #visit child using DFS
        task = self.browse(cr, uid, id, context=context)
        for child in task.child_ids:
            res = self._check_cycle(cr, uid, child.id, visited_branch, visited_node, context=context)
            if not res:
                return False

        visited_branch.remove(id)
        return True
    
    def _check_dates(self, cr, uid, ids, context=None):
        if context == None:
            context = {}
        obj_task = self.browse(cr, uid, ids[0], context=context)
        start = obj_task.date_start or False
        end = obj_task.date_end or False
        if start and end :
            if start > end:
                return False
        return True
    
    _constraints = [
        #(_check_recursion, 'Error ! You cannot create recursive tasks.', ['parent_ids']),
        #(_check_dates, 'Error ! Task end-date must be greater than task start-date', ['date_start','date_end'])
    ]
    
    def stage_find(self, cr, uid, cases, section_id, domain=[], order='sequence', context=None):
        """ Override of the base.stage method
            Parameter of the stage search taken from the lead:
            - section_id: if set, stages must belong to this section or
              be a default stage; if not set, stages must be default
              stages
        """
        if isinstance(cases, (int, long)):
            cases = self.browse(cr, uid, cases, context=context)
        # collect all section_ids
        section_ids = []
        if section_id:
            section_ids.append(section_id)
        for task in cases:
            if task.project_id:
                section_ids.append(task.project_id.id)
        search_domain = []
        if section_ids:
            search_domain = [('|')] * (len(section_ids) - 1)
            for section_id in section_ids:
                search_domain.append(('project_ids', '=', section_id))
        search_domain += list(domain)
        # perform search, return the first found
        stage_ids = self.pool.get('tbab.project.task.type').search(cr, uid, search_domain, order=order, context=context)
        if stage_ids:
            return stage_ids[0]
        return False
    
    def _check_child_task(self, cr, uid, ids, context=None):
        if context == None:
            context = {}
        tasks = self.browse(cr, uid, ids, context=context)
        for task in tasks:
            if task.child_ids:
                for child in task.child_ids:
                    if child.stage_id and not child.stage_id.tptt_closed:
                        raise osv.except_osv(_("Warning!"), _("Child task still open.\nPlease cancel or complete child task first."))
        return True
    
    def unlink(self, cr, uid, ids, context=None):
        if context == None:
            context = {}
        self._check_child_task(cr, uid, ids, context=context)
        res = super(tbab_task, self).unlink(cr, uid, ids, context)
        return res
    
    # ---------------------------------------------------
    # Mail gateway
    # ---------------------------------------------------

    def _message_get_auto_subscribe_fields(self, cr, uid, updated_fields, auto_follow_fields=None, context=None):
        if auto_follow_fields is None:
            auto_follow_fields = ['user_id', 'reviewer_id']
        return super(tbab_task, self)._message_get_auto_subscribe_fields(cr, uid, updated_fields, auto_follow_fields, context=context)

    def message_get_reply_to(self, cr, uid, ids, context=None):
        """ Override to get the reply_to of the parent project. """
        tasks = self.browse(cr, SUPERUSER_ID, ids, context=context)
        project_ids = set([task.project_id.id for task in tasks if task.project_id])
        aliases = self.pool['tbab.project'].message_get_reply_to(cr, uid, list(project_ids), context=context)
        return dict((task.id, aliases.get(task.project_id and task.project_id.id or 0, False)) for task in tasks)

    def message_new(self, cr, uid, msg, custom_values=None, context=None):
        """ Override to updates the document according to the email. """
        if custom_values is None:
            custom_values = {}
        defaults = {
            'name': msg.get('subject'),
            'planned_hours': 0.0,
        }
        defaults.update(custom_values)
        return super(tbab_task, self).message_new(cr, uid, msg, custom_values=defaults, context=context)

    def message_update(self, cr, uid, ids, msg, update_vals=None, context=None):
        """ Override to update the task according to the email. """
        if update_vals is None:
            update_vals = {}
        maps = {
            'cost': 'planned_hours',
        }
        for line in msg['body'].split('\n'):
            line = line.strip()
            res = tools.command_re.match(line)
            if res:
                match = res.group(1).lower()
                field = maps.get(match)
                if field:
                    try:
                        update_vals[field] = float(res.group(2).lower())
                    except (ValueError, TypeError):
                        pass
        return super(tbab_task, self).message_update(cr, uid, ids, msg, update_vals=update_vals, context=context)
    
    def _store_history(self, cr, uid, ids, context=None):
        for task in self.browse(cr, uid, ids, context=context):
            self.pool.get('tbab.project.task.history').create(cr, uid, {
                'task_id': task.id,
                'remaining_hours': task.remaining_hours,
                'planned_hours': task.planned_hours,
                'kanban_state': task.kanban_state,
                'type_id': task.stage_id.id,
                'user_id': task.user_id.id

            }, context=context)
        return True
    
    def create(self, cr, uid, vals, context=None):
        context = dict(context or {})

        # for default stage
        if vals.get('project_id') and not context.get('default_project_id'):
            context['default_project_id'] = vals.get('project_id')
        # user_id change: update date_start
        if vals.get('project_id'):
            project_id = self.pool.get('tbab.project').search(cr,uid,[('id','=',vals['project_id'])])
            project = self.pool.get('tbab.project').browse(cr,uid,project_id)
            if vals.get('user_id'):
                us_id = self.pool.get('res.users').search(cr,uid,[('id','=',vals['user_id'])])
                us = self.pool.get('res.users').browse(cr,uid,us_id)
                list = []
                list.append(us.id)
            if vals.get('reviewer_id'):
                rev_id = self.pool.get('res.users').search(cr,uid,[('id','=',vals['reviewer_id'])])
                rev = self.pool.get('res.users').browse(cr,uid,rev_id)
                list1 = []
                list1.append(rev.id)
            before_users_id = []
            for line in project.user_ids:
                before_users_id.append(line.id)
            mergedlist = before_users_id + list + list1 + [1]
            project.write({'user_ids': [(6,0,[mergedlist])]})
            
        if 'priority' in vals:
            vals['priority'] = vals['priority']
            
        if 'date_start' in vals:
            vals['date_start_first'] = vals['date_start']
            
        if 'date_end' in vals:
            vals['date_end_first'] = vals['date_end']
            
        if 'planned_hours' in vals:
            vals['planned_hours_first'] = vals['planned_hours']
            
        if 'description' in vals:
            vals['description'] = vals['description']
            
        # context: no_log, because subtype already handle this
        #create_context = dict(context, mail_create_nolog=True)
        print 'valsssssss', vals
        
        #To send TASK mail
 #==============================================================================
 #        template_obj = self.pool.get('email.template')
 #        print '111'
 #        #group_model_id = self.pool.get('ir.model').search(cr, uid, [('model', '=', 'tbab.task')])[0]
 #        if 'user_id' in vals:
 #            print '222'
 #            user_obj = self.pool.get('res.users')
 #            res_user_id = self.pool.get('res.users').search(cr, uid, [('id', '=', vals['user_id'])])
 #            us_id = user_obj.browse(cr, uid, res_user_id)
 #            if vals['user_id']:
 #                userss = us_id.name
 #            else:
 #                userss = 'Байхгүй'
 #        if 'reviewer_id' in vals:
 #            print '333'
 #            rev_obj = self.pool.get('res.users')
 #            rev_id = self.pool.get('res.users').search(cr, uid, [('id', '=', vals['reviewer_id'])])
 #            r_id = rev_obj.browse(cr, uid, rev_id)
 #            if vals['reviewer_id']:
 #                reviewer = r_id.name
 #            else:
 #                reviewer = 'Байхгүй'
 # 
 #        if userss != 'Байхгүй' and reviewer != 'Байхгүй':
 #            print '444'
 #            email_to = us_id.login
 #            email_cc = r_id.login
 #            print 'ffffffff', r_id, r_id.login, us_id, us_id.login
 #        elif userss != 'Байхгүй' and reviewer == 'Байхгүй':
 #            print '555'
 #            email_to = us_id.login
 #            email_cc = False
 #        elif userss == 'Байхгүй' and reviewer != 'Байхгүй':
 #            print '666'
 #            email_to = r_id.login
 #            email_cc = False
 #         #Ажлууд үүсгэхэд Гүйцэтгэгч болон Хянагч байгаа тохиолдолд тухайн хэрэглэгчид рүү мэйл явна
 #        if vals['reviewer_id'] or vals['user_id']:
 #            body_html = '''Танд ажил оноогдлоо \n Гүйцэтгэгч : %s '''%userss + '''\n Хянагч : %s '''%reviewer + '''\n Тайлбар : %s '''%vals['description'] + '''\n Эхлэх огноо : %s'''%vals['date_start'] + '''\n Дуусах огноо : %s'''%vals['date_end']
 # 
 #            send_mail_obj = self.pool.get('mail.mail')
 #            email_template_id = {
 #                                #'model_id': group_model_id,
 #                                #'name': vals['name'],
 #                                'subject' : vals['name'],
 #                                'body_html': body_html,
 #                                'email_from' : 'ncderp@ncd.mn',
 #                                'type' : 'email',
 #                                'auto_delete' : True,
 #                                'notification' : True,
 #                                #'force_send' : True,
 #                                'model' : 'tbab.task',
 #                                'email_to' : email_to,
 #                                'email_cc' : email_cc,
 #                                }
 #            print 'rtrtrtrtrtrtrt', send_mail_obj, email_template_id
 #            mail_id = send_mail_obj.create(cr, uid, email_template_id, context=None)
 #==============================================================================
        
        task_id = super(tbab_task, self).create(cr, uid, vals, context=None)
        #self._store_history(cr, uid, [task_id], context=context)
        return task_id
    
    

    def find_user_ids_from_project(self, cr, uid, ids,project_to_change, context=None):
        before_users_id = []
        if project_to_change:
            if project_to_change.user_ids:
                for line in project_to_change.user_ids:
                    before_users_id.append(line.id)
            else:
                before_users_id = []
        else:
            before_users_id = []
        
        return before_users_id
    
    
    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid, ids, context=context)
        if isinstance(ids, (int, long)):
            ids = [ids]
        is_finished_in_time = ''
            
        if_TMuser = self.pool['res.users'].has_group(cr, uid, 'tbab_project_task.group_tbab_task_user')
        if_TMmanager = self.pool['res.users'].has_group(cr, uid, 'tbab_project_task.group_tbab_task_manager')
        if_TMheadman = self.pool['res.users'].has_group(cr, uid, 'tbab_project_task.group_tbab_task_headmans')
        # stage change: update date_last_stage_update
        if 'stage_id' in vals:
            stage_obj = self.pool.get('tbab.project.task.type').browse(cr,uid,vals['stage_id'])
            vals['date_last_stage_update'] = fields.datetime.now()
            self.write(cr, uid, ids, {'stage_id_before': obj.stage_id.id,
                                      'state_mail_created': False,
                                      'stage_str': stage_obj.name}, context=context)
            
            #duussan tolowt shiljvvlehed hiih vildel
            if vals['stage_id'] == 4:
                if obj.date_end:
                    if obj.date_end >= fields.datetime.now():
                        is_finished_in_time = True
                    else:
                        is_finished_in_time = False
                else:
                    raise osv.except_osv(_("Алдаа!"), _("Дуусах огноогүй ажлыг дуусгаж болохгүй."))
                vals['date_closed'] = fields.datetime.now()
                self.write(cr, uid, ids, {'is_finished_in_time': is_finished_in_time}, context=context)
            
            #hyanagdsan tolowt shiljvvlehed hiih vildel
            elif vals['stage_id'] == 5:
                if obj.stage_id != 4:
                    if obj.date_end:
                        if obj.date_end >= fields.datetime.now():
                            is_finished_in_time = True
                        else:
                            is_finished_in_time = False
                    else:
                        raise osv.except_osv(_("Алдаа!"), _("Дуусах огноогүй ажлыг дуусгаж болохгүй."))
                    self.write(cr, uid, ids, {'is_finished_in_time': is_finished_in_time}, context=context)
                vals['date_approved'] = fields.datetime.now()
            else:
                if if_TMheadman or if_TMmanager:
                    self.write(cr, uid, ids, {'is_finished_in_time': False}, context=context)
        
        # Tosliin (project_id) user_ids -g shinechleh heseg
        before_users_id = []
        list = []
        list1 = []
        list_followers = []
        project_to_change = False
        if 'project_id' in vals:
            project_id_ch = self.pool.get('tbab.project').search(cr,uid,[('id','=',vals['project_id'])])
            project_to_change = self.pool.get('tbab.project').browse(cr,uid,project_id_ch)
        else:
            if obj.project_id != False:
                project_to_change = obj.project_id
            else:
                project_to_change = False
        if project_to_change:
            before_users_id = self.find_user_ids_from_project(cr, uid, ids, project_to_change, context)
            
        if 'user_id' in vals:
            vals['user_id'] = vals['user_id']
            self.write(cr, uid, ids, {'user_mail_created': False}, context=context)
            list.append(vals['user_id'])
        else:
            if obj.user_id:
                list.append(obj.user_id.id)
        if 'reviewer_id' in vals:
            vals['reviewer_id'] = vals['reviewer_id']
            self.write(cr, uid, ids, {'reviewer_mail_created': False}, context=context)
            list1.append(vals['reviewer_id'])
        else:
            if obj.reviewer_id:
                list1.append(obj.reviewer_id.id)
        
        #=======================================================================
        # for followers in obj.message_follower_ids:
        #     for user_ids_f in self.pool.get('res.users').browse(cr,uid,[('id','in',followers.user_ids)]):
        #         for follower_user_ids in user_ids_f:
        #             if follower_user_ids.id[2]:
        #                 list_followers.append(follower_user_ids.id[2].id)
        #=======================================================================
        mergedlist1 = []
        mergedlist =[]
        mergedlist1 = before_users_id + list + list1 + [1]
        # + list_followers
        
        
        for num in mergedlist1:#list-n dawhardliig arilgah funkts
            if num not in mergedlist:
                mergedlist.append(num)
        
        if project_to_change != False:#Tosliin user_ids-d IDs nemj bga WRITE
            project_to_change.write({'user_ids': [(6,0,mergedlist)]})
        
        
        # Busad vals - shinechleh heseg
        
        if 'priority' in vals:
            vals['priority'] = vals['priority']
            
        if 'date_start' in vals:
            if if_TMheadman or if_TMmanager:
                vals['date_start'] = vals['date_start']
            elif if_TMuser:
                raise osv.except_osv(_("Буруу үйлдэл!"), _("Та төслийн <<Эхлэх огноо>> -г сольж болохгүй, та албаны даргадаа хандан солиулах боломжтой"))
                    
        if 'date_end' in vals:
            if if_TMheadman or if_TMmanager:
                vals['date_end'] = vals['date_end']
            elif if_TMuser:
                raise osv.except_osv(_("Буруу үйлдэл!"), _("Та төслийн <<Дуусах огноо>> -г сольж болохгүй, та албаны даргадаа хандан солиулах боломжтой"))
                
        if 'planned_hours' in vals:
            if if_TMheadman or if_TMmanager:
                vals['planned_hours'] = vals['planned_hours']
            elif if_TMuser:
                raise osv.except_osv(_("Буруу үйлдэл!"), _("Та төслийн <<Анхны төлөвлөсөн цаг>> -г сольж болохгүй, та албаны даргадаа хандан солиулах боломжтой"))
        
        if 'is_have_auto_task' in vals:
            vals['is_have_auto_task'] = vals['is_have_auto_task']
        task_name = ''
        if 'name' in vals:
            task_name = vals['name']
        else:
            task_name = obj.name
        
        
        #########################
        #To send TASK mail
 #==============================================================================
 #        template_obj = self.pool.get('email.template')
 #        print '111'
 #        #group_model_id = self.pool.get('ir.model').search(cr, uid, [('model', '=', 'tbab.task')])[0]
 #        userss = 'Байхгүй'
 #        reviewer = 'Байхгүй'
 #        if 'user_id' in vals:
 #            if vals['user_id'] != obj.user_id.id:
 #                print '222'
 #                user_obj = self.pool.get('res.users')
 #                res_user_id = self.pool.get('res.users').search(cr, uid, [('id', '=', vals['user_id'])])
 #                us_id = user_obj.browse(cr, uid, res_user_id)
 #                userss = us_id.name
 # 
 #        if 'reviewer_id' in vals:
 #            if vals['reviewer_id'] != obj.user_id.id:
 #                print '333'
 #                rev_obj = self.pool.get('res.users')
 #                rev_id = self.pool.get('res.users').search(cr, uid, [('id', '=', vals['reviewer_id'])])
 #                r_id = rev_obj.browse(cr, uid, rev_id)
 #                reviewer = r_id.name
 # 
 #        if userss != 'Байхгүй' and reviewer != 'Байхгүй':
 #            print '444'
 #            email_to = us_id.login
 #            email_cc = r_id.login
 #            print 'ffffffff', r_id, r_id.login, us_id, us_id.login
 #        elif userss != 'Байхгүй' and reviewer == 'Байхгүй':
 #            print '555'
 #            email_to = us_id.login
 #            email_cc = False
 #        elif userss == 'Байхгүй' and reviewer != 'Байхгүй':
 #            print '666'
 #            email_to = r_id.login
 #            email_cc = False
 #         #Ажлууд засахад Гүйцэтгэгч болон Хянагч өөрчлөгдсөн тохиолдолд тухайн хэрэглэгчид рүү мэйл явна
 #        if userss != 'Байхгүй' or reviewer != 'Байхгүй':
 #            body_html = '''Ажлын гүйцэтгэгч эсвэл хянагч солигдлоо \n Гүйцэтгэгч : %s'''%obj.user_id.name + '--->' + ''' %s '''%userss + '''\n Хянагч : %s '''%obj.reviewer_id.name + '--->' + '''%s'''%reviewer
 # 
 #            send_mail_obj = self.pool.get('mail.mail')
 #            email_template_id = {
 #                                #'model_id': group_model_id,
 #                                #'name': obj.name + '-' + task_name,
 #                                'subject' : obj.name + '-' + task_name,
 #                                'body_html': body_html,
 #                                'email_from' : 'ncderp@ncd.mn',
 #                                'type' : 'email',
 #                                'auto_delete' : True,
 #                                'notification' : True,
 #                                #'force_send' : True,
 #                                'model' : 'tbab.task',
 #                                'email_to' : email_to,
 #                                'email_cc' : email_cc,
 #                                }
 #            mail_id = send_mail_obj.create(cr, uid, email_template_id, context=None)
 #==============================================================================

            
            
        # user_id change: update date_start
        #=======================================================================
        # if vals.get('user_id') and 'date_start' not in vals:
        #     vals['date_start'] = fields.datetime.now()
        #=======================================================================

        # Overridden to reset the kanban_state to normal whenever
        # the stage (stage_id) of the task changes.
        #=======================================================================
        # if vals and not 'kanban_state' in vals and 'stage_id' in vals:
        #     new_stage = vals.get('stage_id')
        #     vals_reset_kstate = dict(vals, kanban_state='normal')
        #     for t in self.browse(cr, uid, ids, context=context):
        #         write_vals = vals_reset_kstate if t.stage_id.id != new_stage else vals
        #         super(tbab_task, self).write(cr, uid, [t.id], write_vals, context=context)
        #     result = True
        # else:
        #     result = super(tbab_task, self).write(cr, uid, ids, vals, context=context)
        #=======================================================================
        
        #=======================================================================
        # if any(item in vals for item in ['stage_id', 'remaining_hours', 'user_id', 'kanban_state']):
        #     self._store_history(cr, uid, ids, context=context)
        #=======================================================================
        return super(tbab_task, self).write(cr, uid, ids, vals, context=context)

    def unlink(self, cr, uid, ids, context=None):
        if context == None:
            context = {}
        self._check_child_task(cr, uid, ids, context=context)
        res = super(tbab_task, self).unlink(cr, uid, ids, context)
        return res
    
    

class tbab_project_task_work(osv.osv):
    _name = "tbab.project.task.work"
    _description = "Tbab Project Task Work"
    _columns = {
        'name': fields.char('Work summary'),
        'date': fields.datetime('Date', select="1"),
        'task_id': fields.many2one('tbab.task', 'Task', ondelete='cascade', required=True, select="1"),
        'hours': fields.float('Time Spent'),
        'user_id': fields.many2one('res.users', 'Done by', required=True, select="1"),
        #'company_id': fields.related('task_id', 'company_id', type='many2one', relation='res.company', string='Company', store=True, readonly=True)
    }

    _defaults = {
        'user_id': lambda obj, cr, uid, context: uid,
        'date': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S')
    }

    _order = "date desc"
    def create(self, cr, uid, vals, context=None):
        if 'hours' in vals and (not vals['hours']):
            vals['hours'] = 0.00
        if 'task_id' in vals:
            cr.execute('update tbab_task set remaining_hours=remaining_hours - %s where id=%s', (vals.get('hours',0.0), vals['task_id']))
            self.pool.get('tbab.task').invalidate_cache(cr, uid, ['remaining_hours'], [vals['task_id']], context=context)
        return super(tbab_project_task_work,self).create(cr, uid, vals, context=context)

    def write(self, cr, uid, ids, vals, context=None):
        if 'hours' in vals and (not vals['hours']):
            vals['hours'] = 0.00
        if 'hours' in vals:
            task_obj = self.pool.get('tbab.task')
            for work in self.browse(cr, uid, ids, context=context):
                cr.execute('update tbab_task set remaining_hours=remaining_hours - %s + (%s) where id=%s', (vals.get('hours',0.0), work.hours, work.task_id.id))
                task_obj.invalidate_cache(cr, uid, ['remaining_hours'], [work.task_id.id], context=context)
        return super(tbab_project_task_work,self).write(cr, uid, ids, vals, context)

    def unlink(self, cr, uid, ids, context=None):
        task_obj = self.pool.get('tbab.task')
        for work in self.browse(cr, uid, ids):
            cr.execute('update tbab_task set remaining_hours=remaining_hours + %s where id=%s', (work.hours, work.task_id.id))
            task_obj.invalidate_cache(cr, uid, ['remaining_hours'], [work.task_id.id], context=context)
        return super(tbab_project_task_work,self).unlink(cr, uid, ids, context=context)

class tbab_project_task_history(osv.osv):
    """
    Tasks History, used for cumulative flow charts (Lean/Agile)
    """
    _name = 'tbab.project.task.history'
    _description = 'History of Tasks'
    _rec_name = 'task_id'
    _log_access = False

    def _get_date(self, cr, uid, ids, name, arg, context=None):
        result = {}
        for history in self.browse(cr, uid, ids, context=context):
            if history.type_id and history.type_id.fold:
                result[history.id] = history.date
                continue
            cr.execute('''select
                    date
                from
                    tbab_project_task_history
                where
                    task_id=%s and
                    id>%s
                order by id limit 1''', (history.task_id.id, history.id))
            res = cr.fetchone()
            result[history.id] = res and res[0] or False
        return result

    def _get_related_date(self, cr, uid, ids, context=None):
        result = []
        for history in self.browse(cr, uid, ids, context=context):
            cr.execute('''select
                    id
                from
                    tbab_project_task_history
                where
                    task_id=%s and
                    id<%s
                order by id desc limit 1''', (history.task_id.id, history.id))
            res = cr.fetchone()
            if res:
                result.append(res[0])
        return result

    _columns = {
        'task_id': fields.many2one('tbab.task', 'Task', ondelete='cascade', required=True, select=True),
        'type_id': fields.many2one('tbab.project.task.type', 'Stage'),
        'kanban_state': fields.selection([('normal', 'Normal'), ('blocked', 'Blocked'), ('done', 'Ready for next stage')], 'Kanban State', required=False),
        'date': fields.date('Date', select=True),
        'end_date': fields.function(_get_date, string='End Date', type="date", store={
            'tbab.project.task.history': (_get_related_date, None, 20)
        }),
        'remaining_hours': fields.float('Remaining Time', digits=(16, 2)),
        'planned_hours': fields.float('Planned Time', digits=(16, 2)),
        'user_id': fields.many2one('res.users', 'Responsible'),
    }
    _defaults = {
        'date': fields.date.context_today,
    }

class tbab_project_category(osv.osv):
    """ Category of tbab project's task (or issue) """
    _name = "tbab.project.category"
    _description = "Category of tbab project's task, issue, ..."
    _columns = {
        'name': fields.char('Name', required=True, translate=True),
    }

class tbab_project_phases(osv.osv):
    """ Category of tbab project's phases """
    _name = "tbab.project.phases"
    _description = "Category of tbab project's phases"
    _columns = {
        'name': fields.char('Name', required=True, translate=True),
        'code': fields.char('Code'),
        'user_id': fields.many2one('res.users', 'User', ondelete='cascade', select=True),
        'project_id': fields.many2one('tbab.project', 'Project'),
        'date_start': fields.date('Starting Date'),
        'date_end': fields.date('Ending Date'),
        
    }

class tbab_autocreate_task(osv.osv):
    _name = "tbab.autocreate.task"
    _description = "Tbab autocreate task"
    
    def _autocreate_count(self, cr, uid, ids,name, args, context = None):
        obj = self.browse(cr, uid,ids)
        now_count = 0
        dn1 = ''
        print 'ccccccccccccccccccccccccccccc' , obj.state
        if datetime.now().strftime('%Y-%m-%d') == obj.date_next and obj.state == 'Running':
            print 'tttttttttttttt' , obj.state
            for line in obj.lines_id:
                if line.date == obj.date_next and line.task_id == False:
                    tbab_task_new = self.pool.get('tbab.task')
                    created_task_id = tbab_task_new.create(cr, uid, {
                                            'name': obj.task_id.name,
                                            'project_id': obj.task_id.project_id.id or False,
                                            'phase_id': obj.task_id.phase_id.id or False,
                                            'user_id': obj.task_id.user_id.id or False,
                                            'reviewer_id': obj.task_id.reviewer_id.id or False,
                                            'planned_hours': obj.task_id.planned_hours or 0.0,
                                            'remaining_hours': obj.task_id.planned_hours or 0.0,
                                            'total_hours': obj.task_id.planned_hours or 0.0,
                                            'date_start': obj.task_id.date_start_first,
                                            'date_end': obj.task_id.date_end_first,
                                            'categ_ids': len(obj.task_id.categ_ids) and obj.task_id.categ_ids[0] or False,
                                            'priority': obj.task_id.priority or False,
                                            'sequence': obj.task_id.sequence or False,
                                            'planned_hours_first': obj.task_id.planned_hours or 0.0,
                                            'date_start_first': obj.task_id.date_start_first,
                                            'date_end_first': obj.task_id.date_end_first,
                                             })
                    line.write({'task_id': created_task_id})
                    #dn1 = line.date
                    if obj.period_type=='day':
                        dn1 = (datetime.strptime(line.date, '%Y-%m-%d') + relativedelta(days=obj.period_nbr)).strftime('%Y-%m-%d')
                    elif obj.period_type=='month':
                        dn1 = (datetime.strptime(line.date, '%Y-%m-%d') + relativedelta(months=obj.period_nbr)).strftime('%Y-%m-%d')
                    elif obj.period_type=='year':
                        dn1 = (datetime.strptime(line.date, '%Y-%m-%d') + relativedelta(years=obj.period_nbr)).strftime('%Y-%m-%d')
                    now_count = obj.auto_count + 1
                    print 'rrrrrrrrrrrr', now_count
                    self.write(cr, uid, ids, {'date_next':dn1})
        
        return {ids[0]:now_count}
    
    _columns = {
        'name': fields.char('Name', required=True),
        'ref': fields.char('Reference'),
        'task_id': fields.many2one('tbab.task', 'Task', required=True),
        'date_start': fields.date('Start Date', required=True),
        'period_total': fields.integer('Number of Periods', required=True),
        'period_nbr': fields.integer('Period', required=True),
        'period_type': fields.selection([('day','days'),('month','month'),('year','year')], 'Period Type', required=True),
        'state': fields.selection([('draft','Draft'),('running','Running'),('done','Done')], 'Status', required=True, readonly=True, copy=False),
        'auto_count':fields.function(_autocreate_count, store=True, type='integer',string="Autocreate count", update=True),
        'lines_id': fields.one2many('tbab.autocreate.task.line', 'autocreate_task_id', 'Autocreate task Lines', copy=True),
        'date_next': fields.date('Next Date'),
        
    }
    _defaults = {
        'date_start': fields.date.context_today,
        'period_type': 'month',
        'period_total': 12,
        'period_nbr': 1,
        'state': 'draft',
    }

    #===========================================================================
    # def state_to_draft(self, cr, uid, ids, context=None):
    #     self.write(cr, uid, ids, {'state':'draft'})
    #     return False
    #===========================================================================

    def state_to_done(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state':'done'})
        return False

    
    
    def check(self, cr, uid, ids, context=None):
        todone = []
        for sub in self.browse(cr, uid, ids, context=context):
            ok = True
            for line in sub.lines_id:
                if not line.task_id.id:
                    ok = False
                    break
            if ok:
                todone.append(sub.id)
        if todone:
            self.write(cr, uid, todone, {'state':'done'})
        return False

    def remove_line(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid,ids)[0]
        toremove = []
        for sub in self.browse(cr, uid, ids, context=context):
            for line in sub.lines_id:
                #if not line.task_id.id:
                toremove.append(line.id)
        if toremove:
            self.pool.get('tbab.autocreate.task.line').unlink(cr, uid, toremove)
        self.write(cr, uid, ids, {'state':'draft','date_next':False})
        obj_tbab_task = self.pool.get('tbab.task').browse(cr, uid, obj.task_id.id).update({'is_have_auto_task': False})
        return False
    
    def unlink(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids)[0]
        obj_tbab_task = self.pool.get('tbab.task').browse(cr, uid, obj.task_id.id).update({'is_have_auto_task': False})
        line_obj = self.pool.get('tbab.autocreate.task.line')
        for line in obj.lines_id:
            line_obj.unlink(cr, uid, line.id)
        return super(tbab_autocreate_task, self).unlink(cr, uid, ids, context=context)
    
    def compute(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid,ids)[0]
        dn = ''
        now_count = 0
        #Ehleh ognoo n onoodroos omno baiwal
        if obj.date_start < datetime.now().strftime('%Y-%m-%d'):
            raise osv.except_osv(_('Алдаа!'),_("Эхлэх огноо нь өнөөдрөөс урд байж болохгүй! Та эхлэх огноогоо засварлана уу!"))
        #Ehleh ognoo n onoodroos hoish baiwal
        elif obj.date_start > datetime.now().strftime('%Y-%m-%d'):
            for sub in self.browse(cr, uid, ids, context=context):
                ds = sub.date_start
                for i in range(sub.period_total):
                    self.pool.get('tbab.autocreate.task.line').create(cr, uid, {
                        'date': ds,
                        'autocreate_task_id': sub.id,
                    })
                    if sub.period_type=='day':
                        ds = (datetime.strptime(ds, '%Y-%m-%d') + relativedelta(days=sub.period_nbr)).strftime('%Y-%m-%d')
                    if sub.period_type=='month':
                        ds = (datetime.strptime(ds, '%Y-%m-%d') + relativedelta(months=sub.period_nbr)).strftime('%Y-%m-%d')
                    if sub.period_type=='year':
                        ds = (datetime.strptime(ds, '%Y-%m-%d') + relativedelta(years=sub.period_nbr)).strftime('%Y-%m-%d')
            dn = obj.date_start
        #Ehleh ognoo n onoodor baiwal
        else:
            for sub in self.browse(cr, uid, ids, context=context):
                ds = sub.date_start
                for i in range(sub.period_total):
                    if i == 0:
                        now_count = obj.auto_count + 1
                        print 'oooooooooooooo', now_count
                        tbab_task_new = self.pool.get('tbab.task')
                        created_task_id = tbab_task_new.create(cr, uid, {
                                                'name': obj.task_id.name,
                                                'project_id': obj.task_id.project_id.id or False,
                                                'phase_id': obj.task_id.phase_id.id or False,
                                                'user_id': obj.task_id.user_id.id or False,
                                                'reviewer_id': obj.task_id.reviewer_id.id or False,
                                                'planned_hours': obj.task_id.planned_hours or 0.0,
                                                'remaining_hours': obj.task_id.planned_hours or 0.0,
                                                'total_hours': obj.task_id.planned_hours or 0.0,
                                                'date_start': obj.task_id.date_start_first,
                                                'date_end': obj.task_id.date_end_first,
                                                'categ_ids': len(obj.task_id.categ_ids) and obj.task_id.categ_ids[0] or False,
                                                'priority': obj.task_id.priority or False,
                                                'sequence': obj.task_id.sequence or False,
                                                'planned_hours_first': obj.task_id.planned_hours or 0.0,
                                                'date_start_first': obj.task_id.date_start_first,
                                                'date_end_first': obj.task_id.date_end_first,
                                                'is_have_auto_task': True,
                                                 })
                        #self.write(cr, uid, ids,{'auto_count': now_count})
                        self.browse(cr, uid, ids, context=context).update({'auto_count': now_count})
                        self.pool.get('tbab.autocreate.task.line').create(cr, uid, {
                            'date': ds,
                            'autocreate_task_id': sub.id,
                            'task_id': created_task_id,
                        })
                    else:
                        self.pool.get('tbab.autocreate.task.line').create(cr, uid, {
                            'date': ds,
                            'autocreate_task_id': sub.id,
                        })
                    if sub.period_type=='day':
                        ds = (datetime.strptime(ds, '%Y-%m-%d') + relativedelta(days=sub.period_nbr)).strftime('%Y-%m-%d')
                    if sub.period_type=='month':
                        ds = (datetime.strptime(ds, '%Y-%m-%d') + relativedelta(months=sub.period_nbr)).strftime('%Y-%m-%d')
                    if sub.period_type=='year':
                        ds = (datetime.strptime(ds, '%Y-%m-%d') + relativedelta(years=sub.period_nbr)).strftime('%Y-%m-%d')
            if obj.period_type=='day':
                dn = (datetime.strptime(obj.date_start, '%Y-%m-%d') + relativedelta(days=obj.period_nbr)).strftime('%Y-%m-%d')
            elif obj.period_type=='month':
                dn = (datetime.strptime(obj.date_start, '%Y-%m-%d') + relativedelta(months=obj.period_nbr)).strftime('%Y-%m-%d')
            elif obj.period_type=='year':
                dn = (datetime.strptime(obj.date_start, '%Y-%m-%d') + relativedelta(years=obj.period_nbr)).strftime('%Y-%m-%d')
        obj_tbab_task = self.pool.get('tbab.task').browse(cr, uid, obj.task_id.id).update({'is_have_auto_task': True})
        self.write(cr, uid, ids, {'state':'running','date_next':dn})
        return True
    
class tbab_autocreate_task_line(osv.osv):
    _name = "tbab.autocreate.task.line"
    _description = "Tbab autocreate task Line"
    _columns = {
        'autocreate_task_id': fields.many2one('tbab.autocreate.task', 'Autocreate task', required=True, select=True),
        'date': fields.date('Date', required=True),
        'task_id': fields.many2one('tbab.task', 'Entry'),
    }

    def move_create(self, cr, uid, ids, context=None):
        tocheck = {}
        all_moves = []
        obj_model = self.pool.get('tbab.task')
        for line in self.browse(cr, uid, ids, context=context):
            data = {
                'date': line.date,
            }
            task_ids = obj_model.generate(cr, uid, [line.autocreate_task_id.task_id.id], data, context)
            tocheck[line.autocreate_task_id.id] = True
            self.write(cr, uid, [line.id], {'task_id':task_ids[0]})
            all_moves.extend(task_ids)
        if tocheck:
            self.pool.get('tbab.autocreate.task').check(cr, uid, tocheck.keys(), context)
        return all_moves

    _rec_name = 'date'
    
    
