# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2013-Today OpenERP SA (<http://www.openerp.com>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import json
import logging
import werkzeug
import werkzeug.utils
from datetime import datetime
from math import ceil

from openerp import SUPERUSER_ID
from openerp.addons.web import http
from openerp.addons.web.http import request
from openerp.tools.misc import DEFAULT_SERVER_DATETIME_FORMAT as DTF, ustr
from openerp.osv import fields


_logger = logging.getLogger(__name__)


class TbabWebsiteCV(http.Controller):
    @http.route('/web/CV1', type='http', auth="public", website=True)
    def web_cv(self, redirect=None, **kw):
        cr = request.cr
        return http.request.render('tbab_web_cv.go_cv', {})

class TbabHrApplicant(http.Controller):
    @http.route('/web/applicant', type='http', auth="public", website=True)
    def start_cv(self, redirect=None, **kw):
        cr = request.cr
        return http.request.render('tbab_web_cv.start_cv', {})
    
class StartApplicant(http.Controller):
     #@http.route('partner/create')
     
    _name = 'start.applicant'
    _description = 'CVss'
    _rec_name = 'title'
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    

    def _get_public_url(self, cr, uid, ids, name, arg, context=None):
        """ Computes a public URL for the survey """
        if context and context.get('relative_url'):
            base_url = '/'
        else:
            base_url = self.pool['ir.config_parameter'].get_param(cr, uid, 'web.base.url')
        res = {}
        for CVsss in self.browse(cr, uid, ids, context=context):
            res[CVsss.id] = urljoin(base_url, "soosee/start/%s" % slug(CVsss))
        return res

    def _get_public_url_html(self, cr, uid, ids, name, arg, context=None):
        """ Computes a public URL for the survey (html-embeddable version)"""
        urls = self._get_public_url(cr, uid, ids, name, arg, context=context)
        for id, url in urls.iteritems():
            urls[id] = '<a href="%s">%s</a>' % (url, _("Click here to start survey"))
        return urls

    def _get_print_url(self, cr, uid, ids, name, arg, context=None):
        """ Computes a printing URL for the survey """
        if context and context.get('relative_url'):
            base_url = '/'
        else:
            base_url = self.pool['ir.config_parameter'].get_param(cr, uid, 'web.base.url')
        res = {}
        for survey in self.browse(cr, uid, ids, context=context):
            res[survey.id] = urljoin(base_url, "survey/print/%s" % slug(survey))
        return res

    def _get_result_url(self, cr, uid, ids, name, arg, context=None):
        """ Computes an URL for the survey results """
        if context and context.get('relative_url'):
            base_url = '/'
        else:
            base_url = self.pool['ir.config_parameter'].get_param(cr, uid, 'web.base.url')
        res = {}
        for CVsss in self.browse(cr, uid, ids, context=context):
            res[CVsss.id] = urljoin(base_url, "soosaa/results/%s" % slug(CVsss))
        return res
    

    _columns = {
        'title': fields.char('Title', required=1, translate=True),
        'public_url': fields.function(_get_public_url,
            string="Public link", type="char"),
        'public_url_html': fields.function(_get_public_url_html,
            string="Public link (html version)", type="char"),
        'print_url': fields.function(_get_print_url,
            string="Print link", type="char"),
        'result_url': fields.function(_get_result_url,
            string="Results link", type="char"),
    }
    
    
    def create_form(self, **kw):
        model = request.registry['hr.applicant']
        trail = ""
        context = dict(context or {}, relative_url=True)
        return {
            'type': 'ir.actions.act_url',
            'name': "Start CVSSSS",
            'target': 'self',
            'url': self.read(cr, uid, ids, ['public_url'], context=context)[0]['public_url'] + trail
        }
         #======================================================================
         # print 'ddddffffffff', model
         # form = {
         #    type: 'ir.actions.act_window',
         #    res_model: 'hr.recruitment',
         #    view_mode: 'form',
         #    view_type: 'form',
         #    views: [[true, 'hr_recruitment.crm_case_form_view_job']],
         #    target: 'new',
         #    context: {
         #        'context': model.context,
         #        #'default_res_model': this.view.dataset.model,
         #        #'default_res_id': this.view.datarecord.id,
         #            },
         #         }
         # #return form
         # print 'gggggggggggg', form, '--', http.request.render('tbab_web_cv.start_cv', {form})
         # 
         # return http.request.render('tbab_web_cv.start_cv', {form})
         #======================================================================